#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 5
#define STATE_COUNT 2579
#define SYMBOL_COUNT 126
#define ALIAS_COUNT 4
#define TOKEN_COUNT 80
#define EXTERNAL_TOKEN_COUNT 11
#define MAX_ALIAS_SEQUENCE_LENGTH 8

enum {
  sym__simple_heredoc = 1,
  sym__heredoc_beginning = 2,
  sym__heredoc_middle = 3,
  sym__heredoc_end = 4,
  sym_file_descriptor = 5,
  sym__empty_value = 6,
  sym__concat = 7,
  sym_variable_name = 8,
  anon_sym_for = 9,
  anon_sym_in = 10,
  anon_sym_while = 11,
  anon_sym_do = 12,
  anon_sym_done = 13,
  anon_sym_if = 14,
  anon_sym_then = 15,
  anon_sym_fi = 16,
  anon_sym_elif = 17,
  anon_sym_else = 18,
  anon_sym_case = 19,
  anon_sym_esac = 20,
  anon_sym_PIPE = 21,
  anon_sym_RPAREN = 22,
  anon_sym_SEMI_SEMI = 23,
  anon_sym_function = 24,
  anon_sym_LPAREN = 25,
  anon_sym_LBRACE = 26,
  anon_sym_RBRACE = 27,
  anon_sym_PIPE_AMP = 28,
  anon_sym_AMP_AMP = 29,
  anon_sym_PIPE_PIPE = 30,
  anon_sym_LBRACK = 31,
  anon_sym_RBRACK = 32,
  anon_sym_LBRACK_LBRACK = 33,
  anon_sym_RBRACK_RBRACK = 34,
  anon_sym_declare = 35,
  anon_sym_typeset = 36,
  anon_sym_export = 37,
  anon_sym_readonly = 38,
  anon_sym_local = 39,
  anon_sym_EQ = 40,
  anon_sym_PLUS_EQ = 41,
  anon_sym_LT = 42,
  anon_sym_GT = 43,
  anon_sym_GT_GT = 44,
  anon_sym_AMP_GT = 45,
  anon_sym_AMP_GT_GT = 46,
  anon_sym_LT_AMP = 47,
  anon_sym_GT_AMP = 48,
  anon_sym_LT_LT = 49,
  anon_sym_LT_LT_DASH = 50,
  anon_sym_LT_LT_LT = 51,
  sym__special_characters = 52,
  anon_sym_DQUOTE = 53,
  sym__string_content = 54,
  sym_raw_string = 55,
  anon_sym_DOLLAR = 56,
  anon_sym_POUND = 57,
  anon_sym_DOLLAR_LBRACE = 58,
  anon_sym_COLON = 59,
  anon_sym_COLON_QMARK = 60,
  anon_sym_COLON_DASH = 61,
  anon_sym_PERCENT = 62,
  anon_sym_SLASH = 63,
  anon_sym_DASH = 64,
  anon_sym_DOLLAR_LPAREN = 65,
  anon_sym_BQUOTE = 66,
  anon_sym_LT_LPAREN = 67,
  anon_sym_GT_LPAREN = 68,
  sym_comment = 69,
  aux_sym_SLASH_BSLASHw_PLUS_SLASH = 70,
  anon_sym_STAR = 71,
  anon_sym_AT = 72,
  anon_sym_QMARK = 73,
  anon_sym_0 = 74,
  anon_sym__ = 75,
  sym_word = 76,
  anon_sym_SEMI = 77,
  anon_sym_LF = 78,
  anon_sym_AMP = 79,
  sym_program = 80,
  sym__terminated_statement = 81,
  sym_for_statement = 82,
  sym_while_statement = 83,
  sym_do_group = 84,
  sym_if_statement = 85,
  sym_elif_clause = 86,
  sym_else_clause = 87,
  sym_case_statement = 88,
  sym_case_item = 89,
  sym_last_case_item = 90,
  sym_function_definition = 91,
  sym_compound_statement = 92,
  sym_subshell = 93,
  sym_pipeline = 94,
  sym_list = 95,
  sym_bracket_command = 96,
  sym_command = 97,
  sym_command_name = 98,
  sym_variable_assignment = 99,
  sym_declaration_command = 100,
  sym__assignment = 101,
  sym_subscript = 102,
  sym_file_redirect = 103,
  sym_heredoc_redirect = 104,
  sym_heredoc = 105,
  sym_herestring_redirect = 106,
  sym_concatenation = 107,
  sym_string = 108,
  sym_array = 109,
  sym_simple_expansion = 110,
  sym_expansion = 111,
  sym_command_substitution = 112,
  sym_process_substitution = 113,
  aux_sym_program_repeat1 = 114,
  aux_sym_for_statement_repeat1 = 115,
  aux_sym_while_statement_repeat1 = 116,
  aux_sym_if_statement_repeat1 = 117,
  aux_sym_case_statement_repeat1 = 118,
  aux_sym_case_item_repeat1 = 119,
  aux_sym_command_repeat1 = 120,
  aux_sym_declaration_command_repeat1 = 121,
  aux_sym_heredoc_repeat1 = 122,
  aux_sym_concatenation_repeat1 = 123,
  aux_sym_string_repeat1 = 124,
  aux_sym_expansion_repeat1 = 125,
  alias_sym_case_item = 126,
  alias_sym_special_variable_name = 127,
  alias_sym_variable_name = 128,
  alias_sym_word = 129,
};

static const char *ts_symbol_names[] = {
  [sym__simple_heredoc] = "_simple_heredoc",
  [sym__heredoc_beginning] = "_heredoc_beginning",
  [sym__heredoc_middle] = "_heredoc_middle",
  [sym__heredoc_end] = "_heredoc_end",
  [sym_file_descriptor] = "file_descriptor",
  [sym__empty_value] = "_empty_value",
  [sym__concat] = "_concat",
  [sym_variable_name] = "variable_name",
  [ts_builtin_sym_end] = "END",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_done] = "done",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_fi] = "fi",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_case] = "case",
  [anon_sym_esac] = "esac",
  [anon_sym_PIPE] = "|",
  [anon_sym_RPAREN] = ")",
  [anon_sym_SEMI_SEMI] = ";;",
  [anon_sym_function] = "function",
  [anon_sym_LPAREN] = "(",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_PIPE_AMP] = "|&",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACK_LBRACK] = "[[",
  [anon_sym_RBRACK_RBRACK] = "]]",
  [anon_sym_declare] = "declare",
  [anon_sym_typeset] = "typeset",
  [anon_sym_export] = "export",
  [anon_sym_readonly] = "readonly",
  [anon_sym_local] = "local",
  [anon_sym_EQ] = "=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_AMP_GT] = "&>",
  [anon_sym_AMP_GT_GT] = "&>>",
  [anon_sym_LT_AMP] = "<&",
  [anon_sym_GT_AMP] = ">&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_LT_LT_DASH] = "<<-",
  [anon_sym_LT_LT_LT] = "<<<",
  [sym__special_characters] = "_special_characters",
  [anon_sym_DQUOTE] = "\"",
  [sym__string_content] = "_string_content",
  [sym_raw_string] = "raw_string",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_POUND] = "#",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_COLON] = ":",
  [anon_sym_COLON_QMARK] = ":?",
  [anon_sym_COLON_DASH] = ":-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_SLASH] = "/",
  [anon_sym_DASH] = "-",
  [anon_sym_DOLLAR_LPAREN] = "$(",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_LT_LPAREN] = "<(",
  [anon_sym_GT_LPAREN] = ">(",
  [sym_comment] = "comment",
  [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = "/\\w+/",
  [anon_sym_STAR] = "*",
  [anon_sym_AT] = "@",
  [anon_sym_QMARK] = "?",
  [anon_sym_0] = "0",
  [anon_sym__] = "_",
  [sym_word] = "word",
  [anon_sym_SEMI] = ";",
  [anon_sym_LF] = "\n",
  [anon_sym_AMP] = "&",
  [sym_program] = "program",
  [sym__terminated_statement] = "_terminated_statement",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_group] = "do_group",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_case_statement] = "case_statement",
  [sym_case_item] = "case_item",
  [sym_last_case_item] = "last_case_item",
  [sym_function_definition] = "function_definition",
  [sym_compound_statement] = "compound_statement",
  [sym_subshell] = "subshell",
  [sym_pipeline] = "pipeline",
  [sym_list] = "list",
  [sym_bracket_command] = "bracket_command",
  [sym_command] = "command",
  [sym_command_name] = "command_name",
  [sym_variable_assignment] = "variable_assignment",
  [sym_declaration_command] = "declaration_command",
  [sym__assignment] = "_assignment",
  [sym_subscript] = "subscript",
  [sym_file_redirect] = "file_redirect",
  [sym_heredoc_redirect] = "heredoc_redirect",
  [sym_heredoc] = "heredoc",
  [sym_herestring_redirect] = "herestring_redirect",
  [sym_concatenation] = "concatenation",
  [sym_string] = "string",
  [sym_array] = "array",
  [sym_simple_expansion] = "simple_expansion",
  [sym_expansion] = "expansion",
  [sym_command_substitution] = "command_substitution",
  [sym_process_substitution] = "process_substitution",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_while_statement_repeat1] = "while_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_case_item_repeat1] = "case_item_repeat1",
  [aux_sym_command_repeat1] = "command_repeat1",
  [aux_sym_declaration_command_repeat1] = "declaration_command_repeat1",
  [aux_sym_heredoc_repeat1] = "heredoc_repeat1",
  [aux_sym_concatenation_repeat1] = "concatenation_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_expansion_repeat1] = "expansion_repeat1",
  [alias_sym_case_item] = "case_item",
  [alias_sym_special_variable_name] = "special_variable_name",
  [alias_sym_variable_name] = "variable_name",
  [alias_sym_word] = "word",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [sym__simple_heredoc] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_beginning] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_middle] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_end] = {
    .visible = false,
    .named = true,
  },
  [sym_file_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_value] = {
    .visible = false,
    .named = true,
  },
  [sym__concat] = {
    .visible = false,
    .named = true,
  },
  [sym_variable_name] = {
    .visible = true,
    .named = true,
  },
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_done] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_esac] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [sym__special_characters] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym_raw_string] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_0] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [sym_word] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__terminated_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_group] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_item] = {
    .visible = true,
    .named = true,
  },
  [sym_last_case_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_subshell] = {
    .visible = true,
    .named = true,
  },
  [sym_pipeline] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_bracket_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command_name] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_command] = {
    .visible = true,
    .named = true,
  },
  [sym__assignment] = {
    .visible = false,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_file_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc] = {
    .visible = true,
    .named = true,
  },
  [sym_herestring_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_command_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_process_substitution] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_while_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_item_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_heredoc_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expansion_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_case_item] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_special_variable_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_variable_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_word] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[17][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = alias_sym_word,
  },
  [2] = {
    [0] = alias_sym_variable_name,
  },
  [3] = {
    [1] = alias_sym_word,
  },
  [4] = {
    [1] = alias_sym_special_variable_name,
  },
  [5] = {
    [1] = alias_sym_variable_name,
  },
  [6] = {
    [2] = alias_sym_word,
  },
  [7] = {
    [2] = alias_sym_special_variable_name,
  },
  [8] = {
    [2] = alias_sym_variable_name,
  },
  [9] = {
    [3] = alias_sym_word,
  },
  [10] = {
    [1] = alias_sym_word,
    [4] = alias_sym_case_item,
  },
  [11] = {
    [4] = alias_sym_case_item,
  },
  [12] = {
    [4] = alias_sym_word,
  },
  [13] = {
    [1] = alias_sym_word,
    [5] = alias_sym_case_item,
  },
  [14] = {
    [5] = alias_sym_case_item,
  },
  [15] = {
    [1] = alias_sym_word,
    [6] = alias_sym_case_item,
  },
  [16] = {
    [6] = alias_sym_case_item,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '*')
        ADVANCE(17);
      if (lookahead == '+')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(20);
      if (lookahead == '/')
        ADVANCE(21);
      if (lookahead == '0')
        ADVANCE(22);
      if (lookahead == ':')
        ADVANCE(24);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '=')
        ADVANCE(35);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '?')
        ADVANCE(40);
      if (lookahead == '@')
        ADVANCE(41);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        SKIP(44);
      if (lookahead == ']')
        ADVANCE(45);
      if (lookahead == '_')
        ADVANCE(47);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '|')
        ADVANCE(50);
      if (lookahead == '}')
        ADVANCE(53);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      if (('1' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(23);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_LF);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '(')
        ADVANCE(6);
      if (lookahead == '{')
        ADVANCE(7);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LPAREN);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '>')
        ADVANCE(11);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_AMP_GT);
      if (lookahead == '>')
        ADVANCE(12);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_AMP_GT_GT);
      END_STATE();
    case 13:
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead != 0)
        ADVANCE(13);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(sym_raw_string);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 18:
      if (lookahead == '=')
        ADVANCE(19);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_0);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(23);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(23);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '-')
        ADVANCE(25);
      if (lookahead == '?')
        ADVANCE(26);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_COLON_DASH);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_SEMI);
      if (lookahead == ';')
        ADVANCE(28);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_SEMI_SEMI);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(30);
      if (lookahead == '(')
        ADVANCE(31);
      if (lookahead == '<')
        ADVANCE(32);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_LT_AMP);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_LT_LPAREN);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '-')
        ADVANCE(33);
      if (lookahead == '<')
        ADVANCE(34);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_LT_LT_DASH);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_LT_LT_LT);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(37);
      if (lookahead == '(')
        ADVANCE(38);
      if (lookahead == '>')
        ADVANCE(39);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_GT_AMP);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_GT_LPAREN);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[')
        ADVANCE(43);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      END_STATE();
    case 44:
      if (lookahead == '\n')
        SKIP(0);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      if (lookahead == ']')
        ADVANCE(46);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym__);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(23);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(sym__special_characters);
      if (lookahead == '[')
        ADVANCE(49);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '}')
        ADVANCE(49);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '&')
        ADVANCE(51);
      if (lookahead == '|')
        ADVANCE(52);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_PIPE_AMP);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 54:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(56);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(58);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == 'c')
        ADVANCE(61);
      if (lookahead == 'd')
        ADVANCE(65);
      if (lookahead == 'e')
        ADVANCE(72);
      if (lookahead == 'f')
        ADVANCE(78);
      if (lookahead == 'i')
        ADVANCE(88);
      if (lookahead == 'l')
        ADVANCE(90);
      if (lookahead == 'r')
        ADVANCE(95);
      if (lookahead == 't')
        ADVANCE(103);
      if (lookahead == 'w')
        ADVANCE(110);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '}')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(54);
      if ((lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(55);
      END_STATE();
    case 56:
      if (lookahead == '>')
        ADVANCE(11);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(30);
      if (lookahead == '(')
        ADVANCE(31);
      END_STATE();
    case 58:
      if (lookahead == '\n')
        SKIP(54);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 60:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'a')
        ADVANCE(62);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          lookahead != 'a' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 's')
        ADVANCE(63);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'e')
        ADVANCE(64);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_case);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'e')
        ADVANCE(66);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'c')
        ADVANCE(67);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'l')
        ADVANCE(68);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'a')
        ADVANCE(69);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          lookahead != 'a' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'r')
        ADVANCE(70);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'e')
        ADVANCE(71);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_declare);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'x')
        ADVANCE(73);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'p')
        ADVANCE(74);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'o')
        ADVANCE(75);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'r')
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 't')
        ADVANCE(77);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_export);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'o')
        ADVANCE(79);
      if (lookahead == 'u')
        ADVANCE(81);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'r')
        ADVANCE(80);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_for);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'n')
        ADVANCE(82);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'c')
        ADVANCE(83);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 't')
        ADVANCE(84);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'i')
        ADVANCE(85);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'o')
        ADVANCE(86);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'n')
        ADVANCE(87);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_function);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'f')
        ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_if);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'o')
        ADVANCE(91);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'a')
        ADVANCE(93);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          lookahead != 'a' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'l')
        ADVANCE(94);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_local);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'e')
        ADVANCE(96);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'a')
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          lookahead != 'a' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'd')
        ADVANCE(98);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'o')
        ADVANCE(99);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'n')
        ADVANCE(100);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'l')
        ADVANCE(101);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'y')
        ADVANCE(102);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_readonly);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'y')
        ADVANCE(104);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'p')
        ADVANCE(105);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'e')
        ADVANCE(106);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 's')
        ADVANCE(107);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'e')
        ADVANCE(108);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 't')
        ADVANCE(109);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_typeset);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'h')
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'i')
        ADVANCE(112);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'l')
        ADVANCE(113);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'e')
        ADVANCE(114);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_while);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 115:
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '&')
        ADVANCE(116);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '+')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(117);
      if (lookahead == '\\')
        SKIP(118);
      if (lookahead == ']')
        ADVANCE(119);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == 'd')
        ADVANCE(120);
      if (lookahead == 'e')
        ADVANCE(122);
      if (lookahead == 'f')
        ADVANCE(131);
      if (lookahead == 'i')
        ADVANCE(133);
      if (lookahead == 't')
        ADVANCE(135);
      if (lookahead == '{')
        ADVANCE(139);
      if (lookahead == '|')
        ADVANCE(50);
      if (lookahead == '}')
        ADVANCE(53);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(115);
      END_STATE();
    case 116:
      if (lookahead == '&')
        ADVANCE(10);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 118:
      if (lookahead == '\n')
        SKIP(115);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 120:
      if (lookahead == 'o')
        ADVANCE(121);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 122:
      if (lookahead == 'l')
        ADVANCE(123);
      if (lookahead == 's')
        ADVANCE(128);
      END_STATE();
    case 123:
      if (lookahead == 'i')
        ADVANCE(124);
      if (lookahead == 's')
        ADVANCE(126);
      END_STATE();
    case 124:
      if (lookahead == 'f')
        ADVANCE(125);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 126:
      if (lookahead == 'e')
        ADVANCE(127);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 128:
      if (lookahead == 'a')
        ADVANCE(129);
      END_STATE();
    case 129:
      if (lookahead == 'c')
        ADVANCE(130);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_esac);
      END_STATE();
    case 131:
      if (lookahead == 'i')
        ADVANCE(132);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_fi);
      END_STATE();
    case 133:
      if (lookahead == 'n')
        ADVANCE(134);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 135:
      if (lookahead == 'h')
        ADVANCE(136);
      END_STATE();
    case 136:
      if (lookahead == 'e')
        ADVANCE(137);
      END_STATE();
    case 137:
      if (lookahead == 'n')
        ADVANCE(138);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 140:
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '\\')
        SKIP(141);
      if (lookahead == '|')
        ADVANCE(142);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(140);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(23);
      END_STATE();
    case 141:
      if (lookahead == '\n')
        SKIP(140);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 143:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(56);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(49);
      if (lookahead == '\\')
        ADVANCE(144);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '}')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(143);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 144:
      if (lookahead == '\n')
        SKIP(143);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 145:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(146);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(147);
      if (lookahead == '>')
        ADVANCE(148);
      if (lookahead == '[')
        ADVANCE(49);
      if (lookahead == '\\')
        ADVANCE(149);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '|')
        ADVANCE(50);
      if (lookahead == '}')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(145);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(59);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(10);
      END_STATE();
    case 147:
      if (lookahead == '(')
        ADVANCE(31);
      END_STATE();
    case 148:
      if (lookahead == '(')
        ADVANCE(38);
      END_STATE();
    case 149:
      if (lookahead == '\n')
        SKIP(145);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(60);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(150);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 151:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(49);
      if (lookahead == '\\')
        ADVANCE(152);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '|')
        ADVANCE(50);
      if (lookahead == '}')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(151);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(59);
      END_STATE();
    case 152:
      if (lookahead == '\n')
        SKIP(151);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 153:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(154);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\\')
        ADVANCE(158);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(159);
      if (lookahead != 0)
        ADVANCE(155);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(155);
      if (lookahead == '\\')
        ADVANCE(157);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(154);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\\')
        ADVANCE(156);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(155);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(155);
      if (lookahead == '\\')
        ADVANCE(156);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(155);
      if (lookahead != 0)
        ADVANCE(155);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(155);
      if (lookahead == '\\')
        ADVANCE(157);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(154);
      if (lookahead != 0)
        ADVANCE(154);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(159);
      if (lookahead == '\\')
        ADVANCE(156);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(155);
      if (lookahead != 0)
        ADVANCE(155);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '#')
        ADVANCE(154);
      if (lookahead == '\\')
        ADVANCE(158);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(159);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(155);
      END_STATE();
    case 160:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(161);
      if (lookahead == '*')
        ADVANCE(17);
      if (lookahead == '-')
        ADVANCE(20);
      if (lookahead == '0')
        ADVANCE(22);
      if (lookahead == '?')
        ADVANCE(40);
      if (lookahead == '@')
        ADVANCE(41);
      if (lookahead == '\\')
        SKIP(162);
      if (lookahead == '_')
        ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(160);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(23);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 162:
      if (lookahead == '\n')
        SKIP(160);
      END_STATE();
    case 163:
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(161);
      if (lookahead == '*')
        ADVANCE(17);
      if (lookahead == '-')
        ADVANCE(20);
      if (lookahead == '0')
        ADVANCE(22);
      if (lookahead == '?')
        ADVANCE(40);
      if (lookahead == '@')
        ADVANCE(41);
      if (lookahead == '\\')
        SKIP(164);
      if (lookahead == '_')
        ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(163);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(23);
      END_STATE();
    case 164:
      if (lookahead == '\n')
        SKIP(163);
      END_STATE();
    case 165:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(49);
      if (lookahead == '\\')
        ADVANCE(166);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '|')
        ADVANCE(50);
      if (lookahead == '}')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(165);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(59);
      END_STATE();
    case 166:
      if (lookahead == '\n')
        SKIP(165);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 167:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(56);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == ';')
        ADVANCE(168);
      if (lookahead == '<')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(169);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == 'c')
        ADVANCE(61);
      if (lookahead == 'd')
        ADVANCE(65);
      if (lookahead == 'e')
        ADVANCE(72);
      if (lookahead == 'f')
        ADVANCE(78);
      if (lookahead == 'i')
        ADVANCE(88);
      if (lookahead == 'l')
        ADVANCE(90);
      if (lookahead == 'r')
        ADVANCE(95);
      if (lookahead == 't')
        ADVANCE(103);
      if (lookahead == 'w')
        ADVANCE(110);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '}')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(167);
      if ((lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 168:
      if (lookahead == ';')
        ADVANCE(28);
      END_STATE();
    case 169:
      if (lookahead == '\n')
        SKIP(167);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 170:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(49);
      if (lookahead == '\\')
        ADVANCE(171);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '|')
        ADVANCE(50);
      if (lookahead == '}')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(170);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(59);
      END_STATE();
    case 171:
      if (lookahead == '\n')
        SKIP(170);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 172:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(49);
      if (lookahead == '\\')
        ADVANCE(173);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '|')
        ADVANCE(50);
      if (lookahead == '}')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(172);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(59);
      END_STATE();
    case 173:
      if (lookahead == '\n')
        SKIP(172);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 174:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(147);
      if (lookahead == '>')
        ADVANCE(148);
      if (lookahead == '[')
        ADVANCE(49);
      if (lookahead == '\\')
        ADVANCE(175);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '}')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(174);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 175:
      if (lookahead == '\n')
        SKIP(174);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 176:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(49);
      if (lookahead == '\\')
        ADVANCE(177);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '|')
        ADVANCE(50);
      if (lookahead == '}')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(176);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(59);
      END_STATE();
    case 177:
      if (lookahead == '\n')
        SKIP(176);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 178:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '&')
        ADVANCE(179);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '\\')
        SKIP(180);
      if (lookahead == 'i')
        ADVANCE(133);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(178);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 180:
      if (lookahead == '\n')
        SKIP(178);
      END_STATE();
    case 181:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(146);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(147);
      if (lookahead == '>')
        ADVANCE(148);
      if (lookahead == '[')
        ADVANCE(49);
      if (lookahead == '\\')
        ADVANCE(182);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '|')
        ADVANCE(50);
      if (lookahead == '}')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(181);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(59);
      END_STATE();
    case 182:
      if (lookahead == '\n')
        SKIP(181);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 183:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(49);
      if (lookahead == '\\')
        ADVANCE(184);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '|')
        ADVANCE(50);
      if (lookahead == '}')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(183);
      if (lookahead != 0)
        ADVANCE(59);
      END_STATE();
    case 184:
      if (lookahead == '\n')
        SKIP(183);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 185:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(147);
      if (lookahead == '>')
        ADVANCE(148);
      if (lookahead == '[')
        ADVANCE(49);
      if (lookahead == '\\')
        ADVANCE(186);
      if (lookahead == ']')
        ADVANCE(119);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '}')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(185);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 186:
      if (lookahead == '\n')
        SKIP(185);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 187:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(147);
      if (lookahead == '>')
        ADVANCE(148);
      if (lookahead == '[')
        ADVANCE(49);
      if (lookahead == '\\')
        ADVANCE(188);
      if (lookahead == ']')
        ADVANCE(189);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '}')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(187);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 188:
      if (lookahead == '\n')
        SKIP(187);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym__special_characters);
      if (lookahead == '[')
        ADVANCE(49);
      if (lookahead == ']')
        ADVANCE(46);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '}')
        ADVANCE(49);
      END_STATE();
    case 190:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(191);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(192);
      if (lookahead == '/')
        ADVANCE(193);
      if (lookahead == ':')
        ADVANCE(194);
      if (lookahead == '<')
        ADVANCE(147);
      if (lookahead == '=')
        ADVANCE(197);
      if (lookahead == '>')
        ADVANCE(148);
      if (lookahead == '[')
        ADVANCE(49);
      if (lookahead == '\\')
        ADVANCE(198);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '}')
        ADVANCE(53);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(190);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '-')
        ADVANCE(195);
      if (lookahead == '?')
        ADVANCE(196);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '?' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_COLON_DASH);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 198:
      if (lookahead == '\n')
        SKIP(190);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 199:
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(161);
      if (lookahead == '*')
        ADVANCE(17);
      if (lookahead == '-')
        ADVANCE(20);
      if (lookahead == '0')
        ADVANCE(22);
      if (lookahead == '?')
        ADVANCE(40);
      if (lookahead == '@')
        ADVANCE(41);
      if (lookahead == '\\')
        SKIP(200);
      if (lookahead == '_')
        ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(199);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(23);
      END_STATE();
    case 200:
      if (lookahead == '\n')
        SKIP(199);
      END_STATE();
    case 201:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(116);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(147);
      if (lookahead == '>')
        ADVANCE(148);
      if (lookahead == '[')
        ADVANCE(49);
      if (lookahead == '\\')
        ADVANCE(202);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '|')
        ADVANCE(50);
      if (lookahead == '}')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(201);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<')
        ADVANCE(59);
      END_STATE();
    case 202:
      if (lookahead == '\n')
        SKIP(201);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 203:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(204);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(49);
      if (lookahead == '\\')
        ADVANCE(205);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '|')
        ADVANCE(50);
      if (lookahead == '}')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(203);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<')
        ADVANCE(59);
      END_STATE();
    case 204:
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '>')
        ADVANCE(11);
      END_STATE();
    case 205:
      if (lookahead == '\n')
        SKIP(203);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 206:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(204);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(49);
      if (lookahead == '\\')
        ADVANCE(207);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '|')
        ADVANCE(50);
      if (lookahead == '}')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(206);
      if (lookahead != 0 &&
          lookahead != ';' &&
          lookahead != '<')
        ADVANCE(59);
      END_STATE();
    case 207:
      if (lookahead == '\n')
        SKIP(206);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 208:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(204);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(49);
      if (lookahead == '\\')
        ADVANCE(209);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '|')
        ADVANCE(50);
      if (lookahead == '}')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(208);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<')
        ADVANCE(59);
      END_STATE();
    case 209:
      if (lookahead == '\n')
        SKIP(208);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 210:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(116);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(147);
      if (lookahead == '>')
        ADVANCE(148);
      if (lookahead == '[')
        ADVANCE(49);
      if (lookahead == '\\')
        ADVANCE(211);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '|')
        ADVANCE(50);
      if (lookahead == '}')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(210);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<')
        ADVANCE(59);
      END_STATE();
    case 211:
      if (lookahead == '\n')
        SKIP(210);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 212:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(204);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(49);
      if (lookahead == '\\')
        ADVANCE(213);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '|')
        ADVANCE(50);
      if (lookahead == '}')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(212);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<')
        ADVANCE(59);
      END_STATE();
    case 213:
      if (lookahead == '\n')
        SKIP(212);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 214:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(204);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(49);
      if (lookahead == '\\')
        ADVANCE(215);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '|')
        ADVANCE(50);
      if (lookahead == '}')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(214);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<')
        ADVANCE(59);
      END_STATE();
    case 215:
      if (lookahead == '\n')
        SKIP(214);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 216:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(204);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(49);
      if (lookahead == '\\')
        ADVANCE(217);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '|')
        ADVANCE(50);
      if (lookahead == '}')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(216);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<')
        ADVANCE(59);
      END_STATE();
    case 217:
      if (lookahead == '\n')
        SKIP(216);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 218:
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '\\')
        SKIP(219);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(218);
      END_STATE();
    case 219:
      if (lookahead == '\n')
        SKIP(218);
      END_STATE();
    case 220:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(221);
      if (lookahead == '>')
        ADVANCE(222);
      if (lookahead == '\\')
        SKIP(223);
      if (lookahead == '|')
        ADVANCE(50);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(220);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(30);
      if (lookahead == '<')
        ADVANCE(32);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(37);
      if (lookahead == '>')
        ADVANCE(39);
      END_STATE();
    case 223:
      if (lookahead == '\n')
        SKIP(220);
      END_STATE();
    case 224:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(221);
      if (lookahead == '>')
        ADVANCE(222);
      if (lookahead == '\\')
        SKIP(225);
      if (lookahead == '|')
        ADVANCE(50);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(224);
      END_STATE();
    case 225:
      if (lookahead == '\n')
        SKIP(224);
      END_STATE();
    case 226:
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '\\')
        SKIP(227);
      if (lookahead == ']')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(226);
      END_STATE();
    case 227:
      if (lookahead == '\n')
        SKIP(226);
      END_STATE();
    case 228:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(56);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(229);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == 'c')
        ADVANCE(61);
      if (lookahead == 'd')
        ADVANCE(230);
      if (lookahead == 'e')
        ADVANCE(72);
      if (lookahead == 'f')
        ADVANCE(78);
      if (lookahead == 'i')
        ADVANCE(88);
      if (lookahead == 'l')
        ADVANCE(90);
      if (lookahead == 'r')
        ADVANCE(95);
      if (lookahead == 't')
        ADVANCE(103);
      if (lookahead == 'w')
        ADVANCE(110);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '}')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(228);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 229:
      if (lookahead == '\n')
        SKIP(228);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'e')
        ADVANCE(66);
      if (lookahead == 'o')
        ADVANCE(231);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'n')
        ADVANCE(232);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'e')
        ADVANCE(233);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(anon_sym_done);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 234:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(56);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(235);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == 'c')
        ADVANCE(61);
      if (lookahead == 'd')
        ADVANCE(65);
      if (lookahead == 'e')
        ADVANCE(236);
      if (lookahead == 'f')
        ADVANCE(242);
      if (lookahead == 'i')
        ADVANCE(88);
      if (lookahead == 'l')
        ADVANCE(90);
      if (lookahead == 'r')
        ADVANCE(95);
      if (lookahead == 't')
        ADVANCE(103);
      if (lookahead == 'w')
        ADVANCE(110);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '}')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(234);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 235:
      if (lookahead == '\n')
        SKIP(234);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'l')
        ADVANCE(237);
      if (lookahead == 'x')
        ADVANCE(73);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'i')
        ADVANCE(238);
      if (lookahead == 's')
        ADVANCE(240);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'f')
        ADVANCE(239);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_elif);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'e')
        ADVANCE(241);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'i')
        ADVANCE(243);
      if (lookahead == 'o')
        ADVANCE(79);
      if (lookahead == 'u')
        ADVANCE(81);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(anon_sym_fi);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 244:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(56);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(245);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == 'c')
        ADVANCE(61);
      if (lookahead == 'd')
        ADVANCE(65);
      if (lookahead == 'e')
        ADVANCE(72);
      if (lookahead == 'f')
        ADVANCE(78);
      if (lookahead == 'i')
        ADVANCE(88);
      if (lookahead == 'l')
        ADVANCE(90);
      if (lookahead == 'r')
        ADVANCE(95);
      if (lookahead == 't')
        ADVANCE(103);
      if (lookahead == 'w')
        ADVANCE(110);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '}')
        ADVANCE(53);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(244);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 245:
      if (lookahead == '\n')
        SKIP(244);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 246:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(247);
      if (lookahead == '>')
        ADVANCE(222);
      if (lookahead == '\\')
        SKIP(248);
      if (lookahead == '|')
        ADVANCE(50);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(246);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(30);
      END_STATE();
    case 248:
      if (lookahead == '\n')
        SKIP(246);
      END_STATE();
    case 249:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(56);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(250);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == 'c')
        ADVANCE(61);
      if (lookahead == 'd')
        ADVANCE(65);
      if (lookahead == 'e')
        ADVANCE(72);
      if (lookahead == 'f')
        ADVANCE(78);
      if (lookahead == 'i')
        ADVANCE(88);
      if (lookahead == 'l')
        ADVANCE(90);
      if (lookahead == 'r')
        ADVANCE(95);
      if (lookahead == 't')
        ADVANCE(103);
      if (lookahead == 'w')
        ADVANCE(110);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '}')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(249);
      if (lookahead != 0 &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 250:
      if (lookahead == '\n')
        SKIP(249);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 251:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(147);
      if (lookahead == '>')
        ADVANCE(148);
      if (lookahead == '[')
        ADVANCE(49);
      if (lookahead == '\\')
        ADVANCE(252);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '}')
        ADVANCE(53);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(251);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 252:
      if (lookahead == '\n')
        SKIP(251);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 253:
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '&')
        ADVANCE(204);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(221);
      if (lookahead == '>')
        ADVANCE(222);
      if (lookahead == '\\')
        SKIP(254);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == '|')
        ADVANCE(50);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(253);
      END_STATE();
    case 254:
      if (lookahead == '\n')
        SKIP(253);
      END_STATE();
    case 255:
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '&')
        ADVANCE(204);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(221);
      if (lookahead == '>')
        ADVANCE(222);
      if (lookahead == '\\')
        SKIP(256);
      if (lookahead == '|')
        ADVANCE(50);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(255);
      END_STATE();
    case 256:
      if (lookahead == '\n')
        SKIP(255);
      END_STATE();
    case 257:
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '&')
        ADVANCE(204);
      if (lookahead == '<')
        ADVANCE(221);
      if (lookahead == '>')
        ADVANCE(222);
      if (lookahead == '\\')
        SKIP(258);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == '|')
        ADVANCE(50);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(257);
      END_STATE();
    case 258:
      if (lookahead == '\n')
        SKIP(257);
      END_STATE();
    case 259:
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(260);
      if (lookahead == '\\')
        SKIP(261);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(259);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '{')
        ADVANCE(7);
      END_STATE();
    case 261:
      if (lookahead == '\n')
        SKIP(259);
      END_STATE();
    case 262:
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '+')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(35);
      if (lookahead == '\\')
        SKIP(263);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(262);
      END_STATE();
    case 263:
      if (lookahead == '\n')
        SKIP(262);
      END_STATE();
    case 264:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(147);
      if (lookahead == '>')
        ADVANCE(148);
      if (lookahead == '[')
        ADVANCE(49);
      if (lookahead == '\\')
        ADVANCE(265);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '}')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(264);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 265:
      if (lookahead == '\n')
        SKIP(264);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 266:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(179);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(147);
      if (lookahead == '>')
        ADVANCE(148);
      if (lookahead == '[')
        ADVANCE(49);
      if (lookahead == '\\')
        ADVANCE(267);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '}')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(266);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 267:
      if (lookahead == '\n')
        SKIP(266);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 268:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(56);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(269);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == 'c')
        ADVANCE(61);
      if (lookahead == 'd')
        ADVANCE(65);
      if (lookahead == 'e')
        ADVANCE(72);
      if (lookahead == 'f')
        ADVANCE(242);
      if (lookahead == 'i')
        ADVANCE(88);
      if (lookahead == 'l')
        ADVANCE(90);
      if (lookahead == 'r')
        ADVANCE(95);
      if (lookahead == 't')
        ADVANCE(103);
      if (lookahead == 'w')
        ADVANCE(110);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '}')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(268);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 269:
      if (lookahead == '\n')
        SKIP(268);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 270:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(147);
      if (lookahead == '>')
        ADVANCE(148);
      if (lookahead == '[')
        ADVANCE(49);
      if (lookahead == '\\')
        ADVANCE(271);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == 'e')
        ADVANCE(272);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '}')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(270);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 271:
      if (lookahead == '\n')
        SKIP(270);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 's')
        ADVANCE(273);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'a')
        ADVANCE(274);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          lookahead != 'a' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'c')
        ADVANCE(275);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym_esac);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 276:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(247);
      if (lookahead == '>')
        ADVANCE(222);
      if (lookahead == '\\')
        SKIP(277);
      if (lookahead == '|')
        ADVANCE(50);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(276);
      END_STATE();
    case 277:
      if (lookahead == '\n')
        SKIP(276);
      END_STATE();
    case 278:
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '\\')
        SKIP(279);
      if (lookahead == '}')
        ADVANCE(53);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(278);
      END_STATE();
    case 279:
      if (lookahead == '\n')
        SKIP(278);
      END_STATE();
    case 280:
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '&')
        ADVANCE(204);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(247);
      if (lookahead == '>')
        ADVANCE(222);
      if (lookahead == '\\')
        SKIP(281);
      if (lookahead == '|')
        ADVANCE(50);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(280);
      END_STATE();
    case 281:
      if (lookahead == '\n')
        SKIP(280);
      END_STATE();
    case 282:
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '&')
        ADVANCE(204);
      if (lookahead == '<')
        ADVANCE(247);
      if (lookahead == '>')
        ADVANCE(222);
      if (lookahead == '\\')
        SKIP(283);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == '|')
        ADVANCE(50);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(282);
      END_STATE();
    case 283:
      if (lookahead == '\n')
        SKIP(282);
      END_STATE();
    case 284:
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '\\')
        SKIP(285);
      if (lookahead == '|')
        ADVANCE(142);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(284);
      END_STATE();
    case 285:
      if (lookahead == '\n')
        SKIP(284);
      END_STATE();
    case 286:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '&')
        ADVANCE(146);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '\\')
        SKIP(287);
      if (lookahead == '|')
        ADVANCE(50);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(286);
      END_STATE();
    case 287:
      if (lookahead == '\n')
        SKIP(286);
      END_STATE();
    case 288:
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '&')
        ADVANCE(204);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(247);
      if (lookahead == '>')
        ADVANCE(222);
      if (lookahead == '\\')
        SKIP(289);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == '|')
        ADVANCE(50);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(288);
      END_STATE();
    case 289:
      if (lookahead == '\n')
        SKIP(288);
      END_STATE();
    case 290:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(56);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == ';')
        ADVANCE(168);
      if (lookahead == '<')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(291);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == 'c')
        ADVANCE(61);
      if (lookahead == 'd')
        ADVANCE(65);
      if (lookahead == 'e')
        ADVANCE(292);
      if (lookahead == 'f')
        ADVANCE(78);
      if (lookahead == 'i')
        ADVANCE(88);
      if (lookahead == 'l')
        ADVANCE(90);
      if (lookahead == 'r')
        ADVANCE(95);
      if (lookahead == 't')
        ADVANCE(103);
      if (lookahead == 'w')
        ADVANCE(110);
      if (lookahead == '{')
        ADVANCE(49);
      if (lookahead == '}')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(290);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 291:
      if (lookahead == '\n')
        SKIP(290);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(59);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 's')
        ADVANCE(273);
      if (lookahead == 'x')
        ADVANCE(73);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(59);
      END_STATE();
    case 293:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '&')
        ADVANCE(146);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '\\')
        SKIP(294);
      if (lookahead == '|')
        ADVANCE(50);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(293);
      END_STATE();
    case 294:
      if (lookahead == '\n')
        SKIP(293);
      END_STATE();
    case 295:
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '&')
        ADVANCE(116);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '\\')
        SKIP(296);
      if (lookahead == '|')
        ADVANCE(50);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(295);
      END_STATE();
    case 296:
      if (lookahead == '\n')
        SKIP(295);
      END_STATE();
    case 297:
      if (lookahead == '#')
        ADVANCE(55);
      if (lookahead == '&')
        ADVANCE(116);
      if (lookahead == '\\')
        SKIP(298);
      if (lookahead == '`')
        ADVANCE(48);
      if (lookahead == '|')
        ADVANCE(50);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(297);
      END_STATE();
    case 298:
      if (lookahead == '\n')
        SKIP(297);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 54, .external_lex_state = 2},
  [2] = {.lex_state = 54},
  [3] = {.lex_state = 115},
  [4] = {.lex_state = 140},
  [5] = {.lex_state = 54, .external_lex_state = 2},
  [6] = {.lex_state = 54, .external_lex_state = 2},
  [7] = {.lex_state = 143},
  [8] = {.lex_state = 143},
  [9] = {.lex_state = 54, .external_lex_state = 2},
  [10] = {.lex_state = 143},
  [11] = {.lex_state = 143},
  [12] = {.lex_state = 145, .external_lex_state = 3},
  [13] = {.lex_state = 143},
  [14] = {.lex_state = 151, .external_lex_state = 4},
  [15] = {.lex_state = 153},
  [16] = {.lex_state = 151, .external_lex_state = 4},
  [17] = {.lex_state = 160},
  [18] = {.lex_state = 163, .external_lex_state = 5},
  [19] = {.lex_state = 54, .external_lex_state = 2},
  [20] = {.lex_state = 54, .external_lex_state = 2},
  [21] = {.lex_state = 54, .external_lex_state = 2},
  [22] = {.lex_state = 165, .external_lex_state = 4},
  [23] = {.lex_state = 54},
  [24] = {.lex_state = 167, .external_lex_state = 2},
  [25] = {.lex_state = 145, .external_lex_state = 6},
  [26] = {.lex_state = 151, .external_lex_state = 7},
  [27] = {.lex_state = 170, .external_lex_state = 8},
  [28] = {.lex_state = 115},
  [29] = {.lex_state = 143, .external_lex_state = 2},
  [30] = {.lex_state = 172, .external_lex_state = 7},
  [31] = {.lex_state = 54, .external_lex_state = 2},
  [32] = {.lex_state = 143, .external_lex_state = 2},
  [33] = {.lex_state = 143},
  [34] = {.lex_state = 143},
  [35] = {.lex_state = 174, .external_lex_state = 9},
  [36] = {.lex_state = 176, .external_lex_state = 8},
  [37] = {.lex_state = 115},
  [38] = {.lex_state = 115},
  [39] = {.lex_state = 145, .external_lex_state = 6},
  [40] = {.lex_state = 170, .external_lex_state = 8},
  [41] = {.lex_state = 115},
  [42] = {.lex_state = 178, .external_lex_state = 10},
  [43] = {.lex_state = 153},
  [44] = {.lex_state = 178, .external_lex_state = 10},
  [45] = {.lex_state = 160},
  [46] = {.lex_state = 163, .external_lex_state = 5},
  [47] = {.lex_state = 54, .external_lex_state = 2},
  [48] = {.lex_state = 54, .external_lex_state = 2},
  [49] = {.lex_state = 54, .external_lex_state = 2},
  [50] = {.lex_state = 178, .external_lex_state = 6},
  [51] = {.lex_state = 115},
  [52] = {.lex_state = 115},
  [53] = {.lex_state = 54, .external_lex_state = 2},
  [54] = {.lex_state = 143},
  [55] = {.lex_state = 181, .external_lex_state = 3},
  [56] = {.lex_state = 172, .external_lex_state = 4},
  [57] = {.lex_state = 153},
  [58] = {.lex_state = 172, .external_lex_state = 4},
  [59] = {.lex_state = 160},
  [60] = {.lex_state = 163, .external_lex_state = 5},
  [61] = {.lex_state = 54, .external_lex_state = 2},
  [62] = {.lex_state = 54, .external_lex_state = 2},
  [63] = {.lex_state = 54, .external_lex_state = 2},
  [64] = {.lex_state = 183, .external_lex_state = 4},
  [65] = {.lex_state = 181, .external_lex_state = 6},
  [66] = {.lex_state = 172, .external_lex_state = 7},
  [67] = {.lex_state = 176, .external_lex_state = 8},
  [68] = {.lex_state = 115},
  [69] = {.lex_state = 54, .external_lex_state = 2},
  [70] = {.lex_state = 143, .external_lex_state = 2},
  [71] = {.lex_state = 185, .external_lex_state = 11},
  [72] = {.lex_state = 153},
  [73] = {.lex_state = 185, .external_lex_state = 11},
  [74] = {.lex_state = 160},
  [75] = {.lex_state = 163, .external_lex_state = 5},
  [76] = {.lex_state = 54, .external_lex_state = 2},
  [77] = {.lex_state = 54, .external_lex_state = 2},
  [78] = {.lex_state = 54, .external_lex_state = 2},
  [79] = {.lex_state = 185, .external_lex_state = 12},
  [80] = {.lex_state = 185, .external_lex_state = 12},
  [81] = {.lex_state = 187, .external_lex_state = 13},
  [82] = {.lex_state = 153},
  [83] = {.lex_state = 187, .external_lex_state = 13},
  [84] = {.lex_state = 160},
  [85] = {.lex_state = 163, .external_lex_state = 5},
  [86] = {.lex_state = 54, .external_lex_state = 2},
  [87] = {.lex_state = 54, .external_lex_state = 2},
  [88] = {.lex_state = 54, .external_lex_state = 2},
  [89] = {.lex_state = 187},
  [90] = {.lex_state = 187},
  [91] = {.lex_state = 115},
  [92] = {.lex_state = 145, .external_lex_state = 14},
  [93] = {.lex_state = 153},
  [94] = {.lex_state = 145, .external_lex_state = 14},
  [95] = {.lex_state = 160},
  [96] = {.lex_state = 163, .external_lex_state = 5},
  [97] = {.lex_state = 54, .external_lex_state = 2},
  [98] = {.lex_state = 54, .external_lex_state = 2},
  [99] = {.lex_state = 54, .external_lex_state = 2},
  [100] = {.lex_state = 181, .external_lex_state = 3},
  [101] = {.lex_state = 181, .external_lex_state = 3},
  [102] = {.lex_state = 115},
  [103] = {.lex_state = 145, .external_lex_state = 3},
  [104] = {.lex_state = 143, .external_lex_state = 15},
  [105] = {.lex_state = 153},
  [106] = {.lex_state = 143, .external_lex_state = 15},
  [107] = {.lex_state = 160},
  [108] = {.lex_state = 163, .external_lex_state = 5},
  [109] = {.lex_state = 54, .external_lex_state = 2},
  [110] = {.lex_state = 54, .external_lex_state = 2},
  [111] = {.lex_state = 54, .external_lex_state = 2},
  [112] = {.lex_state = 143, .external_lex_state = 2},
  [113] = {.lex_state = 143},
  [114] = {.lex_state = 151, .external_lex_state = 4},
  [115] = {.lex_state = 151, .external_lex_state = 4},
  [116] = {.lex_state = 153, .external_lex_state = 13},
  [117] = {.lex_state = 160},
  [118] = {.lex_state = 163, .external_lex_state = 5},
  [119] = {.lex_state = 54, .external_lex_state = 2},
  [120] = {.lex_state = 54, .external_lex_state = 2},
  [121] = {.lex_state = 153},
  [122] = {.lex_state = 151, .external_lex_state = 4},
  [123] = {.lex_state = 151, .external_lex_state = 4},
  [124] = {.lex_state = 151, .external_lex_state = 4},
  [125] = {.lex_state = 115},
  [126] = {.lex_state = 190, .external_lex_state = 16},
  [127] = {.lex_state = 199, .external_lex_state = 5},
  [128] = {.lex_state = 190, .external_lex_state = 16},
  [129] = {.lex_state = 190, .external_lex_state = 16},
  [130] = {.lex_state = 115},
  [131] = {.lex_state = 140},
  [132] = {.lex_state = 54, .external_lex_state = 2},
  [133] = {.lex_state = 54, .external_lex_state = 2},
  [134] = {.lex_state = 143},
  [135] = {.lex_state = 143},
  [136] = {.lex_state = 54, .external_lex_state = 2},
  [137] = {.lex_state = 143},
  [138] = {.lex_state = 143},
  [139] = {.lex_state = 201, .external_lex_state = 5},
  [140] = {.lex_state = 203, .external_lex_state = 17},
  [141] = {.lex_state = 153},
  [142] = {.lex_state = 203, .external_lex_state = 17},
  [143] = {.lex_state = 160},
  [144] = {.lex_state = 163, .external_lex_state = 5},
  [145] = {.lex_state = 54, .external_lex_state = 2},
  [146] = {.lex_state = 54, .external_lex_state = 2},
  [147] = {.lex_state = 54, .external_lex_state = 2},
  [148] = {.lex_state = 206, .external_lex_state = 17},
  [149] = {.lex_state = 115},
  [150] = {.lex_state = 203, .external_lex_state = 18},
  [151] = {.lex_state = 208, .external_lex_state = 2},
  [152] = {.lex_state = 115},
  [153] = {.lex_state = 203, .external_lex_state = 18},
  [154] = {.lex_state = 143, .external_lex_state = 2},
  [155] = {.lex_state = 115},
  [156] = {.lex_state = 54, .external_lex_state = 2},
  [157] = {.lex_state = 143},
  [158] = {.lex_state = 210, .external_lex_state = 5},
  [159] = {.lex_state = 212, .external_lex_state = 17},
  [160] = {.lex_state = 153},
  [161] = {.lex_state = 212, .external_lex_state = 17},
  [162] = {.lex_state = 160},
  [163] = {.lex_state = 163, .external_lex_state = 5},
  [164] = {.lex_state = 54, .external_lex_state = 2},
  [165] = {.lex_state = 54, .external_lex_state = 2},
  [166] = {.lex_state = 54, .external_lex_state = 2},
  [167] = {.lex_state = 214, .external_lex_state = 17},
  [168] = {.lex_state = 115},
  [169] = {.lex_state = 212, .external_lex_state = 18},
  [170] = {.lex_state = 216, .external_lex_state = 2},
  [171] = {.lex_state = 115},
  [172] = {.lex_state = 143, .external_lex_state = 2},
  [173] = {.lex_state = 115},
  [174] = {.lex_state = 208, .external_lex_state = 2},
  [175] = {.lex_state = 115},
  [176] = {.lex_state = 54, .external_lex_state = 2},
  [177] = {.lex_state = 167, .external_lex_state = 2},
  [178] = {.lex_state = 54, .external_lex_state = 2},
  [179] = {.lex_state = 54},
  [180] = {.lex_state = 143},
  [181] = {.lex_state = 218, .external_lex_state = 19},
  [182] = {.lex_state = 143},
  [183] = {.lex_state = 151, .external_lex_state = 4},
  [184] = {.lex_state = 151, .external_lex_state = 4},
  [185] = {.lex_state = 220, .external_lex_state = 7},
  [186] = {.lex_state = 172, .external_lex_state = 7},
  [187] = {.lex_state = 151, .external_lex_state = 7},
  [188] = {.lex_state = 224, .external_lex_state = 7},
  [189] = {.lex_state = 54, .external_lex_state = 2},
  [190] = {.lex_state = 115},
  [191] = {.lex_state = 151, .external_lex_state = 7},
  [192] = {.lex_state = 115},
  [193] = {.lex_state = 143, .external_lex_state = 2},
  [194] = {.lex_state = 143, .external_lex_state = 15},
  [195] = {.lex_state = 143, .external_lex_state = 15},
  [196] = {.lex_state = 143, .external_lex_state = 2},
  [197] = {.lex_state = 226, .external_lex_state = 11},
  [198] = {.lex_state = 153},
  [199] = {.lex_state = 226, .external_lex_state = 11},
  [200] = {.lex_state = 160},
  [201] = {.lex_state = 163, .external_lex_state = 5},
  [202] = {.lex_state = 54, .external_lex_state = 2},
  [203] = {.lex_state = 54, .external_lex_state = 2},
  [204] = {.lex_state = 54, .external_lex_state = 2},
  [205] = {.lex_state = 226, .external_lex_state = 11},
  [206] = {.lex_state = 176, .external_lex_state = 8},
  [207] = {.lex_state = 203},
  [208] = {.lex_state = 170, .external_lex_state = 20},
  [209] = {.lex_state = 153},
  [210] = {.lex_state = 170, .external_lex_state = 20},
  [211] = {.lex_state = 160},
  [212] = {.lex_state = 163, .external_lex_state = 5},
  [213] = {.lex_state = 54, .external_lex_state = 2},
  [214] = {.lex_state = 54, .external_lex_state = 2},
  [215] = {.lex_state = 54, .external_lex_state = 2},
  [216] = {.lex_state = 143},
  [217] = {.lex_state = 228, .external_lex_state = 2},
  [218] = {.lex_state = 224, .external_lex_state = 7},
  [219] = {.lex_state = 115},
  [220] = {.lex_state = 234, .external_lex_state = 2},
  [221] = {.lex_state = 143},
  [222] = {.lex_state = 178, .external_lex_state = 6},
  [223] = {.lex_state = 115},
  [224] = {.lex_state = 178, .external_lex_state = 10},
  [225] = {.lex_state = 178, .external_lex_state = 10},
  [226] = {.lex_state = 153},
  [227] = {.lex_state = 178, .external_lex_state = 6},
  [228] = {.lex_state = 115},
  [229] = {.lex_state = 178, .external_lex_state = 10},
  [230] = {.lex_state = 178, .external_lex_state = 10},
  [231] = {.lex_state = 178, .external_lex_state = 10},
  [232] = {.lex_state = 115},
  [233] = {.lex_state = 190, .external_lex_state = 16},
  [234] = {.lex_state = 199, .external_lex_state = 5},
  [235] = {.lex_state = 190, .external_lex_state = 16},
  [236] = {.lex_state = 190, .external_lex_state = 16},
  [237] = {.lex_state = 115},
  [238] = {.lex_state = 208, .external_lex_state = 2},
  [239] = {.lex_state = 115},
  [240] = {.lex_state = 216, .external_lex_state = 2},
  [241] = {.lex_state = 115},
  [242] = {.lex_state = 208, .external_lex_state = 2},
  [243] = {.lex_state = 115},
  [244] = {.lex_state = 244, .external_lex_state = 21},
  [245] = {.lex_state = 246, .external_lex_state = 7},
  [246] = {.lex_state = 174, .external_lex_state = 9},
  [247] = {.lex_state = 115},
  [248] = {.lex_state = 115},
  [249] = {.lex_state = 115},
  [250] = {.lex_state = 181, .external_lex_state = 14},
  [251] = {.lex_state = 153},
  [252] = {.lex_state = 181, .external_lex_state = 14},
  [253] = {.lex_state = 160},
  [254] = {.lex_state = 163, .external_lex_state = 5},
  [255] = {.lex_state = 54, .external_lex_state = 2},
  [256] = {.lex_state = 54, .external_lex_state = 2},
  [257] = {.lex_state = 54, .external_lex_state = 2},
  [258] = {.lex_state = 115},
  [259] = {.lex_state = 181, .external_lex_state = 3},
  [260] = {.lex_state = 143},
  [261] = {.lex_state = 172, .external_lex_state = 4},
  [262] = {.lex_state = 172, .external_lex_state = 4},
  [263] = {.lex_state = 153},
  [264] = {.lex_state = 172, .external_lex_state = 4},
  [265] = {.lex_state = 172, .external_lex_state = 4},
  [266] = {.lex_state = 172, .external_lex_state = 4},
  [267] = {.lex_state = 115},
  [268] = {.lex_state = 190, .external_lex_state = 16},
  [269] = {.lex_state = 199, .external_lex_state = 5},
  [270] = {.lex_state = 190, .external_lex_state = 16},
  [271] = {.lex_state = 190, .external_lex_state = 16},
  [272] = {.lex_state = 115},
  [273] = {.lex_state = 208, .external_lex_state = 2},
  [274] = {.lex_state = 115},
  [275] = {.lex_state = 216, .external_lex_state = 2},
  [276] = {.lex_state = 115},
  [277] = {.lex_state = 208, .external_lex_state = 2},
  [278] = {.lex_state = 115},
  [279] = {.lex_state = 54, .external_lex_state = 2},
  [280] = {.lex_state = 181, .external_lex_state = 6},
  [281] = {.lex_state = 249, .external_lex_state = 2},
  [282] = {.lex_state = 54, .external_lex_state = 2},
  [283] = {.lex_state = 54},
  [284] = {.lex_state = 143},
  [285] = {.lex_state = 143},
  [286] = {.lex_state = 172, .external_lex_state = 4},
  [287] = {.lex_state = 172, .external_lex_state = 4},
  [288] = {.lex_state = 172, .external_lex_state = 7},
  [289] = {.lex_state = 220, .external_lex_state = 7},
  [290] = {.lex_state = 181, .external_lex_state = 6},
  [291] = {.lex_state = 176, .external_lex_state = 8},
  [292] = {.lex_state = 54, .external_lex_state = 2},
  [293] = {.lex_state = 172, .external_lex_state = 7},
  [294] = {.lex_state = 143},
  [295] = {.lex_state = 185, .external_lex_state = 11},
  [296] = {.lex_state = 185, .external_lex_state = 11},
  [297] = {.lex_state = 153},
  [298] = {.lex_state = 185, .external_lex_state = 11},
  [299] = {.lex_state = 185, .external_lex_state = 11},
  [300] = {.lex_state = 185, .external_lex_state = 11},
  [301] = {.lex_state = 115},
  [302] = {.lex_state = 190, .external_lex_state = 16},
  [303] = {.lex_state = 199, .external_lex_state = 5},
  [304] = {.lex_state = 190, .external_lex_state = 16},
  [305] = {.lex_state = 190, .external_lex_state = 16},
  [306] = {.lex_state = 115},
  [307] = {.lex_state = 208, .external_lex_state = 2},
  [308] = {.lex_state = 115},
  [309] = {.lex_state = 216, .external_lex_state = 2},
  [310] = {.lex_state = 115},
  [311] = {.lex_state = 208, .external_lex_state = 2},
  [312] = {.lex_state = 181, .external_lex_state = 6},
  [313] = {.lex_state = 185, .external_lex_state = 12},
  [314] = {.lex_state = 143},
  [315] = {.lex_state = 187, .external_lex_state = 13},
  [316] = {.lex_state = 187, .external_lex_state = 13},
  [317] = {.lex_state = 153},
  [318] = {.lex_state = 187, .external_lex_state = 13},
  [319] = {.lex_state = 187, .external_lex_state = 13},
  [320] = {.lex_state = 187, .external_lex_state = 13},
  [321] = {.lex_state = 115},
  [322] = {.lex_state = 190, .external_lex_state = 16},
  [323] = {.lex_state = 199, .external_lex_state = 5},
  [324] = {.lex_state = 190, .external_lex_state = 16},
  [325] = {.lex_state = 190, .external_lex_state = 16},
  [326] = {.lex_state = 115},
  [327] = {.lex_state = 208, .external_lex_state = 2},
  [328] = {.lex_state = 115},
  [329] = {.lex_state = 216, .external_lex_state = 2},
  [330] = {.lex_state = 115},
  [331] = {.lex_state = 208, .external_lex_state = 2},
  [332] = {.lex_state = 187},
  [333] = {.lex_state = 174, .external_lex_state = 9},
  [334] = {.lex_state = 181, .external_lex_state = 3},
  [335] = {.lex_state = 143},
  [336] = {.lex_state = 145, .external_lex_state = 14},
  [337] = {.lex_state = 145, .external_lex_state = 14},
  [338] = {.lex_state = 153},
  [339] = {.lex_state = 145, .external_lex_state = 14},
  [340] = {.lex_state = 145, .external_lex_state = 14},
  [341] = {.lex_state = 145, .external_lex_state = 14},
  [342] = {.lex_state = 115},
  [343] = {.lex_state = 190, .external_lex_state = 16},
  [344] = {.lex_state = 199, .external_lex_state = 5},
  [345] = {.lex_state = 190, .external_lex_state = 16},
  [346] = {.lex_state = 190, .external_lex_state = 16},
  [347] = {.lex_state = 115},
  [348] = {.lex_state = 208, .external_lex_state = 2},
  [349] = {.lex_state = 115},
  [350] = {.lex_state = 216, .external_lex_state = 2},
  [351] = {.lex_state = 115},
  [352] = {.lex_state = 208, .external_lex_state = 2},
  [353] = {.lex_state = 145, .external_lex_state = 3},
  [354] = {.lex_state = 143},
  [355] = {.lex_state = 143, .external_lex_state = 15},
  [356] = {.lex_state = 143, .external_lex_state = 15},
  [357] = {.lex_state = 153},
  [358] = {.lex_state = 143, .external_lex_state = 15},
  [359] = {.lex_state = 143, .external_lex_state = 15},
  [360] = {.lex_state = 143, .external_lex_state = 15},
  [361] = {.lex_state = 115},
  [362] = {.lex_state = 190, .external_lex_state = 16},
  [363] = {.lex_state = 199, .external_lex_state = 5},
  [364] = {.lex_state = 190, .external_lex_state = 16},
  [365] = {.lex_state = 190, .external_lex_state = 16},
  [366] = {.lex_state = 115},
  [367] = {.lex_state = 208, .external_lex_state = 2},
  [368] = {.lex_state = 115},
  [369] = {.lex_state = 216, .external_lex_state = 2},
  [370] = {.lex_state = 115},
  [371] = {.lex_state = 208, .external_lex_state = 2},
  [372] = {.lex_state = 151, .external_lex_state = 4},
  [373] = {.lex_state = 151, .external_lex_state = 4},
  [374] = {.lex_state = 153},
  [375] = {.lex_state = 153},
  [376] = {.lex_state = 153, .external_lex_state = 13},
  [377] = {.lex_state = 153, .external_lex_state = 13},
  [378] = {.lex_state = 153, .external_lex_state = 13},
  [379] = {.lex_state = 115},
  [380] = {.lex_state = 190, .external_lex_state = 16},
  [381] = {.lex_state = 199, .external_lex_state = 5},
  [382] = {.lex_state = 190, .external_lex_state = 16},
  [383] = {.lex_state = 190, .external_lex_state = 16},
  [384] = {.lex_state = 115},
  [385] = {.lex_state = 208, .external_lex_state = 2},
  [386] = {.lex_state = 115},
  [387] = {.lex_state = 216, .external_lex_state = 2},
  [388] = {.lex_state = 151, .external_lex_state = 4},
  [389] = {.lex_state = 153},
  [390] = {.lex_state = 143},
  [391] = {.lex_state = 251, .external_lex_state = 16},
  [392] = {.lex_state = 151, .external_lex_state = 4},
  [393] = {.lex_state = 190, .external_lex_state = 16},
  [394] = {.lex_state = 190, .external_lex_state = 22},
  [395] = {.lex_state = 153},
  [396] = {.lex_state = 190, .external_lex_state = 22},
  [397] = {.lex_state = 160},
  [398] = {.lex_state = 163, .external_lex_state = 5},
  [399] = {.lex_state = 54, .external_lex_state = 2},
  [400] = {.lex_state = 54, .external_lex_state = 2},
  [401] = {.lex_state = 54, .external_lex_state = 2},
  [402] = {.lex_state = 190, .external_lex_state = 16},
  [403] = {.lex_state = 115},
  [404] = {.lex_state = 190, .external_lex_state = 16},
  [405] = {.lex_state = 190, .external_lex_state = 16},
  [406] = {.lex_state = 190, .external_lex_state = 16},
  [407] = {.lex_state = 151, .external_lex_state = 4},
  [408] = {.lex_state = 190, .external_lex_state = 16},
  [409] = {.lex_state = 151, .external_lex_state = 4},
  [410] = {.lex_state = 190, .external_lex_state = 16},
  [411] = {.lex_state = 174, .external_lex_state = 9},
  [412] = {.lex_state = 208, .external_lex_state = 2},
  [413] = {.lex_state = 115},
  [414] = {.lex_state = 115},
  [415] = {.lex_state = 115},
  [416] = {.lex_state = 178, .external_lex_state = 10},
  [417] = {.lex_state = 178, .external_lex_state = 10},
  [418] = {.lex_state = 178, .external_lex_state = 6},
  [419] = {.lex_state = 115},
  [420] = {.lex_state = 181, .external_lex_state = 6},
  [421] = {.lex_state = 176, .external_lex_state = 8},
  [422] = {.lex_state = 54, .external_lex_state = 2},
  [423] = {.lex_state = 185, .external_lex_state = 12},
  [424] = {.lex_state = 187},
  [425] = {.lex_state = 115},
  [426] = {.lex_state = 201, .external_lex_state = 23},
  [427] = {.lex_state = 153},
  [428] = {.lex_state = 201, .external_lex_state = 23},
  [429] = {.lex_state = 160},
  [430] = {.lex_state = 163, .external_lex_state = 5},
  [431] = {.lex_state = 54, .external_lex_state = 2},
  [432] = {.lex_state = 54, .external_lex_state = 2},
  [433] = {.lex_state = 54, .external_lex_state = 2},
  [434] = {.lex_state = 201, .external_lex_state = 5},
  [435] = {.lex_state = 201, .external_lex_state = 5},
  [436] = {.lex_state = 115},
  [437] = {.lex_state = 201, .external_lex_state = 5},
  [438] = {.lex_state = 143},
  [439] = {.lex_state = 203, .external_lex_state = 17},
  [440] = {.lex_state = 203, .external_lex_state = 17},
  [441] = {.lex_state = 153},
  [442] = {.lex_state = 203, .external_lex_state = 17},
  [443] = {.lex_state = 203, .external_lex_state = 17},
  [444] = {.lex_state = 203, .external_lex_state = 17},
  [445] = {.lex_state = 115},
  [446] = {.lex_state = 190, .external_lex_state = 16},
  [447] = {.lex_state = 199, .external_lex_state = 5},
  [448] = {.lex_state = 190, .external_lex_state = 16},
  [449] = {.lex_state = 190, .external_lex_state = 16},
  [450] = {.lex_state = 115},
  [451] = {.lex_state = 208, .external_lex_state = 2},
  [452] = {.lex_state = 115},
  [453] = {.lex_state = 216, .external_lex_state = 2},
  [454] = {.lex_state = 115},
  [455] = {.lex_state = 208, .external_lex_state = 2},
  [456] = {.lex_state = 115},
  [457] = {.lex_state = 54, .external_lex_state = 2},
  [458] = {.lex_state = 151, .external_lex_state = 4},
  [459] = {.lex_state = 54, .external_lex_state = 2},
  [460] = {.lex_state = 54},
  [461] = {.lex_state = 143},
  [462] = {.lex_state = 218, .external_lex_state = 19},
  [463] = {.lex_state = 143},
  [464] = {.lex_state = 203, .external_lex_state = 17},
  [465] = {.lex_state = 203, .external_lex_state = 17},
  [466] = {.lex_state = 253, .external_lex_state = 18},
  [467] = {.lex_state = 203, .external_lex_state = 18},
  [468] = {.lex_state = 203, .external_lex_state = 18},
  [469] = {.lex_state = 255, .external_lex_state = 18},
  [470] = {.lex_state = 203, .external_lex_state = 18},
  [471] = {.lex_state = 174, .external_lex_state = 9},
  [472] = {.lex_state = 115},
  [473] = {.lex_state = 115},
  [474] = {.lex_state = 115},
  [475] = {.lex_state = 210, .external_lex_state = 23},
  [476] = {.lex_state = 153},
  [477] = {.lex_state = 210, .external_lex_state = 23},
  [478] = {.lex_state = 160},
  [479] = {.lex_state = 163, .external_lex_state = 5},
  [480] = {.lex_state = 54, .external_lex_state = 2},
  [481] = {.lex_state = 54, .external_lex_state = 2},
  [482] = {.lex_state = 54, .external_lex_state = 2},
  [483] = {.lex_state = 115},
  [484] = {.lex_state = 210, .external_lex_state = 5},
  [485] = {.lex_state = 143},
  [486] = {.lex_state = 212, .external_lex_state = 17},
  [487] = {.lex_state = 212, .external_lex_state = 17},
  [488] = {.lex_state = 153},
  [489] = {.lex_state = 212, .external_lex_state = 17},
  [490] = {.lex_state = 212, .external_lex_state = 17},
  [491] = {.lex_state = 212, .external_lex_state = 17},
  [492] = {.lex_state = 115},
  [493] = {.lex_state = 190, .external_lex_state = 16},
  [494] = {.lex_state = 199, .external_lex_state = 5},
  [495] = {.lex_state = 190, .external_lex_state = 16},
  [496] = {.lex_state = 190, .external_lex_state = 16},
  [497] = {.lex_state = 115},
  [498] = {.lex_state = 208, .external_lex_state = 2},
  [499] = {.lex_state = 115},
  [500] = {.lex_state = 216, .external_lex_state = 2},
  [501] = {.lex_state = 115},
  [502] = {.lex_state = 208, .external_lex_state = 2},
  [503] = {.lex_state = 115},
  [504] = {.lex_state = 54, .external_lex_state = 2},
  [505] = {.lex_state = 54, .external_lex_state = 2},
  [506] = {.lex_state = 54},
  [507] = {.lex_state = 143},
  [508] = {.lex_state = 143},
  [509] = {.lex_state = 212, .external_lex_state = 17},
  [510] = {.lex_state = 212, .external_lex_state = 17},
  [511] = {.lex_state = 212, .external_lex_state = 18},
  [512] = {.lex_state = 257, .external_lex_state = 18},
  [513] = {.lex_state = 212, .external_lex_state = 18},
  [514] = {.lex_state = 151, .external_lex_state = 4},
  [515] = {.lex_state = 115},
  [516] = {.lex_state = 181, .external_lex_state = 6},
  [517] = {.lex_state = 176, .external_lex_state = 8},
  [518] = {.lex_state = 145, .external_lex_state = 6},
  [519] = {.lex_state = 170, .external_lex_state = 8},
  [520] = {.lex_state = 143},
  [521] = {.lex_state = 224, .external_lex_state = 4},
  [522] = {.lex_state = 153},
  [523] = {.lex_state = 224, .external_lex_state = 4},
  [524] = {.lex_state = 160},
  [525] = {.lex_state = 163, .external_lex_state = 5},
  [526] = {.lex_state = 54, .external_lex_state = 2},
  [527] = {.lex_state = 54, .external_lex_state = 2},
  [528] = {.lex_state = 54, .external_lex_state = 2},
  [529] = {.lex_state = 220, .external_lex_state = 7},
  [530] = {.lex_state = 220, .external_lex_state = 7},
  [531] = {.lex_state = 259, .external_lex_state = 24},
  [532] = {.lex_state = 220, .external_lex_state = 7},
  [533] = {.lex_state = 224, .external_lex_state = 4},
  [534] = {.lex_state = 224, .external_lex_state = 4},
  [535] = {.lex_state = 220, .external_lex_state = 7},
  [536] = {.lex_state = 151, .external_lex_state = 7},
  [537] = {.lex_state = 224, .external_lex_state = 7},
  [538] = {.lex_state = 224, .external_lex_state = 7},
  [539] = {.lex_state = 174, .external_lex_state = 9},
  [540] = {.lex_state = 151, .external_lex_state = 7},
  [541] = {.lex_state = 185, .external_lex_state = 12},
  [542] = {.lex_state = 262, .external_lex_state = 13},
  [543] = {.lex_state = 226, .external_lex_state = 11},
  [544] = {.lex_state = 226, .external_lex_state = 11},
  [545] = {.lex_state = 153},
  [546] = {.lex_state = 185, .external_lex_state = 12},
  [547] = {.lex_state = 262, .external_lex_state = 13},
  [548] = {.lex_state = 226, .external_lex_state = 11},
  [549] = {.lex_state = 226, .external_lex_state = 11},
  [550] = {.lex_state = 226, .external_lex_state = 11},
  [551] = {.lex_state = 115},
  [552] = {.lex_state = 190, .external_lex_state = 16},
  [553] = {.lex_state = 199, .external_lex_state = 5},
  [554] = {.lex_state = 190, .external_lex_state = 16},
  [555] = {.lex_state = 190, .external_lex_state = 16},
  [556] = {.lex_state = 115},
  [557] = {.lex_state = 208, .external_lex_state = 2},
  [558] = {.lex_state = 115},
  [559] = {.lex_state = 216, .external_lex_state = 2},
  [560] = {.lex_state = 115},
  [561] = {.lex_state = 208, .external_lex_state = 2},
  [562] = {.lex_state = 115, .external_lex_state = 12},
  [563] = {.lex_state = 176, .external_lex_state = 8},
  [564] = {.lex_state = 264, .external_lex_state = 13},
  [565] = {.lex_state = 153},
  [566] = {.lex_state = 264, .external_lex_state = 13},
  [567] = {.lex_state = 160},
  [568] = {.lex_state = 163, .external_lex_state = 5},
  [569] = {.lex_state = 54, .external_lex_state = 2},
  [570] = {.lex_state = 54, .external_lex_state = 2},
  [571] = {.lex_state = 54, .external_lex_state = 2},
  [572] = {.lex_state = 203},
  [573] = {.lex_state = 203},
  [574] = {.lex_state = 143},
  [575] = {.lex_state = 170, .external_lex_state = 20},
  [576] = {.lex_state = 170, .external_lex_state = 20},
  [577] = {.lex_state = 153},
  [578] = {.lex_state = 170, .external_lex_state = 20},
  [579] = {.lex_state = 170, .external_lex_state = 20},
  [580] = {.lex_state = 170, .external_lex_state = 20},
  [581] = {.lex_state = 115},
  [582] = {.lex_state = 190, .external_lex_state = 16},
  [583] = {.lex_state = 199, .external_lex_state = 5},
  [584] = {.lex_state = 190, .external_lex_state = 16},
  [585] = {.lex_state = 190, .external_lex_state = 16},
  [586] = {.lex_state = 115},
  [587] = {.lex_state = 208, .external_lex_state = 2},
  [588] = {.lex_state = 115},
  [589] = {.lex_state = 216, .external_lex_state = 2},
  [590] = {.lex_state = 115},
  [591] = {.lex_state = 208, .external_lex_state = 2},
  [592] = {.lex_state = 266, .external_lex_state = 10},
  [593] = {.lex_state = 153},
  [594] = {.lex_state = 266, .external_lex_state = 10},
  [595] = {.lex_state = 160},
  [596] = {.lex_state = 163, .external_lex_state = 5},
  [597] = {.lex_state = 54, .external_lex_state = 2},
  [598] = {.lex_state = 54, .external_lex_state = 2},
  [599] = {.lex_state = 54, .external_lex_state = 2},
  [600] = {.lex_state = 266, .external_lex_state = 6},
  [601] = {.lex_state = 266, .external_lex_state = 6},
  [602] = {.lex_state = 220, .external_lex_state = 7},
  [603] = {.lex_state = 228, .external_lex_state = 2},
  [604] = {.lex_state = 145, .external_lex_state = 6},
  [605] = {.lex_state = 170, .external_lex_state = 8},
  [606] = {.lex_state = 228, .external_lex_state = 2},
  [607] = {.lex_state = 224, .external_lex_state = 7},
  [608] = {.lex_state = 181, .external_lex_state = 6},
  [609] = {.lex_state = 54, .external_lex_state = 2},
  [610] = {.lex_state = 268, .external_lex_state = 2},
  [611] = {.lex_state = 234, .external_lex_state = 2},
  [612] = {.lex_state = 145, .external_lex_state = 6},
  [613] = {.lex_state = 115},
  [614] = {.lex_state = 115},
  [615] = {.lex_state = 170, .external_lex_state = 8},
  [616] = {.lex_state = 234, .external_lex_state = 2},
  [617] = {.lex_state = 115},
  [618] = {.lex_state = 178, .external_lex_state = 10},
  [619] = {.lex_state = 270},
  [620] = {.lex_state = 178, .external_lex_state = 6},
  [621] = {.lex_state = 178, .external_lex_state = 10},
  [622] = {.lex_state = 178, .external_lex_state = 10},
  [623] = {.lex_state = 270},
  [624] = {.lex_state = 178, .external_lex_state = 6},
  [625] = {.lex_state = 251, .external_lex_state = 16},
  [626] = {.lex_state = 178, .external_lex_state = 10},
  [627] = {.lex_state = 190, .external_lex_state = 16},
  [628] = {.lex_state = 115},
  [629] = {.lex_state = 190, .external_lex_state = 16},
  [630] = {.lex_state = 190, .external_lex_state = 16},
  [631] = {.lex_state = 190, .external_lex_state = 16},
  [632] = {.lex_state = 178, .external_lex_state = 10},
  [633] = {.lex_state = 190, .external_lex_state = 16},
  [634] = {.lex_state = 178, .external_lex_state = 10},
  [635] = {.lex_state = 190, .external_lex_state = 16},
  [636] = {.lex_state = 178, .external_lex_state = 10},
  [637] = {.lex_state = 178, .external_lex_state = 10},
  [638] = {.lex_state = 115},
  [639] = {.lex_state = 276, .external_lex_state = 7},
  [640] = {.lex_state = 244, .external_lex_state = 21},
  [641] = {.lex_state = 145, .external_lex_state = 6},
  [642] = {.lex_state = 170, .external_lex_state = 8},
  [643] = {.lex_state = 244, .external_lex_state = 21},
  [644] = {.lex_state = 54},
  [645] = {.lex_state = 143},
  [646] = {.lex_state = 181, .external_lex_state = 6},
  [647] = {.lex_state = 176, .external_lex_state = 20},
  [648] = {.lex_state = 153},
  [649] = {.lex_state = 176, .external_lex_state = 20},
  [650] = {.lex_state = 160},
  [651] = {.lex_state = 163, .external_lex_state = 5},
  [652] = {.lex_state = 54, .external_lex_state = 2},
  [653] = {.lex_state = 54, .external_lex_state = 2},
  [654] = {.lex_state = 54, .external_lex_state = 2},
  [655] = {.lex_state = 220, .external_lex_state = 7},
  [656] = {.lex_state = 115},
  [657] = {.lex_state = 276, .external_lex_state = 7},
  [658] = {.lex_state = 174, .external_lex_state = 9},
  [659] = {.lex_state = 143},
  [660] = {.lex_state = 181, .external_lex_state = 14},
  [661] = {.lex_state = 181, .external_lex_state = 14},
  [662] = {.lex_state = 153},
  [663] = {.lex_state = 181, .external_lex_state = 14},
  [664] = {.lex_state = 181, .external_lex_state = 14},
  [665] = {.lex_state = 181, .external_lex_state = 14},
  [666] = {.lex_state = 115},
  [667] = {.lex_state = 190, .external_lex_state = 16},
  [668] = {.lex_state = 199, .external_lex_state = 5},
  [669] = {.lex_state = 190, .external_lex_state = 16},
  [670] = {.lex_state = 190, .external_lex_state = 16},
  [671] = {.lex_state = 115},
  [672] = {.lex_state = 208, .external_lex_state = 2},
  [673] = {.lex_state = 115},
  [674] = {.lex_state = 216, .external_lex_state = 2},
  [675] = {.lex_state = 115},
  [676] = {.lex_state = 208, .external_lex_state = 2},
  [677] = {.lex_state = 181, .external_lex_state = 3},
  [678] = {.lex_state = 172, .external_lex_state = 4},
  [679] = {.lex_state = 172, .external_lex_state = 4},
  [680] = {.lex_state = 172, .external_lex_state = 4},
  [681] = {.lex_state = 251, .external_lex_state = 16},
  [682] = {.lex_state = 172, .external_lex_state = 4},
  [683] = {.lex_state = 190, .external_lex_state = 16},
  [684] = {.lex_state = 115},
  [685] = {.lex_state = 190, .external_lex_state = 16},
  [686] = {.lex_state = 190, .external_lex_state = 16},
  [687] = {.lex_state = 190, .external_lex_state = 16},
  [688] = {.lex_state = 172, .external_lex_state = 4},
  [689] = {.lex_state = 190, .external_lex_state = 16},
  [690] = {.lex_state = 172, .external_lex_state = 4},
  [691] = {.lex_state = 190, .external_lex_state = 16},
  [692] = {.lex_state = 172, .external_lex_state = 4},
  [693] = {.lex_state = 172, .external_lex_state = 4},
  [694] = {.lex_state = 115},
  [695] = {.lex_state = 181, .external_lex_state = 6},
  [696] = {.lex_state = 181, .external_lex_state = 6},
  [697] = {.lex_state = 176, .external_lex_state = 8},
  [698] = {.lex_state = 143},
  [699] = {.lex_state = 220, .external_lex_state = 4},
  [700] = {.lex_state = 153},
  [701] = {.lex_state = 220, .external_lex_state = 4},
  [702] = {.lex_state = 160},
  [703] = {.lex_state = 163, .external_lex_state = 5},
  [704] = {.lex_state = 54, .external_lex_state = 2},
  [705] = {.lex_state = 54, .external_lex_state = 2},
  [706] = {.lex_state = 54, .external_lex_state = 2},
  [707] = {.lex_state = 220, .external_lex_state = 4},
  [708] = {.lex_state = 220, .external_lex_state = 4},
  [709] = {.lex_state = 172, .external_lex_state = 7},
  [710] = {.lex_state = 220, .external_lex_state = 7},
  [711] = {.lex_state = 220, .external_lex_state = 7},
  [712] = {.lex_state = 249, .external_lex_state = 2},
  [713] = {.lex_state = 172, .external_lex_state = 7},
  [714] = {.lex_state = 185, .external_lex_state = 11},
  [715] = {.lex_state = 185, .external_lex_state = 11},
  [716] = {.lex_state = 185, .external_lex_state = 11},
  [717] = {.lex_state = 251, .external_lex_state = 16},
  [718] = {.lex_state = 185, .external_lex_state = 11},
  [719] = {.lex_state = 190, .external_lex_state = 16},
  [720] = {.lex_state = 115},
  [721] = {.lex_state = 190, .external_lex_state = 16},
  [722] = {.lex_state = 190, .external_lex_state = 16},
  [723] = {.lex_state = 190, .external_lex_state = 16},
  [724] = {.lex_state = 185, .external_lex_state = 11},
  [725] = {.lex_state = 190, .external_lex_state = 16},
  [726] = {.lex_state = 185, .external_lex_state = 11},
  [727] = {.lex_state = 190, .external_lex_state = 16},
  [728] = {.lex_state = 185, .external_lex_state = 11},
  [729] = {.lex_state = 185, .external_lex_state = 11},
  [730] = {.lex_state = 187, .external_lex_state = 13},
  [731] = {.lex_state = 187, .external_lex_state = 13},
  [732] = {.lex_state = 187, .external_lex_state = 13},
  [733] = {.lex_state = 251, .external_lex_state = 16},
  [734] = {.lex_state = 187, .external_lex_state = 13},
  [735] = {.lex_state = 190, .external_lex_state = 16},
  [736] = {.lex_state = 115},
  [737] = {.lex_state = 190, .external_lex_state = 16},
  [738] = {.lex_state = 190, .external_lex_state = 16},
  [739] = {.lex_state = 190, .external_lex_state = 16},
  [740] = {.lex_state = 187, .external_lex_state = 13},
  [741] = {.lex_state = 190, .external_lex_state = 16},
  [742] = {.lex_state = 187, .external_lex_state = 13},
  [743] = {.lex_state = 190, .external_lex_state = 16},
  [744] = {.lex_state = 187, .external_lex_state = 13},
  [745] = {.lex_state = 187, .external_lex_state = 13},
  [746] = {.lex_state = 181, .external_lex_state = 3},
  [747] = {.lex_state = 203},
  [748] = {.lex_state = 145, .external_lex_state = 14},
  [749] = {.lex_state = 145, .external_lex_state = 14},
  [750] = {.lex_state = 145, .external_lex_state = 14},
  [751] = {.lex_state = 145, .external_lex_state = 14},
  [752] = {.lex_state = 145, .external_lex_state = 14},
  [753] = {.lex_state = 251, .external_lex_state = 16},
  [754] = {.lex_state = 145, .external_lex_state = 14},
  [755] = {.lex_state = 190, .external_lex_state = 16},
  [756] = {.lex_state = 115},
  [757] = {.lex_state = 190, .external_lex_state = 16},
  [758] = {.lex_state = 190, .external_lex_state = 16},
  [759] = {.lex_state = 190, .external_lex_state = 16},
  [760] = {.lex_state = 145, .external_lex_state = 14},
  [761] = {.lex_state = 190, .external_lex_state = 16},
  [762] = {.lex_state = 145, .external_lex_state = 14},
  [763] = {.lex_state = 190, .external_lex_state = 16},
  [764] = {.lex_state = 145, .external_lex_state = 14},
  [765] = {.lex_state = 145, .external_lex_state = 14},
  [766] = {.lex_state = 143, .external_lex_state = 15},
  [767] = {.lex_state = 143, .external_lex_state = 15},
  [768] = {.lex_state = 143, .external_lex_state = 15},
  [769] = {.lex_state = 251, .external_lex_state = 16},
  [770] = {.lex_state = 143, .external_lex_state = 15},
  [771] = {.lex_state = 190, .external_lex_state = 16},
  [772] = {.lex_state = 115},
  [773] = {.lex_state = 190, .external_lex_state = 16},
  [774] = {.lex_state = 190, .external_lex_state = 16},
  [775] = {.lex_state = 190, .external_lex_state = 16},
  [776] = {.lex_state = 143, .external_lex_state = 15},
  [777] = {.lex_state = 190, .external_lex_state = 16},
  [778] = {.lex_state = 143, .external_lex_state = 15},
  [779] = {.lex_state = 190, .external_lex_state = 16},
  [780] = {.lex_state = 143, .external_lex_state = 15},
  [781] = {.lex_state = 143, .external_lex_state = 15},
  [782] = {.lex_state = 153, .external_lex_state = 13},
  [783] = {.lex_state = 153},
  [784] = {.lex_state = 251, .external_lex_state = 16},
  [785] = {.lex_state = 153, .external_lex_state = 13},
  [786] = {.lex_state = 190, .external_lex_state = 16},
  [787] = {.lex_state = 115},
  [788] = {.lex_state = 190, .external_lex_state = 16},
  [789] = {.lex_state = 190, .external_lex_state = 16},
  [790] = {.lex_state = 190, .external_lex_state = 16},
  [791] = {.lex_state = 153, .external_lex_state = 13},
  [792] = {.lex_state = 190, .external_lex_state = 16},
  [793] = {.lex_state = 153, .external_lex_state = 13},
  [794] = {.lex_state = 190, .external_lex_state = 16},
  [795] = {.lex_state = 153, .external_lex_state = 13},
  [796] = {.lex_state = 226, .external_lex_state = 11},
  [797] = {.lex_state = 226, .external_lex_state = 11},
  [798] = {.lex_state = 226, .external_lex_state = 11},
  [799] = {.lex_state = 151, .external_lex_state = 4},
  [800] = {.lex_state = 278, .external_lex_state = 22},
  [801] = {.lex_state = 153},
  [802] = {.lex_state = 278, .external_lex_state = 22},
  [803] = {.lex_state = 160},
  [804] = {.lex_state = 163, .external_lex_state = 5},
  [805] = {.lex_state = 54, .external_lex_state = 2},
  [806] = {.lex_state = 54, .external_lex_state = 2},
  [807] = {.lex_state = 54, .external_lex_state = 2},
  [808] = {.lex_state = 115, .external_lex_state = 16},
  [809] = {.lex_state = 143},
  [810] = {.lex_state = 190, .external_lex_state = 22},
  [811] = {.lex_state = 190, .external_lex_state = 22},
  [812] = {.lex_state = 153},
  [813] = {.lex_state = 190, .external_lex_state = 22},
  [814] = {.lex_state = 190, .external_lex_state = 22},
  [815] = {.lex_state = 190, .external_lex_state = 22},
  [816] = {.lex_state = 115},
  [817] = {.lex_state = 190, .external_lex_state = 16},
  [818] = {.lex_state = 199, .external_lex_state = 5},
  [819] = {.lex_state = 190, .external_lex_state = 16},
  [820] = {.lex_state = 190, .external_lex_state = 16},
  [821] = {.lex_state = 115},
  [822] = {.lex_state = 208, .external_lex_state = 2},
  [823] = {.lex_state = 115},
  [824] = {.lex_state = 216, .external_lex_state = 2},
  [825] = {.lex_state = 115},
  [826] = {.lex_state = 208, .external_lex_state = 2},
  [827] = {.lex_state = 151, .external_lex_state = 4},
  [828] = {.lex_state = 190, .external_lex_state = 16},
  [829] = {.lex_state = 251, .external_lex_state = 16},
  [830] = {.lex_state = 151, .external_lex_state = 4},
  [831] = {.lex_state = 190, .external_lex_state = 16},
  [832] = {.lex_state = 151, .external_lex_state = 4},
  [833] = {.lex_state = 190, .external_lex_state = 16},
  [834] = {.lex_state = 190, .external_lex_state = 16},
  [835] = {.lex_state = 151, .external_lex_state = 4},
  [836] = {.lex_state = 208, .external_lex_state = 2},
  [837] = {.lex_state = 203},
  [838] = {.lex_state = 208, .external_lex_state = 15},
  [839] = {.lex_state = 153},
  [840] = {.lex_state = 208, .external_lex_state = 15},
  [841] = {.lex_state = 160},
  [842] = {.lex_state = 163, .external_lex_state = 5},
  [843] = {.lex_state = 54, .external_lex_state = 2},
  [844] = {.lex_state = 54, .external_lex_state = 2},
  [845] = {.lex_state = 54, .external_lex_state = 2},
  [846] = {.lex_state = 143},
  [847] = {.lex_state = 228, .external_lex_state = 2},
  [848] = {.lex_state = 255, .external_lex_state = 18},
  [849] = {.lex_state = 234, .external_lex_state = 2},
  [850] = {.lex_state = 178, .external_lex_state = 6},
  [851] = {.lex_state = 115},
  [852] = {.lex_state = 178, .external_lex_state = 6},
  [853] = {.lex_state = 115},
  [854] = {.lex_state = 115},
  [855] = {.lex_state = 244, .external_lex_state = 21},
  [856] = {.lex_state = 280, .external_lex_state = 18},
  [857] = {.lex_state = 115},
  [858] = {.lex_state = 249, .external_lex_state = 2},
  [859] = {.lex_state = 181, .external_lex_state = 6},
  [860] = {.lex_state = 176, .external_lex_state = 8},
  [861] = {.lex_state = 115},
  [862] = {.lex_state = 174, .external_lex_state = 9},
  [863] = {.lex_state = 201, .external_lex_state = 5},
  [864] = {.lex_state = 143},
  [865] = {.lex_state = 201, .external_lex_state = 23},
  [866] = {.lex_state = 201, .external_lex_state = 23},
  [867] = {.lex_state = 153},
  [868] = {.lex_state = 201, .external_lex_state = 23},
  [869] = {.lex_state = 201, .external_lex_state = 23},
  [870] = {.lex_state = 201, .external_lex_state = 23},
  [871] = {.lex_state = 115},
  [872] = {.lex_state = 190, .external_lex_state = 16},
  [873] = {.lex_state = 199, .external_lex_state = 5},
  [874] = {.lex_state = 190, .external_lex_state = 16},
  [875] = {.lex_state = 190, .external_lex_state = 16},
  [876] = {.lex_state = 115},
  [877] = {.lex_state = 208, .external_lex_state = 2},
  [878] = {.lex_state = 115},
  [879] = {.lex_state = 216, .external_lex_state = 2},
  [880] = {.lex_state = 115},
  [881] = {.lex_state = 208, .external_lex_state = 2},
  [882] = {.lex_state = 201, .external_lex_state = 5},
  [883] = {.lex_state = 203, .external_lex_state = 17},
  [884] = {.lex_state = 203, .external_lex_state = 17},
  [885] = {.lex_state = 203, .external_lex_state = 17},
  [886] = {.lex_state = 251, .external_lex_state = 16},
  [887] = {.lex_state = 203, .external_lex_state = 17},
  [888] = {.lex_state = 190, .external_lex_state = 16},
  [889] = {.lex_state = 115},
  [890] = {.lex_state = 190, .external_lex_state = 16},
  [891] = {.lex_state = 190, .external_lex_state = 16},
  [892] = {.lex_state = 190, .external_lex_state = 16},
  [893] = {.lex_state = 203, .external_lex_state = 17},
  [894] = {.lex_state = 190, .external_lex_state = 16},
  [895] = {.lex_state = 203, .external_lex_state = 17},
  [896] = {.lex_state = 190, .external_lex_state = 16},
  [897] = {.lex_state = 203, .external_lex_state = 17},
  [898] = {.lex_state = 203, .external_lex_state = 17},
  [899] = {.lex_state = 115},
  [900] = {.lex_state = 115},
  [901] = {.lex_state = 208, .external_lex_state = 2},
  [902] = {.lex_state = 115},
  [903] = {.lex_state = 208, .external_lex_state = 2},
  [904] = {.lex_state = 143},
  [905] = {.lex_state = 255, .external_lex_state = 17},
  [906] = {.lex_state = 153},
  [907] = {.lex_state = 255, .external_lex_state = 17},
  [908] = {.lex_state = 160},
  [909] = {.lex_state = 163, .external_lex_state = 5},
  [910] = {.lex_state = 54, .external_lex_state = 2},
  [911] = {.lex_state = 54, .external_lex_state = 2},
  [912] = {.lex_state = 54, .external_lex_state = 2},
  [913] = {.lex_state = 253, .external_lex_state = 18},
  [914] = {.lex_state = 253, .external_lex_state = 18},
  [915] = {.lex_state = 259, .external_lex_state = 24},
  [916] = {.lex_state = 253, .external_lex_state = 18},
  [917] = {.lex_state = 255, .external_lex_state = 17},
  [918] = {.lex_state = 255, .external_lex_state = 17},
  [919] = {.lex_state = 253, .external_lex_state = 18},
  [920] = {.lex_state = 203, .external_lex_state = 18},
  [921] = {.lex_state = 255, .external_lex_state = 18},
  [922] = {.lex_state = 255, .external_lex_state = 18},
  [923] = {.lex_state = 203, .external_lex_state = 18},
  [924] = {.lex_state = 216, .external_lex_state = 15},
  [925] = {.lex_state = 153},
  [926] = {.lex_state = 216, .external_lex_state = 15},
  [927] = {.lex_state = 160},
  [928] = {.lex_state = 163, .external_lex_state = 5},
  [929] = {.lex_state = 54, .external_lex_state = 2},
  [930] = {.lex_state = 54, .external_lex_state = 2},
  [931] = {.lex_state = 54, .external_lex_state = 2},
  [932] = {.lex_state = 257, .external_lex_state = 18},
  [933] = {.lex_state = 115},
  [934] = {.lex_state = 282, .external_lex_state = 18},
  [935] = {.lex_state = 174, .external_lex_state = 9},
  [936] = {.lex_state = 143},
  [937] = {.lex_state = 210, .external_lex_state = 23},
  [938] = {.lex_state = 210, .external_lex_state = 23},
  [939] = {.lex_state = 153},
  [940] = {.lex_state = 210, .external_lex_state = 23},
  [941] = {.lex_state = 210, .external_lex_state = 23},
  [942] = {.lex_state = 210, .external_lex_state = 23},
  [943] = {.lex_state = 115},
  [944] = {.lex_state = 190, .external_lex_state = 16},
  [945] = {.lex_state = 199, .external_lex_state = 5},
  [946] = {.lex_state = 190, .external_lex_state = 16},
  [947] = {.lex_state = 190, .external_lex_state = 16},
  [948] = {.lex_state = 115},
  [949] = {.lex_state = 208, .external_lex_state = 2},
  [950] = {.lex_state = 115},
  [951] = {.lex_state = 216, .external_lex_state = 2},
  [952] = {.lex_state = 115},
  [953] = {.lex_state = 208, .external_lex_state = 2},
  [954] = {.lex_state = 210, .external_lex_state = 5},
  [955] = {.lex_state = 212, .external_lex_state = 17},
  [956] = {.lex_state = 212, .external_lex_state = 17},
  [957] = {.lex_state = 212, .external_lex_state = 17},
  [958] = {.lex_state = 251, .external_lex_state = 16},
  [959] = {.lex_state = 212, .external_lex_state = 17},
  [960] = {.lex_state = 190, .external_lex_state = 16},
  [961] = {.lex_state = 115},
  [962] = {.lex_state = 190, .external_lex_state = 16},
  [963] = {.lex_state = 190, .external_lex_state = 16},
  [964] = {.lex_state = 190, .external_lex_state = 16},
  [965] = {.lex_state = 212, .external_lex_state = 17},
  [966] = {.lex_state = 190, .external_lex_state = 16},
  [967] = {.lex_state = 212, .external_lex_state = 17},
  [968] = {.lex_state = 190, .external_lex_state = 16},
  [969] = {.lex_state = 212, .external_lex_state = 17},
  [970] = {.lex_state = 212, .external_lex_state = 17},
  [971] = {.lex_state = 115},
  [972] = {.lex_state = 216, .external_lex_state = 2},
  [973] = {.lex_state = 115},
  [974] = {.lex_state = 216, .external_lex_state = 2},
  [975] = {.lex_state = 143},
  [976] = {.lex_state = 257, .external_lex_state = 17},
  [977] = {.lex_state = 153},
  [978] = {.lex_state = 257, .external_lex_state = 17},
  [979] = {.lex_state = 160},
  [980] = {.lex_state = 163, .external_lex_state = 5},
  [981] = {.lex_state = 54, .external_lex_state = 2},
  [982] = {.lex_state = 54, .external_lex_state = 2},
  [983] = {.lex_state = 54, .external_lex_state = 2},
  [984] = {.lex_state = 257, .external_lex_state = 17},
  [985] = {.lex_state = 257, .external_lex_state = 17},
  [986] = {.lex_state = 212, .external_lex_state = 18},
  [987] = {.lex_state = 257, .external_lex_state = 18},
  [988] = {.lex_state = 257, .external_lex_state = 18},
  [989] = {.lex_state = 212, .external_lex_state = 18},
  [990] = {.lex_state = 246, .external_lex_state = 7},
  [991] = {.lex_state = 224, .external_lex_state = 4},
  [992] = {.lex_state = 224, .external_lex_state = 4},
  [993] = {.lex_state = 220, .external_lex_state = 7},
  [994] = {.lex_state = 143},
  [995] = {.lex_state = 224, .external_lex_state = 4},
  [996] = {.lex_state = 224, .external_lex_state = 4},
  [997] = {.lex_state = 153},
  [998] = {.lex_state = 224, .external_lex_state = 4},
  [999] = {.lex_state = 224, .external_lex_state = 4},
  [1000] = {.lex_state = 224, .external_lex_state = 4},
  [1001] = {.lex_state = 115},
  [1002] = {.lex_state = 190, .external_lex_state = 16},
  [1003] = {.lex_state = 199, .external_lex_state = 5},
  [1004] = {.lex_state = 190, .external_lex_state = 16},
  [1005] = {.lex_state = 190, .external_lex_state = 16},
  [1006] = {.lex_state = 115},
  [1007] = {.lex_state = 208, .external_lex_state = 2},
  [1008] = {.lex_state = 115},
  [1009] = {.lex_state = 216, .external_lex_state = 2},
  [1010] = {.lex_state = 115},
  [1011] = {.lex_state = 208, .external_lex_state = 2},
  [1012] = {.lex_state = 259, .external_lex_state = 24},
  [1013] = {.lex_state = 220, .external_lex_state = 7},
  [1014] = {.lex_state = 160},
  [1015] = {.lex_state = 163, .external_lex_state = 5},
  [1016] = {.lex_state = 259, .external_lex_state = 24},
  [1017] = {.lex_state = 143, .external_lex_state = 15},
  [1018] = {.lex_state = 143, .external_lex_state = 15},
  [1019] = {.lex_state = 224, .external_lex_state = 7},
  [1020] = {.lex_state = 262, .external_lex_state = 13},
  [1021] = {.lex_state = 226, .external_lex_state = 11},
  [1022] = {.lex_state = 115},
  [1023] = {.lex_state = 143},
  [1024] = {.lex_state = 226, .external_lex_state = 11},
  [1025] = {.lex_state = 226, .external_lex_state = 11},
  [1026] = {.lex_state = 262, .external_lex_state = 13},
  [1027] = {.lex_state = 115},
  [1028] = {.lex_state = 251, .external_lex_state = 16},
  [1029] = {.lex_state = 226, .external_lex_state = 11},
  [1030] = {.lex_state = 190, .external_lex_state = 16},
  [1031] = {.lex_state = 115},
  [1032] = {.lex_state = 190, .external_lex_state = 16},
  [1033] = {.lex_state = 190, .external_lex_state = 16},
  [1034] = {.lex_state = 190, .external_lex_state = 16},
  [1035] = {.lex_state = 226, .external_lex_state = 11},
  [1036] = {.lex_state = 190, .external_lex_state = 16},
  [1037] = {.lex_state = 226, .external_lex_state = 11},
  [1038] = {.lex_state = 190, .external_lex_state = 16},
  [1039] = {.lex_state = 226, .external_lex_state = 11},
  [1040] = {.lex_state = 226, .external_lex_state = 11},
  [1041] = {.lex_state = 143},
  [1042] = {.lex_state = 264, .external_lex_state = 13},
  [1043] = {.lex_state = 264, .external_lex_state = 13},
  [1044] = {.lex_state = 153},
  [1045] = {.lex_state = 264, .external_lex_state = 13},
  [1046] = {.lex_state = 264, .external_lex_state = 13},
  [1047] = {.lex_state = 264, .external_lex_state = 13},
  [1048] = {.lex_state = 115},
  [1049] = {.lex_state = 190, .external_lex_state = 16},
  [1050] = {.lex_state = 199, .external_lex_state = 5},
  [1051] = {.lex_state = 190, .external_lex_state = 16},
  [1052] = {.lex_state = 190, .external_lex_state = 16},
  [1053] = {.lex_state = 115},
  [1054] = {.lex_state = 208, .external_lex_state = 2},
  [1055] = {.lex_state = 115},
  [1056] = {.lex_state = 216, .external_lex_state = 2},
  [1057] = {.lex_state = 115},
  [1058] = {.lex_state = 208, .external_lex_state = 2},
  [1059] = {.lex_state = 176, .external_lex_state = 8},
  [1060] = {.lex_state = 203},
  [1061] = {.lex_state = 170, .external_lex_state = 20},
  [1062] = {.lex_state = 170, .external_lex_state = 20},
  [1063] = {.lex_state = 170, .external_lex_state = 20},
  [1064] = {.lex_state = 251, .external_lex_state = 16},
  [1065] = {.lex_state = 170, .external_lex_state = 20},
  [1066] = {.lex_state = 190, .external_lex_state = 16},
  [1067] = {.lex_state = 115},
  [1068] = {.lex_state = 190, .external_lex_state = 16},
  [1069] = {.lex_state = 190, .external_lex_state = 16},
  [1070] = {.lex_state = 190, .external_lex_state = 16},
  [1071] = {.lex_state = 170, .external_lex_state = 20},
  [1072] = {.lex_state = 190, .external_lex_state = 16},
  [1073] = {.lex_state = 170, .external_lex_state = 20},
  [1074] = {.lex_state = 190, .external_lex_state = 16},
  [1075] = {.lex_state = 170, .external_lex_state = 20},
  [1076] = {.lex_state = 170, .external_lex_state = 20},
  [1077] = {.lex_state = 143},
  [1078] = {.lex_state = 266, .external_lex_state = 10},
  [1079] = {.lex_state = 266, .external_lex_state = 10},
  [1080] = {.lex_state = 153},
  [1081] = {.lex_state = 266, .external_lex_state = 10},
  [1082] = {.lex_state = 266, .external_lex_state = 10},
  [1083] = {.lex_state = 266, .external_lex_state = 10},
  [1084] = {.lex_state = 115},
  [1085] = {.lex_state = 190, .external_lex_state = 16},
  [1086] = {.lex_state = 199, .external_lex_state = 5},
  [1087] = {.lex_state = 190, .external_lex_state = 16},
  [1088] = {.lex_state = 190, .external_lex_state = 16},
  [1089] = {.lex_state = 115},
  [1090] = {.lex_state = 208, .external_lex_state = 2},
  [1091] = {.lex_state = 115},
  [1092] = {.lex_state = 216, .external_lex_state = 2},
  [1093] = {.lex_state = 115},
  [1094] = {.lex_state = 208, .external_lex_state = 2},
  [1095] = {.lex_state = 115},
  [1096] = {.lex_state = 266, .external_lex_state = 6},
  [1097] = {.lex_state = 228, .external_lex_state = 2},
  [1098] = {.lex_state = 220, .external_lex_state = 7},
  [1099] = {.lex_state = 228, .external_lex_state = 2},
  [1100] = {.lex_state = 115},
  [1101] = {.lex_state = 268, .external_lex_state = 2},
  [1102] = {.lex_state = 145, .external_lex_state = 6},
  [1103] = {.lex_state = 170, .external_lex_state = 8},
  [1104] = {.lex_state = 268, .external_lex_state = 2},
  [1105] = {.lex_state = 234, .external_lex_state = 2},
  [1106] = {.lex_state = 181, .external_lex_state = 6},
  [1107] = {.lex_state = 115},
  [1108] = {.lex_state = 234, .external_lex_state = 2},
  [1109] = {.lex_state = 115},
  [1110] = {.lex_state = 115},
  [1111] = {.lex_state = 181, .external_lex_state = 6},
  [1112] = {.lex_state = 284, .external_lex_state = 13},
  [1113] = {.lex_state = 153},
  [1114] = {.lex_state = 284, .external_lex_state = 13},
  [1115] = {.lex_state = 160},
  [1116] = {.lex_state = 163, .external_lex_state = 5},
  [1117] = {.lex_state = 54, .external_lex_state = 2},
  [1118] = {.lex_state = 54, .external_lex_state = 2},
  [1119] = {.lex_state = 54, .external_lex_state = 2},
  [1120] = {.lex_state = 143},
  [1121] = {.lex_state = 115},
  [1122] = {.lex_state = 140},
  [1123] = {.lex_state = 143},
  [1124] = {.lex_state = 270},
  [1125] = {.lex_state = 181, .external_lex_state = 6},
  [1126] = {.lex_state = 115},
  [1127] = {.lex_state = 143},
  [1128] = {.lex_state = 270},
  [1129] = {.lex_state = 178, .external_lex_state = 10},
  [1130] = {.lex_state = 278, .external_lex_state = 22},
  [1131] = {.lex_state = 278, .external_lex_state = 22},
  [1132] = {.lex_state = 115, .external_lex_state = 16},
  [1133] = {.lex_state = 178, .external_lex_state = 10},
  [1134] = {.lex_state = 251, .external_lex_state = 16},
  [1135] = {.lex_state = 178, .external_lex_state = 10},
  [1136] = {.lex_state = 190, .external_lex_state = 16},
  [1137] = {.lex_state = 178, .external_lex_state = 10},
  [1138] = {.lex_state = 190, .external_lex_state = 16},
  [1139] = {.lex_state = 190, .external_lex_state = 16},
  [1140] = {.lex_state = 178, .external_lex_state = 10},
  [1141] = {.lex_state = 246, .external_lex_state = 7},
  [1142] = {.lex_state = 244, .external_lex_state = 21},
  [1143] = {.lex_state = 276, .external_lex_state = 7},
  [1144] = {.lex_state = 244, .external_lex_state = 21},
  [1145] = {.lex_state = 143},
  [1146] = {.lex_state = 286, .external_lex_state = 10},
  [1147] = {.lex_state = 153},
  [1148] = {.lex_state = 286, .external_lex_state = 10},
  [1149] = {.lex_state = 160},
  [1150] = {.lex_state = 163, .external_lex_state = 5},
  [1151] = {.lex_state = 54, .external_lex_state = 2},
  [1152] = {.lex_state = 54, .external_lex_state = 2},
  [1153] = {.lex_state = 54, .external_lex_state = 2},
  [1154] = {.lex_state = 181, .external_lex_state = 6},
  [1155] = {.lex_state = 143},
  [1156] = {.lex_state = 176, .external_lex_state = 20},
  [1157] = {.lex_state = 176, .external_lex_state = 20},
  [1158] = {.lex_state = 153},
  [1159] = {.lex_state = 176, .external_lex_state = 20},
  [1160] = {.lex_state = 176, .external_lex_state = 20},
  [1161] = {.lex_state = 176, .external_lex_state = 20},
  [1162] = {.lex_state = 115},
  [1163] = {.lex_state = 190, .external_lex_state = 16},
  [1164] = {.lex_state = 199, .external_lex_state = 5},
  [1165] = {.lex_state = 190, .external_lex_state = 16},
  [1166] = {.lex_state = 190, .external_lex_state = 16},
  [1167] = {.lex_state = 115},
  [1168] = {.lex_state = 208, .external_lex_state = 2},
  [1169] = {.lex_state = 115},
  [1170] = {.lex_state = 216, .external_lex_state = 2},
  [1171] = {.lex_state = 115},
  [1172] = {.lex_state = 208, .external_lex_state = 2},
  [1173] = {.lex_state = 220, .external_lex_state = 7},
  [1174] = {.lex_state = 115},
  [1175] = {.lex_state = 54},
  [1176] = {.lex_state = 143},
  [1177] = {.lex_state = 181, .external_lex_state = 14},
  [1178] = {.lex_state = 181, .external_lex_state = 14},
  [1179] = {.lex_state = 181, .external_lex_state = 14},
  [1180] = {.lex_state = 181, .external_lex_state = 14},
  [1181] = {.lex_state = 181, .external_lex_state = 14},
  [1182] = {.lex_state = 251, .external_lex_state = 16},
  [1183] = {.lex_state = 181, .external_lex_state = 14},
  [1184] = {.lex_state = 190, .external_lex_state = 16},
  [1185] = {.lex_state = 115},
  [1186] = {.lex_state = 190, .external_lex_state = 16},
  [1187] = {.lex_state = 190, .external_lex_state = 16},
  [1188] = {.lex_state = 190, .external_lex_state = 16},
  [1189] = {.lex_state = 181, .external_lex_state = 14},
  [1190] = {.lex_state = 190, .external_lex_state = 16},
  [1191] = {.lex_state = 181, .external_lex_state = 14},
  [1192] = {.lex_state = 190, .external_lex_state = 16},
  [1193] = {.lex_state = 181, .external_lex_state = 14},
  [1194] = {.lex_state = 181, .external_lex_state = 14},
  [1195] = {.lex_state = 172, .external_lex_state = 4},
  [1196] = {.lex_state = 278, .external_lex_state = 22},
  [1197] = {.lex_state = 278, .external_lex_state = 22},
  [1198] = {.lex_state = 115, .external_lex_state = 16},
  [1199] = {.lex_state = 172, .external_lex_state = 4},
  [1200] = {.lex_state = 251, .external_lex_state = 16},
  [1201] = {.lex_state = 172, .external_lex_state = 4},
  [1202] = {.lex_state = 190, .external_lex_state = 16},
  [1203] = {.lex_state = 172, .external_lex_state = 4},
  [1204] = {.lex_state = 190, .external_lex_state = 16},
  [1205] = {.lex_state = 190, .external_lex_state = 16},
  [1206] = {.lex_state = 172, .external_lex_state = 4},
  [1207] = {.lex_state = 276, .external_lex_state = 7},
  [1208] = {.lex_state = 220, .external_lex_state = 4},
  [1209] = {.lex_state = 220, .external_lex_state = 4},
  [1210] = {.lex_state = 143},
  [1211] = {.lex_state = 220, .external_lex_state = 4},
  [1212] = {.lex_state = 220, .external_lex_state = 4},
  [1213] = {.lex_state = 153},
  [1214] = {.lex_state = 220, .external_lex_state = 4},
  [1215] = {.lex_state = 220, .external_lex_state = 4},
  [1216] = {.lex_state = 220, .external_lex_state = 4},
  [1217] = {.lex_state = 115},
  [1218] = {.lex_state = 190, .external_lex_state = 16},
  [1219] = {.lex_state = 199, .external_lex_state = 5},
  [1220] = {.lex_state = 190, .external_lex_state = 16},
  [1221] = {.lex_state = 190, .external_lex_state = 16},
  [1222] = {.lex_state = 115},
  [1223] = {.lex_state = 208, .external_lex_state = 2},
  [1224] = {.lex_state = 115},
  [1225] = {.lex_state = 216, .external_lex_state = 2},
  [1226] = {.lex_state = 115},
  [1227] = {.lex_state = 208, .external_lex_state = 2},
  [1228] = {.lex_state = 181, .external_lex_state = 6},
  [1229] = {.lex_state = 220, .external_lex_state = 7},
  [1230] = {.lex_state = 185, .external_lex_state = 11},
  [1231] = {.lex_state = 278, .external_lex_state = 22},
  [1232] = {.lex_state = 278, .external_lex_state = 22},
  [1233] = {.lex_state = 115, .external_lex_state = 16},
  [1234] = {.lex_state = 185, .external_lex_state = 11},
  [1235] = {.lex_state = 251, .external_lex_state = 16},
  [1236] = {.lex_state = 185, .external_lex_state = 11},
  [1237] = {.lex_state = 190, .external_lex_state = 16},
  [1238] = {.lex_state = 185, .external_lex_state = 11},
  [1239] = {.lex_state = 190, .external_lex_state = 16},
  [1240] = {.lex_state = 190, .external_lex_state = 16},
  [1241] = {.lex_state = 185, .external_lex_state = 11},
  [1242] = {.lex_state = 187, .external_lex_state = 13},
  [1243] = {.lex_state = 278, .external_lex_state = 22},
  [1244] = {.lex_state = 278, .external_lex_state = 22},
  [1245] = {.lex_state = 115, .external_lex_state = 16},
  [1246] = {.lex_state = 187, .external_lex_state = 13},
  [1247] = {.lex_state = 251, .external_lex_state = 16},
  [1248] = {.lex_state = 187, .external_lex_state = 13},
  [1249] = {.lex_state = 190, .external_lex_state = 16},
  [1250] = {.lex_state = 187, .external_lex_state = 13},
  [1251] = {.lex_state = 190, .external_lex_state = 16},
  [1252] = {.lex_state = 190, .external_lex_state = 16},
  [1253] = {.lex_state = 187, .external_lex_state = 13},
  [1254] = {.lex_state = 181, .external_lex_state = 3},
  [1255] = {.lex_state = 203},
  [1256] = {.lex_state = 145, .external_lex_state = 14},
  [1257] = {.lex_state = 278, .external_lex_state = 22},
  [1258] = {.lex_state = 278, .external_lex_state = 22},
  [1259] = {.lex_state = 115, .external_lex_state = 16},
  [1260] = {.lex_state = 145, .external_lex_state = 14},
  [1261] = {.lex_state = 251, .external_lex_state = 16},
  [1262] = {.lex_state = 145, .external_lex_state = 14},
  [1263] = {.lex_state = 190, .external_lex_state = 16},
  [1264] = {.lex_state = 145, .external_lex_state = 14},
  [1265] = {.lex_state = 190, .external_lex_state = 16},
  [1266] = {.lex_state = 190, .external_lex_state = 16},
  [1267] = {.lex_state = 145, .external_lex_state = 14},
  [1268] = {.lex_state = 143, .external_lex_state = 15},
  [1269] = {.lex_state = 278, .external_lex_state = 22},
  [1270] = {.lex_state = 278, .external_lex_state = 22},
  [1271] = {.lex_state = 115, .external_lex_state = 16},
  [1272] = {.lex_state = 143, .external_lex_state = 15},
  [1273] = {.lex_state = 251, .external_lex_state = 16},
  [1274] = {.lex_state = 143, .external_lex_state = 15},
  [1275] = {.lex_state = 190, .external_lex_state = 16},
  [1276] = {.lex_state = 143, .external_lex_state = 15},
  [1277] = {.lex_state = 190, .external_lex_state = 16},
  [1278] = {.lex_state = 190, .external_lex_state = 16},
  [1279] = {.lex_state = 143, .external_lex_state = 15},
  [1280] = {.lex_state = 153, .external_lex_state = 13},
  [1281] = {.lex_state = 153, .external_lex_state = 13},
  [1282] = {.lex_state = 278, .external_lex_state = 22},
  [1283] = {.lex_state = 278, .external_lex_state = 22},
  [1284] = {.lex_state = 115, .external_lex_state = 16},
  [1285] = {.lex_state = 153, .external_lex_state = 13},
  [1286] = {.lex_state = 251, .external_lex_state = 16},
  [1287] = {.lex_state = 153, .external_lex_state = 13},
  [1288] = {.lex_state = 190, .external_lex_state = 16},
  [1289] = {.lex_state = 153, .external_lex_state = 13},
  [1290] = {.lex_state = 190, .external_lex_state = 16},
  [1291] = {.lex_state = 190, .external_lex_state = 16},
  [1292] = {.lex_state = 153, .external_lex_state = 13},
  [1293] = {.lex_state = 185, .external_lex_state = 12},
  [1294] = {.lex_state = 190, .external_lex_state = 22},
  [1295] = {.lex_state = 185, .external_lex_state = 12},
  [1296] = {.lex_state = 190, .external_lex_state = 22},
  [1297] = {.lex_state = 115, .external_lex_state = 12},
  [1298] = {.lex_state = 143},
  [1299] = {.lex_state = 151, .external_lex_state = 4},
  [1300] = {.lex_state = 278, .external_lex_state = 22},
  [1301] = {.lex_state = 278, .external_lex_state = 22},
  [1302] = {.lex_state = 153},
  [1303] = {.lex_state = 151, .external_lex_state = 4},
  [1304] = {.lex_state = 278, .external_lex_state = 22},
  [1305] = {.lex_state = 278, .external_lex_state = 22},
  [1306] = {.lex_state = 278, .external_lex_state = 22},
  [1307] = {.lex_state = 115},
  [1308] = {.lex_state = 190, .external_lex_state = 16},
  [1309] = {.lex_state = 199, .external_lex_state = 5},
  [1310] = {.lex_state = 190, .external_lex_state = 16},
  [1311] = {.lex_state = 190, .external_lex_state = 16},
  [1312] = {.lex_state = 115},
  [1313] = {.lex_state = 208, .external_lex_state = 2},
  [1314] = {.lex_state = 115},
  [1315] = {.lex_state = 216, .external_lex_state = 2},
  [1316] = {.lex_state = 115},
  [1317] = {.lex_state = 208, .external_lex_state = 2},
  [1318] = {.lex_state = 190, .external_lex_state = 22},
  [1319] = {.lex_state = 190, .external_lex_state = 22},
  [1320] = {.lex_state = 190, .external_lex_state = 22},
  [1321] = {.lex_state = 251, .external_lex_state = 16},
  [1322] = {.lex_state = 190, .external_lex_state = 22},
  [1323] = {.lex_state = 190, .external_lex_state = 16},
  [1324] = {.lex_state = 115},
  [1325] = {.lex_state = 190, .external_lex_state = 16},
  [1326] = {.lex_state = 190, .external_lex_state = 16},
  [1327] = {.lex_state = 190, .external_lex_state = 16},
  [1328] = {.lex_state = 190, .external_lex_state = 22},
  [1329] = {.lex_state = 190, .external_lex_state = 16},
  [1330] = {.lex_state = 190, .external_lex_state = 22},
  [1331] = {.lex_state = 190, .external_lex_state = 16},
  [1332] = {.lex_state = 190, .external_lex_state = 22},
  [1333] = {.lex_state = 190, .external_lex_state = 22},
  [1334] = {.lex_state = 278, .external_lex_state = 22},
  [1335] = {.lex_state = 278, .external_lex_state = 22},
  [1336] = {.lex_state = 115, .external_lex_state = 16},
  [1337] = {.lex_state = 151, .external_lex_state = 4},
  [1338] = {.lex_state = 151, .external_lex_state = 4},
  [1339] = {.lex_state = 208, .external_lex_state = 2},
  [1340] = {.lex_state = 203},
  [1341] = {.lex_state = 143},
  [1342] = {.lex_state = 208, .external_lex_state = 15},
  [1343] = {.lex_state = 208, .external_lex_state = 15},
  [1344] = {.lex_state = 153},
  [1345] = {.lex_state = 208, .external_lex_state = 15},
  [1346] = {.lex_state = 208, .external_lex_state = 15},
  [1347] = {.lex_state = 208, .external_lex_state = 15},
  [1348] = {.lex_state = 115},
  [1349] = {.lex_state = 190, .external_lex_state = 16},
  [1350] = {.lex_state = 199, .external_lex_state = 5},
  [1351] = {.lex_state = 190, .external_lex_state = 16},
  [1352] = {.lex_state = 190, .external_lex_state = 16},
  [1353] = {.lex_state = 115},
  [1354] = {.lex_state = 208, .external_lex_state = 2},
  [1355] = {.lex_state = 115},
  [1356] = {.lex_state = 216, .external_lex_state = 2},
  [1357] = {.lex_state = 115},
  [1358] = {.lex_state = 208, .external_lex_state = 2},
  [1359] = {.lex_state = 266, .external_lex_state = 6},
  [1360] = {.lex_state = 253, .external_lex_state = 18},
  [1361] = {.lex_state = 228, .external_lex_state = 2},
  [1362] = {.lex_state = 255, .external_lex_state = 18},
  [1363] = {.lex_state = 115},
  [1364] = {.lex_state = 115},
  [1365] = {.lex_state = 234, .external_lex_state = 2},
  [1366] = {.lex_state = 115},
  [1367] = {.lex_state = 270},
  [1368] = {.lex_state = 178, .external_lex_state = 6},
  [1369] = {.lex_state = 270},
  [1370] = {.lex_state = 178, .external_lex_state = 6},
  [1371] = {.lex_state = 115},
  [1372] = {.lex_state = 288, .external_lex_state = 18},
  [1373] = {.lex_state = 244, .external_lex_state = 21},
  [1374] = {.lex_state = 54},
  [1375] = {.lex_state = 143},
  [1376] = {.lex_state = 115},
  [1377] = {.lex_state = 115},
  [1378] = {.lex_state = 249, .external_lex_state = 2},
  [1379] = {.lex_state = 201, .external_lex_state = 5},
  [1380] = {.lex_state = 203},
  [1381] = {.lex_state = 201, .external_lex_state = 23},
  [1382] = {.lex_state = 201, .external_lex_state = 23},
  [1383] = {.lex_state = 201, .external_lex_state = 23},
  [1384] = {.lex_state = 201, .external_lex_state = 23},
  [1385] = {.lex_state = 201, .external_lex_state = 23},
  [1386] = {.lex_state = 251, .external_lex_state = 16},
  [1387] = {.lex_state = 201, .external_lex_state = 23},
  [1388] = {.lex_state = 190, .external_lex_state = 16},
  [1389] = {.lex_state = 115},
  [1390] = {.lex_state = 190, .external_lex_state = 16},
  [1391] = {.lex_state = 190, .external_lex_state = 16},
  [1392] = {.lex_state = 190, .external_lex_state = 16},
  [1393] = {.lex_state = 201, .external_lex_state = 23},
  [1394] = {.lex_state = 190, .external_lex_state = 16},
  [1395] = {.lex_state = 201, .external_lex_state = 23},
  [1396] = {.lex_state = 190, .external_lex_state = 16},
  [1397] = {.lex_state = 201, .external_lex_state = 23},
  [1398] = {.lex_state = 201, .external_lex_state = 23},
  [1399] = {.lex_state = 203, .external_lex_state = 17},
  [1400] = {.lex_state = 278, .external_lex_state = 22},
  [1401] = {.lex_state = 278, .external_lex_state = 22},
  [1402] = {.lex_state = 115, .external_lex_state = 16},
  [1403] = {.lex_state = 203, .external_lex_state = 17},
  [1404] = {.lex_state = 251, .external_lex_state = 16},
  [1405] = {.lex_state = 203, .external_lex_state = 17},
  [1406] = {.lex_state = 190, .external_lex_state = 16},
  [1407] = {.lex_state = 203, .external_lex_state = 17},
  [1408] = {.lex_state = 190, .external_lex_state = 16},
  [1409] = {.lex_state = 190, .external_lex_state = 16},
  [1410] = {.lex_state = 203, .external_lex_state = 17},
  [1411] = {.lex_state = 280, .external_lex_state = 18},
  [1412] = {.lex_state = 255, .external_lex_state = 17},
  [1413] = {.lex_state = 255, .external_lex_state = 17},
  [1414] = {.lex_state = 253, .external_lex_state = 18},
  [1415] = {.lex_state = 143},
  [1416] = {.lex_state = 255, .external_lex_state = 17},
  [1417] = {.lex_state = 255, .external_lex_state = 17},
  [1418] = {.lex_state = 153},
  [1419] = {.lex_state = 255, .external_lex_state = 17},
  [1420] = {.lex_state = 255, .external_lex_state = 17},
  [1421] = {.lex_state = 255, .external_lex_state = 17},
  [1422] = {.lex_state = 115},
  [1423] = {.lex_state = 190, .external_lex_state = 16},
  [1424] = {.lex_state = 199, .external_lex_state = 5},
  [1425] = {.lex_state = 190, .external_lex_state = 16},
  [1426] = {.lex_state = 190, .external_lex_state = 16},
  [1427] = {.lex_state = 115},
  [1428] = {.lex_state = 208, .external_lex_state = 2},
  [1429] = {.lex_state = 115},
  [1430] = {.lex_state = 216, .external_lex_state = 2},
  [1431] = {.lex_state = 115},
  [1432] = {.lex_state = 208, .external_lex_state = 2},
  [1433] = {.lex_state = 253, .external_lex_state = 18},
  [1434] = {.lex_state = 259, .external_lex_state = 24},
  [1435] = {.lex_state = 255, .external_lex_state = 18},
  [1436] = {.lex_state = 143},
  [1437] = {.lex_state = 216, .external_lex_state = 15},
  [1438] = {.lex_state = 216, .external_lex_state = 15},
  [1439] = {.lex_state = 153},
  [1440] = {.lex_state = 216, .external_lex_state = 15},
  [1441] = {.lex_state = 216, .external_lex_state = 15},
  [1442] = {.lex_state = 216, .external_lex_state = 15},
  [1443] = {.lex_state = 115},
  [1444] = {.lex_state = 190, .external_lex_state = 16},
  [1445] = {.lex_state = 199, .external_lex_state = 5},
  [1446] = {.lex_state = 190, .external_lex_state = 16},
  [1447] = {.lex_state = 190, .external_lex_state = 16},
  [1448] = {.lex_state = 115},
  [1449] = {.lex_state = 208, .external_lex_state = 2},
  [1450] = {.lex_state = 115},
  [1451] = {.lex_state = 216, .external_lex_state = 2},
  [1452] = {.lex_state = 115},
  [1453] = {.lex_state = 208, .external_lex_state = 2},
  [1454] = {.lex_state = 257, .external_lex_state = 18},
  [1455] = {.lex_state = 115},
  [1456] = {.lex_state = 54},
  [1457] = {.lex_state = 143},
  [1458] = {.lex_state = 210, .external_lex_state = 23},
  [1459] = {.lex_state = 210, .external_lex_state = 23},
  [1460] = {.lex_state = 210, .external_lex_state = 23},
  [1461] = {.lex_state = 210, .external_lex_state = 23},
  [1462] = {.lex_state = 210, .external_lex_state = 23},
  [1463] = {.lex_state = 251, .external_lex_state = 16},
  [1464] = {.lex_state = 210, .external_lex_state = 23},
  [1465] = {.lex_state = 190, .external_lex_state = 16},
  [1466] = {.lex_state = 115},
  [1467] = {.lex_state = 190, .external_lex_state = 16},
  [1468] = {.lex_state = 190, .external_lex_state = 16},
  [1469] = {.lex_state = 190, .external_lex_state = 16},
  [1470] = {.lex_state = 210, .external_lex_state = 23},
  [1471] = {.lex_state = 190, .external_lex_state = 16},
  [1472] = {.lex_state = 210, .external_lex_state = 23},
  [1473] = {.lex_state = 190, .external_lex_state = 16},
  [1474] = {.lex_state = 210, .external_lex_state = 23},
  [1475] = {.lex_state = 210, .external_lex_state = 23},
  [1476] = {.lex_state = 212, .external_lex_state = 17},
  [1477] = {.lex_state = 278, .external_lex_state = 22},
  [1478] = {.lex_state = 278, .external_lex_state = 22},
  [1479] = {.lex_state = 115, .external_lex_state = 16},
  [1480] = {.lex_state = 212, .external_lex_state = 17},
  [1481] = {.lex_state = 251, .external_lex_state = 16},
  [1482] = {.lex_state = 212, .external_lex_state = 17},
  [1483] = {.lex_state = 190, .external_lex_state = 16},
  [1484] = {.lex_state = 212, .external_lex_state = 17},
  [1485] = {.lex_state = 190, .external_lex_state = 16},
  [1486] = {.lex_state = 190, .external_lex_state = 16},
  [1487] = {.lex_state = 212, .external_lex_state = 17},
  [1488] = {.lex_state = 282, .external_lex_state = 18},
  [1489] = {.lex_state = 257, .external_lex_state = 17},
  [1490] = {.lex_state = 257, .external_lex_state = 17},
  [1491] = {.lex_state = 143},
  [1492] = {.lex_state = 257, .external_lex_state = 17},
  [1493] = {.lex_state = 257, .external_lex_state = 17},
  [1494] = {.lex_state = 153},
  [1495] = {.lex_state = 257, .external_lex_state = 17},
  [1496] = {.lex_state = 257, .external_lex_state = 17},
  [1497] = {.lex_state = 257, .external_lex_state = 17},
  [1498] = {.lex_state = 115},
  [1499] = {.lex_state = 190, .external_lex_state = 16},
  [1500] = {.lex_state = 199, .external_lex_state = 5},
  [1501] = {.lex_state = 190, .external_lex_state = 16},
  [1502] = {.lex_state = 190, .external_lex_state = 16},
  [1503] = {.lex_state = 115},
  [1504] = {.lex_state = 208, .external_lex_state = 2},
  [1505] = {.lex_state = 115},
  [1506] = {.lex_state = 216, .external_lex_state = 2},
  [1507] = {.lex_state = 115},
  [1508] = {.lex_state = 208, .external_lex_state = 2},
  [1509] = {.lex_state = 257, .external_lex_state = 18},
  [1510] = {.lex_state = 181, .external_lex_state = 6},
  [1511] = {.lex_state = 224, .external_lex_state = 4},
  [1512] = {.lex_state = 224, .external_lex_state = 4},
  [1513] = {.lex_state = 224, .external_lex_state = 4},
  [1514] = {.lex_state = 251, .external_lex_state = 16},
  [1515] = {.lex_state = 224, .external_lex_state = 4},
  [1516] = {.lex_state = 190, .external_lex_state = 16},
  [1517] = {.lex_state = 115},
  [1518] = {.lex_state = 190, .external_lex_state = 16},
  [1519] = {.lex_state = 190, .external_lex_state = 16},
  [1520] = {.lex_state = 190, .external_lex_state = 16},
  [1521] = {.lex_state = 224, .external_lex_state = 4},
  [1522] = {.lex_state = 190, .external_lex_state = 16},
  [1523] = {.lex_state = 224, .external_lex_state = 4},
  [1524] = {.lex_state = 190, .external_lex_state = 16},
  [1525] = {.lex_state = 224, .external_lex_state = 4},
  [1526] = {.lex_state = 224, .external_lex_state = 4},
  [1527] = {.lex_state = 153},
  [1528] = {.lex_state = 259, .external_lex_state = 24},
  [1529] = {.lex_state = 259, .external_lex_state = 24},
  [1530] = {.lex_state = 259, .external_lex_state = 24},
  [1531] = {.lex_state = 115},
  [1532] = {.lex_state = 190, .external_lex_state = 16},
  [1533] = {.lex_state = 199, .external_lex_state = 5},
  [1534] = {.lex_state = 190, .external_lex_state = 16},
  [1535] = {.lex_state = 190, .external_lex_state = 16},
  [1536] = {.lex_state = 220, .external_lex_state = 7},
  [1537] = {.lex_state = 259, .external_lex_state = 24},
  [1538] = {.lex_state = 115},
  [1539] = {.lex_state = 115},
  [1540] = {.lex_state = 226, .external_lex_state = 11},
  [1541] = {.lex_state = 278, .external_lex_state = 22},
  [1542] = {.lex_state = 278, .external_lex_state = 22},
  [1543] = {.lex_state = 115, .external_lex_state = 16},
  [1544] = {.lex_state = 226, .external_lex_state = 11},
  [1545] = {.lex_state = 251, .external_lex_state = 16},
  [1546] = {.lex_state = 226, .external_lex_state = 11},
  [1547] = {.lex_state = 190, .external_lex_state = 16},
  [1548] = {.lex_state = 226, .external_lex_state = 11},
  [1549] = {.lex_state = 190, .external_lex_state = 16},
  [1550] = {.lex_state = 190, .external_lex_state = 16},
  [1551] = {.lex_state = 226, .external_lex_state = 11},
  [1552] = {.lex_state = 264, .external_lex_state = 13},
  [1553] = {.lex_state = 264, .external_lex_state = 13},
  [1554] = {.lex_state = 264, .external_lex_state = 13},
  [1555] = {.lex_state = 251, .external_lex_state = 16},
  [1556] = {.lex_state = 264, .external_lex_state = 13},
  [1557] = {.lex_state = 190, .external_lex_state = 16},
  [1558] = {.lex_state = 115},
  [1559] = {.lex_state = 190, .external_lex_state = 16},
  [1560] = {.lex_state = 190, .external_lex_state = 16},
  [1561] = {.lex_state = 190, .external_lex_state = 16},
  [1562] = {.lex_state = 264, .external_lex_state = 13},
  [1563] = {.lex_state = 190, .external_lex_state = 16},
  [1564] = {.lex_state = 264, .external_lex_state = 13},
  [1565] = {.lex_state = 190, .external_lex_state = 16},
  [1566] = {.lex_state = 264, .external_lex_state = 13},
  [1567] = {.lex_state = 264, .external_lex_state = 13},
  [1568] = {.lex_state = 170, .external_lex_state = 20},
  [1569] = {.lex_state = 278, .external_lex_state = 22},
  [1570] = {.lex_state = 278, .external_lex_state = 22},
  [1571] = {.lex_state = 115, .external_lex_state = 16},
  [1572] = {.lex_state = 170, .external_lex_state = 20},
  [1573] = {.lex_state = 251, .external_lex_state = 16},
  [1574] = {.lex_state = 170, .external_lex_state = 20},
  [1575] = {.lex_state = 190, .external_lex_state = 16},
  [1576] = {.lex_state = 170, .external_lex_state = 20},
  [1577] = {.lex_state = 190, .external_lex_state = 16},
  [1578] = {.lex_state = 190, .external_lex_state = 16},
  [1579] = {.lex_state = 170, .external_lex_state = 20},
  [1580] = {.lex_state = 266, .external_lex_state = 10},
  [1581] = {.lex_state = 266, .external_lex_state = 10},
  [1582] = {.lex_state = 266, .external_lex_state = 10},
  [1583] = {.lex_state = 251, .external_lex_state = 16},
  [1584] = {.lex_state = 266, .external_lex_state = 10},
  [1585] = {.lex_state = 190, .external_lex_state = 16},
  [1586] = {.lex_state = 115},
  [1587] = {.lex_state = 190, .external_lex_state = 16},
  [1588] = {.lex_state = 190, .external_lex_state = 16},
  [1589] = {.lex_state = 190, .external_lex_state = 16},
  [1590] = {.lex_state = 266, .external_lex_state = 10},
  [1591] = {.lex_state = 190, .external_lex_state = 16},
  [1592] = {.lex_state = 266, .external_lex_state = 10},
  [1593] = {.lex_state = 190, .external_lex_state = 16},
  [1594] = {.lex_state = 266, .external_lex_state = 10},
  [1595] = {.lex_state = 266, .external_lex_state = 10},
  [1596] = {.lex_state = 228, .external_lex_state = 2},
  [1597] = {.lex_state = 181, .external_lex_state = 6},
  [1598] = {.lex_state = 234, .external_lex_state = 2},
  [1599] = {.lex_state = 268, .external_lex_state = 2},
  [1600] = {.lex_state = 268, .external_lex_state = 2},
  [1601] = {.lex_state = 181, .external_lex_state = 6},
  [1602] = {.lex_state = 115},
  [1603] = {.lex_state = 143},
  [1604] = {.lex_state = 143},
  [1605] = {.lex_state = 290, .external_lex_state = 2},
  [1606] = {.lex_state = 140},
  [1607] = {.lex_state = 284, .external_lex_state = 13},
  [1608] = {.lex_state = 284, .external_lex_state = 13},
  [1609] = {.lex_state = 153},
  [1610] = {.lex_state = 290, .external_lex_state = 2},
  [1611] = {.lex_state = 140},
  [1612] = {.lex_state = 284, .external_lex_state = 13},
  [1613] = {.lex_state = 284, .external_lex_state = 13},
  [1614] = {.lex_state = 284, .external_lex_state = 13},
  [1615] = {.lex_state = 115},
  [1616] = {.lex_state = 190, .external_lex_state = 16},
  [1617] = {.lex_state = 199, .external_lex_state = 5},
  [1618] = {.lex_state = 190, .external_lex_state = 16},
  [1619] = {.lex_state = 190, .external_lex_state = 16},
  [1620] = {.lex_state = 115},
  [1621] = {.lex_state = 208, .external_lex_state = 2},
  [1622] = {.lex_state = 115},
  [1623] = {.lex_state = 216, .external_lex_state = 2},
  [1624] = {.lex_state = 115},
  [1625] = {.lex_state = 208, .external_lex_state = 2},
  [1626] = {.lex_state = 181, .external_lex_state = 6},
  [1627] = {.lex_state = 115},
  [1628] = {.lex_state = 143},
  [1629] = {.lex_state = 181, .external_lex_state = 6},
  [1630] = {.lex_state = 143},
  [1631] = {.lex_state = 181, .external_lex_state = 6},
  [1632] = {.lex_state = 115},
  [1633] = {.lex_state = 181, .external_lex_state = 6},
  [1634] = {.lex_state = 143},
  [1635] = {.lex_state = 178, .external_lex_state = 10},
  [1636] = {.lex_state = 178, .external_lex_state = 10},
  [1637] = {.lex_state = 278, .external_lex_state = 22},
  [1638] = {.lex_state = 278, .external_lex_state = 22},
  [1639] = {.lex_state = 115, .external_lex_state = 16},
  [1640] = {.lex_state = 178, .external_lex_state = 10},
  [1641] = {.lex_state = 178, .external_lex_state = 10},
  [1642] = {.lex_state = 181, .external_lex_state = 6},
  [1643] = {.lex_state = 286, .external_lex_state = 10},
  [1644] = {.lex_state = 286, .external_lex_state = 10},
  [1645] = {.lex_state = 181, .external_lex_state = 6},
  [1646] = {.lex_state = 143},
  [1647] = {.lex_state = 286, .external_lex_state = 10},
  [1648] = {.lex_state = 286, .external_lex_state = 10},
  [1649] = {.lex_state = 153},
  [1650] = {.lex_state = 286, .external_lex_state = 10},
  [1651] = {.lex_state = 286, .external_lex_state = 10},
  [1652] = {.lex_state = 286, .external_lex_state = 10},
  [1653] = {.lex_state = 115},
  [1654] = {.lex_state = 190, .external_lex_state = 16},
  [1655] = {.lex_state = 199, .external_lex_state = 5},
  [1656] = {.lex_state = 190, .external_lex_state = 16},
  [1657] = {.lex_state = 190, .external_lex_state = 16},
  [1658] = {.lex_state = 115},
  [1659] = {.lex_state = 208, .external_lex_state = 2},
  [1660] = {.lex_state = 115},
  [1661] = {.lex_state = 216, .external_lex_state = 2},
  [1662] = {.lex_state = 115},
  [1663] = {.lex_state = 208, .external_lex_state = 2},
  [1664] = {.lex_state = 176, .external_lex_state = 20},
  [1665] = {.lex_state = 176, .external_lex_state = 20},
  [1666] = {.lex_state = 176, .external_lex_state = 20},
  [1667] = {.lex_state = 251, .external_lex_state = 16},
  [1668] = {.lex_state = 176, .external_lex_state = 20},
  [1669] = {.lex_state = 190, .external_lex_state = 16},
  [1670] = {.lex_state = 115},
  [1671] = {.lex_state = 190, .external_lex_state = 16},
  [1672] = {.lex_state = 190, .external_lex_state = 16},
  [1673] = {.lex_state = 190, .external_lex_state = 16},
  [1674] = {.lex_state = 176, .external_lex_state = 20},
  [1675] = {.lex_state = 190, .external_lex_state = 16},
  [1676] = {.lex_state = 176, .external_lex_state = 20},
  [1677] = {.lex_state = 190, .external_lex_state = 16},
  [1678] = {.lex_state = 176, .external_lex_state = 20},
  [1679] = {.lex_state = 176, .external_lex_state = 20},
  [1680] = {.lex_state = 276, .external_lex_state = 7},
  [1681] = {.lex_state = 143},
  [1682] = {.lex_state = 293, .external_lex_state = 10},
  [1683] = {.lex_state = 153},
  [1684] = {.lex_state = 293, .external_lex_state = 10},
  [1685] = {.lex_state = 160},
  [1686] = {.lex_state = 163, .external_lex_state = 5},
  [1687] = {.lex_state = 54, .external_lex_state = 2},
  [1688] = {.lex_state = 54, .external_lex_state = 2},
  [1689] = {.lex_state = 54, .external_lex_state = 2},
  [1690] = {.lex_state = 181, .external_lex_state = 14},
  [1691] = {.lex_state = 278, .external_lex_state = 22},
  [1692] = {.lex_state = 278, .external_lex_state = 22},
  [1693] = {.lex_state = 115, .external_lex_state = 16},
  [1694] = {.lex_state = 181, .external_lex_state = 14},
  [1695] = {.lex_state = 251, .external_lex_state = 16},
  [1696] = {.lex_state = 181, .external_lex_state = 14},
  [1697] = {.lex_state = 190, .external_lex_state = 16},
  [1698] = {.lex_state = 181, .external_lex_state = 14},
  [1699] = {.lex_state = 190, .external_lex_state = 16},
  [1700] = {.lex_state = 190, .external_lex_state = 16},
  [1701] = {.lex_state = 181, .external_lex_state = 14},
  [1702] = {.lex_state = 172, .external_lex_state = 4},
  [1703] = {.lex_state = 172, .external_lex_state = 4},
  [1704] = {.lex_state = 278, .external_lex_state = 22},
  [1705] = {.lex_state = 278, .external_lex_state = 22},
  [1706] = {.lex_state = 115, .external_lex_state = 16},
  [1707] = {.lex_state = 172, .external_lex_state = 4},
  [1708] = {.lex_state = 172, .external_lex_state = 4},
  [1709] = {.lex_state = 220, .external_lex_state = 4},
  [1710] = {.lex_state = 220, .external_lex_state = 4},
  [1711] = {.lex_state = 220, .external_lex_state = 4},
  [1712] = {.lex_state = 251, .external_lex_state = 16},
  [1713] = {.lex_state = 220, .external_lex_state = 4},
  [1714] = {.lex_state = 190, .external_lex_state = 16},
  [1715] = {.lex_state = 115},
  [1716] = {.lex_state = 190, .external_lex_state = 16},
  [1717] = {.lex_state = 190, .external_lex_state = 16},
  [1718] = {.lex_state = 190, .external_lex_state = 16},
  [1719] = {.lex_state = 220, .external_lex_state = 4},
  [1720] = {.lex_state = 190, .external_lex_state = 16},
  [1721] = {.lex_state = 220, .external_lex_state = 4},
  [1722] = {.lex_state = 190, .external_lex_state = 16},
  [1723] = {.lex_state = 220, .external_lex_state = 4},
  [1724] = {.lex_state = 220, .external_lex_state = 4},
  [1725] = {.lex_state = 185, .external_lex_state = 11},
  [1726] = {.lex_state = 185, .external_lex_state = 11},
  [1727] = {.lex_state = 278, .external_lex_state = 22},
  [1728] = {.lex_state = 278, .external_lex_state = 22},
  [1729] = {.lex_state = 115, .external_lex_state = 16},
  [1730] = {.lex_state = 185, .external_lex_state = 11},
  [1731] = {.lex_state = 185, .external_lex_state = 11},
  [1732] = {.lex_state = 187, .external_lex_state = 13},
  [1733] = {.lex_state = 187, .external_lex_state = 13},
  [1734] = {.lex_state = 278, .external_lex_state = 22},
  [1735] = {.lex_state = 278, .external_lex_state = 22},
  [1736] = {.lex_state = 115, .external_lex_state = 16},
  [1737] = {.lex_state = 187, .external_lex_state = 13},
  [1738] = {.lex_state = 187, .external_lex_state = 13},
  [1739] = {.lex_state = 181, .external_lex_state = 3},
  [1740] = {.lex_state = 145, .external_lex_state = 14},
  [1741] = {.lex_state = 145, .external_lex_state = 14},
  [1742] = {.lex_state = 278, .external_lex_state = 22},
  [1743] = {.lex_state = 278, .external_lex_state = 22},
  [1744] = {.lex_state = 115, .external_lex_state = 16},
  [1745] = {.lex_state = 145, .external_lex_state = 14},
  [1746] = {.lex_state = 145, .external_lex_state = 14},
  [1747] = {.lex_state = 143, .external_lex_state = 15},
  [1748] = {.lex_state = 143, .external_lex_state = 15},
  [1749] = {.lex_state = 278, .external_lex_state = 22},
  [1750] = {.lex_state = 278, .external_lex_state = 22},
  [1751] = {.lex_state = 115, .external_lex_state = 16},
  [1752] = {.lex_state = 143, .external_lex_state = 15},
  [1753] = {.lex_state = 143, .external_lex_state = 15},
  [1754] = {.lex_state = 153, .external_lex_state = 13},
  [1755] = {.lex_state = 153, .external_lex_state = 13},
  [1756] = {.lex_state = 278, .external_lex_state = 22},
  [1757] = {.lex_state = 278, .external_lex_state = 22},
  [1758] = {.lex_state = 115, .external_lex_state = 16},
  [1759] = {.lex_state = 153, .external_lex_state = 13},
  [1760] = {.lex_state = 153, .external_lex_state = 13},
  [1761] = {.lex_state = 190, .external_lex_state = 22},
  [1762] = {.lex_state = 190, .external_lex_state = 16},
  [1763] = {.lex_state = 190, .external_lex_state = 22},
  [1764] = {.lex_state = 190, .external_lex_state = 16},
  [1765] = {.lex_state = 278, .external_lex_state = 22},
  [1766] = {.lex_state = 278, .external_lex_state = 22},
  [1767] = {.lex_state = 278, .external_lex_state = 22},
  [1768] = {.lex_state = 251, .external_lex_state = 16},
  [1769] = {.lex_state = 278, .external_lex_state = 22},
  [1770] = {.lex_state = 190, .external_lex_state = 16},
  [1771] = {.lex_state = 115},
  [1772] = {.lex_state = 190, .external_lex_state = 16},
  [1773] = {.lex_state = 190, .external_lex_state = 16},
  [1774] = {.lex_state = 190, .external_lex_state = 16},
  [1775] = {.lex_state = 278, .external_lex_state = 22},
  [1776] = {.lex_state = 190, .external_lex_state = 16},
  [1777] = {.lex_state = 278, .external_lex_state = 22},
  [1778] = {.lex_state = 190, .external_lex_state = 16},
  [1779] = {.lex_state = 278, .external_lex_state = 22},
  [1780] = {.lex_state = 278, .external_lex_state = 22},
  [1781] = {.lex_state = 190, .external_lex_state = 22},
  [1782] = {.lex_state = 278, .external_lex_state = 22},
  [1783] = {.lex_state = 278, .external_lex_state = 22},
  [1784] = {.lex_state = 115, .external_lex_state = 16},
  [1785] = {.lex_state = 190, .external_lex_state = 22},
  [1786] = {.lex_state = 251, .external_lex_state = 16},
  [1787] = {.lex_state = 190, .external_lex_state = 22},
  [1788] = {.lex_state = 190, .external_lex_state = 16},
  [1789] = {.lex_state = 190, .external_lex_state = 22},
  [1790] = {.lex_state = 190, .external_lex_state = 16},
  [1791] = {.lex_state = 190, .external_lex_state = 16},
  [1792] = {.lex_state = 190, .external_lex_state = 22},
  [1793] = {.lex_state = 151, .external_lex_state = 4},
  [1794] = {.lex_state = 151, .external_lex_state = 4},
  [1795] = {.lex_state = 208, .external_lex_state = 2},
  [1796] = {.lex_state = 208, .external_lex_state = 15},
  [1797] = {.lex_state = 208, .external_lex_state = 15},
  [1798] = {.lex_state = 208, .external_lex_state = 15},
  [1799] = {.lex_state = 251, .external_lex_state = 16},
  [1800] = {.lex_state = 208, .external_lex_state = 15},
  [1801] = {.lex_state = 190, .external_lex_state = 16},
  [1802] = {.lex_state = 115},
  [1803] = {.lex_state = 190, .external_lex_state = 16},
  [1804] = {.lex_state = 190, .external_lex_state = 16},
  [1805] = {.lex_state = 190, .external_lex_state = 16},
  [1806] = {.lex_state = 208, .external_lex_state = 15},
  [1807] = {.lex_state = 190, .external_lex_state = 16},
  [1808] = {.lex_state = 208, .external_lex_state = 15},
  [1809] = {.lex_state = 190, .external_lex_state = 16},
  [1810] = {.lex_state = 208, .external_lex_state = 15},
  [1811] = {.lex_state = 208, .external_lex_state = 15},
  [1812] = {.lex_state = 115},
  [1813] = {.lex_state = 253, .external_lex_state = 18},
  [1814] = {.lex_state = 115},
  [1815] = {.lex_state = 115},
  [1816] = {.lex_state = 115},
  [1817] = {.lex_state = 115},
  [1818] = {.lex_state = 115},
  [1819] = {.lex_state = 143},
  [1820] = {.lex_state = 270},
  [1821] = {.lex_state = 115},
  [1822] = {.lex_state = 115},
  [1823] = {.lex_state = 143},
  [1824] = {.lex_state = 270},
  [1825] = {.lex_state = 280, .external_lex_state = 18},
  [1826] = {.lex_state = 288, .external_lex_state = 18},
  [1827] = {.lex_state = 143},
  [1828] = {.lex_state = 295, .external_lex_state = 13},
  [1829] = {.lex_state = 153},
  [1830] = {.lex_state = 295, .external_lex_state = 13},
  [1831] = {.lex_state = 160},
  [1832] = {.lex_state = 163, .external_lex_state = 5},
  [1833] = {.lex_state = 54, .external_lex_state = 2},
  [1834] = {.lex_state = 54, .external_lex_state = 2},
  [1835] = {.lex_state = 54, .external_lex_state = 2},
  [1836] = {.lex_state = 115},
  [1837] = {.lex_state = 115},
  [1838] = {.lex_state = 201, .external_lex_state = 5},
  [1839] = {.lex_state = 203},
  [1840] = {.lex_state = 201, .external_lex_state = 23},
  [1841] = {.lex_state = 278, .external_lex_state = 22},
  [1842] = {.lex_state = 278, .external_lex_state = 22},
  [1843] = {.lex_state = 115, .external_lex_state = 16},
  [1844] = {.lex_state = 201, .external_lex_state = 23},
  [1845] = {.lex_state = 251, .external_lex_state = 16},
  [1846] = {.lex_state = 201, .external_lex_state = 23},
  [1847] = {.lex_state = 190, .external_lex_state = 16},
  [1848] = {.lex_state = 201, .external_lex_state = 23},
  [1849] = {.lex_state = 190, .external_lex_state = 16},
  [1850] = {.lex_state = 190, .external_lex_state = 16},
  [1851] = {.lex_state = 201, .external_lex_state = 23},
  [1852] = {.lex_state = 203, .external_lex_state = 17},
  [1853] = {.lex_state = 203, .external_lex_state = 17},
  [1854] = {.lex_state = 278, .external_lex_state = 22},
  [1855] = {.lex_state = 278, .external_lex_state = 22},
  [1856] = {.lex_state = 115, .external_lex_state = 16},
  [1857] = {.lex_state = 203, .external_lex_state = 17},
  [1858] = {.lex_state = 203, .external_lex_state = 17},
  [1859] = {.lex_state = 115},
  [1860] = {.lex_state = 255, .external_lex_state = 17},
  [1861] = {.lex_state = 255, .external_lex_state = 17},
  [1862] = {.lex_state = 255, .external_lex_state = 17},
  [1863] = {.lex_state = 251, .external_lex_state = 16},
  [1864] = {.lex_state = 255, .external_lex_state = 17},
  [1865] = {.lex_state = 190, .external_lex_state = 16},
  [1866] = {.lex_state = 115},
  [1867] = {.lex_state = 190, .external_lex_state = 16},
  [1868] = {.lex_state = 190, .external_lex_state = 16},
  [1869] = {.lex_state = 190, .external_lex_state = 16},
  [1870] = {.lex_state = 255, .external_lex_state = 17},
  [1871] = {.lex_state = 190, .external_lex_state = 16},
  [1872] = {.lex_state = 255, .external_lex_state = 17},
  [1873] = {.lex_state = 190, .external_lex_state = 16},
  [1874] = {.lex_state = 255, .external_lex_state = 17},
  [1875] = {.lex_state = 255, .external_lex_state = 17},
  [1876] = {.lex_state = 253, .external_lex_state = 18},
  [1877] = {.lex_state = 216, .external_lex_state = 15},
  [1878] = {.lex_state = 216, .external_lex_state = 15},
  [1879] = {.lex_state = 216, .external_lex_state = 15},
  [1880] = {.lex_state = 251, .external_lex_state = 16},
  [1881] = {.lex_state = 216, .external_lex_state = 15},
  [1882] = {.lex_state = 190, .external_lex_state = 16},
  [1883] = {.lex_state = 115},
  [1884] = {.lex_state = 190, .external_lex_state = 16},
  [1885] = {.lex_state = 190, .external_lex_state = 16},
  [1886] = {.lex_state = 190, .external_lex_state = 16},
  [1887] = {.lex_state = 216, .external_lex_state = 15},
  [1888] = {.lex_state = 190, .external_lex_state = 16},
  [1889] = {.lex_state = 216, .external_lex_state = 15},
  [1890] = {.lex_state = 190, .external_lex_state = 16},
  [1891] = {.lex_state = 216, .external_lex_state = 15},
  [1892] = {.lex_state = 216, .external_lex_state = 15},
  [1893] = {.lex_state = 282, .external_lex_state = 18},
  [1894] = {.lex_state = 143},
  [1895] = {.lex_state = 297, .external_lex_state = 13},
  [1896] = {.lex_state = 153},
  [1897] = {.lex_state = 297, .external_lex_state = 13},
  [1898] = {.lex_state = 160},
  [1899] = {.lex_state = 163, .external_lex_state = 5},
  [1900] = {.lex_state = 54, .external_lex_state = 2},
  [1901] = {.lex_state = 54, .external_lex_state = 2},
  [1902] = {.lex_state = 54, .external_lex_state = 2},
  [1903] = {.lex_state = 210, .external_lex_state = 23},
  [1904] = {.lex_state = 278, .external_lex_state = 22},
  [1905] = {.lex_state = 278, .external_lex_state = 22},
  [1906] = {.lex_state = 115, .external_lex_state = 16},
  [1907] = {.lex_state = 210, .external_lex_state = 23},
  [1908] = {.lex_state = 251, .external_lex_state = 16},
  [1909] = {.lex_state = 210, .external_lex_state = 23},
  [1910] = {.lex_state = 190, .external_lex_state = 16},
  [1911] = {.lex_state = 210, .external_lex_state = 23},
  [1912] = {.lex_state = 190, .external_lex_state = 16},
  [1913] = {.lex_state = 190, .external_lex_state = 16},
  [1914] = {.lex_state = 210, .external_lex_state = 23},
  [1915] = {.lex_state = 212, .external_lex_state = 17},
  [1916] = {.lex_state = 212, .external_lex_state = 17},
  [1917] = {.lex_state = 278, .external_lex_state = 22},
  [1918] = {.lex_state = 278, .external_lex_state = 22},
  [1919] = {.lex_state = 115, .external_lex_state = 16},
  [1920] = {.lex_state = 212, .external_lex_state = 17},
  [1921] = {.lex_state = 212, .external_lex_state = 17},
  [1922] = {.lex_state = 257, .external_lex_state = 17},
  [1923] = {.lex_state = 257, .external_lex_state = 17},
  [1924] = {.lex_state = 257, .external_lex_state = 17},
  [1925] = {.lex_state = 251, .external_lex_state = 16},
  [1926] = {.lex_state = 257, .external_lex_state = 17},
  [1927] = {.lex_state = 190, .external_lex_state = 16},
  [1928] = {.lex_state = 115},
  [1929] = {.lex_state = 190, .external_lex_state = 16},
  [1930] = {.lex_state = 190, .external_lex_state = 16},
  [1931] = {.lex_state = 190, .external_lex_state = 16},
  [1932] = {.lex_state = 257, .external_lex_state = 17},
  [1933] = {.lex_state = 190, .external_lex_state = 16},
  [1934] = {.lex_state = 257, .external_lex_state = 17},
  [1935] = {.lex_state = 190, .external_lex_state = 16},
  [1936] = {.lex_state = 257, .external_lex_state = 17},
  [1937] = {.lex_state = 257, .external_lex_state = 17},
  [1938] = {.lex_state = 224, .external_lex_state = 4},
  [1939] = {.lex_state = 278, .external_lex_state = 22},
  [1940] = {.lex_state = 278, .external_lex_state = 22},
  [1941] = {.lex_state = 115, .external_lex_state = 16},
  [1942] = {.lex_state = 224, .external_lex_state = 4},
  [1943] = {.lex_state = 251, .external_lex_state = 16},
  [1944] = {.lex_state = 224, .external_lex_state = 4},
  [1945] = {.lex_state = 190, .external_lex_state = 16},
  [1946] = {.lex_state = 224, .external_lex_state = 4},
  [1947] = {.lex_state = 190, .external_lex_state = 16},
  [1948] = {.lex_state = 190, .external_lex_state = 16},
  [1949] = {.lex_state = 224, .external_lex_state = 4},
  [1950] = {.lex_state = 259, .external_lex_state = 24},
  [1951] = {.lex_state = 153},
  [1952] = {.lex_state = 251, .external_lex_state = 16},
  [1953] = {.lex_state = 259, .external_lex_state = 24},
  [1954] = {.lex_state = 190, .external_lex_state = 16},
  [1955] = {.lex_state = 115},
  [1956] = {.lex_state = 190, .external_lex_state = 16},
  [1957] = {.lex_state = 190, .external_lex_state = 16},
  [1958] = {.lex_state = 190, .external_lex_state = 16},
  [1959] = {.lex_state = 259, .external_lex_state = 24},
  [1960] = {.lex_state = 190, .external_lex_state = 16},
  [1961] = {.lex_state = 259, .external_lex_state = 24},
  [1962] = {.lex_state = 190, .external_lex_state = 16},
  [1963] = {.lex_state = 226, .external_lex_state = 11},
  [1964] = {.lex_state = 226, .external_lex_state = 11},
  [1965] = {.lex_state = 278, .external_lex_state = 22},
  [1966] = {.lex_state = 278, .external_lex_state = 22},
  [1967] = {.lex_state = 115, .external_lex_state = 16},
  [1968] = {.lex_state = 226, .external_lex_state = 11},
  [1969] = {.lex_state = 226, .external_lex_state = 11},
  [1970] = {.lex_state = 264, .external_lex_state = 13},
  [1971] = {.lex_state = 278, .external_lex_state = 22},
  [1972] = {.lex_state = 278, .external_lex_state = 22},
  [1973] = {.lex_state = 115, .external_lex_state = 16},
  [1974] = {.lex_state = 264, .external_lex_state = 13},
  [1975] = {.lex_state = 251, .external_lex_state = 16},
  [1976] = {.lex_state = 264, .external_lex_state = 13},
  [1977] = {.lex_state = 190, .external_lex_state = 16},
  [1978] = {.lex_state = 264, .external_lex_state = 13},
  [1979] = {.lex_state = 190, .external_lex_state = 16},
  [1980] = {.lex_state = 190, .external_lex_state = 16},
  [1981] = {.lex_state = 264, .external_lex_state = 13},
  [1982] = {.lex_state = 170, .external_lex_state = 20},
  [1983] = {.lex_state = 170, .external_lex_state = 20},
  [1984] = {.lex_state = 278, .external_lex_state = 22},
  [1985] = {.lex_state = 278, .external_lex_state = 22},
  [1986] = {.lex_state = 115, .external_lex_state = 16},
  [1987] = {.lex_state = 170, .external_lex_state = 20},
  [1988] = {.lex_state = 170, .external_lex_state = 20},
  [1989] = {.lex_state = 266, .external_lex_state = 10},
  [1990] = {.lex_state = 278, .external_lex_state = 22},
  [1991] = {.lex_state = 278, .external_lex_state = 22},
  [1992] = {.lex_state = 115, .external_lex_state = 16},
  [1993] = {.lex_state = 266, .external_lex_state = 10},
  [1994] = {.lex_state = 251, .external_lex_state = 16},
  [1995] = {.lex_state = 266, .external_lex_state = 10},
  [1996] = {.lex_state = 190, .external_lex_state = 16},
  [1997] = {.lex_state = 266, .external_lex_state = 10},
  [1998] = {.lex_state = 190, .external_lex_state = 16},
  [1999] = {.lex_state = 190, .external_lex_state = 16},
  [2000] = {.lex_state = 266, .external_lex_state = 10},
  [2001] = {.lex_state = 181, .external_lex_state = 6},
  [2002] = {.lex_state = 228, .external_lex_state = 2},
  [2003] = {.lex_state = 234, .external_lex_state = 2},
  [2004] = {.lex_state = 181, .external_lex_state = 6},
  [2005] = {.lex_state = 284, .external_lex_state = 13},
  [2006] = {.lex_state = 284, .external_lex_state = 13},
  [2007] = {.lex_state = 284, .external_lex_state = 13},
  [2008] = {.lex_state = 140},
  [2009] = {.lex_state = 270},
  [2010] = {.lex_state = 290, .external_lex_state = 2},
  [2011] = {.lex_state = 145, .external_lex_state = 6},
  [2012] = {.lex_state = 170, .external_lex_state = 8},
  [2013] = {.lex_state = 290, .external_lex_state = 2},
  [2014] = {.lex_state = 290, .external_lex_state = 2},
  [2015] = {.lex_state = 140},
  [2016] = {.lex_state = 284, .external_lex_state = 13},
  [2017] = {.lex_state = 284, .external_lex_state = 13},
  [2018] = {.lex_state = 270},
  [2019] = {.lex_state = 290, .external_lex_state = 2},
  [2020] = {.lex_state = 290, .external_lex_state = 2},
  [2021] = {.lex_state = 251, .external_lex_state = 16},
  [2022] = {.lex_state = 284, .external_lex_state = 13},
  [2023] = {.lex_state = 190, .external_lex_state = 16},
  [2024] = {.lex_state = 115},
  [2025] = {.lex_state = 190, .external_lex_state = 16},
  [2026] = {.lex_state = 190, .external_lex_state = 16},
  [2027] = {.lex_state = 190, .external_lex_state = 16},
  [2028] = {.lex_state = 284, .external_lex_state = 13},
  [2029] = {.lex_state = 190, .external_lex_state = 16},
  [2030] = {.lex_state = 284, .external_lex_state = 13},
  [2031] = {.lex_state = 190, .external_lex_state = 16},
  [2032] = {.lex_state = 284, .external_lex_state = 13},
  [2033] = {.lex_state = 284, .external_lex_state = 13},
  [2034] = {.lex_state = 181, .external_lex_state = 6},
  [2035] = {.lex_state = 284, .external_lex_state = 13},
  [2036] = {.lex_state = 284, .external_lex_state = 13},
  [2037] = {.lex_state = 140},
  [2038] = {.lex_state = 115},
  [2039] = {.lex_state = 181, .external_lex_state = 6},
  [2040] = {.lex_state = 115},
  [2041] = {.lex_state = 178, .external_lex_state = 10},
  [2042] = {.lex_state = 178, .external_lex_state = 10},
  [2043] = {.lex_state = 286, .external_lex_state = 10},
  [2044] = {.lex_state = 286, .external_lex_state = 10},
  [2045] = {.lex_state = 286, .external_lex_state = 10},
  [2046] = {.lex_state = 251, .external_lex_state = 16},
  [2047] = {.lex_state = 286, .external_lex_state = 10},
  [2048] = {.lex_state = 190, .external_lex_state = 16},
  [2049] = {.lex_state = 115},
  [2050] = {.lex_state = 190, .external_lex_state = 16},
  [2051] = {.lex_state = 190, .external_lex_state = 16},
  [2052] = {.lex_state = 190, .external_lex_state = 16},
  [2053] = {.lex_state = 286, .external_lex_state = 10},
  [2054] = {.lex_state = 190, .external_lex_state = 16},
  [2055] = {.lex_state = 286, .external_lex_state = 10},
  [2056] = {.lex_state = 190, .external_lex_state = 16},
  [2057] = {.lex_state = 286, .external_lex_state = 10},
  [2058] = {.lex_state = 286, .external_lex_state = 10},
  [2059] = {.lex_state = 176, .external_lex_state = 20},
  [2060] = {.lex_state = 278, .external_lex_state = 22},
  [2061] = {.lex_state = 278, .external_lex_state = 22},
  [2062] = {.lex_state = 115, .external_lex_state = 16},
  [2063] = {.lex_state = 176, .external_lex_state = 20},
  [2064] = {.lex_state = 251, .external_lex_state = 16},
  [2065] = {.lex_state = 176, .external_lex_state = 20},
  [2066] = {.lex_state = 190, .external_lex_state = 16},
  [2067] = {.lex_state = 176, .external_lex_state = 20},
  [2068] = {.lex_state = 190, .external_lex_state = 16},
  [2069] = {.lex_state = 190, .external_lex_state = 16},
  [2070] = {.lex_state = 176, .external_lex_state = 20},
  [2071] = {.lex_state = 293, .external_lex_state = 10},
  [2072] = {.lex_state = 293, .external_lex_state = 10},
  [2073] = {.lex_state = 143},
  [2074] = {.lex_state = 293, .external_lex_state = 10},
  [2075] = {.lex_state = 293, .external_lex_state = 10},
  [2076] = {.lex_state = 153},
  [2077] = {.lex_state = 293, .external_lex_state = 10},
  [2078] = {.lex_state = 293, .external_lex_state = 10},
  [2079] = {.lex_state = 293, .external_lex_state = 10},
  [2080] = {.lex_state = 115},
  [2081] = {.lex_state = 190, .external_lex_state = 16},
  [2082] = {.lex_state = 199, .external_lex_state = 5},
  [2083] = {.lex_state = 190, .external_lex_state = 16},
  [2084] = {.lex_state = 190, .external_lex_state = 16},
  [2085] = {.lex_state = 115},
  [2086] = {.lex_state = 208, .external_lex_state = 2},
  [2087] = {.lex_state = 115},
  [2088] = {.lex_state = 216, .external_lex_state = 2},
  [2089] = {.lex_state = 115},
  [2090] = {.lex_state = 208, .external_lex_state = 2},
  [2091] = {.lex_state = 181, .external_lex_state = 14},
  [2092] = {.lex_state = 181, .external_lex_state = 14},
  [2093] = {.lex_state = 278, .external_lex_state = 22},
  [2094] = {.lex_state = 278, .external_lex_state = 22},
  [2095] = {.lex_state = 115, .external_lex_state = 16},
  [2096] = {.lex_state = 181, .external_lex_state = 14},
  [2097] = {.lex_state = 181, .external_lex_state = 14},
  [2098] = {.lex_state = 172, .external_lex_state = 4},
  [2099] = {.lex_state = 172, .external_lex_state = 4},
  [2100] = {.lex_state = 220, .external_lex_state = 4},
  [2101] = {.lex_state = 278, .external_lex_state = 22},
  [2102] = {.lex_state = 278, .external_lex_state = 22},
  [2103] = {.lex_state = 115, .external_lex_state = 16},
  [2104] = {.lex_state = 220, .external_lex_state = 4},
  [2105] = {.lex_state = 251, .external_lex_state = 16},
  [2106] = {.lex_state = 220, .external_lex_state = 4},
  [2107] = {.lex_state = 190, .external_lex_state = 16},
  [2108] = {.lex_state = 220, .external_lex_state = 4},
  [2109] = {.lex_state = 190, .external_lex_state = 16},
  [2110] = {.lex_state = 190, .external_lex_state = 16},
  [2111] = {.lex_state = 220, .external_lex_state = 4},
  [2112] = {.lex_state = 185, .external_lex_state = 11},
  [2113] = {.lex_state = 185, .external_lex_state = 11},
  [2114] = {.lex_state = 187, .external_lex_state = 13},
  [2115] = {.lex_state = 187, .external_lex_state = 13},
  [2116] = {.lex_state = 145, .external_lex_state = 14},
  [2117] = {.lex_state = 145, .external_lex_state = 14},
  [2118] = {.lex_state = 143, .external_lex_state = 15},
  [2119] = {.lex_state = 143, .external_lex_state = 15},
  [2120] = {.lex_state = 153, .external_lex_state = 13},
  [2121] = {.lex_state = 153, .external_lex_state = 13},
  [2122] = {.lex_state = 190, .external_lex_state = 16},
  [2123] = {.lex_state = 190, .external_lex_state = 16},
  [2124] = {.lex_state = 278, .external_lex_state = 22},
  [2125] = {.lex_state = 278, .external_lex_state = 22},
  [2126] = {.lex_state = 278, .external_lex_state = 22},
  [2127] = {.lex_state = 115, .external_lex_state = 16},
  [2128] = {.lex_state = 278, .external_lex_state = 22},
  [2129] = {.lex_state = 251, .external_lex_state = 16},
  [2130] = {.lex_state = 278, .external_lex_state = 22},
  [2131] = {.lex_state = 190, .external_lex_state = 16},
  [2132] = {.lex_state = 278, .external_lex_state = 22},
  [2133] = {.lex_state = 190, .external_lex_state = 16},
  [2134] = {.lex_state = 190, .external_lex_state = 16},
  [2135] = {.lex_state = 278, .external_lex_state = 22},
  [2136] = {.lex_state = 190, .external_lex_state = 22},
  [2137] = {.lex_state = 190, .external_lex_state = 22},
  [2138] = {.lex_state = 278, .external_lex_state = 22},
  [2139] = {.lex_state = 278, .external_lex_state = 22},
  [2140] = {.lex_state = 115, .external_lex_state = 16},
  [2141] = {.lex_state = 190, .external_lex_state = 22},
  [2142] = {.lex_state = 190, .external_lex_state = 22},
  [2143] = {.lex_state = 208, .external_lex_state = 15},
  [2144] = {.lex_state = 278, .external_lex_state = 22},
  [2145] = {.lex_state = 278, .external_lex_state = 22},
  [2146] = {.lex_state = 115, .external_lex_state = 16},
  [2147] = {.lex_state = 208, .external_lex_state = 15},
  [2148] = {.lex_state = 251, .external_lex_state = 16},
  [2149] = {.lex_state = 208, .external_lex_state = 15},
  [2150] = {.lex_state = 190, .external_lex_state = 16},
  [2151] = {.lex_state = 208, .external_lex_state = 15},
  [2152] = {.lex_state = 190, .external_lex_state = 16},
  [2153] = {.lex_state = 190, .external_lex_state = 16},
  [2154] = {.lex_state = 208, .external_lex_state = 15},
  [2155] = {.lex_state = 228, .external_lex_state = 2},
  [2156] = {.lex_state = 115},
  [2157] = {.lex_state = 115},
  [2158] = {.lex_state = 115},
  [2159] = {.lex_state = 115},
  [2160] = {.lex_state = 115},
  [2161] = {.lex_state = 115},
  [2162] = {.lex_state = 143},
  [2163] = {.lex_state = 115},
  [2164] = {.lex_state = 115},
  [2165] = {.lex_state = 115},
  [2166] = {.lex_state = 143},
  [2167] = {.lex_state = 115},
  [2168] = {.lex_state = 295, .external_lex_state = 13},
  [2169] = {.lex_state = 295, .external_lex_state = 13},
  [2170] = {.lex_state = 115},
  [2171] = {.lex_state = 143},
  [2172] = {.lex_state = 295, .external_lex_state = 13},
  [2173] = {.lex_state = 295, .external_lex_state = 13},
  [2174] = {.lex_state = 153},
  [2175] = {.lex_state = 295, .external_lex_state = 13},
  [2176] = {.lex_state = 295, .external_lex_state = 13},
  [2177] = {.lex_state = 295, .external_lex_state = 13},
  [2178] = {.lex_state = 115},
  [2179] = {.lex_state = 190, .external_lex_state = 16},
  [2180] = {.lex_state = 199, .external_lex_state = 5},
  [2181] = {.lex_state = 190, .external_lex_state = 16},
  [2182] = {.lex_state = 190, .external_lex_state = 16},
  [2183] = {.lex_state = 115},
  [2184] = {.lex_state = 208, .external_lex_state = 2},
  [2185] = {.lex_state = 115},
  [2186] = {.lex_state = 216, .external_lex_state = 2},
  [2187] = {.lex_state = 115},
  [2188] = {.lex_state = 208, .external_lex_state = 2},
  [2189] = {.lex_state = 201, .external_lex_state = 5},
  [2190] = {.lex_state = 201, .external_lex_state = 23},
  [2191] = {.lex_state = 201, .external_lex_state = 23},
  [2192] = {.lex_state = 278, .external_lex_state = 22},
  [2193] = {.lex_state = 278, .external_lex_state = 22},
  [2194] = {.lex_state = 115, .external_lex_state = 16},
  [2195] = {.lex_state = 201, .external_lex_state = 23},
  [2196] = {.lex_state = 201, .external_lex_state = 23},
  [2197] = {.lex_state = 203, .external_lex_state = 17},
  [2198] = {.lex_state = 203, .external_lex_state = 17},
  [2199] = {.lex_state = 255, .external_lex_state = 17},
  [2200] = {.lex_state = 278, .external_lex_state = 22},
  [2201] = {.lex_state = 278, .external_lex_state = 22},
  [2202] = {.lex_state = 115, .external_lex_state = 16},
  [2203] = {.lex_state = 255, .external_lex_state = 17},
  [2204] = {.lex_state = 251, .external_lex_state = 16},
  [2205] = {.lex_state = 255, .external_lex_state = 17},
  [2206] = {.lex_state = 190, .external_lex_state = 16},
  [2207] = {.lex_state = 255, .external_lex_state = 17},
  [2208] = {.lex_state = 190, .external_lex_state = 16},
  [2209] = {.lex_state = 190, .external_lex_state = 16},
  [2210] = {.lex_state = 255, .external_lex_state = 17},
  [2211] = {.lex_state = 216, .external_lex_state = 15},
  [2212] = {.lex_state = 278, .external_lex_state = 22},
  [2213] = {.lex_state = 278, .external_lex_state = 22},
  [2214] = {.lex_state = 115, .external_lex_state = 16},
  [2215] = {.lex_state = 216, .external_lex_state = 15},
  [2216] = {.lex_state = 251, .external_lex_state = 16},
  [2217] = {.lex_state = 216, .external_lex_state = 15},
  [2218] = {.lex_state = 190, .external_lex_state = 16},
  [2219] = {.lex_state = 216, .external_lex_state = 15},
  [2220] = {.lex_state = 190, .external_lex_state = 16},
  [2221] = {.lex_state = 190, .external_lex_state = 16},
  [2222] = {.lex_state = 216, .external_lex_state = 15},
  [2223] = {.lex_state = 297, .external_lex_state = 13},
  [2224] = {.lex_state = 297, .external_lex_state = 13},
  [2225] = {.lex_state = 143},
  [2226] = {.lex_state = 297, .external_lex_state = 13},
  [2227] = {.lex_state = 297, .external_lex_state = 13},
  [2228] = {.lex_state = 153},
  [2229] = {.lex_state = 297, .external_lex_state = 13},
  [2230] = {.lex_state = 297, .external_lex_state = 13},
  [2231] = {.lex_state = 297, .external_lex_state = 13},
  [2232] = {.lex_state = 115},
  [2233] = {.lex_state = 190, .external_lex_state = 16},
  [2234] = {.lex_state = 199, .external_lex_state = 5},
  [2235] = {.lex_state = 190, .external_lex_state = 16},
  [2236] = {.lex_state = 190, .external_lex_state = 16},
  [2237] = {.lex_state = 115},
  [2238] = {.lex_state = 208, .external_lex_state = 2},
  [2239] = {.lex_state = 115},
  [2240] = {.lex_state = 216, .external_lex_state = 2},
  [2241] = {.lex_state = 115},
  [2242] = {.lex_state = 208, .external_lex_state = 2},
  [2243] = {.lex_state = 210, .external_lex_state = 23},
  [2244] = {.lex_state = 210, .external_lex_state = 23},
  [2245] = {.lex_state = 278, .external_lex_state = 22},
  [2246] = {.lex_state = 278, .external_lex_state = 22},
  [2247] = {.lex_state = 115, .external_lex_state = 16},
  [2248] = {.lex_state = 210, .external_lex_state = 23},
  [2249] = {.lex_state = 210, .external_lex_state = 23},
  [2250] = {.lex_state = 212, .external_lex_state = 17},
  [2251] = {.lex_state = 212, .external_lex_state = 17},
  [2252] = {.lex_state = 257, .external_lex_state = 17},
  [2253] = {.lex_state = 278, .external_lex_state = 22},
  [2254] = {.lex_state = 278, .external_lex_state = 22},
  [2255] = {.lex_state = 115, .external_lex_state = 16},
  [2256] = {.lex_state = 257, .external_lex_state = 17},
  [2257] = {.lex_state = 251, .external_lex_state = 16},
  [2258] = {.lex_state = 257, .external_lex_state = 17},
  [2259] = {.lex_state = 190, .external_lex_state = 16},
  [2260] = {.lex_state = 257, .external_lex_state = 17},
  [2261] = {.lex_state = 190, .external_lex_state = 16},
  [2262] = {.lex_state = 190, .external_lex_state = 16},
  [2263] = {.lex_state = 257, .external_lex_state = 17},
  [2264] = {.lex_state = 224, .external_lex_state = 4},
  [2265] = {.lex_state = 224, .external_lex_state = 4},
  [2266] = {.lex_state = 278, .external_lex_state = 22},
  [2267] = {.lex_state = 278, .external_lex_state = 22},
  [2268] = {.lex_state = 115, .external_lex_state = 16},
  [2269] = {.lex_state = 224, .external_lex_state = 4},
  [2270] = {.lex_state = 224, .external_lex_state = 4},
  [2271] = {.lex_state = 259, .external_lex_state = 24},
  [2272] = {.lex_state = 259, .external_lex_state = 24},
  [2273] = {.lex_state = 278, .external_lex_state = 22},
  [2274] = {.lex_state = 278, .external_lex_state = 22},
  [2275] = {.lex_state = 115, .external_lex_state = 16},
  [2276] = {.lex_state = 259, .external_lex_state = 24},
  [2277] = {.lex_state = 251, .external_lex_state = 16},
  [2278] = {.lex_state = 259, .external_lex_state = 24},
  [2279] = {.lex_state = 190, .external_lex_state = 16},
  [2280] = {.lex_state = 259, .external_lex_state = 24},
  [2281] = {.lex_state = 190, .external_lex_state = 16},
  [2282] = {.lex_state = 190, .external_lex_state = 16},
  [2283] = {.lex_state = 259, .external_lex_state = 24},
  [2284] = {.lex_state = 226, .external_lex_state = 11},
  [2285] = {.lex_state = 226, .external_lex_state = 11},
  [2286] = {.lex_state = 264, .external_lex_state = 13},
  [2287] = {.lex_state = 264, .external_lex_state = 13},
  [2288] = {.lex_state = 278, .external_lex_state = 22},
  [2289] = {.lex_state = 278, .external_lex_state = 22},
  [2290] = {.lex_state = 115, .external_lex_state = 16},
  [2291] = {.lex_state = 264, .external_lex_state = 13},
  [2292] = {.lex_state = 264, .external_lex_state = 13},
  [2293] = {.lex_state = 170, .external_lex_state = 20},
  [2294] = {.lex_state = 170, .external_lex_state = 20},
  [2295] = {.lex_state = 266, .external_lex_state = 10},
  [2296] = {.lex_state = 266, .external_lex_state = 10},
  [2297] = {.lex_state = 278, .external_lex_state = 22},
  [2298] = {.lex_state = 278, .external_lex_state = 22},
  [2299] = {.lex_state = 115, .external_lex_state = 16},
  [2300] = {.lex_state = 266, .external_lex_state = 10},
  [2301] = {.lex_state = 266, .external_lex_state = 10},
  [2302] = {.lex_state = 181, .external_lex_state = 6},
  [2303] = {.lex_state = 290, .external_lex_state = 2},
  [2304] = {.lex_state = 270},
  [2305] = {.lex_state = 290, .external_lex_state = 2},
  [2306] = {.lex_state = 290, .external_lex_state = 2},
  [2307] = {.lex_state = 270},
  [2308] = {.lex_state = 290, .external_lex_state = 2},
  [2309] = {.lex_state = 284, .external_lex_state = 13},
  [2310] = {.lex_state = 278, .external_lex_state = 22},
  [2311] = {.lex_state = 278, .external_lex_state = 22},
  [2312] = {.lex_state = 115, .external_lex_state = 16},
  [2313] = {.lex_state = 284, .external_lex_state = 13},
  [2314] = {.lex_state = 251, .external_lex_state = 16},
  [2315] = {.lex_state = 284, .external_lex_state = 13},
  [2316] = {.lex_state = 190, .external_lex_state = 16},
  [2317] = {.lex_state = 284, .external_lex_state = 13},
  [2318] = {.lex_state = 190, .external_lex_state = 16},
  [2319] = {.lex_state = 190, .external_lex_state = 16},
  [2320] = {.lex_state = 284, .external_lex_state = 13},
  [2321] = {.lex_state = 167, .external_lex_state = 2},
  [2322] = {.lex_state = 140},
  [2323] = {.lex_state = 167, .external_lex_state = 2},
  [2324] = {.lex_state = 140},
  [2325] = {.lex_state = 181, .external_lex_state = 6},
  [2326] = {.lex_state = 181, .external_lex_state = 6},
  [2327] = {.lex_state = 286, .external_lex_state = 10},
  [2328] = {.lex_state = 278, .external_lex_state = 22},
  [2329] = {.lex_state = 278, .external_lex_state = 22},
  [2330] = {.lex_state = 115, .external_lex_state = 16},
  [2331] = {.lex_state = 286, .external_lex_state = 10},
  [2332] = {.lex_state = 251, .external_lex_state = 16},
  [2333] = {.lex_state = 286, .external_lex_state = 10},
  [2334] = {.lex_state = 190, .external_lex_state = 16},
  [2335] = {.lex_state = 286, .external_lex_state = 10},
  [2336] = {.lex_state = 190, .external_lex_state = 16},
  [2337] = {.lex_state = 190, .external_lex_state = 16},
  [2338] = {.lex_state = 286, .external_lex_state = 10},
  [2339] = {.lex_state = 176, .external_lex_state = 20},
  [2340] = {.lex_state = 176, .external_lex_state = 20},
  [2341] = {.lex_state = 278, .external_lex_state = 22},
  [2342] = {.lex_state = 278, .external_lex_state = 22},
  [2343] = {.lex_state = 115, .external_lex_state = 16},
  [2344] = {.lex_state = 176, .external_lex_state = 20},
  [2345] = {.lex_state = 176, .external_lex_state = 20},
  [2346] = {.lex_state = 293, .external_lex_state = 10},
  [2347] = {.lex_state = 293, .external_lex_state = 10},
  [2348] = {.lex_state = 293, .external_lex_state = 10},
  [2349] = {.lex_state = 251, .external_lex_state = 16},
  [2350] = {.lex_state = 293, .external_lex_state = 10},
  [2351] = {.lex_state = 190, .external_lex_state = 16},
  [2352] = {.lex_state = 115},
  [2353] = {.lex_state = 190, .external_lex_state = 16},
  [2354] = {.lex_state = 190, .external_lex_state = 16},
  [2355] = {.lex_state = 190, .external_lex_state = 16},
  [2356] = {.lex_state = 293, .external_lex_state = 10},
  [2357] = {.lex_state = 190, .external_lex_state = 16},
  [2358] = {.lex_state = 293, .external_lex_state = 10},
  [2359] = {.lex_state = 190, .external_lex_state = 16},
  [2360] = {.lex_state = 293, .external_lex_state = 10},
  [2361] = {.lex_state = 293, .external_lex_state = 10},
  [2362] = {.lex_state = 181, .external_lex_state = 14},
  [2363] = {.lex_state = 181, .external_lex_state = 14},
  [2364] = {.lex_state = 220, .external_lex_state = 4},
  [2365] = {.lex_state = 220, .external_lex_state = 4},
  [2366] = {.lex_state = 278, .external_lex_state = 22},
  [2367] = {.lex_state = 278, .external_lex_state = 22},
  [2368] = {.lex_state = 115, .external_lex_state = 16},
  [2369] = {.lex_state = 220, .external_lex_state = 4},
  [2370] = {.lex_state = 220, .external_lex_state = 4},
  [2371] = {.lex_state = 278, .external_lex_state = 22},
  [2372] = {.lex_state = 278, .external_lex_state = 22},
  [2373] = {.lex_state = 278, .external_lex_state = 22},
  [2374] = {.lex_state = 278, .external_lex_state = 22},
  [2375] = {.lex_state = 115, .external_lex_state = 16},
  [2376] = {.lex_state = 278, .external_lex_state = 22},
  [2377] = {.lex_state = 278, .external_lex_state = 22},
  [2378] = {.lex_state = 190, .external_lex_state = 22},
  [2379] = {.lex_state = 190, .external_lex_state = 22},
  [2380] = {.lex_state = 208, .external_lex_state = 15},
  [2381] = {.lex_state = 208, .external_lex_state = 15},
  [2382] = {.lex_state = 278, .external_lex_state = 22},
  [2383] = {.lex_state = 278, .external_lex_state = 22},
  [2384] = {.lex_state = 115, .external_lex_state = 16},
  [2385] = {.lex_state = 208, .external_lex_state = 15},
  [2386] = {.lex_state = 208, .external_lex_state = 15},
  [2387] = {.lex_state = 115},
  [2388] = {.lex_state = 228, .external_lex_state = 2},
  [2389] = {.lex_state = 115},
  [2390] = {.lex_state = 115},
  [2391] = {.lex_state = 115},
  [2392] = {.lex_state = 115},
  [2393] = {.lex_state = 115},
  [2394] = {.lex_state = 295, .external_lex_state = 13},
  [2395] = {.lex_state = 295, .external_lex_state = 13},
  [2396] = {.lex_state = 295, .external_lex_state = 13},
  [2397] = {.lex_state = 251, .external_lex_state = 16},
  [2398] = {.lex_state = 295, .external_lex_state = 13},
  [2399] = {.lex_state = 190, .external_lex_state = 16},
  [2400] = {.lex_state = 115},
  [2401] = {.lex_state = 190, .external_lex_state = 16},
  [2402] = {.lex_state = 190, .external_lex_state = 16},
  [2403] = {.lex_state = 190, .external_lex_state = 16},
  [2404] = {.lex_state = 295, .external_lex_state = 13},
  [2405] = {.lex_state = 190, .external_lex_state = 16},
  [2406] = {.lex_state = 295, .external_lex_state = 13},
  [2407] = {.lex_state = 190, .external_lex_state = 16},
  [2408] = {.lex_state = 295, .external_lex_state = 13},
  [2409] = {.lex_state = 295, .external_lex_state = 13},
  [2410] = {.lex_state = 201, .external_lex_state = 23},
  [2411] = {.lex_state = 201, .external_lex_state = 23},
  [2412] = {.lex_state = 255, .external_lex_state = 17},
  [2413] = {.lex_state = 255, .external_lex_state = 17},
  [2414] = {.lex_state = 278, .external_lex_state = 22},
  [2415] = {.lex_state = 278, .external_lex_state = 22},
  [2416] = {.lex_state = 115, .external_lex_state = 16},
  [2417] = {.lex_state = 255, .external_lex_state = 17},
  [2418] = {.lex_state = 255, .external_lex_state = 17},
  [2419] = {.lex_state = 216, .external_lex_state = 15},
  [2420] = {.lex_state = 216, .external_lex_state = 15},
  [2421] = {.lex_state = 278, .external_lex_state = 22},
  [2422] = {.lex_state = 278, .external_lex_state = 22},
  [2423] = {.lex_state = 115, .external_lex_state = 16},
  [2424] = {.lex_state = 216, .external_lex_state = 15},
  [2425] = {.lex_state = 216, .external_lex_state = 15},
  [2426] = {.lex_state = 297, .external_lex_state = 13},
  [2427] = {.lex_state = 297, .external_lex_state = 13},
  [2428] = {.lex_state = 297, .external_lex_state = 13},
  [2429] = {.lex_state = 251, .external_lex_state = 16},
  [2430] = {.lex_state = 297, .external_lex_state = 13},
  [2431] = {.lex_state = 190, .external_lex_state = 16},
  [2432] = {.lex_state = 115},
  [2433] = {.lex_state = 190, .external_lex_state = 16},
  [2434] = {.lex_state = 190, .external_lex_state = 16},
  [2435] = {.lex_state = 190, .external_lex_state = 16},
  [2436] = {.lex_state = 297, .external_lex_state = 13},
  [2437] = {.lex_state = 190, .external_lex_state = 16},
  [2438] = {.lex_state = 297, .external_lex_state = 13},
  [2439] = {.lex_state = 190, .external_lex_state = 16},
  [2440] = {.lex_state = 297, .external_lex_state = 13},
  [2441] = {.lex_state = 297, .external_lex_state = 13},
  [2442] = {.lex_state = 210, .external_lex_state = 23},
  [2443] = {.lex_state = 210, .external_lex_state = 23},
  [2444] = {.lex_state = 257, .external_lex_state = 17},
  [2445] = {.lex_state = 257, .external_lex_state = 17},
  [2446] = {.lex_state = 278, .external_lex_state = 22},
  [2447] = {.lex_state = 278, .external_lex_state = 22},
  [2448] = {.lex_state = 115, .external_lex_state = 16},
  [2449] = {.lex_state = 257, .external_lex_state = 17},
  [2450] = {.lex_state = 257, .external_lex_state = 17},
  [2451] = {.lex_state = 224, .external_lex_state = 4},
  [2452] = {.lex_state = 224, .external_lex_state = 4},
  [2453] = {.lex_state = 259, .external_lex_state = 24},
  [2454] = {.lex_state = 259, .external_lex_state = 24},
  [2455] = {.lex_state = 278, .external_lex_state = 22},
  [2456] = {.lex_state = 278, .external_lex_state = 22},
  [2457] = {.lex_state = 115, .external_lex_state = 16},
  [2458] = {.lex_state = 259, .external_lex_state = 24},
  [2459] = {.lex_state = 259, .external_lex_state = 24},
  [2460] = {.lex_state = 264, .external_lex_state = 13},
  [2461] = {.lex_state = 264, .external_lex_state = 13},
  [2462] = {.lex_state = 266, .external_lex_state = 10},
  [2463] = {.lex_state = 266, .external_lex_state = 10},
  [2464] = {.lex_state = 270},
  [2465] = {.lex_state = 270},
  [2466] = {.lex_state = 284, .external_lex_state = 13},
  [2467] = {.lex_state = 284, .external_lex_state = 13},
  [2468] = {.lex_state = 278, .external_lex_state = 22},
  [2469] = {.lex_state = 278, .external_lex_state = 22},
  [2470] = {.lex_state = 115, .external_lex_state = 16},
  [2471] = {.lex_state = 284, .external_lex_state = 13},
  [2472] = {.lex_state = 284, .external_lex_state = 13},
  [2473] = {.lex_state = 143},
  [2474] = {.lex_state = 167, .external_lex_state = 2},
  [2475] = {.lex_state = 167, .external_lex_state = 2},
  [2476] = {.lex_state = 143},
  [2477] = {.lex_state = 167, .external_lex_state = 2},
  [2478] = {.lex_state = 167, .external_lex_state = 2},
  [2479] = {.lex_state = 286, .external_lex_state = 10},
  [2480] = {.lex_state = 286, .external_lex_state = 10},
  [2481] = {.lex_state = 278, .external_lex_state = 22},
  [2482] = {.lex_state = 278, .external_lex_state = 22},
  [2483] = {.lex_state = 115, .external_lex_state = 16},
  [2484] = {.lex_state = 286, .external_lex_state = 10},
  [2485] = {.lex_state = 286, .external_lex_state = 10},
  [2486] = {.lex_state = 176, .external_lex_state = 20},
  [2487] = {.lex_state = 176, .external_lex_state = 20},
  [2488] = {.lex_state = 293, .external_lex_state = 10},
  [2489] = {.lex_state = 278, .external_lex_state = 22},
  [2490] = {.lex_state = 278, .external_lex_state = 22},
  [2491] = {.lex_state = 115, .external_lex_state = 16},
  [2492] = {.lex_state = 293, .external_lex_state = 10},
  [2493] = {.lex_state = 251, .external_lex_state = 16},
  [2494] = {.lex_state = 293, .external_lex_state = 10},
  [2495] = {.lex_state = 190, .external_lex_state = 16},
  [2496] = {.lex_state = 293, .external_lex_state = 10},
  [2497] = {.lex_state = 190, .external_lex_state = 16},
  [2498] = {.lex_state = 190, .external_lex_state = 16},
  [2499] = {.lex_state = 293, .external_lex_state = 10},
  [2500] = {.lex_state = 220, .external_lex_state = 4},
  [2501] = {.lex_state = 220, .external_lex_state = 4},
  [2502] = {.lex_state = 278, .external_lex_state = 22},
  [2503] = {.lex_state = 278, .external_lex_state = 22},
  [2504] = {.lex_state = 208, .external_lex_state = 15},
  [2505] = {.lex_state = 208, .external_lex_state = 15},
  [2506] = {.lex_state = 115},
  [2507] = {.lex_state = 115},
  [2508] = {.lex_state = 115},
  [2509] = {.lex_state = 295, .external_lex_state = 13},
  [2510] = {.lex_state = 278, .external_lex_state = 22},
  [2511] = {.lex_state = 278, .external_lex_state = 22},
  [2512] = {.lex_state = 115, .external_lex_state = 16},
  [2513] = {.lex_state = 295, .external_lex_state = 13},
  [2514] = {.lex_state = 251, .external_lex_state = 16},
  [2515] = {.lex_state = 295, .external_lex_state = 13},
  [2516] = {.lex_state = 190, .external_lex_state = 16},
  [2517] = {.lex_state = 295, .external_lex_state = 13},
  [2518] = {.lex_state = 190, .external_lex_state = 16},
  [2519] = {.lex_state = 190, .external_lex_state = 16},
  [2520] = {.lex_state = 295, .external_lex_state = 13},
  [2521] = {.lex_state = 255, .external_lex_state = 17},
  [2522] = {.lex_state = 255, .external_lex_state = 17},
  [2523] = {.lex_state = 216, .external_lex_state = 15},
  [2524] = {.lex_state = 216, .external_lex_state = 15},
  [2525] = {.lex_state = 297, .external_lex_state = 13},
  [2526] = {.lex_state = 278, .external_lex_state = 22},
  [2527] = {.lex_state = 278, .external_lex_state = 22},
  [2528] = {.lex_state = 115, .external_lex_state = 16},
  [2529] = {.lex_state = 297, .external_lex_state = 13},
  [2530] = {.lex_state = 251, .external_lex_state = 16},
  [2531] = {.lex_state = 297, .external_lex_state = 13},
  [2532] = {.lex_state = 190, .external_lex_state = 16},
  [2533] = {.lex_state = 297, .external_lex_state = 13},
  [2534] = {.lex_state = 190, .external_lex_state = 16},
  [2535] = {.lex_state = 190, .external_lex_state = 16},
  [2536] = {.lex_state = 297, .external_lex_state = 13},
  [2537] = {.lex_state = 257, .external_lex_state = 17},
  [2538] = {.lex_state = 257, .external_lex_state = 17},
  [2539] = {.lex_state = 259, .external_lex_state = 24},
  [2540] = {.lex_state = 259, .external_lex_state = 24},
  [2541] = {.lex_state = 284, .external_lex_state = 13},
  [2542] = {.lex_state = 284, .external_lex_state = 13},
  [2543] = {.lex_state = 143},
  [2544] = {.lex_state = 167, .external_lex_state = 2},
  [2545] = {.lex_state = 167, .external_lex_state = 2},
  [2546] = {.lex_state = 143},
  [2547] = {.lex_state = 167, .external_lex_state = 2},
  [2548] = {.lex_state = 286, .external_lex_state = 10},
  [2549] = {.lex_state = 286, .external_lex_state = 10},
  [2550] = {.lex_state = 293, .external_lex_state = 10},
  [2551] = {.lex_state = 293, .external_lex_state = 10},
  [2552] = {.lex_state = 278, .external_lex_state = 22},
  [2553] = {.lex_state = 278, .external_lex_state = 22},
  [2554] = {.lex_state = 115, .external_lex_state = 16},
  [2555] = {.lex_state = 293, .external_lex_state = 10},
  [2556] = {.lex_state = 293, .external_lex_state = 10},
  [2557] = {.lex_state = 295, .external_lex_state = 13},
  [2558] = {.lex_state = 295, .external_lex_state = 13},
  [2559] = {.lex_state = 278, .external_lex_state = 22},
  [2560] = {.lex_state = 278, .external_lex_state = 22},
  [2561] = {.lex_state = 115, .external_lex_state = 16},
  [2562] = {.lex_state = 295, .external_lex_state = 13},
  [2563] = {.lex_state = 295, .external_lex_state = 13},
  [2564] = {.lex_state = 297, .external_lex_state = 13},
  [2565] = {.lex_state = 297, .external_lex_state = 13},
  [2566] = {.lex_state = 278, .external_lex_state = 22},
  [2567] = {.lex_state = 278, .external_lex_state = 22},
  [2568] = {.lex_state = 115, .external_lex_state = 16},
  [2569] = {.lex_state = 297, .external_lex_state = 13},
  [2570] = {.lex_state = 297, .external_lex_state = 13},
  [2571] = {.lex_state = 143},
  [2572] = {.lex_state = 143},
  [2573] = {.lex_state = 293, .external_lex_state = 10},
  [2574] = {.lex_state = 293, .external_lex_state = 10},
  [2575] = {.lex_state = 295, .external_lex_state = 13},
  [2576] = {.lex_state = 295, .external_lex_state = 13},
  [2577] = {.lex_state = 297, .external_lex_state = 13},
  [2578] = {.lex_state = 297, .external_lex_state = 13},
};

enum {
  ts_external_token__simple_heredoc,
  ts_external_token__heredoc_beginning,
  ts_external_token__heredoc_middle,
  ts_external_token__heredoc_end,
  ts_external_token_file_descriptor,
  ts_external_token__empty_value,
  ts_external_token__concat,
  ts_external_token_variable_name,
  ts_external_token_RBRACE,
  ts_external_token_RBRACK,
  ts_external_token_LF,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__simple_heredoc] = sym__simple_heredoc,
  [ts_external_token__heredoc_beginning] = sym__heredoc_beginning,
  [ts_external_token__heredoc_middle] = sym__heredoc_middle,
  [ts_external_token__heredoc_end] = sym__heredoc_end,
  [ts_external_token_file_descriptor] = sym_file_descriptor,
  [ts_external_token__empty_value] = sym__empty_value,
  [ts_external_token__concat] = sym__concat,
  [ts_external_token_variable_name] = sym_variable_name,
  [ts_external_token_RBRACE] = anon_sym_RBRACE,
  [ts_external_token_RBRACK] = anon_sym_RBRACK,
  [ts_external_token_LF] = anon_sym_LF,
};

static bool ts_external_scanner_states[25][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__simple_heredoc] = true,
    [ts_external_token__heredoc_beginning] = true,
    [ts_external_token__heredoc_middle] = true,
    [ts_external_token__heredoc_end] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__empty_value] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_RBRACK] = true,
    [ts_external_token_LF] = true,
  },
  [2] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
  },
  [3] = {
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [4] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
  [5] = {
    [ts_external_token_variable_name] = true,
  },
  [6] = {
    [ts_external_token_LF] = true,
  },
  [7] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_LF] = true,
  },
  [8] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [9] = {
    [ts_external_token__empty_value] = true,
  },
  [10] = {
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
  [11] = {
    [ts_external_token__concat] = true,
    [ts_external_token_RBRACK] = true,
  },
  [12] = {
    [ts_external_token_RBRACK] = true,
  },
  [13] = {
    [ts_external_token__concat] = true,
  },
  [14] = {
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [15] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
  },
  [16] = {
    [ts_external_token_RBRACE] = true,
  },
  [17] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
  },
  [18] = {
    [ts_external_token_file_descriptor] = true,
  },
  [19] = {
    [ts_external_token__simple_heredoc] = true,
    [ts_external_token__heredoc_beginning] = true,
  },
  [20] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [21] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_RBRACE] = true,
  },
  [22] = {
    [ts_external_token__concat] = true,
    [ts_external_token_RBRACE] = true,
  },
  [23] = {
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
  },
  [24] = {
    [ts_external_token__heredoc_middle] = true,
    [ts_external_token__heredoc_end] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym__simple_heredoc] = ACTIONS(1),
    [sym__heredoc_beginning] = ACTIONS(1),
    [sym__heredoc_middle] = ACTIONS(1),
    [sym__heredoc_end] = ACTIONS(1),
    [sym_file_descriptor] = ACTIONS(1),
    [sym__empty_value] = ACTIONS(1),
    [sym__concat] = ACTIONS(1),
    [sym_variable_name] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(3),
    [anon_sym_PIPE] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(3),
    [anon_sym_SEMI_SEMI] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3),
    [anon_sym_RBRACE] = ACTIONS(3),
    [anon_sym_PIPE_AMP] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3),
    [anon_sym_PIPE_PIPE] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(3),
    [anon_sym_RBRACK] = ACTIONS(3),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(3),
    [anon_sym_PLUS_EQ] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(3),
    [anon_sym_GT] = ACTIONS(3),
    [anon_sym_GT_GT] = ACTIONS(3),
    [anon_sym_AMP_GT] = ACTIONS(3),
    [anon_sym_AMP_GT_GT] = ACTIONS(3),
    [anon_sym_LT_AMP] = ACTIONS(3),
    [anon_sym_GT_AMP] = ACTIONS(3),
    [anon_sym_LT_LT] = ACTIONS(3),
    [anon_sym_LT_LT_DASH] = ACTIONS(3),
    [anon_sym_LT_LT_LT] = ACTIONS(3),
    [sym__special_characters] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(3),
    [sym_raw_string] = ACTIONS(3),
    [anon_sym_DOLLAR] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3),
    [anon_sym_COLON_QMARK] = ACTIONS(3),
    [anon_sym_COLON_DASH] = ACTIONS(3),
    [anon_sym_PERCENT] = ACTIONS(3),
    [anon_sym_SLASH] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3),
    [anon_sym_LT_LPAREN] = ACTIONS(3),
    [anon_sym_GT_LPAREN] = ACTIONS(3),
    [sym_comment] = ACTIONS(5),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3),
    [anon_sym_STAR] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(3),
    [anon_sym_QMARK] = ACTIONS(3),
    [anon_sym_0] = ACTIONS(3),
    [anon_sym__] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(3),
  },
  [1] = {
    [sym_program] = STATE(23),
    [sym__terminated_statement] = STATE(24),
    [sym_for_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_case_statement] = STATE(25),
    [sym_function_definition] = STATE(25),
    [sym_subshell] = STATE(25),
    [sym_pipeline] = STATE(25),
    [sym_list] = STATE(25),
    [sym_bracket_command] = STATE(25),
    [sym_command] = STATE(25),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(27),
    [sym_declaration_command] = STATE(25),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(31),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [ts_builtin_sym_end] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [2] = {
    [anon_sym_LT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(56),
    [anon_sym_GT_GT] = ACTIONS(58),
    [anon_sym_AMP_GT] = ACTIONS(56),
    [anon_sym_AMP_GT_GT] = ACTIONS(58),
    [anon_sym_LT_AMP] = ACTIONS(58),
    [anon_sym_GT_AMP] = ACTIONS(58),
    [sym_comment] = ACTIONS(52),
  },
  [3] = {
    [sym__assignment] = STATE(36),
    [anon_sym_LBRACK] = ACTIONS(60),
    [anon_sym_EQ] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(62),
    [sym_comment] = ACTIONS(52),
  },
  [4] = {
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(64),
  },
  [5] = {
    [sym__terminated_statement] = STATE(38),
    [sym_for_statement] = STATE(39),
    [sym_while_statement] = STATE(39),
    [sym_if_statement] = STATE(39),
    [sym_case_statement] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_subshell] = STATE(39),
    [sym_pipeline] = STATE(39),
    [sym_list] = STATE(39),
    [sym_bracket_command] = STATE(39),
    [sym_command] = STATE(39),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(40),
    [sym_declaration_command] = STATE(39),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [6] = {
    [sym__terminated_statement] = STATE(41),
    [sym_for_statement] = STATE(39),
    [sym_while_statement] = STATE(39),
    [sym_if_statement] = STATE(39),
    [sym_case_statement] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_subshell] = STATE(39),
    [sym_pipeline] = STATE(39),
    [sym_list] = STATE(39),
    [sym_bracket_command] = STATE(39),
    [sym_command] = STATE(39),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(40),
    [sym_declaration_command] = STATE(39),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [7] = {
    [sym_concatenation] = STATE(50),
    [sym_string] = STATE(44),
    [sym_simple_expansion] = STATE(44),
    [sym_expansion] = STATE(44),
    [sym_command_substitution] = STATE(44),
    [sym_process_substitution] = STATE(44),
    [sym__special_characters] = ACTIONS(66),
    [anon_sym_DQUOTE] = ACTIONS(68),
    [sym_raw_string] = ACTIONS(70),
    [anon_sym_DOLLAR] = ACTIONS(72),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(74),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(76),
    [anon_sym_BQUOTE] = ACTIONS(78),
    [anon_sym_LT_LPAREN] = ACTIONS(80),
    [anon_sym_GT_LPAREN] = ACTIONS(80),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(82),
  },
  [8] = {
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(84),
  },
  [9] = {
    [sym__terminated_statement] = STATE(24),
    [sym_for_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_if_statement] = STATE(65),
    [sym_case_statement] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_subshell] = STATE(65),
    [sym_pipeline] = STATE(65),
    [sym_list] = STATE(65),
    [sym_bracket_command] = STATE(65),
    [sym_command] = STATE(65),
    [sym_command_name] = STATE(66),
    [sym_variable_assignment] = STATE(67),
    [sym_declaration_command] = STATE(65),
    [sym_subscript] = STATE(68),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(58),
    [sym_simple_expansion] = STATE(58),
    [sym_expansion] = STATE(58),
    [sym_command_substitution] = STATE(58),
    [sym_process_substitution] = STATE(58),
    [aux_sym_program_repeat1] = STATE(69),
    [aux_sym_command_repeat1] = STATE(70),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(86),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(88),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(90),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(92),
    [anon_sym_typeset] = ACTIONS(92),
    [anon_sym_export] = ACTIONS(92),
    [anon_sym_readonly] = ACTIONS(92),
    [anon_sym_local] = ACTIONS(92),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(94),
    [anon_sym_DQUOTE] = ACTIONS(96),
    [sym_raw_string] = ACTIONS(98),
    [anon_sym_DOLLAR] = ACTIONS(100),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(102),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(104),
    [anon_sym_BQUOTE] = ACTIONS(106),
    [anon_sym_LT_LPAREN] = ACTIONS(108),
    [anon_sym_GT_LPAREN] = ACTIONS(108),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(110),
  },
  [10] = {
    [sym_concatenation] = STATE(79),
    [sym_string] = STATE(73),
    [sym_simple_expansion] = STATE(73),
    [sym_expansion] = STATE(73),
    [sym_command_substitution] = STATE(73),
    [sym_process_substitution] = STATE(73),
    [aux_sym_for_statement_repeat1] = STATE(80),
    [sym__special_characters] = ACTIONS(112),
    [anon_sym_DQUOTE] = ACTIONS(114),
    [sym_raw_string] = ACTIONS(116),
    [anon_sym_DOLLAR] = ACTIONS(118),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(120),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(122),
    [anon_sym_BQUOTE] = ACTIONS(124),
    [anon_sym_LT_LPAREN] = ACTIONS(126),
    [anon_sym_GT_LPAREN] = ACTIONS(126),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(128),
  },
  [11] = {
    [sym_concatenation] = STATE(89),
    [sym_string] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [sym_expansion] = STATE(83),
    [sym_command_substitution] = STATE(83),
    [sym_process_substitution] = STATE(83),
    [aux_sym_for_statement_repeat1] = STATE(90),
    [sym__special_characters] = ACTIONS(130),
    [anon_sym_DQUOTE] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(134),
    [anon_sym_DOLLAR] = ACTIONS(136),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(138),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(140),
    [anon_sym_BQUOTE] = ACTIONS(142),
    [anon_sym_LT_LPAREN] = ACTIONS(144),
    [anon_sym_GT_LPAREN] = ACTIONS(144),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(146),
  },
  [12] = {
    [sym_variable_assignment] = STATE(101),
    [sym_subscript] = STATE(102),
    [sym_concatenation] = STATE(101),
    [sym_string] = STATE(94),
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [sym_process_substitution] = STATE(94),
    [aux_sym_declaration_command_repeat1] = STATE(103),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_PIPE] = ACTIONS(150),
    [anon_sym_SEMI_SEMI] = ACTIONS(150),
    [anon_sym_PIPE_AMP] = ACTIONS(150),
    [anon_sym_AMP_AMP] = ACTIONS(150),
    [anon_sym_PIPE_PIPE] = ACTIONS(150),
    [sym__special_characters] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(154),
    [sym_raw_string] = ACTIONS(156),
    [anon_sym_DOLLAR] = ACTIONS(158),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(160),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(162),
    [anon_sym_BQUOTE] = ACTIONS(164),
    [anon_sym_LT_LPAREN] = ACTIONS(166),
    [anon_sym_GT_LPAREN] = ACTIONS(166),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(170),
    [sym_word] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LF] = ACTIONS(150),
    [anon_sym_AMP] = ACTIONS(150),
  },
  [13] = {
    [sym_concatenation] = STATE(112),
    [sym_string] = STATE(106),
    [sym_simple_expansion] = STATE(106),
    [sym_expansion] = STATE(106),
    [sym_command_substitution] = STATE(106),
    [sym_process_substitution] = STATE(106),
    [sym__special_characters] = ACTIONS(172),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [sym_raw_string] = ACTIONS(176),
    [anon_sym_DOLLAR] = ACTIONS(178),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(180),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(182),
    [anon_sym_BQUOTE] = ACTIONS(184),
    [anon_sym_LT_LPAREN] = ACTIONS(186),
    [anon_sym_GT_LPAREN] = ACTIONS(186),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(188),
  },
  [14] = {
    [aux_sym_concatenation_repeat1] = STATE(114),
    [sym_file_descriptor] = ACTIONS(190),
    [sym__concat] = ACTIONS(192),
    [anon_sym_PIPE] = ACTIONS(194),
    [anon_sym_SEMI_SEMI] = ACTIONS(194),
    [anon_sym_PIPE_AMP] = ACTIONS(194),
    [anon_sym_AMP_AMP] = ACTIONS(194),
    [anon_sym_PIPE_PIPE] = ACTIONS(194),
    [anon_sym_LT] = ACTIONS(194),
    [anon_sym_GT] = ACTIONS(194),
    [anon_sym_GT_GT] = ACTIONS(194),
    [anon_sym_AMP_GT] = ACTIONS(194),
    [anon_sym_AMP_GT_GT] = ACTIONS(194),
    [anon_sym_LT_AMP] = ACTIONS(194),
    [anon_sym_GT_AMP] = ACTIONS(194),
    [anon_sym_LT_LT] = ACTIONS(194),
    [anon_sym_LT_LT_DASH] = ACTIONS(194),
    [anon_sym_LT_LT_LT] = ACTIONS(194),
    [sym__special_characters] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(194),
    [sym_raw_string] = ACTIONS(194),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(194),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(194),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [anon_sym_LT_LPAREN] = ACTIONS(194),
    [anon_sym_GT_LPAREN] = ACTIONS(194),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(194),
    [anon_sym_SEMI] = ACTIONS(194),
    [anon_sym_LF] = ACTIONS(194),
    [anon_sym_AMP] = ACTIONS(194),
  },
  [15] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(121),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [16] = {
    [aux_sym_concatenation_repeat1] = STATE(114),
    [sym_file_descriptor] = ACTIONS(208),
    [sym__concat] = ACTIONS(192),
    [anon_sym_PIPE] = ACTIONS(210),
    [anon_sym_SEMI_SEMI] = ACTIONS(210),
    [anon_sym_PIPE_AMP] = ACTIONS(210),
    [anon_sym_AMP_AMP] = ACTIONS(210),
    [anon_sym_PIPE_PIPE] = ACTIONS(210),
    [anon_sym_LT] = ACTIONS(210),
    [anon_sym_GT] = ACTIONS(210),
    [anon_sym_GT_GT] = ACTIONS(210),
    [anon_sym_AMP_GT] = ACTIONS(210),
    [anon_sym_AMP_GT_GT] = ACTIONS(210),
    [anon_sym_LT_AMP] = ACTIONS(210),
    [anon_sym_GT_AMP] = ACTIONS(210),
    [anon_sym_LT_LT] = ACTIONS(210),
    [anon_sym_LT_LT_DASH] = ACTIONS(210),
    [anon_sym_LT_LT_LT] = ACTIONS(210),
    [sym__special_characters] = ACTIONS(210),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [sym_raw_string] = ACTIONS(210),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(210),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(210),
    [anon_sym_BQUOTE] = ACTIONS(210),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(210),
    [anon_sym_SEMI] = ACTIONS(210),
    [anon_sym_LF] = ACTIONS(210),
    [anon_sym_AMP] = ACTIONS(210),
  },
  [17] = {
    [sym_string] = STATE(124),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [anon_sym_DOLLAR] = ACTIONS(212),
    [anon_sym_POUND] = ACTIONS(212),
    [anon_sym_DASH] = ACTIONS(212),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(214),
    [anon_sym_STAR] = ACTIONS(212),
    [anon_sym_AT] = ACTIONS(212),
    [anon_sym_QMARK] = ACTIONS(212),
    [anon_sym_0] = ACTIONS(216),
    [anon_sym__] = ACTIONS(216),
  },
  [18] = {
    [sym_subscript] = STATE(129),
    [sym_variable_name] = ACTIONS(218),
    [anon_sym_DOLLAR] = ACTIONS(220),
    [anon_sym_POUND] = ACTIONS(222),
    [anon_sym_DASH] = ACTIONS(220),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(224),
    [anon_sym_STAR] = ACTIONS(220),
    [anon_sym_AT] = ACTIONS(220),
    [anon_sym_QMARK] = ACTIONS(220),
    [anon_sym_0] = ACTIONS(226),
    [anon_sym__] = ACTIONS(226),
  },
  [19] = {
    [sym_for_statement] = STATE(149),
    [sym_while_statement] = STATE(149),
    [sym_if_statement] = STATE(149),
    [sym_case_statement] = STATE(149),
    [sym_function_definition] = STATE(149),
    [sym_subshell] = STATE(149),
    [sym_pipeline] = STATE(149),
    [sym_list] = STATE(149),
    [sym_bracket_command] = STATE(149),
    [sym_command] = STATE(149),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(151),
    [sym_declaration_command] = STATE(149),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [20] = {
    [sym_for_statement] = STATE(168),
    [sym_while_statement] = STATE(168),
    [sym_if_statement] = STATE(168),
    [sym_case_statement] = STATE(168),
    [sym_function_definition] = STATE(168),
    [sym_subshell] = STATE(168),
    [sym_pipeline] = STATE(168),
    [sym_list] = STATE(168),
    [sym_bracket_command] = STATE(168),
    [sym_command] = STATE(168),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(170),
    [sym_declaration_command] = STATE(168),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [21] = {
    [sym_for_statement] = STATE(173),
    [sym_while_statement] = STATE(173),
    [sym_if_statement] = STATE(173),
    [sym_case_statement] = STATE(173),
    [sym_function_definition] = STATE(173),
    [sym_subshell] = STATE(173),
    [sym_pipeline] = STATE(173),
    [sym_list] = STATE(173),
    [sym_bracket_command] = STATE(173),
    [sym_command] = STATE(173),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(174),
    [sym_declaration_command] = STATE(173),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [22] = {
    [aux_sym_concatenation_repeat1] = STATE(114),
    [sym_file_descriptor] = ACTIONS(208),
    [sym__concat] = ACTIONS(192),
    [anon_sym_PIPE] = ACTIONS(210),
    [anon_sym_SEMI_SEMI] = ACTIONS(210),
    [anon_sym_LPAREN] = ACTIONS(292),
    [anon_sym_PIPE_AMP] = ACTIONS(210),
    [anon_sym_AMP_AMP] = ACTIONS(210),
    [anon_sym_PIPE_PIPE] = ACTIONS(210),
    [anon_sym_LT] = ACTIONS(210),
    [anon_sym_GT] = ACTIONS(210),
    [anon_sym_GT_GT] = ACTIONS(210),
    [anon_sym_AMP_GT] = ACTIONS(210),
    [anon_sym_AMP_GT_GT] = ACTIONS(210),
    [anon_sym_LT_AMP] = ACTIONS(210),
    [anon_sym_GT_AMP] = ACTIONS(210),
    [anon_sym_LT_LT] = ACTIONS(210),
    [anon_sym_LT_LT_DASH] = ACTIONS(210),
    [anon_sym_LT_LT_LT] = ACTIONS(210),
    [sym__special_characters] = ACTIONS(210),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [sym_raw_string] = ACTIONS(210),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(210),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(210),
    [anon_sym_BQUOTE] = ACTIONS(210),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(210),
    [anon_sym_SEMI] = ACTIONS(210),
    [anon_sym_LF] = ACTIONS(210),
    [anon_sym_AMP] = ACTIONS(210),
  },
  [23] = {
    [ts_builtin_sym_end] = ACTIONS(294),
    [sym_comment] = ACTIONS(52),
  },
  [24] = {
    [sym_file_descriptor] = ACTIONS(296),
    [sym_variable_name] = ACTIONS(296),
    [ts_builtin_sym_end] = ACTIONS(296),
    [anon_sym_for] = ACTIONS(298),
    [anon_sym_while] = ACTIONS(298),
    [anon_sym_if] = ACTIONS(298),
    [anon_sym_case] = ACTIONS(298),
    [anon_sym_SEMI_SEMI] = ACTIONS(296),
    [anon_sym_function] = ACTIONS(298),
    [anon_sym_LPAREN] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(296),
    [anon_sym_declare] = ACTIONS(298),
    [anon_sym_typeset] = ACTIONS(298),
    [anon_sym_export] = ACTIONS(298),
    [anon_sym_readonly] = ACTIONS(298),
    [anon_sym_local] = ACTIONS(298),
    [anon_sym_LT] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(298),
    [anon_sym_GT_GT] = ACTIONS(296),
    [anon_sym_AMP_GT] = ACTIONS(298),
    [anon_sym_AMP_GT_GT] = ACTIONS(296),
    [anon_sym_LT_AMP] = ACTIONS(296),
    [anon_sym_GT_AMP] = ACTIONS(296),
    [sym__special_characters] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(296),
    [sym_raw_string] = ACTIONS(296),
    [anon_sym_DOLLAR] = ACTIONS(298),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(296),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(296),
    [anon_sym_BQUOTE] = ACTIONS(296),
    [anon_sym_LT_LPAREN] = ACTIONS(296),
    [anon_sym_GT_LPAREN] = ACTIONS(296),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(300),
  },
  [25] = {
    [anon_sym_PIPE] = ACTIONS(302),
    [anon_sym_SEMI_SEMI] = ACTIONS(304),
    [anon_sym_PIPE_AMP] = ACTIONS(302),
    [anon_sym_AMP_AMP] = ACTIONS(306),
    [anon_sym_PIPE_PIPE] = ACTIONS(306),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(304),
    [anon_sym_LF] = ACTIONS(304),
    [anon_sym_AMP] = ACTIONS(304),
  },
  [26] = {
    [sym_file_redirect] = STATE(185),
    [sym_heredoc_redirect] = STATE(185),
    [sym_herestring_redirect] = STATE(185),
    [sym_concatenation] = STATE(186),
    [sym_string] = STATE(184),
    [sym_simple_expansion] = STATE(184),
    [sym_expansion] = STATE(184),
    [sym_command_substitution] = STATE(184),
    [sym_process_substitution] = STATE(184),
    [aux_sym_for_statement_repeat1] = STATE(187),
    [aux_sym_while_statement_repeat1] = STATE(188),
    [sym_file_descriptor] = ACTIONS(308),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_SEMI_SEMI] = ACTIONS(310),
    [anon_sym_PIPE_AMP] = ACTIONS(310),
    [anon_sym_AMP_AMP] = ACTIONS(310),
    [anon_sym_PIPE_PIPE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(312),
    [anon_sym_GT] = ACTIONS(312),
    [anon_sym_GT_GT] = ACTIONS(312),
    [anon_sym_AMP_GT] = ACTIONS(312),
    [anon_sym_AMP_GT_GT] = ACTIONS(312),
    [anon_sym_LT_AMP] = ACTIONS(312),
    [anon_sym_GT_AMP] = ACTIONS(312),
    [anon_sym_LT_LT] = ACTIONS(314),
    [anon_sym_LT_LT_DASH] = ACTIONS(314),
    [anon_sym_LT_LT_LT] = ACTIONS(316),
    [sym__special_characters] = ACTIONS(318),
    [anon_sym_DQUOTE] = ACTIONS(320),
    [sym_raw_string] = ACTIONS(322),
    [anon_sym_DOLLAR] = ACTIONS(324),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(326),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(328),
    [anon_sym_BQUOTE] = ACTIONS(330),
    [anon_sym_LT_LPAREN] = ACTIONS(332),
    [anon_sym_GT_LPAREN] = ACTIONS(332),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(322),
    [anon_sym_SEMI] = ACTIONS(310),
    [anon_sym_LF] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
  },
  [27] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(302),
    [anon_sym_SEMI_SEMI] = ACTIONS(304),
    [anon_sym_PIPE_AMP] = ACTIONS(302),
    [anon_sym_AMP_AMP] = ACTIONS(306),
    [anon_sym_PIPE_PIPE] = ACTIONS(306),
    [anon_sym_LT] = ACTIONS(336),
    [anon_sym_GT] = ACTIONS(336),
    [anon_sym_GT_GT] = ACTIONS(336),
    [anon_sym_AMP_GT] = ACTIONS(336),
    [anon_sym_AMP_GT_GT] = ACTIONS(336),
    [anon_sym_LT_AMP] = ACTIONS(336),
    [anon_sym_GT_AMP] = ACTIONS(336),
    [sym__special_characters] = ACTIONS(336),
    [anon_sym_DQUOTE] = ACTIONS(336),
    [sym_raw_string] = ACTIONS(336),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(336),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(336),
    [anon_sym_BQUOTE] = ACTIONS(336),
    [anon_sym_LT_LPAREN] = ACTIONS(336),
    [anon_sym_GT_LPAREN] = ACTIONS(336),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(336),
    [anon_sym_SEMI] = ACTIONS(304),
    [anon_sym_LF] = ACTIONS(304),
    [anon_sym_AMP] = ACTIONS(304),
  },
  [28] = {
    [sym__assignment] = STATE(36),
    [anon_sym_EQ] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(62),
    [sym_comment] = ACTIONS(52),
  },
  [29] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [30] = {
    [sym_file_descriptor] = ACTIONS(208),
    [anon_sym_PIPE] = ACTIONS(210),
    [anon_sym_RPAREN] = ACTIONS(210),
    [anon_sym_SEMI_SEMI] = ACTIONS(210),
    [anon_sym_PIPE_AMP] = ACTIONS(210),
    [anon_sym_AMP_AMP] = ACTIONS(210),
    [anon_sym_PIPE_PIPE] = ACTIONS(210),
    [anon_sym_LT] = ACTIONS(210),
    [anon_sym_GT] = ACTIONS(210),
    [anon_sym_GT_GT] = ACTIONS(210),
    [anon_sym_AMP_GT] = ACTIONS(210),
    [anon_sym_AMP_GT_GT] = ACTIONS(210),
    [anon_sym_LT_AMP] = ACTIONS(210),
    [anon_sym_GT_AMP] = ACTIONS(210),
    [anon_sym_LT_LT] = ACTIONS(210),
    [anon_sym_LT_LT_DASH] = ACTIONS(210),
    [anon_sym_LT_LT_LT] = ACTIONS(210),
    [sym__special_characters] = ACTIONS(210),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [sym_raw_string] = ACTIONS(210),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(210),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(210),
    [anon_sym_BQUOTE] = ACTIONS(210),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(210),
    [anon_sym_SEMI] = ACTIONS(210),
    [anon_sym_LF] = ACTIONS(210),
    [anon_sym_AMP] = ACTIONS(210),
  },
  [31] = {
    [sym__terminated_statement] = STATE(24),
    [sym_for_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_case_statement] = STATE(25),
    [sym_function_definition] = STATE(25),
    [sym_subshell] = STATE(25),
    [sym_pipeline] = STATE(25),
    [sym_list] = STATE(25),
    [sym_bracket_command] = STATE(25),
    [sym_command] = STATE(25),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(27),
    [sym_declaration_command] = STATE(25),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(189),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [ts_builtin_sym_end] = ACTIONS(340),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [32] = {
    [sym_command_name] = STATE(191),
    [sym_variable_assignment] = STATE(29),
    [sym_subscript] = STATE(192),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_command_repeat1] = STATE(193),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(342),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(344),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(346),
  },
  [33] = {
    [sym_concatenation] = STATE(196),
    [sym_string] = STATE(195),
    [sym_simple_expansion] = STATE(195),
    [sym_expansion] = STATE(195),
    [sym_command_substitution] = STATE(195),
    [sym_process_substitution] = STATE(195),
    [sym__special_characters] = ACTIONS(348),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [sym_raw_string] = ACTIONS(350),
    [anon_sym_DOLLAR] = ACTIONS(178),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(180),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(182),
    [anon_sym_BQUOTE] = ACTIONS(184),
    [anon_sym_LT_LPAREN] = ACTIONS(186),
    [anon_sym_GT_LPAREN] = ACTIONS(186),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(352),
  },
  [34] = {
    [sym_concatenation] = STATE(205),
    [sym_string] = STATE(199),
    [sym_simple_expansion] = STATE(199),
    [sym_expansion] = STATE(199),
    [sym_command_substitution] = STATE(199),
    [sym_process_substitution] = STATE(199),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(358),
    [anon_sym_DOLLAR] = ACTIONS(360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(364),
    [anon_sym_BQUOTE] = ACTIONS(366),
    [anon_sym_LT_LPAREN] = ACTIONS(368),
    [anon_sym_GT_LPAREN] = ACTIONS(368),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(370),
  },
  [35] = {
    [sym_concatenation] = STATE(206),
    [sym_string] = STATE(210),
    [sym_array] = STATE(206),
    [sym_simple_expansion] = STATE(210),
    [sym_expansion] = STATE(210),
    [sym_command_substitution] = STATE(210),
    [sym_process_substitution] = STATE(210),
    [sym__empty_value] = ACTIONS(372),
    [anon_sym_LPAREN] = ACTIONS(374),
    [sym__special_characters] = ACTIONS(376),
    [anon_sym_DQUOTE] = ACTIONS(378),
    [sym_raw_string] = ACTIONS(380),
    [anon_sym_DOLLAR] = ACTIONS(382),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(384),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(386),
    [anon_sym_BQUOTE] = ACTIONS(388),
    [anon_sym_LT_LPAREN] = ACTIONS(390),
    [anon_sym_GT_LPAREN] = ACTIONS(390),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(392),
  },
  [36] = {
    [sym_file_descriptor] = ACTIONS(394),
    [sym_variable_name] = ACTIONS(394),
    [anon_sym_PIPE] = ACTIONS(396),
    [anon_sym_RPAREN] = ACTIONS(396),
    [anon_sym_SEMI_SEMI] = ACTIONS(396),
    [anon_sym_PIPE_AMP] = ACTIONS(396),
    [anon_sym_AMP_AMP] = ACTIONS(396),
    [anon_sym_PIPE_PIPE] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(396),
    [anon_sym_GT] = ACTIONS(396),
    [anon_sym_GT_GT] = ACTIONS(396),
    [anon_sym_AMP_GT] = ACTIONS(396),
    [anon_sym_AMP_GT_GT] = ACTIONS(396),
    [anon_sym_LT_AMP] = ACTIONS(396),
    [anon_sym_GT_AMP] = ACTIONS(396),
    [sym__special_characters] = ACTIONS(396),
    [anon_sym_DQUOTE] = ACTIONS(396),
    [sym_raw_string] = ACTIONS(396),
    [anon_sym_DOLLAR] = ACTIONS(396),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(396),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(396),
    [anon_sym_BQUOTE] = ACTIONS(396),
    [anon_sym_LT_LPAREN] = ACTIONS(396),
    [anon_sym_GT_LPAREN] = ACTIONS(396),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(396),
    [anon_sym_SEMI] = ACTIONS(396),
    [anon_sym_LF] = ACTIONS(396),
    [anon_sym_AMP] = ACTIONS(396),
  },
  [37] = {
    [anon_sym_in] = ACTIONS(398),
    [sym_comment] = ACTIONS(52),
  },
  [38] = {
    [sym_do_group] = STATE(218),
    [anon_sym_do] = ACTIONS(400),
    [sym_comment] = ACTIONS(52),
  },
  [39] = {
    [anon_sym_PIPE] = ACTIONS(302),
    [anon_sym_SEMI_SEMI] = ACTIONS(402),
    [anon_sym_PIPE_AMP] = ACTIONS(302),
    [anon_sym_AMP_AMP] = ACTIONS(306),
    [anon_sym_PIPE_PIPE] = ACTIONS(306),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(402),
    [anon_sym_LF] = ACTIONS(402),
    [anon_sym_AMP] = ACTIONS(402),
  },
  [40] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(302),
    [anon_sym_SEMI_SEMI] = ACTIONS(402),
    [anon_sym_PIPE_AMP] = ACTIONS(302),
    [anon_sym_AMP_AMP] = ACTIONS(306),
    [anon_sym_PIPE_PIPE] = ACTIONS(306),
    [anon_sym_LT] = ACTIONS(336),
    [anon_sym_GT] = ACTIONS(336),
    [anon_sym_GT_GT] = ACTIONS(336),
    [anon_sym_AMP_GT] = ACTIONS(336),
    [anon_sym_AMP_GT_GT] = ACTIONS(336),
    [anon_sym_LT_AMP] = ACTIONS(336),
    [anon_sym_GT_AMP] = ACTIONS(336),
    [sym__special_characters] = ACTIONS(336),
    [anon_sym_DQUOTE] = ACTIONS(336),
    [sym_raw_string] = ACTIONS(336),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(336),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(336),
    [anon_sym_BQUOTE] = ACTIONS(336),
    [anon_sym_LT_LPAREN] = ACTIONS(336),
    [anon_sym_GT_LPAREN] = ACTIONS(336),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(336),
    [anon_sym_SEMI] = ACTIONS(402),
    [anon_sym_LF] = ACTIONS(402),
    [anon_sym_AMP] = ACTIONS(402),
  },
  [41] = {
    [anon_sym_then] = ACTIONS(404),
    [sym_comment] = ACTIONS(52),
  },
  [42] = {
    [aux_sym_concatenation_repeat1] = STATE(224),
    [sym__concat] = ACTIONS(406),
    [anon_sym_in] = ACTIONS(408),
    [anon_sym_SEMI_SEMI] = ACTIONS(410),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(410),
    [anon_sym_LF] = ACTIONS(410),
    [anon_sym_AMP] = ACTIONS(410),
  },
  [43] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(226),
    [anon_sym_DQUOTE] = ACTIONS(412),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [44] = {
    [aux_sym_concatenation_repeat1] = STATE(224),
    [sym__concat] = ACTIONS(406),
    [anon_sym_in] = ACTIONS(414),
    [anon_sym_SEMI_SEMI] = ACTIONS(416),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(416),
    [anon_sym_LF] = ACTIONS(416),
    [anon_sym_AMP] = ACTIONS(416),
  },
  [45] = {
    [sym_string] = STATE(231),
    [anon_sym_DQUOTE] = ACTIONS(68),
    [anon_sym_DOLLAR] = ACTIONS(418),
    [anon_sym_POUND] = ACTIONS(418),
    [anon_sym_DASH] = ACTIONS(418),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(420),
    [anon_sym_STAR] = ACTIONS(418),
    [anon_sym_AT] = ACTIONS(418),
    [anon_sym_QMARK] = ACTIONS(418),
    [anon_sym_0] = ACTIONS(422),
    [anon_sym__] = ACTIONS(422),
  },
  [46] = {
    [sym_subscript] = STATE(236),
    [sym_variable_name] = ACTIONS(424),
    [anon_sym_DOLLAR] = ACTIONS(426),
    [anon_sym_POUND] = ACTIONS(428),
    [anon_sym_DASH] = ACTIONS(426),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(430),
    [anon_sym_STAR] = ACTIONS(426),
    [anon_sym_AT] = ACTIONS(426),
    [anon_sym_QMARK] = ACTIONS(426),
    [anon_sym_0] = ACTIONS(432),
    [anon_sym__] = ACTIONS(432),
  },
  [47] = {
    [sym_for_statement] = STATE(237),
    [sym_while_statement] = STATE(237),
    [sym_if_statement] = STATE(237),
    [sym_case_statement] = STATE(237),
    [sym_function_definition] = STATE(237),
    [sym_subshell] = STATE(237),
    [sym_pipeline] = STATE(237),
    [sym_list] = STATE(237),
    [sym_bracket_command] = STATE(237),
    [sym_command] = STATE(237),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(238),
    [sym_declaration_command] = STATE(237),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [48] = {
    [sym_for_statement] = STATE(239),
    [sym_while_statement] = STATE(239),
    [sym_if_statement] = STATE(239),
    [sym_case_statement] = STATE(239),
    [sym_function_definition] = STATE(239),
    [sym_subshell] = STATE(239),
    [sym_pipeline] = STATE(239),
    [sym_list] = STATE(239),
    [sym_bracket_command] = STATE(239),
    [sym_command] = STATE(239),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(240),
    [sym_declaration_command] = STATE(239),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [49] = {
    [sym_for_statement] = STATE(241),
    [sym_while_statement] = STATE(241),
    [sym_if_statement] = STATE(241),
    [sym_case_statement] = STATE(241),
    [sym_function_definition] = STATE(241),
    [sym_subshell] = STATE(241),
    [sym_pipeline] = STATE(241),
    [sym_list] = STATE(241),
    [sym_bracket_command] = STATE(241),
    [sym_command] = STATE(241),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(242),
    [sym_declaration_command] = STATE(241),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [50] = {
    [anon_sym_in] = ACTIONS(414),
    [anon_sym_SEMI_SEMI] = ACTIONS(416),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(416),
    [anon_sym_LF] = ACTIONS(416),
    [anon_sym_AMP] = ACTIONS(416),
  },
  [51] = {
    [sym_compound_statement] = STATE(245),
    [anon_sym_LPAREN] = ACTIONS(434),
    [anon_sym_LBRACE] = ACTIONS(436),
    [sym_comment] = ACTIONS(52),
  },
  [52] = {
    [sym__assignment] = STATE(36),
    [anon_sym_LBRACK] = ACTIONS(60),
    [anon_sym_EQ] = ACTIONS(438),
    [anon_sym_PLUS_EQ] = ACTIONS(438),
    [sym_comment] = ACTIONS(52),
  },
  [53] = {
    [sym__terminated_statement] = STATE(247),
    [sym_for_statement] = STATE(39),
    [sym_while_statement] = STATE(39),
    [sym_if_statement] = STATE(39),
    [sym_case_statement] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_subshell] = STATE(39),
    [sym_pipeline] = STATE(39),
    [sym_list] = STATE(39),
    [sym_bracket_command] = STATE(39),
    [sym_command] = STATE(39),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(40),
    [sym_declaration_command] = STATE(39),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [54] = {
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(440),
  },
  [55] = {
    [sym_variable_assignment] = STATE(101),
    [sym_subscript] = STATE(258),
    [sym_concatenation] = STATE(101),
    [sym_string] = STATE(252),
    [sym_simple_expansion] = STATE(252),
    [sym_expansion] = STATE(252),
    [sym_command_substitution] = STATE(252),
    [sym_process_substitution] = STATE(252),
    [aux_sym_declaration_command_repeat1] = STATE(259),
    [sym_variable_name] = ACTIONS(442),
    [anon_sym_PIPE] = ACTIONS(150),
    [anon_sym_RPAREN] = ACTIONS(150),
    [anon_sym_SEMI_SEMI] = ACTIONS(150),
    [anon_sym_PIPE_AMP] = ACTIONS(150),
    [anon_sym_AMP_AMP] = ACTIONS(150),
    [anon_sym_PIPE_PIPE] = ACTIONS(150),
    [sym__special_characters] = ACTIONS(444),
    [anon_sym_DQUOTE] = ACTIONS(446),
    [sym_raw_string] = ACTIONS(448),
    [anon_sym_DOLLAR] = ACTIONS(450),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(452),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(454),
    [anon_sym_BQUOTE] = ACTIONS(456),
    [anon_sym_LT_LPAREN] = ACTIONS(458),
    [anon_sym_GT_LPAREN] = ACTIONS(458),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(170),
    [sym_word] = ACTIONS(448),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LF] = ACTIONS(150),
    [anon_sym_AMP] = ACTIONS(150),
  },
  [56] = {
    [aux_sym_concatenation_repeat1] = STATE(261),
    [sym_file_descriptor] = ACTIONS(190),
    [sym__concat] = ACTIONS(460),
    [anon_sym_PIPE] = ACTIONS(194),
    [anon_sym_RPAREN] = ACTIONS(194),
    [anon_sym_SEMI_SEMI] = ACTIONS(194),
    [anon_sym_PIPE_AMP] = ACTIONS(194),
    [anon_sym_AMP_AMP] = ACTIONS(194),
    [anon_sym_PIPE_PIPE] = ACTIONS(194),
    [anon_sym_LT] = ACTIONS(194),
    [anon_sym_GT] = ACTIONS(194),
    [anon_sym_GT_GT] = ACTIONS(194),
    [anon_sym_AMP_GT] = ACTIONS(194),
    [anon_sym_AMP_GT_GT] = ACTIONS(194),
    [anon_sym_LT_AMP] = ACTIONS(194),
    [anon_sym_GT_AMP] = ACTIONS(194),
    [anon_sym_LT_LT] = ACTIONS(194),
    [anon_sym_LT_LT_DASH] = ACTIONS(194),
    [anon_sym_LT_LT_LT] = ACTIONS(194),
    [sym__special_characters] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(194),
    [sym_raw_string] = ACTIONS(194),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(194),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(194),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [anon_sym_LT_LPAREN] = ACTIONS(194),
    [anon_sym_GT_LPAREN] = ACTIONS(194),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(194),
    [anon_sym_SEMI] = ACTIONS(194),
    [anon_sym_LF] = ACTIONS(194),
    [anon_sym_AMP] = ACTIONS(194),
  },
  [57] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(263),
    [anon_sym_DQUOTE] = ACTIONS(462),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [58] = {
    [aux_sym_concatenation_repeat1] = STATE(261),
    [sym_file_descriptor] = ACTIONS(208),
    [sym__concat] = ACTIONS(460),
    [anon_sym_PIPE] = ACTIONS(210),
    [anon_sym_RPAREN] = ACTIONS(210),
    [anon_sym_SEMI_SEMI] = ACTIONS(210),
    [anon_sym_PIPE_AMP] = ACTIONS(210),
    [anon_sym_AMP_AMP] = ACTIONS(210),
    [anon_sym_PIPE_PIPE] = ACTIONS(210),
    [anon_sym_LT] = ACTIONS(210),
    [anon_sym_GT] = ACTIONS(210),
    [anon_sym_GT_GT] = ACTIONS(210),
    [anon_sym_AMP_GT] = ACTIONS(210),
    [anon_sym_AMP_GT_GT] = ACTIONS(210),
    [anon_sym_LT_AMP] = ACTIONS(210),
    [anon_sym_GT_AMP] = ACTIONS(210),
    [anon_sym_LT_LT] = ACTIONS(210),
    [anon_sym_LT_LT_DASH] = ACTIONS(210),
    [anon_sym_LT_LT_LT] = ACTIONS(210),
    [sym__special_characters] = ACTIONS(210),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [sym_raw_string] = ACTIONS(210),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(210),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(210),
    [anon_sym_BQUOTE] = ACTIONS(210),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(210),
    [anon_sym_SEMI] = ACTIONS(210),
    [anon_sym_LF] = ACTIONS(210),
    [anon_sym_AMP] = ACTIONS(210),
  },
  [59] = {
    [sym_string] = STATE(266),
    [anon_sym_DQUOTE] = ACTIONS(96),
    [anon_sym_DOLLAR] = ACTIONS(464),
    [anon_sym_POUND] = ACTIONS(464),
    [anon_sym_DASH] = ACTIONS(464),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(466),
    [anon_sym_STAR] = ACTIONS(464),
    [anon_sym_AT] = ACTIONS(464),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_0] = ACTIONS(468),
    [anon_sym__] = ACTIONS(468),
  },
  [60] = {
    [sym_subscript] = STATE(271),
    [sym_variable_name] = ACTIONS(470),
    [anon_sym_DOLLAR] = ACTIONS(472),
    [anon_sym_POUND] = ACTIONS(474),
    [anon_sym_DASH] = ACTIONS(472),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(476),
    [anon_sym_STAR] = ACTIONS(472),
    [anon_sym_AT] = ACTIONS(472),
    [anon_sym_QMARK] = ACTIONS(472),
    [anon_sym_0] = ACTIONS(478),
    [anon_sym__] = ACTIONS(478),
  },
  [61] = {
    [sym_for_statement] = STATE(272),
    [sym_while_statement] = STATE(272),
    [sym_if_statement] = STATE(272),
    [sym_case_statement] = STATE(272),
    [sym_function_definition] = STATE(272),
    [sym_subshell] = STATE(272),
    [sym_pipeline] = STATE(272),
    [sym_list] = STATE(272),
    [sym_bracket_command] = STATE(272),
    [sym_command] = STATE(272),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(273),
    [sym_declaration_command] = STATE(272),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [62] = {
    [sym_for_statement] = STATE(274),
    [sym_while_statement] = STATE(274),
    [sym_if_statement] = STATE(274),
    [sym_case_statement] = STATE(274),
    [sym_function_definition] = STATE(274),
    [sym_subshell] = STATE(274),
    [sym_pipeline] = STATE(274),
    [sym_list] = STATE(274),
    [sym_bracket_command] = STATE(274),
    [sym_command] = STATE(274),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(275),
    [sym_declaration_command] = STATE(274),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [63] = {
    [sym_for_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_case_statement] = STATE(276),
    [sym_function_definition] = STATE(276),
    [sym_subshell] = STATE(276),
    [sym_pipeline] = STATE(276),
    [sym_list] = STATE(276),
    [sym_bracket_command] = STATE(276),
    [sym_command] = STATE(276),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(277),
    [sym_declaration_command] = STATE(276),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [64] = {
    [aux_sym_concatenation_repeat1] = STATE(261),
    [sym_file_descriptor] = ACTIONS(208),
    [sym__concat] = ACTIONS(460),
    [anon_sym_PIPE] = ACTIONS(210),
    [anon_sym_RPAREN] = ACTIONS(210),
    [anon_sym_SEMI_SEMI] = ACTIONS(210),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_PIPE_AMP] = ACTIONS(210),
    [anon_sym_AMP_AMP] = ACTIONS(210),
    [anon_sym_PIPE_PIPE] = ACTIONS(210),
    [anon_sym_LT] = ACTIONS(210),
    [anon_sym_GT] = ACTIONS(210),
    [anon_sym_GT_GT] = ACTIONS(210),
    [anon_sym_AMP_GT] = ACTIONS(210),
    [anon_sym_AMP_GT_GT] = ACTIONS(210),
    [anon_sym_LT_AMP] = ACTIONS(210),
    [anon_sym_GT_AMP] = ACTIONS(210),
    [anon_sym_LT_LT] = ACTIONS(210),
    [anon_sym_LT_LT_DASH] = ACTIONS(210),
    [anon_sym_LT_LT_LT] = ACTIONS(210),
    [sym__special_characters] = ACTIONS(210),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [sym_raw_string] = ACTIONS(210),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(210),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(210),
    [anon_sym_BQUOTE] = ACTIONS(210),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(210),
    [anon_sym_SEMI] = ACTIONS(210),
    [anon_sym_LF] = ACTIONS(210),
    [anon_sym_AMP] = ACTIONS(210),
  },
  [65] = {
    [anon_sym_PIPE] = ACTIONS(482),
    [anon_sym_RPAREN] = ACTIONS(484),
    [anon_sym_SEMI_SEMI] = ACTIONS(486),
    [anon_sym_PIPE_AMP] = ACTIONS(482),
    [anon_sym_AMP_AMP] = ACTIONS(488),
    [anon_sym_PIPE_PIPE] = ACTIONS(488),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(486),
    [anon_sym_LF] = ACTIONS(486),
    [anon_sym_AMP] = ACTIONS(486),
  },
  [66] = {
    [sym_file_redirect] = STATE(185),
    [sym_heredoc_redirect] = STATE(185),
    [sym_herestring_redirect] = STATE(185),
    [sym_concatenation] = STATE(186),
    [sym_string] = STATE(287),
    [sym_simple_expansion] = STATE(287),
    [sym_expansion] = STATE(287),
    [sym_command_substitution] = STATE(287),
    [sym_process_substitution] = STATE(287),
    [aux_sym_for_statement_repeat1] = STATE(288),
    [aux_sym_while_statement_repeat1] = STATE(289),
    [sym_file_descriptor] = ACTIONS(490),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_RPAREN] = ACTIONS(310),
    [anon_sym_SEMI_SEMI] = ACTIONS(310),
    [anon_sym_PIPE_AMP] = ACTIONS(310),
    [anon_sym_AMP_AMP] = ACTIONS(310),
    [anon_sym_PIPE_PIPE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_GT] = ACTIONS(492),
    [anon_sym_GT_GT] = ACTIONS(492),
    [anon_sym_AMP_GT] = ACTIONS(492),
    [anon_sym_AMP_GT_GT] = ACTIONS(492),
    [anon_sym_LT_AMP] = ACTIONS(492),
    [anon_sym_GT_AMP] = ACTIONS(492),
    [anon_sym_LT_LT] = ACTIONS(314),
    [anon_sym_LT_LT_DASH] = ACTIONS(314),
    [anon_sym_LT_LT_LT] = ACTIONS(494),
    [sym__special_characters] = ACTIONS(496),
    [anon_sym_DQUOTE] = ACTIONS(498),
    [sym_raw_string] = ACTIONS(500),
    [anon_sym_DOLLAR] = ACTIONS(502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(504),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(506),
    [anon_sym_BQUOTE] = ACTIONS(508),
    [anon_sym_LT_LPAREN] = ACTIONS(510),
    [anon_sym_GT_LPAREN] = ACTIONS(510),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(500),
    [anon_sym_SEMI] = ACTIONS(310),
    [anon_sym_LF] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
  },
  [67] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(482),
    [anon_sym_RPAREN] = ACTIONS(484),
    [anon_sym_SEMI_SEMI] = ACTIONS(486),
    [anon_sym_PIPE_AMP] = ACTIONS(482),
    [anon_sym_AMP_AMP] = ACTIONS(488),
    [anon_sym_PIPE_PIPE] = ACTIONS(488),
    [anon_sym_LT] = ACTIONS(336),
    [anon_sym_GT] = ACTIONS(336),
    [anon_sym_GT_GT] = ACTIONS(336),
    [anon_sym_AMP_GT] = ACTIONS(336),
    [anon_sym_AMP_GT_GT] = ACTIONS(336),
    [anon_sym_LT_AMP] = ACTIONS(336),
    [anon_sym_GT_AMP] = ACTIONS(336),
    [sym__special_characters] = ACTIONS(336),
    [anon_sym_DQUOTE] = ACTIONS(336),
    [sym_raw_string] = ACTIONS(336),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(336),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(336),
    [anon_sym_BQUOTE] = ACTIONS(336),
    [anon_sym_LT_LPAREN] = ACTIONS(336),
    [anon_sym_GT_LPAREN] = ACTIONS(336),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(336),
    [anon_sym_SEMI] = ACTIONS(486),
    [anon_sym_LF] = ACTIONS(486),
    [anon_sym_AMP] = ACTIONS(486),
  },
  [68] = {
    [sym__assignment] = STATE(36),
    [anon_sym_EQ] = ACTIONS(438),
    [anon_sym_PLUS_EQ] = ACTIONS(438),
    [sym_comment] = ACTIONS(52),
  },
  [69] = {
    [sym__terminated_statement] = STATE(24),
    [sym_for_statement] = STATE(290),
    [sym_while_statement] = STATE(290),
    [sym_if_statement] = STATE(290),
    [sym_case_statement] = STATE(290),
    [sym_function_definition] = STATE(290),
    [sym_subshell] = STATE(290),
    [sym_pipeline] = STATE(290),
    [sym_list] = STATE(290),
    [sym_bracket_command] = STATE(290),
    [sym_command] = STATE(290),
    [sym_command_name] = STATE(66),
    [sym_variable_assignment] = STATE(291),
    [sym_declaration_command] = STATE(290),
    [sym_subscript] = STATE(68),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(58),
    [sym_simple_expansion] = STATE(58),
    [sym_expansion] = STATE(58),
    [sym_command_substitution] = STATE(58),
    [sym_process_substitution] = STATE(58),
    [aux_sym_program_repeat1] = STATE(292),
    [aux_sym_command_repeat1] = STATE(70),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(86),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(88),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(90),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(92),
    [anon_sym_typeset] = ACTIONS(92),
    [anon_sym_export] = ACTIONS(92),
    [anon_sym_readonly] = ACTIONS(92),
    [anon_sym_local] = ACTIONS(92),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(94),
    [anon_sym_DQUOTE] = ACTIONS(96),
    [sym_raw_string] = ACTIONS(98),
    [anon_sym_DOLLAR] = ACTIONS(100),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(102),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(104),
    [anon_sym_BQUOTE] = ACTIONS(106),
    [anon_sym_LT_LPAREN] = ACTIONS(108),
    [anon_sym_GT_LPAREN] = ACTIONS(108),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(110),
  },
  [70] = {
    [sym_command_name] = STATE(293),
    [sym_variable_assignment] = STATE(29),
    [sym_subscript] = STATE(192),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(58),
    [sym_simple_expansion] = STATE(58),
    [sym_expansion] = STATE(58),
    [sym_command_substitution] = STATE(58),
    [sym_process_substitution] = STATE(58),
    [aux_sym_command_repeat1] = STATE(193),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(342),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(512),
    [anon_sym_DQUOTE] = ACTIONS(96),
    [sym_raw_string] = ACTIONS(98),
    [anon_sym_DOLLAR] = ACTIONS(100),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(102),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(104),
    [anon_sym_BQUOTE] = ACTIONS(106),
    [anon_sym_LT_LPAREN] = ACTIONS(108),
    [anon_sym_GT_LPAREN] = ACTIONS(108),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(514),
  },
  [71] = {
    [aux_sym_concatenation_repeat1] = STATE(295),
    [sym__concat] = ACTIONS(516),
    [anon_sym_RBRACK] = ACTIONS(518),
    [sym__special_characters] = ACTIONS(520),
    [anon_sym_DQUOTE] = ACTIONS(522),
    [sym_raw_string] = ACTIONS(522),
    [anon_sym_DOLLAR] = ACTIONS(518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(522),
    [anon_sym_LT_LPAREN] = ACTIONS(522),
    [anon_sym_GT_LPAREN] = ACTIONS(522),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(518),
  },
  [72] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(297),
    [anon_sym_DQUOTE] = ACTIONS(524),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [73] = {
    [aux_sym_concatenation_repeat1] = STATE(295),
    [sym__concat] = ACTIONS(516),
    [anon_sym_RBRACK] = ACTIONS(526),
    [sym__special_characters] = ACTIONS(528),
    [anon_sym_DQUOTE] = ACTIONS(530),
    [sym_raw_string] = ACTIONS(530),
    [anon_sym_DOLLAR] = ACTIONS(526),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(530),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(530),
    [anon_sym_BQUOTE] = ACTIONS(530),
    [anon_sym_LT_LPAREN] = ACTIONS(530),
    [anon_sym_GT_LPAREN] = ACTIONS(530),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(526),
  },
  [74] = {
    [sym_string] = STATE(300),
    [anon_sym_DQUOTE] = ACTIONS(114),
    [anon_sym_DOLLAR] = ACTIONS(532),
    [anon_sym_POUND] = ACTIONS(532),
    [anon_sym_DASH] = ACTIONS(532),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(534),
    [anon_sym_STAR] = ACTIONS(532),
    [anon_sym_AT] = ACTIONS(532),
    [anon_sym_QMARK] = ACTIONS(532),
    [anon_sym_0] = ACTIONS(536),
    [anon_sym__] = ACTIONS(536),
  },
  [75] = {
    [sym_subscript] = STATE(305),
    [sym_variable_name] = ACTIONS(538),
    [anon_sym_DOLLAR] = ACTIONS(540),
    [anon_sym_POUND] = ACTIONS(542),
    [anon_sym_DASH] = ACTIONS(540),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(544),
    [anon_sym_STAR] = ACTIONS(540),
    [anon_sym_AT] = ACTIONS(540),
    [anon_sym_QMARK] = ACTIONS(540),
    [anon_sym_0] = ACTIONS(546),
    [anon_sym__] = ACTIONS(546),
  },
  [76] = {
    [sym_for_statement] = STATE(306),
    [sym_while_statement] = STATE(306),
    [sym_if_statement] = STATE(306),
    [sym_case_statement] = STATE(306),
    [sym_function_definition] = STATE(306),
    [sym_subshell] = STATE(306),
    [sym_pipeline] = STATE(306),
    [sym_list] = STATE(306),
    [sym_bracket_command] = STATE(306),
    [sym_command] = STATE(306),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(307),
    [sym_declaration_command] = STATE(306),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [77] = {
    [sym_for_statement] = STATE(308),
    [sym_while_statement] = STATE(308),
    [sym_if_statement] = STATE(308),
    [sym_case_statement] = STATE(308),
    [sym_function_definition] = STATE(308),
    [sym_subshell] = STATE(308),
    [sym_pipeline] = STATE(308),
    [sym_list] = STATE(308),
    [sym_bracket_command] = STATE(308),
    [sym_command] = STATE(308),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(309),
    [sym_declaration_command] = STATE(308),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [78] = {
    [sym_for_statement] = STATE(310),
    [sym_while_statement] = STATE(310),
    [sym_if_statement] = STATE(310),
    [sym_case_statement] = STATE(310),
    [sym_function_definition] = STATE(310),
    [sym_subshell] = STATE(310),
    [sym_pipeline] = STATE(310),
    [sym_list] = STATE(310),
    [sym_bracket_command] = STATE(310),
    [sym_command] = STATE(310),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(311),
    [sym_declaration_command] = STATE(310),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [79] = {
    [anon_sym_RBRACK] = ACTIONS(526),
    [sym__special_characters] = ACTIONS(528),
    [anon_sym_DQUOTE] = ACTIONS(530),
    [sym_raw_string] = ACTIONS(530),
    [anon_sym_DOLLAR] = ACTIONS(526),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(530),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(530),
    [anon_sym_BQUOTE] = ACTIONS(530),
    [anon_sym_LT_LPAREN] = ACTIONS(530),
    [anon_sym_GT_LPAREN] = ACTIONS(530),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(526),
  },
  [80] = {
    [sym_concatenation] = STATE(79),
    [sym_string] = STATE(73),
    [sym_simple_expansion] = STATE(73),
    [sym_expansion] = STATE(73),
    [sym_command_substitution] = STATE(73),
    [sym_process_substitution] = STATE(73),
    [aux_sym_for_statement_repeat1] = STATE(313),
    [anon_sym_RBRACK] = ACTIONS(548),
    [sym__special_characters] = ACTIONS(550),
    [anon_sym_DQUOTE] = ACTIONS(114),
    [sym_raw_string] = ACTIONS(116),
    [anon_sym_DOLLAR] = ACTIONS(118),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(120),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(122),
    [anon_sym_BQUOTE] = ACTIONS(124),
    [anon_sym_LT_LPAREN] = ACTIONS(126),
    [anon_sym_GT_LPAREN] = ACTIONS(126),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(128),
  },
  [81] = {
    [aux_sym_concatenation_repeat1] = STATE(315),
    [sym__concat] = ACTIONS(552),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(522),
    [sym__special_characters] = ACTIONS(520),
    [anon_sym_DQUOTE] = ACTIONS(522),
    [sym_raw_string] = ACTIONS(522),
    [anon_sym_DOLLAR] = ACTIONS(518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(522),
    [anon_sym_LT_LPAREN] = ACTIONS(522),
    [anon_sym_GT_LPAREN] = ACTIONS(522),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(518),
  },
  [82] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(317),
    [anon_sym_DQUOTE] = ACTIONS(554),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [83] = {
    [aux_sym_concatenation_repeat1] = STATE(315),
    [sym__concat] = ACTIONS(552),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(530),
    [sym__special_characters] = ACTIONS(528),
    [anon_sym_DQUOTE] = ACTIONS(530),
    [sym_raw_string] = ACTIONS(530),
    [anon_sym_DOLLAR] = ACTIONS(526),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(530),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(530),
    [anon_sym_BQUOTE] = ACTIONS(530),
    [anon_sym_LT_LPAREN] = ACTIONS(530),
    [anon_sym_GT_LPAREN] = ACTIONS(530),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(526),
  },
  [84] = {
    [sym_string] = STATE(320),
    [anon_sym_DQUOTE] = ACTIONS(132),
    [anon_sym_DOLLAR] = ACTIONS(556),
    [anon_sym_POUND] = ACTIONS(556),
    [anon_sym_DASH] = ACTIONS(556),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(558),
    [anon_sym_STAR] = ACTIONS(556),
    [anon_sym_AT] = ACTIONS(556),
    [anon_sym_QMARK] = ACTIONS(556),
    [anon_sym_0] = ACTIONS(560),
    [anon_sym__] = ACTIONS(560),
  },
  [85] = {
    [sym_subscript] = STATE(325),
    [sym_variable_name] = ACTIONS(562),
    [anon_sym_DOLLAR] = ACTIONS(564),
    [anon_sym_POUND] = ACTIONS(566),
    [anon_sym_DASH] = ACTIONS(564),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(568),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_AT] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(564),
    [anon_sym_0] = ACTIONS(570),
    [anon_sym__] = ACTIONS(570),
  },
  [86] = {
    [sym_for_statement] = STATE(326),
    [sym_while_statement] = STATE(326),
    [sym_if_statement] = STATE(326),
    [sym_case_statement] = STATE(326),
    [sym_function_definition] = STATE(326),
    [sym_subshell] = STATE(326),
    [sym_pipeline] = STATE(326),
    [sym_list] = STATE(326),
    [sym_bracket_command] = STATE(326),
    [sym_command] = STATE(326),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(327),
    [sym_declaration_command] = STATE(326),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [87] = {
    [sym_for_statement] = STATE(328),
    [sym_while_statement] = STATE(328),
    [sym_if_statement] = STATE(328),
    [sym_case_statement] = STATE(328),
    [sym_function_definition] = STATE(328),
    [sym_subshell] = STATE(328),
    [sym_pipeline] = STATE(328),
    [sym_list] = STATE(328),
    [sym_bracket_command] = STATE(328),
    [sym_command] = STATE(328),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(329),
    [sym_declaration_command] = STATE(328),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [88] = {
    [sym_for_statement] = STATE(330),
    [sym_while_statement] = STATE(330),
    [sym_if_statement] = STATE(330),
    [sym_case_statement] = STATE(330),
    [sym_function_definition] = STATE(330),
    [sym_subshell] = STATE(330),
    [sym_pipeline] = STATE(330),
    [sym_list] = STATE(330),
    [sym_bracket_command] = STATE(330),
    [sym_command] = STATE(330),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(331),
    [sym_declaration_command] = STATE(330),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [89] = {
    [anon_sym_RBRACK_RBRACK] = ACTIONS(530),
    [sym__special_characters] = ACTIONS(528),
    [anon_sym_DQUOTE] = ACTIONS(530),
    [sym_raw_string] = ACTIONS(530),
    [anon_sym_DOLLAR] = ACTIONS(526),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(530),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(530),
    [anon_sym_BQUOTE] = ACTIONS(530),
    [anon_sym_LT_LPAREN] = ACTIONS(530),
    [anon_sym_GT_LPAREN] = ACTIONS(530),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(526),
  },
  [90] = {
    [sym_concatenation] = STATE(89),
    [sym_string] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [sym_expansion] = STATE(83),
    [sym_command_substitution] = STATE(83),
    [sym_process_substitution] = STATE(83),
    [aux_sym_for_statement_repeat1] = STATE(332),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(572),
    [sym__special_characters] = ACTIONS(574),
    [anon_sym_DQUOTE] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(134),
    [anon_sym_DOLLAR] = ACTIONS(136),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(138),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(140),
    [anon_sym_BQUOTE] = ACTIONS(142),
    [anon_sym_LT_LPAREN] = ACTIONS(144),
    [anon_sym_GT_LPAREN] = ACTIONS(144),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(146),
  },
  [91] = {
    [sym__assignment] = STATE(334),
    [anon_sym_LBRACK] = ACTIONS(60),
    [anon_sym_EQ] = ACTIONS(576),
    [anon_sym_PLUS_EQ] = ACTIONS(576),
    [sym_comment] = ACTIONS(52),
  },
  [92] = {
    [aux_sym_concatenation_repeat1] = STATE(336),
    [sym__concat] = ACTIONS(578),
    [sym_variable_name] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_SEMI_SEMI] = ACTIONS(582),
    [anon_sym_PIPE_AMP] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [sym__special_characters] = ACTIONS(582),
    [anon_sym_DQUOTE] = ACTIONS(582),
    [sym_raw_string] = ACTIONS(582),
    [anon_sym_DOLLAR] = ACTIONS(582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(582),
    [anon_sym_BQUOTE] = ACTIONS(582),
    [anon_sym_LT_LPAREN] = ACTIONS(582),
    [anon_sym_GT_LPAREN] = ACTIONS(582),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(582),
    [sym_word] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(582),
    [anon_sym_LF] = ACTIONS(582),
    [anon_sym_AMP] = ACTIONS(582),
  },
  [93] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(338),
    [anon_sym_DQUOTE] = ACTIONS(584),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [94] = {
    [aux_sym_concatenation_repeat1] = STATE(336),
    [sym__concat] = ACTIONS(578),
    [sym_variable_name] = ACTIONS(586),
    [anon_sym_PIPE] = ACTIONS(588),
    [anon_sym_SEMI_SEMI] = ACTIONS(588),
    [anon_sym_PIPE_AMP] = ACTIONS(588),
    [anon_sym_AMP_AMP] = ACTIONS(588),
    [anon_sym_PIPE_PIPE] = ACTIONS(588),
    [sym__special_characters] = ACTIONS(588),
    [anon_sym_DQUOTE] = ACTIONS(588),
    [sym_raw_string] = ACTIONS(588),
    [anon_sym_DOLLAR] = ACTIONS(588),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(588),
    [anon_sym_BQUOTE] = ACTIONS(588),
    [anon_sym_LT_LPAREN] = ACTIONS(588),
    [anon_sym_GT_LPAREN] = ACTIONS(588),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(588),
    [sym_word] = ACTIONS(588),
    [anon_sym_SEMI] = ACTIONS(588),
    [anon_sym_LF] = ACTIONS(588),
    [anon_sym_AMP] = ACTIONS(588),
  },
  [95] = {
    [sym_string] = STATE(341),
    [anon_sym_DQUOTE] = ACTIONS(590),
    [anon_sym_DOLLAR] = ACTIONS(592),
    [anon_sym_POUND] = ACTIONS(592),
    [anon_sym_DASH] = ACTIONS(592),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(594),
    [anon_sym_STAR] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_0] = ACTIONS(596),
    [anon_sym__] = ACTIONS(596),
  },
  [96] = {
    [sym_subscript] = STATE(346),
    [sym_variable_name] = ACTIONS(598),
    [anon_sym_DOLLAR] = ACTIONS(600),
    [anon_sym_POUND] = ACTIONS(602),
    [anon_sym_DASH] = ACTIONS(600),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(604),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_AT] = ACTIONS(600),
    [anon_sym_QMARK] = ACTIONS(600),
    [anon_sym_0] = ACTIONS(606),
    [anon_sym__] = ACTIONS(606),
  },
  [97] = {
    [sym_for_statement] = STATE(347),
    [sym_while_statement] = STATE(347),
    [sym_if_statement] = STATE(347),
    [sym_case_statement] = STATE(347),
    [sym_function_definition] = STATE(347),
    [sym_subshell] = STATE(347),
    [sym_pipeline] = STATE(347),
    [sym_list] = STATE(347),
    [sym_bracket_command] = STATE(347),
    [sym_command] = STATE(347),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(348),
    [sym_declaration_command] = STATE(347),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [98] = {
    [sym_for_statement] = STATE(349),
    [sym_while_statement] = STATE(349),
    [sym_if_statement] = STATE(349),
    [sym_case_statement] = STATE(349),
    [sym_function_definition] = STATE(349),
    [sym_subshell] = STATE(349),
    [sym_pipeline] = STATE(349),
    [sym_list] = STATE(349),
    [sym_bracket_command] = STATE(349),
    [sym_command] = STATE(349),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(350),
    [sym_declaration_command] = STATE(349),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [99] = {
    [sym_for_statement] = STATE(351),
    [sym_while_statement] = STATE(351),
    [sym_if_statement] = STATE(351),
    [sym_case_statement] = STATE(351),
    [sym_function_definition] = STATE(351),
    [sym_subshell] = STATE(351),
    [sym_pipeline] = STATE(351),
    [sym_list] = STATE(351),
    [sym_bracket_command] = STATE(351),
    [sym_command] = STATE(351),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(352),
    [sym_declaration_command] = STATE(351),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [100] = {
    [sym_variable_name] = ACTIONS(608),
    [anon_sym_PIPE] = ACTIONS(610),
    [anon_sym_RPAREN] = ACTIONS(610),
    [anon_sym_SEMI_SEMI] = ACTIONS(610),
    [anon_sym_PIPE_AMP] = ACTIONS(610),
    [anon_sym_AMP_AMP] = ACTIONS(610),
    [anon_sym_PIPE_PIPE] = ACTIONS(610),
    [sym__special_characters] = ACTIONS(610),
    [anon_sym_DQUOTE] = ACTIONS(610),
    [sym_raw_string] = ACTIONS(610),
    [anon_sym_DOLLAR] = ACTIONS(610),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(610),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(610),
    [anon_sym_BQUOTE] = ACTIONS(610),
    [anon_sym_LT_LPAREN] = ACTIONS(610),
    [anon_sym_GT_LPAREN] = ACTIONS(610),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(610),
    [sym_word] = ACTIONS(610),
    [anon_sym_SEMI] = ACTIONS(610),
    [anon_sym_LF] = ACTIONS(610),
    [anon_sym_AMP] = ACTIONS(610),
  },
  [101] = {
    [sym_variable_name] = ACTIONS(586),
    [anon_sym_PIPE] = ACTIONS(588),
    [anon_sym_RPAREN] = ACTIONS(588),
    [anon_sym_SEMI_SEMI] = ACTIONS(588),
    [anon_sym_PIPE_AMP] = ACTIONS(588),
    [anon_sym_AMP_AMP] = ACTIONS(588),
    [anon_sym_PIPE_PIPE] = ACTIONS(588),
    [sym__special_characters] = ACTIONS(588),
    [anon_sym_DQUOTE] = ACTIONS(588),
    [sym_raw_string] = ACTIONS(588),
    [anon_sym_DOLLAR] = ACTIONS(588),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(588),
    [anon_sym_BQUOTE] = ACTIONS(588),
    [anon_sym_LT_LPAREN] = ACTIONS(588),
    [anon_sym_GT_LPAREN] = ACTIONS(588),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(588),
    [sym_word] = ACTIONS(588),
    [anon_sym_SEMI] = ACTIONS(588),
    [anon_sym_LF] = ACTIONS(588),
    [anon_sym_AMP] = ACTIONS(588),
  },
  [102] = {
    [sym__assignment] = STATE(334),
    [anon_sym_EQ] = ACTIONS(576),
    [anon_sym_PLUS_EQ] = ACTIONS(576),
    [sym_comment] = ACTIONS(52),
  },
  [103] = {
    [sym_variable_assignment] = STATE(101),
    [sym_subscript] = STATE(102),
    [sym_concatenation] = STATE(101),
    [sym_string] = STATE(94),
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [sym_process_substitution] = STATE(94),
    [aux_sym_declaration_command_repeat1] = STATE(353),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_PIPE] = ACTIONS(612),
    [anon_sym_SEMI_SEMI] = ACTIONS(612),
    [anon_sym_PIPE_AMP] = ACTIONS(612),
    [anon_sym_AMP_AMP] = ACTIONS(612),
    [anon_sym_PIPE_PIPE] = ACTIONS(612),
    [sym__special_characters] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(154),
    [sym_raw_string] = ACTIONS(156),
    [anon_sym_DOLLAR] = ACTIONS(158),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(160),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(162),
    [anon_sym_BQUOTE] = ACTIONS(164),
    [anon_sym_LT_LPAREN] = ACTIONS(166),
    [anon_sym_GT_LPAREN] = ACTIONS(166),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(170),
    [sym_word] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(612),
    [anon_sym_LF] = ACTIONS(612),
    [anon_sym_AMP] = ACTIONS(612),
  },
  [104] = {
    [aux_sym_concatenation_repeat1] = STATE(355),
    [sym_file_descriptor] = ACTIONS(614),
    [sym__concat] = ACTIONS(616),
    [sym_variable_name] = ACTIONS(614),
    [anon_sym_LT] = ACTIONS(618),
    [anon_sym_GT] = ACTIONS(618),
    [anon_sym_GT_GT] = ACTIONS(614),
    [anon_sym_AMP_GT] = ACTIONS(618),
    [anon_sym_AMP_GT_GT] = ACTIONS(614),
    [anon_sym_LT_AMP] = ACTIONS(614),
    [anon_sym_GT_AMP] = ACTIONS(614),
    [sym__special_characters] = ACTIONS(618),
    [anon_sym_DQUOTE] = ACTIONS(614),
    [sym_raw_string] = ACTIONS(614),
    [anon_sym_DOLLAR] = ACTIONS(618),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(614),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(614),
    [anon_sym_BQUOTE] = ACTIONS(614),
    [anon_sym_LT_LPAREN] = ACTIONS(614),
    [anon_sym_GT_LPAREN] = ACTIONS(614),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(618),
  },
  [105] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(357),
    [anon_sym_DQUOTE] = ACTIONS(620),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [106] = {
    [aux_sym_concatenation_repeat1] = STATE(355),
    [sym_file_descriptor] = ACTIONS(622),
    [sym__concat] = ACTIONS(616),
    [sym_variable_name] = ACTIONS(622),
    [anon_sym_LT] = ACTIONS(624),
    [anon_sym_GT] = ACTIONS(624),
    [anon_sym_GT_GT] = ACTIONS(622),
    [anon_sym_AMP_GT] = ACTIONS(624),
    [anon_sym_AMP_GT_GT] = ACTIONS(622),
    [anon_sym_LT_AMP] = ACTIONS(622),
    [anon_sym_GT_AMP] = ACTIONS(622),
    [sym__special_characters] = ACTIONS(624),
    [anon_sym_DQUOTE] = ACTIONS(622),
    [sym_raw_string] = ACTIONS(622),
    [anon_sym_DOLLAR] = ACTIONS(624),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(622),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(622),
    [anon_sym_BQUOTE] = ACTIONS(622),
    [anon_sym_LT_LPAREN] = ACTIONS(622),
    [anon_sym_GT_LPAREN] = ACTIONS(622),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(624),
  },
  [107] = {
    [sym_string] = STATE(360),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_DOLLAR] = ACTIONS(626),
    [anon_sym_POUND] = ACTIONS(626),
    [anon_sym_DASH] = ACTIONS(626),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(628),
    [anon_sym_STAR] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(626),
    [anon_sym_QMARK] = ACTIONS(626),
    [anon_sym_0] = ACTIONS(630),
    [anon_sym__] = ACTIONS(630),
  },
  [108] = {
    [sym_subscript] = STATE(365),
    [sym_variable_name] = ACTIONS(632),
    [anon_sym_DOLLAR] = ACTIONS(634),
    [anon_sym_POUND] = ACTIONS(636),
    [anon_sym_DASH] = ACTIONS(634),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(638),
    [anon_sym_STAR] = ACTIONS(634),
    [anon_sym_AT] = ACTIONS(634),
    [anon_sym_QMARK] = ACTIONS(634),
    [anon_sym_0] = ACTIONS(640),
    [anon_sym__] = ACTIONS(640),
  },
  [109] = {
    [sym_for_statement] = STATE(366),
    [sym_while_statement] = STATE(366),
    [sym_if_statement] = STATE(366),
    [sym_case_statement] = STATE(366),
    [sym_function_definition] = STATE(366),
    [sym_subshell] = STATE(366),
    [sym_pipeline] = STATE(366),
    [sym_list] = STATE(366),
    [sym_bracket_command] = STATE(366),
    [sym_command] = STATE(366),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(367),
    [sym_declaration_command] = STATE(366),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [110] = {
    [sym_for_statement] = STATE(368),
    [sym_while_statement] = STATE(368),
    [sym_if_statement] = STATE(368),
    [sym_case_statement] = STATE(368),
    [sym_function_definition] = STATE(368),
    [sym_subshell] = STATE(368),
    [sym_pipeline] = STATE(368),
    [sym_list] = STATE(368),
    [sym_bracket_command] = STATE(368),
    [sym_command] = STATE(368),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(369),
    [sym_declaration_command] = STATE(368),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [111] = {
    [sym_for_statement] = STATE(370),
    [sym_while_statement] = STATE(370),
    [sym_if_statement] = STATE(370),
    [sym_case_statement] = STATE(370),
    [sym_function_definition] = STATE(370),
    [sym_subshell] = STATE(370),
    [sym_pipeline] = STATE(370),
    [sym_list] = STATE(370),
    [sym_bracket_command] = STATE(370),
    [sym_command] = STATE(370),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(371),
    [sym_declaration_command] = STATE(370),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [112] = {
    [sym_file_descriptor] = ACTIONS(622),
    [sym_variable_name] = ACTIONS(622),
    [anon_sym_LT] = ACTIONS(624),
    [anon_sym_GT] = ACTIONS(624),
    [anon_sym_GT_GT] = ACTIONS(622),
    [anon_sym_AMP_GT] = ACTIONS(624),
    [anon_sym_AMP_GT_GT] = ACTIONS(622),
    [anon_sym_LT_AMP] = ACTIONS(622),
    [anon_sym_GT_AMP] = ACTIONS(622),
    [sym__special_characters] = ACTIONS(624),
    [anon_sym_DQUOTE] = ACTIONS(622),
    [sym_raw_string] = ACTIONS(622),
    [anon_sym_DOLLAR] = ACTIONS(624),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(622),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(622),
    [anon_sym_BQUOTE] = ACTIONS(622),
    [anon_sym_LT_LPAREN] = ACTIONS(622),
    [anon_sym_GT_LPAREN] = ACTIONS(622),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(624),
  },
  [113] = {
    [sym_string] = STATE(372),
    [sym_simple_expansion] = STATE(372),
    [sym_expansion] = STATE(372),
    [sym_command_substitution] = STATE(372),
    [sym_process_substitution] = STATE(372),
    [sym__special_characters] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(644),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(642),
  },
  [114] = {
    [aux_sym_concatenation_repeat1] = STATE(373),
    [sym_file_descriptor] = ACTIONS(646),
    [sym__concat] = ACTIONS(192),
    [anon_sym_PIPE] = ACTIONS(648),
    [anon_sym_SEMI_SEMI] = ACTIONS(648),
    [anon_sym_PIPE_AMP] = ACTIONS(648),
    [anon_sym_AMP_AMP] = ACTIONS(648),
    [anon_sym_PIPE_PIPE] = ACTIONS(648),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(648),
    [anon_sym_GT_GT] = ACTIONS(648),
    [anon_sym_AMP_GT] = ACTIONS(648),
    [anon_sym_AMP_GT_GT] = ACTIONS(648),
    [anon_sym_LT_AMP] = ACTIONS(648),
    [anon_sym_GT_AMP] = ACTIONS(648),
    [anon_sym_LT_LT] = ACTIONS(648),
    [anon_sym_LT_LT_DASH] = ACTIONS(648),
    [anon_sym_LT_LT_LT] = ACTIONS(648),
    [sym__special_characters] = ACTIONS(648),
    [anon_sym_DQUOTE] = ACTIONS(648),
    [sym_raw_string] = ACTIONS(648),
    [anon_sym_DOLLAR] = ACTIONS(648),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(648),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(648),
    [anon_sym_BQUOTE] = ACTIONS(648),
    [anon_sym_LT_LPAREN] = ACTIONS(648),
    [anon_sym_GT_LPAREN] = ACTIONS(648),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(648),
    [anon_sym_SEMI] = ACTIONS(648),
    [anon_sym_LF] = ACTIONS(648),
    [anon_sym_AMP] = ACTIONS(648),
  },
  [115] = {
    [sym_file_descriptor] = ACTIONS(650),
    [sym__concat] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(652),
    [anon_sym_SEMI_SEMI] = ACTIONS(652),
    [anon_sym_PIPE_AMP] = ACTIONS(652),
    [anon_sym_AMP_AMP] = ACTIONS(652),
    [anon_sym_PIPE_PIPE] = ACTIONS(652),
    [anon_sym_LT] = ACTIONS(652),
    [anon_sym_GT] = ACTIONS(652),
    [anon_sym_GT_GT] = ACTIONS(652),
    [anon_sym_AMP_GT] = ACTIONS(652),
    [anon_sym_AMP_GT_GT] = ACTIONS(652),
    [anon_sym_LT_AMP] = ACTIONS(652),
    [anon_sym_GT_AMP] = ACTIONS(652),
    [anon_sym_LT_LT] = ACTIONS(652),
    [anon_sym_LT_LT_DASH] = ACTIONS(652),
    [anon_sym_LT_LT_LT] = ACTIONS(652),
    [sym__special_characters] = ACTIONS(652),
    [anon_sym_DQUOTE] = ACTIONS(652),
    [sym_raw_string] = ACTIONS(652),
    [anon_sym_DOLLAR] = ACTIONS(652),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(652),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(652),
    [anon_sym_BQUOTE] = ACTIONS(652),
    [anon_sym_LT_LPAREN] = ACTIONS(652),
    [anon_sym_GT_LPAREN] = ACTIONS(652),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(652),
    [anon_sym_SEMI] = ACTIONS(652),
    [anon_sym_LF] = ACTIONS(652),
    [anon_sym_AMP] = ACTIONS(652),
  },
  [116] = {
    [sym__concat] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [sym__string_content] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(656),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(656),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(656),
    [anon_sym_BQUOTE] = ACTIONS(656),
    [sym_comment] = ACTIONS(168),
  },
  [117] = {
    [sym_string] = STATE(378),
    [anon_sym_DQUOTE] = ACTIONS(660),
    [anon_sym_DOLLAR] = ACTIONS(662),
    [anon_sym_POUND] = ACTIONS(662),
    [anon_sym_DASH] = ACTIONS(662),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(664),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_AT] = ACTIONS(662),
    [anon_sym_QMARK] = ACTIONS(662),
    [anon_sym_0] = ACTIONS(666),
    [anon_sym__] = ACTIONS(666),
  },
  [118] = {
    [sym_subscript] = STATE(383),
    [sym_variable_name] = ACTIONS(668),
    [anon_sym_DOLLAR] = ACTIONS(670),
    [anon_sym_POUND] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(670),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(674),
    [anon_sym_STAR] = ACTIONS(670),
    [anon_sym_AT] = ACTIONS(670),
    [anon_sym_QMARK] = ACTIONS(670),
    [anon_sym_0] = ACTIONS(676),
    [anon_sym__] = ACTIONS(676),
  },
  [119] = {
    [sym_for_statement] = STATE(384),
    [sym_while_statement] = STATE(384),
    [sym_if_statement] = STATE(384),
    [sym_case_statement] = STATE(384),
    [sym_function_definition] = STATE(384),
    [sym_subshell] = STATE(384),
    [sym_pipeline] = STATE(384),
    [sym_list] = STATE(384),
    [sym_bracket_command] = STATE(384),
    [sym_command] = STATE(384),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(385),
    [sym_declaration_command] = STATE(384),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [120] = {
    [sym_for_statement] = STATE(386),
    [sym_while_statement] = STATE(386),
    [sym_if_statement] = STATE(386),
    [sym_case_statement] = STATE(386),
    [sym_function_definition] = STATE(386),
    [sym_subshell] = STATE(386),
    [sym_pipeline] = STATE(386),
    [sym_list] = STATE(386),
    [sym_bracket_command] = STATE(386),
    [sym_command] = STATE(386),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(387),
    [sym_declaration_command] = STATE(386),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [121] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(678),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [122] = {
    [sym_file_descriptor] = ACTIONS(680),
    [sym__concat] = ACTIONS(680),
    [anon_sym_PIPE] = ACTIONS(682),
    [anon_sym_SEMI_SEMI] = ACTIONS(682),
    [anon_sym_PIPE_AMP] = ACTIONS(682),
    [anon_sym_AMP_AMP] = ACTIONS(682),
    [anon_sym_PIPE_PIPE] = ACTIONS(682),
    [anon_sym_LT] = ACTIONS(682),
    [anon_sym_GT] = ACTIONS(682),
    [anon_sym_GT_GT] = ACTIONS(682),
    [anon_sym_AMP_GT] = ACTIONS(682),
    [anon_sym_AMP_GT_GT] = ACTIONS(682),
    [anon_sym_LT_AMP] = ACTIONS(682),
    [anon_sym_GT_AMP] = ACTIONS(682),
    [anon_sym_LT_LT] = ACTIONS(682),
    [anon_sym_LT_LT_DASH] = ACTIONS(682),
    [anon_sym_LT_LT_LT] = ACTIONS(682),
    [sym__special_characters] = ACTIONS(682),
    [anon_sym_DQUOTE] = ACTIONS(682),
    [sym_raw_string] = ACTIONS(682),
    [anon_sym_DOLLAR] = ACTIONS(682),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(682),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(682),
    [anon_sym_BQUOTE] = ACTIONS(682),
    [anon_sym_LT_LPAREN] = ACTIONS(682),
    [anon_sym_GT_LPAREN] = ACTIONS(682),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(682),
    [anon_sym_SEMI] = ACTIONS(682),
    [anon_sym_LF] = ACTIONS(682),
    [anon_sym_AMP] = ACTIONS(682),
  },
  [123] = {
    [sym_file_descriptor] = ACTIONS(684),
    [sym__concat] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(686),
    [anon_sym_SEMI_SEMI] = ACTIONS(686),
    [anon_sym_PIPE_AMP] = ACTIONS(686),
    [anon_sym_AMP_AMP] = ACTIONS(686),
    [anon_sym_PIPE_PIPE] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(686),
    [anon_sym_GT] = ACTIONS(686),
    [anon_sym_GT_GT] = ACTIONS(686),
    [anon_sym_AMP_GT] = ACTIONS(686),
    [anon_sym_AMP_GT_GT] = ACTIONS(686),
    [anon_sym_LT_AMP] = ACTIONS(686),
    [anon_sym_GT_AMP] = ACTIONS(686),
    [anon_sym_LT_LT] = ACTIONS(686),
    [anon_sym_LT_LT_DASH] = ACTIONS(686),
    [anon_sym_LT_LT_LT] = ACTIONS(686),
    [sym__special_characters] = ACTIONS(686),
    [anon_sym_DQUOTE] = ACTIONS(686),
    [sym_raw_string] = ACTIONS(686),
    [anon_sym_DOLLAR] = ACTIONS(686),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(686),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(686),
    [anon_sym_BQUOTE] = ACTIONS(686),
    [anon_sym_LT_LPAREN] = ACTIONS(686),
    [anon_sym_GT_LPAREN] = ACTIONS(686),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(686),
    [anon_sym_SEMI] = ACTIONS(686),
    [anon_sym_LF] = ACTIONS(686),
    [anon_sym_AMP] = ACTIONS(686),
  },
  [124] = {
    [sym_file_descriptor] = ACTIONS(688),
    [sym__concat] = ACTIONS(688),
    [anon_sym_PIPE] = ACTIONS(690),
    [anon_sym_SEMI_SEMI] = ACTIONS(690),
    [anon_sym_PIPE_AMP] = ACTIONS(690),
    [anon_sym_AMP_AMP] = ACTIONS(690),
    [anon_sym_PIPE_PIPE] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(690),
    [anon_sym_GT] = ACTIONS(690),
    [anon_sym_GT_GT] = ACTIONS(690),
    [anon_sym_AMP_GT] = ACTIONS(690),
    [anon_sym_AMP_GT_GT] = ACTIONS(690),
    [anon_sym_LT_AMP] = ACTIONS(690),
    [anon_sym_GT_AMP] = ACTIONS(690),
    [anon_sym_LT_LT] = ACTIONS(690),
    [anon_sym_LT_LT_DASH] = ACTIONS(690),
    [anon_sym_LT_LT_LT] = ACTIONS(690),
    [sym__special_characters] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(690),
    [sym_raw_string] = ACTIONS(690),
    [anon_sym_DOLLAR] = ACTIONS(690),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(690),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(690),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [anon_sym_LT_LPAREN] = ACTIONS(690),
    [anon_sym_GT_LPAREN] = ACTIONS(690),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(690),
    [anon_sym_SEMI] = ACTIONS(690),
    [anon_sym_LF] = ACTIONS(690),
    [anon_sym_AMP] = ACTIONS(690),
  },
  [125] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(694),
    [sym_comment] = ACTIONS(52),
  },
  [126] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(402),
    [anon_sym_RBRACE] = ACTIONS(696),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [127] = {
    [sym_subscript] = STATE(406),
    [sym_variable_name] = ACTIONS(720),
    [anon_sym_DOLLAR] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(724),
    [anon_sym_STAR] = ACTIONS(722),
    [anon_sym_AT] = ACTIONS(722),
    [anon_sym_QMARK] = ACTIONS(722),
    [anon_sym_0] = ACTIONS(726),
    [anon_sym__] = ACTIONS(726),
  },
  [128] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(408),
    [anon_sym_RBRACE] = ACTIONS(728),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [129] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(410),
    [anon_sym_RBRACE] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [130] = {
    [sym__assignment] = STATE(412),
    [anon_sym_LBRACK] = ACTIONS(60),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_PLUS_EQ] = ACTIONS(732),
    [sym_comment] = ACTIONS(52),
  },
  [131] = {
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(734),
  },
  [132] = {
    [sym__terminated_statement] = STATE(414),
    [sym_for_statement] = STATE(39),
    [sym_while_statement] = STATE(39),
    [sym_if_statement] = STATE(39),
    [sym_case_statement] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_subshell] = STATE(39),
    [sym_pipeline] = STATE(39),
    [sym_list] = STATE(39),
    [sym_bracket_command] = STATE(39),
    [sym_command] = STATE(39),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(40),
    [sym_declaration_command] = STATE(39),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [133] = {
    [sym__terminated_statement] = STATE(415),
    [sym_for_statement] = STATE(39),
    [sym_while_statement] = STATE(39),
    [sym_if_statement] = STATE(39),
    [sym_case_statement] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_subshell] = STATE(39),
    [sym_pipeline] = STATE(39),
    [sym_list] = STATE(39),
    [sym_bracket_command] = STATE(39),
    [sym_command] = STATE(39),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(40),
    [sym_declaration_command] = STATE(39),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [134] = {
    [sym_concatenation] = STATE(418),
    [sym_string] = STATE(417),
    [sym_simple_expansion] = STATE(417),
    [sym_expansion] = STATE(417),
    [sym_command_substitution] = STATE(417),
    [sym_process_substitution] = STATE(417),
    [sym__special_characters] = ACTIONS(736),
    [anon_sym_DQUOTE] = ACTIONS(68),
    [sym_raw_string] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(72),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(74),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(76),
    [anon_sym_BQUOTE] = ACTIONS(78),
    [anon_sym_LT_LPAREN] = ACTIONS(80),
    [anon_sym_GT_LPAREN] = ACTIONS(80),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(740),
  },
  [135] = {
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(742),
  },
  [136] = {
    [sym__terminated_statement] = STATE(24),
    [sym_for_statement] = STATE(420),
    [sym_while_statement] = STATE(420),
    [sym_if_statement] = STATE(420),
    [sym_case_statement] = STATE(420),
    [sym_function_definition] = STATE(420),
    [sym_subshell] = STATE(420),
    [sym_pipeline] = STATE(420),
    [sym_list] = STATE(420),
    [sym_bracket_command] = STATE(420),
    [sym_command] = STATE(420),
    [sym_command_name] = STATE(66),
    [sym_variable_assignment] = STATE(421),
    [sym_declaration_command] = STATE(420),
    [sym_subscript] = STATE(68),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(58),
    [sym_simple_expansion] = STATE(58),
    [sym_expansion] = STATE(58),
    [sym_command_substitution] = STATE(58),
    [sym_process_substitution] = STATE(58),
    [aux_sym_program_repeat1] = STATE(422),
    [aux_sym_command_repeat1] = STATE(70),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(86),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(88),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(90),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(92),
    [anon_sym_typeset] = ACTIONS(92),
    [anon_sym_export] = ACTIONS(92),
    [anon_sym_readonly] = ACTIONS(92),
    [anon_sym_local] = ACTIONS(92),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(94),
    [anon_sym_DQUOTE] = ACTIONS(96),
    [sym_raw_string] = ACTIONS(98),
    [anon_sym_DOLLAR] = ACTIONS(100),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(102),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(104),
    [anon_sym_BQUOTE] = ACTIONS(106),
    [anon_sym_LT_LPAREN] = ACTIONS(108),
    [anon_sym_GT_LPAREN] = ACTIONS(108),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(110),
  },
  [137] = {
    [sym_concatenation] = STATE(79),
    [sym_string] = STATE(73),
    [sym_simple_expansion] = STATE(73),
    [sym_expansion] = STATE(73),
    [sym_command_substitution] = STATE(73),
    [sym_process_substitution] = STATE(73),
    [aux_sym_for_statement_repeat1] = STATE(423),
    [sym__special_characters] = ACTIONS(112),
    [anon_sym_DQUOTE] = ACTIONS(114),
    [sym_raw_string] = ACTIONS(116),
    [anon_sym_DOLLAR] = ACTIONS(118),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(120),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(122),
    [anon_sym_BQUOTE] = ACTIONS(124),
    [anon_sym_LT_LPAREN] = ACTIONS(126),
    [anon_sym_GT_LPAREN] = ACTIONS(126),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(128),
  },
  [138] = {
    [sym_concatenation] = STATE(89),
    [sym_string] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [sym_expansion] = STATE(83),
    [sym_command_substitution] = STATE(83),
    [sym_process_substitution] = STATE(83),
    [aux_sym_for_statement_repeat1] = STATE(424),
    [sym__special_characters] = ACTIONS(130),
    [anon_sym_DQUOTE] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(134),
    [anon_sym_DOLLAR] = ACTIONS(136),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(138),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(140),
    [anon_sym_BQUOTE] = ACTIONS(142),
    [anon_sym_LT_LPAREN] = ACTIONS(144),
    [anon_sym_GT_LPAREN] = ACTIONS(144),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(146),
  },
  [139] = {
    [sym_variable_assignment] = STATE(435),
    [sym_subscript] = STATE(436),
    [sym_concatenation] = STATE(435),
    [sym_string] = STATE(428),
    [sym_simple_expansion] = STATE(428),
    [sym_expansion] = STATE(428),
    [sym_command_substitution] = STATE(428),
    [sym_process_substitution] = STATE(428),
    [aux_sym_declaration_command_repeat1] = STATE(437),
    [sym_variable_name] = ACTIONS(744),
    [anon_sym_PIPE] = ACTIONS(746),
    [anon_sym_RPAREN] = ACTIONS(748),
    [anon_sym_PIPE_AMP] = ACTIONS(748),
    [anon_sym_AMP_AMP] = ACTIONS(748),
    [anon_sym_PIPE_PIPE] = ACTIONS(748),
    [sym__special_characters] = ACTIONS(750),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [sym_raw_string] = ACTIONS(754),
    [anon_sym_DOLLAR] = ACTIONS(756),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(758),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(766),
    [sym_word] = ACTIONS(768),
  },
  [140] = {
    [aux_sym_concatenation_repeat1] = STATE(439),
    [sym_file_descriptor] = ACTIONS(190),
    [sym__concat] = ACTIONS(770),
    [anon_sym_PIPE] = ACTIONS(772),
    [anon_sym_RPAREN] = ACTIONS(190),
    [anon_sym_PIPE_AMP] = ACTIONS(190),
    [anon_sym_AMP_AMP] = ACTIONS(190),
    [anon_sym_PIPE_PIPE] = ACTIONS(190),
    [anon_sym_LT] = ACTIONS(772),
    [anon_sym_GT] = ACTIONS(772),
    [anon_sym_GT_GT] = ACTIONS(190),
    [anon_sym_AMP_GT] = ACTIONS(772),
    [anon_sym_AMP_GT_GT] = ACTIONS(190),
    [anon_sym_LT_AMP] = ACTIONS(190),
    [anon_sym_GT_AMP] = ACTIONS(190),
    [anon_sym_LT_LT] = ACTIONS(772),
    [anon_sym_LT_LT_DASH] = ACTIONS(190),
    [anon_sym_LT_LT_LT] = ACTIONS(190),
    [sym__special_characters] = ACTIONS(772),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(190),
    [anon_sym_DOLLAR] = ACTIONS(772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(190),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(190),
    [anon_sym_BQUOTE] = ACTIONS(190),
    [anon_sym_LT_LPAREN] = ACTIONS(190),
    [anon_sym_GT_LPAREN] = ACTIONS(190),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(772),
  },
  [141] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(441),
    [anon_sym_DQUOTE] = ACTIONS(774),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [142] = {
    [aux_sym_concatenation_repeat1] = STATE(439),
    [sym_file_descriptor] = ACTIONS(208),
    [sym__concat] = ACTIONS(770),
    [anon_sym_PIPE] = ACTIONS(776),
    [anon_sym_RPAREN] = ACTIONS(208),
    [anon_sym_PIPE_AMP] = ACTIONS(208),
    [anon_sym_AMP_AMP] = ACTIONS(208),
    [anon_sym_PIPE_PIPE] = ACTIONS(208),
    [anon_sym_LT] = ACTIONS(776),
    [anon_sym_GT] = ACTIONS(776),
    [anon_sym_GT_GT] = ACTIONS(208),
    [anon_sym_AMP_GT] = ACTIONS(776),
    [anon_sym_AMP_GT_GT] = ACTIONS(208),
    [anon_sym_LT_AMP] = ACTIONS(208),
    [anon_sym_GT_AMP] = ACTIONS(208),
    [anon_sym_LT_LT] = ACTIONS(776),
    [anon_sym_LT_LT_DASH] = ACTIONS(208),
    [anon_sym_LT_LT_LT] = ACTIONS(208),
    [sym__special_characters] = ACTIONS(776),
    [anon_sym_DQUOTE] = ACTIONS(208),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(776),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(208),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(208),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(208),
    [anon_sym_GT_LPAREN] = ACTIONS(208),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(776),
  },
  [143] = {
    [sym_string] = STATE(444),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [anon_sym_DOLLAR] = ACTIONS(778),
    [anon_sym_POUND] = ACTIONS(778),
    [anon_sym_DASH] = ACTIONS(778),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(780),
    [anon_sym_STAR] = ACTIONS(778),
    [anon_sym_AT] = ACTIONS(778),
    [anon_sym_QMARK] = ACTIONS(778),
    [anon_sym_0] = ACTIONS(782),
    [anon_sym__] = ACTIONS(782),
  },
  [144] = {
    [sym_subscript] = STATE(449),
    [sym_variable_name] = ACTIONS(784),
    [anon_sym_DOLLAR] = ACTIONS(786),
    [anon_sym_POUND] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(786),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(790),
    [anon_sym_STAR] = ACTIONS(786),
    [anon_sym_AT] = ACTIONS(786),
    [anon_sym_QMARK] = ACTIONS(786),
    [anon_sym_0] = ACTIONS(792),
    [anon_sym__] = ACTIONS(792),
  },
  [145] = {
    [sym_for_statement] = STATE(450),
    [sym_while_statement] = STATE(450),
    [sym_if_statement] = STATE(450),
    [sym_case_statement] = STATE(450),
    [sym_function_definition] = STATE(450),
    [sym_subshell] = STATE(450),
    [sym_pipeline] = STATE(450),
    [sym_list] = STATE(450),
    [sym_bracket_command] = STATE(450),
    [sym_command] = STATE(450),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(451),
    [sym_declaration_command] = STATE(450),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [146] = {
    [sym_for_statement] = STATE(452),
    [sym_while_statement] = STATE(452),
    [sym_if_statement] = STATE(452),
    [sym_case_statement] = STATE(452),
    [sym_function_definition] = STATE(452),
    [sym_subshell] = STATE(452),
    [sym_pipeline] = STATE(452),
    [sym_list] = STATE(452),
    [sym_bracket_command] = STATE(452),
    [sym_command] = STATE(452),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(453),
    [sym_declaration_command] = STATE(452),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [147] = {
    [sym_for_statement] = STATE(454),
    [sym_while_statement] = STATE(454),
    [sym_if_statement] = STATE(454),
    [sym_case_statement] = STATE(454),
    [sym_function_definition] = STATE(454),
    [sym_subshell] = STATE(454),
    [sym_pipeline] = STATE(454),
    [sym_list] = STATE(454),
    [sym_bracket_command] = STATE(454),
    [sym_command] = STATE(454),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(455),
    [sym_declaration_command] = STATE(454),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [148] = {
    [aux_sym_concatenation_repeat1] = STATE(439),
    [sym_file_descriptor] = ACTIONS(208),
    [sym__concat] = ACTIONS(770),
    [anon_sym_PIPE] = ACTIONS(776),
    [anon_sym_RPAREN] = ACTIONS(208),
    [anon_sym_LPAREN] = ACTIONS(794),
    [anon_sym_PIPE_AMP] = ACTIONS(208),
    [anon_sym_AMP_AMP] = ACTIONS(208),
    [anon_sym_PIPE_PIPE] = ACTIONS(208),
    [anon_sym_LT] = ACTIONS(776),
    [anon_sym_GT] = ACTIONS(776),
    [anon_sym_GT_GT] = ACTIONS(208),
    [anon_sym_AMP_GT] = ACTIONS(776),
    [anon_sym_AMP_GT_GT] = ACTIONS(208),
    [anon_sym_LT_AMP] = ACTIONS(208),
    [anon_sym_GT_AMP] = ACTIONS(208),
    [anon_sym_LT_LT] = ACTIONS(776),
    [anon_sym_LT_LT_DASH] = ACTIONS(208),
    [anon_sym_LT_LT_LT] = ACTIONS(208),
    [sym__special_characters] = ACTIONS(776),
    [anon_sym_DQUOTE] = ACTIONS(208),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(776),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(208),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(208),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(208),
    [anon_sym_GT_LPAREN] = ACTIONS(208),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(776),
  },
  [149] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(798),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [150] = {
    [sym_file_redirect] = STATE(466),
    [sym_heredoc_redirect] = STATE(466),
    [sym_herestring_redirect] = STATE(466),
    [sym_concatenation] = STATE(467),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_for_statement_repeat1] = STATE(468),
    [aux_sym_while_statement_repeat1] = STATE(469),
    [sym_file_descriptor] = ACTIONS(804),
    [anon_sym_PIPE] = ACTIONS(806),
    [anon_sym_RPAREN] = ACTIONS(808),
    [anon_sym_PIPE_AMP] = ACTIONS(808),
    [anon_sym_AMP_AMP] = ACTIONS(808),
    [anon_sym_PIPE_PIPE] = ACTIONS(808),
    [anon_sym_LT] = ACTIONS(810),
    [anon_sym_GT] = ACTIONS(810),
    [anon_sym_GT_GT] = ACTIONS(812),
    [anon_sym_AMP_GT] = ACTIONS(810),
    [anon_sym_AMP_GT_GT] = ACTIONS(812),
    [anon_sym_LT_AMP] = ACTIONS(812),
    [anon_sym_GT_AMP] = ACTIONS(812),
    [anon_sym_LT_LT] = ACTIONS(814),
    [anon_sym_LT_LT_DASH] = ACTIONS(816),
    [anon_sym_LT_LT_LT] = ACTIONS(818),
    [sym__special_characters] = ACTIONS(820),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(824),
  },
  [151] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(798),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [152] = {
    [sym__assignment] = STATE(412),
    [anon_sym_EQ] = ACTIONS(732),
    [anon_sym_PLUS_EQ] = ACTIONS(732),
    [sym_comment] = ACTIONS(52),
  },
  [153] = {
    [sym_file_descriptor] = ACTIONS(208),
    [anon_sym_PIPE] = ACTIONS(776),
    [anon_sym_RPAREN] = ACTIONS(208),
    [anon_sym_PIPE_AMP] = ACTIONS(208),
    [anon_sym_AMP_AMP] = ACTIONS(208),
    [anon_sym_PIPE_PIPE] = ACTIONS(208),
    [anon_sym_LT] = ACTIONS(776),
    [anon_sym_GT] = ACTIONS(776),
    [anon_sym_GT_GT] = ACTIONS(208),
    [anon_sym_AMP_GT] = ACTIONS(776),
    [anon_sym_AMP_GT_GT] = ACTIONS(208),
    [anon_sym_LT_AMP] = ACTIONS(208),
    [anon_sym_GT_AMP] = ACTIONS(208),
    [anon_sym_LT_LT] = ACTIONS(776),
    [anon_sym_LT_LT_DASH] = ACTIONS(208),
    [anon_sym_LT_LT_LT] = ACTIONS(208),
    [sym__special_characters] = ACTIONS(776),
    [anon_sym_DQUOTE] = ACTIONS(208),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(776),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(208),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(208),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(208),
    [anon_sym_GT_LPAREN] = ACTIONS(208),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(776),
  },
  [154] = {
    [sym_command_name] = STATE(470),
    [sym_variable_assignment] = STATE(29),
    [sym_subscript] = STATE(192),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(193),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(342),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(826),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(828),
  },
  [155] = {
    [sym__assignment] = STATE(412),
    [anon_sym_LBRACK] = ACTIONS(60),
    [anon_sym_EQ] = ACTIONS(830),
    [anon_sym_PLUS_EQ] = ACTIONS(830),
    [sym_comment] = ACTIONS(52),
  },
  [156] = {
    [sym__terminated_statement] = STATE(472),
    [sym_for_statement] = STATE(39),
    [sym_while_statement] = STATE(39),
    [sym_if_statement] = STATE(39),
    [sym_case_statement] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_subshell] = STATE(39),
    [sym_pipeline] = STATE(39),
    [sym_list] = STATE(39),
    [sym_bracket_command] = STATE(39),
    [sym_command] = STATE(39),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(40),
    [sym_declaration_command] = STATE(39),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [157] = {
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(832),
  },
  [158] = {
    [sym_variable_assignment] = STATE(435),
    [sym_subscript] = STATE(483),
    [sym_concatenation] = STATE(435),
    [sym_string] = STATE(477),
    [sym_simple_expansion] = STATE(477),
    [sym_expansion] = STATE(477),
    [sym_command_substitution] = STATE(477),
    [sym_process_substitution] = STATE(477),
    [aux_sym_declaration_command_repeat1] = STATE(484),
    [sym_variable_name] = ACTIONS(834),
    [anon_sym_PIPE] = ACTIONS(746),
    [anon_sym_PIPE_AMP] = ACTIONS(748),
    [anon_sym_AMP_AMP] = ACTIONS(748),
    [anon_sym_PIPE_PIPE] = ACTIONS(748),
    [sym__special_characters] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(838),
    [sym_raw_string] = ACTIONS(840),
    [anon_sym_DOLLAR] = ACTIONS(842),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(844),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(846),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [anon_sym_LT_LPAREN] = ACTIONS(848),
    [anon_sym_GT_LPAREN] = ACTIONS(848),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(766),
    [sym_word] = ACTIONS(850),
  },
  [159] = {
    [aux_sym_concatenation_repeat1] = STATE(486),
    [sym_file_descriptor] = ACTIONS(190),
    [sym__concat] = ACTIONS(852),
    [anon_sym_PIPE] = ACTIONS(772),
    [anon_sym_PIPE_AMP] = ACTIONS(190),
    [anon_sym_AMP_AMP] = ACTIONS(190),
    [anon_sym_PIPE_PIPE] = ACTIONS(190),
    [anon_sym_LT] = ACTIONS(772),
    [anon_sym_GT] = ACTIONS(772),
    [anon_sym_GT_GT] = ACTIONS(190),
    [anon_sym_AMP_GT] = ACTIONS(772),
    [anon_sym_AMP_GT_GT] = ACTIONS(190),
    [anon_sym_LT_AMP] = ACTIONS(190),
    [anon_sym_GT_AMP] = ACTIONS(190),
    [anon_sym_LT_LT] = ACTIONS(772),
    [anon_sym_LT_LT_DASH] = ACTIONS(190),
    [anon_sym_LT_LT_LT] = ACTIONS(190),
    [sym__special_characters] = ACTIONS(772),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(190),
    [anon_sym_DOLLAR] = ACTIONS(772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(190),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(190),
    [anon_sym_BQUOTE] = ACTIONS(190),
    [anon_sym_LT_LPAREN] = ACTIONS(190),
    [anon_sym_GT_LPAREN] = ACTIONS(190),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(772),
  },
  [160] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(488),
    [anon_sym_DQUOTE] = ACTIONS(854),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [161] = {
    [aux_sym_concatenation_repeat1] = STATE(486),
    [sym_file_descriptor] = ACTIONS(208),
    [sym__concat] = ACTIONS(852),
    [anon_sym_PIPE] = ACTIONS(776),
    [anon_sym_PIPE_AMP] = ACTIONS(208),
    [anon_sym_AMP_AMP] = ACTIONS(208),
    [anon_sym_PIPE_PIPE] = ACTIONS(208),
    [anon_sym_LT] = ACTIONS(776),
    [anon_sym_GT] = ACTIONS(776),
    [anon_sym_GT_GT] = ACTIONS(208),
    [anon_sym_AMP_GT] = ACTIONS(776),
    [anon_sym_AMP_GT_GT] = ACTIONS(208),
    [anon_sym_LT_AMP] = ACTIONS(208),
    [anon_sym_GT_AMP] = ACTIONS(208),
    [anon_sym_LT_LT] = ACTIONS(776),
    [anon_sym_LT_LT_DASH] = ACTIONS(208),
    [anon_sym_LT_LT_LT] = ACTIONS(208),
    [sym__special_characters] = ACTIONS(776),
    [anon_sym_DQUOTE] = ACTIONS(208),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(776),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(208),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(208),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(208),
    [anon_sym_GT_LPAREN] = ACTIONS(208),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(776),
  },
  [162] = {
    [sym_string] = STATE(491),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [anon_sym_DOLLAR] = ACTIONS(856),
    [anon_sym_POUND] = ACTIONS(856),
    [anon_sym_DASH] = ACTIONS(856),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(858),
    [anon_sym_STAR] = ACTIONS(856),
    [anon_sym_AT] = ACTIONS(856),
    [anon_sym_QMARK] = ACTIONS(856),
    [anon_sym_0] = ACTIONS(860),
    [anon_sym__] = ACTIONS(860),
  },
  [163] = {
    [sym_subscript] = STATE(496),
    [sym_variable_name] = ACTIONS(862),
    [anon_sym_DOLLAR] = ACTIONS(864),
    [anon_sym_POUND] = ACTIONS(866),
    [anon_sym_DASH] = ACTIONS(864),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(868),
    [anon_sym_STAR] = ACTIONS(864),
    [anon_sym_AT] = ACTIONS(864),
    [anon_sym_QMARK] = ACTIONS(864),
    [anon_sym_0] = ACTIONS(870),
    [anon_sym__] = ACTIONS(870),
  },
  [164] = {
    [sym_for_statement] = STATE(497),
    [sym_while_statement] = STATE(497),
    [sym_if_statement] = STATE(497),
    [sym_case_statement] = STATE(497),
    [sym_function_definition] = STATE(497),
    [sym_subshell] = STATE(497),
    [sym_pipeline] = STATE(497),
    [sym_list] = STATE(497),
    [sym_bracket_command] = STATE(497),
    [sym_command] = STATE(497),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(498),
    [sym_declaration_command] = STATE(497),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [165] = {
    [sym_for_statement] = STATE(499),
    [sym_while_statement] = STATE(499),
    [sym_if_statement] = STATE(499),
    [sym_case_statement] = STATE(499),
    [sym_function_definition] = STATE(499),
    [sym_subshell] = STATE(499),
    [sym_pipeline] = STATE(499),
    [sym_list] = STATE(499),
    [sym_bracket_command] = STATE(499),
    [sym_command] = STATE(499),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(500),
    [sym_declaration_command] = STATE(499),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [166] = {
    [sym_for_statement] = STATE(501),
    [sym_while_statement] = STATE(501),
    [sym_if_statement] = STATE(501),
    [sym_case_statement] = STATE(501),
    [sym_function_definition] = STATE(501),
    [sym_subshell] = STATE(501),
    [sym_pipeline] = STATE(501),
    [sym_list] = STATE(501),
    [sym_bracket_command] = STATE(501),
    [sym_command] = STATE(501),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(502),
    [sym_declaration_command] = STATE(501),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [167] = {
    [aux_sym_concatenation_repeat1] = STATE(486),
    [sym_file_descriptor] = ACTIONS(208),
    [sym__concat] = ACTIONS(852),
    [anon_sym_PIPE] = ACTIONS(776),
    [anon_sym_LPAREN] = ACTIONS(872),
    [anon_sym_PIPE_AMP] = ACTIONS(208),
    [anon_sym_AMP_AMP] = ACTIONS(208),
    [anon_sym_PIPE_PIPE] = ACTIONS(208),
    [anon_sym_LT] = ACTIONS(776),
    [anon_sym_GT] = ACTIONS(776),
    [anon_sym_GT_GT] = ACTIONS(208),
    [anon_sym_AMP_GT] = ACTIONS(776),
    [anon_sym_AMP_GT_GT] = ACTIONS(208),
    [anon_sym_LT_AMP] = ACTIONS(208),
    [anon_sym_GT_AMP] = ACTIONS(208),
    [anon_sym_LT_LT] = ACTIONS(776),
    [anon_sym_LT_LT_DASH] = ACTIONS(208),
    [anon_sym_LT_LT_LT] = ACTIONS(208),
    [sym__special_characters] = ACTIONS(776),
    [anon_sym_DQUOTE] = ACTIONS(208),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(776),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(208),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(208),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(208),
    [anon_sym_GT_LPAREN] = ACTIONS(208),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(776),
  },
  [168] = {
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_comment] = ACTIONS(52),
  },
  [169] = {
    [sym_file_redirect] = STATE(466),
    [sym_heredoc_redirect] = STATE(466),
    [sym_herestring_redirect] = STATE(466),
    [sym_concatenation] = STATE(467),
    [sym_string] = STATE(510),
    [sym_simple_expansion] = STATE(510),
    [sym_expansion] = STATE(510),
    [sym_command_substitution] = STATE(510),
    [sym_process_substitution] = STATE(510),
    [aux_sym_for_statement_repeat1] = STATE(511),
    [aux_sym_while_statement_repeat1] = STATE(512),
    [sym_file_descriptor] = ACTIONS(880),
    [anon_sym_PIPE] = ACTIONS(806),
    [anon_sym_PIPE_AMP] = ACTIONS(808),
    [anon_sym_AMP_AMP] = ACTIONS(808),
    [anon_sym_PIPE_PIPE] = ACTIONS(808),
    [anon_sym_LT] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(882),
    [anon_sym_GT_GT] = ACTIONS(884),
    [anon_sym_AMP_GT] = ACTIONS(882),
    [anon_sym_AMP_GT_GT] = ACTIONS(884),
    [anon_sym_LT_AMP] = ACTIONS(884),
    [anon_sym_GT_AMP] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(814),
    [anon_sym_LT_LT_DASH] = ACTIONS(816),
    [anon_sym_LT_LT_LT] = ACTIONS(886),
    [sym__special_characters] = ACTIONS(888),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(890),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(808),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(892),
  },
  [170] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [171] = {
    [sym__assignment] = STATE(412),
    [anon_sym_EQ] = ACTIONS(830),
    [anon_sym_PLUS_EQ] = ACTIONS(830),
    [sym_comment] = ACTIONS(52),
  },
  [172] = {
    [sym_command_name] = STATE(513),
    [sym_variable_assignment] = STATE(29),
    [sym_subscript] = STATE(192),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(193),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(342),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(894),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(896),
  },
  [173] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(898),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [174] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(898),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [175] = {
    [anon_sym_RPAREN] = ACTIONS(900),
    [sym_comment] = ACTIONS(52),
  },
  [176] = {
    [sym_for_statement] = STATE(516),
    [sym_while_statement] = STATE(516),
    [sym_if_statement] = STATE(516),
    [sym_case_statement] = STATE(516),
    [sym_function_definition] = STATE(516),
    [sym_subshell] = STATE(516),
    [sym_pipeline] = STATE(516),
    [sym_list] = STATE(516),
    [sym_bracket_command] = STATE(516),
    [sym_command] = STATE(516),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(517),
    [sym_declaration_command] = STATE(516),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [177] = {
    [sym_file_descriptor] = ACTIONS(902),
    [sym_variable_name] = ACTIONS(902),
    [ts_builtin_sym_end] = ACTIONS(902),
    [anon_sym_for] = ACTIONS(904),
    [anon_sym_while] = ACTIONS(904),
    [anon_sym_if] = ACTIONS(904),
    [anon_sym_case] = ACTIONS(904),
    [anon_sym_SEMI_SEMI] = ACTIONS(902),
    [anon_sym_function] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(902),
    [anon_sym_LBRACK] = ACTIONS(904),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym_declare] = ACTIONS(904),
    [anon_sym_typeset] = ACTIONS(904),
    [anon_sym_export] = ACTIONS(904),
    [anon_sym_readonly] = ACTIONS(904),
    [anon_sym_local] = ACTIONS(904),
    [anon_sym_LT] = ACTIONS(904),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_GT_GT] = ACTIONS(902),
    [anon_sym_AMP_GT] = ACTIONS(904),
    [anon_sym_AMP_GT_GT] = ACTIONS(902),
    [anon_sym_LT_AMP] = ACTIONS(902),
    [anon_sym_GT_AMP] = ACTIONS(902),
    [sym__special_characters] = ACTIONS(906),
    [anon_sym_DQUOTE] = ACTIONS(902),
    [sym_raw_string] = ACTIONS(902),
    [anon_sym_DOLLAR] = ACTIONS(904),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(902),
    [anon_sym_BQUOTE] = ACTIONS(902),
    [anon_sym_LT_LPAREN] = ACTIONS(902),
    [anon_sym_GT_LPAREN] = ACTIONS(902),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(906),
  },
  [178] = {
    [sym_for_statement] = STATE(518),
    [sym_while_statement] = STATE(518),
    [sym_if_statement] = STATE(518),
    [sym_case_statement] = STATE(518),
    [sym_function_definition] = STATE(518),
    [sym_subshell] = STATE(518),
    [sym_pipeline] = STATE(518),
    [sym_list] = STATE(518),
    [sym_bracket_command] = STATE(518),
    [sym_command] = STATE(518),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(519),
    [sym_declaration_command] = STATE(518),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [179] = {
    [anon_sym_LT] = ACTIONS(908),
    [anon_sym_GT] = ACTIONS(908),
    [anon_sym_GT_GT] = ACTIONS(910),
    [anon_sym_AMP_GT] = ACTIONS(908),
    [anon_sym_AMP_GT_GT] = ACTIONS(910),
    [anon_sym_LT_AMP] = ACTIONS(910),
    [anon_sym_GT_AMP] = ACTIONS(910),
    [sym_comment] = ACTIONS(52),
  },
  [180] = {
    [sym_concatenation] = STATE(529),
    [sym_string] = STATE(523),
    [sym_simple_expansion] = STATE(523),
    [sym_expansion] = STATE(523),
    [sym_command_substitution] = STATE(523),
    [sym_process_substitution] = STATE(523),
    [sym__special_characters] = ACTIONS(912),
    [anon_sym_DQUOTE] = ACTIONS(914),
    [sym_raw_string] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(922),
    [anon_sym_BQUOTE] = ACTIONS(924),
    [anon_sym_LT_LPAREN] = ACTIONS(926),
    [anon_sym_GT_LPAREN] = ACTIONS(926),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(928),
  },
  [181] = {
    [sym_heredoc] = STATE(532),
    [sym__simple_heredoc] = ACTIONS(930),
    [sym__heredoc_beginning] = ACTIONS(932),
    [sym_comment] = ACTIONS(52),
  },
  [182] = {
    [sym_concatenation] = STATE(535),
    [sym_string] = STATE(534),
    [sym_simple_expansion] = STATE(534),
    [sym_expansion] = STATE(534),
    [sym_command_substitution] = STATE(534),
    [sym_process_substitution] = STATE(534),
    [sym__special_characters] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(914),
    [sym_raw_string] = ACTIONS(936),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(922),
    [anon_sym_BQUOTE] = ACTIONS(924),
    [anon_sym_LT_LPAREN] = ACTIONS(926),
    [anon_sym_GT_LPAREN] = ACTIONS(926),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(938),
  },
  [183] = {
    [aux_sym_concatenation_repeat1] = STATE(114),
    [sym_file_descriptor] = ACTIONS(522),
    [sym__concat] = ACTIONS(192),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_SEMI_SEMI] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(520),
    [anon_sym_AMP_AMP] = ACTIONS(520),
    [anon_sym_PIPE_PIPE] = ACTIONS(520),
    [anon_sym_LT] = ACTIONS(520),
    [anon_sym_GT] = ACTIONS(520),
    [anon_sym_GT_GT] = ACTIONS(520),
    [anon_sym_AMP_GT] = ACTIONS(520),
    [anon_sym_AMP_GT_GT] = ACTIONS(520),
    [anon_sym_LT_AMP] = ACTIONS(520),
    [anon_sym_GT_AMP] = ACTIONS(520),
    [anon_sym_LT_LT] = ACTIONS(520),
    [anon_sym_LT_LT_DASH] = ACTIONS(520),
    [anon_sym_LT_LT_LT] = ACTIONS(520),
    [sym__special_characters] = ACTIONS(520),
    [anon_sym_DQUOTE] = ACTIONS(520),
    [sym_raw_string] = ACTIONS(520),
    [anon_sym_DOLLAR] = ACTIONS(520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(520),
    [anon_sym_BQUOTE] = ACTIONS(520),
    [anon_sym_LT_LPAREN] = ACTIONS(520),
    [anon_sym_GT_LPAREN] = ACTIONS(520),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(520),
    [anon_sym_SEMI] = ACTIONS(520),
    [anon_sym_LF] = ACTIONS(520),
    [anon_sym_AMP] = ACTIONS(520),
  },
  [184] = {
    [aux_sym_concatenation_repeat1] = STATE(114),
    [sym_file_descriptor] = ACTIONS(530),
    [sym__concat] = ACTIONS(192),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_SEMI_SEMI] = ACTIONS(528),
    [anon_sym_PIPE_AMP] = ACTIONS(528),
    [anon_sym_AMP_AMP] = ACTIONS(528),
    [anon_sym_PIPE_PIPE] = ACTIONS(528),
    [anon_sym_LT] = ACTIONS(528),
    [anon_sym_GT] = ACTIONS(528),
    [anon_sym_GT_GT] = ACTIONS(528),
    [anon_sym_AMP_GT] = ACTIONS(528),
    [anon_sym_AMP_GT_GT] = ACTIONS(528),
    [anon_sym_LT_AMP] = ACTIONS(528),
    [anon_sym_GT_AMP] = ACTIONS(528),
    [anon_sym_LT_LT] = ACTIONS(528),
    [anon_sym_LT_LT_DASH] = ACTIONS(528),
    [anon_sym_LT_LT_LT] = ACTIONS(528),
    [sym__special_characters] = ACTIONS(528),
    [anon_sym_DQUOTE] = ACTIONS(528),
    [sym_raw_string] = ACTIONS(528),
    [anon_sym_DOLLAR] = ACTIONS(528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(528),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(528),
    [anon_sym_BQUOTE] = ACTIONS(528),
    [anon_sym_LT_LPAREN] = ACTIONS(528),
    [anon_sym_GT_LPAREN] = ACTIONS(528),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(528),
    [anon_sym_SEMI] = ACTIONS(528),
    [anon_sym_LF] = ACTIONS(528),
    [anon_sym_AMP] = ACTIONS(528),
  },
  [185] = {
    [sym_file_descriptor] = ACTIONS(940),
    [anon_sym_PIPE] = ACTIONS(942),
    [anon_sym_RPAREN] = ACTIONS(942),
    [anon_sym_SEMI_SEMI] = ACTIONS(942),
    [anon_sym_PIPE_AMP] = ACTIONS(942),
    [anon_sym_AMP_AMP] = ACTIONS(942),
    [anon_sym_PIPE_PIPE] = ACTIONS(942),
    [anon_sym_LT] = ACTIONS(942),
    [anon_sym_GT] = ACTIONS(942),
    [anon_sym_GT_GT] = ACTIONS(942),
    [anon_sym_AMP_GT] = ACTIONS(942),
    [anon_sym_AMP_GT_GT] = ACTIONS(942),
    [anon_sym_LT_AMP] = ACTIONS(942),
    [anon_sym_GT_AMP] = ACTIONS(942),
    [anon_sym_LT_LT] = ACTIONS(942),
    [anon_sym_LT_LT_DASH] = ACTIONS(942),
    [anon_sym_LT_LT_LT] = ACTIONS(942),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(942),
    [anon_sym_LF] = ACTIONS(942),
    [anon_sym_AMP] = ACTIONS(942),
  },
  [186] = {
    [sym_file_descriptor] = ACTIONS(530),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(528),
    [anon_sym_SEMI_SEMI] = ACTIONS(528),
    [anon_sym_PIPE_AMP] = ACTIONS(528),
    [anon_sym_AMP_AMP] = ACTIONS(528),
    [anon_sym_PIPE_PIPE] = ACTIONS(528),
    [anon_sym_LT] = ACTIONS(528),
    [anon_sym_GT] = ACTIONS(528),
    [anon_sym_GT_GT] = ACTIONS(528),
    [anon_sym_AMP_GT] = ACTIONS(528),
    [anon_sym_AMP_GT_GT] = ACTIONS(528),
    [anon_sym_LT_AMP] = ACTIONS(528),
    [anon_sym_GT_AMP] = ACTIONS(528),
    [anon_sym_LT_LT] = ACTIONS(528),
    [anon_sym_LT_LT_DASH] = ACTIONS(528),
    [anon_sym_LT_LT_LT] = ACTIONS(528),
    [sym__special_characters] = ACTIONS(528),
    [anon_sym_DQUOTE] = ACTIONS(528),
    [sym_raw_string] = ACTIONS(528),
    [anon_sym_DOLLAR] = ACTIONS(528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(528),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(528),
    [anon_sym_BQUOTE] = ACTIONS(528),
    [anon_sym_LT_LPAREN] = ACTIONS(528),
    [anon_sym_GT_LPAREN] = ACTIONS(528),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(528),
    [anon_sym_SEMI] = ACTIONS(528),
    [anon_sym_LF] = ACTIONS(528),
    [anon_sym_AMP] = ACTIONS(528),
  },
  [187] = {
    [sym_file_redirect] = STATE(185),
    [sym_heredoc_redirect] = STATE(185),
    [sym_herestring_redirect] = STATE(185),
    [sym_concatenation] = STATE(186),
    [sym_string] = STATE(184),
    [sym_simple_expansion] = STATE(184),
    [sym_expansion] = STATE(184),
    [sym_command_substitution] = STATE(184),
    [sym_process_substitution] = STATE(184),
    [aux_sym_for_statement_repeat1] = STATE(536),
    [aux_sym_while_statement_repeat1] = STATE(537),
    [sym_file_descriptor] = ACTIONS(308),
    [anon_sym_PIPE] = ACTIONS(944),
    [anon_sym_SEMI_SEMI] = ACTIONS(944),
    [anon_sym_PIPE_AMP] = ACTIONS(944),
    [anon_sym_AMP_AMP] = ACTIONS(944),
    [anon_sym_PIPE_PIPE] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(312),
    [anon_sym_GT] = ACTIONS(312),
    [anon_sym_GT_GT] = ACTIONS(312),
    [anon_sym_AMP_GT] = ACTIONS(312),
    [anon_sym_AMP_GT_GT] = ACTIONS(312),
    [anon_sym_LT_AMP] = ACTIONS(312),
    [anon_sym_GT_AMP] = ACTIONS(312),
    [anon_sym_LT_LT] = ACTIONS(314),
    [anon_sym_LT_LT_DASH] = ACTIONS(314),
    [anon_sym_LT_LT_LT] = ACTIONS(316),
    [sym__special_characters] = ACTIONS(318),
    [anon_sym_DQUOTE] = ACTIONS(320),
    [sym_raw_string] = ACTIONS(322),
    [anon_sym_DOLLAR] = ACTIONS(324),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(326),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(328),
    [anon_sym_BQUOTE] = ACTIONS(330),
    [anon_sym_LT_LPAREN] = ACTIONS(332),
    [anon_sym_GT_LPAREN] = ACTIONS(332),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(322),
    [anon_sym_SEMI] = ACTIONS(944),
    [anon_sym_LF] = ACTIONS(944),
    [anon_sym_AMP] = ACTIONS(944),
  },
  [188] = {
    [sym_file_redirect] = STATE(185),
    [sym_heredoc_redirect] = STATE(185),
    [sym_herestring_redirect] = STATE(185),
    [aux_sym_while_statement_repeat1] = STATE(538),
    [sym_file_descriptor] = ACTIONS(308),
    [anon_sym_PIPE] = ACTIONS(944),
    [anon_sym_SEMI_SEMI] = ACTIONS(944),
    [anon_sym_PIPE_AMP] = ACTIONS(944),
    [anon_sym_AMP_AMP] = ACTIONS(944),
    [anon_sym_PIPE_PIPE] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(312),
    [anon_sym_GT] = ACTIONS(312),
    [anon_sym_GT_GT] = ACTIONS(312),
    [anon_sym_AMP_GT] = ACTIONS(312),
    [anon_sym_AMP_GT_GT] = ACTIONS(312),
    [anon_sym_LT_AMP] = ACTIONS(312),
    [anon_sym_GT_AMP] = ACTIONS(312),
    [anon_sym_LT_LT] = ACTIONS(314),
    [anon_sym_LT_LT_DASH] = ACTIONS(314),
    [anon_sym_LT_LT_LT] = ACTIONS(316),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(944),
    [anon_sym_LF] = ACTIONS(944),
    [anon_sym_AMP] = ACTIONS(944),
  },
  [189] = {
    [sym__terminated_statement] = STATE(24),
    [sym_for_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_case_statement] = STATE(25),
    [sym_function_definition] = STATE(25),
    [sym_subshell] = STATE(25),
    [sym_pipeline] = STATE(25),
    [sym_list] = STATE(25),
    [sym_bracket_command] = STATE(25),
    [sym_command] = STATE(25),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(27),
    [sym_declaration_command] = STATE(25),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(189),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(946),
    [sym_variable_name] = ACTIONS(949),
    [ts_builtin_sym_end] = ACTIONS(952),
    [anon_sym_for] = ACTIONS(954),
    [anon_sym_while] = ACTIONS(957),
    [anon_sym_if] = ACTIONS(960),
    [anon_sym_case] = ACTIONS(963),
    [anon_sym_function] = ACTIONS(966),
    [anon_sym_LPAREN] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_typeset] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_local] = ACTIONS(978),
    [anon_sym_LT] = ACTIONS(981),
    [anon_sym_GT] = ACTIONS(981),
    [anon_sym_GT_GT] = ACTIONS(984),
    [anon_sym_AMP_GT] = ACTIONS(981),
    [anon_sym_AMP_GT_GT] = ACTIONS(984),
    [anon_sym_LT_AMP] = ACTIONS(984),
    [anon_sym_GT_AMP] = ACTIONS(984),
    [sym__special_characters] = ACTIONS(987),
    [anon_sym_DQUOTE] = ACTIONS(990),
    [sym_raw_string] = ACTIONS(993),
    [anon_sym_DOLLAR] = ACTIONS(996),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(999),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1002),
    [anon_sym_BQUOTE] = ACTIONS(1005),
    [anon_sym_LT_LPAREN] = ACTIONS(1008),
    [anon_sym_GT_LPAREN] = ACTIONS(1008),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1011),
  },
  [190] = {
    [sym__assignment] = STATE(412),
    [anon_sym_LBRACK] = ACTIONS(60),
    [anon_sym_EQ] = ACTIONS(1014),
    [anon_sym_PLUS_EQ] = ACTIONS(1014),
    [sym_comment] = ACTIONS(52),
  },
  [191] = {
    [sym_file_redirect] = STATE(185),
    [sym_heredoc_redirect] = STATE(185),
    [sym_herestring_redirect] = STATE(185),
    [sym_concatenation] = STATE(186),
    [sym_string] = STATE(184),
    [sym_simple_expansion] = STATE(184),
    [sym_expansion] = STATE(184),
    [sym_command_substitution] = STATE(184),
    [sym_process_substitution] = STATE(184),
    [aux_sym_for_statement_repeat1] = STATE(540),
    [aux_sym_while_statement_repeat1] = STATE(537),
    [sym_file_descriptor] = ACTIONS(308),
    [anon_sym_PIPE] = ACTIONS(944),
    [anon_sym_SEMI_SEMI] = ACTIONS(944),
    [anon_sym_PIPE_AMP] = ACTIONS(944),
    [anon_sym_AMP_AMP] = ACTIONS(944),
    [anon_sym_PIPE_PIPE] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(312),
    [anon_sym_GT] = ACTIONS(312),
    [anon_sym_GT_GT] = ACTIONS(312),
    [anon_sym_AMP_GT] = ACTIONS(312),
    [anon_sym_AMP_GT_GT] = ACTIONS(312),
    [anon_sym_LT_AMP] = ACTIONS(312),
    [anon_sym_GT_AMP] = ACTIONS(312),
    [anon_sym_LT_LT] = ACTIONS(314),
    [anon_sym_LT_LT_DASH] = ACTIONS(314),
    [anon_sym_LT_LT_LT] = ACTIONS(316),
    [sym__special_characters] = ACTIONS(318),
    [anon_sym_DQUOTE] = ACTIONS(320),
    [sym_raw_string] = ACTIONS(322),
    [anon_sym_DOLLAR] = ACTIONS(324),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(326),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(328),
    [anon_sym_BQUOTE] = ACTIONS(330),
    [anon_sym_LT_LPAREN] = ACTIONS(332),
    [anon_sym_GT_LPAREN] = ACTIONS(332),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(322),
    [anon_sym_SEMI] = ACTIONS(944),
    [anon_sym_LF] = ACTIONS(944),
    [anon_sym_AMP] = ACTIONS(944),
  },
  [192] = {
    [sym__assignment] = STATE(412),
    [anon_sym_EQ] = ACTIONS(1014),
    [anon_sym_PLUS_EQ] = ACTIONS(1014),
    [sym_comment] = ACTIONS(52),
  },
  [193] = {
    [sym_variable_assignment] = STATE(29),
    [sym_subscript] = STATE(192),
    [sym_file_redirect] = STATE(29),
    [aux_sym_command_repeat1] = STATE(193),
    [sym_file_descriptor] = ACTIONS(1016),
    [sym_variable_name] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1022),
    [anon_sym_GT] = ACTIONS(1022),
    [anon_sym_GT_GT] = ACTIONS(1025),
    [anon_sym_AMP_GT] = ACTIONS(1022),
    [anon_sym_AMP_GT_GT] = ACTIONS(1025),
    [anon_sym_LT_AMP] = ACTIONS(1025),
    [anon_sym_GT_AMP] = ACTIONS(1025),
    [sym__special_characters] = ACTIONS(1028),
    [anon_sym_DQUOTE] = ACTIONS(1030),
    [sym_raw_string] = ACTIONS(1030),
    [anon_sym_DOLLAR] = ACTIONS(1028),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1030),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1030),
    [anon_sym_BQUOTE] = ACTIONS(1030),
    [anon_sym_LT_LPAREN] = ACTIONS(1030),
    [anon_sym_GT_LPAREN] = ACTIONS(1030),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1028),
  },
  [194] = {
    [aux_sym_concatenation_repeat1] = STATE(355),
    [sym_file_descriptor] = ACTIONS(1032),
    [sym__concat] = ACTIONS(616),
    [sym_variable_name] = ACTIONS(1032),
    [anon_sym_LT] = ACTIONS(1034),
    [anon_sym_GT] = ACTIONS(1034),
    [anon_sym_GT_GT] = ACTIONS(1032),
    [anon_sym_AMP_GT] = ACTIONS(1034),
    [anon_sym_AMP_GT_GT] = ACTIONS(1032),
    [anon_sym_LT_AMP] = ACTIONS(1032),
    [anon_sym_GT_AMP] = ACTIONS(1032),
    [sym__special_characters] = ACTIONS(1034),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [sym_raw_string] = ACTIONS(1032),
    [anon_sym_DOLLAR] = ACTIONS(1034),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1032),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1032),
    [anon_sym_BQUOTE] = ACTIONS(1032),
    [anon_sym_LT_LPAREN] = ACTIONS(1032),
    [anon_sym_GT_LPAREN] = ACTIONS(1032),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1034),
  },
  [195] = {
    [aux_sym_concatenation_repeat1] = STATE(355),
    [sym_file_descriptor] = ACTIONS(1036),
    [sym__concat] = ACTIONS(616),
    [sym_variable_name] = ACTIONS(1036),
    [anon_sym_LT] = ACTIONS(1038),
    [anon_sym_GT] = ACTIONS(1038),
    [anon_sym_GT_GT] = ACTIONS(1036),
    [anon_sym_AMP_GT] = ACTIONS(1038),
    [anon_sym_AMP_GT_GT] = ACTIONS(1036),
    [anon_sym_LT_AMP] = ACTIONS(1036),
    [anon_sym_GT_AMP] = ACTIONS(1036),
    [sym__special_characters] = ACTIONS(1038),
    [anon_sym_DQUOTE] = ACTIONS(1036),
    [sym_raw_string] = ACTIONS(1036),
    [anon_sym_DOLLAR] = ACTIONS(1038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1036),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [anon_sym_LT_LPAREN] = ACTIONS(1036),
    [anon_sym_GT_LPAREN] = ACTIONS(1036),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1038),
  },
  [196] = {
    [sym_file_descriptor] = ACTIONS(1036),
    [sym_variable_name] = ACTIONS(1036),
    [anon_sym_LT] = ACTIONS(1038),
    [anon_sym_GT] = ACTIONS(1038),
    [anon_sym_GT_GT] = ACTIONS(1036),
    [anon_sym_AMP_GT] = ACTIONS(1038),
    [anon_sym_AMP_GT_GT] = ACTIONS(1036),
    [anon_sym_LT_AMP] = ACTIONS(1036),
    [anon_sym_GT_AMP] = ACTIONS(1036),
    [sym__special_characters] = ACTIONS(1038),
    [anon_sym_DQUOTE] = ACTIONS(1036),
    [sym_raw_string] = ACTIONS(1036),
    [anon_sym_DOLLAR] = ACTIONS(1038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1036),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [anon_sym_LT_LPAREN] = ACTIONS(1036),
    [anon_sym_GT_LPAREN] = ACTIONS(1036),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1038),
  },
  [197] = {
    [aux_sym_concatenation_repeat1] = STATE(543),
    [sym__concat] = ACTIONS(1040),
    [anon_sym_RBRACK] = ACTIONS(1042),
    [sym_comment] = ACTIONS(52),
  },
  [198] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(545),
    [anon_sym_DQUOTE] = ACTIONS(1044),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [199] = {
    [aux_sym_concatenation_repeat1] = STATE(543),
    [sym__concat] = ACTIONS(1046),
    [anon_sym_RBRACK] = ACTIONS(1048),
    [sym_comment] = ACTIONS(52),
  },
  [200] = {
    [sym_string] = STATE(550),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [anon_sym_DOLLAR] = ACTIONS(1050),
    [anon_sym_POUND] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1052),
    [anon_sym_STAR] = ACTIONS(1050),
    [anon_sym_AT] = ACTIONS(1050),
    [anon_sym_QMARK] = ACTIONS(1050),
    [anon_sym_0] = ACTIONS(1054),
    [anon_sym__] = ACTIONS(1054),
  },
  [201] = {
    [sym_subscript] = STATE(555),
    [sym_variable_name] = ACTIONS(1056),
    [anon_sym_DOLLAR] = ACTIONS(1058),
    [anon_sym_POUND] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1058),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1062),
    [anon_sym_STAR] = ACTIONS(1058),
    [anon_sym_AT] = ACTIONS(1058),
    [anon_sym_QMARK] = ACTIONS(1058),
    [anon_sym_0] = ACTIONS(1064),
    [anon_sym__] = ACTIONS(1064),
  },
  [202] = {
    [sym_for_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_case_statement] = STATE(556),
    [sym_function_definition] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_pipeline] = STATE(556),
    [sym_list] = STATE(556),
    [sym_bracket_command] = STATE(556),
    [sym_command] = STATE(556),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(557),
    [sym_declaration_command] = STATE(556),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [203] = {
    [sym_for_statement] = STATE(558),
    [sym_while_statement] = STATE(558),
    [sym_if_statement] = STATE(558),
    [sym_case_statement] = STATE(558),
    [sym_function_definition] = STATE(558),
    [sym_subshell] = STATE(558),
    [sym_pipeline] = STATE(558),
    [sym_list] = STATE(558),
    [sym_bracket_command] = STATE(558),
    [sym_command] = STATE(558),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(559),
    [sym_declaration_command] = STATE(558),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [204] = {
    [sym_for_statement] = STATE(560),
    [sym_while_statement] = STATE(560),
    [sym_if_statement] = STATE(560),
    [sym_case_statement] = STATE(560),
    [sym_function_definition] = STATE(560),
    [sym_subshell] = STATE(560),
    [sym_pipeline] = STATE(560),
    [sym_list] = STATE(560),
    [sym_bracket_command] = STATE(560),
    [sym_command] = STATE(560),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(561),
    [sym_declaration_command] = STATE(560),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [205] = {
    [sym__concat] = ACTIONS(1066),
    [anon_sym_RBRACK] = ACTIONS(1048),
    [sym_comment] = ACTIONS(52),
  },
  [206] = {
    [sym_file_descriptor] = ACTIONS(1068),
    [sym_variable_name] = ACTIONS(1068),
    [anon_sym_PIPE] = ACTIONS(1070),
    [anon_sym_RPAREN] = ACTIONS(1070),
    [anon_sym_SEMI_SEMI] = ACTIONS(1070),
    [anon_sym_PIPE_AMP] = ACTIONS(1070),
    [anon_sym_AMP_AMP] = ACTIONS(1070),
    [anon_sym_PIPE_PIPE] = ACTIONS(1070),
    [anon_sym_LT] = ACTIONS(1070),
    [anon_sym_GT] = ACTIONS(1070),
    [anon_sym_GT_GT] = ACTIONS(1070),
    [anon_sym_AMP_GT] = ACTIONS(1070),
    [anon_sym_AMP_GT_GT] = ACTIONS(1070),
    [anon_sym_LT_AMP] = ACTIONS(1070),
    [anon_sym_GT_AMP] = ACTIONS(1070),
    [sym__special_characters] = ACTIONS(1070),
    [anon_sym_DQUOTE] = ACTIONS(1070),
    [sym_raw_string] = ACTIONS(1070),
    [anon_sym_DOLLAR] = ACTIONS(1070),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1070),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1070),
    [anon_sym_BQUOTE] = ACTIONS(1070),
    [anon_sym_LT_LPAREN] = ACTIONS(1070),
    [anon_sym_GT_LPAREN] = ACTIONS(1070),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1070),
    [anon_sym_SEMI] = ACTIONS(1070),
    [anon_sym_LF] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(1070),
  },
  [207] = {
    [sym_concatenation] = STATE(572),
    [sym_string] = STATE(566),
    [sym_simple_expansion] = STATE(566),
    [sym_expansion] = STATE(566),
    [sym_command_substitution] = STATE(566),
    [sym_process_substitution] = STATE(566),
    [aux_sym_for_statement_repeat1] = STATE(573),
    [anon_sym_RPAREN] = ACTIONS(1072),
    [sym__special_characters] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1076),
    [sym_raw_string] = ACTIONS(1078),
    [anon_sym_DOLLAR] = ACTIONS(1080),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1084),
    [anon_sym_BQUOTE] = ACTIONS(1086),
    [anon_sym_LT_LPAREN] = ACTIONS(1088),
    [anon_sym_GT_LPAREN] = ACTIONS(1088),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1090),
  },
  [208] = {
    [aux_sym_concatenation_repeat1] = STATE(575),
    [sym_file_descriptor] = ACTIONS(1092),
    [sym__concat] = ACTIONS(1094),
    [sym_variable_name] = ACTIONS(1092),
    [anon_sym_PIPE] = ACTIONS(1096),
    [anon_sym_SEMI_SEMI] = ACTIONS(1096),
    [anon_sym_PIPE_AMP] = ACTIONS(1096),
    [anon_sym_AMP_AMP] = ACTIONS(1096),
    [anon_sym_PIPE_PIPE] = ACTIONS(1096),
    [anon_sym_LT] = ACTIONS(1096),
    [anon_sym_GT] = ACTIONS(1096),
    [anon_sym_GT_GT] = ACTIONS(1096),
    [anon_sym_AMP_GT] = ACTIONS(1096),
    [anon_sym_AMP_GT_GT] = ACTIONS(1096),
    [anon_sym_LT_AMP] = ACTIONS(1096),
    [anon_sym_GT_AMP] = ACTIONS(1096),
    [sym__special_characters] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1096),
    [sym_raw_string] = ACTIONS(1096),
    [anon_sym_DOLLAR] = ACTIONS(1096),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1096),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1096),
    [anon_sym_BQUOTE] = ACTIONS(1096),
    [anon_sym_LT_LPAREN] = ACTIONS(1096),
    [anon_sym_GT_LPAREN] = ACTIONS(1096),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1096),
    [anon_sym_SEMI] = ACTIONS(1096),
    [anon_sym_LF] = ACTIONS(1096),
    [anon_sym_AMP] = ACTIONS(1096),
  },
  [209] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(577),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [210] = {
    [aux_sym_concatenation_repeat1] = STATE(575),
    [sym_file_descriptor] = ACTIONS(1068),
    [sym__concat] = ACTIONS(1094),
    [sym_variable_name] = ACTIONS(1068),
    [anon_sym_PIPE] = ACTIONS(1070),
    [anon_sym_SEMI_SEMI] = ACTIONS(1070),
    [anon_sym_PIPE_AMP] = ACTIONS(1070),
    [anon_sym_AMP_AMP] = ACTIONS(1070),
    [anon_sym_PIPE_PIPE] = ACTIONS(1070),
    [anon_sym_LT] = ACTIONS(1070),
    [anon_sym_GT] = ACTIONS(1070),
    [anon_sym_GT_GT] = ACTIONS(1070),
    [anon_sym_AMP_GT] = ACTIONS(1070),
    [anon_sym_AMP_GT_GT] = ACTIONS(1070),
    [anon_sym_LT_AMP] = ACTIONS(1070),
    [anon_sym_GT_AMP] = ACTIONS(1070),
    [sym__special_characters] = ACTIONS(1070),
    [anon_sym_DQUOTE] = ACTIONS(1070),
    [sym_raw_string] = ACTIONS(1070),
    [anon_sym_DOLLAR] = ACTIONS(1070),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1070),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1070),
    [anon_sym_BQUOTE] = ACTIONS(1070),
    [anon_sym_LT_LPAREN] = ACTIONS(1070),
    [anon_sym_GT_LPAREN] = ACTIONS(1070),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1070),
    [anon_sym_SEMI] = ACTIONS(1070),
    [anon_sym_LF] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(1070),
  },
  [211] = {
    [sym_string] = STATE(580),
    [anon_sym_DQUOTE] = ACTIONS(378),
    [anon_sym_DOLLAR] = ACTIONS(1100),
    [anon_sym_POUND] = ACTIONS(1100),
    [anon_sym_DASH] = ACTIONS(1100),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1102),
    [anon_sym_STAR] = ACTIONS(1100),
    [anon_sym_AT] = ACTIONS(1100),
    [anon_sym_QMARK] = ACTIONS(1100),
    [anon_sym_0] = ACTIONS(1104),
    [anon_sym__] = ACTIONS(1104),
  },
  [212] = {
    [sym_subscript] = STATE(585),
    [sym_variable_name] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(1108),
    [anon_sym_POUND] = ACTIONS(1110),
    [anon_sym_DASH] = ACTIONS(1108),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1112),
    [anon_sym_STAR] = ACTIONS(1108),
    [anon_sym_AT] = ACTIONS(1108),
    [anon_sym_QMARK] = ACTIONS(1108),
    [anon_sym_0] = ACTIONS(1114),
    [anon_sym__] = ACTIONS(1114),
  },
  [213] = {
    [sym_for_statement] = STATE(586),
    [sym_while_statement] = STATE(586),
    [sym_if_statement] = STATE(586),
    [sym_case_statement] = STATE(586),
    [sym_function_definition] = STATE(586),
    [sym_subshell] = STATE(586),
    [sym_pipeline] = STATE(586),
    [sym_list] = STATE(586),
    [sym_bracket_command] = STATE(586),
    [sym_command] = STATE(586),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(587),
    [sym_declaration_command] = STATE(586),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [214] = {
    [sym_for_statement] = STATE(588),
    [sym_while_statement] = STATE(588),
    [sym_if_statement] = STATE(588),
    [sym_case_statement] = STATE(588),
    [sym_function_definition] = STATE(588),
    [sym_subshell] = STATE(588),
    [sym_pipeline] = STATE(588),
    [sym_list] = STATE(588),
    [sym_bracket_command] = STATE(588),
    [sym_command] = STATE(588),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(589),
    [sym_declaration_command] = STATE(588),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [215] = {
    [sym_for_statement] = STATE(590),
    [sym_while_statement] = STATE(590),
    [sym_if_statement] = STATE(590),
    [sym_case_statement] = STATE(590),
    [sym_function_definition] = STATE(590),
    [sym_subshell] = STATE(590),
    [sym_pipeline] = STATE(590),
    [sym_list] = STATE(590),
    [sym_bracket_command] = STATE(590),
    [sym_command] = STATE(590),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(591),
    [sym_declaration_command] = STATE(590),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [216] = {
    [sym_concatenation] = STATE(600),
    [sym_string] = STATE(594),
    [sym_simple_expansion] = STATE(594),
    [sym_expansion] = STATE(594),
    [sym_command_substitution] = STATE(594),
    [sym_process_substitution] = STATE(594),
    [aux_sym_for_statement_repeat1] = STATE(601),
    [sym__special_characters] = ACTIONS(1116),
    [anon_sym_DQUOTE] = ACTIONS(1118),
    [sym_raw_string] = ACTIONS(1120),
    [anon_sym_DOLLAR] = ACTIONS(1122),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1124),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1126),
    [anon_sym_BQUOTE] = ACTIONS(1128),
    [anon_sym_LT_LPAREN] = ACTIONS(1130),
    [anon_sym_GT_LPAREN] = ACTIONS(1130),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1132),
  },
  [217] = {
    [sym__terminated_statement] = STATE(603),
    [sym_for_statement] = STATE(604),
    [sym_while_statement] = STATE(604),
    [sym_if_statement] = STATE(604),
    [sym_case_statement] = STATE(604),
    [sym_function_definition] = STATE(604),
    [sym_subshell] = STATE(604),
    [sym_pipeline] = STATE(604),
    [sym_list] = STATE(604),
    [sym_bracket_command] = STATE(604),
    [sym_command] = STATE(604),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(605),
    [sym_declaration_command] = STATE(604),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(606),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_done] = ACTIONS(1134),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [218] = {
    [sym_file_redirect] = STATE(185),
    [sym_heredoc_redirect] = STATE(185),
    [sym_herestring_redirect] = STATE(185),
    [aux_sym_while_statement_repeat1] = STATE(607),
    [sym_file_descriptor] = ACTIONS(308),
    [anon_sym_PIPE] = ACTIONS(1136),
    [anon_sym_SEMI_SEMI] = ACTIONS(1136),
    [anon_sym_PIPE_AMP] = ACTIONS(1136),
    [anon_sym_AMP_AMP] = ACTIONS(1136),
    [anon_sym_PIPE_PIPE] = ACTIONS(1136),
    [anon_sym_LT] = ACTIONS(312),
    [anon_sym_GT] = ACTIONS(312),
    [anon_sym_GT_GT] = ACTIONS(312),
    [anon_sym_AMP_GT] = ACTIONS(312),
    [anon_sym_AMP_GT_GT] = ACTIONS(312),
    [anon_sym_LT_AMP] = ACTIONS(312),
    [anon_sym_GT_AMP] = ACTIONS(312),
    [anon_sym_LT_LT] = ACTIONS(314),
    [anon_sym_LT_LT_DASH] = ACTIONS(314),
    [anon_sym_LT_LT_LT] = ACTIONS(316),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1136),
    [anon_sym_LF] = ACTIONS(1136),
    [anon_sym_AMP] = ACTIONS(1136),
  },
  [219] = {
    [anon_sym_do] = ACTIONS(902),
    [anon_sym_then] = ACTIONS(902),
    [sym_comment] = ACTIONS(52),
  },
  [220] = {
    [sym__terminated_statement] = STATE(611),
    [sym_for_statement] = STATE(612),
    [sym_while_statement] = STATE(612),
    [sym_if_statement] = STATE(612),
    [sym_elif_clause] = STATE(613),
    [sym_else_clause] = STATE(614),
    [sym_case_statement] = STATE(612),
    [sym_function_definition] = STATE(612),
    [sym_subshell] = STATE(612),
    [sym_pipeline] = STATE(612),
    [sym_list] = STATE(612),
    [sym_bracket_command] = STATE(612),
    [sym_command] = STATE(612),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(615),
    [sym_declaration_command] = STATE(612),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(616),
    [aux_sym_if_statement_repeat1] = STATE(617),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_fi] = ACTIONS(1138),
    [anon_sym_elif] = ACTIONS(1140),
    [anon_sym_else] = ACTIONS(1142),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [221] = {
    [sym_string] = STATE(618),
    [sym_simple_expansion] = STATE(618),
    [sym_expansion] = STATE(618),
    [sym_command_substitution] = STATE(618),
    [sym_process_substitution] = STATE(618),
    [sym__special_characters] = ACTIONS(1144),
    [anon_sym_DQUOTE] = ACTIONS(68),
    [sym_raw_string] = ACTIONS(1146),
    [anon_sym_DOLLAR] = ACTIONS(72),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(74),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(76),
    [anon_sym_BQUOTE] = ACTIONS(78),
    [anon_sym_LT_LPAREN] = ACTIONS(80),
    [anon_sym_GT_LPAREN] = ACTIONS(80),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1144),
  },
  [222] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1148),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1148),
    [anon_sym_LF] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(1148),
  },
  [223] = {
    [anon_sym_in] = ACTIONS(1150),
    [sym_comment] = ACTIONS(52),
  },
  [224] = {
    [aux_sym_concatenation_repeat1] = STATE(621),
    [sym__concat] = ACTIONS(406),
    [anon_sym_in] = ACTIONS(648),
    [anon_sym_SEMI_SEMI] = ACTIONS(648),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(648),
    [anon_sym_LF] = ACTIONS(648),
    [anon_sym_AMP] = ACTIONS(648),
  },
  [225] = {
    [sym__concat] = ACTIONS(650),
    [anon_sym_in] = ACTIONS(652),
    [anon_sym_SEMI_SEMI] = ACTIONS(652),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(652),
    [anon_sym_LF] = ACTIONS(652),
    [anon_sym_AMP] = ACTIONS(652),
  },
  [226] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(1152),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [227] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1154),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1154),
    [anon_sym_LF] = ACTIONS(1154),
    [anon_sym_AMP] = ACTIONS(1154),
  },
  [228] = {
    [anon_sym_in] = ACTIONS(1156),
    [sym_comment] = ACTIONS(52),
  },
  [229] = {
    [sym__concat] = ACTIONS(680),
    [anon_sym_in] = ACTIONS(682),
    [anon_sym_SEMI_SEMI] = ACTIONS(682),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(682),
    [anon_sym_LF] = ACTIONS(682),
    [anon_sym_AMP] = ACTIONS(682),
  },
  [230] = {
    [sym__concat] = ACTIONS(684),
    [anon_sym_in] = ACTIONS(686),
    [anon_sym_SEMI_SEMI] = ACTIONS(686),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(686),
    [anon_sym_LF] = ACTIONS(686),
    [anon_sym_AMP] = ACTIONS(686),
  },
  [231] = {
    [sym__concat] = ACTIONS(688),
    [anon_sym_in] = ACTIONS(690),
    [anon_sym_SEMI_SEMI] = ACTIONS(690),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(690),
    [anon_sym_LF] = ACTIONS(690),
    [anon_sym_AMP] = ACTIONS(690),
  },
  [232] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(1158),
    [sym_comment] = ACTIONS(52),
  },
  [233] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(627),
    [anon_sym_RBRACE] = ACTIONS(1160),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [234] = {
    [sym_subscript] = STATE(631),
    [sym_variable_name] = ACTIONS(1162),
    [anon_sym_DOLLAR] = ACTIONS(1164),
    [anon_sym_DASH] = ACTIONS(1164),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1166),
    [anon_sym_STAR] = ACTIONS(1164),
    [anon_sym_AT] = ACTIONS(1164),
    [anon_sym_QMARK] = ACTIONS(1164),
    [anon_sym_0] = ACTIONS(1168),
    [anon_sym__] = ACTIONS(1168),
  },
  [235] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(633),
    [anon_sym_RBRACE] = ACTIONS(1170),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [236] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(635),
    [anon_sym_RBRACE] = ACTIONS(1172),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [237] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1174),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [238] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1174),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [239] = {
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(1174),
    [sym_comment] = ACTIONS(52),
  },
  [240] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(1174),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [241] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1176),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [242] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1176),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [243] = {
    [anon_sym_RPAREN] = ACTIONS(1178),
    [sym_comment] = ACTIONS(52),
  },
  [244] = {
    [sym__terminated_statement] = STATE(640),
    [sym_for_statement] = STATE(641),
    [sym_while_statement] = STATE(641),
    [sym_if_statement] = STATE(641),
    [sym_case_statement] = STATE(641),
    [sym_function_definition] = STATE(641),
    [sym_subshell] = STATE(641),
    [sym_pipeline] = STATE(641),
    [sym_list] = STATE(641),
    [sym_bracket_command] = STATE(641),
    [sym_command] = STATE(641),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(642),
    [sym_declaration_command] = STATE(641),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(643),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_RBRACE] = ACTIONS(1180),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [245] = {
    [sym_file_redirect] = STATE(646),
    [sym_file_descriptor] = ACTIONS(1182),
    [anon_sym_PIPE] = ACTIONS(1184),
    [anon_sym_SEMI_SEMI] = ACTIONS(1184),
    [anon_sym_PIPE_AMP] = ACTIONS(1184),
    [anon_sym_AMP_AMP] = ACTIONS(1184),
    [anon_sym_PIPE_PIPE] = ACTIONS(1184),
    [anon_sym_LT] = ACTIONS(1186),
    [anon_sym_GT] = ACTIONS(1186),
    [anon_sym_GT_GT] = ACTIONS(1186),
    [anon_sym_AMP_GT] = ACTIONS(1186),
    [anon_sym_AMP_GT_GT] = ACTIONS(1186),
    [anon_sym_LT_AMP] = ACTIONS(1186),
    [anon_sym_GT_AMP] = ACTIONS(1186),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1184),
    [anon_sym_LF] = ACTIONS(1184),
    [anon_sym_AMP] = ACTIONS(1184),
  },
  [246] = {
    [sym_concatenation] = STATE(206),
    [sym_string] = STATE(649),
    [sym_array] = STATE(206),
    [sym_simple_expansion] = STATE(649),
    [sym_expansion] = STATE(649),
    [sym_command_substitution] = STATE(649),
    [sym_process_substitution] = STATE(649),
    [sym__empty_value] = ACTIONS(372),
    [anon_sym_LPAREN] = ACTIONS(374),
    [sym__special_characters] = ACTIONS(1188),
    [anon_sym_DQUOTE] = ACTIONS(1190),
    [sym_raw_string] = ACTIONS(1192),
    [anon_sym_DOLLAR] = ACTIONS(1194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1198),
    [anon_sym_BQUOTE] = ACTIONS(1200),
    [anon_sym_LT_LPAREN] = ACTIONS(1202),
    [anon_sym_GT_LPAREN] = ACTIONS(1202),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1204),
  },
  [247] = {
    [sym_do_group] = STATE(655),
    [anon_sym_do] = ACTIONS(400),
    [sym_comment] = ACTIONS(52),
  },
  [248] = {
    [sym_compound_statement] = STATE(657),
    [anon_sym_LPAREN] = ACTIONS(1206),
    [anon_sym_LBRACE] = ACTIONS(436),
    [sym_comment] = ACTIONS(52),
  },
  [249] = {
    [sym__assignment] = STATE(334),
    [anon_sym_LBRACK] = ACTIONS(60),
    [anon_sym_EQ] = ACTIONS(1208),
    [anon_sym_PLUS_EQ] = ACTIONS(1208),
    [sym_comment] = ACTIONS(52),
  },
  [250] = {
    [aux_sym_concatenation_repeat1] = STATE(660),
    [sym__concat] = ACTIONS(1210),
    [sym_variable_name] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_RPAREN] = ACTIONS(582),
    [anon_sym_SEMI_SEMI] = ACTIONS(582),
    [anon_sym_PIPE_AMP] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [sym__special_characters] = ACTIONS(582),
    [anon_sym_DQUOTE] = ACTIONS(582),
    [sym_raw_string] = ACTIONS(582),
    [anon_sym_DOLLAR] = ACTIONS(582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(582),
    [anon_sym_BQUOTE] = ACTIONS(582),
    [anon_sym_LT_LPAREN] = ACTIONS(582),
    [anon_sym_GT_LPAREN] = ACTIONS(582),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(582),
    [sym_word] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(582),
    [anon_sym_LF] = ACTIONS(582),
    [anon_sym_AMP] = ACTIONS(582),
  },
  [251] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(662),
    [anon_sym_DQUOTE] = ACTIONS(1212),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [252] = {
    [aux_sym_concatenation_repeat1] = STATE(660),
    [sym__concat] = ACTIONS(1210),
    [sym_variable_name] = ACTIONS(586),
    [anon_sym_PIPE] = ACTIONS(588),
    [anon_sym_RPAREN] = ACTIONS(588),
    [anon_sym_SEMI_SEMI] = ACTIONS(588),
    [anon_sym_PIPE_AMP] = ACTIONS(588),
    [anon_sym_AMP_AMP] = ACTIONS(588),
    [anon_sym_PIPE_PIPE] = ACTIONS(588),
    [sym__special_characters] = ACTIONS(588),
    [anon_sym_DQUOTE] = ACTIONS(588),
    [sym_raw_string] = ACTIONS(588),
    [anon_sym_DOLLAR] = ACTIONS(588),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(588),
    [anon_sym_BQUOTE] = ACTIONS(588),
    [anon_sym_LT_LPAREN] = ACTIONS(588),
    [anon_sym_GT_LPAREN] = ACTIONS(588),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(588),
    [sym_word] = ACTIONS(588),
    [anon_sym_SEMI] = ACTIONS(588),
    [anon_sym_LF] = ACTIONS(588),
    [anon_sym_AMP] = ACTIONS(588),
  },
  [253] = {
    [sym_string] = STATE(665),
    [anon_sym_DQUOTE] = ACTIONS(1214),
    [anon_sym_DOLLAR] = ACTIONS(1216),
    [anon_sym_POUND] = ACTIONS(1216),
    [anon_sym_DASH] = ACTIONS(1216),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1218),
    [anon_sym_STAR] = ACTIONS(1216),
    [anon_sym_AT] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(1216),
    [anon_sym_0] = ACTIONS(1220),
    [anon_sym__] = ACTIONS(1220),
  },
  [254] = {
    [sym_subscript] = STATE(670),
    [sym_variable_name] = ACTIONS(1222),
    [anon_sym_DOLLAR] = ACTIONS(1224),
    [anon_sym_POUND] = ACTIONS(1226),
    [anon_sym_DASH] = ACTIONS(1224),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1228),
    [anon_sym_STAR] = ACTIONS(1224),
    [anon_sym_AT] = ACTIONS(1224),
    [anon_sym_QMARK] = ACTIONS(1224),
    [anon_sym_0] = ACTIONS(1230),
    [anon_sym__] = ACTIONS(1230),
  },
  [255] = {
    [sym_for_statement] = STATE(671),
    [sym_while_statement] = STATE(671),
    [sym_if_statement] = STATE(671),
    [sym_case_statement] = STATE(671),
    [sym_function_definition] = STATE(671),
    [sym_subshell] = STATE(671),
    [sym_pipeline] = STATE(671),
    [sym_list] = STATE(671),
    [sym_bracket_command] = STATE(671),
    [sym_command] = STATE(671),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(672),
    [sym_declaration_command] = STATE(671),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [256] = {
    [sym_for_statement] = STATE(673),
    [sym_while_statement] = STATE(673),
    [sym_if_statement] = STATE(673),
    [sym_case_statement] = STATE(673),
    [sym_function_definition] = STATE(673),
    [sym_subshell] = STATE(673),
    [sym_pipeline] = STATE(673),
    [sym_list] = STATE(673),
    [sym_bracket_command] = STATE(673),
    [sym_command] = STATE(673),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(674),
    [sym_declaration_command] = STATE(673),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [257] = {
    [sym_for_statement] = STATE(675),
    [sym_while_statement] = STATE(675),
    [sym_if_statement] = STATE(675),
    [sym_case_statement] = STATE(675),
    [sym_function_definition] = STATE(675),
    [sym_subshell] = STATE(675),
    [sym_pipeline] = STATE(675),
    [sym_list] = STATE(675),
    [sym_bracket_command] = STATE(675),
    [sym_command] = STATE(675),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(676),
    [sym_declaration_command] = STATE(675),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [258] = {
    [sym__assignment] = STATE(334),
    [anon_sym_EQ] = ACTIONS(1208),
    [anon_sym_PLUS_EQ] = ACTIONS(1208),
    [sym_comment] = ACTIONS(52),
  },
  [259] = {
    [sym_variable_assignment] = STATE(101),
    [sym_subscript] = STATE(258),
    [sym_concatenation] = STATE(101),
    [sym_string] = STATE(252),
    [sym_simple_expansion] = STATE(252),
    [sym_expansion] = STATE(252),
    [sym_command_substitution] = STATE(252),
    [sym_process_substitution] = STATE(252),
    [aux_sym_declaration_command_repeat1] = STATE(677),
    [sym_variable_name] = ACTIONS(442),
    [anon_sym_PIPE] = ACTIONS(612),
    [anon_sym_RPAREN] = ACTIONS(612),
    [anon_sym_SEMI_SEMI] = ACTIONS(612),
    [anon_sym_PIPE_AMP] = ACTIONS(612),
    [anon_sym_AMP_AMP] = ACTIONS(612),
    [anon_sym_PIPE_PIPE] = ACTIONS(612),
    [sym__special_characters] = ACTIONS(444),
    [anon_sym_DQUOTE] = ACTIONS(446),
    [sym_raw_string] = ACTIONS(448),
    [anon_sym_DOLLAR] = ACTIONS(450),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(452),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(454),
    [anon_sym_BQUOTE] = ACTIONS(456),
    [anon_sym_LT_LPAREN] = ACTIONS(458),
    [anon_sym_GT_LPAREN] = ACTIONS(458),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(170),
    [sym_word] = ACTIONS(448),
    [anon_sym_SEMI] = ACTIONS(612),
    [anon_sym_LF] = ACTIONS(612),
    [anon_sym_AMP] = ACTIONS(612),
  },
  [260] = {
    [sym_string] = STATE(678),
    [sym_simple_expansion] = STATE(678),
    [sym_expansion] = STATE(678),
    [sym_command_substitution] = STATE(678),
    [sym_process_substitution] = STATE(678),
    [sym__special_characters] = ACTIONS(1232),
    [anon_sym_DQUOTE] = ACTIONS(96),
    [sym_raw_string] = ACTIONS(1234),
    [anon_sym_DOLLAR] = ACTIONS(100),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(102),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(104),
    [anon_sym_BQUOTE] = ACTIONS(106),
    [anon_sym_LT_LPAREN] = ACTIONS(108),
    [anon_sym_GT_LPAREN] = ACTIONS(108),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1232),
  },
  [261] = {
    [aux_sym_concatenation_repeat1] = STATE(679),
    [sym_file_descriptor] = ACTIONS(646),
    [sym__concat] = ACTIONS(460),
    [anon_sym_PIPE] = ACTIONS(648),
    [anon_sym_RPAREN] = ACTIONS(648),
    [anon_sym_SEMI_SEMI] = ACTIONS(648),
    [anon_sym_PIPE_AMP] = ACTIONS(648),
    [anon_sym_AMP_AMP] = ACTIONS(648),
    [anon_sym_PIPE_PIPE] = ACTIONS(648),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(648),
    [anon_sym_GT_GT] = ACTIONS(648),
    [anon_sym_AMP_GT] = ACTIONS(648),
    [anon_sym_AMP_GT_GT] = ACTIONS(648),
    [anon_sym_LT_AMP] = ACTIONS(648),
    [anon_sym_GT_AMP] = ACTIONS(648),
    [anon_sym_LT_LT] = ACTIONS(648),
    [anon_sym_LT_LT_DASH] = ACTIONS(648),
    [anon_sym_LT_LT_LT] = ACTIONS(648),
    [sym__special_characters] = ACTIONS(648),
    [anon_sym_DQUOTE] = ACTIONS(648),
    [sym_raw_string] = ACTIONS(648),
    [anon_sym_DOLLAR] = ACTIONS(648),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(648),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(648),
    [anon_sym_BQUOTE] = ACTIONS(648),
    [anon_sym_LT_LPAREN] = ACTIONS(648),
    [anon_sym_GT_LPAREN] = ACTIONS(648),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(648),
    [anon_sym_SEMI] = ACTIONS(648),
    [anon_sym_LF] = ACTIONS(648),
    [anon_sym_AMP] = ACTIONS(648),
  },
  [262] = {
    [sym_file_descriptor] = ACTIONS(650),
    [sym__concat] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(652),
    [anon_sym_RPAREN] = ACTIONS(652),
    [anon_sym_SEMI_SEMI] = ACTIONS(652),
    [anon_sym_PIPE_AMP] = ACTIONS(652),
    [anon_sym_AMP_AMP] = ACTIONS(652),
    [anon_sym_PIPE_PIPE] = ACTIONS(652),
    [anon_sym_LT] = ACTIONS(652),
    [anon_sym_GT] = ACTIONS(652),
    [anon_sym_GT_GT] = ACTIONS(652),
    [anon_sym_AMP_GT] = ACTIONS(652),
    [anon_sym_AMP_GT_GT] = ACTIONS(652),
    [anon_sym_LT_AMP] = ACTIONS(652),
    [anon_sym_GT_AMP] = ACTIONS(652),
    [anon_sym_LT_LT] = ACTIONS(652),
    [anon_sym_LT_LT_DASH] = ACTIONS(652),
    [anon_sym_LT_LT_LT] = ACTIONS(652),
    [sym__special_characters] = ACTIONS(652),
    [anon_sym_DQUOTE] = ACTIONS(652),
    [sym_raw_string] = ACTIONS(652),
    [anon_sym_DOLLAR] = ACTIONS(652),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(652),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(652),
    [anon_sym_BQUOTE] = ACTIONS(652),
    [anon_sym_LT_LPAREN] = ACTIONS(652),
    [anon_sym_GT_LPAREN] = ACTIONS(652),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(652),
    [anon_sym_SEMI] = ACTIONS(652),
    [anon_sym_LF] = ACTIONS(652),
    [anon_sym_AMP] = ACTIONS(652),
  },
  [263] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(1236),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [264] = {
    [sym_file_descriptor] = ACTIONS(680),
    [sym__concat] = ACTIONS(680),
    [anon_sym_PIPE] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(682),
    [anon_sym_SEMI_SEMI] = ACTIONS(682),
    [anon_sym_PIPE_AMP] = ACTIONS(682),
    [anon_sym_AMP_AMP] = ACTIONS(682),
    [anon_sym_PIPE_PIPE] = ACTIONS(682),
    [anon_sym_LT] = ACTIONS(682),
    [anon_sym_GT] = ACTIONS(682),
    [anon_sym_GT_GT] = ACTIONS(682),
    [anon_sym_AMP_GT] = ACTIONS(682),
    [anon_sym_AMP_GT_GT] = ACTIONS(682),
    [anon_sym_LT_AMP] = ACTIONS(682),
    [anon_sym_GT_AMP] = ACTIONS(682),
    [anon_sym_LT_LT] = ACTIONS(682),
    [anon_sym_LT_LT_DASH] = ACTIONS(682),
    [anon_sym_LT_LT_LT] = ACTIONS(682),
    [sym__special_characters] = ACTIONS(682),
    [anon_sym_DQUOTE] = ACTIONS(682),
    [sym_raw_string] = ACTIONS(682),
    [anon_sym_DOLLAR] = ACTIONS(682),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(682),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(682),
    [anon_sym_BQUOTE] = ACTIONS(682),
    [anon_sym_LT_LPAREN] = ACTIONS(682),
    [anon_sym_GT_LPAREN] = ACTIONS(682),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(682),
    [anon_sym_SEMI] = ACTIONS(682),
    [anon_sym_LF] = ACTIONS(682),
    [anon_sym_AMP] = ACTIONS(682),
  },
  [265] = {
    [sym_file_descriptor] = ACTIONS(684),
    [sym__concat] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(686),
    [anon_sym_RPAREN] = ACTIONS(686),
    [anon_sym_SEMI_SEMI] = ACTIONS(686),
    [anon_sym_PIPE_AMP] = ACTIONS(686),
    [anon_sym_AMP_AMP] = ACTIONS(686),
    [anon_sym_PIPE_PIPE] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(686),
    [anon_sym_GT] = ACTIONS(686),
    [anon_sym_GT_GT] = ACTIONS(686),
    [anon_sym_AMP_GT] = ACTIONS(686),
    [anon_sym_AMP_GT_GT] = ACTIONS(686),
    [anon_sym_LT_AMP] = ACTIONS(686),
    [anon_sym_GT_AMP] = ACTIONS(686),
    [anon_sym_LT_LT] = ACTIONS(686),
    [anon_sym_LT_LT_DASH] = ACTIONS(686),
    [anon_sym_LT_LT_LT] = ACTIONS(686),
    [sym__special_characters] = ACTIONS(686),
    [anon_sym_DQUOTE] = ACTIONS(686),
    [sym_raw_string] = ACTIONS(686),
    [anon_sym_DOLLAR] = ACTIONS(686),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(686),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(686),
    [anon_sym_BQUOTE] = ACTIONS(686),
    [anon_sym_LT_LPAREN] = ACTIONS(686),
    [anon_sym_GT_LPAREN] = ACTIONS(686),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(686),
    [anon_sym_SEMI] = ACTIONS(686),
    [anon_sym_LF] = ACTIONS(686),
    [anon_sym_AMP] = ACTIONS(686),
  },
  [266] = {
    [sym_file_descriptor] = ACTIONS(688),
    [sym__concat] = ACTIONS(688),
    [anon_sym_PIPE] = ACTIONS(690),
    [anon_sym_RPAREN] = ACTIONS(690),
    [anon_sym_SEMI_SEMI] = ACTIONS(690),
    [anon_sym_PIPE_AMP] = ACTIONS(690),
    [anon_sym_AMP_AMP] = ACTIONS(690),
    [anon_sym_PIPE_PIPE] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(690),
    [anon_sym_GT] = ACTIONS(690),
    [anon_sym_GT_GT] = ACTIONS(690),
    [anon_sym_AMP_GT] = ACTIONS(690),
    [anon_sym_AMP_GT_GT] = ACTIONS(690),
    [anon_sym_LT_AMP] = ACTIONS(690),
    [anon_sym_GT_AMP] = ACTIONS(690),
    [anon_sym_LT_LT] = ACTIONS(690),
    [anon_sym_LT_LT_DASH] = ACTIONS(690),
    [anon_sym_LT_LT_LT] = ACTIONS(690),
    [sym__special_characters] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(690),
    [sym_raw_string] = ACTIONS(690),
    [anon_sym_DOLLAR] = ACTIONS(690),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(690),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(690),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [anon_sym_LT_LPAREN] = ACTIONS(690),
    [anon_sym_GT_LPAREN] = ACTIONS(690),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(690),
    [anon_sym_SEMI] = ACTIONS(690),
    [anon_sym_LF] = ACTIONS(690),
    [anon_sym_AMP] = ACTIONS(690),
  },
  [267] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(1238),
    [sym_comment] = ACTIONS(52),
  },
  [268] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(683),
    [anon_sym_RBRACE] = ACTIONS(1240),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [269] = {
    [sym_subscript] = STATE(687),
    [sym_variable_name] = ACTIONS(1242),
    [anon_sym_DOLLAR] = ACTIONS(1244),
    [anon_sym_DASH] = ACTIONS(1244),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1246),
    [anon_sym_STAR] = ACTIONS(1244),
    [anon_sym_AT] = ACTIONS(1244),
    [anon_sym_QMARK] = ACTIONS(1244),
    [anon_sym_0] = ACTIONS(1248),
    [anon_sym__] = ACTIONS(1248),
  },
  [270] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(689),
    [anon_sym_RBRACE] = ACTIONS(1250),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [271] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(691),
    [anon_sym_RBRACE] = ACTIONS(1252),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [272] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1254),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [273] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1254),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [274] = {
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(1254),
    [sym_comment] = ACTIONS(52),
  },
  [275] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(1254),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [276] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1256),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [277] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1256),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [278] = {
    [anon_sym_RPAREN] = ACTIONS(1258),
    [sym_comment] = ACTIONS(52),
  },
  [279] = {
    [sym_for_statement] = STATE(516),
    [sym_while_statement] = STATE(516),
    [sym_if_statement] = STATE(516),
    [sym_case_statement] = STATE(516),
    [sym_function_definition] = STATE(516),
    [sym_subshell] = STATE(516),
    [sym_pipeline] = STATE(516),
    [sym_list] = STATE(516),
    [sym_bracket_command] = STATE(516),
    [sym_command] = STATE(516),
    [sym_command_name] = STATE(66),
    [sym_variable_assignment] = STATE(517),
    [sym_declaration_command] = STATE(516),
    [sym_subscript] = STATE(68),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(58),
    [sym_simple_expansion] = STATE(58),
    [sym_expansion] = STATE(58),
    [sym_command_substitution] = STATE(58),
    [sym_process_substitution] = STATE(58),
    [aux_sym_command_repeat1] = STATE(70),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(86),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(88),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(90),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(92),
    [anon_sym_typeset] = ACTIONS(92),
    [anon_sym_export] = ACTIONS(92),
    [anon_sym_readonly] = ACTIONS(92),
    [anon_sym_local] = ACTIONS(92),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(94),
    [anon_sym_DQUOTE] = ACTIONS(96),
    [sym_raw_string] = ACTIONS(98),
    [anon_sym_DOLLAR] = ACTIONS(100),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(102),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(104),
    [anon_sym_BQUOTE] = ACTIONS(106),
    [anon_sym_LT_LPAREN] = ACTIONS(108),
    [anon_sym_GT_LPAREN] = ACTIONS(108),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(110),
  },
  [280] = {
    [anon_sym_PIPE] = ACTIONS(1260),
    [anon_sym_RPAREN] = ACTIONS(1260),
    [anon_sym_SEMI_SEMI] = ACTIONS(1260),
    [anon_sym_PIPE_AMP] = ACTIONS(1260),
    [anon_sym_AMP_AMP] = ACTIONS(1260),
    [anon_sym_PIPE_PIPE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1260),
    [anon_sym_LF] = ACTIONS(1260),
    [anon_sym_AMP] = ACTIONS(1260),
  },
  [281] = {
    [sym_file_descriptor] = ACTIONS(902),
    [sym_variable_name] = ACTIONS(902),
    [anon_sym_for] = ACTIONS(904),
    [anon_sym_while] = ACTIONS(904),
    [anon_sym_if] = ACTIONS(904),
    [anon_sym_case] = ACTIONS(904),
    [anon_sym_RPAREN] = ACTIONS(1262),
    [anon_sym_function] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(902),
    [anon_sym_LBRACK] = ACTIONS(904),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym_declare] = ACTIONS(904),
    [anon_sym_typeset] = ACTIONS(904),
    [anon_sym_export] = ACTIONS(904),
    [anon_sym_readonly] = ACTIONS(904),
    [anon_sym_local] = ACTIONS(904),
    [anon_sym_LT] = ACTIONS(904),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_GT_GT] = ACTIONS(902),
    [anon_sym_AMP_GT] = ACTIONS(904),
    [anon_sym_AMP_GT_GT] = ACTIONS(902),
    [anon_sym_LT_AMP] = ACTIONS(902),
    [anon_sym_GT_AMP] = ACTIONS(902),
    [sym__special_characters] = ACTIONS(906),
    [anon_sym_DQUOTE] = ACTIONS(902),
    [sym_raw_string] = ACTIONS(902),
    [anon_sym_DOLLAR] = ACTIONS(904),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(902),
    [anon_sym_BQUOTE] = ACTIONS(902),
    [anon_sym_LT_LPAREN] = ACTIONS(902),
    [anon_sym_GT_LPAREN] = ACTIONS(902),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(906),
  },
  [282] = {
    [sym_for_statement] = STATE(696),
    [sym_while_statement] = STATE(696),
    [sym_if_statement] = STATE(696),
    [sym_case_statement] = STATE(696),
    [sym_function_definition] = STATE(696),
    [sym_subshell] = STATE(696),
    [sym_pipeline] = STATE(696),
    [sym_list] = STATE(696),
    [sym_bracket_command] = STATE(696),
    [sym_command] = STATE(696),
    [sym_command_name] = STATE(66),
    [sym_variable_assignment] = STATE(697),
    [sym_declaration_command] = STATE(696),
    [sym_subscript] = STATE(68),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(58),
    [sym_simple_expansion] = STATE(58),
    [sym_expansion] = STATE(58),
    [sym_command_substitution] = STATE(58),
    [sym_process_substitution] = STATE(58),
    [aux_sym_command_repeat1] = STATE(70),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(86),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(88),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(90),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(92),
    [anon_sym_typeset] = ACTIONS(92),
    [anon_sym_export] = ACTIONS(92),
    [anon_sym_readonly] = ACTIONS(92),
    [anon_sym_local] = ACTIONS(92),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(94),
    [anon_sym_DQUOTE] = ACTIONS(96),
    [sym_raw_string] = ACTIONS(98),
    [anon_sym_DOLLAR] = ACTIONS(100),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(102),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(104),
    [anon_sym_BQUOTE] = ACTIONS(106),
    [anon_sym_LT_LPAREN] = ACTIONS(108),
    [anon_sym_GT_LPAREN] = ACTIONS(108),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(110),
  },
  [283] = {
    [anon_sym_LT] = ACTIONS(1264),
    [anon_sym_GT] = ACTIONS(1264),
    [anon_sym_GT_GT] = ACTIONS(1266),
    [anon_sym_AMP_GT] = ACTIONS(1264),
    [anon_sym_AMP_GT_GT] = ACTIONS(1266),
    [anon_sym_LT_AMP] = ACTIONS(1266),
    [anon_sym_GT_AMP] = ACTIONS(1266),
    [sym_comment] = ACTIONS(52),
  },
  [284] = {
    [sym_concatenation] = STATE(529),
    [sym_string] = STATE(701),
    [sym_simple_expansion] = STATE(701),
    [sym_expansion] = STATE(701),
    [sym_command_substitution] = STATE(701),
    [sym_process_substitution] = STATE(701),
    [sym__special_characters] = ACTIONS(1268),
    [anon_sym_DQUOTE] = ACTIONS(1270),
    [sym_raw_string] = ACTIONS(1272),
    [anon_sym_DOLLAR] = ACTIONS(1274),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1276),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1278),
    [anon_sym_BQUOTE] = ACTIONS(1280),
    [anon_sym_LT_LPAREN] = ACTIONS(1282),
    [anon_sym_GT_LPAREN] = ACTIONS(1282),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1284),
  },
  [285] = {
    [sym_concatenation] = STATE(535),
    [sym_string] = STATE(708),
    [sym_simple_expansion] = STATE(708),
    [sym_expansion] = STATE(708),
    [sym_command_substitution] = STATE(708),
    [sym_process_substitution] = STATE(708),
    [sym__special_characters] = ACTIONS(1286),
    [anon_sym_DQUOTE] = ACTIONS(1270),
    [sym_raw_string] = ACTIONS(1288),
    [anon_sym_DOLLAR] = ACTIONS(1274),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1276),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1278),
    [anon_sym_BQUOTE] = ACTIONS(1280),
    [anon_sym_LT_LPAREN] = ACTIONS(1282),
    [anon_sym_GT_LPAREN] = ACTIONS(1282),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1290),
  },
  [286] = {
    [aux_sym_concatenation_repeat1] = STATE(261),
    [sym_file_descriptor] = ACTIONS(522),
    [sym__concat] = ACTIONS(460),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_RPAREN] = ACTIONS(520),
    [anon_sym_SEMI_SEMI] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(520),
    [anon_sym_AMP_AMP] = ACTIONS(520),
    [anon_sym_PIPE_PIPE] = ACTIONS(520),
    [anon_sym_LT] = ACTIONS(520),
    [anon_sym_GT] = ACTIONS(520),
    [anon_sym_GT_GT] = ACTIONS(520),
    [anon_sym_AMP_GT] = ACTIONS(520),
    [anon_sym_AMP_GT_GT] = ACTIONS(520),
    [anon_sym_LT_AMP] = ACTIONS(520),
    [anon_sym_GT_AMP] = ACTIONS(520),
    [anon_sym_LT_LT] = ACTIONS(520),
    [anon_sym_LT_LT_DASH] = ACTIONS(520),
    [anon_sym_LT_LT_LT] = ACTIONS(520),
    [sym__special_characters] = ACTIONS(520),
    [anon_sym_DQUOTE] = ACTIONS(520),
    [sym_raw_string] = ACTIONS(520),
    [anon_sym_DOLLAR] = ACTIONS(520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(520),
    [anon_sym_BQUOTE] = ACTIONS(520),
    [anon_sym_LT_LPAREN] = ACTIONS(520),
    [anon_sym_GT_LPAREN] = ACTIONS(520),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(520),
    [anon_sym_SEMI] = ACTIONS(520),
    [anon_sym_LF] = ACTIONS(520),
    [anon_sym_AMP] = ACTIONS(520),
  },
  [287] = {
    [aux_sym_concatenation_repeat1] = STATE(261),
    [sym_file_descriptor] = ACTIONS(530),
    [sym__concat] = ACTIONS(460),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(528),
    [anon_sym_SEMI_SEMI] = ACTIONS(528),
    [anon_sym_PIPE_AMP] = ACTIONS(528),
    [anon_sym_AMP_AMP] = ACTIONS(528),
    [anon_sym_PIPE_PIPE] = ACTIONS(528),
    [anon_sym_LT] = ACTIONS(528),
    [anon_sym_GT] = ACTIONS(528),
    [anon_sym_GT_GT] = ACTIONS(528),
    [anon_sym_AMP_GT] = ACTIONS(528),
    [anon_sym_AMP_GT_GT] = ACTIONS(528),
    [anon_sym_LT_AMP] = ACTIONS(528),
    [anon_sym_GT_AMP] = ACTIONS(528),
    [anon_sym_LT_LT] = ACTIONS(528),
    [anon_sym_LT_LT_DASH] = ACTIONS(528),
    [anon_sym_LT_LT_LT] = ACTIONS(528),
    [sym__special_characters] = ACTIONS(528),
    [anon_sym_DQUOTE] = ACTIONS(528),
    [sym_raw_string] = ACTIONS(528),
    [anon_sym_DOLLAR] = ACTIONS(528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(528),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(528),
    [anon_sym_BQUOTE] = ACTIONS(528),
    [anon_sym_LT_LPAREN] = ACTIONS(528),
    [anon_sym_GT_LPAREN] = ACTIONS(528),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(528),
    [anon_sym_SEMI] = ACTIONS(528),
    [anon_sym_LF] = ACTIONS(528),
    [anon_sym_AMP] = ACTIONS(528),
  },
  [288] = {
    [sym_file_redirect] = STATE(185),
    [sym_heredoc_redirect] = STATE(185),
    [sym_herestring_redirect] = STATE(185),
    [sym_concatenation] = STATE(186),
    [sym_string] = STATE(287),
    [sym_simple_expansion] = STATE(287),
    [sym_expansion] = STATE(287),
    [sym_command_substitution] = STATE(287),
    [sym_process_substitution] = STATE(287),
    [aux_sym_for_statement_repeat1] = STATE(709),
    [aux_sym_while_statement_repeat1] = STATE(710),
    [sym_file_descriptor] = ACTIONS(490),
    [anon_sym_PIPE] = ACTIONS(944),
    [anon_sym_RPAREN] = ACTIONS(944),
    [anon_sym_SEMI_SEMI] = ACTIONS(944),
    [anon_sym_PIPE_AMP] = ACTIONS(944),
    [anon_sym_AMP_AMP] = ACTIONS(944),
    [anon_sym_PIPE_PIPE] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_GT] = ACTIONS(492),
    [anon_sym_GT_GT] = ACTIONS(492),
    [anon_sym_AMP_GT] = ACTIONS(492),
    [anon_sym_AMP_GT_GT] = ACTIONS(492),
    [anon_sym_LT_AMP] = ACTIONS(492),
    [anon_sym_GT_AMP] = ACTIONS(492),
    [anon_sym_LT_LT] = ACTIONS(314),
    [anon_sym_LT_LT_DASH] = ACTIONS(314),
    [anon_sym_LT_LT_LT] = ACTIONS(494),
    [sym__special_characters] = ACTIONS(496),
    [anon_sym_DQUOTE] = ACTIONS(498),
    [sym_raw_string] = ACTIONS(500),
    [anon_sym_DOLLAR] = ACTIONS(502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(504),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(506),
    [anon_sym_BQUOTE] = ACTIONS(508),
    [anon_sym_LT_LPAREN] = ACTIONS(510),
    [anon_sym_GT_LPAREN] = ACTIONS(510),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(500),
    [anon_sym_SEMI] = ACTIONS(944),
    [anon_sym_LF] = ACTIONS(944),
    [anon_sym_AMP] = ACTIONS(944),
  },
  [289] = {
    [sym_file_redirect] = STATE(185),
    [sym_heredoc_redirect] = STATE(185),
    [sym_herestring_redirect] = STATE(185),
    [aux_sym_while_statement_repeat1] = STATE(711),
    [sym_file_descriptor] = ACTIONS(490),
    [anon_sym_PIPE] = ACTIONS(944),
    [anon_sym_RPAREN] = ACTIONS(944),
    [anon_sym_SEMI_SEMI] = ACTIONS(944),
    [anon_sym_PIPE_AMP] = ACTIONS(944),
    [anon_sym_AMP_AMP] = ACTIONS(944),
    [anon_sym_PIPE_PIPE] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_GT] = ACTIONS(492),
    [anon_sym_GT_GT] = ACTIONS(492),
    [anon_sym_AMP_GT] = ACTIONS(492),
    [anon_sym_AMP_GT_GT] = ACTIONS(492),
    [anon_sym_LT_AMP] = ACTIONS(492),
    [anon_sym_GT_AMP] = ACTIONS(492),
    [anon_sym_LT_LT] = ACTIONS(314),
    [anon_sym_LT_LT_DASH] = ACTIONS(314),
    [anon_sym_LT_LT_LT] = ACTIONS(494),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(944),
    [anon_sym_LF] = ACTIONS(944),
    [anon_sym_AMP] = ACTIONS(944),
  },
  [290] = {
    [anon_sym_PIPE] = ACTIONS(482),
    [anon_sym_RPAREN] = ACTIONS(1292),
    [anon_sym_SEMI_SEMI] = ACTIONS(1294),
    [anon_sym_PIPE_AMP] = ACTIONS(482),
    [anon_sym_AMP_AMP] = ACTIONS(488),
    [anon_sym_PIPE_PIPE] = ACTIONS(488),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1294),
    [anon_sym_LF] = ACTIONS(1294),
    [anon_sym_AMP] = ACTIONS(1294),
  },
  [291] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(482),
    [anon_sym_RPAREN] = ACTIONS(1292),
    [anon_sym_SEMI_SEMI] = ACTIONS(1294),
    [anon_sym_PIPE_AMP] = ACTIONS(482),
    [anon_sym_AMP_AMP] = ACTIONS(488),
    [anon_sym_PIPE_PIPE] = ACTIONS(488),
    [anon_sym_LT] = ACTIONS(336),
    [anon_sym_GT] = ACTIONS(336),
    [anon_sym_GT_GT] = ACTIONS(336),
    [anon_sym_AMP_GT] = ACTIONS(336),
    [anon_sym_AMP_GT_GT] = ACTIONS(336),
    [anon_sym_LT_AMP] = ACTIONS(336),
    [anon_sym_GT_AMP] = ACTIONS(336),
    [sym__special_characters] = ACTIONS(336),
    [anon_sym_DQUOTE] = ACTIONS(336),
    [sym_raw_string] = ACTIONS(336),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(336),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(336),
    [anon_sym_BQUOTE] = ACTIONS(336),
    [anon_sym_LT_LPAREN] = ACTIONS(336),
    [anon_sym_GT_LPAREN] = ACTIONS(336),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(336),
    [anon_sym_SEMI] = ACTIONS(1294),
    [anon_sym_LF] = ACTIONS(1294),
    [anon_sym_AMP] = ACTIONS(1294),
  },
  [292] = {
    [sym__terminated_statement] = STATE(24),
    [sym_for_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_case_statement] = STATE(25),
    [sym_function_definition] = STATE(25),
    [sym_subshell] = STATE(25),
    [sym_pipeline] = STATE(25),
    [sym_list] = STATE(25),
    [sym_bracket_command] = STATE(25),
    [sym_command] = STATE(25),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(27),
    [sym_declaration_command] = STATE(25),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(292),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(946),
    [sym_variable_name] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(954),
    [anon_sym_while] = ACTIONS(957),
    [anon_sym_if] = ACTIONS(960),
    [anon_sym_case] = ACTIONS(963),
    [anon_sym_function] = ACTIONS(966),
    [anon_sym_LPAREN] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_typeset] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_local] = ACTIONS(978),
    [anon_sym_LT] = ACTIONS(981),
    [anon_sym_GT] = ACTIONS(981),
    [anon_sym_GT_GT] = ACTIONS(984),
    [anon_sym_AMP_GT] = ACTIONS(981),
    [anon_sym_AMP_GT_GT] = ACTIONS(984),
    [anon_sym_LT_AMP] = ACTIONS(984),
    [anon_sym_GT_AMP] = ACTIONS(984),
    [sym__special_characters] = ACTIONS(987),
    [anon_sym_DQUOTE] = ACTIONS(990),
    [sym_raw_string] = ACTIONS(993),
    [anon_sym_DOLLAR] = ACTIONS(996),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(999),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1002),
    [anon_sym_BQUOTE] = ACTIONS(1005),
    [anon_sym_LT_LPAREN] = ACTIONS(1008),
    [anon_sym_GT_LPAREN] = ACTIONS(1008),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1011),
  },
  [293] = {
    [sym_file_redirect] = STATE(185),
    [sym_heredoc_redirect] = STATE(185),
    [sym_herestring_redirect] = STATE(185),
    [sym_concatenation] = STATE(186),
    [sym_string] = STATE(287),
    [sym_simple_expansion] = STATE(287),
    [sym_expansion] = STATE(287),
    [sym_command_substitution] = STATE(287),
    [sym_process_substitution] = STATE(287),
    [aux_sym_for_statement_repeat1] = STATE(713),
    [aux_sym_while_statement_repeat1] = STATE(710),
    [sym_file_descriptor] = ACTIONS(490),
    [anon_sym_PIPE] = ACTIONS(944),
    [anon_sym_RPAREN] = ACTIONS(944),
    [anon_sym_SEMI_SEMI] = ACTIONS(944),
    [anon_sym_PIPE_AMP] = ACTIONS(944),
    [anon_sym_AMP_AMP] = ACTIONS(944),
    [anon_sym_PIPE_PIPE] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_GT] = ACTIONS(492),
    [anon_sym_GT_GT] = ACTIONS(492),
    [anon_sym_AMP_GT] = ACTIONS(492),
    [anon_sym_AMP_GT_GT] = ACTIONS(492),
    [anon_sym_LT_AMP] = ACTIONS(492),
    [anon_sym_GT_AMP] = ACTIONS(492),
    [anon_sym_LT_LT] = ACTIONS(314),
    [anon_sym_LT_LT_DASH] = ACTIONS(314),
    [anon_sym_LT_LT_LT] = ACTIONS(494),
    [sym__special_characters] = ACTIONS(496),
    [anon_sym_DQUOTE] = ACTIONS(498),
    [sym_raw_string] = ACTIONS(500),
    [anon_sym_DOLLAR] = ACTIONS(502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(504),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(506),
    [anon_sym_BQUOTE] = ACTIONS(508),
    [anon_sym_LT_LPAREN] = ACTIONS(510),
    [anon_sym_GT_LPAREN] = ACTIONS(510),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(500),
    [anon_sym_SEMI] = ACTIONS(944),
    [anon_sym_LF] = ACTIONS(944),
    [anon_sym_AMP] = ACTIONS(944),
  },
  [294] = {
    [sym_string] = STATE(714),
    [sym_simple_expansion] = STATE(714),
    [sym_expansion] = STATE(714),
    [sym_command_substitution] = STATE(714),
    [sym_process_substitution] = STATE(714),
    [sym__special_characters] = ACTIONS(1296),
    [anon_sym_DQUOTE] = ACTIONS(114),
    [sym_raw_string] = ACTIONS(1298),
    [anon_sym_DOLLAR] = ACTIONS(118),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(120),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(122),
    [anon_sym_BQUOTE] = ACTIONS(124),
    [anon_sym_LT_LPAREN] = ACTIONS(126),
    [anon_sym_GT_LPAREN] = ACTIONS(126),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1296),
  },
  [295] = {
    [aux_sym_concatenation_repeat1] = STATE(715),
    [sym__concat] = ACTIONS(516),
    [anon_sym_RBRACK] = ACTIONS(1300),
    [sym__special_characters] = ACTIONS(648),
    [anon_sym_DQUOTE] = ACTIONS(646),
    [sym_raw_string] = ACTIONS(646),
    [anon_sym_DOLLAR] = ACTIONS(1300),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(646),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(646),
    [anon_sym_BQUOTE] = ACTIONS(646),
    [anon_sym_LT_LPAREN] = ACTIONS(646),
    [anon_sym_GT_LPAREN] = ACTIONS(646),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1300),
  },
  [296] = {
    [sym__concat] = ACTIONS(650),
    [anon_sym_RBRACK] = ACTIONS(1302),
    [sym__special_characters] = ACTIONS(652),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [sym_raw_string] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(1302),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(650),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LT_LPAREN] = ACTIONS(650),
    [anon_sym_GT_LPAREN] = ACTIONS(650),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1302),
  },
  [297] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(1304),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [298] = {
    [sym__concat] = ACTIONS(680),
    [anon_sym_RBRACK] = ACTIONS(1306),
    [sym__special_characters] = ACTIONS(682),
    [anon_sym_DQUOTE] = ACTIONS(680),
    [sym_raw_string] = ACTIONS(680),
    [anon_sym_DOLLAR] = ACTIONS(1306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(680),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(680),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [anon_sym_LT_LPAREN] = ACTIONS(680),
    [anon_sym_GT_LPAREN] = ACTIONS(680),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1306),
  },
  [299] = {
    [sym__concat] = ACTIONS(684),
    [anon_sym_RBRACK] = ACTIONS(1308),
    [sym__special_characters] = ACTIONS(686),
    [anon_sym_DQUOTE] = ACTIONS(684),
    [sym_raw_string] = ACTIONS(684),
    [anon_sym_DOLLAR] = ACTIONS(1308),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(684),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(684),
    [anon_sym_BQUOTE] = ACTIONS(684),
    [anon_sym_LT_LPAREN] = ACTIONS(684),
    [anon_sym_GT_LPAREN] = ACTIONS(684),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1308),
  },
  [300] = {
    [sym__concat] = ACTIONS(688),
    [anon_sym_RBRACK] = ACTIONS(1310),
    [sym__special_characters] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(688),
    [sym_raw_string] = ACTIONS(688),
    [anon_sym_DOLLAR] = ACTIONS(1310),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(688),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(688),
    [anon_sym_BQUOTE] = ACTIONS(688),
    [anon_sym_LT_LPAREN] = ACTIONS(688),
    [anon_sym_GT_LPAREN] = ACTIONS(688),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1310),
  },
  [301] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(1312),
    [sym_comment] = ACTIONS(52),
  },
  [302] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(719),
    [anon_sym_RBRACE] = ACTIONS(1314),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [303] = {
    [sym_subscript] = STATE(723),
    [sym_variable_name] = ACTIONS(1316),
    [anon_sym_DOLLAR] = ACTIONS(1318),
    [anon_sym_DASH] = ACTIONS(1318),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1320),
    [anon_sym_STAR] = ACTIONS(1318),
    [anon_sym_AT] = ACTIONS(1318),
    [anon_sym_QMARK] = ACTIONS(1318),
    [anon_sym_0] = ACTIONS(1322),
    [anon_sym__] = ACTIONS(1322),
  },
  [304] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(725),
    [anon_sym_RBRACE] = ACTIONS(1324),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [305] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(727),
    [anon_sym_RBRACE] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [306] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1328),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [307] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1328),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [308] = {
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(1328),
    [sym_comment] = ACTIONS(52),
  },
  [309] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(1328),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [310] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1330),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [311] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1330),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [312] = {
    [anon_sym_PIPE] = ACTIONS(1332),
    [anon_sym_RPAREN] = ACTIONS(1332),
    [anon_sym_SEMI_SEMI] = ACTIONS(1332),
    [anon_sym_PIPE_AMP] = ACTIONS(1332),
    [anon_sym_AMP_AMP] = ACTIONS(1332),
    [anon_sym_PIPE_PIPE] = ACTIONS(1332),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1332),
    [anon_sym_LF] = ACTIONS(1332),
    [anon_sym_AMP] = ACTIONS(1332),
  },
  [313] = {
    [sym_concatenation] = STATE(79),
    [sym_string] = STATE(73),
    [sym_simple_expansion] = STATE(73),
    [sym_expansion] = STATE(73),
    [sym_command_substitution] = STATE(73),
    [sym_process_substitution] = STATE(73),
    [aux_sym_for_statement_repeat1] = STATE(313),
    [anon_sym_RBRACK] = ACTIONS(1334),
    [sym__special_characters] = ACTIONS(1336),
    [anon_sym_DQUOTE] = ACTIONS(1339),
    [sym_raw_string] = ACTIONS(1342),
    [anon_sym_DOLLAR] = ACTIONS(1345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1348),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1351),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_LT_LPAREN] = ACTIONS(1357),
    [anon_sym_GT_LPAREN] = ACTIONS(1357),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1360),
  },
  [314] = {
    [sym_string] = STATE(730),
    [sym_simple_expansion] = STATE(730),
    [sym_expansion] = STATE(730),
    [sym_command_substitution] = STATE(730),
    [sym_process_substitution] = STATE(730),
    [sym__special_characters] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(1365),
    [anon_sym_DOLLAR] = ACTIONS(136),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(138),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(140),
    [anon_sym_BQUOTE] = ACTIONS(142),
    [anon_sym_LT_LPAREN] = ACTIONS(144),
    [anon_sym_GT_LPAREN] = ACTIONS(144),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1363),
  },
  [315] = {
    [aux_sym_concatenation_repeat1] = STATE(731),
    [sym__concat] = ACTIONS(552),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(646),
    [sym__special_characters] = ACTIONS(648),
    [anon_sym_DQUOTE] = ACTIONS(646),
    [sym_raw_string] = ACTIONS(646),
    [anon_sym_DOLLAR] = ACTIONS(1300),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(646),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(646),
    [anon_sym_BQUOTE] = ACTIONS(646),
    [anon_sym_LT_LPAREN] = ACTIONS(646),
    [anon_sym_GT_LPAREN] = ACTIONS(646),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1300),
  },
  [316] = {
    [sym__concat] = ACTIONS(650),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(650),
    [sym__special_characters] = ACTIONS(652),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [sym_raw_string] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(1302),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(650),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LT_LPAREN] = ACTIONS(650),
    [anon_sym_GT_LPAREN] = ACTIONS(650),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1302),
  },
  [317] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [318] = {
    [sym__concat] = ACTIONS(680),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(680),
    [sym__special_characters] = ACTIONS(682),
    [anon_sym_DQUOTE] = ACTIONS(680),
    [sym_raw_string] = ACTIONS(680),
    [anon_sym_DOLLAR] = ACTIONS(1306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(680),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(680),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [anon_sym_LT_LPAREN] = ACTIONS(680),
    [anon_sym_GT_LPAREN] = ACTIONS(680),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1306),
  },
  [319] = {
    [sym__concat] = ACTIONS(684),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(684),
    [sym__special_characters] = ACTIONS(686),
    [anon_sym_DQUOTE] = ACTIONS(684),
    [sym_raw_string] = ACTIONS(684),
    [anon_sym_DOLLAR] = ACTIONS(1308),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(684),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(684),
    [anon_sym_BQUOTE] = ACTIONS(684),
    [anon_sym_LT_LPAREN] = ACTIONS(684),
    [anon_sym_GT_LPAREN] = ACTIONS(684),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1308),
  },
  [320] = {
    [sym__concat] = ACTIONS(688),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(688),
    [sym__special_characters] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(688),
    [sym_raw_string] = ACTIONS(688),
    [anon_sym_DOLLAR] = ACTIONS(1310),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(688),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(688),
    [anon_sym_BQUOTE] = ACTIONS(688),
    [anon_sym_LT_LPAREN] = ACTIONS(688),
    [anon_sym_GT_LPAREN] = ACTIONS(688),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1310),
  },
  [321] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(1369),
    [sym_comment] = ACTIONS(52),
  },
  [322] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(735),
    [anon_sym_RBRACE] = ACTIONS(1371),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [323] = {
    [sym_subscript] = STATE(739),
    [sym_variable_name] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [anon_sym_DASH] = ACTIONS(1375),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1377),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_AT] = ACTIONS(1375),
    [anon_sym_QMARK] = ACTIONS(1375),
    [anon_sym_0] = ACTIONS(1379),
    [anon_sym__] = ACTIONS(1379),
  },
  [324] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(741),
    [anon_sym_RBRACE] = ACTIONS(1381),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [325] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(743),
    [anon_sym_RBRACE] = ACTIONS(1383),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [326] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [327] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [328] = {
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [sym_comment] = ACTIONS(52),
  },
  [329] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [330] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1387),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [331] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1387),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [332] = {
    [sym_concatenation] = STATE(89),
    [sym_string] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [sym_expansion] = STATE(83),
    [sym_command_substitution] = STATE(83),
    [sym_process_substitution] = STATE(83),
    [aux_sym_for_statement_repeat1] = STATE(332),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1389),
    [sym__special_characters] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1394),
    [sym_raw_string] = ACTIONS(1397),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1403),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1406),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [anon_sym_LT_LPAREN] = ACTIONS(1412),
    [anon_sym_GT_LPAREN] = ACTIONS(1412),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1415),
  },
  [333] = {
    [sym_concatenation] = STATE(746),
    [sym_string] = STATE(749),
    [sym_array] = STATE(746),
    [sym_simple_expansion] = STATE(749),
    [sym_expansion] = STATE(749),
    [sym_command_substitution] = STATE(749),
    [sym_process_substitution] = STATE(749),
    [sym__empty_value] = ACTIONS(1418),
    [anon_sym_LPAREN] = ACTIONS(1420),
    [sym__special_characters] = ACTIONS(1422),
    [anon_sym_DQUOTE] = ACTIONS(590),
    [sym_raw_string] = ACTIONS(1424),
    [anon_sym_DOLLAR] = ACTIONS(1426),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1428),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1430),
    [anon_sym_BQUOTE] = ACTIONS(1432),
    [anon_sym_LT_LPAREN] = ACTIONS(1434),
    [anon_sym_GT_LPAREN] = ACTIONS(1434),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1436),
  },
  [334] = {
    [sym_variable_name] = ACTIONS(394),
    [anon_sym_PIPE] = ACTIONS(396),
    [anon_sym_RPAREN] = ACTIONS(396),
    [anon_sym_SEMI_SEMI] = ACTIONS(396),
    [anon_sym_PIPE_AMP] = ACTIONS(396),
    [anon_sym_AMP_AMP] = ACTIONS(396),
    [anon_sym_PIPE_PIPE] = ACTIONS(396),
    [sym__special_characters] = ACTIONS(396),
    [anon_sym_DQUOTE] = ACTIONS(396),
    [sym_raw_string] = ACTIONS(396),
    [anon_sym_DOLLAR] = ACTIONS(396),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(396),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(396),
    [anon_sym_BQUOTE] = ACTIONS(396),
    [anon_sym_LT_LPAREN] = ACTIONS(396),
    [anon_sym_GT_LPAREN] = ACTIONS(396),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(396),
    [sym_word] = ACTIONS(396),
    [anon_sym_SEMI] = ACTIONS(396),
    [anon_sym_LF] = ACTIONS(396),
    [anon_sym_AMP] = ACTIONS(396),
  },
  [335] = {
    [sym_string] = STATE(750),
    [sym_simple_expansion] = STATE(750),
    [sym_expansion] = STATE(750),
    [sym_command_substitution] = STATE(750),
    [sym_process_substitution] = STATE(750),
    [sym__special_characters] = ACTIONS(1438),
    [anon_sym_DQUOTE] = ACTIONS(590),
    [sym_raw_string] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1426),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1428),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1430),
    [anon_sym_BQUOTE] = ACTIONS(1432),
    [anon_sym_LT_LPAREN] = ACTIONS(1434),
    [anon_sym_GT_LPAREN] = ACTIONS(1434),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1438),
  },
  [336] = {
    [aux_sym_concatenation_repeat1] = STATE(751),
    [sym__concat] = ACTIONS(578),
    [sym_variable_name] = ACTIONS(646),
    [anon_sym_PIPE] = ACTIONS(648),
    [anon_sym_SEMI_SEMI] = ACTIONS(648),
    [anon_sym_PIPE_AMP] = ACTIONS(648),
    [anon_sym_AMP_AMP] = ACTIONS(648),
    [anon_sym_PIPE_PIPE] = ACTIONS(648),
    [sym__special_characters] = ACTIONS(648),
    [anon_sym_DQUOTE] = ACTIONS(648),
    [sym_raw_string] = ACTIONS(648),
    [anon_sym_DOLLAR] = ACTIONS(648),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(648),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(648),
    [anon_sym_BQUOTE] = ACTIONS(648),
    [anon_sym_LT_LPAREN] = ACTIONS(648),
    [anon_sym_GT_LPAREN] = ACTIONS(648),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(648),
    [sym_word] = ACTIONS(648),
    [anon_sym_SEMI] = ACTIONS(648),
    [anon_sym_LF] = ACTIONS(648),
    [anon_sym_AMP] = ACTIONS(648),
  },
  [337] = {
    [sym__concat] = ACTIONS(650),
    [sym_variable_name] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(652),
    [anon_sym_SEMI_SEMI] = ACTIONS(652),
    [anon_sym_PIPE_AMP] = ACTIONS(652),
    [anon_sym_AMP_AMP] = ACTIONS(652),
    [anon_sym_PIPE_PIPE] = ACTIONS(652),
    [sym__special_characters] = ACTIONS(652),
    [anon_sym_DQUOTE] = ACTIONS(652),
    [sym_raw_string] = ACTIONS(652),
    [anon_sym_DOLLAR] = ACTIONS(652),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(652),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(652),
    [anon_sym_BQUOTE] = ACTIONS(652),
    [anon_sym_LT_LPAREN] = ACTIONS(652),
    [anon_sym_GT_LPAREN] = ACTIONS(652),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(652),
    [sym_word] = ACTIONS(652),
    [anon_sym_SEMI] = ACTIONS(652),
    [anon_sym_LF] = ACTIONS(652),
    [anon_sym_AMP] = ACTIONS(652),
  },
  [338] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(1442),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [339] = {
    [sym__concat] = ACTIONS(680),
    [sym_variable_name] = ACTIONS(680),
    [anon_sym_PIPE] = ACTIONS(682),
    [anon_sym_SEMI_SEMI] = ACTIONS(682),
    [anon_sym_PIPE_AMP] = ACTIONS(682),
    [anon_sym_AMP_AMP] = ACTIONS(682),
    [anon_sym_PIPE_PIPE] = ACTIONS(682),
    [sym__special_characters] = ACTIONS(682),
    [anon_sym_DQUOTE] = ACTIONS(682),
    [sym_raw_string] = ACTIONS(682),
    [anon_sym_DOLLAR] = ACTIONS(682),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(682),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(682),
    [anon_sym_BQUOTE] = ACTIONS(682),
    [anon_sym_LT_LPAREN] = ACTIONS(682),
    [anon_sym_GT_LPAREN] = ACTIONS(682),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(682),
    [sym_word] = ACTIONS(682),
    [anon_sym_SEMI] = ACTIONS(682),
    [anon_sym_LF] = ACTIONS(682),
    [anon_sym_AMP] = ACTIONS(682),
  },
  [340] = {
    [sym__concat] = ACTIONS(684),
    [sym_variable_name] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(686),
    [anon_sym_SEMI_SEMI] = ACTIONS(686),
    [anon_sym_PIPE_AMP] = ACTIONS(686),
    [anon_sym_AMP_AMP] = ACTIONS(686),
    [anon_sym_PIPE_PIPE] = ACTIONS(686),
    [sym__special_characters] = ACTIONS(686),
    [anon_sym_DQUOTE] = ACTIONS(686),
    [sym_raw_string] = ACTIONS(686),
    [anon_sym_DOLLAR] = ACTIONS(686),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(686),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(686),
    [anon_sym_BQUOTE] = ACTIONS(686),
    [anon_sym_LT_LPAREN] = ACTIONS(686),
    [anon_sym_GT_LPAREN] = ACTIONS(686),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(686),
    [sym_word] = ACTIONS(686),
    [anon_sym_SEMI] = ACTIONS(686),
    [anon_sym_LF] = ACTIONS(686),
    [anon_sym_AMP] = ACTIONS(686),
  },
  [341] = {
    [sym__concat] = ACTIONS(688),
    [sym_variable_name] = ACTIONS(688),
    [anon_sym_PIPE] = ACTIONS(690),
    [anon_sym_SEMI_SEMI] = ACTIONS(690),
    [anon_sym_PIPE_AMP] = ACTIONS(690),
    [anon_sym_AMP_AMP] = ACTIONS(690),
    [anon_sym_PIPE_PIPE] = ACTIONS(690),
    [sym__special_characters] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(690),
    [sym_raw_string] = ACTIONS(690),
    [anon_sym_DOLLAR] = ACTIONS(690),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(690),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(690),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [anon_sym_LT_LPAREN] = ACTIONS(690),
    [anon_sym_GT_LPAREN] = ACTIONS(690),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(690),
    [sym_word] = ACTIONS(690),
    [anon_sym_SEMI] = ACTIONS(690),
    [anon_sym_LF] = ACTIONS(690),
    [anon_sym_AMP] = ACTIONS(690),
  },
  [342] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(1444),
    [sym_comment] = ACTIONS(52),
  },
  [343] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(755),
    [anon_sym_RBRACE] = ACTIONS(1446),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [344] = {
    [sym_subscript] = STATE(759),
    [sym_variable_name] = ACTIONS(1448),
    [anon_sym_DOLLAR] = ACTIONS(1450),
    [anon_sym_DASH] = ACTIONS(1450),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1452),
    [anon_sym_STAR] = ACTIONS(1450),
    [anon_sym_AT] = ACTIONS(1450),
    [anon_sym_QMARK] = ACTIONS(1450),
    [anon_sym_0] = ACTIONS(1454),
    [anon_sym__] = ACTIONS(1454),
  },
  [345] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(761),
    [anon_sym_RBRACE] = ACTIONS(1456),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [346] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(763),
    [anon_sym_RBRACE] = ACTIONS(1458),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [347] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1460),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [348] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1460),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [349] = {
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(1460),
    [sym_comment] = ACTIONS(52),
  },
  [350] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(1460),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [351] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1462),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [352] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1462),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [353] = {
    [sym_variable_assignment] = STATE(101),
    [sym_subscript] = STATE(102),
    [sym_concatenation] = STATE(101),
    [sym_string] = STATE(94),
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [sym_process_substitution] = STATE(94),
    [aux_sym_declaration_command_repeat1] = STATE(353),
    [sym_variable_name] = ACTIONS(1464),
    [anon_sym_PIPE] = ACTIONS(1467),
    [anon_sym_SEMI_SEMI] = ACTIONS(1467),
    [anon_sym_PIPE_AMP] = ACTIONS(1467),
    [anon_sym_AMP_AMP] = ACTIONS(1467),
    [anon_sym_PIPE_PIPE] = ACTIONS(1467),
    [sym__special_characters] = ACTIONS(1469),
    [anon_sym_DQUOTE] = ACTIONS(1472),
    [sym_raw_string] = ACTIONS(1475),
    [anon_sym_DOLLAR] = ACTIONS(1478),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1481),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1484),
    [anon_sym_BQUOTE] = ACTIONS(1487),
    [anon_sym_LT_LPAREN] = ACTIONS(1490),
    [anon_sym_GT_LPAREN] = ACTIONS(1490),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1493),
    [sym_word] = ACTIONS(1475),
    [anon_sym_SEMI] = ACTIONS(1467),
    [anon_sym_LF] = ACTIONS(1467),
    [anon_sym_AMP] = ACTIONS(1467),
  },
  [354] = {
    [sym_string] = STATE(766),
    [sym_simple_expansion] = STATE(766),
    [sym_expansion] = STATE(766),
    [sym_command_substitution] = STATE(766),
    [sym_process_substitution] = STATE(766),
    [sym__special_characters] = ACTIONS(1496),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [sym_raw_string] = ACTIONS(1498),
    [anon_sym_DOLLAR] = ACTIONS(178),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(180),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(182),
    [anon_sym_BQUOTE] = ACTIONS(184),
    [anon_sym_LT_LPAREN] = ACTIONS(186),
    [anon_sym_GT_LPAREN] = ACTIONS(186),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1496),
  },
  [355] = {
    [aux_sym_concatenation_repeat1] = STATE(767),
    [sym_file_descriptor] = ACTIONS(646),
    [sym__concat] = ACTIONS(616),
    [sym_variable_name] = ACTIONS(646),
    [anon_sym_LT] = ACTIONS(1300),
    [anon_sym_GT] = ACTIONS(1300),
    [anon_sym_GT_GT] = ACTIONS(646),
    [anon_sym_AMP_GT] = ACTIONS(1300),
    [anon_sym_AMP_GT_GT] = ACTIONS(646),
    [anon_sym_LT_AMP] = ACTIONS(646),
    [anon_sym_GT_AMP] = ACTIONS(646),
    [sym__special_characters] = ACTIONS(1300),
    [anon_sym_DQUOTE] = ACTIONS(646),
    [sym_raw_string] = ACTIONS(646),
    [anon_sym_DOLLAR] = ACTIONS(1300),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(646),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(646),
    [anon_sym_BQUOTE] = ACTIONS(646),
    [anon_sym_LT_LPAREN] = ACTIONS(646),
    [anon_sym_GT_LPAREN] = ACTIONS(646),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1300),
  },
  [356] = {
    [sym_file_descriptor] = ACTIONS(650),
    [sym__concat] = ACTIONS(650),
    [sym_variable_name] = ACTIONS(650),
    [anon_sym_LT] = ACTIONS(1302),
    [anon_sym_GT] = ACTIONS(1302),
    [anon_sym_GT_GT] = ACTIONS(650),
    [anon_sym_AMP_GT] = ACTIONS(1302),
    [anon_sym_AMP_GT_GT] = ACTIONS(650),
    [anon_sym_LT_AMP] = ACTIONS(650),
    [anon_sym_GT_AMP] = ACTIONS(650),
    [sym__special_characters] = ACTIONS(1302),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [sym_raw_string] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(1302),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(650),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LT_LPAREN] = ACTIONS(650),
    [anon_sym_GT_LPAREN] = ACTIONS(650),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1302),
  },
  [357] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(1500),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [358] = {
    [sym_file_descriptor] = ACTIONS(680),
    [sym__concat] = ACTIONS(680),
    [sym_variable_name] = ACTIONS(680),
    [anon_sym_LT] = ACTIONS(1306),
    [anon_sym_GT] = ACTIONS(1306),
    [anon_sym_GT_GT] = ACTIONS(680),
    [anon_sym_AMP_GT] = ACTIONS(1306),
    [anon_sym_AMP_GT_GT] = ACTIONS(680),
    [anon_sym_LT_AMP] = ACTIONS(680),
    [anon_sym_GT_AMP] = ACTIONS(680),
    [sym__special_characters] = ACTIONS(1306),
    [anon_sym_DQUOTE] = ACTIONS(680),
    [sym_raw_string] = ACTIONS(680),
    [anon_sym_DOLLAR] = ACTIONS(1306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(680),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(680),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [anon_sym_LT_LPAREN] = ACTIONS(680),
    [anon_sym_GT_LPAREN] = ACTIONS(680),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1306),
  },
  [359] = {
    [sym_file_descriptor] = ACTIONS(684),
    [sym__concat] = ACTIONS(684),
    [sym_variable_name] = ACTIONS(684),
    [anon_sym_LT] = ACTIONS(1308),
    [anon_sym_GT] = ACTIONS(1308),
    [anon_sym_GT_GT] = ACTIONS(684),
    [anon_sym_AMP_GT] = ACTIONS(1308),
    [anon_sym_AMP_GT_GT] = ACTIONS(684),
    [anon_sym_LT_AMP] = ACTIONS(684),
    [anon_sym_GT_AMP] = ACTIONS(684),
    [sym__special_characters] = ACTIONS(1308),
    [anon_sym_DQUOTE] = ACTIONS(684),
    [sym_raw_string] = ACTIONS(684),
    [anon_sym_DOLLAR] = ACTIONS(1308),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(684),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(684),
    [anon_sym_BQUOTE] = ACTIONS(684),
    [anon_sym_LT_LPAREN] = ACTIONS(684),
    [anon_sym_GT_LPAREN] = ACTIONS(684),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1308),
  },
  [360] = {
    [sym_file_descriptor] = ACTIONS(688),
    [sym__concat] = ACTIONS(688),
    [sym_variable_name] = ACTIONS(688),
    [anon_sym_LT] = ACTIONS(1310),
    [anon_sym_GT] = ACTIONS(1310),
    [anon_sym_GT_GT] = ACTIONS(688),
    [anon_sym_AMP_GT] = ACTIONS(1310),
    [anon_sym_AMP_GT_GT] = ACTIONS(688),
    [anon_sym_LT_AMP] = ACTIONS(688),
    [anon_sym_GT_AMP] = ACTIONS(688),
    [sym__special_characters] = ACTIONS(1310),
    [anon_sym_DQUOTE] = ACTIONS(688),
    [sym_raw_string] = ACTIONS(688),
    [anon_sym_DOLLAR] = ACTIONS(1310),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(688),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(688),
    [anon_sym_BQUOTE] = ACTIONS(688),
    [anon_sym_LT_LPAREN] = ACTIONS(688),
    [anon_sym_GT_LPAREN] = ACTIONS(688),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1310),
  },
  [361] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(1502),
    [sym_comment] = ACTIONS(52),
  },
  [362] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(771),
    [anon_sym_RBRACE] = ACTIONS(1504),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [363] = {
    [sym_subscript] = STATE(775),
    [sym_variable_name] = ACTIONS(1506),
    [anon_sym_DOLLAR] = ACTIONS(1508),
    [anon_sym_DASH] = ACTIONS(1508),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1510),
    [anon_sym_STAR] = ACTIONS(1508),
    [anon_sym_AT] = ACTIONS(1508),
    [anon_sym_QMARK] = ACTIONS(1508),
    [anon_sym_0] = ACTIONS(1512),
    [anon_sym__] = ACTIONS(1512),
  },
  [364] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(777),
    [anon_sym_RBRACE] = ACTIONS(1514),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [365] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(779),
    [anon_sym_RBRACE] = ACTIONS(1516),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [366] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1518),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [367] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1518),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [368] = {
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(1518),
    [sym_comment] = ACTIONS(52),
  },
  [369] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(1518),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [370] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1520),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [371] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1520),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [372] = {
    [sym_file_descriptor] = ACTIONS(1522),
    [sym__concat] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(1524),
    [anon_sym_SEMI_SEMI] = ACTIONS(1524),
    [anon_sym_PIPE_AMP] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1524),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_LT] = ACTIONS(1524),
    [anon_sym_GT] = ACTIONS(1524),
    [anon_sym_GT_GT] = ACTIONS(1524),
    [anon_sym_AMP_GT] = ACTIONS(1524),
    [anon_sym_AMP_GT_GT] = ACTIONS(1524),
    [anon_sym_LT_AMP] = ACTIONS(1524),
    [anon_sym_GT_AMP] = ACTIONS(1524),
    [anon_sym_LT_LT] = ACTIONS(1524),
    [anon_sym_LT_LT_DASH] = ACTIONS(1524),
    [anon_sym_LT_LT_LT] = ACTIONS(1524),
    [sym__special_characters] = ACTIONS(1524),
    [anon_sym_DQUOTE] = ACTIONS(1524),
    [sym_raw_string] = ACTIONS(1524),
    [anon_sym_DOLLAR] = ACTIONS(1524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1524),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1524),
    [anon_sym_BQUOTE] = ACTIONS(1524),
    [anon_sym_LT_LPAREN] = ACTIONS(1524),
    [anon_sym_GT_LPAREN] = ACTIONS(1524),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1524),
    [anon_sym_SEMI] = ACTIONS(1524),
    [anon_sym_LF] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1524),
  },
  [373] = {
    [aux_sym_concatenation_repeat1] = STATE(373),
    [sym_file_descriptor] = ACTIONS(1522),
    [sym__concat] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1524),
    [anon_sym_SEMI_SEMI] = ACTIONS(1524),
    [anon_sym_PIPE_AMP] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1524),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_LT] = ACTIONS(1524),
    [anon_sym_GT] = ACTIONS(1524),
    [anon_sym_GT_GT] = ACTIONS(1524),
    [anon_sym_AMP_GT] = ACTIONS(1524),
    [anon_sym_AMP_GT_GT] = ACTIONS(1524),
    [anon_sym_LT_AMP] = ACTIONS(1524),
    [anon_sym_GT_AMP] = ACTIONS(1524),
    [anon_sym_LT_LT] = ACTIONS(1524),
    [anon_sym_LT_LT_DASH] = ACTIONS(1524),
    [anon_sym_LT_LT_LT] = ACTIONS(1524),
    [sym__special_characters] = ACTIONS(1524),
    [anon_sym_DQUOTE] = ACTIONS(1524),
    [sym_raw_string] = ACTIONS(1524),
    [anon_sym_DOLLAR] = ACTIONS(1524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1524),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1524),
    [anon_sym_BQUOTE] = ACTIONS(1524),
    [anon_sym_LT_LPAREN] = ACTIONS(1524),
    [anon_sym_GT_LPAREN] = ACTIONS(1524),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1524),
    [anon_sym_SEMI] = ACTIONS(1524),
    [anon_sym_LF] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1524),
  },
  [374] = {
    [anon_sym_DQUOTE] = ACTIONS(1529),
    [sym__string_content] = ACTIONS(1531),
    [anon_sym_DOLLAR] = ACTIONS(1529),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1529),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1529),
    [anon_sym_BQUOTE] = ACTIONS(1529),
    [sym_comment] = ACTIONS(168),
  },
  [375] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(783),
    [anon_sym_DQUOTE] = ACTIONS(1533),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [376] = {
    [sym__concat] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(682),
    [sym__string_content] = ACTIONS(1306),
    [anon_sym_DOLLAR] = ACTIONS(682),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(682),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(682),
    [anon_sym_BQUOTE] = ACTIONS(682),
    [sym_comment] = ACTIONS(168),
  },
  [377] = {
    [sym__concat] = ACTIONS(684),
    [anon_sym_DQUOTE] = ACTIONS(686),
    [sym__string_content] = ACTIONS(1308),
    [anon_sym_DOLLAR] = ACTIONS(686),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(686),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(686),
    [anon_sym_BQUOTE] = ACTIONS(686),
    [sym_comment] = ACTIONS(168),
  },
  [378] = {
    [sym__concat] = ACTIONS(688),
    [anon_sym_DQUOTE] = ACTIONS(690),
    [sym__string_content] = ACTIONS(1310),
    [anon_sym_DOLLAR] = ACTIONS(690),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(690),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(690),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [sym_comment] = ACTIONS(168),
  },
  [379] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(1535),
    [sym_comment] = ACTIONS(52),
  },
  [380] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(786),
    [anon_sym_RBRACE] = ACTIONS(1537),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [381] = {
    [sym_subscript] = STATE(790),
    [sym_variable_name] = ACTIONS(1539),
    [anon_sym_DOLLAR] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_AT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1541),
    [anon_sym_0] = ACTIONS(1545),
    [anon_sym__] = ACTIONS(1545),
  },
  [382] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(792),
    [anon_sym_RBRACE] = ACTIONS(1547),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [383] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(794),
    [anon_sym_RBRACE] = ACTIONS(1549),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [384] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1551),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [385] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1551),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [386] = {
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(52),
  },
  [387] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(1551),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [388] = {
    [sym_file_descriptor] = ACTIONS(1553),
    [sym__concat] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(1555),
    [anon_sym_SEMI_SEMI] = ACTIONS(1555),
    [anon_sym_PIPE_AMP] = ACTIONS(1555),
    [anon_sym_AMP_AMP] = ACTIONS(1555),
    [anon_sym_PIPE_PIPE] = ACTIONS(1555),
    [anon_sym_LT] = ACTIONS(1555),
    [anon_sym_GT] = ACTIONS(1555),
    [anon_sym_GT_GT] = ACTIONS(1555),
    [anon_sym_AMP_GT] = ACTIONS(1555),
    [anon_sym_AMP_GT_GT] = ACTIONS(1555),
    [anon_sym_LT_AMP] = ACTIONS(1555),
    [anon_sym_GT_AMP] = ACTIONS(1555),
    [anon_sym_LT_LT] = ACTIONS(1555),
    [anon_sym_LT_LT_DASH] = ACTIONS(1555),
    [anon_sym_LT_LT_LT] = ACTIONS(1555),
    [sym__special_characters] = ACTIONS(1555),
    [anon_sym_DQUOTE] = ACTIONS(1555),
    [sym_raw_string] = ACTIONS(1555),
    [anon_sym_DOLLAR] = ACTIONS(1555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1555),
    [anon_sym_BQUOTE] = ACTIONS(1555),
    [anon_sym_LT_LPAREN] = ACTIONS(1555),
    [anon_sym_GT_LPAREN] = ACTIONS(1555),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1555),
    [anon_sym_SEMI] = ACTIONS(1555),
    [anon_sym_LF] = ACTIONS(1555),
    [anon_sym_AMP] = ACTIONS(1555),
  },
  [389] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(1529),
    [sym__string_content] = ACTIONS(1557),
    [anon_sym_DOLLAR] = ACTIONS(1560),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1563),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1566),
    [anon_sym_BQUOTE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(168),
  },
  [390] = {
    [sym_concatenation] = STATE(798),
    [sym_string] = STATE(797),
    [sym_simple_expansion] = STATE(797),
    [sym_expansion] = STATE(797),
    [sym_command_substitution] = STATE(797),
    [sym_process_substitution] = STATE(797),
    [sym__special_characters] = ACTIONS(1572),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(1574),
    [anon_sym_DOLLAR] = ACTIONS(360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(364),
    [anon_sym_BQUOTE] = ACTIONS(366),
    [anon_sym_LT_LPAREN] = ACTIONS(368),
    [anon_sym_GT_LPAREN] = ACTIONS(368),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1576),
  },
  [391] = {
    [sym_concatenation] = STATE(808),
    [sym_string] = STATE(802),
    [sym_simple_expansion] = STATE(802),
    [sym_expansion] = STATE(802),
    [sym_command_substitution] = STATE(802),
    [sym_process_substitution] = STATE(802),
    [anon_sym_RBRACE] = ACTIONS(1578),
    [sym__special_characters] = ACTIONS(1580),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(1584),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1596),
  },
  [392] = {
    [sym_file_descriptor] = ACTIONS(1598),
    [sym__concat] = ACTIONS(1598),
    [anon_sym_PIPE] = ACTIONS(1600),
    [anon_sym_SEMI_SEMI] = ACTIONS(1600),
    [anon_sym_PIPE_AMP] = ACTIONS(1600),
    [anon_sym_AMP_AMP] = ACTIONS(1600),
    [anon_sym_PIPE_PIPE] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1600),
    [anon_sym_GT] = ACTIONS(1600),
    [anon_sym_GT_GT] = ACTIONS(1600),
    [anon_sym_AMP_GT] = ACTIONS(1600),
    [anon_sym_AMP_GT_GT] = ACTIONS(1600),
    [anon_sym_LT_AMP] = ACTIONS(1600),
    [anon_sym_GT_AMP] = ACTIONS(1600),
    [anon_sym_LT_LT] = ACTIONS(1600),
    [anon_sym_LT_LT_DASH] = ACTIONS(1600),
    [anon_sym_LT_LT_LT] = ACTIONS(1600),
    [sym__special_characters] = ACTIONS(1600),
    [anon_sym_DQUOTE] = ACTIONS(1600),
    [sym_raw_string] = ACTIONS(1600),
    [anon_sym_DOLLAR] = ACTIONS(1600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1600),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1600),
    [anon_sym_BQUOTE] = ACTIONS(1600),
    [anon_sym_LT_LPAREN] = ACTIONS(1600),
    [anon_sym_GT_LPAREN] = ACTIONS(1600),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1600),
    [anon_sym_SEMI] = ACTIONS(1600),
    [anon_sym_LF] = ACTIONS(1600),
    [anon_sym_AMP] = ACTIONS(1600),
  },
  [393] = {
    [anon_sym_RBRACE] = ACTIONS(1602),
    [anon_sym_EQ] = ACTIONS(1604),
    [sym__special_characters] = ACTIONS(1606),
    [anon_sym_DQUOTE] = ACTIONS(1602),
    [sym_raw_string] = ACTIONS(1602),
    [anon_sym_DOLLAR] = ACTIONS(1604),
    [anon_sym_POUND] = ACTIONS(1602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1602),
    [anon_sym_COLON] = ACTIONS(1604),
    [anon_sym_COLON_QMARK] = ACTIONS(1604),
    [anon_sym_COLON_DASH] = ACTIONS(1604),
    [anon_sym_PERCENT] = ACTIONS(1604),
    [anon_sym_SLASH] = ACTIONS(1604),
    [anon_sym_DASH] = ACTIONS(1604),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1602),
    [anon_sym_BQUOTE] = ACTIONS(1602),
    [anon_sym_LT_LPAREN] = ACTIONS(1602),
    [anon_sym_GT_LPAREN] = ACTIONS(1602),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1606),
  },
  [394] = {
    [aux_sym_concatenation_repeat1] = STATE(810),
    [sym__concat] = ACTIONS(1608),
    [anon_sym_RBRACE] = ACTIONS(1610),
    [anon_sym_EQ] = ACTIONS(1612),
    [sym__special_characters] = ACTIONS(1614),
    [anon_sym_DQUOTE] = ACTIONS(1610),
    [sym_raw_string] = ACTIONS(1610),
    [anon_sym_DOLLAR] = ACTIONS(1612),
    [anon_sym_POUND] = ACTIONS(1610),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1610),
    [anon_sym_COLON] = ACTIONS(1612),
    [anon_sym_COLON_QMARK] = ACTIONS(1612),
    [anon_sym_COLON_DASH] = ACTIONS(1612),
    [anon_sym_PERCENT] = ACTIONS(1612),
    [anon_sym_SLASH] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1612),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1610),
    [anon_sym_BQUOTE] = ACTIONS(1610),
    [anon_sym_LT_LPAREN] = ACTIONS(1610),
    [anon_sym_GT_LPAREN] = ACTIONS(1610),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1614),
  },
  [395] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(812),
    [anon_sym_DQUOTE] = ACTIONS(1616),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [396] = {
    [aux_sym_concatenation_repeat1] = STATE(810),
    [sym__concat] = ACTIONS(1608),
    [anon_sym_RBRACE] = ACTIONS(1602),
    [anon_sym_EQ] = ACTIONS(1604),
    [sym__special_characters] = ACTIONS(1606),
    [anon_sym_DQUOTE] = ACTIONS(1602),
    [sym_raw_string] = ACTIONS(1602),
    [anon_sym_DOLLAR] = ACTIONS(1604),
    [anon_sym_POUND] = ACTIONS(1602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1602),
    [anon_sym_COLON] = ACTIONS(1604),
    [anon_sym_COLON_QMARK] = ACTIONS(1604),
    [anon_sym_COLON_DASH] = ACTIONS(1604),
    [anon_sym_PERCENT] = ACTIONS(1604),
    [anon_sym_SLASH] = ACTIONS(1604),
    [anon_sym_DASH] = ACTIONS(1604),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1602),
    [anon_sym_BQUOTE] = ACTIONS(1602),
    [anon_sym_LT_LPAREN] = ACTIONS(1602),
    [anon_sym_GT_LPAREN] = ACTIONS(1602),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1606),
  },
  [397] = {
    [sym_string] = STATE(815),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [anon_sym_DOLLAR] = ACTIONS(1618),
    [anon_sym_POUND] = ACTIONS(1618),
    [anon_sym_DASH] = ACTIONS(1618),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1620),
    [anon_sym_STAR] = ACTIONS(1618),
    [anon_sym_AT] = ACTIONS(1618),
    [anon_sym_QMARK] = ACTIONS(1618),
    [anon_sym_0] = ACTIONS(1622),
    [anon_sym__] = ACTIONS(1622),
  },
  [398] = {
    [sym_subscript] = STATE(820),
    [sym_variable_name] = ACTIONS(1624),
    [anon_sym_DOLLAR] = ACTIONS(1626),
    [anon_sym_POUND] = ACTIONS(1628),
    [anon_sym_DASH] = ACTIONS(1626),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1630),
    [anon_sym_STAR] = ACTIONS(1626),
    [anon_sym_AT] = ACTIONS(1626),
    [anon_sym_QMARK] = ACTIONS(1626),
    [anon_sym_0] = ACTIONS(1632),
    [anon_sym__] = ACTIONS(1632),
  },
  [399] = {
    [sym_for_statement] = STATE(821),
    [sym_while_statement] = STATE(821),
    [sym_if_statement] = STATE(821),
    [sym_case_statement] = STATE(821),
    [sym_function_definition] = STATE(821),
    [sym_subshell] = STATE(821),
    [sym_pipeline] = STATE(821),
    [sym_list] = STATE(821),
    [sym_bracket_command] = STATE(821),
    [sym_command] = STATE(821),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(822),
    [sym_declaration_command] = STATE(821),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [400] = {
    [sym_for_statement] = STATE(823),
    [sym_while_statement] = STATE(823),
    [sym_if_statement] = STATE(823),
    [sym_case_statement] = STATE(823),
    [sym_function_definition] = STATE(823),
    [sym_subshell] = STATE(823),
    [sym_pipeline] = STATE(823),
    [sym_list] = STATE(823),
    [sym_bracket_command] = STATE(823),
    [sym_command] = STATE(823),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(824),
    [sym_declaration_command] = STATE(823),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [401] = {
    [sym_for_statement] = STATE(825),
    [sym_while_statement] = STATE(825),
    [sym_if_statement] = STATE(825),
    [sym_case_statement] = STATE(825),
    [sym_function_definition] = STATE(825),
    [sym_subshell] = STATE(825),
    [sym_pipeline] = STATE(825),
    [sym_list] = STATE(825),
    [sym_bracket_command] = STATE(825),
    [sym_command] = STATE(825),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(826),
    [sym_declaration_command] = STATE(825),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [402] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(1634),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [403] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(1636),
    [sym_comment] = ACTIONS(52),
  },
  [404] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(831),
    [anon_sym_RBRACE] = ACTIONS(1638),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [405] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(833),
    [anon_sym_RBRACE] = ACTIONS(1640),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [406] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(834),
    [anon_sym_RBRACE] = ACTIONS(1578),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [407] = {
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1644),
    [anon_sym_LT_LT_DASH] = ACTIONS(1644),
    [anon_sym_LT_LT_LT] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1644),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1644),
    [anon_sym_BQUOTE] = ACTIONS(1644),
    [anon_sym_LT_LPAREN] = ACTIONS(1644),
    [anon_sym_GT_LPAREN] = ACTIONS(1644),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [408] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(1646),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [409] = {
    [sym_file_descriptor] = ACTIONS(1648),
    [sym__concat] = ACTIONS(1648),
    [anon_sym_PIPE] = ACTIONS(1650),
    [anon_sym_SEMI_SEMI] = ACTIONS(1650),
    [anon_sym_PIPE_AMP] = ACTIONS(1650),
    [anon_sym_AMP_AMP] = ACTIONS(1650),
    [anon_sym_PIPE_PIPE] = ACTIONS(1650),
    [anon_sym_LT] = ACTIONS(1650),
    [anon_sym_GT] = ACTIONS(1650),
    [anon_sym_GT_GT] = ACTIONS(1650),
    [anon_sym_AMP_GT] = ACTIONS(1650),
    [anon_sym_AMP_GT_GT] = ACTIONS(1650),
    [anon_sym_LT_AMP] = ACTIONS(1650),
    [anon_sym_GT_AMP] = ACTIONS(1650),
    [anon_sym_LT_LT] = ACTIONS(1650),
    [anon_sym_LT_LT_DASH] = ACTIONS(1650),
    [anon_sym_LT_LT_LT] = ACTIONS(1650),
    [sym__special_characters] = ACTIONS(1650),
    [anon_sym_DQUOTE] = ACTIONS(1650),
    [sym_raw_string] = ACTIONS(1650),
    [anon_sym_DOLLAR] = ACTIONS(1650),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1650),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1650),
    [anon_sym_BQUOTE] = ACTIONS(1650),
    [anon_sym_LT_LPAREN] = ACTIONS(1650),
    [anon_sym_GT_LPAREN] = ACTIONS(1650),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(1650),
    [anon_sym_LF] = ACTIONS(1650),
    [anon_sym_AMP] = ACTIONS(1650),
  },
  [410] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(1578),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [411] = {
    [sym_concatenation] = STATE(836),
    [sym_string] = STATE(840),
    [sym_array] = STATE(836),
    [sym_simple_expansion] = STATE(840),
    [sym_expansion] = STATE(840),
    [sym_command_substitution] = STATE(840),
    [sym_process_substitution] = STATE(840),
    [sym__empty_value] = ACTIONS(1652),
    [anon_sym_LPAREN] = ACTIONS(1654),
    [sym__special_characters] = ACTIONS(1656),
    [anon_sym_DQUOTE] = ACTIONS(1658),
    [sym_raw_string] = ACTIONS(1660),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1666),
    [anon_sym_BQUOTE] = ACTIONS(1668),
    [anon_sym_LT_LPAREN] = ACTIONS(1670),
    [anon_sym_GT_LPAREN] = ACTIONS(1670),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1672),
  },
  [412] = {
    [sym_file_descriptor] = ACTIONS(394),
    [sym_variable_name] = ACTIONS(394),
    [anon_sym_PIPE] = ACTIONS(1674),
    [anon_sym_RPAREN] = ACTIONS(394),
    [anon_sym_PIPE_AMP] = ACTIONS(394),
    [anon_sym_AMP_AMP] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [anon_sym_LT] = ACTIONS(1674),
    [anon_sym_GT] = ACTIONS(1674),
    [anon_sym_GT_GT] = ACTIONS(394),
    [anon_sym_AMP_GT] = ACTIONS(1674),
    [anon_sym_AMP_GT_GT] = ACTIONS(394),
    [anon_sym_LT_AMP] = ACTIONS(394),
    [anon_sym_GT_AMP] = ACTIONS(394),
    [sym__special_characters] = ACTIONS(1674),
    [anon_sym_DQUOTE] = ACTIONS(394),
    [sym_raw_string] = ACTIONS(394),
    [anon_sym_DOLLAR] = ACTIONS(1674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(394),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(394),
    [anon_sym_BQUOTE] = ACTIONS(394),
    [anon_sym_LT_LPAREN] = ACTIONS(394),
    [anon_sym_GT_LPAREN] = ACTIONS(394),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1674),
  },
  [413] = {
    [anon_sym_in] = ACTIONS(1676),
    [sym_comment] = ACTIONS(52),
  },
  [414] = {
    [sym_do_group] = STATE(848),
    [anon_sym_do] = ACTIONS(1678),
    [sym_comment] = ACTIONS(52),
  },
  [415] = {
    [anon_sym_then] = ACTIONS(1680),
    [sym_comment] = ACTIONS(52),
  },
  [416] = {
    [aux_sym_concatenation_repeat1] = STATE(224),
    [sym__concat] = ACTIONS(406),
    [anon_sym_in] = ACTIONS(1682),
    [anon_sym_SEMI_SEMI] = ACTIONS(1684),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1684),
    [anon_sym_LF] = ACTIONS(1684),
    [anon_sym_AMP] = ACTIONS(1684),
  },
  [417] = {
    [aux_sym_concatenation_repeat1] = STATE(224),
    [sym__concat] = ACTIONS(406),
    [anon_sym_in] = ACTIONS(1686),
    [anon_sym_SEMI_SEMI] = ACTIONS(1688),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1688),
    [anon_sym_LF] = ACTIONS(1688),
    [anon_sym_AMP] = ACTIONS(1688),
  },
  [418] = {
    [anon_sym_in] = ACTIONS(1686),
    [anon_sym_SEMI_SEMI] = ACTIONS(1688),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1688),
    [anon_sym_LF] = ACTIONS(1688),
    [anon_sym_AMP] = ACTIONS(1688),
  },
  [419] = {
    [sym_compound_statement] = STATE(856),
    [anon_sym_LPAREN] = ACTIONS(1690),
    [anon_sym_LBRACE] = ACTIONS(1692),
    [sym_comment] = ACTIONS(52),
  },
  [420] = {
    [anon_sym_PIPE] = ACTIONS(482),
    [anon_sym_RPAREN] = ACTIONS(1694),
    [anon_sym_SEMI_SEMI] = ACTIONS(1696),
    [anon_sym_PIPE_AMP] = ACTIONS(482),
    [anon_sym_AMP_AMP] = ACTIONS(488),
    [anon_sym_PIPE_PIPE] = ACTIONS(488),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1696),
    [anon_sym_LF] = ACTIONS(1696),
    [anon_sym_AMP] = ACTIONS(1696),
  },
  [421] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(482),
    [anon_sym_RPAREN] = ACTIONS(1694),
    [anon_sym_SEMI_SEMI] = ACTIONS(1696),
    [anon_sym_PIPE_AMP] = ACTIONS(482),
    [anon_sym_AMP_AMP] = ACTIONS(488),
    [anon_sym_PIPE_PIPE] = ACTIONS(488),
    [anon_sym_LT] = ACTIONS(336),
    [anon_sym_GT] = ACTIONS(336),
    [anon_sym_GT_GT] = ACTIONS(336),
    [anon_sym_AMP_GT] = ACTIONS(336),
    [anon_sym_AMP_GT_GT] = ACTIONS(336),
    [anon_sym_LT_AMP] = ACTIONS(336),
    [anon_sym_GT_AMP] = ACTIONS(336),
    [sym__special_characters] = ACTIONS(336),
    [anon_sym_DQUOTE] = ACTIONS(336),
    [sym_raw_string] = ACTIONS(336),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(336),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(336),
    [anon_sym_BQUOTE] = ACTIONS(336),
    [anon_sym_LT_LPAREN] = ACTIONS(336),
    [anon_sym_GT_LPAREN] = ACTIONS(336),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(336),
    [anon_sym_SEMI] = ACTIONS(1696),
    [anon_sym_LF] = ACTIONS(1696),
    [anon_sym_AMP] = ACTIONS(1696),
  },
  [422] = {
    [sym__terminated_statement] = STATE(24),
    [sym_for_statement] = STATE(859),
    [sym_while_statement] = STATE(859),
    [sym_if_statement] = STATE(859),
    [sym_case_statement] = STATE(859),
    [sym_function_definition] = STATE(859),
    [sym_subshell] = STATE(859),
    [sym_pipeline] = STATE(859),
    [sym_list] = STATE(859),
    [sym_bracket_command] = STATE(859),
    [sym_command] = STATE(859),
    [sym_command_name] = STATE(66),
    [sym_variable_assignment] = STATE(860),
    [sym_declaration_command] = STATE(859),
    [sym_subscript] = STATE(68),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(58),
    [sym_simple_expansion] = STATE(58),
    [sym_expansion] = STATE(58),
    [sym_command_substitution] = STATE(58),
    [sym_process_substitution] = STATE(58),
    [aux_sym_program_repeat1] = STATE(292),
    [aux_sym_command_repeat1] = STATE(70),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(86),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(88),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(90),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(92),
    [anon_sym_typeset] = ACTIONS(92),
    [anon_sym_export] = ACTIONS(92),
    [anon_sym_readonly] = ACTIONS(92),
    [anon_sym_local] = ACTIONS(92),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(94),
    [anon_sym_DQUOTE] = ACTIONS(96),
    [sym_raw_string] = ACTIONS(98),
    [anon_sym_DOLLAR] = ACTIONS(100),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(102),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(104),
    [anon_sym_BQUOTE] = ACTIONS(106),
    [anon_sym_LT_LPAREN] = ACTIONS(108),
    [anon_sym_GT_LPAREN] = ACTIONS(108),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(110),
  },
  [423] = {
    [sym_concatenation] = STATE(79),
    [sym_string] = STATE(73),
    [sym_simple_expansion] = STATE(73),
    [sym_expansion] = STATE(73),
    [sym_command_substitution] = STATE(73),
    [sym_process_substitution] = STATE(73),
    [aux_sym_for_statement_repeat1] = STATE(313),
    [anon_sym_RBRACK] = ACTIONS(1698),
    [sym__special_characters] = ACTIONS(550),
    [anon_sym_DQUOTE] = ACTIONS(114),
    [sym_raw_string] = ACTIONS(116),
    [anon_sym_DOLLAR] = ACTIONS(118),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(120),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(122),
    [anon_sym_BQUOTE] = ACTIONS(124),
    [anon_sym_LT_LPAREN] = ACTIONS(126),
    [anon_sym_GT_LPAREN] = ACTIONS(126),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(128),
  },
  [424] = {
    [sym_concatenation] = STATE(89),
    [sym_string] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [sym_expansion] = STATE(83),
    [sym_command_substitution] = STATE(83),
    [sym_process_substitution] = STATE(83),
    [aux_sym_for_statement_repeat1] = STATE(332),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1700),
    [sym__special_characters] = ACTIONS(574),
    [anon_sym_DQUOTE] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(134),
    [anon_sym_DOLLAR] = ACTIONS(136),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(138),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(140),
    [anon_sym_BQUOTE] = ACTIONS(142),
    [anon_sym_LT_LPAREN] = ACTIONS(144),
    [anon_sym_GT_LPAREN] = ACTIONS(144),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(146),
  },
  [425] = {
    [sym__assignment] = STATE(863),
    [anon_sym_LBRACK] = ACTIONS(60),
    [anon_sym_EQ] = ACTIONS(1702),
    [anon_sym_PLUS_EQ] = ACTIONS(1702),
    [sym_comment] = ACTIONS(52),
  },
  [426] = {
    [aux_sym_concatenation_repeat1] = STATE(865),
    [sym__concat] = ACTIONS(1704),
    [sym_variable_name] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(1706),
    [anon_sym_RPAREN] = ACTIONS(580),
    [anon_sym_PIPE_AMP] = ACTIONS(580),
    [anon_sym_AMP_AMP] = ACTIONS(580),
    [anon_sym_PIPE_PIPE] = ACTIONS(580),
    [sym__special_characters] = ACTIONS(1706),
    [anon_sym_DQUOTE] = ACTIONS(580),
    [sym_raw_string] = ACTIONS(580),
    [anon_sym_DOLLAR] = ACTIONS(1706),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(580),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(580),
    [anon_sym_BQUOTE] = ACTIONS(580),
    [anon_sym_LT_LPAREN] = ACTIONS(580),
    [anon_sym_GT_LPAREN] = ACTIONS(580),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1706),
    [sym_word] = ACTIONS(582),
  },
  [427] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(867),
    [anon_sym_DQUOTE] = ACTIONS(1708),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [428] = {
    [aux_sym_concatenation_repeat1] = STATE(865),
    [sym__concat] = ACTIONS(1704),
    [sym_variable_name] = ACTIONS(586),
    [anon_sym_PIPE] = ACTIONS(1710),
    [anon_sym_RPAREN] = ACTIONS(586),
    [anon_sym_PIPE_AMP] = ACTIONS(586),
    [anon_sym_AMP_AMP] = ACTIONS(586),
    [anon_sym_PIPE_PIPE] = ACTIONS(586),
    [sym__special_characters] = ACTIONS(1710),
    [anon_sym_DQUOTE] = ACTIONS(586),
    [sym_raw_string] = ACTIONS(586),
    [anon_sym_DOLLAR] = ACTIONS(1710),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(586),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(586),
    [anon_sym_BQUOTE] = ACTIONS(586),
    [anon_sym_LT_LPAREN] = ACTIONS(586),
    [anon_sym_GT_LPAREN] = ACTIONS(586),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1710),
    [sym_word] = ACTIONS(588),
  },
  [429] = {
    [sym_string] = STATE(870),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [anon_sym_DOLLAR] = ACTIONS(1712),
    [anon_sym_POUND] = ACTIONS(1712),
    [anon_sym_DASH] = ACTIONS(1712),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1714),
    [anon_sym_STAR] = ACTIONS(1712),
    [anon_sym_AT] = ACTIONS(1712),
    [anon_sym_QMARK] = ACTIONS(1712),
    [anon_sym_0] = ACTIONS(1716),
    [anon_sym__] = ACTIONS(1716),
  },
  [430] = {
    [sym_subscript] = STATE(875),
    [sym_variable_name] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [anon_sym_POUND] = ACTIONS(1722),
    [anon_sym_DASH] = ACTIONS(1720),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1724),
    [anon_sym_STAR] = ACTIONS(1720),
    [anon_sym_AT] = ACTIONS(1720),
    [anon_sym_QMARK] = ACTIONS(1720),
    [anon_sym_0] = ACTIONS(1726),
    [anon_sym__] = ACTIONS(1726),
  },
  [431] = {
    [sym_for_statement] = STATE(876),
    [sym_while_statement] = STATE(876),
    [sym_if_statement] = STATE(876),
    [sym_case_statement] = STATE(876),
    [sym_function_definition] = STATE(876),
    [sym_subshell] = STATE(876),
    [sym_pipeline] = STATE(876),
    [sym_list] = STATE(876),
    [sym_bracket_command] = STATE(876),
    [sym_command] = STATE(876),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(877),
    [sym_declaration_command] = STATE(876),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [432] = {
    [sym_for_statement] = STATE(878),
    [sym_while_statement] = STATE(878),
    [sym_if_statement] = STATE(878),
    [sym_case_statement] = STATE(878),
    [sym_function_definition] = STATE(878),
    [sym_subshell] = STATE(878),
    [sym_pipeline] = STATE(878),
    [sym_list] = STATE(878),
    [sym_bracket_command] = STATE(878),
    [sym_command] = STATE(878),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(879),
    [sym_declaration_command] = STATE(878),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [433] = {
    [sym_for_statement] = STATE(880),
    [sym_while_statement] = STATE(880),
    [sym_if_statement] = STATE(880),
    [sym_case_statement] = STATE(880),
    [sym_function_definition] = STATE(880),
    [sym_subshell] = STATE(880),
    [sym_pipeline] = STATE(880),
    [sym_list] = STATE(880),
    [sym_bracket_command] = STATE(880),
    [sym_command] = STATE(880),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(881),
    [sym_declaration_command] = STATE(880),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [434] = {
    [sym_variable_name] = ACTIONS(608),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_RPAREN] = ACTIONS(608),
    [anon_sym_PIPE_AMP] = ACTIONS(608),
    [anon_sym_AMP_AMP] = ACTIONS(608),
    [anon_sym_PIPE_PIPE] = ACTIONS(608),
    [sym__special_characters] = ACTIONS(1728),
    [anon_sym_DQUOTE] = ACTIONS(608),
    [sym_raw_string] = ACTIONS(608),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(608),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(608),
    [anon_sym_BQUOTE] = ACTIONS(608),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1728),
    [sym_word] = ACTIONS(610),
  },
  [435] = {
    [sym_variable_name] = ACTIONS(586),
    [anon_sym_PIPE] = ACTIONS(1710),
    [anon_sym_RPAREN] = ACTIONS(586),
    [anon_sym_PIPE_AMP] = ACTIONS(586),
    [anon_sym_AMP_AMP] = ACTIONS(586),
    [anon_sym_PIPE_PIPE] = ACTIONS(586),
    [sym__special_characters] = ACTIONS(1710),
    [anon_sym_DQUOTE] = ACTIONS(586),
    [sym_raw_string] = ACTIONS(586),
    [anon_sym_DOLLAR] = ACTIONS(1710),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(586),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(586),
    [anon_sym_BQUOTE] = ACTIONS(586),
    [anon_sym_LT_LPAREN] = ACTIONS(586),
    [anon_sym_GT_LPAREN] = ACTIONS(586),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1710),
    [sym_word] = ACTIONS(588),
  },
  [436] = {
    [sym__assignment] = STATE(863),
    [anon_sym_EQ] = ACTIONS(1702),
    [anon_sym_PLUS_EQ] = ACTIONS(1702),
    [sym_comment] = ACTIONS(52),
  },
  [437] = {
    [sym_variable_assignment] = STATE(435),
    [sym_subscript] = STATE(436),
    [sym_concatenation] = STATE(435),
    [sym_string] = STATE(428),
    [sym_simple_expansion] = STATE(428),
    [sym_expansion] = STATE(428),
    [sym_command_substitution] = STATE(428),
    [sym_process_substitution] = STATE(428),
    [aux_sym_declaration_command_repeat1] = STATE(882),
    [sym_variable_name] = ACTIONS(744),
    [anon_sym_PIPE] = ACTIONS(1730),
    [anon_sym_RPAREN] = ACTIONS(1732),
    [anon_sym_PIPE_AMP] = ACTIONS(1732),
    [anon_sym_AMP_AMP] = ACTIONS(1732),
    [anon_sym_PIPE_PIPE] = ACTIONS(1732),
    [sym__special_characters] = ACTIONS(750),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [sym_raw_string] = ACTIONS(754),
    [anon_sym_DOLLAR] = ACTIONS(756),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(758),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(766),
    [sym_word] = ACTIONS(768),
  },
  [438] = {
    [sym_string] = STATE(883),
    [sym_simple_expansion] = STATE(883),
    [sym_expansion] = STATE(883),
    [sym_command_substitution] = STATE(883),
    [sym_process_substitution] = STATE(883),
    [sym__special_characters] = ACTIONS(1734),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1734),
  },
  [439] = {
    [aux_sym_concatenation_repeat1] = STATE(884),
    [sym_file_descriptor] = ACTIONS(646),
    [sym__concat] = ACTIONS(770),
    [anon_sym_PIPE] = ACTIONS(1300),
    [anon_sym_RPAREN] = ACTIONS(646),
    [anon_sym_PIPE_AMP] = ACTIONS(646),
    [anon_sym_AMP_AMP] = ACTIONS(646),
    [anon_sym_PIPE_PIPE] = ACTIONS(646),
    [anon_sym_LT] = ACTIONS(1300),
    [anon_sym_GT] = ACTIONS(1300),
    [anon_sym_GT_GT] = ACTIONS(646),
    [anon_sym_AMP_GT] = ACTIONS(1300),
    [anon_sym_AMP_GT_GT] = ACTIONS(646),
    [anon_sym_LT_AMP] = ACTIONS(646),
    [anon_sym_GT_AMP] = ACTIONS(646),
    [anon_sym_LT_LT] = ACTIONS(1300),
    [anon_sym_LT_LT_DASH] = ACTIONS(646),
    [anon_sym_LT_LT_LT] = ACTIONS(646),
    [sym__special_characters] = ACTIONS(1300),
    [anon_sym_DQUOTE] = ACTIONS(646),
    [sym_raw_string] = ACTIONS(646),
    [anon_sym_DOLLAR] = ACTIONS(1300),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(646),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(646),
    [anon_sym_BQUOTE] = ACTIONS(646),
    [anon_sym_LT_LPAREN] = ACTIONS(646),
    [anon_sym_GT_LPAREN] = ACTIONS(646),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1300),
  },
  [440] = {
    [sym_file_descriptor] = ACTIONS(650),
    [sym__concat] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(1302),
    [anon_sym_RPAREN] = ACTIONS(650),
    [anon_sym_PIPE_AMP] = ACTIONS(650),
    [anon_sym_AMP_AMP] = ACTIONS(650),
    [anon_sym_PIPE_PIPE] = ACTIONS(650),
    [anon_sym_LT] = ACTIONS(1302),
    [anon_sym_GT] = ACTIONS(1302),
    [anon_sym_GT_GT] = ACTIONS(650),
    [anon_sym_AMP_GT] = ACTIONS(1302),
    [anon_sym_AMP_GT_GT] = ACTIONS(650),
    [anon_sym_LT_AMP] = ACTIONS(650),
    [anon_sym_GT_AMP] = ACTIONS(650),
    [anon_sym_LT_LT] = ACTIONS(1302),
    [anon_sym_LT_LT_DASH] = ACTIONS(650),
    [anon_sym_LT_LT_LT] = ACTIONS(650),
    [sym__special_characters] = ACTIONS(1302),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [sym_raw_string] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(1302),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(650),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LT_LPAREN] = ACTIONS(650),
    [anon_sym_GT_LPAREN] = ACTIONS(650),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1302),
  },
  [441] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(1738),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [442] = {
    [sym_file_descriptor] = ACTIONS(680),
    [sym__concat] = ACTIONS(680),
    [anon_sym_PIPE] = ACTIONS(1306),
    [anon_sym_RPAREN] = ACTIONS(680),
    [anon_sym_PIPE_AMP] = ACTIONS(680),
    [anon_sym_AMP_AMP] = ACTIONS(680),
    [anon_sym_PIPE_PIPE] = ACTIONS(680),
    [anon_sym_LT] = ACTIONS(1306),
    [anon_sym_GT] = ACTIONS(1306),
    [anon_sym_GT_GT] = ACTIONS(680),
    [anon_sym_AMP_GT] = ACTIONS(1306),
    [anon_sym_AMP_GT_GT] = ACTIONS(680),
    [anon_sym_LT_AMP] = ACTIONS(680),
    [anon_sym_GT_AMP] = ACTIONS(680),
    [anon_sym_LT_LT] = ACTIONS(1306),
    [anon_sym_LT_LT_DASH] = ACTIONS(680),
    [anon_sym_LT_LT_LT] = ACTIONS(680),
    [sym__special_characters] = ACTIONS(1306),
    [anon_sym_DQUOTE] = ACTIONS(680),
    [sym_raw_string] = ACTIONS(680),
    [anon_sym_DOLLAR] = ACTIONS(1306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(680),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(680),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [anon_sym_LT_LPAREN] = ACTIONS(680),
    [anon_sym_GT_LPAREN] = ACTIONS(680),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1306),
  },
  [443] = {
    [sym_file_descriptor] = ACTIONS(684),
    [sym__concat] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(1308),
    [anon_sym_RPAREN] = ACTIONS(684),
    [anon_sym_PIPE_AMP] = ACTIONS(684),
    [anon_sym_AMP_AMP] = ACTIONS(684),
    [anon_sym_PIPE_PIPE] = ACTIONS(684),
    [anon_sym_LT] = ACTIONS(1308),
    [anon_sym_GT] = ACTIONS(1308),
    [anon_sym_GT_GT] = ACTIONS(684),
    [anon_sym_AMP_GT] = ACTIONS(1308),
    [anon_sym_AMP_GT_GT] = ACTIONS(684),
    [anon_sym_LT_AMP] = ACTIONS(684),
    [anon_sym_GT_AMP] = ACTIONS(684),
    [anon_sym_LT_LT] = ACTIONS(1308),
    [anon_sym_LT_LT_DASH] = ACTIONS(684),
    [anon_sym_LT_LT_LT] = ACTIONS(684),
    [sym__special_characters] = ACTIONS(1308),
    [anon_sym_DQUOTE] = ACTIONS(684),
    [sym_raw_string] = ACTIONS(684),
    [anon_sym_DOLLAR] = ACTIONS(1308),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(684),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(684),
    [anon_sym_BQUOTE] = ACTIONS(684),
    [anon_sym_LT_LPAREN] = ACTIONS(684),
    [anon_sym_GT_LPAREN] = ACTIONS(684),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1308),
  },
  [444] = {
    [sym_file_descriptor] = ACTIONS(688),
    [sym__concat] = ACTIONS(688),
    [anon_sym_PIPE] = ACTIONS(1310),
    [anon_sym_RPAREN] = ACTIONS(688),
    [anon_sym_PIPE_AMP] = ACTIONS(688),
    [anon_sym_AMP_AMP] = ACTIONS(688),
    [anon_sym_PIPE_PIPE] = ACTIONS(688),
    [anon_sym_LT] = ACTIONS(1310),
    [anon_sym_GT] = ACTIONS(1310),
    [anon_sym_GT_GT] = ACTIONS(688),
    [anon_sym_AMP_GT] = ACTIONS(1310),
    [anon_sym_AMP_GT_GT] = ACTIONS(688),
    [anon_sym_LT_AMP] = ACTIONS(688),
    [anon_sym_GT_AMP] = ACTIONS(688),
    [anon_sym_LT_LT] = ACTIONS(1310),
    [anon_sym_LT_LT_DASH] = ACTIONS(688),
    [anon_sym_LT_LT_LT] = ACTIONS(688),
    [sym__special_characters] = ACTIONS(1310),
    [anon_sym_DQUOTE] = ACTIONS(688),
    [sym_raw_string] = ACTIONS(688),
    [anon_sym_DOLLAR] = ACTIONS(1310),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(688),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(688),
    [anon_sym_BQUOTE] = ACTIONS(688),
    [anon_sym_LT_LPAREN] = ACTIONS(688),
    [anon_sym_GT_LPAREN] = ACTIONS(688),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1310),
  },
  [445] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(1740),
    [sym_comment] = ACTIONS(52),
  },
  [446] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(888),
    [anon_sym_RBRACE] = ACTIONS(1742),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [447] = {
    [sym_subscript] = STATE(892),
    [sym_variable_name] = ACTIONS(1744),
    [anon_sym_DOLLAR] = ACTIONS(1746),
    [anon_sym_DASH] = ACTIONS(1746),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1748),
    [anon_sym_STAR] = ACTIONS(1746),
    [anon_sym_AT] = ACTIONS(1746),
    [anon_sym_QMARK] = ACTIONS(1746),
    [anon_sym_0] = ACTIONS(1750),
    [anon_sym__] = ACTIONS(1750),
  },
  [448] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(894),
    [anon_sym_RBRACE] = ACTIONS(1752),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [449] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(896),
    [anon_sym_RBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [450] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1756),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [451] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1756),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [452] = {
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(1756),
    [sym_comment] = ACTIONS(52),
  },
  [453] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(1756),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [454] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1758),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [455] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1758),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [456] = {
    [anon_sym_RPAREN] = ACTIONS(1760),
    [sym_comment] = ACTIONS(52),
  },
  [457] = {
    [sym_for_statement] = STATE(900),
    [sym_while_statement] = STATE(900),
    [sym_if_statement] = STATE(900),
    [sym_case_statement] = STATE(900),
    [sym_function_definition] = STATE(900),
    [sym_subshell] = STATE(900),
    [sym_pipeline] = STATE(900),
    [sym_list] = STATE(900),
    [sym_bracket_command] = STATE(900),
    [sym_command] = STATE(900),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(901),
    [sym_declaration_command] = STATE(900),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [458] = {
    [sym_file_descriptor] = ACTIONS(1762),
    [sym__concat] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(1764),
    [anon_sym_SEMI_SEMI] = ACTIONS(1764),
    [anon_sym_PIPE_AMP] = ACTIONS(1764),
    [anon_sym_AMP_AMP] = ACTIONS(1764),
    [anon_sym_PIPE_PIPE] = ACTIONS(1764),
    [anon_sym_LT] = ACTIONS(1764),
    [anon_sym_GT] = ACTIONS(1764),
    [anon_sym_GT_GT] = ACTIONS(1764),
    [anon_sym_AMP_GT] = ACTIONS(1764),
    [anon_sym_AMP_GT_GT] = ACTIONS(1764),
    [anon_sym_LT_AMP] = ACTIONS(1764),
    [anon_sym_GT_AMP] = ACTIONS(1764),
    [anon_sym_LT_LT] = ACTIONS(1764),
    [anon_sym_LT_LT_DASH] = ACTIONS(1764),
    [anon_sym_LT_LT_LT] = ACTIONS(1764),
    [sym__special_characters] = ACTIONS(1764),
    [anon_sym_DQUOTE] = ACTIONS(1764),
    [sym_raw_string] = ACTIONS(1764),
    [anon_sym_DOLLAR] = ACTIONS(1764),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1764),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1764),
    [anon_sym_BQUOTE] = ACTIONS(1764),
    [anon_sym_LT_LPAREN] = ACTIONS(1764),
    [anon_sym_GT_LPAREN] = ACTIONS(1764),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1764),
    [anon_sym_SEMI] = ACTIONS(1764),
    [anon_sym_LF] = ACTIONS(1764),
    [anon_sym_AMP] = ACTIONS(1764),
  },
  [459] = {
    [sym_for_statement] = STATE(902),
    [sym_while_statement] = STATE(902),
    [sym_if_statement] = STATE(902),
    [sym_case_statement] = STATE(902),
    [sym_function_definition] = STATE(902),
    [sym_subshell] = STATE(902),
    [sym_pipeline] = STATE(902),
    [sym_list] = STATE(902),
    [sym_bracket_command] = STATE(902),
    [sym_command] = STATE(902),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(903),
    [sym_declaration_command] = STATE(902),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [460] = {
    [anon_sym_LT] = ACTIONS(1766),
    [anon_sym_GT] = ACTIONS(1766),
    [anon_sym_GT_GT] = ACTIONS(1768),
    [anon_sym_AMP_GT] = ACTIONS(1766),
    [anon_sym_AMP_GT_GT] = ACTIONS(1768),
    [anon_sym_LT_AMP] = ACTIONS(1768),
    [anon_sym_GT_AMP] = ACTIONS(1768),
    [sym_comment] = ACTIONS(52),
  },
  [461] = {
    [sym_concatenation] = STATE(913),
    [sym_string] = STATE(907),
    [sym_simple_expansion] = STATE(907),
    [sym_expansion] = STATE(907),
    [sym_command_substitution] = STATE(907),
    [sym_process_substitution] = STATE(907),
    [sym__special_characters] = ACTIONS(1770),
    [anon_sym_DQUOTE] = ACTIONS(1772),
    [sym_raw_string] = ACTIONS(1774),
    [anon_sym_DOLLAR] = ACTIONS(1776),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1778),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1780),
    [anon_sym_BQUOTE] = ACTIONS(1782),
    [anon_sym_LT_LPAREN] = ACTIONS(1784),
    [anon_sym_GT_LPAREN] = ACTIONS(1784),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1786),
  },
  [462] = {
    [sym_heredoc] = STATE(916),
    [sym__simple_heredoc] = ACTIONS(1788),
    [sym__heredoc_beginning] = ACTIONS(1790),
    [sym_comment] = ACTIONS(52),
  },
  [463] = {
    [sym_concatenation] = STATE(919),
    [sym_string] = STATE(918),
    [sym_simple_expansion] = STATE(918),
    [sym_expansion] = STATE(918),
    [sym_command_substitution] = STATE(918),
    [sym_process_substitution] = STATE(918),
    [sym__special_characters] = ACTIONS(1792),
    [anon_sym_DQUOTE] = ACTIONS(1772),
    [sym_raw_string] = ACTIONS(1794),
    [anon_sym_DOLLAR] = ACTIONS(1776),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1778),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1780),
    [anon_sym_BQUOTE] = ACTIONS(1782),
    [anon_sym_LT_LPAREN] = ACTIONS(1784),
    [anon_sym_GT_LPAREN] = ACTIONS(1784),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1796),
  },
  [464] = {
    [aux_sym_concatenation_repeat1] = STATE(439),
    [sym_file_descriptor] = ACTIONS(522),
    [sym__concat] = ACTIONS(770),
    [anon_sym_PIPE] = ACTIONS(518),
    [anon_sym_RPAREN] = ACTIONS(522),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(522),
    [anon_sym_PIPE_PIPE] = ACTIONS(522),
    [anon_sym_LT] = ACTIONS(518),
    [anon_sym_GT] = ACTIONS(518),
    [anon_sym_GT_GT] = ACTIONS(522),
    [anon_sym_AMP_GT] = ACTIONS(518),
    [anon_sym_AMP_GT_GT] = ACTIONS(522),
    [anon_sym_LT_AMP] = ACTIONS(522),
    [anon_sym_GT_AMP] = ACTIONS(522),
    [anon_sym_LT_LT] = ACTIONS(518),
    [anon_sym_LT_LT_DASH] = ACTIONS(522),
    [anon_sym_LT_LT_LT] = ACTIONS(522),
    [sym__special_characters] = ACTIONS(518),
    [anon_sym_DQUOTE] = ACTIONS(522),
    [sym_raw_string] = ACTIONS(522),
    [anon_sym_DOLLAR] = ACTIONS(518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(522),
    [anon_sym_LT_LPAREN] = ACTIONS(522),
    [anon_sym_GT_LPAREN] = ACTIONS(522),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(518),
  },
  [465] = {
    [aux_sym_concatenation_repeat1] = STATE(439),
    [sym_file_descriptor] = ACTIONS(530),
    [sym__concat] = ACTIONS(770),
    [anon_sym_PIPE] = ACTIONS(526),
    [anon_sym_RPAREN] = ACTIONS(530),
    [anon_sym_PIPE_AMP] = ACTIONS(530),
    [anon_sym_AMP_AMP] = ACTIONS(530),
    [anon_sym_PIPE_PIPE] = ACTIONS(530),
    [anon_sym_LT] = ACTIONS(526),
    [anon_sym_GT] = ACTIONS(526),
    [anon_sym_GT_GT] = ACTIONS(530),
    [anon_sym_AMP_GT] = ACTIONS(526),
    [anon_sym_AMP_GT_GT] = ACTIONS(530),
    [anon_sym_LT_AMP] = ACTIONS(530),
    [anon_sym_GT_AMP] = ACTIONS(530),
    [anon_sym_LT_LT] = ACTIONS(526),
    [anon_sym_LT_LT_DASH] = ACTIONS(530),
    [anon_sym_LT_LT_LT] = ACTIONS(530),
    [sym__special_characters] = ACTIONS(526),
    [anon_sym_DQUOTE] = ACTIONS(530),
    [sym_raw_string] = ACTIONS(530),
    [anon_sym_DOLLAR] = ACTIONS(526),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(530),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(530),
    [anon_sym_BQUOTE] = ACTIONS(530),
    [anon_sym_LT_LPAREN] = ACTIONS(530),
    [anon_sym_GT_LPAREN] = ACTIONS(530),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(526),
  },
  [466] = {
    [sym_file_descriptor] = ACTIONS(940),
    [anon_sym_PIPE] = ACTIONS(1798),
    [anon_sym_RPAREN] = ACTIONS(940),
    [anon_sym_PIPE_AMP] = ACTIONS(940),
    [anon_sym_AMP_AMP] = ACTIONS(940),
    [anon_sym_PIPE_PIPE] = ACTIONS(940),
    [anon_sym_LT] = ACTIONS(1798),
    [anon_sym_GT] = ACTIONS(1798),
    [anon_sym_GT_GT] = ACTIONS(940),
    [anon_sym_AMP_GT] = ACTIONS(1798),
    [anon_sym_AMP_GT_GT] = ACTIONS(940),
    [anon_sym_LT_AMP] = ACTIONS(940),
    [anon_sym_GT_AMP] = ACTIONS(940),
    [anon_sym_LT_LT] = ACTIONS(1798),
    [anon_sym_LT_LT_DASH] = ACTIONS(940),
    [anon_sym_LT_LT_LT] = ACTIONS(940),
    [anon_sym_BQUOTE] = ACTIONS(940),
    [sym_comment] = ACTIONS(52),
  },
  [467] = {
    [sym_file_descriptor] = ACTIONS(530),
    [anon_sym_PIPE] = ACTIONS(526),
    [anon_sym_RPAREN] = ACTIONS(530),
    [anon_sym_PIPE_AMP] = ACTIONS(530),
    [anon_sym_AMP_AMP] = ACTIONS(530),
    [anon_sym_PIPE_PIPE] = ACTIONS(530),
    [anon_sym_LT] = ACTIONS(526),
    [anon_sym_GT] = ACTIONS(526),
    [anon_sym_GT_GT] = ACTIONS(530),
    [anon_sym_AMP_GT] = ACTIONS(526),
    [anon_sym_AMP_GT_GT] = ACTIONS(530),
    [anon_sym_LT_AMP] = ACTIONS(530),
    [anon_sym_GT_AMP] = ACTIONS(530),
    [anon_sym_LT_LT] = ACTIONS(526),
    [anon_sym_LT_LT_DASH] = ACTIONS(530),
    [anon_sym_LT_LT_LT] = ACTIONS(530),
    [sym__special_characters] = ACTIONS(526),
    [anon_sym_DQUOTE] = ACTIONS(530),
    [sym_raw_string] = ACTIONS(530),
    [anon_sym_DOLLAR] = ACTIONS(526),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(530),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(530),
    [anon_sym_BQUOTE] = ACTIONS(530),
    [anon_sym_LT_LPAREN] = ACTIONS(530),
    [anon_sym_GT_LPAREN] = ACTIONS(530),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(526),
  },
  [468] = {
    [sym_file_redirect] = STATE(466),
    [sym_heredoc_redirect] = STATE(466),
    [sym_herestring_redirect] = STATE(466),
    [sym_concatenation] = STATE(467),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_for_statement_repeat1] = STATE(920),
    [aux_sym_while_statement_repeat1] = STATE(921),
    [sym_file_descriptor] = ACTIONS(804),
    [anon_sym_PIPE] = ACTIONS(1800),
    [anon_sym_RPAREN] = ACTIONS(1802),
    [anon_sym_PIPE_AMP] = ACTIONS(1802),
    [anon_sym_AMP_AMP] = ACTIONS(1802),
    [anon_sym_PIPE_PIPE] = ACTIONS(1802),
    [anon_sym_LT] = ACTIONS(810),
    [anon_sym_GT] = ACTIONS(810),
    [anon_sym_GT_GT] = ACTIONS(812),
    [anon_sym_AMP_GT] = ACTIONS(810),
    [anon_sym_AMP_GT_GT] = ACTIONS(812),
    [anon_sym_LT_AMP] = ACTIONS(812),
    [anon_sym_GT_AMP] = ACTIONS(812),
    [anon_sym_LT_LT] = ACTIONS(814),
    [anon_sym_LT_LT_DASH] = ACTIONS(816),
    [anon_sym_LT_LT_LT] = ACTIONS(818),
    [sym__special_characters] = ACTIONS(820),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(824),
  },
  [469] = {
    [sym_file_redirect] = STATE(466),
    [sym_heredoc_redirect] = STATE(466),
    [sym_herestring_redirect] = STATE(466),
    [aux_sym_while_statement_repeat1] = STATE(922),
    [sym_file_descriptor] = ACTIONS(804),
    [anon_sym_PIPE] = ACTIONS(1800),
    [anon_sym_RPAREN] = ACTIONS(1802),
    [anon_sym_PIPE_AMP] = ACTIONS(1802),
    [anon_sym_AMP_AMP] = ACTIONS(1802),
    [anon_sym_PIPE_PIPE] = ACTIONS(1802),
    [anon_sym_LT] = ACTIONS(810),
    [anon_sym_GT] = ACTIONS(810),
    [anon_sym_GT_GT] = ACTIONS(812),
    [anon_sym_AMP_GT] = ACTIONS(810),
    [anon_sym_AMP_GT_GT] = ACTIONS(812),
    [anon_sym_LT_AMP] = ACTIONS(812),
    [anon_sym_GT_AMP] = ACTIONS(812),
    [anon_sym_LT_LT] = ACTIONS(814),
    [anon_sym_LT_LT_DASH] = ACTIONS(816),
    [anon_sym_LT_LT_LT] = ACTIONS(818),
    [sym_comment] = ACTIONS(52),
  },
  [470] = {
    [sym_file_redirect] = STATE(466),
    [sym_heredoc_redirect] = STATE(466),
    [sym_herestring_redirect] = STATE(466),
    [sym_concatenation] = STATE(467),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_for_statement_repeat1] = STATE(923),
    [aux_sym_while_statement_repeat1] = STATE(921),
    [sym_file_descriptor] = ACTIONS(804),
    [anon_sym_PIPE] = ACTIONS(1800),
    [anon_sym_RPAREN] = ACTIONS(1802),
    [anon_sym_PIPE_AMP] = ACTIONS(1802),
    [anon_sym_AMP_AMP] = ACTIONS(1802),
    [anon_sym_PIPE_PIPE] = ACTIONS(1802),
    [anon_sym_LT] = ACTIONS(810),
    [anon_sym_GT] = ACTIONS(810),
    [anon_sym_GT_GT] = ACTIONS(812),
    [anon_sym_AMP_GT] = ACTIONS(810),
    [anon_sym_AMP_GT_GT] = ACTIONS(812),
    [anon_sym_LT_AMP] = ACTIONS(812),
    [anon_sym_GT_AMP] = ACTIONS(812),
    [anon_sym_LT_LT] = ACTIONS(814),
    [anon_sym_LT_LT_DASH] = ACTIONS(816),
    [anon_sym_LT_LT_LT] = ACTIONS(818),
    [sym__special_characters] = ACTIONS(820),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(824),
  },
  [471] = {
    [sym_concatenation] = STATE(836),
    [sym_string] = STATE(926),
    [sym_array] = STATE(836),
    [sym_simple_expansion] = STATE(926),
    [sym_expansion] = STATE(926),
    [sym_command_substitution] = STATE(926),
    [sym_process_substitution] = STATE(926),
    [sym__empty_value] = ACTIONS(1652),
    [anon_sym_LPAREN] = ACTIONS(1654),
    [sym__special_characters] = ACTIONS(1804),
    [anon_sym_DQUOTE] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(1808),
    [anon_sym_DOLLAR] = ACTIONS(1810),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1812),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1814),
    [anon_sym_BQUOTE] = ACTIONS(1816),
    [anon_sym_LT_LPAREN] = ACTIONS(1818),
    [anon_sym_GT_LPAREN] = ACTIONS(1818),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1820),
  },
  [472] = {
    [sym_do_group] = STATE(932),
    [anon_sym_do] = ACTIONS(1678),
    [sym_comment] = ACTIONS(52),
  },
  [473] = {
    [sym_compound_statement] = STATE(934),
    [anon_sym_LPAREN] = ACTIONS(1822),
    [anon_sym_LBRACE] = ACTIONS(1692),
    [sym_comment] = ACTIONS(52),
  },
  [474] = {
    [sym__assignment] = STATE(863),
    [anon_sym_LBRACK] = ACTIONS(60),
    [anon_sym_EQ] = ACTIONS(1824),
    [anon_sym_PLUS_EQ] = ACTIONS(1824),
    [sym_comment] = ACTIONS(52),
  },
  [475] = {
    [aux_sym_concatenation_repeat1] = STATE(937),
    [sym__concat] = ACTIONS(1826),
    [sym_variable_name] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(1706),
    [anon_sym_PIPE_AMP] = ACTIONS(580),
    [anon_sym_AMP_AMP] = ACTIONS(580),
    [anon_sym_PIPE_PIPE] = ACTIONS(580),
    [sym__special_characters] = ACTIONS(1706),
    [anon_sym_DQUOTE] = ACTIONS(580),
    [sym_raw_string] = ACTIONS(580),
    [anon_sym_DOLLAR] = ACTIONS(1706),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(580),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(580),
    [anon_sym_BQUOTE] = ACTIONS(580),
    [anon_sym_LT_LPAREN] = ACTIONS(580),
    [anon_sym_GT_LPAREN] = ACTIONS(580),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1706),
    [sym_word] = ACTIONS(582),
  },
  [476] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(939),
    [anon_sym_DQUOTE] = ACTIONS(1828),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [477] = {
    [aux_sym_concatenation_repeat1] = STATE(937),
    [sym__concat] = ACTIONS(1826),
    [sym_variable_name] = ACTIONS(586),
    [anon_sym_PIPE] = ACTIONS(1710),
    [anon_sym_PIPE_AMP] = ACTIONS(586),
    [anon_sym_AMP_AMP] = ACTIONS(586),
    [anon_sym_PIPE_PIPE] = ACTIONS(586),
    [sym__special_characters] = ACTIONS(1710),
    [anon_sym_DQUOTE] = ACTIONS(586),
    [sym_raw_string] = ACTIONS(586),
    [anon_sym_DOLLAR] = ACTIONS(1710),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(586),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(586),
    [anon_sym_BQUOTE] = ACTIONS(586),
    [anon_sym_LT_LPAREN] = ACTIONS(586),
    [anon_sym_GT_LPAREN] = ACTIONS(586),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1710),
    [sym_word] = ACTIONS(588),
  },
  [478] = {
    [sym_string] = STATE(942),
    [anon_sym_DQUOTE] = ACTIONS(838),
    [anon_sym_DOLLAR] = ACTIONS(1830),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_DASH] = ACTIONS(1830),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1832),
    [anon_sym_STAR] = ACTIONS(1830),
    [anon_sym_AT] = ACTIONS(1830),
    [anon_sym_QMARK] = ACTIONS(1830),
    [anon_sym_0] = ACTIONS(1834),
    [anon_sym__] = ACTIONS(1834),
  },
  [479] = {
    [sym_subscript] = STATE(947),
    [sym_variable_name] = ACTIONS(1836),
    [anon_sym_DOLLAR] = ACTIONS(1838),
    [anon_sym_POUND] = ACTIONS(1840),
    [anon_sym_DASH] = ACTIONS(1838),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1842),
    [anon_sym_STAR] = ACTIONS(1838),
    [anon_sym_AT] = ACTIONS(1838),
    [anon_sym_QMARK] = ACTIONS(1838),
    [anon_sym_0] = ACTIONS(1844),
    [anon_sym__] = ACTIONS(1844),
  },
  [480] = {
    [sym_for_statement] = STATE(948),
    [sym_while_statement] = STATE(948),
    [sym_if_statement] = STATE(948),
    [sym_case_statement] = STATE(948),
    [sym_function_definition] = STATE(948),
    [sym_subshell] = STATE(948),
    [sym_pipeline] = STATE(948),
    [sym_list] = STATE(948),
    [sym_bracket_command] = STATE(948),
    [sym_command] = STATE(948),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(949),
    [sym_declaration_command] = STATE(948),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [481] = {
    [sym_for_statement] = STATE(950),
    [sym_while_statement] = STATE(950),
    [sym_if_statement] = STATE(950),
    [sym_case_statement] = STATE(950),
    [sym_function_definition] = STATE(950),
    [sym_subshell] = STATE(950),
    [sym_pipeline] = STATE(950),
    [sym_list] = STATE(950),
    [sym_bracket_command] = STATE(950),
    [sym_command] = STATE(950),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(951),
    [sym_declaration_command] = STATE(950),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [482] = {
    [sym_for_statement] = STATE(952),
    [sym_while_statement] = STATE(952),
    [sym_if_statement] = STATE(952),
    [sym_case_statement] = STATE(952),
    [sym_function_definition] = STATE(952),
    [sym_subshell] = STATE(952),
    [sym_pipeline] = STATE(952),
    [sym_list] = STATE(952),
    [sym_bracket_command] = STATE(952),
    [sym_command] = STATE(952),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(953),
    [sym_declaration_command] = STATE(952),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [483] = {
    [sym__assignment] = STATE(863),
    [anon_sym_EQ] = ACTIONS(1824),
    [anon_sym_PLUS_EQ] = ACTIONS(1824),
    [sym_comment] = ACTIONS(52),
  },
  [484] = {
    [sym_variable_assignment] = STATE(435),
    [sym_subscript] = STATE(483),
    [sym_concatenation] = STATE(435),
    [sym_string] = STATE(477),
    [sym_simple_expansion] = STATE(477),
    [sym_expansion] = STATE(477),
    [sym_command_substitution] = STATE(477),
    [sym_process_substitution] = STATE(477),
    [aux_sym_declaration_command_repeat1] = STATE(954),
    [sym_variable_name] = ACTIONS(834),
    [anon_sym_PIPE] = ACTIONS(1730),
    [anon_sym_PIPE_AMP] = ACTIONS(1732),
    [anon_sym_AMP_AMP] = ACTIONS(1732),
    [anon_sym_PIPE_PIPE] = ACTIONS(1732),
    [sym__special_characters] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(838),
    [sym_raw_string] = ACTIONS(840),
    [anon_sym_DOLLAR] = ACTIONS(842),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(844),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(846),
    [anon_sym_BQUOTE] = ACTIONS(1732),
    [anon_sym_LT_LPAREN] = ACTIONS(848),
    [anon_sym_GT_LPAREN] = ACTIONS(848),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(766),
    [sym_word] = ACTIONS(850),
  },
  [485] = {
    [sym_string] = STATE(955),
    [sym_simple_expansion] = STATE(955),
    [sym_expansion] = STATE(955),
    [sym_command_substitution] = STATE(955),
    [sym_process_substitution] = STATE(955),
    [sym__special_characters] = ACTIONS(1846),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(1848),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1846),
  },
  [486] = {
    [aux_sym_concatenation_repeat1] = STATE(956),
    [sym_file_descriptor] = ACTIONS(646),
    [sym__concat] = ACTIONS(852),
    [anon_sym_PIPE] = ACTIONS(1300),
    [anon_sym_PIPE_AMP] = ACTIONS(646),
    [anon_sym_AMP_AMP] = ACTIONS(646),
    [anon_sym_PIPE_PIPE] = ACTIONS(646),
    [anon_sym_LT] = ACTIONS(1300),
    [anon_sym_GT] = ACTIONS(1300),
    [anon_sym_GT_GT] = ACTIONS(646),
    [anon_sym_AMP_GT] = ACTIONS(1300),
    [anon_sym_AMP_GT_GT] = ACTIONS(646),
    [anon_sym_LT_AMP] = ACTIONS(646),
    [anon_sym_GT_AMP] = ACTIONS(646),
    [anon_sym_LT_LT] = ACTIONS(1300),
    [anon_sym_LT_LT_DASH] = ACTIONS(646),
    [anon_sym_LT_LT_LT] = ACTIONS(646),
    [sym__special_characters] = ACTIONS(1300),
    [anon_sym_DQUOTE] = ACTIONS(646),
    [sym_raw_string] = ACTIONS(646),
    [anon_sym_DOLLAR] = ACTIONS(1300),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(646),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(646),
    [anon_sym_BQUOTE] = ACTIONS(646),
    [anon_sym_LT_LPAREN] = ACTIONS(646),
    [anon_sym_GT_LPAREN] = ACTIONS(646),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1300),
  },
  [487] = {
    [sym_file_descriptor] = ACTIONS(650),
    [sym__concat] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(1302),
    [anon_sym_PIPE_AMP] = ACTIONS(650),
    [anon_sym_AMP_AMP] = ACTIONS(650),
    [anon_sym_PIPE_PIPE] = ACTIONS(650),
    [anon_sym_LT] = ACTIONS(1302),
    [anon_sym_GT] = ACTIONS(1302),
    [anon_sym_GT_GT] = ACTIONS(650),
    [anon_sym_AMP_GT] = ACTIONS(1302),
    [anon_sym_AMP_GT_GT] = ACTIONS(650),
    [anon_sym_LT_AMP] = ACTIONS(650),
    [anon_sym_GT_AMP] = ACTIONS(650),
    [anon_sym_LT_LT] = ACTIONS(1302),
    [anon_sym_LT_LT_DASH] = ACTIONS(650),
    [anon_sym_LT_LT_LT] = ACTIONS(650),
    [sym__special_characters] = ACTIONS(1302),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [sym_raw_string] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(1302),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(650),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LT_LPAREN] = ACTIONS(650),
    [anon_sym_GT_LPAREN] = ACTIONS(650),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1302),
  },
  [488] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(1850),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [489] = {
    [sym_file_descriptor] = ACTIONS(680),
    [sym__concat] = ACTIONS(680),
    [anon_sym_PIPE] = ACTIONS(1306),
    [anon_sym_PIPE_AMP] = ACTIONS(680),
    [anon_sym_AMP_AMP] = ACTIONS(680),
    [anon_sym_PIPE_PIPE] = ACTIONS(680),
    [anon_sym_LT] = ACTIONS(1306),
    [anon_sym_GT] = ACTIONS(1306),
    [anon_sym_GT_GT] = ACTIONS(680),
    [anon_sym_AMP_GT] = ACTIONS(1306),
    [anon_sym_AMP_GT_GT] = ACTIONS(680),
    [anon_sym_LT_AMP] = ACTIONS(680),
    [anon_sym_GT_AMP] = ACTIONS(680),
    [anon_sym_LT_LT] = ACTIONS(1306),
    [anon_sym_LT_LT_DASH] = ACTIONS(680),
    [anon_sym_LT_LT_LT] = ACTIONS(680),
    [sym__special_characters] = ACTIONS(1306),
    [anon_sym_DQUOTE] = ACTIONS(680),
    [sym_raw_string] = ACTIONS(680),
    [anon_sym_DOLLAR] = ACTIONS(1306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(680),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(680),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [anon_sym_LT_LPAREN] = ACTIONS(680),
    [anon_sym_GT_LPAREN] = ACTIONS(680),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1306),
  },
  [490] = {
    [sym_file_descriptor] = ACTIONS(684),
    [sym__concat] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(1308),
    [anon_sym_PIPE_AMP] = ACTIONS(684),
    [anon_sym_AMP_AMP] = ACTIONS(684),
    [anon_sym_PIPE_PIPE] = ACTIONS(684),
    [anon_sym_LT] = ACTIONS(1308),
    [anon_sym_GT] = ACTIONS(1308),
    [anon_sym_GT_GT] = ACTIONS(684),
    [anon_sym_AMP_GT] = ACTIONS(1308),
    [anon_sym_AMP_GT_GT] = ACTIONS(684),
    [anon_sym_LT_AMP] = ACTIONS(684),
    [anon_sym_GT_AMP] = ACTIONS(684),
    [anon_sym_LT_LT] = ACTIONS(1308),
    [anon_sym_LT_LT_DASH] = ACTIONS(684),
    [anon_sym_LT_LT_LT] = ACTIONS(684),
    [sym__special_characters] = ACTIONS(1308),
    [anon_sym_DQUOTE] = ACTIONS(684),
    [sym_raw_string] = ACTIONS(684),
    [anon_sym_DOLLAR] = ACTIONS(1308),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(684),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(684),
    [anon_sym_BQUOTE] = ACTIONS(684),
    [anon_sym_LT_LPAREN] = ACTIONS(684),
    [anon_sym_GT_LPAREN] = ACTIONS(684),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1308),
  },
  [491] = {
    [sym_file_descriptor] = ACTIONS(688),
    [sym__concat] = ACTIONS(688),
    [anon_sym_PIPE] = ACTIONS(1310),
    [anon_sym_PIPE_AMP] = ACTIONS(688),
    [anon_sym_AMP_AMP] = ACTIONS(688),
    [anon_sym_PIPE_PIPE] = ACTIONS(688),
    [anon_sym_LT] = ACTIONS(1310),
    [anon_sym_GT] = ACTIONS(1310),
    [anon_sym_GT_GT] = ACTIONS(688),
    [anon_sym_AMP_GT] = ACTIONS(1310),
    [anon_sym_AMP_GT_GT] = ACTIONS(688),
    [anon_sym_LT_AMP] = ACTIONS(688),
    [anon_sym_GT_AMP] = ACTIONS(688),
    [anon_sym_LT_LT] = ACTIONS(1310),
    [anon_sym_LT_LT_DASH] = ACTIONS(688),
    [anon_sym_LT_LT_LT] = ACTIONS(688),
    [sym__special_characters] = ACTIONS(1310),
    [anon_sym_DQUOTE] = ACTIONS(688),
    [sym_raw_string] = ACTIONS(688),
    [anon_sym_DOLLAR] = ACTIONS(1310),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(688),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(688),
    [anon_sym_BQUOTE] = ACTIONS(688),
    [anon_sym_LT_LPAREN] = ACTIONS(688),
    [anon_sym_GT_LPAREN] = ACTIONS(688),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1310),
  },
  [492] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(1852),
    [sym_comment] = ACTIONS(52),
  },
  [493] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(960),
    [anon_sym_RBRACE] = ACTIONS(1854),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [494] = {
    [sym_subscript] = STATE(964),
    [sym_variable_name] = ACTIONS(1856),
    [anon_sym_DOLLAR] = ACTIONS(1858),
    [anon_sym_DASH] = ACTIONS(1858),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1860),
    [anon_sym_STAR] = ACTIONS(1858),
    [anon_sym_AT] = ACTIONS(1858),
    [anon_sym_QMARK] = ACTIONS(1858),
    [anon_sym_0] = ACTIONS(1862),
    [anon_sym__] = ACTIONS(1862),
  },
  [495] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(966),
    [anon_sym_RBRACE] = ACTIONS(1864),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [496] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(968),
    [anon_sym_RBRACE] = ACTIONS(1866),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [497] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1868),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [498] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1868),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [499] = {
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(1868),
    [sym_comment] = ACTIONS(52),
  },
  [500] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(1868),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [501] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1870),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [502] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(1870),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [503] = {
    [anon_sym_RPAREN] = ACTIONS(1872),
    [sym_comment] = ACTIONS(52),
  },
  [504] = {
    [sym_for_statement] = STATE(900),
    [sym_while_statement] = STATE(900),
    [sym_if_statement] = STATE(900),
    [sym_case_statement] = STATE(900),
    [sym_function_definition] = STATE(900),
    [sym_subshell] = STATE(900),
    [sym_pipeline] = STATE(900),
    [sym_list] = STATE(900),
    [sym_bracket_command] = STATE(900),
    [sym_command] = STATE(900),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(972),
    [sym_declaration_command] = STATE(900),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [505] = {
    [sym_for_statement] = STATE(973),
    [sym_while_statement] = STATE(973),
    [sym_if_statement] = STATE(973),
    [sym_case_statement] = STATE(973),
    [sym_function_definition] = STATE(973),
    [sym_subshell] = STATE(973),
    [sym_pipeline] = STATE(973),
    [sym_list] = STATE(973),
    [sym_bracket_command] = STATE(973),
    [sym_command] = STATE(973),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(974),
    [sym_declaration_command] = STATE(973),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [506] = {
    [anon_sym_LT] = ACTIONS(1874),
    [anon_sym_GT] = ACTIONS(1874),
    [anon_sym_GT_GT] = ACTIONS(1876),
    [anon_sym_AMP_GT] = ACTIONS(1874),
    [anon_sym_AMP_GT_GT] = ACTIONS(1876),
    [anon_sym_LT_AMP] = ACTIONS(1876),
    [anon_sym_GT_AMP] = ACTIONS(1876),
    [sym_comment] = ACTIONS(52),
  },
  [507] = {
    [sym_concatenation] = STATE(913),
    [sym_string] = STATE(978),
    [sym_simple_expansion] = STATE(978),
    [sym_expansion] = STATE(978),
    [sym_command_substitution] = STATE(978),
    [sym_process_substitution] = STATE(978),
    [sym__special_characters] = ACTIONS(1878),
    [anon_sym_DQUOTE] = ACTIONS(1880),
    [sym_raw_string] = ACTIONS(1882),
    [anon_sym_DOLLAR] = ACTIONS(1884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1888),
    [anon_sym_BQUOTE] = ACTIONS(1890),
    [anon_sym_LT_LPAREN] = ACTIONS(1892),
    [anon_sym_GT_LPAREN] = ACTIONS(1892),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1894),
  },
  [508] = {
    [sym_concatenation] = STATE(919),
    [sym_string] = STATE(985),
    [sym_simple_expansion] = STATE(985),
    [sym_expansion] = STATE(985),
    [sym_command_substitution] = STATE(985),
    [sym_process_substitution] = STATE(985),
    [sym__special_characters] = ACTIONS(1896),
    [anon_sym_DQUOTE] = ACTIONS(1880),
    [sym_raw_string] = ACTIONS(1898),
    [anon_sym_DOLLAR] = ACTIONS(1884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1888),
    [anon_sym_BQUOTE] = ACTIONS(1890),
    [anon_sym_LT_LPAREN] = ACTIONS(1892),
    [anon_sym_GT_LPAREN] = ACTIONS(1892),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1900),
  },
  [509] = {
    [aux_sym_concatenation_repeat1] = STATE(486),
    [sym_file_descriptor] = ACTIONS(522),
    [sym__concat] = ACTIONS(852),
    [anon_sym_PIPE] = ACTIONS(518),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(522),
    [anon_sym_PIPE_PIPE] = ACTIONS(522),
    [anon_sym_LT] = ACTIONS(518),
    [anon_sym_GT] = ACTIONS(518),
    [anon_sym_GT_GT] = ACTIONS(522),
    [anon_sym_AMP_GT] = ACTIONS(518),
    [anon_sym_AMP_GT_GT] = ACTIONS(522),
    [anon_sym_LT_AMP] = ACTIONS(522),
    [anon_sym_GT_AMP] = ACTIONS(522),
    [anon_sym_LT_LT] = ACTIONS(518),
    [anon_sym_LT_LT_DASH] = ACTIONS(522),
    [anon_sym_LT_LT_LT] = ACTIONS(522),
    [sym__special_characters] = ACTIONS(518),
    [anon_sym_DQUOTE] = ACTIONS(522),
    [sym_raw_string] = ACTIONS(522),
    [anon_sym_DOLLAR] = ACTIONS(518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(522),
    [anon_sym_LT_LPAREN] = ACTIONS(522),
    [anon_sym_GT_LPAREN] = ACTIONS(522),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(518),
  },
  [510] = {
    [aux_sym_concatenation_repeat1] = STATE(486),
    [sym_file_descriptor] = ACTIONS(530),
    [sym__concat] = ACTIONS(852),
    [anon_sym_PIPE] = ACTIONS(526),
    [anon_sym_PIPE_AMP] = ACTIONS(530),
    [anon_sym_AMP_AMP] = ACTIONS(530),
    [anon_sym_PIPE_PIPE] = ACTIONS(530),
    [anon_sym_LT] = ACTIONS(526),
    [anon_sym_GT] = ACTIONS(526),
    [anon_sym_GT_GT] = ACTIONS(530),
    [anon_sym_AMP_GT] = ACTIONS(526),
    [anon_sym_AMP_GT_GT] = ACTIONS(530),
    [anon_sym_LT_AMP] = ACTIONS(530),
    [anon_sym_GT_AMP] = ACTIONS(530),
    [anon_sym_LT_LT] = ACTIONS(526),
    [anon_sym_LT_LT_DASH] = ACTIONS(530),
    [anon_sym_LT_LT_LT] = ACTIONS(530),
    [sym__special_characters] = ACTIONS(526),
    [anon_sym_DQUOTE] = ACTIONS(530),
    [sym_raw_string] = ACTIONS(530),
    [anon_sym_DOLLAR] = ACTIONS(526),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(530),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(530),
    [anon_sym_BQUOTE] = ACTIONS(530),
    [anon_sym_LT_LPAREN] = ACTIONS(530),
    [anon_sym_GT_LPAREN] = ACTIONS(530),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(526),
  },
  [511] = {
    [sym_file_redirect] = STATE(466),
    [sym_heredoc_redirect] = STATE(466),
    [sym_herestring_redirect] = STATE(466),
    [sym_concatenation] = STATE(467),
    [sym_string] = STATE(510),
    [sym_simple_expansion] = STATE(510),
    [sym_expansion] = STATE(510),
    [sym_command_substitution] = STATE(510),
    [sym_process_substitution] = STATE(510),
    [aux_sym_for_statement_repeat1] = STATE(986),
    [aux_sym_while_statement_repeat1] = STATE(987),
    [sym_file_descriptor] = ACTIONS(880),
    [anon_sym_PIPE] = ACTIONS(1800),
    [anon_sym_PIPE_AMP] = ACTIONS(1802),
    [anon_sym_AMP_AMP] = ACTIONS(1802),
    [anon_sym_PIPE_PIPE] = ACTIONS(1802),
    [anon_sym_LT] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(882),
    [anon_sym_GT_GT] = ACTIONS(884),
    [anon_sym_AMP_GT] = ACTIONS(882),
    [anon_sym_AMP_GT_GT] = ACTIONS(884),
    [anon_sym_LT_AMP] = ACTIONS(884),
    [anon_sym_GT_AMP] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(814),
    [anon_sym_LT_LT_DASH] = ACTIONS(816),
    [anon_sym_LT_LT_LT] = ACTIONS(886),
    [sym__special_characters] = ACTIONS(888),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(890),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(1802),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(892),
  },
  [512] = {
    [sym_file_redirect] = STATE(466),
    [sym_heredoc_redirect] = STATE(466),
    [sym_herestring_redirect] = STATE(466),
    [aux_sym_while_statement_repeat1] = STATE(988),
    [sym_file_descriptor] = ACTIONS(880),
    [anon_sym_PIPE] = ACTIONS(1800),
    [anon_sym_PIPE_AMP] = ACTIONS(1802),
    [anon_sym_AMP_AMP] = ACTIONS(1802),
    [anon_sym_PIPE_PIPE] = ACTIONS(1802),
    [anon_sym_LT] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(882),
    [anon_sym_GT_GT] = ACTIONS(884),
    [anon_sym_AMP_GT] = ACTIONS(882),
    [anon_sym_AMP_GT_GT] = ACTIONS(884),
    [anon_sym_LT_AMP] = ACTIONS(884),
    [anon_sym_GT_AMP] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(814),
    [anon_sym_LT_LT_DASH] = ACTIONS(816),
    [anon_sym_LT_LT_LT] = ACTIONS(886),
    [anon_sym_BQUOTE] = ACTIONS(1802),
    [sym_comment] = ACTIONS(52),
  },
  [513] = {
    [sym_file_redirect] = STATE(466),
    [sym_heredoc_redirect] = STATE(466),
    [sym_herestring_redirect] = STATE(466),
    [sym_concatenation] = STATE(467),
    [sym_string] = STATE(510),
    [sym_simple_expansion] = STATE(510),
    [sym_expansion] = STATE(510),
    [sym_command_substitution] = STATE(510),
    [sym_process_substitution] = STATE(510),
    [aux_sym_for_statement_repeat1] = STATE(989),
    [aux_sym_while_statement_repeat1] = STATE(987),
    [sym_file_descriptor] = ACTIONS(880),
    [anon_sym_PIPE] = ACTIONS(1800),
    [anon_sym_PIPE_AMP] = ACTIONS(1802),
    [anon_sym_AMP_AMP] = ACTIONS(1802),
    [anon_sym_PIPE_PIPE] = ACTIONS(1802),
    [anon_sym_LT] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(882),
    [anon_sym_GT_GT] = ACTIONS(884),
    [anon_sym_AMP_GT] = ACTIONS(882),
    [anon_sym_AMP_GT_GT] = ACTIONS(884),
    [anon_sym_LT_AMP] = ACTIONS(884),
    [anon_sym_GT_AMP] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(814),
    [anon_sym_LT_LT_DASH] = ACTIONS(816),
    [anon_sym_LT_LT_LT] = ACTIONS(886),
    [sym__special_characters] = ACTIONS(888),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(890),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(1802),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(892),
  },
  [514] = {
    [sym_file_descriptor] = ACTIONS(1902),
    [sym__concat] = ACTIONS(1902),
    [anon_sym_PIPE] = ACTIONS(1904),
    [anon_sym_SEMI_SEMI] = ACTIONS(1904),
    [anon_sym_PIPE_AMP] = ACTIONS(1904),
    [anon_sym_AMP_AMP] = ACTIONS(1904),
    [anon_sym_PIPE_PIPE] = ACTIONS(1904),
    [anon_sym_LT] = ACTIONS(1904),
    [anon_sym_GT] = ACTIONS(1904),
    [anon_sym_GT_GT] = ACTIONS(1904),
    [anon_sym_AMP_GT] = ACTIONS(1904),
    [anon_sym_AMP_GT_GT] = ACTIONS(1904),
    [anon_sym_LT_AMP] = ACTIONS(1904),
    [anon_sym_GT_AMP] = ACTIONS(1904),
    [anon_sym_LT_LT] = ACTIONS(1904),
    [anon_sym_LT_LT_DASH] = ACTIONS(1904),
    [anon_sym_LT_LT_LT] = ACTIONS(1904),
    [sym__special_characters] = ACTIONS(1904),
    [anon_sym_DQUOTE] = ACTIONS(1904),
    [sym_raw_string] = ACTIONS(1904),
    [anon_sym_DOLLAR] = ACTIONS(1904),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1904),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1904),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [anon_sym_LT_LPAREN] = ACTIONS(1904),
    [anon_sym_GT_LPAREN] = ACTIONS(1904),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1904),
    [anon_sym_SEMI] = ACTIONS(1904),
    [anon_sym_LF] = ACTIONS(1904),
    [anon_sym_AMP] = ACTIONS(1904),
  },
  [515] = {
    [sym_compound_statement] = STATE(990),
    [anon_sym_LBRACE] = ACTIONS(436),
    [sym_comment] = ACTIONS(52),
  },
  [516] = {
    [anon_sym_PIPE] = ACTIONS(1906),
    [anon_sym_RPAREN] = ACTIONS(1906),
    [anon_sym_SEMI_SEMI] = ACTIONS(1906),
    [anon_sym_PIPE_AMP] = ACTIONS(1906),
    [anon_sym_AMP_AMP] = ACTIONS(1906),
    [anon_sym_PIPE_PIPE] = ACTIONS(1906),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1906),
    [anon_sym_LF] = ACTIONS(1906),
    [anon_sym_AMP] = ACTIONS(1906),
  },
  [517] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(1906),
    [anon_sym_RPAREN] = ACTIONS(1906),
    [anon_sym_SEMI_SEMI] = ACTIONS(1906),
    [anon_sym_PIPE_AMP] = ACTIONS(1906),
    [anon_sym_AMP_AMP] = ACTIONS(1906),
    [anon_sym_PIPE_PIPE] = ACTIONS(1906),
    [anon_sym_LT] = ACTIONS(336),
    [anon_sym_GT] = ACTIONS(336),
    [anon_sym_GT_GT] = ACTIONS(336),
    [anon_sym_AMP_GT] = ACTIONS(336),
    [anon_sym_AMP_GT_GT] = ACTIONS(336),
    [anon_sym_LT_AMP] = ACTIONS(336),
    [anon_sym_GT_AMP] = ACTIONS(336),
    [sym__special_characters] = ACTIONS(336),
    [anon_sym_DQUOTE] = ACTIONS(336),
    [sym_raw_string] = ACTIONS(336),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(336),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(336),
    [anon_sym_BQUOTE] = ACTIONS(336),
    [anon_sym_LT_LPAREN] = ACTIONS(336),
    [anon_sym_GT_LPAREN] = ACTIONS(336),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(336),
    [anon_sym_SEMI] = ACTIONS(1906),
    [anon_sym_LF] = ACTIONS(1906),
    [anon_sym_AMP] = ACTIONS(1906),
  },
  [518] = {
    [anon_sym_PIPE] = ACTIONS(302),
    [anon_sym_SEMI_SEMI] = ACTIONS(1908),
    [anon_sym_PIPE_AMP] = ACTIONS(302),
    [anon_sym_AMP_AMP] = ACTIONS(1908),
    [anon_sym_PIPE_PIPE] = ACTIONS(1908),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1908),
    [anon_sym_LF] = ACTIONS(1908),
    [anon_sym_AMP] = ACTIONS(1908),
  },
  [519] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(302),
    [anon_sym_SEMI_SEMI] = ACTIONS(1908),
    [anon_sym_PIPE_AMP] = ACTIONS(302),
    [anon_sym_AMP_AMP] = ACTIONS(1908),
    [anon_sym_PIPE_PIPE] = ACTIONS(1908),
    [anon_sym_LT] = ACTIONS(336),
    [anon_sym_GT] = ACTIONS(336),
    [anon_sym_GT_GT] = ACTIONS(336),
    [anon_sym_AMP_GT] = ACTIONS(336),
    [anon_sym_AMP_GT_GT] = ACTIONS(336),
    [anon_sym_LT_AMP] = ACTIONS(336),
    [anon_sym_GT_AMP] = ACTIONS(336),
    [sym__special_characters] = ACTIONS(336),
    [anon_sym_DQUOTE] = ACTIONS(336),
    [sym_raw_string] = ACTIONS(336),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(336),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(336),
    [anon_sym_BQUOTE] = ACTIONS(336),
    [anon_sym_LT_LPAREN] = ACTIONS(336),
    [anon_sym_GT_LPAREN] = ACTIONS(336),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(336),
    [anon_sym_SEMI] = ACTIONS(1908),
    [anon_sym_LF] = ACTIONS(1908),
    [anon_sym_AMP] = ACTIONS(1908),
  },
  [520] = {
    [sym_concatenation] = STATE(993),
    [sym_string] = STATE(992),
    [sym_simple_expansion] = STATE(992),
    [sym_expansion] = STATE(992),
    [sym_command_substitution] = STATE(992),
    [sym_process_substitution] = STATE(992),
    [sym__special_characters] = ACTIONS(1910),
    [anon_sym_DQUOTE] = ACTIONS(914),
    [sym_raw_string] = ACTIONS(1912),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(922),
    [anon_sym_BQUOTE] = ACTIONS(924),
    [anon_sym_LT_LPAREN] = ACTIONS(926),
    [anon_sym_GT_LPAREN] = ACTIONS(926),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1914),
  },
  [521] = {
    [aux_sym_concatenation_repeat1] = STATE(995),
    [sym_file_descriptor] = ACTIONS(614),
    [sym__concat] = ACTIONS(1916),
    [anon_sym_PIPE] = ACTIONS(1918),
    [anon_sym_SEMI_SEMI] = ACTIONS(1918),
    [anon_sym_PIPE_AMP] = ACTIONS(1918),
    [anon_sym_AMP_AMP] = ACTIONS(1918),
    [anon_sym_PIPE_PIPE] = ACTIONS(1918),
    [anon_sym_LT] = ACTIONS(1918),
    [anon_sym_GT] = ACTIONS(1918),
    [anon_sym_GT_GT] = ACTIONS(1918),
    [anon_sym_AMP_GT] = ACTIONS(1918),
    [anon_sym_AMP_GT_GT] = ACTIONS(1918),
    [anon_sym_LT_AMP] = ACTIONS(1918),
    [anon_sym_GT_AMP] = ACTIONS(1918),
    [anon_sym_LT_LT] = ACTIONS(1918),
    [anon_sym_LT_LT_DASH] = ACTIONS(1918),
    [anon_sym_LT_LT_LT] = ACTIONS(1918),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1918),
    [anon_sym_LF] = ACTIONS(1918),
    [anon_sym_AMP] = ACTIONS(1918),
  },
  [522] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(997),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [523] = {
    [aux_sym_concatenation_repeat1] = STATE(995),
    [sym_file_descriptor] = ACTIONS(622),
    [sym__concat] = ACTIONS(1916),
    [anon_sym_PIPE] = ACTIONS(1922),
    [anon_sym_SEMI_SEMI] = ACTIONS(1922),
    [anon_sym_PIPE_AMP] = ACTIONS(1922),
    [anon_sym_AMP_AMP] = ACTIONS(1922),
    [anon_sym_PIPE_PIPE] = ACTIONS(1922),
    [anon_sym_LT] = ACTIONS(1922),
    [anon_sym_GT] = ACTIONS(1922),
    [anon_sym_GT_GT] = ACTIONS(1922),
    [anon_sym_AMP_GT] = ACTIONS(1922),
    [anon_sym_AMP_GT_GT] = ACTIONS(1922),
    [anon_sym_LT_AMP] = ACTIONS(1922),
    [anon_sym_GT_AMP] = ACTIONS(1922),
    [anon_sym_LT_LT] = ACTIONS(1922),
    [anon_sym_LT_LT_DASH] = ACTIONS(1922),
    [anon_sym_LT_LT_LT] = ACTIONS(1922),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1922),
    [anon_sym_LF] = ACTIONS(1922),
    [anon_sym_AMP] = ACTIONS(1922),
  },
  [524] = {
    [sym_string] = STATE(1000),
    [anon_sym_DQUOTE] = ACTIONS(914),
    [anon_sym_DOLLAR] = ACTIONS(1924),
    [anon_sym_POUND] = ACTIONS(1924),
    [anon_sym_DASH] = ACTIONS(1924),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1926),
    [anon_sym_STAR] = ACTIONS(1924),
    [anon_sym_AT] = ACTIONS(1924),
    [anon_sym_QMARK] = ACTIONS(1924),
    [anon_sym_0] = ACTIONS(1928),
    [anon_sym__] = ACTIONS(1928),
  },
  [525] = {
    [sym_subscript] = STATE(1005),
    [sym_variable_name] = ACTIONS(1930),
    [anon_sym_DOLLAR] = ACTIONS(1932),
    [anon_sym_POUND] = ACTIONS(1934),
    [anon_sym_DASH] = ACTIONS(1932),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(1932),
    [anon_sym_AT] = ACTIONS(1932),
    [anon_sym_QMARK] = ACTIONS(1932),
    [anon_sym_0] = ACTIONS(1938),
    [anon_sym__] = ACTIONS(1938),
  },
  [526] = {
    [sym_for_statement] = STATE(1006),
    [sym_while_statement] = STATE(1006),
    [sym_if_statement] = STATE(1006),
    [sym_case_statement] = STATE(1006),
    [sym_function_definition] = STATE(1006),
    [sym_subshell] = STATE(1006),
    [sym_pipeline] = STATE(1006),
    [sym_list] = STATE(1006),
    [sym_bracket_command] = STATE(1006),
    [sym_command] = STATE(1006),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(1007),
    [sym_declaration_command] = STATE(1006),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [527] = {
    [sym_for_statement] = STATE(1008),
    [sym_while_statement] = STATE(1008),
    [sym_if_statement] = STATE(1008),
    [sym_case_statement] = STATE(1008),
    [sym_function_definition] = STATE(1008),
    [sym_subshell] = STATE(1008),
    [sym_pipeline] = STATE(1008),
    [sym_list] = STATE(1008),
    [sym_bracket_command] = STATE(1008),
    [sym_command] = STATE(1008),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(1009),
    [sym_declaration_command] = STATE(1008),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [528] = {
    [sym_for_statement] = STATE(1010),
    [sym_while_statement] = STATE(1010),
    [sym_if_statement] = STATE(1010),
    [sym_case_statement] = STATE(1010),
    [sym_function_definition] = STATE(1010),
    [sym_subshell] = STATE(1010),
    [sym_pipeline] = STATE(1010),
    [sym_list] = STATE(1010),
    [sym_bracket_command] = STATE(1010),
    [sym_command] = STATE(1010),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(1011),
    [sym_declaration_command] = STATE(1010),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [529] = {
    [sym_file_descriptor] = ACTIONS(622),
    [anon_sym_PIPE] = ACTIONS(1922),
    [anon_sym_RPAREN] = ACTIONS(1922),
    [anon_sym_SEMI_SEMI] = ACTIONS(1922),
    [anon_sym_PIPE_AMP] = ACTIONS(1922),
    [anon_sym_AMP_AMP] = ACTIONS(1922),
    [anon_sym_PIPE_PIPE] = ACTIONS(1922),
    [anon_sym_LT] = ACTIONS(1922),
    [anon_sym_GT] = ACTIONS(1922),
    [anon_sym_GT_GT] = ACTIONS(1922),
    [anon_sym_AMP_GT] = ACTIONS(1922),
    [anon_sym_AMP_GT_GT] = ACTIONS(1922),
    [anon_sym_LT_AMP] = ACTIONS(1922),
    [anon_sym_GT_AMP] = ACTIONS(1922),
    [anon_sym_LT_LT] = ACTIONS(1922),
    [anon_sym_LT_LT_DASH] = ACTIONS(1922),
    [anon_sym_LT_LT_LT] = ACTIONS(1922),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1922),
    [anon_sym_LF] = ACTIONS(1922),
    [anon_sym_AMP] = ACTIONS(1922),
  },
  [530] = {
    [sym_file_descriptor] = ACTIONS(1940),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_RPAREN] = ACTIONS(1942),
    [anon_sym_SEMI_SEMI] = ACTIONS(1942),
    [anon_sym_PIPE_AMP] = ACTIONS(1942),
    [anon_sym_AMP_AMP] = ACTIONS(1942),
    [anon_sym_PIPE_PIPE] = ACTIONS(1942),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_GT_GT] = ACTIONS(1942),
    [anon_sym_AMP_GT] = ACTIONS(1942),
    [anon_sym_AMP_GT_GT] = ACTIONS(1942),
    [anon_sym_LT_AMP] = ACTIONS(1942),
    [anon_sym_GT_AMP] = ACTIONS(1942),
    [anon_sym_LT_LT] = ACTIONS(1942),
    [anon_sym_LT_LT_DASH] = ACTIONS(1942),
    [anon_sym_LT_LT_LT] = ACTIONS(1942),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1942),
    [anon_sym_LF] = ACTIONS(1942),
    [anon_sym_AMP] = ACTIONS(1942),
  },
  [531] = {
    [sym_simple_expansion] = STATE(1012),
    [sym_expansion] = STATE(1012),
    [aux_sym_heredoc_repeat1] = STATE(1016),
    [sym__heredoc_middle] = ACTIONS(1944),
    [sym__heredoc_end] = ACTIONS(1946),
    [anon_sym_DOLLAR] = ACTIONS(1948),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1950),
    [sym_comment] = ACTIONS(52),
  },
  [532] = {
    [sym_file_descriptor] = ACTIONS(1952),
    [anon_sym_PIPE] = ACTIONS(1954),
    [anon_sym_RPAREN] = ACTIONS(1954),
    [anon_sym_SEMI_SEMI] = ACTIONS(1954),
    [anon_sym_PIPE_AMP] = ACTIONS(1954),
    [anon_sym_AMP_AMP] = ACTIONS(1954),
    [anon_sym_PIPE_PIPE] = ACTIONS(1954),
    [anon_sym_LT] = ACTIONS(1954),
    [anon_sym_GT] = ACTIONS(1954),
    [anon_sym_GT_GT] = ACTIONS(1954),
    [anon_sym_AMP_GT] = ACTIONS(1954),
    [anon_sym_AMP_GT_GT] = ACTIONS(1954),
    [anon_sym_LT_AMP] = ACTIONS(1954),
    [anon_sym_GT_AMP] = ACTIONS(1954),
    [anon_sym_LT_LT] = ACTIONS(1954),
    [anon_sym_LT_LT_DASH] = ACTIONS(1954),
    [anon_sym_LT_LT_LT] = ACTIONS(1954),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1954),
    [anon_sym_LF] = ACTIONS(1954),
    [anon_sym_AMP] = ACTIONS(1954),
  },
  [533] = {
    [aux_sym_concatenation_repeat1] = STATE(995),
    [sym_file_descriptor] = ACTIONS(1956),
    [sym__concat] = ACTIONS(1916),
    [anon_sym_PIPE] = ACTIONS(1958),
    [anon_sym_SEMI_SEMI] = ACTIONS(1958),
    [anon_sym_PIPE_AMP] = ACTIONS(1958),
    [anon_sym_AMP_AMP] = ACTIONS(1958),
    [anon_sym_PIPE_PIPE] = ACTIONS(1958),
    [anon_sym_LT] = ACTIONS(1958),
    [anon_sym_GT] = ACTIONS(1958),
    [anon_sym_GT_GT] = ACTIONS(1958),
    [anon_sym_AMP_GT] = ACTIONS(1958),
    [anon_sym_AMP_GT_GT] = ACTIONS(1958),
    [anon_sym_LT_AMP] = ACTIONS(1958),
    [anon_sym_GT_AMP] = ACTIONS(1958),
    [anon_sym_LT_LT] = ACTIONS(1958),
    [anon_sym_LT_LT_DASH] = ACTIONS(1958),
    [anon_sym_LT_LT_LT] = ACTIONS(1958),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1958),
    [anon_sym_LF] = ACTIONS(1958),
    [anon_sym_AMP] = ACTIONS(1958),
  },
  [534] = {
    [aux_sym_concatenation_repeat1] = STATE(995),
    [sym_file_descriptor] = ACTIONS(1960),
    [sym__concat] = ACTIONS(1916),
    [anon_sym_PIPE] = ACTIONS(1962),
    [anon_sym_SEMI_SEMI] = ACTIONS(1962),
    [anon_sym_PIPE_AMP] = ACTIONS(1962),
    [anon_sym_AMP_AMP] = ACTIONS(1962),
    [anon_sym_PIPE_PIPE] = ACTIONS(1962),
    [anon_sym_LT] = ACTIONS(1962),
    [anon_sym_GT] = ACTIONS(1962),
    [anon_sym_GT_GT] = ACTIONS(1962),
    [anon_sym_AMP_GT] = ACTIONS(1962),
    [anon_sym_AMP_GT_GT] = ACTIONS(1962),
    [anon_sym_LT_AMP] = ACTIONS(1962),
    [anon_sym_GT_AMP] = ACTIONS(1962),
    [anon_sym_LT_LT] = ACTIONS(1962),
    [anon_sym_LT_LT_DASH] = ACTIONS(1962),
    [anon_sym_LT_LT_LT] = ACTIONS(1962),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1962),
    [anon_sym_LF] = ACTIONS(1962),
    [anon_sym_AMP] = ACTIONS(1962),
  },
  [535] = {
    [sym_file_descriptor] = ACTIONS(1960),
    [anon_sym_PIPE] = ACTIONS(1962),
    [anon_sym_RPAREN] = ACTIONS(1962),
    [anon_sym_SEMI_SEMI] = ACTIONS(1962),
    [anon_sym_PIPE_AMP] = ACTIONS(1962),
    [anon_sym_AMP_AMP] = ACTIONS(1962),
    [anon_sym_PIPE_PIPE] = ACTIONS(1962),
    [anon_sym_LT] = ACTIONS(1962),
    [anon_sym_GT] = ACTIONS(1962),
    [anon_sym_GT_GT] = ACTIONS(1962),
    [anon_sym_AMP_GT] = ACTIONS(1962),
    [anon_sym_AMP_GT_GT] = ACTIONS(1962),
    [anon_sym_LT_AMP] = ACTIONS(1962),
    [anon_sym_GT_AMP] = ACTIONS(1962),
    [anon_sym_LT_LT] = ACTIONS(1962),
    [anon_sym_LT_LT_DASH] = ACTIONS(1962),
    [anon_sym_LT_LT_LT] = ACTIONS(1962),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1962),
    [anon_sym_LF] = ACTIONS(1962),
    [anon_sym_AMP] = ACTIONS(1962),
  },
  [536] = {
    [sym_concatenation] = STATE(186),
    [sym_string] = STATE(184),
    [sym_simple_expansion] = STATE(184),
    [sym_expansion] = STATE(184),
    [sym_command_substitution] = STATE(184),
    [sym_process_substitution] = STATE(184),
    [aux_sym_for_statement_repeat1] = STATE(536),
    [sym_file_descriptor] = ACTIONS(1389),
    [anon_sym_PIPE] = ACTIONS(1964),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [anon_sym_LT] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1964),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT_GT] = ACTIONS(1964),
    [anon_sym_LT_AMP] = ACTIONS(1964),
    [anon_sym_GT_AMP] = ACTIONS(1964),
    [anon_sym_LT_LT] = ACTIONS(1964),
    [anon_sym_LT_LT_DASH] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(1964),
    [sym__special_characters] = ACTIONS(1966),
    [anon_sym_DQUOTE] = ACTIONS(1969),
    [sym_raw_string] = ACTIONS(1972),
    [anon_sym_DOLLAR] = ACTIONS(1975),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1978),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1981),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1987),
    [anon_sym_GT_LPAREN] = ACTIONS(1987),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1972),
    [anon_sym_SEMI] = ACTIONS(1964),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_AMP] = ACTIONS(1964),
  },
  [537] = {
    [sym_file_redirect] = STATE(185),
    [sym_heredoc_redirect] = STATE(185),
    [sym_herestring_redirect] = STATE(185),
    [aux_sym_while_statement_repeat1] = STATE(538),
    [sym_file_descriptor] = ACTIONS(308),
    [anon_sym_PIPE] = ACTIONS(1990),
    [anon_sym_SEMI_SEMI] = ACTIONS(1990),
    [anon_sym_PIPE_AMP] = ACTIONS(1990),
    [anon_sym_AMP_AMP] = ACTIONS(1990),
    [anon_sym_PIPE_PIPE] = ACTIONS(1990),
    [anon_sym_LT] = ACTIONS(312),
    [anon_sym_GT] = ACTIONS(312),
    [anon_sym_GT_GT] = ACTIONS(312),
    [anon_sym_AMP_GT] = ACTIONS(312),
    [anon_sym_AMP_GT_GT] = ACTIONS(312),
    [anon_sym_LT_AMP] = ACTIONS(312),
    [anon_sym_GT_AMP] = ACTIONS(312),
    [anon_sym_LT_LT] = ACTIONS(314),
    [anon_sym_LT_LT_DASH] = ACTIONS(314),
    [anon_sym_LT_LT_LT] = ACTIONS(316),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1990),
    [anon_sym_LF] = ACTIONS(1990),
    [anon_sym_AMP] = ACTIONS(1990),
  },
  [538] = {
    [sym_file_redirect] = STATE(185),
    [sym_heredoc_redirect] = STATE(185),
    [sym_herestring_redirect] = STATE(185),
    [aux_sym_while_statement_repeat1] = STATE(538),
    [sym_file_descriptor] = ACTIONS(1992),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_SEMI_SEMI] = ACTIONS(1995),
    [anon_sym_PIPE_AMP] = ACTIONS(1995),
    [anon_sym_AMP_AMP] = ACTIONS(1995),
    [anon_sym_PIPE_PIPE] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1997),
    [anon_sym_AMP_GT] = ACTIONS(1997),
    [anon_sym_AMP_GT_GT] = ACTIONS(1997),
    [anon_sym_LT_AMP] = ACTIONS(1997),
    [anon_sym_GT_AMP] = ACTIONS(1997),
    [anon_sym_LT_LT] = ACTIONS(2000),
    [anon_sym_LT_LT_DASH] = ACTIONS(2000),
    [anon_sym_LT_LT_LT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1995),
    [anon_sym_LF] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
  },
  [539] = {
    [sym_concatenation] = STATE(836),
    [sym_string] = STATE(1018),
    [sym_array] = STATE(836),
    [sym_simple_expansion] = STATE(1018),
    [sym_expansion] = STATE(1018),
    [sym_command_substitution] = STATE(1018),
    [sym_process_substitution] = STATE(1018),
    [sym__empty_value] = ACTIONS(1652),
    [anon_sym_LPAREN] = ACTIONS(1654),
    [sym__special_characters] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [sym_raw_string] = ACTIONS(2008),
    [anon_sym_DOLLAR] = ACTIONS(178),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(180),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(182),
    [anon_sym_BQUOTE] = ACTIONS(184),
    [anon_sym_LT_LPAREN] = ACTIONS(186),
    [anon_sym_GT_LPAREN] = ACTIONS(186),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2010),
  },
  [540] = {
    [sym_file_redirect] = STATE(185),
    [sym_heredoc_redirect] = STATE(185),
    [sym_herestring_redirect] = STATE(185),
    [sym_concatenation] = STATE(186),
    [sym_string] = STATE(184),
    [sym_simple_expansion] = STATE(184),
    [sym_expansion] = STATE(184),
    [sym_command_substitution] = STATE(184),
    [sym_process_substitution] = STATE(184),
    [aux_sym_for_statement_repeat1] = STATE(536),
    [aux_sym_while_statement_repeat1] = STATE(1019),
    [sym_file_descriptor] = ACTIONS(308),
    [anon_sym_PIPE] = ACTIONS(1990),
    [anon_sym_SEMI_SEMI] = ACTIONS(1990),
    [anon_sym_PIPE_AMP] = ACTIONS(1990),
    [anon_sym_AMP_AMP] = ACTIONS(1990),
    [anon_sym_PIPE_PIPE] = ACTIONS(1990),
    [anon_sym_LT] = ACTIONS(312),
    [anon_sym_GT] = ACTIONS(312),
    [anon_sym_GT_GT] = ACTIONS(312),
    [anon_sym_AMP_GT] = ACTIONS(312),
    [anon_sym_AMP_GT_GT] = ACTIONS(312),
    [anon_sym_LT_AMP] = ACTIONS(312),
    [anon_sym_GT_AMP] = ACTIONS(312),
    [anon_sym_LT_LT] = ACTIONS(314),
    [anon_sym_LT_LT_DASH] = ACTIONS(314),
    [anon_sym_LT_LT_LT] = ACTIONS(316),
    [sym__special_characters] = ACTIONS(318),
    [anon_sym_DQUOTE] = ACTIONS(320),
    [sym_raw_string] = ACTIONS(322),
    [anon_sym_DOLLAR] = ACTIONS(324),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(326),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(328),
    [anon_sym_BQUOTE] = ACTIONS(330),
    [anon_sym_LT_LPAREN] = ACTIONS(332),
    [anon_sym_GT_LPAREN] = ACTIONS(332),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(322),
    [anon_sym_SEMI] = ACTIONS(1990),
    [anon_sym_LF] = ACTIONS(1990),
    [anon_sym_AMP] = ACTIONS(1990),
  },
  [541] = {
    [sym_string] = STATE(1021),
    [sym_simple_expansion] = STATE(1021),
    [sym_expansion] = STATE(1021),
    [sym_command_substitution] = STATE(1021),
    [sym_process_substitution] = STATE(1021),
    [anon_sym_RBRACK] = ACTIONS(2012),
    [sym__special_characters] = ACTIONS(2014),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(2016),
    [anon_sym_DOLLAR] = ACTIONS(360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(364),
    [anon_sym_BQUOTE] = ACTIONS(366),
    [anon_sym_LT_LPAREN] = ACTIONS(368),
    [anon_sym_GT_LPAREN] = ACTIONS(368),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2018),
  },
  [542] = {
    [sym__concat] = ACTIONS(2020),
    [anon_sym_EQ] = ACTIONS(2022),
    [anon_sym_PLUS_EQ] = ACTIONS(2022),
    [sym_comment] = ACTIONS(52),
  },
  [543] = {
    [aux_sym_concatenation_repeat1] = STATE(1024),
    [sym__concat] = ACTIONS(2024),
    [anon_sym_RBRACK] = ACTIONS(646),
    [sym_comment] = ACTIONS(52),
  },
  [544] = {
    [sym__concat] = ACTIONS(650),
    [anon_sym_RBRACK] = ACTIONS(650),
    [sym_comment] = ACTIONS(52),
  },
  [545] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(2026),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [546] = {
    [sym_string] = STATE(1021),
    [sym_simple_expansion] = STATE(1021),
    [sym_expansion] = STATE(1021),
    [sym_command_substitution] = STATE(1021),
    [sym_process_substitution] = STATE(1021),
    [anon_sym_RBRACK] = ACTIONS(2028),
    [sym__special_characters] = ACTIONS(2014),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(2016),
    [anon_sym_DOLLAR] = ACTIONS(360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(364),
    [anon_sym_BQUOTE] = ACTIONS(366),
    [anon_sym_LT_LPAREN] = ACTIONS(368),
    [anon_sym_GT_LPAREN] = ACTIONS(368),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2018),
  },
  [547] = {
    [sym__concat] = ACTIONS(2030),
    [anon_sym_EQ] = ACTIONS(2032),
    [anon_sym_PLUS_EQ] = ACTIONS(2032),
    [sym_comment] = ACTIONS(52),
  },
  [548] = {
    [sym__concat] = ACTIONS(680),
    [anon_sym_RBRACK] = ACTIONS(680),
    [sym_comment] = ACTIONS(52),
  },
  [549] = {
    [sym__concat] = ACTIONS(684),
    [anon_sym_RBRACK] = ACTIONS(684),
    [sym_comment] = ACTIONS(52),
  },
  [550] = {
    [sym__concat] = ACTIONS(688),
    [anon_sym_RBRACK] = ACTIONS(688),
    [sym_comment] = ACTIONS(52),
  },
  [551] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(2034),
    [sym_comment] = ACTIONS(52),
  },
  [552] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1030),
    [anon_sym_RBRACE] = ACTIONS(2036),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [553] = {
    [sym_subscript] = STATE(1034),
    [sym_variable_name] = ACTIONS(2038),
    [anon_sym_DOLLAR] = ACTIONS(2040),
    [anon_sym_DASH] = ACTIONS(2040),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2042),
    [anon_sym_STAR] = ACTIONS(2040),
    [anon_sym_AT] = ACTIONS(2040),
    [anon_sym_QMARK] = ACTIONS(2040),
    [anon_sym_0] = ACTIONS(2044),
    [anon_sym__] = ACTIONS(2044),
  },
  [554] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1036),
    [anon_sym_RBRACE] = ACTIONS(2046),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [555] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1038),
    [anon_sym_RBRACE] = ACTIONS(2048),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [556] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(2050),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [557] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(2050),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [558] = {
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(2050),
    [sym_comment] = ACTIONS(52),
  },
  [559] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(2050),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [560] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(2052),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [561] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(2052),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [562] = {
    [anon_sym_RBRACK] = ACTIONS(2054),
    [sym_comment] = ACTIONS(52),
  },
  [563] = {
    [sym_file_descriptor] = ACTIONS(2056),
    [sym_variable_name] = ACTIONS(2056),
    [anon_sym_PIPE] = ACTIONS(2058),
    [anon_sym_RPAREN] = ACTIONS(2058),
    [anon_sym_SEMI_SEMI] = ACTIONS(2058),
    [anon_sym_PIPE_AMP] = ACTIONS(2058),
    [anon_sym_AMP_AMP] = ACTIONS(2058),
    [anon_sym_PIPE_PIPE] = ACTIONS(2058),
    [anon_sym_LT] = ACTIONS(2058),
    [anon_sym_GT] = ACTIONS(2058),
    [anon_sym_GT_GT] = ACTIONS(2058),
    [anon_sym_AMP_GT] = ACTIONS(2058),
    [anon_sym_AMP_GT_GT] = ACTIONS(2058),
    [anon_sym_LT_AMP] = ACTIONS(2058),
    [anon_sym_GT_AMP] = ACTIONS(2058),
    [sym__special_characters] = ACTIONS(2058),
    [anon_sym_DQUOTE] = ACTIONS(2058),
    [sym_raw_string] = ACTIONS(2058),
    [anon_sym_DOLLAR] = ACTIONS(2058),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2058),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2058),
    [anon_sym_BQUOTE] = ACTIONS(2058),
    [anon_sym_LT_LPAREN] = ACTIONS(2058),
    [anon_sym_GT_LPAREN] = ACTIONS(2058),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2058),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym_LF] = ACTIONS(2058),
    [anon_sym_AMP] = ACTIONS(2058),
  },
  [564] = {
    [aux_sym_concatenation_repeat1] = STATE(1042),
    [sym__concat] = ACTIONS(2060),
    [anon_sym_RPAREN] = ACTIONS(522),
    [sym__special_characters] = ACTIONS(518),
    [anon_sym_DQUOTE] = ACTIONS(522),
    [sym_raw_string] = ACTIONS(522),
    [anon_sym_DOLLAR] = ACTIONS(518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(522),
    [anon_sym_LT_LPAREN] = ACTIONS(522),
    [anon_sym_GT_LPAREN] = ACTIONS(522),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(518),
  },
  [565] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(1044),
    [anon_sym_DQUOTE] = ACTIONS(2062),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [566] = {
    [aux_sym_concatenation_repeat1] = STATE(1042),
    [sym__concat] = ACTIONS(2060),
    [anon_sym_RPAREN] = ACTIONS(530),
    [sym__special_characters] = ACTIONS(526),
    [anon_sym_DQUOTE] = ACTIONS(530),
    [sym_raw_string] = ACTIONS(530),
    [anon_sym_DOLLAR] = ACTIONS(526),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(530),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(530),
    [anon_sym_BQUOTE] = ACTIONS(530),
    [anon_sym_LT_LPAREN] = ACTIONS(530),
    [anon_sym_GT_LPAREN] = ACTIONS(530),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(526),
  },
  [567] = {
    [sym_string] = STATE(1047),
    [anon_sym_DQUOTE] = ACTIONS(1076),
    [anon_sym_DOLLAR] = ACTIONS(2064),
    [anon_sym_POUND] = ACTIONS(2064),
    [anon_sym_DASH] = ACTIONS(2064),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2066),
    [anon_sym_STAR] = ACTIONS(2064),
    [anon_sym_AT] = ACTIONS(2064),
    [anon_sym_QMARK] = ACTIONS(2064),
    [anon_sym_0] = ACTIONS(2068),
    [anon_sym__] = ACTIONS(2068),
  },
  [568] = {
    [sym_subscript] = STATE(1052),
    [sym_variable_name] = ACTIONS(2070),
    [anon_sym_DOLLAR] = ACTIONS(2072),
    [anon_sym_POUND] = ACTIONS(2074),
    [anon_sym_DASH] = ACTIONS(2072),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2076),
    [anon_sym_STAR] = ACTIONS(2072),
    [anon_sym_AT] = ACTIONS(2072),
    [anon_sym_QMARK] = ACTIONS(2072),
    [anon_sym_0] = ACTIONS(2078),
    [anon_sym__] = ACTIONS(2078),
  },
  [569] = {
    [sym_for_statement] = STATE(1053),
    [sym_while_statement] = STATE(1053),
    [sym_if_statement] = STATE(1053),
    [sym_case_statement] = STATE(1053),
    [sym_function_definition] = STATE(1053),
    [sym_subshell] = STATE(1053),
    [sym_pipeline] = STATE(1053),
    [sym_list] = STATE(1053),
    [sym_bracket_command] = STATE(1053),
    [sym_command] = STATE(1053),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(1054),
    [sym_declaration_command] = STATE(1053),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [570] = {
    [sym_for_statement] = STATE(1055),
    [sym_while_statement] = STATE(1055),
    [sym_if_statement] = STATE(1055),
    [sym_case_statement] = STATE(1055),
    [sym_function_definition] = STATE(1055),
    [sym_subshell] = STATE(1055),
    [sym_pipeline] = STATE(1055),
    [sym_list] = STATE(1055),
    [sym_bracket_command] = STATE(1055),
    [sym_command] = STATE(1055),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(1056),
    [sym_declaration_command] = STATE(1055),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [571] = {
    [sym_for_statement] = STATE(1057),
    [sym_while_statement] = STATE(1057),
    [sym_if_statement] = STATE(1057),
    [sym_case_statement] = STATE(1057),
    [sym_function_definition] = STATE(1057),
    [sym_subshell] = STATE(1057),
    [sym_pipeline] = STATE(1057),
    [sym_list] = STATE(1057),
    [sym_bracket_command] = STATE(1057),
    [sym_command] = STATE(1057),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(1058),
    [sym_declaration_command] = STATE(1057),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [572] = {
    [anon_sym_RPAREN] = ACTIONS(530),
    [sym__special_characters] = ACTIONS(526),
    [anon_sym_DQUOTE] = ACTIONS(530),
    [sym_raw_string] = ACTIONS(530),
    [anon_sym_DOLLAR] = ACTIONS(526),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(530),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(530),
    [anon_sym_BQUOTE] = ACTIONS(530),
    [anon_sym_LT_LPAREN] = ACTIONS(530),
    [anon_sym_GT_LPAREN] = ACTIONS(530),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(526),
  },
  [573] = {
    [sym_concatenation] = STATE(572),
    [sym_string] = STATE(566),
    [sym_simple_expansion] = STATE(566),
    [sym_expansion] = STATE(566),
    [sym_command_substitution] = STATE(566),
    [sym_process_substitution] = STATE(566),
    [aux_sym_for_statement_repeat1] = STATE(1060),
    [anon_sym_RPAREN] = ACTIONS(2080),
    [sym__special_characters] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1076),
    [sym_raw_string] = ACTIONS(1078),
    [anon_sym_DOLLAR] = ACTIONS(1080),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1084),
    [anon_sym_BQUOTE] = ACTIONS(1086),
    [anon_sym_LT_LPAREN] = ACTIONS(1088),
    [anon_sym_GT_LPAREN] = ACTIONS(1088),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1090),
  },
  [574] = {
    [sym_string] = STATE(1061),
    [sym_simple_expansion] = STATE(1061),
    [sym_expansion] = STATE(1061),
    [sym_command_substitution] = STATE(1061),
    [sym_process_substitution] = STATE(1061),
    [sym__special_characters] = ACTIONS(2082),
    [anon_sym_DQUOTE] = ACTIONS(378),
    [sym_raw_string] = ACTIONS(2084),
    [anon_sym_DOLLAR] = ACTIONS(382),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(384),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(386),
    [anon_sym_BQUOTE] = ACTIONS(388),
    [anon_sym_LT_LPAREN] = ACTIONS(390),
    [anon_sym_GT_LPAREN] = ACTIONS(390),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2082),
  },
  [575] = {
    [aux_sym_concatenation_repeat1] = STATE(1062),
    [sym_file_descriptor] = ACTIONS(646),
    [sym__concat] = ACTIONS(1094),
    [sym_variable_name] = ACTIONS(646),
    [anon_sym_PIPE] = ACTIONS(648),
    [anon_sym_SEMI_SEMI] = ACTIONS(648),
    [anon_sym_PIPE_AMP] = ACTIONS(648),
    [anon_sym_AMP_AMP] = ACTIONS(648),
    [anon_sym_PIPE_PIPE] = ACTIONS(648),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(648),
    [anon_sym_GT_GT] = ACTIONS(648),
    [anon_sym_AMP_GT] = ACTIONS(648),
    [anon_sym_AMP_GT_GT] = ACTIONS(648),
    [anon_sym_LT_AMP] = ACTIONS(648),
    [anon_sym_GT_AMP] = ACTIONS(648),
    [sym__special_characters] = ACTIONS(648),
    [anon_sym_DQUOTE] = ACTIONS(648),
    [sym_raw_string] = ACTIONS(648),
    [anon_sym_DOLLAR] = ACTIONS(648),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(648),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(648),
    [anon_sym_BQUOTE] = ACTIONS(648),
    [anon_sym_LT_LPAREN] = ACTIONS(648),
    [anon_sym_GT_LPAREN] = ACTIONS(648),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(648),
    [anon_sym_SEMI] = ACTIONS(648),
    [anon_sym_LF] = ACTIONS(648),
    [anon_sym_AMP] = ACTIONS(648),
  },
  [576] = {
    [sym_file_descriptor] = ACTIONS(650),
    [sym__concat] = ACTIONS(650),
    [sym_variable_name] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(652),
    [anon_sym_SEMI_SEMI] = ACTIONS(652),
    [anon_sym_PIPE_AMP] = ACTIONS(652),
    [anon_sym_AMP_AMP] = ACTIONS(652),
    [anon_sym_PIPE_PIPE] = ACTIONS(652),
    [anon_sym_LT] = ACTIONS(652),
    [anon_sym_GT] = ACTIONS(652),
    [anon_sym_GT_GT] = ACTIONS(652),
    [anon_sym_AMP_GT] = ACTIONS(652),
    [anon_sym_AMP_GT_GT] = ACTIONS(652),
    [anon_sym_LT_AMP] = ACTIONS(652),
    [anon_sym_GT_AMP] = ACTIONS(652),
    [sym__special_characters] = ACTIONS(652),
    [anon_sym_DQUOTE] = ACTIONS(652),
    [sym_raw_string] = ACTIONS(652),
    [anon_sym_DOLLAR] = ACTIONS(652),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(652),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(652),
    [anon_sym_BQUOTE] = ACTIONS(652),
    [anon_sym_LT_LPAREN] = ACTIONS(652),
    [anon_sym_GT_LPAREN] = ACTIONS(652),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(652),
    [anon_sym_SEMI] = ACTIONS(652),
    [anon_sym_LF] = ACTIONS(652),
    [anon_sym_AMP] = ACTIONS(652),
  },
  [577] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(2086),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [578] = {
    [sym_file_descriptor] = ACTIONS(680),
    [sym__concat] = ACTIONS(680),
    [sym_variable_name] = ACTIONS(680),
    [anon_sym_PIPE] = ACTIONS(682),
    [anon_sym_SEMI_SEMI] = ACTIONS(682),
    [anon_sym_PIPE_AMP] = ACTIONS(682),
    [anon_sym_AMP_AMP] = ACTIONS(682),
    [anon_sym_PIPE_PIPE] = ACTIONS(682),
    [anon_sym_LT] = ACTIONS(682),
    [anon_sym_GT] = ACTIONS(682),
    [anon_sym_GT_GT] = ACTIONS(682),
    [anon_sym_AMP_GT] = ACTIONS(682),
    [anon_sym_AMP_GT_GT] = ACTIONS(682),
    [anon_sym_LT_AMP] = ACTIONS(682),
    [anon_sym_GT_AMP] = ACTIONS(682),
    [sym__special_characters] = ACTIONS(682),
    [anon_sym_DQUOTE] = ACTIONS(682),
    [sym_raw_string] = ACTIONS(682),
    [anon_sym_DOLLAR] = ACTIONS(682),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(682),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(682),
    [anon_sym_BQUOTE] = ACTIONS(682),
    [anon_sym_LT_LPAREN] = ACTIONS(682),
    [anon_sym_GT_LPAREN] = ACTIONS(682),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(682),
    [anon_sym_SEMI] = ACTIONS(682),
    [anon_sym_LF] = ACTIONS(682),
    [anon_sym_AMP] = ACTIONS(682),
  },
  [579] = {
    [sym_file_descriptor] = ACTIONS(684),
    [sym__concat] = ACTIONS(684),
    [sym_variable_name] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(686),
    [anon_sym_SEMI_SEMI] = ACTIONS(686),
    [anon_sym_PIPE_AMP] = ACTIONS(686),
    [anon_sym_AMP_AMP] = ACTIONS(686),
    [anon_sym_PIPE_PIPE] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(686),
    [anon_sym_GT] = ACTIONS(686),
    [anon_sym_GT_GT] = ACTIONS(686),
    [anon_sym_AMP_GT] = ACTIONS(686),
    [anon_sym_AMP_GT_GT] = ACTIONS(686),
    [anon_sym_LT_AMP] = ACTIONS(686),
    [anon_sym_GT_AMP] = ACTIONS(686),
    [sym__special_characters] = ACTIONS(686),
    [anon_sym_DQUOTE] = ACTIONS(686),
    [sym_raw_string] = ACTIONS(686),
    [anon_sym_DOLLAR] = ACTIONS(686),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(686),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(686),
    [anon_sym_BQUOTE] = ACTIONS(686),
    [anon_sym_LT_LPAREN] = ACTIONS(686),
    [anon_sym_GT_LPAREN] = ACTIONS(686),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(686),
    [anon_sym_SEMI] = ACTIONS(686),
    [anon_sym_LF] = ACTIONS(686),
    [anon_sym_AMP] = ACTIONS(686),
  },
  [580] = {
    [sym_file_descriptor] = ACTIONS(688),
    [sym__concat] = ACTIONS(688),
    [sym_variable_name] = ACTIONS(688),
    [anon_sym_PIPE] = ACTIONS(690),
    [anon_sym_SEMI_SEMI] = ACTIONS(690),
    [anon_sym_PIPE_AMP] = ACTIONS(690),
    [anon_sym_AMP_AMP] = ACTIONS(690),
    [anon_sym_PIPE_PIPE] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(690),
    [anon_sym_GT] = ACTIONS(690),
    [anon_sym_GT_GT] = ACTIONS(690),
    [anon_sym_AMP_GT] = ACTIONS(690),
    [anon_sym_AMP_GT_GT] = ACTIONS(690),
    [anon_sym_LT_AMP] = ACTIONS(690),
    [anon_sym_GT_AMP] = ACTIONS(690),
    [sym__special_characters] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(690),
    [sym_raw_string] = ACTIONS(690),
    [anon_sym_DOLLAR] = ACTIONS(690),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(690),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(690),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [anon_sym_LT_LPAREN] = ACTIONS(690),
    [anon_sym_GT_LPAREN] = ACTIONS(690),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(690),
    [anon_sym_SEMI] = ACTIONS(690),
    [anon_sym_LF] = ACTIONS(690),
    [anon_sym_AMP] = ACTIONS(690),
  },
  [581] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(2088),
    [sym_comment] = ACTIONS(52),
  },
  [582] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1066),
    [anon_sym_RBRACE] = ACTIONS(2090),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [583] = {
    [sym_subscript] = STATE(1070),
    [sym_variable_name] = ACTIONS(2092),
    [anon_sym_DOLLAR] = ACTIONS(2094),
    [anon_sym_DASH] = ACTIONS(2094),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2096),
    [anon_sym_STAR] = ACTIONS(2094),
    [anon_sym_AT] = ACTIONS(2094),
    [anon_sym_QMARK] = ACTIONS(2094),
    [anon_sym_0] = ACTIONS(2098),
    [anon_sym__] = ACTIONS(2098),
  },
  [584] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1072),
    [anon_sym_RBRACE] = ACTIONS(2100),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [585] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1074),
    [anon_sym_RBRACE] = ACTIONS(2102),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [586] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(2104),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [587] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(2104),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [588] = {
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(2104),
    [sym_comment] = ACTIONS(52),
  },
  [589] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(2104),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [590] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(2106),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [591] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(2106),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [592] = {
    [aux_sym_concatenation_repeat1] = STATE(1078),
    [sym__concat] = ACTIONS(2108),
    [anon_sym_SEMI_SEMI] = ACTIONS(520),
    [sym__special_characters] = ACTIONS(520),
    [anon_sym_DQUOTE] = ACTIONS(520),
    [sym_raw_string] = ACTIONS(520),
    [anon_sym_DOLLAR] = ACTIONS(520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(520),
    [anon_sym_BQUOTE] = ACTIONS(520),
    [anon_sym_LT_LPAREN] = ACTIONS(520),
    [anon_sym_GT_LPAREN] = ACTIONS(520),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(520),
    [anon_sym_SEMI] = ACTIONS(520),
    [anon_sym_LF] = ACTIONS(520),
    [anon_sym_AMP] = ACTIONS(520),
  },
  [593] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(1080),
    [anon_sym_DQUOTE] = ACTIONS(2110),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [594] = {
    [aux_sym_concatenation_repeat1] = STATE(1078),
    [sym__concat] = ACTIONS(2108),
    [anon_sym_SEMI_SEMI] = ACTIONS(528),
    [sym__special_characters] = ACTIONS(528),
    [anon_sym_DQUOTE] = ACTIONS(528),
    [sym_raw_string] = ACTIONS(528),
    [anon_sym_DOLLAR] = ACTIONS(528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(528),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(528),
    [anon_sym_BQUOTE] = ACTIONS(528),
    [anon_sym_LT_LPAREN] = ACTIONS(528),
    [anon_sym_GT_LPAREN] = ACTIONS(528),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(528),
    [anon_sym_SEMI] = ACTIONS(528),
    [anon_sym_LF] = ACTIONS(528),
    [anon_sym_AMP] = ACTIONS(528),
  },
  [595] = {
    [sym_string] = STATE(1083),
    [anon_sym_DQUOTE] = ACTIONS(1118),
    [anon_sym_DOLLAR] = ACTIONS(2112),
    [anon_sym_POUND] = ACTIONS(2112),
    [anon_sym_DASH] = ACTIONS(2112),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(2112),
    [anon_sym_AT] = ACTIONS(2112),
    [anon_sym_QMARK] = ACTIONS(2112),
    [anon_sym_0] = ACTIONS(2116),
    [anon_sym__] = ACTIONS(2116),
  },
  [596] = {
    [sym_subscript] = STATE(1088),
    [sym_variable_name] = ACTIONS(2118),
    [anon_sym_DOLLAR] = ACTIONS(2120),
    [anon_sym_POUND] = ACTIONS(2122),
    [anon_sym_DASH] = ACTIONS(2120),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2124),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AT] = ACTIONS(2120),
    [anon_sym_QMARK] = ACTIONS(2120),
    [anon_sym_0] = ACTIONS(2126),
    [anon_sym__] = ACTIONS(2126),
  },
  [597] = {
    [sym_for_statement] = STATE(1089),
    [sym_while_statement] = STATE(1089),
    [sym_if_statement] = STATE(1089),
    [sym_case_statement] = STATE(1089),
    [sym_function_definition] = STATE(1089),
    [sym_subshell] = STATE(1089),
    [sym_pipeline] = STATE(1089),
    [sym_list] = STATE(1089),
    [sym_bracket_command] = STATE(1089),
    [sym_command] = STATE(1089),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(1090),
    [sym_declaration_command] = STATE(1089),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [598] = {
    [sym_for_statement] = STATE(1091),
    [sym_while_statement] = STATE(1091),
    [sym_if_statement] = STATE(1091),
    [sym_case_statement] = STATE(1091),
    [sym_function_definition] = STATE(1091),
    [sym_subshell] = STATE(1091),
    [sym_pipeline] = STATE(1091),
    [sym_list] = STATE(1091),
    [sym_bracket_command] = STATE(1091),
    [sym_command] = STATE(1091),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(1092),
    [sym_declaration_command] = STATE(1091),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [599] = {
    [sym_for_statement] = STATE(1093),
    [sym_while_statement] = STATE(1093),
    [sym_if_statement] = STATE(1093),
    [sym_case_statement] = STATE(1093),
    [sym_function_definition] = STATE(1093),
    [sym_subshell] = STATE(1093),
    [sym_pipeline] = STATE(1093),
    [sym_list] = STATE(1093),
    [sym_bracket_command] = STATE(1093),
    [sym_command] = STATE(1093),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(1094),
    [sym_declaration_command] = STATE(1093),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [600] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(528),
    [sym__special_characters] = ACTIONS(528),
    [anon_sym_DQUOTE] = ACTIONS(528),
    [sym_raw_string] = ACTIONS(528),
    [anon_sym_DOLLAR] = ACTIONS(528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(528),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(528),
    [anon_sym_BQUOTE] = ACTIONS(528),
    [anon_sym_LT_LPAREN] = ACTIONS(528),
    [anon_sym_GT_LPAREN] = ACTIONS(528),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(528),
    [anon_sym_SEMI] = ACTIONS(528),
    [anon_sym_LF] = ACTIONS(528),
    [anon_sym_AMP] = ACTIONS(528),
  },
  [601] = {
    [sym_concatenation] = STATE(600),
    [sym_string] = STATE(594),
    [sym_simple_expansion] = STATE(594),
    [sym_expansion] = STATE(594),
    [sym_command_substitution] = STATE(594),
    [sym_process_substitution] = STATE(594),
    [aux_sym_for_statement_repeat1] = STATE(1096),
    [anon_sym_SEMI_SEMI] = ACTIONS(2128),
    [sym__special_characters] = ACTIONS(2130),
    [anon_sym_DQUOTE] = ACTIONS(2132),
    [sym_raw_string] = ACTIONS(2134),
    [anon_sym_DOLLAR] = ACTIONS(2136),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2138),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2140),
    [anon_sym_BQUOTE] = ACTIONS(2142),
    [anon_sym_LT_LPAREN] = ACTIONS(2144),
    [anon_sym_GT_LPAREN] = ACTIONS(2144),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2134),
    [anon_sym_SEMI] = ACTIONS(2128),
    [anon_sym_LF] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
  },
  [602] = {
    [sym_file_descriptor] = ACTIONS(2146),
    [anon_sym_PIPE] = ACTIONS(2148),
    [anon_sym_RPAREN] = ACTIONS(2148),
    [anon_sym_SEMI_SEMI] = ACTIONS(2148),
    [anon_sym_PIPE_AMP] = ACTIONS(2148),
    [anon_sym_AMP_AMP] = ACTIONS(2148),
    [anon_sym_PIPE_PIPE] = ACTIONS(2148),
    [anon_sym_LT] = ACTIONS(2148),
    [anon_sym_GT] = ACTIONS(2148),
    [anon_sym_GT_GT] = ACTIONS(2148),
    [anon_sym_AMP_GT] = ACTIONS(2148),
    [anon_sym_AMP_GT_GT] = ACTIONS(2148),
    [anon_sym_LT_AMP] = ACTIONS(2148),
    [anon_sym_GT_AMP] = ACTIONS(2148),
    [anon_sym_LT_LT] = ACTIONS(2148),
    [anon_sym_LT_LT_DASH] = ACTIONS(2148),
    [anon_sym_LT_LT_LT] = ACTIONS(2148),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2148),
    [anon_sym_LF] = ACTIONS(2148),
    [anon_sym_AMP] = ACTIONS(2148),
  },
  [603] = {
    [sym_file_descriptor] = ACTIONS(296),
    [sym_variable_name] = ACTIONS(296),
    [anon_sym_for] = ACTIONS(298),
    [anon_sym_while] = ACTIONS(298),
    [anon_sym_done] = ACTIONS(298),
    [anon_sym_if] = ACTIONS(298),
    [anon_sym_case] = ACTIONS(298),
    [anon_sym_function] = ACTIONS(298),
    [anon_sym_LPAREN] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(296),
    [anon_sym_declare] = ACTIONS(298),
    [anon_sym_typeset] = ACTIONS(298),
    [anon_sym_export] = ACTIONS(298),
    [anon_sym_readonly] = ACTIONS(298),
    [anon_sym_local] = ACTIONS(298),
    [anon_sym_LT] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(298),
    [anon_sym_GT_GT] = ACTIONS(296),
    [anon_sym_AMP_GT] = ACTIONS(298),
    [anon_sym_AMP_GT_GT] = ACTIONS(296),
    [anon_sym_LT_AMP] = ACTIONS(296),
    [anon_sym_GT_AMP] = ACTIONS(296),
    [sym__special_characters] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(296),
    [sym_raw_string] = ACTIONS(296),
    [anon_sym_DOLLAR] = ACTIONS(298),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(296),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(296),
    [anon_sym_BQUOTE] = ACTIONS(296),
    [anon_sym_LT_LPAREN] = ACTIONS(296),
    [anon_sym_GT_LPAREN] = ACTIONS(296),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(300),
  },
  [604] = {
    [anon_sym_PIPE] = ACTIONS(302),
    [anon_sym_SEMI_SEMI] = ACTIONS(2150),
    [anon_sym_PIPE_AMP] = ACTIONS(302),
    [anon_sym_AMP_AMP] = ACTIONS(306),
    [anon_sym_PIPE_PIPE] = ACTIONS(306),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2150),
    [anon_sym_LF] = ACTIONS(2150),
    [anon_sym_AMP] = ACTIONS(2150),
  },
  [605] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(302),
    [anon_sym_SEMI_SEMI] = ACTIONS(2150),
    [anon_sym_PIPE_AMP] = ACTIONS(302),
    [anon_sym_AMP_AMP] = ACTIONS(306),
    [anon_sym_PIPE_PIPE] = ACTIONS(306),
    [anon_sym_LT] = ACTIONS(336),
    [anon_sym_GT] = ACTIONS(336),
    [anon_sym_GT_GT] = ACTIONS(336),
    [anon_sym_AMP_GT] = ACTIONS(336),
    [anon_sym_AMP_GT_GT] = ACTIONS(336),
    [anon_sym_LT_AMP] = ACTIONS(336),
    [anon_sym_GT_AMP] = ACTIONS(336),
    [sym__special_characters] = ACTIONS(336),
    [anon_sym_DQUOTE] = ACTIONS(336),
    [sym_raw_string] = ACTIONS(336),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(336),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(336),
    [anon_sym_BQUOTE] = ACTIONS(336),
    [anon_sym_LT_LPAREN] = ACTIONS(336),
    [anon_sym_GT_LPAREN] = ACTIONS(336),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(336),
    [anon_sym_SEMI] = ACTIONS(2150),
    [anon_sym_LF] = ACTIONS(2150),
    [anon_sym_AMP] = ACTIONS(2150),
  },
  [606] = {
    [sym__terminated_statement] = STATE(603),
    [sym_for_statement] = STATE(604),
    [sym_while_statement] = STATE(604),
    [sym_if_statement] = STATE(604),
    [sym_case_statement] = STATE(604),
    [sym_function_definition] = STATE(604),
    [sym_subshell] = STATE(604),
    [sym_pipeline] = STATE(604),
    [sym_list] = STATE(604),
    [sym_bracket_command] = STATE(604),
    [sym_command] = STATE(604),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(605),
    [sym_declaration_command] = STATE(604),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(1099),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_done] = ACTIONS(2152),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [607] = {
    [sym_file_redirect] = STATE(185),
    [sym_heredoc_redirect] = STATE(185),
    [sym_herestring_redirect] = STATE(185),
    [aux_sym_while_statement_repeat1] = STATE(538),
    [sym_file_descriptor] = ACTIONS(308),
    [anon_sym_PIPE] = ACTIONS(2154),
    [anon_sym_SEMI_SEMI] = ACTIONS(2154),
    [anon_sym_PIPE_AMP] = ACTIONS(2154),
    [anon_sym_AMP_AMP] = ACTIONS(2154),
    [anon_sym_PIPE_PIPE] = ACTIONS(2154),
    [anon_sym_LT] = ACTIONS(312),
    [anon_sym_GT] = ACTIONS(312),
    [anon_sym_GT_GT] = ACTIONS(312),
    [anon_sym_AMP_GT] = ACTIONS(312),
    [anon_sym_AMP_GT_GT] = ACTIONS(312),
    [anon_sym_LT_AMP] = ACTIONS(312),
    [anon_sym_GT_AMP] = ACTIONS(312),
    [anon_sym_LT_LT] = ACTIONS(314),
    [anon_sym_LT_LT_DASH] = ACTIONS(314),
    [anon_sym_LT_LT_LT] = ACTIONS(316),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2154),
    [anon_sym_LF] = ACTIONS(2154),
    [anon_sym_AMP] = ACTIONS(2154),
  },
  [608] = {
    [anon_sym_PIPE] = ACTIONS(2156),
    [anon_sym_RPAREN] = ACTIONS(2156),
    [anon_sym_SEMI_SEMI] = ACTIONS(2156),
    [anon_sym_PIPE_AMP] = ACTIONS(2156),
    [anon_sym_AMP_AMP] = ACTIONS(2156),
    [anon_sym_PIPE_PIPE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2156),
    [anon_sym_LF] = ACTIONS(2156),
    [anon_sym_AMP] = ACTIONS(2156),
  },
  [609] = {
    [sym__terminated_statement] = STATE(1100),
    [sym_for_statement] = STATE(39),
    [sym_while_statement] = STATE(39),
    [sym_if_statement] = STATE(39),
    [sym_case_statement] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_subshell] = STATE(39),
    [sym_pipeline] = STATE(39),
    [sym_list] = STATE(39),
    [sym_bracket_command] = STATE(39),
    [sym_command] = STATE(39),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(40),
    [sym_declaration_command] = STATE(39),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [610] = {
    [sym__terminated_statement] = STATE(1101),
    [sym_for_statement] = STATE(1102),
    [sym_while_statement] = STATE(1102),
    [sym_if_statement] = STATE(1102),
    [sym_case_statement] = STATE(1102),
    [sym_function_definition] = STATE(1102),
    [sym_subshell] = STATE(1102),
    [sym_pipeline] = STATE(1102),
    [sym_list] = STATE(1102),
    [sym_bracket_command] = STATE(1102),
    [sym_command] = STATE(1102),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(1103),
    [sym_declaration_command] = STATE(1102),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(1104),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_fi] = ACTIONS(2158),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [611] = {
    [sym_file_descriptor] = ACTIONS(296),
    [sym_variable_name] = ACTIONS(296),
    [anon_sym_for] = ACTIONS(298),
    [anon_sym_while] = ACTIONS(298),
    [anon_sym_if] = ACTIONS(298),
    [anon_sym_fi] = ACTIONS(298),
    [anon_sym_elif] = ACTIONS(298),
    [anon_sym_else] = ACTIONS(298),
    [anon_sym_case] = ACTIONS(298),
    [anon_sym_function] = ACTIONS(298),
    [anon_sym_LPAREN] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(296),
    [anon_sym_declare] = ACTIONS(298),
    [anon_sym_typeset] = ACTIONS(298),
    [anon_sym_export] = ACTIONS(298),
    [anon_sym_readonly] = ACTIONS(298),
    [anon_sym_local] = ACTIONS(298),
    [anon_sym_LT] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(298),
    [anon_sym_GT_GT] = ACTIONS(296),
    [anon_sym_AMP_GT] = ACTIONS(298),
    [anon_sym_AMP_GT_GT] = ACTIONS(296),
    [anon_sym_LT_AMP] = ACTIONS(296),
    [anon_sym_GT_AMP] = ACTIONS(296),
    [sym__special_characters] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(296),
    [sym_raw_string] = ACTIONS(296),
    [anon_sym_DOLLAR] = ACTIONS(298),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(296),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(296),
    [anon_sym_BQUOTE] = ACTIONS(296),
    [anon_sym_LT_LPAREN] = ACTIONS(296),
    [anon_sym_GT_LPAREN] = ACTIONS(296),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(300),
  },
  [612] = {
    [anon_sym_PIPE] = ACTIONS(302),
    [anon_sym_SEMI_SEMI] = ACTIONS(2160),
    [anon_sym_PIPE_AMP] = ACTIONS(302),
    [anon_sym_AMP_AMP] = ACTIONS(306),
    [anon_sym_PIPE_PIPE] = ACTIONS(306),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_LF] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2160),
  },
  [613] = {
    [anon_sym_fi] = ACTIONS(2162),
    [anon_sym_elif] = ACTIONS(2162),
    [anon_sym_else] = ACTIONS(2162),
    [sym_comment] = ACTIONS(52),
  },
  [614] = {
    [anon_sym_fi] = ACTIONS(2164),
    [sym_comment] = ACTIONS(52),
  },
  [615] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(302),
    [anon_sym_SEMI_SEMI] = ACTIONS(2160),
    [anon_sym_PIPE_AMP] = ACTIONS(302),
    [anon_sym_AMP_AMP] = ACTIONS(306),
    [anon_sym_PIPE_PIPE] = ACTIONS(306),
    [anon_sym_LT] = ACTIONS(336),
    [anon_sym_GT] = ACTIONS(336),
    [anon_sym_GT_GT] = ACTIONS(336),
    [anon_sym_AMP_GT] = ACTIONS(336),
    [anon_sym_AMP_GT_GT] = ACTIONS(336),
    [anon_sym_LT_AMP] = ACTIONS(336),
    [anon_sym_GT_AMP] = ACTIONS(336),
    [sym__special_characters] = ACTIONS(336),
    [anon_sym_DQUOTE] = ACTIONS(336),
    [sym_raw_string] = ACTIONS(336),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(336),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(336),
    [anon_sym_BQUOTE] = ACTIONS(336),
    [anon_sym_LT_LPAREN] = ACTIONS(336),
    [anon_sym_GT_LPAREN] = ACTIONS(336),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(336),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_LF] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2160),
  },
  [616] = {
    [sym__terminated_statement] = STATE(611),
    [sym_for_statement] = STATE(612),
    [sym_while_statement] = STATE(612),
    [sym_if_statement] = STATE(612),
    [sym_elif_clause] = STATE(613),
    [sym_else_clause] = STATE(1107),
    [sym_case_statement] = STATE(612),
    [sym_function_definition] = STATE(612),
    [sym_subshell] = STATE(612),
    [sym_pipeline] = STATE(612),
    [sym_list] = STATE(612),
    [sym_bracket_command] = STATE(612),
    [sym_command] = STATE(612),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(615),
    [sym_declaration_command] = STATE(612),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(1108),
    [aux_sym_if_statement_repeat1] = STATE(1109),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_fi] = ACTIONS(2166),
    [anon_sym_elif] = ACTIONS(1140),
    [anon_sym_else] = ACTIONS(1142),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [617] = {
    [sym_elif_clause] = STATE(613),
    [sym_else_clause] = STATE(1107),
    [aux_sym_if_statement_repeat1] = STATE(1110),
    [anon_sym_fi] = ACTIONS(2164),
    [anon_sym_elif] = ACTIONS(2168),
    [anon_sym_else] = ACTIONS(2170),
    [sym_comment] = ACTIONS(52),
  },
  [618] = {
    [sym__concat] = ACTIONS(1522),
    [anon_sym_in] = ACTIONS(1524),
    [anon_sym_SEMI_SEMI] = ACTIONS(1524),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1524),
    [anon_sym_LF] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1524),
  },
  [619] = {
    [sym_case_item] = STATE(1120),
    [sym_last_case_item] = STATE(1121),
    [sym_concatenation] = STATE(1122),
    [sym_string] = STATE(1114),
    [sym_simple_expansion] = STATE(1114),
    [sym_expansion] = STATE(1114),
    [sym_command_substitution] = STATE(1114),
    [sym_process_substitution] = STATE(1114),
    [aux_sym_case_statement_repeat1] = STATE(1123),
    [anon_sym_esac] = ACTIONS(2172),
    [sym__special_characters] = ACTIONS(2174),
    [anon_sym_DQUOTE] = ACTIONS(2176),
    [sym_raw_string] = ACTIONS(2178),
    [anon_sym_DOLLAR] = ACTIONS(2180),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2182),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2184),
    [anon_sym_BQUOTE] = ACTIONS(2186),
    [anon_sym_LT_LPAREN] = ACTIONS(2188),
    [anon_sym_GT_LPAREN] = ACTIONS(2188),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2190),
  },
  [620] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(2192),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2192),
    [anon_sym_LF] = ACTIONS(2192),
    [anon_sym_AMP] = ACTIONS(2192),
  },
  [621] = {
    [aux_sym_concatenation_repeat1] = STATE(621),
    [sym__concat] = ACTIONS(2194),
    [anon_sym_in] = ACTIONS(1524),
    [anon_sym_SEMI_SEMI] = ACTIONS(1524),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1524),
    [anon_sym_LF] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1524),
  },
  [622] = {
    [sym__concat] = ACTIONS(1553),
    [anon_sym_in] = ACTIONS(1555),
    [anon_sym_SEMI_SEMI] = ACTIONS(1555),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1555),
    [anon_sym_LF] = ACTIONS(1555),
    [anon_sym_AMP] = ACTIONS(1555),
  },
  [623] = {
    [sym_case_item] = STATE(1120),
    [sym_last_case_item] = STATE(1126),
    [sym_concatenation] = STATE(1122),
    [sym_string] = STATE(1114),
    [sym_simple_expansion] = STATE(1114),
    [sym_expansion] = STATE(1114),
    [sym_command_substitution] = STATE(1114),
    [sym_process_substitution] = STATE(1114),
    [aux_sym_case_statement_repeat1] = STATE(1127),
    [anon_sym_esac] = ACTIONS(2197),
    [sym__special_characters] = ACTIONS(2174),
    [anon_sym_DQUOTE] = ACTIONS(2176),
    [sym_raw_string] = ACTIONS(2178),
    [anon_sym_DOLLAR] = ACTIONS(2180),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2182),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2184),
    [anon_sym_BQUOTE] = ACTIONS(2186),
    [anon_sym_LT_LPAREN] = ACTIONS(2188),
    [anon_sym_GT_LPAREN] = ACTIONS(2188),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2190),
  },
  [624] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(2199),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2199),
    [anon_sym_LF] = ACTIONS(2199),
    [anon_sym_AMP] = ACTIONS(2199),
  },
  [625] = {
    [sym_concatenation] = STATE(1132),
    [sym_string] = STATE(1131),
    [sym_simple_expansion] = STATE(1131),
    [sym_expansion] = STATE(1131),
    [sym_command_substitution] = STATE(1131),
    [sym_process_substitution] = STATE(1131),
    [anon_sym_RBRACE] = ACTIONS(2201),
    [sym__special_characters] = ACTIONS(2203),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(2205),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2207),
  },
  [626] = {
    [sym__concat] = ACTIONS(1598),
    [anon_sym_in] = ACTIONS(1600),
    [anon_sym_SEMI_SEMI] = ACTIONS(1600),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1600),
    [anon_sym_LF] = ACTIONS(1600),
    [anon_sym_AMP] = ACTIONS(1600),
  },
  [627] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(2209),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [628] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(2211),
    [sym_comment] = ACTIONS(52),
  },
  [629] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1136),
    [anon_sym_RBRACE] = ACTIONS(2213),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [630] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1138),
    [anon_sym_RBRACE] = ACTIONS(2215),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [631] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1139),
    [anon_sym_RBRACE] = ACTIONS(2201),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [632] = {
    [sym__concat] = ACTIONS(1642),
    [anon_sym_in] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [633] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(2217),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [634] = {
    [sym__concat] = ACTIONS(1648),
    [anon_sym_in] = ACTIONS(1650),
    [anon_sym_SEMI_SEMI] = ACTIONS(1650),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1650),
    [anon_sym_LF] = ACTIONS(1650),
    [anon_sym_AMP] = ACTIONS(1650),
  },
  [635] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(2201),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [636] = {
    [sym__concat] = ACTIONS(1762),
    [anon_sym_in] = ACTIONS(1764),
    [anon_sym_SEMI_SEMI] = ACTIONS(1764),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1764),
    [anon_sym_LF] = ACTIONS(1764),
    [anon_sym_AMP] = ACTIONS(1764),
  },
  [637] = {
    [sym__concat] = ACTIONS(1902),
    [anon_sym_in] = ACTIONS(1904),
    [anon_sym_SEMI_SEMI] = ACTIONS(1904),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1904),
    [anon_sym_LF] = ACTIONS(1904),
    [anon_sym_AMP] = ACTIONS(1904),
  },
  [638] = {
    [sym_compound_statement] = STATE(1141),
    [anon_sym_LBRACE] = ACTIONS(436),
    [sym_comment] = ACTIONS(52),
  },
  [639] = {
    [sym_file_descriptor] = ACTIONS(2219),
    [anon_sym_PIPE] = ACTIONS(2221),
    [anon_sym_RPAREN] = ACTIONS(2221),
    [anon_sym_SEMI_SEMI] = ACTIONS(2221),
    [anon_sym_PIPE_AMP] = ACTIONS(2221),
    [anon_sym_AMP_AMP] = ACTIONS(2221),
    [anon_sym_PIPE_PIPE] = ACTIONS(2221),
    [anon_sym_LT] = ACTIONS(2221),
    [anon_sym_GT] = ACTIONS(2221),
    [anon_sym_GT_GT] = ACTIONS(2221),
    [anon_sym_AMP_GT] = ACTIONS(2221),
    [anon_sym_AMP_GT_GT] = ACTIONS(2221),
    [anon_sym_LT_AMP] = ACTIONS(2221),
    [anon_sym_GT_AMP] = ACTIONS(2221),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2221),
    [anon_sym_LF] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
  },
  [640] = {
    [sym_file_descriptor] = ACTIONS(296),
    [sym_variable_name] = ACTIONS(296),
    [anon_sym_for] = ACTIONS(298),
    [anon_sym_while] = ACTIONS(298),
    [anon_sym_if] = ACTIONS(298),
    [anon_sym_case] = ACTIONS(298),
    [anon_sym_function] = ACTIONS(298),
    [anon_sym_LPAREN] = ACTIONS(296),
    [anon_sym_RBRACE] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(296),
    [anon_sym_declare] = ACTIONS(298),
    [anon_sym_typeset] = ACTIONS(298),
    [anon_sym_export] = ACTIONS(298),
    [anon_sym_readonly] = ACTIONS(298),
    [anon_sym_local] = ACTIONS(298),
    [anon_sym_LT] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(298),
    [anon_sym_GT_GT] = ACTIONS(296),
    [anon_sym_AMP_GT] = ACTIONS(298),
    [anon_sym_AMP_GT_GT] = ACTIONS(296),
    [anon_sym_LT_AMP] = ACTIONS(296),
    [anon_sym_GT_AMP] = ACTIONS(296),
    [sym__special_characters] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(296),
    [sym_raw_string] = ACTIONS(296),
    [anon_sym_DOLLAR] = ACTIONS(298),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(296),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(296),
    [anon_sym_BQUOTE] = ACTIONS(296),
    [anon_sym_LT_LPAREN] = ACTIONS(296),
    [anon_sym_GT_LPAREN] = ACTIONS(296),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(300),
  },
  [641] = {
    [anon_sym_PIPE] = ACTIONS(302),
    [anon_sym_SEMI_SEMI] = ACTIONS(2223),
    [anon_sym_PIPE_AMP] = ACTIONS(302),
    [anon_sym_AMP_AMP] = ACTIONS(306),
    [anon_sym_PIPE_PIPE] = ACTIONS(306),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LF] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2223),
  },
  [642] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(302),
    [anon_sym_SEMI_SEMI] = ACTIONS(2223),
    [anon_sym_PIPE_AMP] = ACTIONS(302),
    [anon_sym_AMP_AMP] = ACTIONS(306),
    [anon_sym_PIPE_PIPE] = ACTIONS(306),
    [anon_sym_LT] = ACTIONS(336),
    [anon_sym_GT] = ACTIONS(336),
    [anon_sym_GT_GT] = ACTIONS(336),
    [anon_sym_AMP_GT] = ACTIONS(336),
    [anon_sym_AMP_GT_GT] = ACTIONS(336),
    [anon_sym_LT_AMP] = ACTIONS(336),
    [anon_sym_GT_AMP] = ACTIONS(336),
    [sym__special_characters] = ACTIONS(336),
    [anon_sym_DQUOTE] = ACTIONS(336),
    [sym_raw_string] = ACTIONS(336),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(336),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(336),
    [anon_sym_BQUOTE] = ACTIONS(336),
    [anon_sym_LT_LPAREN] = ACTIONS(336),
    [anon_sym_GT_LPAREN] = ACTIONS(336),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(336),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LF] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2223),
  },
  [643] = {
    [sym__terminated_statement] = STATE(640),
    [sym_for_statement] = STATE(641),
    [sym_while_statement] = STATE(641),
    [sym_if_statement] = STATE(641),
    [sym_case_statement] = STATE(641),
    [sym_function_definition] = STATE(641),
    [sym_subshell] = STATE(641),
    [sym_pipeline] = STATE(641),
    [sym_list] = STATE(641),
    [sym_bracket_command] = STATE(641),
    [sym_command] = STATE(641),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(642),
    [sym_declaration_command] = STATE(641),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(1144),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_RBRACE] = ACTIONS(2225),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [644] = {
    [anon_sym_LT] = ACTIONS(2227),
    [anon_sym_GT] = ACTIONS(2227),
    [anon_sym_GT_GT] = ACTIONS(2229),
    [anon_sym_AMP_GT] = ACTIONS(2227),
    [anon_sym_AMP_GT_GT] = ACTIONS(2229),
    [anon_sym_LT_AMP] = ACTIONS(2229),
    [anon_sym_GT_AMP] = ACTIONS(2229),
    [sym_comment] = ACTIONS(52),
  },
  [645] = {
    [sym_concatenation] = STATE(1154),
    [sym_string] = STATE(1148),
    [sym_simple_expansion] = STATE(1148),
    [sym_expansion] = STATE(1148),
    [sym_command_substitution] = STATE(1148),
    [sym_process_substitution] = STATE(1148),
    [sym__special_characters] = ACTIONS(2231),
    [anon_sym_DQUOTE] = ACTIONS(2233),
    [sym_raw_string] = ACTIONS(2235),
    [anon_sym_DOLLAR] = ACTIONS(2237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2239),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2241),
    [anon_sym_BQUOTE] = ACTIONS(2243),
    [anon_sym_LT_LPAREN] = ACTIONS(2245),
    [anon_sym_GT_LPAREN] = ACTIONS(2245),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2247),
  },
  [646] = {
    [anon_sym_PIPE] = ACTIONS(2249),
    [anon_sym_RPAREN] = ACTIONS(2249),
    [anon_sym_SEMI_SEMI] = ACTIONS(2249),
    [anon_sym_PIPE_AMP] = ACTIONS(2249),
    [anon_sym_AMP_AMP] = ACTIONS(2249),
    [anon_sym_PIPE_PIPE] = ACTIONS(2249),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2249),
    [anon_sym_LF] = ACTIONS(2249),
    [anon_sym_AMP] = ACTIONS(2249),
  },
  [647] = {
    [aux_sym_concatenation_repeat1] = STATE(1156),
    [sym_file_descriptor] = ACTIONS(1092),
    [sym__concat] = ACTIONS(2251),
    [sym_variable_name] = ACTIONS(1092),
    [anon_sym_PIPE] = ACTIONS(1096),
    [anon_sym_RPAREN] = ACTIONS(1096),
    [anon_sym_SEMI_SEMI] = ACTIONS(1096),
    [anon_sym_PIPE_AMP] = ACTIONS(1096),
    [anon_sym_AMP_AMP] = ACTIONS(1096),
    [anon_sym_PIPE_PIPE] = ACTIONS(1096),
    [anon_sym_LT] = ACTIONS(1096),
    [anon_sym_GT] = ACTIONS(1096),
    [anon_sym_GT_GT] = ACTIONS(1096),
    [anon_sym_AMP_GT] = ACTIONS(1096),
    [anon_sym_AMP_GT_GT] = ACTIONS(1096),
    [anon_sym_LT_AMP] = ACTIONS(1096),
    [anon_sym_GT_AMP] = ACTIONS(1096),
    [sym__special_characters] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1096),
    [sym_raw_string] = ACTIONS(1096),
    [anon_sym_DOLLAR] = ACTIONS(1096),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1096),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1096),
    [anon_sym_BQUOTE] = ACTIONS(1096),
    [anon_sym_LT_LPAREN] = ACTIONS(1096),
    [anon_sym_GT_LPAREN] = ACTIONS(1096),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1096),
    [anon_sym_SEMI] = ACTIONS(1096),
    [anon_sym_LF] = ACTIONS(1096),
    [anon_sym_AMP] = ACTIONS(1096),
  },
  [648] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(1158),
    [anon_sym_DQUOTE] = ACTIONS(2253),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [649] = {
    [aux_sym_concatenation_repeat1] = STATE(1156),
    [sym_file_descriptor] = ACTIONS(1068),
    [sym__concat] = ACTIONS(2251),
    [sym_variable_name] = ACTIONS(1068),
    [anon_sym_PIPE] = ACTIONS(1070),
    [anon_sym_RPAREN] = ACTIONS(1070),
    [anon_sym_SEMI_SEMI] = ACTIONS(1070),
    [anon_sym_PIPE_AMP] = ACTIONS(1070),
    [anon_sym_AMP_AMP] = ACTIONS(1070),
    [anon_sym_PIPE_PIPE] = ACTIONS(1070),
    [anon_sym_LT] = ACTIONS(1070),
    [anon_sym_GT] = ACTIONS(1070),
    [anon_sym_GT_GT] = ACTIONS(1070),
    [anon_sym_AMP_GT] = ACTIONS(1070),
    [anon_sym_AMP_GT_GT] = ACTIONS(1070),
    [anon_sym_LT_AMP] = ACTIONS(1070),
    [anon_sym_GT_AMP] = ACTIONS(1070),
    [sym__special_characters] = ACTIONS(1070),
    [anon_sym_DQUOTE] = ACTIONS(1070),
    [sym_raw_string] = ACTIONS(1070),
    [anon_sym_DOLLAR] = ACTIONS(1070),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1070),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1070),
    [anon_sym_BQUOTE] = ACTIONS(1070),
    [anon_sym_LT_LPAREN] = ACTIONS(1070),
    [anon_sym_GT_LPAREN] = ACTIONS(1070),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1070),
    [anon_sym_SEMI] = ACTIONS(1070),
    [anon_sym_LF] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(1070),
  },
  [650] = {
    [sym_string] = STATE(1161),
    [anon_sym_DQUOTE] = ACTIONS(1190),
    [anon_sym_DOLLAR] = ACTIONS(2255),
    [anon_sym_POUND] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2255),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2257),
    [anon_sym_STAR] = ACTIONS(2255),
    [anon_sym_AT] = ACTIONS(2255),
    [anon_sym_QMARK] = ACTIONS(2255),
    [anon_sym_0] = ACTIONS(2259),
    [anon_sym__] = ACTIONS(2259),
  },
  [651] = {
    [sym_subscript] = STATE(1166),
    [sym_variable_name] = ACTIONS(2261),
    [anon_sym_DOLLAR] = ACTIONS(2263),
    [anon_sym_POUND] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2263),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2267),
    [anon_sym_STAR] = ACTIONS(2263),
    [anon_sym_AT] = ACTIONS(2263),
    [anon_sym_QMARK] = ACTIONS(2263),
    [anon_sym_0] = ACTIONS(2269),
    [anon_sym__] = ACTIONS(2269),
  },
  [652] = {
    [sym_for_statement] = STATE(1167),
    [sym_while_statement] = STATE(1167),
    [sym_if_statement] = STATE(1167),
    [sym_case_statement] = STATE(1167),
    [sym_function_definition] = STATE(1167),
    [sym_subshell] = STATE(1167),
    [sym_pipeline] = STATE(1167),
    [sym_list] = STATE(1167),
    [sym_bracket_command] = STATE(1167),
    [sym_command] = STATE(1167),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(1168),
    [sym_declaration_command] = STATE(1167),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [653] = {
    [sym_for_statement] = STATE(1169),
    [sym_while_statement] = STATE(1169),
    [sym_if_statement] = STATE(1169),
    [sym_case_statement] = STATE(1169),
    [sym_function_definition] = STATE(1169),
    [sym_subshell] = STATE(1169),
    [sym_pipeline] = STATE(1169),
    [sym_list] = STATE(1169),
    [sym_bracket_command] = STATE(1169),
    [sym_command] = STATE(1169),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(1170),
    [sym_declaration_command] = STATE(1169),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [654] = {
    [sym_for_statement] = STATE(1171),
    [sym_while_statement] = STATE(1171),
    [sym_if_statement] = STATE(1171),
    [sym_case_statement] = STATE(1171),
    [sym_function_definition] = STATE(1171),
    [sym_subshell] = STATE(1171),
    [sym_pipeline] = STATE(1171),
    [sym_list] = STATE(1171),
    [sym_bracket_command] = STATE(1171),
    [sym_command] = STATE(1171),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(1172),
    [sym_declaration_command] = STATE(1171),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [655] = {
    [sym_file_redirect] = STATE(185),
    [sym_heredoc_redirect] = STATE(185),
    [sym_herestring_redirect] = STATE(185),
    [aux_sym_while_statement_repeat1] = STATE(1173),
    [sym_file_descriptor] = ACTIONS(490),
    [anon_sym_PIPE] = ACTIONS(1136),
    [anon_sym_RPAREN] = ACTIONS(1136),
    [anon_sym_SEMI_SEMI] = ACTIONS(1136),
    [anon_sym_PIPE_AMP] = ACTIONS(1136),
    [anon_sym_AMP_AMP] = ACTIONS(1136),
    [anon_sym_PIPE_PIPE] = ACTIONS(1136),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_GT] = ACTIONS(492),
    [anon_sym_GT_GT] = ACTIONS(492),
    [anon_sym_AMP_GT] = ACTIONS(492),
    [anon_sym_AMP_GT_GT] = ACTIONS(492),
    [anon_sym_LT_AMP] = ACTIONS(492),
    [anon_sym_GT_AMP] = ACTIONS(492),
    [anon_sym_LT_LT] = ACTIONS(314),
    [anon_sym_LT_LT_DASH] = ACTIONS(314),
    [anon_sym_LT_LT_LT] = ACTIONS(494),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1136),
    [anon_sym_LF] = ACTIONS(1136),
    [anon_sym_AMP] = ACTIONS(1136),
  },
  [656] = {
    [anon_sym_RPAREN] = ACTIONS(2271),
    [sym_comment] = ACTIONS(52),
  },
  [657] = {
    [sym_file_redirect] = STATE(646),
    [sym_file_descriptor] = ACTIONS(2273),
    [anon_sym_PIPE] = ACTIONS(1184),
    [anon_sym_RPAREN] = ACTIONS(1184),
    [anon_sym_SEMI_SEMI] = ACTIONS(1184),
    [anon_sym_PIPE_AMP] = ACTIONS(1184),
    [anon_sym_AMP_AMP] = ACTIONS(1184),
    [anon_sym_PIPE_PIPE] = ACTIONS(1184),
    [anon_sym_LT] = ACTIONS(2275),
    [anon_sym_GT] = ACTIONS(2275),
    [anon_sym_GT_GT] = ACTIONS(2275),
    [anon_sym_AMP_GT] = ACTIONS(2275),
    [anon_sym_AMP_GT_GT] = ACTIONS(2275),
    [anon_sym_LT_AMP] = ACTIONS(2275),
    [anon_sym_GT_AMP] = ACTIONS(2275),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1184),
    [anon_sym_LF] = ACTIONS(1184),
    [anon_sym_AMP] = ACTIONS(1184),
  },
  [658] = {
    [sym_concatenation] = STATE(746),
    [sym_string] = STATE(1178),
    [sym_array] = STATE(746),
    [sym_simple_expansion] = STATE(1178),
    [sym_expansion] = STATE(1178),
    [sym_command_substitution] = STATE(1178),
    [sym_process_substitution] = STATE(1178),
    [sym__empty_value] = ACTIONS(1418),
    [anon_sym_LPAREN] = ACTIONS(1420),
    [sym__special_characters] = ACTIONS(2277),
    [anon_sym_DQUOTE] = ACTIONS(1214),
    [sym_raw_string] = ACTIONS(2279),
    [anon_sym_DOLLAR] = ACTIONS(2281),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2283),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2285),
    [anon_sym_BQUOTE] = ACTIONS(2287),
    [anon_sym_LT_LPAREN] = ACTIONS(2289),
    [anon_sym_GT_LPAREN] = ACTIONS(2289),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2291),
  },
  [659] = {
    [sym_string] = STATE(1179),
    [sym_simple_expansion] = STATE(1179),
    [sym_expansion] = STATE(1179),
    [sym_command_substitution] = STATE(1179),
    [sym_process_substitution] = STATE(1179),
    [sym__special_characters] = ACTIONS(2293),
    [anon_sym_DQUOTE] = ACTIONS(1214),
    [sym_raw_string] = ACTIONS(2295),
    [anon_sym_DOLLAR] = ACTIONS(2281),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2283),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2285),
    [anon_sym_BQUOTE] = ACTIONS(2287),
    [anon_sym_LT_LPAREN] = ACTIONS(2289),
    [anon_sym_GT_LPAREN] = ACTIONS(2289),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2293),
  },
  [660] = {
    [aux_sym_concatenation_repeat1] = STATE(1180),
    [sym__concat] = ACTIONS(1210),
    [sym_variable_name] = ACTIONS(646),
    [anon_sym_PIPE] = ACTIONS(648),
    [anon_sym_RPAREN] = ACTIONS(648),
    [anon_sym_SEMI_SEMI] = ACTIONS(648),
    [anon_sym_PIPE_AMP] = ACTIONS(648),
    [anon_sym_AMP_AMP] = ACTIONS(648),
    [anon_sym_PIPE_PIPE] = ACTIONS(648),
    [sym__special_characters] = ACTIONS(648),
    [anon_sym_DQUOTE] = ACTIONS(648),
    [sym_raw_string] = ACTIONS(648),
    [anon_sym_DOLLAR] = ACTIONS(648),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(648),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(648),
    [anon_sym_BQUOTE] = ACTIONS(648),
    [anon_sym_LT_LPAREN] = ACTIONS(648),
    [anon_sym_GT_LPAREN] = ACTIONS(648),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(648),
    [sym_word] = ACTIONS(648),
    [anon_sym_SEMI] = ACTIONS(648),
    [anon_sym_LF] = ACTIONS(648),
    [anon_sym_AMP] = ACTIONS(648),
  },
  [661] = {
    [sym__concat] = ACTIONS(650),
    [sym_variable_name] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(652),
    [anon_sym_RPAREN] = ACTIONS(652),
    [anon_sym_SEMI_SEMI] = ACTIONS(652),
    [anon_sym_PIPE_AMP] = ACTIONS(652),
    [anon_sym_AMP_AMP] = ACTIONS(652),
    [anon_sym_PIPE_PIPE] = ACTIONS(652),
    [sym__special_characters] = ACTIONS(652),
    [anon_sym_DQUOTE] = ACTIONS(652),
    [sym_raw_string] = ACTIONS(652),
    [anon_sym_DOLLAR] = ACTIONS(652),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(652),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(652),
    [anon_sym_BQUOTE] = ACTIONS(652),
    [anon_sym_LT_LPAREN] = ACTIONS(652),
    [anon_sym_GT_LPAREN] = ACTIONS(652),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(652),
    [sym_word] = ACTIONS(652),
    [anon_sym_SEMI] = ACTIONS(652),
    [anon_sym_LF] = ACTIONS(652),
    [anon_sym_AMP] = ACTIONS(652),
  },
  [662] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(2297),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [663] = {
    [sym__concat] = ACTIONS(680),
    [sym_variable_name] = ACTIONS(680),
    [anon_sym_PIPE] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(682),
    [anon_sym_SEMI_SEMI] = ACTIONS(682),
    [anon_sym_PIPE_AMP] = ACTIONS(682),
    [anon_sym_AMP_AMP] = ACTIONS(682),
    [anon_sym_PIPE_PIPE] = ACTIONS(682),
    [sym__special_characters] = ACTIONS(682),
    [anon_sym_DQUOTE] = ACTIONS(682),
    [sym_raw_string] = ACTIONS(682),
    [anon_sym_DOLLAR] = ACTIONS(682),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(682),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(682),
    [anon_sym_BQUOTE] = ACTIONS(682),
    [anon_sym_LT_LPAREN] = ACTIONS(682),
    [anon_sym_GT_LPAREN] = ACTIONS(682),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(682),
    [sym_word] = ACTIONS(682),
    [anon_sym_SEMI] = ACTIONS(682),
    [anon_sym_LF] = ACTIONS(682),
    [anon_sym_AMP] = ACTIONS(682),
  },
  [664] = {
    [sym__concat] = ACTIONS(684),
    [sym_variable_name] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(686),
    [anon_sym_RPAREN] = ACTIONS(686),
    [anon_sym_SEMI_SEMI] = ACTIONS(686),
    [anon_sym_PIPE_AMP] = ACTIONS(686),
    [anon_sym_AMP_AMP] = ACTIONS(686),
    [anon_sym_PIPE_PIPE] = ACTIONS(686),
    [sym__special_characters] = ACTIONS(686),
    [anon_sym_DQUOTE] = ACTIONS(686),
    [sym_raw_string] = ACTIONS(686),
    [anon_sym_DOLLAR] = ACTIONS(686),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(686),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(686),
    [anon_sym_BQUOTE] = ACTIONS(686),
    [anon_sym_LT_LPAREN] = ACTIONS(686),
    [anon_sym_GT_LPAREN] = ACTIONS(686),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(686),
    [sym_word] = ACTIONS(686),
    [anon_sym_SEMI] = ACTIONS(686),
    [anon_sym_LF] = ACTIONS(686),
    [anon_sym_AMP] = ACTIONS(686),
  },
  [665] = {
    [sym__concat] = ACTIONS(688),
    [sym_variable_name] = ACTIONS(688),
    [anon_sym_PIPE] = ACTIONS(690),
    [anon_sym_RPAREN] = ACTIONS(690),
    [anon_sym_SEMI_SEMI] = ACTIONS(690),
    [anon_sym_PIPE_AMP] = ACTIONS(690),
    [anon_sym_AMP_AMP] = ACTIONS(690),
    [anon_sym_PIPE_PIPE] = ACTIONS(690),
    [sym__special_characters] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(690),
    [sym_raw_string] = ACTIONS(690),
    [anon_sym_DOLLAR] = ACTIONS(690),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(690),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(690),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [anon_sym_LT_LPAREN] = ACTIONS(690),
    [anon_sym_GT_LPAREN] = ACTIONS(690),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(690),
    [sym_word] = ACTIONS(690),
    [anon_sym_SEMI] = ACTIONS(690),
    [anon_sym_LF] = ACTIONS(690),
    [anon_sym_AMP] = ACTIONS(690),
  },
  [666] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(2299),
    [sym_comment] = ACTIONS(52),
  },
  [667] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1184),
    [anon_sym_RBRACE] = ACTIONS(2301),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [668] = {
    [sym_subscript] = STATE(1188),
    [sym_variable_name] = ACTIONS(2303),
    [anon_sym_DOLLAR] = ACTIONS(2305),
    [anon_sym_DASH] = ACTIONS(2305),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2307),
    [anon_sym_STAR] = ACTIONS(2305),
    [anon_sym_AT] = ACTIONS(2305),
    [anon_sym_QMARK] = ACTIONS(2305),
    [anon_sym_0] = ACTIONS(2309),
    [anon_sym__] = ACTIONS(2309),
  },
  [669] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(2311),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [670] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1192),
    [anon_sym_RBRACE] = ACTIONS(2313),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [671] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(2315),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [672] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(2315),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [673] = {
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(2315),
    [sym_comment] = ACTIONS(52),
  },
  [674] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(2315),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [675] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(2317),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [676] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(2317),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [677] = {
    [sym_variable_assignment] = STATE(101),
    [sym_subscript] = STATE(258),
    [sym_concatenation] = STATE(101),
    [sym_string] = STATE(252),
    [sym_simple_expansion] = STATE(252),
    [sym_expansion] = STATE(252),
    [sym_command_substitution] = STATE(252),
    [sym_process_substitution] = STATE(252),
    [aux_sym_declaration_command_repeat1] = STATE(677),
    [sym_variable_name] = ACTIONS(2319),
    [anon_sym_PIPE] = ACTIONS(1467),
    [anon_sym_RPAREN] = ACTIONS(1467),
    [anon_sym_SEMI_SEMI] = ACTIONS(1467),
    [anon_sym_PIPE_AMP] = ACTIONS(1467),
    [anon_sym_AMP_AMP] = ACTIONS(1467),
    [anon_sym_PIPE_PIPE] = ACTIONS(1467),
    [sym__special_characters] = ACTIONS(2322),
    [anon_sym_DQUOTE] = ACTIONS(2325),
    [sym_raw_string] = ACTIONS(2328),
    [anon_sym_DOLLAR] = ACTIONS(2331),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2337),
    [anon_sym_BQUOTE] = ACTIONS(2340),
    [anon_sym_LT_LPAREN] = ACTIONS(2343),
    [anon_sym_GT_LPAREN] = ACTIONS(2343),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1493),
    [sym_word] = ACTIONS(2328),
    [anon_sym_SEMI] = ACTIONS(1467),
    [anon_sym_LF] = ACTIONS(1467),
    [anon_sym_AMP] = ACTIONS(1467),
  },
  [678] = {
    [sym_file_descriptor] = ACTIONS(1522),
    [sym__concat] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(1524),
    [anon_sym_RPAREN] = ACTIONS(1524),
    [anon_sym_SEMI_SEMI] = ACTIONS(1524),
    [anon_sym_PIPE_AMP] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1524),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_LT] = ACTIONS(1524),
    [anon_sym_GT] = ACTIONS(1524),
    [anon_sym_GT_GT] = ACTIONS(1524),
    [anon_sym_AMP_GT] = ACTIONS(1524),
    [anon_sym_AMP_GT_GT] = ACTIONS(1524),
    [anon_sym_LT_AMP] = ACTIONS(1524),
    [anon_sym_GT_AMP] = ACTIONS(1524),
    [anon_sym_LT_LT] = ACTIONS(1524),
    [anon_sym_LT_LT_DASH] = ACTIONS(1524),
    [anon_sym_LT_LT_LT] = ACTIONS(1524),
    [sym__special_characters] = ACTIONS(1524),
    [anon_sym_DQUOTE] = ACTIONS(1524),
    [sym_raw_string] = ACTIONS(1524),
    [anon_sym_DOLLAR] = ACTIONS(1524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1524),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1524),
    [anon_sym_BQUOTE] = ACTIONS(1524),
    [anon_sym_LT_LPAREN] = ACTIONS(1524),
    [anon_sym_GT_LPAREN] = ACTIONS(1524),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1524),
    [anon_sym_SEMI] = ACTIONS(1524),
    [anon_sym_LF] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1524),
  },
  [679] = {
    [aux_sym_concatenation_repeat1] = STATE(679),
    [sym_file_descriptor] = ACTIONS(1522),
    [sym__concat] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(1524),
    [anon_sym_RPAREN] = ACTIONS(1524),
    [anon_sym_SEMI_SEMI] = ACTIONS(1524),
    [anon_sym_PIPE_AMP] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1524),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_LT] = ACTIONS(1524),
    [anon_sym_GT] = ACTIONS(1524),
    [anon_sym_GT_GT] = ACTIONS(1524),
    [anon_sym_AMP_GT] = ACTIONS(1524),
    [anon_sym_AMP_GT_GT] = ACTIONS(1524),
    [anon_sym_LT_AMP] = ACTIONS(1524),
    [anon_sym_GT_AMP] = ACTIONS(1524),
    [anon_sym_LT_LT] = ACTIONS(1524),
    [anon_sym_LT_LT_DASH] = ACTIONS(1524),
    [anon_sym_LT_LT_LT] = ACTIONS(1524),
    [sym__special_characters] = ACTIONS(1524),
    [anon_sym_DQUOTE] = ACTIONS(1524),
    [sym_raw_string] = ACTIONS(1524),
    [anon_sym_DOLLAR] = ACTIONS(1524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1524),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1524),
    [anon_sym_BQUOTE] = ACTIONS(1524),
    [anon_sym_LT_LPAREN] = ACTIONS(1524),
    [anon_sym_GT_LPAREN] = ACTIONS(1524),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1524),
    [anon_sym_SEMI] = ACTIONS(1524),
    [anon_sym_LF] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1524),
  },
  [680] = {
    [sym_file_descriptor] = ACTIONS(1553),
    [sym__concat] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(1555),
    [anon_sym_RPAREN] = ACTIONS(1555),
    [anon_sym_SEMI_SEMI] = ACTIONS(1555),
    [anon_sym_PIPE_AMP] = ACTIONS(1555),
    [anon_sym_AMP_AMP] = ACTIONS(1555),
    [anon_sym_PIPE_PIPE] = ACTIONS(1555),
    [anon_sym_LT] = ACTIONS(1555),
    [anon_sym_GT] = ACTIONS(1555),
    [anon_sym_GT_GT] = ACTIONS(1555),
    [anon_sym_AMP_GT] = ACTIONS(1555),
    [anon_sym_AMP_GT_GT] = ACTIONS(1555),
    [anon_sym_LT_AMP] = ACTIONS(1555),
    [anon_sym_GT_AMP] = ACTIONS(1555),
    [anon_sym_LT_LT] = ACTIONS(1555),
    [anon_sym_LT_LT_DASH] = ACTIONS(1555),
    [anon_sym_LT_LT_LT] = ACTIONS(1555),
    [sym__special_characters] = ACTIONS(1555),
    [anon_sym_DQUOTE] = ACTIONS(1555),
    [sym_raw_string] = ACTIONS(1555),
    [anon_sym_DOLLAR] = ACTIONS(1555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1555),
    [anon_sym_BQUOTE] = ACTIONS(1555),
    [anon_sym_LT_LPAREN] = ACTIONS(1555),
    [anon_sym_GT_LPAREN] = ACTIONS(1555),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1555),
    [anon_sym_SEMI] = ACTIONS(1555),
    [anon_sym_LF] = ACTIONS(1555),
    [anon_sym_AMP] = ACTIONS(1555),
  },
  [681] = {
    [sym_concatenation] = STATE(1198),
    [sym_string] = STATE(1197),
    [sym_simple_expansion] = STATE(1197),
    [sym_expansion] = STATE(1197),
    [sym_command_substitution] = STATE(1197),
    [sym_process_substitution] = STATE(1197),
    [anon_sym_RBRACE] = ACTIONS(2349),
    [sym__special_characters] = ACTIONS(2351),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(2353),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2355),
  },
  [682] = {
    [sym_file_descriptor] = ACTIONS(1598),
    [sym__concat] = ACTIONS(1598),
    [anon_sym_PIPE] = ACTIONS(1600),
    [anon_sym_RPAREN] = ACTIONS(1600),
    [anon_sym_SEMI_SEMI] = ACTIONS(1600),
    [anon_sym_PIPE_AMP] = ACTIONS(1600),
    [anon_sym_AMP_AMP] = ACTIONS(1600),
    [anon_sym_PIPE_PIPE] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1600),
    [anon_sym_GT] = ACTIONS(1600),
    [anon_sym_GT_GT] = ACTIONS(1600),
    [anon_sym_AMP_GT] = ACTIONS(1600),
    [anon_sym_AMP_GT_GT] = ACTIONS(1600),
    [anon_sym_LT_AMP] = ACTIONS(1600),
    [anon_sym_GT_AMP] = ACTIONS(1600),
    [anon_sym_LT_LT] = ACTIONS(1600),
    [anon_sym_LT_LT_DASH] = ACTIONS(1600),
    [anon_sym_LT_LT_LT] = ACTIONS(1600),
    [sym__special_characters] = ACTIONS(1600),
    [anon_sym_DQUOTE] = ACTIONS(1600),
    [sym_raw_string] = ACTIONS(1600),
    [anon_sym_DOLLAR] = ACTIONS(1600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1600),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1600),
    [anon_sym_BQUOTE] = ACTIONS(1600),
    [anon_sym_LT_LPAREN] = ACTIONS(1600),
    [anon_sym_GT_LPAREN] = ACTIONS(1600),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1600),
    [anon_sym_SEMI] = ACTIONS(1600),
    [anon_sym_LF] = ACTIONS(1600),
    [anon_sym_AMP] = ACTIONS(1600),
  },
  [683] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(2357),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [684] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(2359),
    [sym_comment] = ACTIONS(52),
  },
  [685] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1202),
    [anon_sym_RBRACE] = ACTIONS(2361),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [686] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1204),
    [anon_sym_RBRACE] = ACTIONS(2363),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [687] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1205),
    [anon_sym_RBRACE] = ACTIONS(2349),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [688] = {
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1644),
    [anon_sym_LT_LT_DASH] = ACTIONS(1644),
    [anon_sym_LT_LT_LT] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1644),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1644),
    [anon_sym_BQUOTE] = ACTIONS(1644),
    [anon_sym_LT_LPAREN] = ACTIONS(1644),
    [anon_sym_GT_LPAREN] = ACTIONS(1644),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [689] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(2365),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [690] = {
    [sym_file_descriptor] = ACTIONS(1648),
    [sym__concat] = ACTIONS(1648),
    [anon_sym_PIPE] = ACTIONS(1650),
    [anon_sym_RPAREN] = ACTIONS(1650),
    [anon_sym_SEMI_SEMI] = ACTIONS(1650),
    [anon_sym_PIPE_AMP] = ACTIONS(1650),
    [anon_sym_AMP_AMP] = ACTIONS(1650),
    [anon_sym_PIPE_PIPE] = ACTIONS(1650),
    [anon_sym_LT] = ACTIONS(1650),
    [anon_sym_GT] = ACTIONS(1650),
    [anon_sym_GT_GT] = ACTIONS(1650),
    [anon_sym_AMP_GT] = ACTIONS(1650),
    [anon_sym_AMP_GT_GT] = ACTIONS(1650),
    [anon_sym_LT_AMP] = ACTIONS(1650),
    [anon_sym_GT_AMP] = ACTIONS(1650),
    [anon_sym_LT_LT] = ACTIONS(1650),
    [anon_sym_LT_LT_DASH] = ACTIONS(1650),
    [anon_sym_LT_LT_LT] = ACTIONS(1650),
    [sym__special_characters] = ACTIONS(1650),
    [anon_sym_DQUOTE] = ACTIONS(1650),
    [sym_raw_string] = ACTIONS(1650),
    [anon_sym_DOLLAR] = ACTIONS(1650),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1650),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1650),
    [anon_sym_BQUOTE] = ACTIONS(1650),
    [anon_sym_LT_LPAREN] = ACTIONS(1650),
    [anon_sym_GT_LPAREN] = ACTIONS(1650),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(1650),
    [anon_sym_LF] = ACTIONS(1650),
    [anon_sym_AMP] = ACTIONS(1650),
  },
  [691] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(2349),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [692] = {
    [sym_file_descriptor] = ACTIONS(1762),
    [sym__concat] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(1764),
    [anon_sym_RPAREN] = ACTIONS(1764),
    [anon_sym_SEMI_SEMI] = ACTIONS(1764),
    [anon_sym_PIPE_AMP] = ACTIONS(1764),
    [anon_sym_AMP_AMP] = ACTIONS(1764),
    [anon_sym_PIPE_PIPE] = ACTIONS(1764),
    [anon_sym_LT] = ACTIONS(1764),
    [anon_sym_GT] = ACTIONS(1764),
    [anon_sym_GT_GT] = ACTIONS(1764),
    [anon_sym_AMP_GT] = ACTIONS(1764),
    [anon_sym_AMP_GT_GT] = ACTIONS(1764),
    [anon_sym_LT_AMP] = ACTIONS(1764),
    [anon_sym_GT_AMP] = ACTIONS(1764),
    [anon_sym_LT_LT] = ACTIONS(1764),
    [anon_sym_LT_LT_DASH] = ACTIONS(1764),
    [anon_sym_LT_LT_LT] = ACTIONS(1764),
    [sym__special_characters] = ACTIONS(1764),
    [anon_sym_DQUOTE] = ACTIONS(1764),
    [sym_raw_string] = ACTIONS(1764),
    [anon_sym_DOLLAR] = ACTIONS(1764),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1764),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1764),
    [anon_sym_BQUOTE] = ACTIONS(1764),
    [anon_sym_LT_LPAREN] = ACTIONS(1764),
    [anon_sym_GT_LPAREN] = ACTIONS(1764),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1764),
    [anon_sym_SEMI] = ACTIONS(1764),
    [anon_sym_LF] = ACTIONS(1764),
    [anon_sym_AMP] = ACTIONS(1764),
  },
  [693] = {
    [sym_file_descriptor] = ACTIONS(1902),
    [sym__concat] = ACTIONS(1902),
    [anon_sym_PIPE] = ACTIONS(1904),
    [anon_sym_RPAREN] = ACTIONS(1904),
    [anon_sym_SEMI_SEMI] = ACTIONS(1904),
    [anon_sym_PIPE_AMP] = ACTIONS(1904),
    [anon_sym_AMP_AMP] = ACTIONS(1904),
    [anon_sym_PIPE_PIPE] = ACTIONS(1904),
    [anon_sym_LT] = ACTIONS(1904),
    [anon_sym_GT] = ACTIONS(1904),
    [anon_sym_GT_GT] = ACTIONS(1904),
    [anon_sym_AMP_GT] = ACTIONS(1904),
    [anon_sym_AMP_GT_GT] = ACTIONS(1904),
    [anon_sym_LT_AMP] = ACTIONS(1904),
    [anon_sym_GT_AMP] = ACTIONS(1904),
    [anon_sym_LT_LT] = ACTIONS(1904),
    [anon_sym_LT_LT_DASH] = ACTIONS(1904),
    [anon_sym_LT_LT_LT] = ACTIONS(1904),
    [sym__special_characters] = ACTIONS(1904),
    [anon_sym_DQUOTE] = ACTIONS(1904),
    [sym_raw_string] = ACTIONS(1904),
    [anon_sym_DOLLAR] = ACTIONS(1904),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1904),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1904),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [anon_sym_LT_LPAREN] = ACTIONS(1904),
    [anon_sym_GT_LPAREN] = ACTIONS(1904),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1904),
    [anon_sym_SEMI] = ACTIONS(1904),
    [anon_sym_LF] = ACTIONS(1904),
    [anon_sym_AMP] = ACTIONS(1904),
  },
  [694] = {
    [sym_compound_statement] = STATE(1207),
    [anon_sym_LBRACE] = ACTIONS(436),
    [sym_comment] = ACTIONS(52),
  },
  [695] = {
    [anon_sym_PIPE] = ACTIONS(2367),
    [anon_sym_RPAREN] = ACTIONS(2367),
    [anon_sym_SEMI_SEMI] = ACTIONS(2367),
    [anon_sym_PIPE_AMP] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2367),
    [anon_sym_PIPE_PIPE] = ACTIONS(2367),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2367),
    [anon_sym_LF] = ACTIONS(2367),
    [anon_sym_AMP] = ACTIONS(2367),
  },
  [696] = {
    [anon_sym_PIPE] = ACTIONS(482),
    [anon_sym_RPAREN] = ACTIONS(1908),
    [anon_sym_SEMI_SEMI] = ACTIONS(1908),
    [anon_sym_PIPE_AMP] = ACTIONS(482),
    [anon_sym_AMP_AMP] = ACTIONS(1908),
    [anon_sym_PIPE_PIPE] = ACTIONS(1908),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1908),
    [anon_sym_LF] = ACTIONS(1908),
    [anon_sym_AMP] = ACTIONS(1908),
  },
  [697] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(482),
    [anon_sym_RPAREN] = ACTIONS(1908),
    [anon_sym_SEMI_SEMI] = ACTIONS(1908),
    [anon_sym_PIPE_AMP] = ACTIONS(482),
    [anon_sym_AMP_AMP] = ACTIONS(1908),
    [anon_sym_PIPE_PIPE] = ACTIONS(1908),
    [anon_sym_LT] = ACTIONS(336),
    [anon_sym_GT] = ACTIONS(336),
    [anon_sym_GT_GT] = ACTIONS(336),
    [anon_sym_AMP_GT] = ACTIONS(336),
    [anon_sym_AMP_GT_GT] = ACTIONS(336),
    [anon_sym_LT_AMP] = ACTIONS(336),
    [anon_sym_GT_AMP] = ACTIONS(336),
    [sym__special_characters] = ACTIONS(336),
    [anon_sym_DQUOTE] = ACTIONS(336),
    [sym_raw_string] = ACTIONS(336),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(336),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(336),
    [anon_sym_BQUOTE] = ACTIONS(336),
    [anon_sym_LT_LPAREN] = ACTIONS(336),
    [anon_sym_GT_LPAREN] = ACTIONS(336),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(336),
    [anon_sym_SEMI] = ACTIONS(1908),
    [anon_sym_LF] = ACTIONS(1908),
    [anon_sym_AMP] = ACTIONS(1908),
  },
  [698] = {
    [sym_concatenation] = STATE(993),
    [sym_string] = STATE(1209),
    [sym_simple_expansion] = STATE(1209),
    [sym_expansion] = STATE(1209),
    [sym_command_substitution] = STATE(1209),
    [sym_process_substitution] = STATE(1209),
    [sym__special_characters] = ACTIONS(2369),
    [anon_sym_DQUOTE] = ACTIONS(1270),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(1274),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1276),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1278),
    [anon_sym_BQUOTE] = ACTIONS(1280),
    [anon_sym_LT_LPAREN] = ACTIONS(1282),
    [anon_sym_GT_LPAREN] = ACTIONS(1282),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2373),
  },
  [699] = {
    [aux_sym_concatenation_repeat1] = STATE(1211),
    [sym_file_descriptor] = ACTIONS(614),
    [sym__concat] = ACTIONS(2375),
    [anon_sym_PIPE] = ACTIONS(1918),
    [anon_sym_RPAREN] = ACTIONS(1918),
    [anon_sym_SEMI_SEMI] = ACTIONS(1918),
    [anon_sym_PIPE_AMP] = ACTIONS(1918),
    [anon_sym_AMP_AMP] = ACTIONS(1918),
    [anon_sym_PIPE_PIPE] = ACTIONS(1918),
    [anon_sym_LT] = ACTIONS(1918),
    [anon_sym_GT] = ACTIONS(1918),
    [anon_sym_GT_GT] = ACTIONS(1918),
    [anon_sym_AMP_GT] = ACTIONS(1918),
    [anon_sym_AMP_GT_GT] = ACTIONS(1918),
    [anon_sym_LT_AMP] = ACTIONS(1918),
    [anon_sym_GT_AMP] = ACTIONS(1918),
    [anon_sym_LT_LT] = ACTIONS(1918),
    [anon_sym_LT_LT_DASH] = ACTIONS(1918),
    [anon_sym_LT_LT_LT] = ACTIONS(1918),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1918),
    [anon_sym_LF] = ACTIONS(1918),
    [anon_sym_AMP] = ACTIONS(1918),
  },
  [700] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(1213),
    [anon_sym_DQUOTE] = ACTIONS(2377),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [701] = {
    [aux_sym_concatenation_repeat1] = STATE(1211),
    [sym_file_descriptor] = ACTIONS(622),
    [sym__concat] = ACTIONS(2375),
    [anon_sym_PIPE] = ACTIONS(1922),
    [anon_sym_RPAREN] = ACTIONS(1922),
    [anon_sym_SEMI_SEMI] = ACTIONS(1922),
    [anon_sym_PIPE_AMP] = ACTIONS(1922),
    [anon_sym_AMP_AMP] = ACTIONS(1922),
    [anon_sym_PIPE_PIPE] = ACTIONS(1922),
    [anon_sym_LT] = ACTIONS(1922),
    [anon_sym_GT] = ACTIONS(1922),
    [anon_sym_GT_GT] = ACTIONS(1922),
    [anon_sym_AMP_GT] = ACTIONS(1922),
    [anon_sym_AMP_GT_GT] = ACTIONS(1922),
    [anon_sym_LT_AMP] = ACTIONS(1922),
    [anon_sym_GT_AMP] = ACTIONS(1922),
    [anon_sym_LT_LT] = ACTIONS(1922),
    [anon_sym_LT_LT_DASH] = ACTIONS(1922),
    [anon_sym_LT_LT_LT] = ACTIONS(1922),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1922),
    [anon_sym_LF] = ACTIONS(1922),
    [anon_sym_AMP] = ACTIONS(1922),
  },
  [702] = {
    [sym_string] = STATE(1216),
    [anon_sym_DQUOTE] = ACTIONS(1270),
    [anon_sym_DOLLAR] = ACTIONS(2379),
    [anon_sym_POUND] = ACTIONS(2379),
    [anon_sym_DASH] = ACTIONS(2379),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2381),
    [anon_sym_STAR] = ACTIONS(2379),
    [anon_sym_AT] = ACTIONS(2379),
    [anon_sym_QMARK] = ACTIONS(2379),
    [anon_sym_0] = ACTIONS(2383),
    [anon_sym__] = ACTIONS(2383),
  },
  [703] = {
    [sym_subscript] = STATE(1221),
    [sym_variable_name] = ACTIONS(2385),
    [anon_sym_DOLLAR] = ACTIONS(2387),
    [anon_sym_POUND] = ACTIONS(2389),
    [anon_sym_DASH] = ACTIONS(2387),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2391),
    [anon_sym_STAR] = ACTIONS(2387),
    [anon_sym_AT] = ACTIONS(2387),
    [anon_sym_QMARK] = ACTIONS(2387),
    [anon_sym_0] = ACTIONS(2393),
    [anon_sym__] = ACTIONS(2393),
  },
  [704] = {
    [sym_for_statement] = STATE(1222),
    [sym_while_statement] = STATE(1222),
    [sym_if_statement] = STATE(1222),
    [sym_case_statement] = STATE(1222),
    [sym_function_definition] = STATE(1222),
    [sym_subshell] = STATE(1222),
    [sym_pipeline] = STATE(1222),
    [sym_list] = STATE(1222),
    [sym_bracket_command] = STATE(1222),
    [sym_command] = STATE(1222),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(1223),
    [sym_declaration_command] = STATE(1222),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [705] = {
    [sym_for_statement] = STATE(1224),
    [sym_while_statement] = STATE(1224),
    [sym_if_statement] = STATE(1224),
    [sym_case_statement] = STATE(1224),
    [sym_function_definition] = STATE(1224),
    [sym_subshell] = STATE(1224),
    [sym_pipeline] = STATE(1224),
    [sym_list] = STATE(1224),
    [sym_bracket_command] = STATE(1224),
    [sym_command] = STATE(1224),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(1225),
    [sym_declaration_command] = STATE(1224),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [706] = {
    [sym_for_statement] = STATE(1226),
    [sym_while_statement] = STATE(1226),
    [sym_if_statement] = STATE(1226),
    [sym_case_statement] = STATE(1226),
    [sym_function_definition] = STATE(1226),
    [sym_subshell] = STATE(1226),
    [sym_pipeline] = STATE(1226),
    [sym_list] = STATE(1226),
    [sym_bracket_command] = STATE(1226),
    [sym_command] = STATE(1226),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(1227),
    [sym_declaration_command] = STATE(1226),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [707] = {
    [aux_sym_concatenation_repeat1] = STATE(1211),
    [sym_file_descriptor] = ACTIONS(1956),
    [sym__concat] = ACTIONS(2375),
    [anon_sym_PIPE] = ACTIONS(1958),
    [anon_sym_RPAREN] = ACTIONS(1958),
    [anon_sym_SEMI_SEMI] = ACTIONS(1958),
    [anon_sym_PIPE_AMP] = ACTIONS(1958),
    [anon_sym_AMP_AMP] = ACTIONS(1958),
    [anon_sym_PIPE_PIPE] = ACTIONS(1958),
    [anon_sym_LT] = ACTIONS(1958),
    [anon_sym_GT] = ACTIONS(1958),
    [anon_sym_GT_GT] = ACTIONS(1958),
    [anon_sym_AMP_GT] = ACTIONS(1958),
    [anon_sym_AMP_GT_GT] = ACTIONS(1958),
    [anon_sym_LT_AMP] = ACTIONS(1958),
    [anon_sym_GT_AMP] = ACTIONS(1958),
    [anon_sym_LT_LT] = ACTIONS(1958),
    [anon_sym_LT_LT_DASH] = ACTIONS(1958),
    [anon_sym_LT_LT_LT] = ACTIONS(1958),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1958),
    [anon_sym_LF] = ACTIONS(1958),
    [anon_sym_AMP] = ACTIONS(1958),
  },
  [708] = {
    [aux_sym_concatenation_repeat1] = STATE(1211),
    [sym_file_descriptor] = ACTIONS(1960),
    [sym__concat] = ACTIONS(2375),
    [anon_sym_PIPE] = ACTIONS(1962),
    [anon_sym_RPAREN] = ACTIONS(1962),
    [anon_sym_SEMI_SEMI] = ACTIONS(1962),
    [anon_sym_PIPE_AMP] = ACTIONS(1962),
    [anon_sym_AMP_AMP] = ACTIONS(1962),
    [anon_sym_PIPE_PIPE] = ACTIONS(1962),
    [anon_sym_LT] = ACTIONS(1962),
    [anon_sym_GT] = ACTIONS(1962),
    [anon_sym_GT_GT] = ACTIONS(1962),
    [anon_sym_AMP_GT] = ACTIONS(1962),
    [anon_sym_AMP_GT_GT] = ACTIONS(1962),
    [anon_sym_LT_AMP] = ACTIONS(1962),
    [anon_sym_GT_AMP] = ACTIONS(1962),
    [anon_sym_LT_LT] = ACTIONS(1962),
    [anon_sym_LT_LT_DASH] = ACTIONS(1962),
    [anon_sym_LT_LT_LT] = ACTIONS(1962),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1962),
    [anon_sym_LF] = ACTIONS(1962),
    [anon_sym_AMP] = ACTIONS(1962),
  },
  [709] = {
    [sym_concatenation] = STATE(186),
    [sym_string] = STATE(287),
    [sym_simple_expansion] = STATE(287),
    [sym_expansion] = STATE(287),
    [sym_command_substitution] = STATE(287),
    [sym_process_substitution] = STATE(287),
    [aux_sym_for_statement_repeat1] = STATE(709),
    [sym_file_descriptor] = ACTIONS(1389),
    [anon_sym_PIPE] = ACTIONS(1964),
    [anon_sym_RPAREN] = ACTIONS(1964),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [anon_sym_LT] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1964),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT_GT] = ACTIONS(1964),
    [anon_sym_LT_AMP] = ACTIONS(1964),
    [anon_sym_GT_AMP] = ACTIONS(1964),
    [anon_sym_LT_LT] = ACTIONS(1964),
    [anon_sym_LT_LT_DASH] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(1964),
    [sym__special_characters] = ACTIONS(2395),
    [anon_sym_DQUOTE] = ACTIONS(2398),
    [sym_raw_string] = ACTIONS(2401),
    [anon_sym_DOLLAR] = ACTIONS(2404),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2410),
    [anon_sym_BQUOTE] = ACTIONS(2413),
    [anon_sym_LT_LPAREN] = ACTIONS(2416),
    [anon_sym_GT_LPAREN] = ACTIONS(2416),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2401),
    [anon_sym_SEMI] = ACTIONS(1964),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_AMP] = ACTIONS(1964),
  },
  [710] = {
    [sym_file_redirect] = STATE(185),
    [sym_heredoc_redirect] = STATE(185),
    [sym_herestring_redirect] = STATE(185),
    [aux_sym_while_statement_repeat1] = STATE(711),
    [sym_file_descriptor] = ACTIONS(490),
    [anon_sym_PIPE] = ACTIONS(1990),
    [anon_sym_RPAREN] = ACTIONS(1990),
    [anon_sym_SEMI_SEMI] = ACTIONS(1990),
    [anon_sym_PIPE_AMP] = ACTIONS(1990),
    [anon_sym_AMP_AMP] = ACTIONS(1990),
    [anon_sym_PIPE_PIPE] = ACTIONS(1990),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_GT] = ACTIONS(492),
    [anon_sym_GT_GT] = ACTIONS(492),
    [anon_sym_AMP_GT] = ACTIONS(492),
    [anon_sym_AMP_GT_GT] = ACTIONS(492),
    [anon_sym_LT_AMP] = ACTIONS(492),
    [anon_sym_GT_AMP] = ACTIONS(492),
    [anon_sym_LT_LT] = ACTIONS(314),
    [anon_sym_LT_LT_DASH] = ACTIONS(314),
    [anon_sym_LT_LT_LT] = ACTIONS(494),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1990),
    [anon_sym_LF] = ACTIONS(1990),
    [anon_sym_AMP] = ACTIONS(1990),
  },
  [711] = {
    [sym_file_redirect] = STATE(185),
    [sym_heredoc_redirect] = STATE(185),
    [sym_herestring_redirect] = STATE(185),
    [aux_sym_while_statement_repeat1] = STATE(711),
    [sym_file_descriptor] = ACTIONS(2419),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_SEMI_SEMI] = ACTIONS(1995),
    [anon_sym_PIPE_AMP] = ACTIONS(1995),
    [anon_sym_AMP_AMP] = ACTIONS(1995),
    [anon_sym_PIPE_PIPE] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(2422),
    [anon_sym_GT] = ACTIONS(2422),
    [anon_sym_GT_GT] = ACTIONS(2422),
    [anon_sym_AMP_GT] = ACTIONS(2422),
    [anon_sym_AMP_GT_GT] = ACTIONS(2422),
    [anon_sym_LT_AMP] = ACTIONS(2422),
    [anon_sym_GT_AMP] = ACTIONS(2422),
    [anon_sym_LT_LT] = ACTIONS(2000),
    [anon_sym_LT_LT_DASH] = ACTIONS(2000),
    [anon_sym_LT_LT_LT] = ACTIONS(2425),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1995),
    [anon_sym_LF] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
  },
  [712] = {
    [sym_file_descriptor] = ACTIONS(902),
    [sym_variable_name] = ACTIONS(902),
    [anon_sym_for] = ACTIONS(904),
    [anon_sym_while] = ACTIONS(904),
    [anon_sym_if] = ACTIONS(904),
    [anon_sym_case] = ACTIONS(904),
    [anon_sym_RPAREN] = ACTIONS(2428),
    [anon_sym_function] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(902),
    [anon_sym_LBRACK] = ACTIONS(904),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym_declare] = ACTIONS(904),
    [anon_sym_typeset] = ACTIONS(904),
    [anon_sym_export] = ACTIONS(904),
    [anon_sym_readonly] = ACTIONS(904),
    [anon_sym_local] = ACTIONS(904),
    [anon_sym_LT] = ACTIONS(904),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_GT_GT] = ACTIONS(902),
    [anon_sym_AMP_GT] = ACTIONS(904),
    [anon_sym_AMP_GT_GT] = ACTIONS(902),
    [anon_sym_LT_AMP] = ACTIONS(902),
    [anon_sym_GT_AMP] = ACTIONS(902),
    [sym__special_characters] = ACTIONS(906),
    [anon_sym_DQUOTE] = ACTIONS(902),
    [sym_raw_string] = ACTIONS(902),
    [anon_sym_DOLLAR] = ACTIONS(904),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(902),
    [anon_sym_BQUOTE] = ACTIONS(902),
    [anon_sym_LT_LPAREN] = ACTIONS(902),
    [anon_sym_GT_LPAREN] = ACTIONS(902),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(906),
  },
  [713] = {
    [sym_file_redirect] = STATE(185),
    [sym_heredoc_redirect] = STATE(185),
    [sym_herestring_redirect] = STATE(185),
    [sym_concatenation] = STATE(186),
    [sym_string] = STATE(287),
    [sym_simple_expansion] = STATE(287),
    [sym_expansion] = STATE(287),
    [sym_command_substitution] = STATE(287),
    [sym_process_substitution] = STATE(287),
    [aux_sym_for_statement_repeat1] = STATE(709),
    [aux_sym_while_statement_repeat1] = STATE(1229),
    [sym_file_descriptor] = ACTIONS(490),
    [anon_sym_PIPE] = ACTIONS(1990),
    [anon_sym_RPAREN] = ACTIONS(1990),
    [anon_sym_SEMI_SEMI] = ACTIONS(1990),
    [anon_sym_PIPE_AMP] = ACTIONS(1990),
    [anon_sym_AMP_AMP] = ACTIONS(1990),
    [anon_sym_PIPE_PIPE] = ACTIONS(1990),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_GT] = ACTIONS(492),
    [anon_sym_GT_GT] = ACTIONS(492),
    [anon_sym_AMP_GT] = ACTIONS(492),
    [anon_sym_AMP_GT_GT] = ACTIONS(492),
    [anon_sym_LT_AMP] = ACTIONS(492),
    [anon_sym_GT_AMP] = ACTIONS(492),
    [anon_sym_LT_LT] = ACTIONS(314),
    [anon_sym_LT_LT_DASH] = ACTIONS(314),
    [anon_sym_LT_LT_LT] = ACTIONS(494),
    [sym__special_characters] = ACTIONS(496),
    [anon_sym_DQUOTE] = ACTIONS(498),
    [sym_raw_string] = ACTIONS(500),
    [anon_sym_DOLLAR] = ACTIONS(502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(504),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(506),
    [anon_sym_BQUOTE] = ACTIONS(508),
    [anon_sym_LT_LPAREN] = ACTIONS(510),
    [anon_sym_GT_LPAREN] = ACTIONS(510),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(500),
    [anon_sym_SEMI] = ACTIONS(1990),
    [anon_sym_LF] = ACTIONS(1990),
    [anon_sym_AMP] = ACTIONS(1990),
  },
  [714] = {
    [sym__concat] = ACTIONS(1522),
    [anon_sym_RBRACK] = ACTIONS(2430),
    [sym__special_characters] = ACTIONS(1524),
    [anon_sym_DQUOTE] = ACTIONS(1522),
    [sym_raw_string] = ACTIONS(1522),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1522),
    [anon_sym_BQUOTE] = ACTIONS(1522),
    [anon_sym_LT_LPAREN] = ACTIONS(1522),
    [anon_sym_GT_LPAREN] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2430),
  },
  [715] = {
    [aux_sym_concatenation_repeat1] = STATE(715),
    [sym__concat] = ACTIONS(2432),
    [anon_sym_RBRACK] = ACTIONS(2430),
    [sym__special_characters] = ACTIONS(1524),
    [anon_sym_DQUOTE] = ACTIONS(1522),
    [sym_raw_string] = ACTIONS(1522),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1522),
    [anon_sym_BQUOTE] = ACTIONS(1522),
    [anon_sym_LT_LPAREN] = ACTIONS(1522),
    [anon_sym_GT_LPAREN] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2430),
  },
  [716] = {
    [sym__concat] = ACTIONS(1553),
    [anon_sym_RBRACK] = ACTIONS(2435),
    [sym__special_characters] = ACTIONS(1555),
    [anon_sym_DQUOTE] = ACTIONS(1553),
    [sym_raw_string] = ACTIONS(1553),
    [anon_sym_DOLLAR] = ACTIONS(2435),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1553),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1553),
    [anon_sym_BQUOTE] = ACTIONS(1553),
    [anon_sym_LT_LPAREN] = ACTIONS(1553),
    [anon_sym_GT_LPAREN] = ACTIONS(1553),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2435),
  },
  [717] = {
    [sym_concatenation] = STATE(1233),
    [sym_string] = STATE(1232),
    [sym_simple_expansion] = STATE(1232),
    [sym_expansion] = STATE(1232),
    [sym_command_substitution] = STATE(1232),
    [sym_process_substitution] = STATE(1232),
    [anon_sym_RBRACE] = ACTIONS(2437),
    [sym__special_characters] = ACTIONS(2439),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(2441),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2443),
  },
  [718] = {
    [sym__concat] = ACTIONS(1598),
    [anon_sym_RBRACK] = ACTIONS(2445),
    [sym__special_characters] = ACTIONS(1600),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [sym_raw_string] = ACTIONS(1598),
    [anon_sym_DOLLAR] = ACTIONS(2445),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1598),
    [anon_sym_BQUOTE] = ACTIONS(1598),
    [anon_sym_LT_LPAREN] = ACTIONS(1598),
    [anon_sym_GT_LPAREN] = ACTIONS(1598),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2445),
  },
  [719] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(2447),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [720] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(2449),
    [sym_comment] = ACTIONS(52),
  },
  [721] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1237),
    [anon_sym_RBRACE] = ACTIONS(2451),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [722] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1239),
    [anon_sym_RBRACE] = ACTIONS(2453),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [723] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1240),
    [anon_sym_RBRACE] = ACTIONS(2437),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [724] = {
    [sym__concat] = ACTIONS(1642),
    [anon_sym_RBRACK] = ACTIONS(2455),
    [sym__special_characters] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [sym_raw_string] = ACTIONS(1642),
    [anon_sym_DOLLAR] = ACTIONS(2455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [anon_sym_LT_LPAREN] = ACTIONS(1642),
    [anon_sym_GT_LPAREN] = ACTIONS(1642),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2455),
  },
  [725] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(2457),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [726] = {
    [sym__concat] = ACTIONS(1648),
    [anon_sym_RBRACK] = ACTIONS(2459),
    [sym__special_characters] = ACTIONS(1650),
    [anon_sym_DQUOTE] = ACTIONS(1648),
    [sym_raw_string] = ACTIONS(1648),
    [anon_sym_DOLLAR] = ACTIONS(2459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1648),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1648),
    [anon_sym_BQUOTE] = ACTIONS(1648),
    [anon_sym_LT_LPAREN] = ACTIONS(1648),
    [anon_sym_GT_LPAREN] = ACTIONS(1648),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2459),
  },
  [727] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(2437),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [728] = {
    [sym__concat] = ACTIONS(1762),
    [anon_sym_RBRACK] = ACTIONS(2461),
    [sym__special_characters] = ACTIONS(1764),
    [anon_sym_DQUOTE] = ACTIONS(1762),
    [sym_raw_string] = ACTIONS(1762),
    [anon_sym_DOLLAR] = ACTIONS(2461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1762),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1762),
    [anon_sym_BQUOTE] = ACTIONS(1762),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2461),
  },
  [729] = {
    [sym__concat] = ACTIONS(1902),
    [anon_sym_RBRACK] = ACTIONS(2463),
    [sym__special_characters] = ACTIONS(1904),
    [anon_sym_DQUOTE] = ACTIONS(1902),
    [sym_raw_string] = ACTIONS(1902),
    [anon_sym_DOLLAR] = ACTIONS(2463),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1902),
    [anon_sym_BQUOTE] = ACTIONS(1902),
    [anon_sym_LT_LPAREN] = ACTIONS(1902),
    [anon_sym_GT_LPAREN] = ACTIONS(1902),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2463),
  },
  [730] = {
    [sym__concat] = ACTIONS(1522),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1522),
    [sym__special_characters] = ACTIONS(1524),
    [anon_sym_DQUOTE] = ACTIONS(1522),
    [sym_raw_string] = ACTIONS(1522),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1522),
    [anon_sym_BQUOTE] = ACTIONS(1522),
    [anon_sym_LT_LPAREN] = ACTIONS(1522),
    [anon_sym_GT_LPAREN] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2430),
  },
  [731] = {
    [aux_sym_concatenation_repeat1] = STATE(731),
    [sym__concat] = ACTIONS(2465),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1522),
    [sym__special_characters] = ACTIONS(1524),
    [anon_sym_DQUOTE] = ACTIONS(1522),
    [sym_raw_string] = ACTIONS(1522),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1522),
    [anon_sym_BQUOTE] = ACTIONS(1522),
    [anon_sym_LT_LPAREN] = ACTIONS(1522),
    [anon_sym_GT_LPAREN] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2430),
  },
  [732] = {
    [sym__concat] = ACTIONS(1553),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1553),
    [sym__special_characters] = ACTIONS(1555),
    [anon_sym_DQUOTE] = ACTIONS(1553),
    [sym_raw_string] = ACTIONS(1553),
    [anon_sym_DOLLAR] = ACTIONS(2435),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1553),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1553),
    [anon_sym_BQUOTE] = ACTIONS(1553),
    [anon_sym_LT_LPAREN] = ACTIONS(1553),
    [anon_sym_GT_LPAREN] = ACTIONS(1553),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2435),
  },
  [733] = {
    [sym_concatenation] = STATE(1245),
    [sym_string] = STATE(1244),
    [sym_simple_expansion] = STATE(1244),
    [sym_expansion] = STATE(1244),
    [sym_command_substitution] = STATE(1244),
    [sym_process_substitution] = STATE(1244),
    [anon_sym_RBRACE] = ACTIONS(2468),
    [sym__special_characters] = ACTIONS(2470),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(2472),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2474),
  },
  [734] = {
    [sym__concat] = ACTIONS(1598),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1598),
    [sym__special_characters] = ACTIONS(1600),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [sym_raw_string] = ACTIONS(1598),
    [anon_sym_DOLLAR] = ACTIONS(2445),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1598),
    [anon_sym_BQUOTE] = ACTIONS(1598),
    [anon_sym_LT_LPAREN] = ACTIONS(1598),
    [anon_sym_GT_LPAREN] = ACTIONS(1598),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2445),
  },
  [735] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(2476),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [736] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(2478),
    [sym_comment] = ACTIONS(52),
  },
  [737] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1249),
    [anon_sym_RBRACE] = ACTIONS(2480),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [738] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1251),
    [anon_sym_RBRACE] = ACTIONS(2482),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [739] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1252),
    [anon_sym_RBRACE] = ACTIONS(2468),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [740] = {
    [sym__concat] = ACTIONS(1642),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1642),
    [sym__special_characters] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [sym_raw_string] = ACTIONS(1642),
    [anon_sym_DOLLAR] = ACTIONS(2455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [anon_sym_LT_LPAREN] = ACTIONS(1642),
    [anon_sym_GT_LPAREN] = ACTIONS(1642),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2455),
  },
  [741] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(2484),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [742] = {
    [sym__concat] = ACTIONS(1648),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1648),
    [sym__special_characters] = ACTIONS(1650),
    [anon_sym_DQUOTE] = ACTIONS(1648),
    [sym_raw_string] = ACTIONS(1648),
    [anon_sym_DOLLAR] = ACTIONS(2459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1648),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1648),
    [anon_sym_BQUOTE] = ACTIONS(1648),
    [anon_sym_LT_LPAREN] = ACTIONS(1648),
    [anon_sym_GT_LPAREN] = ACTIONS(1648),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2459),
  },
  [743] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(2468),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [744] = {
    [sym__concat] = ACTIONS(1762),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1762),
    [sym__special_characters] = ACTIONS(1764),
    [anon_sym_DQUOTE] = ACTIONS(1762),
    [sym_raw_string] = ACTIONS(1762),
    [anon_sym_DOLLAR] = ACTIONS(2461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1762),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1762),
    [anon_sym_BQUOTE] = ACTIONS(1762),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2461),
  },
  [745] = {
    [sym__concat] = ACTIONS(1902),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1902),
    [sym__special_characters] = ACTIONS(1904),
    [anon_sym_DQUOTE] = ACTIONS(1902),
    [sym_raw_string] = ACTIONS(1902),
    [anon_sym_DOLLAR] = ACTIONS(2463),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1902),
    [anon_sym_BQUOTE] = ACTIONS(1902),
    [anon_sym_LT_LPAREN] = ACTIONS(1902),
    [anon_sym_GT_LPAREN] = ACTIONS(1902),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2463),
  },
  [746] = {
    [sym_variable_name] = ACTIONS(1068),
    [anon_sym_PIPE] = ACTIONS(1070),
    [anon_sym_RPAREN] = ACTIONS(1070),
    [anon_sym_SEMI_SEMI] = ACTIONS(1070),
    [anon_sym_PIPE_AMP] = ACTIONS(1070),
    [anon_sym_AMP_AMP] = ACTIONS(1070),
    [anon_sym_PIPE_PIPE] = ACTIONS(1070),
    [sym__special_characters] = ACTIONS(1070),
    [anon_sym_DQUOTE] = ACTIONS(1070),
    [sym_raw_string] = ACTIONS(1070),
    [anon_sym_DOLLAR] = ACTIONS(1070),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1070),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1070),
    [anon_sym_BQUOTE] = ACTIONS(1070),
    [anon_sym_LT_LPAREN] = ACTIONS(1070),
    [anon_sym_GT_LPAREN] = ACTIONS(1070),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1070),
    [sym_word] = ACTIONS(1070),
    [anon_sym_SEMI] = ACTIONS(1070),
    [anon_sym_LF] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(1070),
  },
  [747] = {
    [sym_concatenation] = STATE(572),
    [sym_string] = STATE(566),
    [sym_simple_expansion] = STATE(566),
    [sym_expansion] = STATE(566),
    [sym_command_substitution] = STATE(566),
    [sym_process_substitution] = STATE(566),
    [aux_sym_for_statement_repeat1] = STATE(1255),
    [anon_sym_RPAREN] = ACTIONS(2486),
    [sym__special_characters] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1076),
    [sym_raw_string] = ACTIONS(1078),
    [anon_sym_DOLLAR] = ACTIONS(1080),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1084),
    [anon_sym_BQUOTE] = ACTIONS(1086),
    [anon_sym_LT_LPAREN] = ACTIONS(1088),
    [anon_sym_GT_LPAREN] = ACTIONS(1088),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1090),
  },
  [748] = {
    [aux_sym_concatenation_repeat1] = STATE(336),
    [sym__concat] = ACTIONS(578),
    [sym_variable_name] = ACTIONS(1092),
    [anon_sym_PIPE] = ACTIONS(1096),
    [anon_sym_SEMI_SEMI] = ACTIONS(1096),
    [anon_sym_PIPE_AMP] = ACTIONS(1096),
    [anon_sym_AMP_AMP] = ACTIONS(1096),
    [anon_sym_PIPE_PIPE] = ACTIONS(1096),
    [sym__special_characters] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1096),
    [sym_raw_string] = ACTIONS(1096),
    [anon_sym_DOLLAR] = ACTIONS(1096),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1096),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1096),
    [anon_sym_BQUOTE] = ACTIONS(1096),
    [anon_sym_LT_LPAREN] = ACTIONS(1096),
    [anon_sym_GT_LPAREN] = ACTIONS(1096),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1096),
    [sym_word] = ACTIONS(1096),
    [anon_sym_SEMI] = ACTIONS(1096),
    [anon_sym_LF] = ACTIONS(1096),
    [anon_sym_AMP] = ACTIONS(1096),
  },
  [749] = {
    [aux_sym_concatenation_repeat1] = STATE(336),
    [sym__concat] = ACTIONS(578),
    [sym_variable_name] = ACTIONS(1068),
    [anon_sym_PIPE] = ACTIONS(1070),
    [anon_sym_SEMI_SEMI] = ACTIONS(1070),
    [anon_sym_PIPE_AMP] = ACTIONS(1070),
    [anon_sym_AMP_AMP] = ACTIONS(1070),
    [anon_sym_PIPE_PIPE] = ACTIONS(1070),
    [sym__special_characters] = ACTIONS(1070),
    [anon_sym_DQUOTE] = ACTIONS(1070),
    [sym_raw_string] = ACTIONS(1070),
    [anon_sym_DOLLAR] = ACTIONS(1070),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1070),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1070),
    [anon_sym_BQUOTE] = ACTIONS(1070),
    [anon_sym_LT_LPAREN] = ACTIONS(1070),
    [anon_sym_GT_LPAREN] = ACTIONS(1070),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1070),
    [sym_word] = ACTIONS(1070),
    [anon_sym_SEMI] = ACTIONS(1070),
    [anon_sym_LF] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(1070),
  },
  [750] = {
    [sym__concat] = ACTIONS(1522),
    [sym_variable_name] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(1524),
    [anon_sym_SEMI_SEMI] = ACTIONS(1524),
    [anon_sym_PIPE_AMP] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1524),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [sym__special_characters] = ACTIONS(1524),
    [anon_sym_DQUOTE] = ACTIONS(1524),
    [sym_raw_string] = ACTIONS(1524),
    [anon_sym_DOLLAR] = ACTIONS(1524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1524),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1524),
    [anon_sym_BQUOTE] = ACTIONS(1524),
    [anon_sym_LT_LPAREN] = ACTIONS(1524),
    [anon_sym_GT_LPAREN] = ACTIONS(1524),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1524),
    [sym_word] = ACTIONS(1524),
    [anon_sym_SEMI] = ACTIONS(1524),
    [anon_sym_LF] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1524),
  },
  [751] = {
    [aux_sym_concatenation_repeat1] = STATE(751),
    [sym__concat] = ACTIONS(2488),
    [sym_variable_name] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(1524),
    [anon_sym_SEMI_SEMI] = ACTIONS(1524),
    [anon_sym_PIPE_AMP] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1524),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [sym__special_characters] = ACTIONS(1524),
    [anon_sym_DQUOTE] = ACTIONS(1524),
    [sym_raw_string] = ACTIONS(1524),
    [anon_sym_DOLLAR] = ACTIONS(1524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1524),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1524),
    [anon_sym_BQUOTE] = ACTIONS(1524),
    [anon_sym_LT_LPAREN] = ACTIONS(1524),
    [anon_sym_GT_LPAREN] = ACTIONS(1524),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1524),
    [sym_word] = ACTIONS(1524),
    [anon_sym_SEMI] = ACTIONS(1524),
    [anon_sym_LF] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1524),
  },
  [752] = {
    [sym__concat] = ACTIONS(1553),
    [sym_variable_name] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(1555),
    [anon_sym_SEMI_SEMI] = ACTIONS(1555),
    [anon_sym_PIPE_AMP] = ACTIONS(1555),
    [anon_sym_AMP_AMP] = ACTIONS(1555),
    [anon_sym_PIPE_PIPE] = ACTIONS(1555),
    [sym__special_characters] = ACTIONS(1555),
    [anon_sym_DQUOTE] = ACTIONS(1555),
    [sym_raw_string] = ACTIONS(1555),
    [anon_sym_DOLLAR] = ACTIONS(1555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1555),
    [anon_sym_BQUOTE] = ACTIONS(1555),
    [anon_sym_LT_LPAREN] = ACTIONS(1555),
    [anon_sym_GT_LPAREN] = ACTIONS(1555),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1555),
    [sym_word] = ACTIONS(1555),
    [anon_sym_SEMI] = ACTIONS(1555),
    [anon_sym_LF] = ACTIONS(1555),
    [anon_sym_AMP] = ACTIONS(1555),
  },
  [753] = {
    [sym_concatenation] = STATE(1259),
    [sym_string] = STATE(1258),
    [sym_simple_expansion] = STATE(1258),
    [sym_expansion] = STATE(1258),
    [sym_command_substitution] = STATE(1258),
    [sym_process_substitution] = STATE(1258),
    [anon_sym_RBRACE] = ACTIONS(2491),
    [sym__special_characters] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(2495),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2497),
  },
  [754] = {
    [sym__concat] = ACTIONS(1598),
    [sym_variable_name] = ACTIONS(1598),
    [anon_sym_PIPE] = ACTIONS(1600),
    [anon_sym_SEMI_SEMI] = ACTIONS(1600),
    [anon_sym_PIPE_AMP] = ACTIONS(1600),
    [anon_sym_AMP_AMP] = ACTIONS(1600),
    [anon_sym_PIPE_PIPE] = ACTIONS(1600),
    [sym__special_characters] = ACTIONS(1600),
    [anon_sym_DQUOTE] = ACTIONS(1600),
    [sym_raw_string] = ACTIONS(1600),
    [anon_sym_DOLLAR] = ACTIONS(1600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1600),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1600),
    [anon_sym_BQUOTE] = ACTIONS(1600),
    [anon_sym_LT_LPAREN] = ACTIONS(1600),
    [anon_sym_GT_LPAREN] = ACTIONS(1600),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1600),
    [sym_word] = ACTIONS(1600),
    [anon_sym_SEMI] = ACTIONS(1600),
    [anon_sym_LF] = ACTIONS(1600),
    [anon_sym_AMP] = ACTIONS(1600),
  },
  [755] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(2499),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [756] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(2501),
    [sym_comment] = ACTIONS(52),
  },
  [757] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1263),
    [anon_sym_RBRACE] = ACTIONS(2503),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [758] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1265),
    [anon_sym_RBRACE] = ACTIONS(2505),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [759] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1266),
    [anon_sym_RBRACE] = ACTIONS(2491),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [760] = {
    [sym__concat] = ACTIONS(1642),
    [sym_variable_name] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1644),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1644),
    [anon_sym_BQUOTE] = ACTIONS(1644),
    [anon_sym_LT_LPAREN] = ACTIONS(1644),
    [anon_sym_GT_LPAREN] = ACTIONS(1644),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1644),
    [sym_word] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [761] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(2507),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [762] = {
    [sym__concat] = ACTIONS(1648),
    [sym_variable_name] = ACTIONS(1648),
    [anon_sym_PIPE] = ACTIONS(1650),
    [anon_sym_SEMI_SEMI] = ACTIONS(1650),
    [anon_sym_PIPE_AMP] = ACTIONS(1650),
    [anon_sym_AMP_AMP] = ACTIONS(1650),
    [anon_sym_PIPE_PIPE] = ACTIONS(1650),
    [sym__special_characters] = ACTIONS(1650),
    [anon_sym_DQUOTE] = ACTIONS(1650),
    [sym_raw_string] = ACTIONS(1650),
    [anon_sym_DOLLAR] = ACTIONS(1650),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1650),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1650),
    [anon_sym_BQUOTE] = ACTIONS(1650),
    [anon_sym_LT_LPAREN] = ACTIONS(1650),
    [anon_sym_GT_LPAREN] = ACTIONS(1650),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1650),
    [sym_word] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(1650),
    [anon_sym_LF] = ACTIONS(1650),
    [anon_sym_AMP] = ACTIONS(1650),
  },
  [763] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(2491),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [764] = {
    [sym__concat] = ACTIONS(1762),
    [sym_variable_name] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(1764),
    [anon_sym_SEMI_SEMI] = ACTIONS(1764),
    [anon_sym_PIPE_AMP] = ACTIONS(1764),
    [anon_sym_AMP_AMP] = ACTIONS(1764),
    [anon_sym_PIPE_PIPE] = ACTIONS(1764),
    [sym__special_characters] = ACTIONS(1764),
    [anon_sym_DQUOTE] = ACTIONS(1764),
    [sym_raw_string] = ACTIONS(1764),
    [anon_sym_DOLLAR] = ACTIONS(1764),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1764),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1764),
    [anon_sym_BQUOTE] = ACTIONS(1764),
    [anon_sym_LT_LPAREN] = ACTIONS(1764),
    [anon_sym_GT_LPAREN] = ACTIONS(1764),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1764),
    [sym_word] = ACTIONS(1764),
    [anon_sym_SEMI] = ACTIONS(1764),
    [anon_sym_LF] = ACTIONS(1764),
    [anon_sym_AMP] = ACTIONS(1764),
  },
  [765] = {
    [sym__concat] = ACTIONS(1902),
    [sym_variable_name] = ACTIONS(1902),
    [anon_sym_PIPE] = ACTIONS(1904),
    [anon_sym_SEMI_SEMI] = ACTIONS(1904),
    [anon_sym_PIPE_AMP] = ACTIONS(1904),
    [anon_sym_AMP_AMP] = ACTIONS(1904),
    [anon_sym_PIPE_PIPE] = ACTIONS(1904),
    [sym__special_characters] = ACTIONS(1904),
    [anon_sym_DQUOTE] = ACTIONS(1904),
    [sym_raw_string] = ACTIONS(1904),
    [anon_sym_DOLLAR] = ACTIONS(1904),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1904),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1904),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [anon_sym_LT_LPAREN] = ACTIONS(1904),
    [anon_sym_GT_LPAREN] = ACTIONS(1904),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1904),
    [sym_word] = ACTIONS(1904),
    [anon_sym_SEMI] = ACTIONS(1904),
    [anon_sym_LF] = ACTIONS(1904),
    [anon_sym_AMP] = ACTIONS(1904),
  },
  [766] = {
    [sym_file_descriptor] = ACTIONS(1522),
    [sym__concat] = ACTIONS(1522),
    [sym_variable_name] = ACTIONS(1522),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_GT_GT] = ACTIONS(1522),
    [anon_sym_AMP_GT] = ACTIONS(2430),
    [anon_sym_AMP_GT_GT] = ACTIONS(1522),
    [anon_sym_LT_AMP] = ACTIONS(1522),
    [anon_sym_GT_AMP] = ACTIONS(1522),
    [sym__special_characters] = ACTIONS(2430),
    [anon_sym_DQUOTE] = ACTIONS(1522),
    [sym_raw_string] = ACTIONS(1522),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1522),
    [anon_sym_BQUOTE] = ACTIONS(1522),
    [anon_sym_LT_LPAREN] = ACTIONS(1522),
    [anon_sym_GT_LPAREN] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2430),
  },
  [767] = {
    [aux_sym_concatenation_repeat1] = STATE(767),
    [sym_file_descriptor] = ACTIONS(1522),
    [sym__concat] = ACTIONS(2509),
    [sym_variable_name] = ACTIONS(1522),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_GT_GT] = ACTIONS(1522),
    [anon_sym_AMP_GT] = ACTIONS(2430),
    [anon_sym_AMP_GT_GT] = ACTIONS(1522),
    [anon_sym_LT_AMP] = ACTIONS(1522),
    [anon_sym_GT_AMP] = ACTIONS(1522),
    [sym__special_characters] = ACTIONS(2430),
    [anon_sym_DQUOTE] = ACTIONS(1522),
    [sym_raw_string] = ACTIONS(1522),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1522),
    [anon_sym_BQUOTE] = ACTIONS(1522),
    [anon_sym_LT_LPAREN] = ACTIONS(1522),
    [anon_sym_GT_LPAREN] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2430),
  },
  [768] = {
    [sym_file_descriptor] = ACTIONS(1553),
    [sym__concat] = ACTIONS(1553),
    [sym_variable_name] = ACTIONS(1553),
    [anon_sym_LT] = ACTIONS(2435),
    [anon_sym_GT] = ACTIONS(2435),
    [anon_sym_GT_GT] = ACTIONS(1553),
    [anon_sym_AMP_GT] = ACTIONS(2435),
    [anon_sym_AMP_GT_GT] = ACTIONS(1553),
    [anon_sym_LT_AMP] = ACTIONS(1553),
    [anon_sym_GT_AMP] = ACTIONS(1553),
    [sym__special_characters] = ACTIONS(2435),
    [anon_sym_DQUOTE] = ACTIONS(1553),
    [sym_raw_string] = ACTIONS(1553),
    [anon_sym_DOLLAR] = ACTIONS(2435),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1553),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1553),
    [anon_sym_BQUOTE] = ACTIONS(1553),
    [anon_sym_LT_LPAREN] = ACTIONS(1553),
    [anon_sym_GT_LPAREN] = ACTIONS(1553),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2435),
  },
  [769] = {
    [sym_concatenation] = STATE(1271),
    [sym_string] = STATE(1270),
    [sym_simple_expansion] = STATE(1270),
    [sym_expansion] = STATE(1270),
    [sym_command_substitution] = STATE(1270),
    [sym_process_substitution] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(2512),
    [sym__special_characters] = ACTIONS(2514),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(2516),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2518),
  },
  [770] = {
    [sym_file_descriptor] = ACTIONS(1598),
    [sym__concat] = ACTIONS(1598),
    [sym_variable_name] = ACTIONS(1598),
    [anon_sym_LT] = ACTIONS(2445),
    [anon_sym_GT] = ACTIONS(2445),
    [anon_sym_GT_GT] = ACTIONS(1598),
    [anon_sym_AMP_GT] = ACTIONS(2445),
    [anon_sym_AMP_GT_GT] = ACTIONS(1598),
    [anon_sym_LT_AMP] = ACTIONS(1598),
    [anon_sym_GT_AMP] = ACTIONS(1598),
    [sym__special_characters] = ACTIONS(2445),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [sym_raw_string] = ACTIONS(1598),
    [anon_sym_DOLLAR] = ACTIONS(2445),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1598),
    [anon_sym_BQUOTE] = ACTIONS(1598),
    [anon_sym_LT_LPAREN] = ACTIONS(1598),
    [anon_sym_GT_LPAREN] = ACTIONS(1598),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2445),
  },
  [771] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(2520),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [772] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(2522),
    [sym_comment] = ACTIONS(52),
  },
  [773] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1275),
    [anon_sym_RBRACE] = ACTIONS(2524),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [774] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1277),
    [anon_sym_RBRACE] = ACTIONS(2526),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [775] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1278),
    [anon_sym_RBRACE] = ACTIONS(2512),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [776] = {
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(1642),
    [sym_variable_name] = ACTIONS(1642),
    [anon_sym_LT] = ACTIONS(2455),
    [anon_sym_GT] = ACTIONS(2455),
    [anon_sym_GT_GT] = ACTIONS(1642),
    [anon_sym_AMP_GT] = ACTIONS(2455),
    [anon_sym_AMP_GT_GT] = ACTIONS(1642),
    [anon_sym_LT_AMP] = ACTIONS(1642),
    [anon_sym_GT_AMP] = ACTIONS(1642),
    [sym__special_characters] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [sym_raw_string] = ACTIONS(1642),
    [anon_sym_DOLLAR] = ACTIONS(2455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [anon_sym_LT_LPAREN] = ACTIONS(1642),
    [anon_sym_GT_LPAREN] = ACTIONS(1642),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2455),
  },
  [777] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(2528),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [778] = {
    [sym_file_descriptor] = ACTIONS(1648),
    [sym__concat] = ACTIONS(1648),
    [sym_variable_name] = ACTIONS(1648),
    [anon_sym_LT] = ACTIONS(2459),
    [anon_sym_GT] = ACTIONS(2459),
    [anon_sym_GT_GT] = ACTIONS(1648),
    [anon_sym_AMP_GT] = ACTIONS(2459),
    [anon_sym_AMP_GT_GT] = ACTIONS(1648),
    [anon_sym_LT_AMP] = ACTIONS(1648),
    [anon_sym_GT_AMP] = ACTIONS(1648),
    [sym__special_characters] = ACTIONS(2459),
    [anon_sym_DQUOTE] = ACTIONS(1648),
    [sym_raw_string] = ACTIONS(1648),
    [anon_sym_DOLLAR] = ACTIONS(2459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1648),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1648),
    [anon_sym_BQUOTE] = ACTIONS(1648),
    [anon_sym_LT_LPAREN] = ACTIONS(1648),
    [anon_sym_GT_LPAREN] = ACTIONS(1648),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2459),
  },
  [779] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(2512),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [780] = {
    [sym_file_descriptor] = ACTIONS(1762),
    [sym__concat] = ACTIONS(1762),
    [sym_variable_name] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(2461),
    [anon_sym_GT] = ACTIONS(2461),
    [anon_sym_GT_GT] = ACTIONS(1762),
    [anon_sym_AMP_GT] = ACTIONS(2461),
    [anon_sym_AMP_GT_GT] = ACTIONS(1762),
    [anon_sym_LT_AMP] = ACTIONS(1762),
    [anon_sym_GT_AMP] = ACTIONS(1762),
    [sym__special_characters] = ACTIONS(2461),
    [anon_sym_DQUOTE] = ACTIONS(1762),
    [sym_raw_string] = ACTIONS(1762),
    [anon_sym_DOLLAR] = ACTIONS(2461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1762),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1762),
    [anon_sym_BQUOTE] = ACTIONS(1762),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2461),
  },
  [781] = {
    [sym_file_descriptor] = ACTIONS(1902),
    [sym__concat] = ACTIONS(1902),
    [sym_variable_name] = ACTIONS(1902),
    [anon_sym_LT] = ACTIONS(2463),
    [anon_sym_GT] = ACTIONS(2463),
    [anon_sym_GT_GT] = ACTIONS(1902),
    [anon_sym_AMP_GT] = ACTIONS(2463),
    [anon_sym_AMP_GT_GT] = ACTIONS(1902),
    [anon_sym_LT_AMP] = ACTIONS(1902),
    [anon_sym_GT_AMP] = ACTIONS(1902),
    [sym__special_characters] = ACTIONS(2463),
    [anon_sym_DQUOTE] = ACTIONS(1902),
    [sym_raw_string] = ACTIONS(1902),
    [anon_sym_DOLLAR] = ACTIONS(2463),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1902),
    [anon_sym_BQUOTE] = ACTIONS(1902),
    [anon_sym_LT_LPAREN] = ACTIONS(1902),
    [anon_sym_GT_LPAREN] = ACTIONS(1902),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2463),
  },
  [782] = {
    [sym__concat] = ACTIONS(650),
    [anon_sym_DQUOTE] = ACTIONS(652),
    [sym__string_content] = ACTIONS(1302),
    [anon_sym_DOLLAR] = ACTIONS(652),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(652),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(652),
    [anon_sym_BQUOTE] = ACTIONS(652),
    [sym_comment] = ACTIONS(168),
  },
  [783] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(2530),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [784] = {
    [sym_concatenation] = STATE(1284),
    [sym_string] = STATE(1283),
    [sym_simple_expansion] = STATE(1283),
    [sym_expansion] = STATE(1283),
    [sym_command_substitution] = STATE(1283),
    [sym_process_substitution] = STATE(1283),
    [anon_sym_RBRACE] = ACTIONS(2532),
    [sym__special_characters] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(2536),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2538),
  },
  [785] = {
    [sym__concat] = ACTIONS(1598),
    [anon_sym_DQUOTE] = ACTIONS(1600),
    [sym__string_content] = ACTIONS(2445),
    [anon_sym_DOLLAR] = ACTIONS(1600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1600),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1600),
    [anon_sym_BQUOTE] = ACTIONS(1600),
    [sym_comment] = ACTIONS(168),
  },
  [786] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(2540),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [787] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(2542),
    [sym_comment] = ACTIONS(52),
  },
  [788] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1288),
    [anon_sym_RBRACE] = ACTIONS(2544),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [789] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1290),
    [anon_sym_RBRACE] = ACTIONS(2546),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [790] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1291),
    [anon_sym_RBRACE] = ACTIONS(2532),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [791] = {
    [sym__concat] = ACTIONS(1642),
    [anon_sym_DQUOTE] = ACTIONS(1644),
    [sym__string_content] = ACTIONS(2455),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1644),
    [anon_sym_BQUOTE] = ACTIONS(1644),
    [sym_comment] = ACTIONS(168),
  },
  [792] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(2548),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [793] = {
    [sym__concat] = ACTIONS(1648),
    [anon_sym_DQUOTE] = ACTIONS(1650),
    [sym__string_content] = ACTIONS(2459),
    [anon_sym_DOLLAR] = ACTIONS(1650),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1650),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1650),
    [anon_sym_BQUOTE] = ACTIONS(1650),
    [sym_comment] = ACTIONS(168),
  },
  [794] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(2532),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [795] = {
    [sym__concat] = ACTIONS(1762),
    [anon_sym_DQUOTE] = ACTIONS(1764),
    [sym__string_content] = ACTIONS(2461),
    [anon_sym_DOLLAR] = ACTIONS(1764),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1764),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1764),
    [anon_sym_BQUOTE] = ACTIONS(1764),
    [sym_comment] = ACTIONS(168),
  },
  [796] = {
    [aux_sym_concatenation_repeat1] = STATE(543),
    [sym__concat] = ACTIONS(2550),
    [anon_sym_RBRACK] = ACTIONS(2552),
    [sym_comment] = ACTIONS(52),
  },
  [797] = {
    [aux_sym_concatenation_repeat1] = STATE(543),
    [sym__concat] = ACTIONS(2554),
    [anon_sym_RBRACK] = ACTIONS(2556),
    [sym_comment] = ACTIONS(52),
  },
  [798] = {
    [sym__concat] = ACTIONS(2558),
    [anon_sym_RBRACK] = ACTIONS(2556),
    [sym_comment] = ACTIONS(52),
  },
  [799] = {
    [sym_file_descriptor] = ACTIONS(2560),
    [sym__concat] = ACTIONS(2560),
    [anon_sym_PIPE] = ACTIONS(2562),
    [anon_sym_SEMI_SEMI] = ACTIONS(2562),
    [anon_sym_PIPE_AMP] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_PIPE_PIPE] = ACTIONS(2562),
    [anon_sym_LT] = ACTIONS(2562),
    [anon_sym_GT] = ACTIONS(2562),
    [anon_sym_GT_GT] = ACTIONS(2562),
    [anon_sym_AMP_GT] = ACTIONS(2562),
    [anon_sym_AMP_GT_GT] = ACTIONS(2562),
    [anon_sym_LT_AMP] = ACTIONS(2562),
    [anon_sym_GT_AMP] = ACTIONS(2562),
    [anon_sym_LT_LT] = ACTIONS(2562),
    [anon_sym_LT_LT_DASH] = ACTIONS(2562),
    [anon_sym_LT_LT_LT] = ACTIONS(2562),
    [sym__special_characters] = ACTIONS(2562),
    [anon_sym_DQUOTE] = ACTIONS(2562),
    [sym_raw_string] = ACTIONS(2562),
    [anon_sym_DOLLAR] = ACTIONS(2562),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2562),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2562),
    [anon_sym_BQUOTE] = ACTIONS(2562),
    [anon_sym_LT_LPAREN] = ACTIONS(2562),
    [anon_sym_GT_LPAREN] = ACTIONS(2562),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2562),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym_LF] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(2562),
  },
  [800] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(2566),
    [sym_comment] = ACTIONS(52),
  },
  [801] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(1302),
    [anon_sym_DQUOTE] = ACTIONS(2568),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [802] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(2570),
    [sym_comment] = ACTIONS(52),
  },
  [803] = {
    [sym_string] = STATE(1306),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [anon_sym_DOLLAR] = ACTIONS(2572),
    [anon_sym_POUND] = ACTIONS(2572),
    [anon_sym_DASH] = ACTIONS(2572),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2574),
    [anon_sym_STAR] = ACTIONS(2572),
    [anon_sym_AT] = ACTIONS(2572),
    [anon_sym_QMARK] = ACTIONS(2572),
    [anon_sym_0] = ACTIONS(2576),
    [anon_sym__] = ACTIONS(2576),
  },
  [804] = {
    [sym_subscript] = STATE(1311),
    [sym_variable_name] = ACTIONS(2578),
    [anon_sym_DOLLAR] = ACTIONS(2580),
    [anon_sym_POUND] = ACTIONS(2582),
    [anon_sym_DASH] = ACTIONS(2580),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2584),
    [anon_sym_STAR] = ACTIONS(2580),
    [anon_sym_AT] = ACTIONS(2580),
    [anon_sym_QMARK] = ACTIONS(2580),
    [anon_sym_0] = ACTIONS(2586),
    [anon_sym__] = ACTIONS(2586),
  },
  [805] = {
    [sym_for_statement] = STATE(1312),
    [sym_while_statement] = STATE(1312),
    [sym_if_statement] = STATE(1312),
    [sym_case_statement] = STATE(1312),
    [sym_function_definition] = STATE(1312),
    [sym_subshell] = STATE(1312),
    [sym_pipeline] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_bracket_command] = STATE(1312),
    [sym_command] = STATE(1312),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(1313),
    [sym_declaration_command] = STATE(1312),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [806] = {
    [sym_for_statement] = STATE(1314),
    [sym_while_statement] = STATE(1314),
    [sym_if_statement] = STATE(1314),
    [sym_case_statement] = STATE(1314),
    [sym_function_definition] = STATE(1314),
    [sym_subshell] = STATE(1314),
    [sym_pipeline] = STATE(1314),
    [sym_list] = STATE(1314),
    [sym_bracket_command] = STATE(1314),
    [sym_command] = STATE(1314),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(1315),
    [sym_declaration_command] = STATE(1314),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [807] = {
    [sym_for_statement] = STATE(1316),
    [sym_while_statement] = STATE(1316),
    [sym_if_statement] = STATE(1316),
    [sym_case_statement] = STATE(1316),
    [sym_function_definition] = STATE(1316),
    [sym_subshell] = STATE(1316),
    [sym_pipeline] = STATE(1316),
    [sym_list] = STATE(1316),
    [sym_bracket_command] = STATE(1316),
    [sym_command] = STATE(1316),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(1317),
    [sym_declaration_command] = STATE(1316),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [808] = {
    [anon_sym_RBRACE] = ACTIONS(2570),
    [sym_comment] = ACTIONS(52),
  },
  [809] = {
    [sym_string] = STATE(1318),
    [sym_simple_expansion] = STATE(1318),
    [sym_expansion] = STATE(1318),
    [sym_command_substitution] = STATE(1318),
    [sym_process_substitution] = STATE(1318),
    [sym__special_characters] = ACTIONS(2588),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(2590),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2588),
  },
  [810] = {
    [aux_sym_concatenation_repeat1] = STATE(1319),
    [sym__concat] = ACTIONS(1608),
    [anon_sym_RBRACE] = ACTIONS(646),
    [anon_sym_EQ] = ACTIONS(1300),
    [sym__special_characters] = ACTIONS(648),
    [anon_sym_DQUOTE] = ACTIONS(646),
    [sym_raw_string] = ACTIONS(646),
    [anon_sym_DOLLAR] = ACTIONS(1300),
    [anon_sym_POUND] = ACTIONS(646),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(646),
    [anon_sym_COLON] = ACTIONS(1300),
    [anon_sym_COLON_QMARK] = ACTIONS(1300),
    [anon_sym_COLON_DASH] = ACTIONS(1300),
    [anon_sym_PERCENT] = ACTIONS(1300),
    [anon_sym_SLASH] = ACTIONS(1300),
    [anon_sym_DASH] = ACTIONS(1300),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(646),
    [anon_sym_BQUOTE] = ACTIONS(646),
    [anon_sym_LT_LPAREN] = ACTIONS(646),
    [anon_sym_GT_LPAREN] = ACTIONS(646),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(648),
  },
  [811] = {
    [sym__concat] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(1302),
    [sym__special_characters] = ACTIONS(652),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [sym_raw_string] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(1302),
    [anon_sym_POUND] = ACTIONS(650),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(1302),
    [anon_sym_COLON_QMARK] = ACTIONS(1302),
    [anon_sym_COLON_DASH] = ACTIONS(1302),
    [anon_sym_PERCENT] = ACTIONS(1302),
    [anon_sym_SLASH] = ACTIONS(1302),
    [anon_sym_DASH] = ACTIONS(1302),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LT_LPAREN] = ACTIONS(650),
    [anon_sym_GT_LPAREN] = ACTIONS(650),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(652),
  },
  [812] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(2592),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [813] = {
    [sym__concat] = ACTIONS(680),
    [anon_sym_RBRACE] = ACTIONS(680),
    [anon_sym_EQ] = ACTIONS(1306),
    [sym__special_characters] = ACTIONS(682),
    [anon_sym_DQUOTE] = ACTIONS(680),
    [sym_raw_string] = ACTIONS(680),
    [anon_sym_DOLLAR] = ACTIONS(1306),
    [anon_sym_POUND] = ACTIONS(680),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(680),
    [anon_sym_COLON] = ACTIONS(1306),
    [anon_sym_COLON_QMARK] = ACTIONS(1306),
    [anon_sym_COLON_DASH] = ACTIONS(1306),
    [anon_sym_PERCENT] = ACTIONS(1306),
    [anon_sym_SLASH] = ACTIONS(1306),
    [anon_sym_DASH] = ACTIONS(1306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(680),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [anon_sym_LT_LPAREN] = ACTIONS(680),
    [anon_sym_GT_LPAREN] = ACTIONS(680),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(682),
  },
  [814] = {
    [sym__concat] = ACTIONS(684),
    [anon_sym_RBRACE] = ACTIONS(684),
    [anon_sym_EQ] = ACTIONS(1308),
    [sym__special_characters] = ACTIONS(686),
    [anon_sym_DQUOTE] = ACTIONS(684),
    [sym_raw_string] = ACTIONS(684),
    [anon_sym_DOLLAR] = ACTIONS(1308),
    [anon_sym_POUND] = ACTIONS(684),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(684),
    [anon_sym_COLON] = ACTIONS(1308),
    [anon_sym_COLON_QMARK] = ACTIONS(1308),
    [anon_sym_COLON_DASH] = ACTIONS(1308),
    [anon_sym_PERCENT] = ACTIONS(1308),
    [anon_sym_SLASH] = ACTIONS(1308),
    [anon_sym_DASH] = ACTIONS(1308),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(684),
    [anon_sym_BQUOTE] = ACTIONS(684),
    [anon_sym_LT_LPAREN] = ACTIONS(684),
    [anon_sym_GT_LPAREN] = ACTIONS(684),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(686),
  },
  [815] = {
    [sym__concat] = ACTIONS(688),
    [anon_sym_RBRACE] = ACTIONS(688),
    [anon_sym_EQ] = ACTIONS(1310),
    [sym__special_characters] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(688),
    [sym_raw_string] = ACTIONS(688),
    [anon_sym_DOLLAR] = ACTIONS(1310),
    [anon_sym_POUND] = ACTIONS(688),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(688),
    [anon_sym_COLON] = ACTIONS(1310),
    [anon_sym_COLON_QMARK] = ACTIONS(1310),
    [anon_sym_COLON_DASH] = ACTIONS(1310),
    [anon_sym_PERCENT] = ACTIONS(1310),
    [anon_sym_SLASH] = ACTIONS(1310),
    [anon_sym_DASH] = ACTIONS(1310),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(688),
    [anon_sym_BQUOTE] = ACTIONS(688),
    [anon_sym_LT_LPAREN] = ACTIONS(688),
    [anon_sym_GT_LPAREN] = ACTIONS(688),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(690),
  },
  [816] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(2594),
    [sym_comment] = ACTIONS(52),
  },
  [817] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1323),
    [anon_sym_RBRACE] = ACTIONS(2596),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [818] = {
    [sym_subscript] = STATE(1327),
    [sym_variable_name] = ACTIONS(2598),
    [anon_sym_DOLLAR] = ACTIONS(2600),
    [anon_sym_DASH] = ACTIONS(2600),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2602),
    [anon_sym_STAR] = ACTIONS(2600),
    [anon_sym_AT] = ACTIONS(2600),
    [anon_sym_QMARK] = ACTIONS(2600),
    [anon_sym_0] = ACTIONS(2604),
    [anon_sym__] = ACTIONS(2604),
  },
  [819] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1329),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [820] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1331),
    [anon_sym_RBRACE] = ACTIONS(2608),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [821] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(2610),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [822] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(2610),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [823] = {
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(52),
  },
  [824] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(2610),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [825] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(2612),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [826] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(2612),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [827] = {
    [sym_file_descriptor] = ACTIONS(2614),
    [sym__concat] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2616),
    [anon_sym_SEMI_SEMI] = ACTIONS(2616),
    [anon_sym_PIPE_AMP] = ACTIONS(2616),
    [anon_sym_AMP_AMP] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2616),
    [anon_sym_LT] = ACTIONS(2616),
    [anon_sym_GT] = ACTIONS(2616),
    [anon_sym_GT_GT] = ACTIONS(2616),
    [anon_sym_AMP_GT] = ACTIONS(2616),
    [anon_sym_AMP_GT_GT] = ACTIONS(2616),
    [anon_sym_LT_AMP] = ACTIONS(2616),
    [anon_sym_GT_AMP] = ACTIONS(2616),
    [anon_sym_LT_LT] = ACTIONS(2616),
    [anon_sym_LT_LT_DASH] = ACTIONS(2616),
    [anon_sym_LT_LT_LT] = ACTIONS(2616),
    [sym__special_characters] = ACTIONS(2616),
    [anon_sym_DQUOTE] = ACTIONS(2616),
    [sym_raw_string] = ACTIONS(2616),
    [anon_sym_DOLLAR] = ACTIONS(2616),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2616),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2616),
    [anon_sym_BQUOTE] = ACTIONS(2616),
    [anon_sym_LT_LPAREN] = ACTIONS(2616),
    [anon_sym_GT_LPAREN] = ACTIONS(2616),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2616),
    [anon_sym_LF] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2616),
  },
  [828] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(2618),
    [anon_sym_EQ] = ACTIONS(2620),
    [sym__special_characters] = ACTIONS(2623),
    [anon_sym_DQUOTE] = ACTIONS(2626),
    [sym_raw_string] = ACTIONS(2629),
    [anon_sym_DOLLAR] = ACTIONS(2632),
    [anon_sym_POUND] = ACTIONS(2635),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2638),
    [anon_sym_COLON] = ACTIONS(2620),
    [anon_sym_COLON_QMARK] = ACTIONS(2620),
    [anon_sym_COLON_DASH] = ACTIONS(2620),
    [anon_sym_PERCENT] = ACTIONS(2620),
    [anon_sym_SLASH] = ACTIONS(2620),
    [anon_sym_DASH] = ACTIONS(2620),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2641),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [anon_sym_LT_LPAREN] = ACTIONS(2647),
    [anon_sym_GT_LPAREN] = ACTIONS(2647),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2650),
  },
  [829] = {
    [sym_concatenation] = STATE(1336),
    [sym_string] = STATE(1335),
    [sym_simple_expansion] = STATE(1335),
    [sym_expansion] = STATE(1335),
    [sym_command_substitution] = STATE(1335),
    [sym_process_substitution] = STATE(1335),
    [anon_sym_RBRACE] = ACTIONS(2570),
    [sym__special_characters] = ACTIONS(2653),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(2655),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2657),
  },
  [830] = {
    [sym_file_descriptor] = ACTIONS(2659),
    [sym__concat] = ACTIONS(2659),
    [anon_sym_PIPE] = ACTIONS(2661),
    [anon_sym_SEMI_SEMI] = ACTIONS(2661),
    [anon_sym_PIPE_AMP] = ACTIONS(2661),
    [anon_sym_AMP_AMP] = ACTIONS(2661),
    [anon_sym_PIPE_PIPE] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(2661),
    [anon_sym_GT] = ACTIONS(2661),
    [anon_sym_GT_GT] = ACTIONS(2661),
    [anon_sym_AMP_GT] = ACTIONS(2661),
    [anon_sym_AMP_GT_GT] = ACTIONS(2661),
    [anon_sym_LT_AMP] = ACTIONS(2661),
    [anon_sym_GT_AMP] = ACTIONS(2661),
    [anon_sym_LT_LT] = ACTIONS(2661),
    [anon_sym_LT_LT_DASH] = ACTIONS(2661),
    [anon_sym_LT_LT_LT] = ACTIONS(2661),
    [sym__special_characters] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2661),
    [sym_raw_string] = ACTIONS(2661),
    [anon_sym_DOLLAR] = ACTIONS(2661),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2661),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2661),
    [anon_sym_BQUOTE] = ACTIONS(2661),
    [anon_sym_LT_LPAREN] = ACTIONS(2661),
    [anon_sym_GT_LPAREN] = ACTIONS(2661),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2661),
    [anon_sym_SEMI] = ACTIONS(2661),
    [anon_sym_LF] = ACTIONS(2661),
    [anon_sym_AMP] = ACTIONS(2661),
  },
  [831] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(2663),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [832] = {
    [sym_file_descriptor] = ACTIONS(2665),
    [sym__concat] = ACTIONS(2665),
    [anon_sym_PIPE] = ACTIONS(2667),
    [anon_sym_SEMI_SEMI] = ACTIONS(2667),
    [anon_sym_PIPE_AMP] = ACTIONS(2667),
    [anon_sym_AMP_AMP] = ACTIONS(2667),
    [anon_sym_PIPE_PIPE] = ACTIONS(2667),
    [anon_sym_LT] = ACTIONS(2667),
    [anon_sym_GT] = ACTIONS(2667),
    [anon_sym_GT_GT] = ACTIONS(2667),
    [anon_sym_AMP_GT] = ACTIONS(2667),
    [anon_sym_AMP_GT_GT] = ACTIONS(2667),
    [anon_sym_LT_AMP] = ACTIONS(2667),
    [anon_sym_GT_AMP] = ACTIONS(2667),
    [anon_sym_LT_LT] = ACTIONS(2667),
    [anon_sym_LT_LT_DASH] = ACTIONS(2667),
    [anon_sym_LT_LT_LT] = ACTIONS(2667),
    [sym__special_characters] = ACTIONS(2667),
    [anon_sym_DQUOTE] = ACTIONS(2667),
    [sym_raw_string] = ACTIONS(2667),
    [anon_sym_DOLLAR] = ACTIONS(2667),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2667),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2667),
    [anon_sym_BQUOTE] = ACTIONS(2667),
    [anon_sym_LT_LPAREN] = ACTIONS(2667),
    [anon_sym_GT_LPAREN] = ACTIONS(2667),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2667),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym_LF] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(2667),
  },
  [833] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(2669),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [834] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(2570),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [835] = {
    [sym_file_descriptor] = ACTIONS(2671),
    [sym__concat] = ACTIONS(2671),
    [anon_sym_PIPE] = ACTIONS(2673),
    [anon_sym_SEMI_SEMI] = ACTIONS(2673),
    [anon_sym_PIPE_AMP] = ACTIONS(2673),
    [anon_sym_AMP_AMP] = ACTIONS(2673),
    [anon_sym_PIPE_PIPE] = ACTIONS(2673),
    [anon_sym_LT] = ACTIONS(2673),
    [anon_sym_GT] = ACTIONS(2673),
    [anon_sym_GT_GT] = ACTIONS(2673),
    [anon_sym_AMP_GT] = ACTIONS(2673),
    [anon_sym_AMP_GT_GT] = ACTIONS(2673),
    [anon_sym_LT_AMP] = ACTIONS(2673),
    [anon_sym_GT_AMP] = ACTIONS(2673),
    [anon_sym_LT_LT] = ACTIONS(2673),
    [anon_sym_LT_LT_DASH] = ACTIONS(2673),
    [anon_sym_LT_LT_LT] = ACTIONS(2673),
    [sym__special_characters] = ACTIONS(2673),
    [anon_sym_DQUOTE] = ACTIONS(2673),
    [sym_raw_string] = ACTIONS(2673),
    [anon_sym_DOLLAR] = ACTIONS(2673),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2673),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2673),
    [anon_sym_BQUOTE] = ACTIONS(2673),
    [anon_sym_LT_LPAREN] = ACTIONS(2673),
    [anon_sym_GT_LPAREN] = ACTIONS(2673),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2673),
    [anon_sym_SEMI] = ACTIONS(2673),
    [anon_sym_LF] = ACTIONS(2673),
    [anon_sym_AMP] = ACTIONS(2673),
  },
  [836] = {
    [sym_file_descriptor] = ACTIONS(1068),
    [sym_variable_name] = ACTIONS(1068),
    [anon_sym_PIPE] = ACTIONS(2675),
    [anon_sym_RPAREN] = ACTIONS(1068),
    [anon_sym_PIPE_AMP] = ACTIONS(1068),
    [anon_sym_AMP_AMP] = ACTIONS(1068),
    [anon_sym_PIPE_PIPE] = ACTIONS(1068),
    [anon_sym_LT] = ACTIONS(2675),
    [anon_sym_GT] = ACTIONS(2675),
    [anon_sym_GT_GT] = ACTIONS(1068),
    [anon_sym_AMP_GT] = ACTIONS(2675),
    [anon_sym_AMP_GT_GT] = ACTIONS(1068),
    [anon_sym_LT_AMP] = ACTIONS(1068),
    [anon_sym_GT_AMP] = ACTIONS(1068),
    [sym__special_characters] = ACTIONS(2675),
    [anon_sym_DQUOTE] = ACTIONS(1068),
    [sym_raw_string] = ACTIONS(1068),
    [anon_sym_DOLLAR] = ACTIONS(2675),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1068),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1068),
    [anon_sym_BQUOTE] = ACTIONS(1068),
    [anon_sym_LT_LPAREN] = ACTIONS(1068),
    [anon_sym_GT_LPAREN] = ACTIONS(1068),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2675),
  },
  [837] = {
    [sym_concatenation] = STATE(572),
    [sym_string] = STATE(566),
    [sym_simple_expansion] = STATE(566),
    [sym_expansion] = STATE(566),
    [sym_command_substitution] = STATE(566),
    [sym_process_substitution] = STATE(566),
    [aux_sym_for_statement_repeat1] = STATE(1340),
    [anon_sym_RPAREN] = ACTIONS(2677),
    [sym__special_characters] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1076),
    [sym_raw_string] = ACTIONS(1078),
    [anon_sym_DOLLAR] = ACTIONS(1080),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1084),
    [anon_sym_BQUOTE] = ACTIONS(1086),
    [anon_sym_LT_LPAREN] = ACTIONS(1088),
    [anon_sym_GT_LPAREN] = ACTIONS(1088),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1090),
  },
  [838] = {
    [aux_sym_concatenation_repeat1] = STATE(1342),
    [sym_file_descriptor] = ACTIONS(1092),
    [sym__concat] = ACTIONS(2679),
    [sym_variable_name] = ACTIONS(1092),
    [anon_sym_PIPE] = ACTIONS(2681),
    [anon_sym_RPAREN] = ACTIONS(1092),
    [anon_sym_PIPE_AMP] = ACTIONS(1092),
    [anon_sym_AMP_AMP] = ACTIONS(1092),
    [anon_sym_PIPE_PIPE] = ACTIONS(1092),
    [anon_sym_LT] = ACTIONS(2681),
    [anon_sym_GT] = ACTIONS(2681),
    [anon_sym_GT_GT] = ACTIONS(1092),
    [anon_sym_AMP_GT] = ACTIONS(2681),
    [anon_sym_AMP_GT_GT] = ACTIONS(1092),
    [anon_sym_LT_AMP] = ACTIONS(1092),
    [anon_sym_GT_AMP] = ACTIONS(1092),
    [sym__special_characters] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(1092),
    [sym_raw_string] = ACTIONS(1092),
    [anon_sym_DOLLAR] = ACTIONS(2681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1092),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1092),
    [anon_sym_BQUOTE] = ACTIONS(1092),
    [anon_sym_LT_LPAREN] = ACTIONS(1092),
    [anon_sym_GT_LPAREN] = ACTIONS(1092),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2681),
  },
  [839] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(1344),
    [anon_sym_DQUOTE] = ACTIONS(2683),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [840] = {
    [aux_sym_concatenation_repeat1] = STATE(1342),
    [sym_file_descriptor] = ACTIONS(1068),
    [sym__concat] = ACTIONS(2679),
    [sym_variable_name] = ACTIONS(1068),
    [anon_sym_PIPE] = ACTIONS(2675),
    [anon_sym_RPAREN] = ACTIONS(1068),
    [anon_sym_PIPE_AMP] = ACTIONS(1068),
    [anon_sym_AMP_AMP] = ACTIONS(1068),
    [anon_sym_PIPE_PIPE] = ACTIONS(1068),
    [anon_sym_LT] = ACTIONS(2675),
    [anon_sym_GT] = ACTIONS(2675),
    [anon_sym_GT_GT] = ACTIONS(1068),
    [anon_sym_AMP_GT] = ACTIONS(2675),
    [anon_sym_AMP_GT_GT] = ACTIONS(1068),
    [anon_sym_LT_AMP] = ACTIONS(1068),
    [anon_sym_GT_AMP] = ACTIONS(1068),
    [sym__special_characters] = ACTIONS(2675),
    [anon_sym_DQUOTE] = ACTIONS(1068),
    [sym_raw_string] = ACTIONS(1068),
    [anon_sym_DOLLAR] = ACTIONS(2675),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1068),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1068),
    [anon_sym_BQUOTE] = ACTIONS(1068),
    [anon_sym_LT_LPAREN] = ACTIONS(1068),
    [anon_sym_GT_LPAREN] = ACTIONS(1068),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2675),
  },
  [841] = {
    [sym_string] = STATE(1347),
    [anon_sym_DQUOTE] = ACTIONS(1658),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_POUND] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2687),
    [anon_sym_STAR] = ACTIONS(2685),
    [anon_sym_AT] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_0] = ACTIONS(2689),
    [anon_sym__] = ACTIONS(2689),
  },
  [842] = {
    [sym_subscript] = STATE(1352),
    [sym_variable_name] = ACTIONS(2691),
    [anon_sym_DOLLAR] = ACTIONS(2693),
    [anon_sym_POUND] = ACTIONS(2695),
    [anon_sym_DASH] = ACTIONS(2693),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2697),
    [anon_sym_STAR] = ACTIONS(2693),
    [anon_sym_AT] = ACTIONS(2693),
    [anon_sym_QMARK] = ACTIONS(2693),
    [anon_sym_0] = ACTIONS(2699),
    [anon_sym__] = ACTIONS(2699),
  },
  [843] = {
    [sym_for_statement] = STATE(1353),
    [sym_while_statement] = STATE(1353),
    [sym_if_statement] = STATE(1353),
    [sym_case_statement] = STATE(1353),
    [sym_function_definition] = STATE(1353),
    [sym_subshell] = STATE(1353),
    [sym_pipeline] = STATE(1353),
    [sym_list] = STATE(1353),
    [sym_bracket_command] = STATE(1353),
    [sym_command] = STATE(1353),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(1354),
    [sym_declaration_command] = STATE(1353),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [844] = {
    [sym_for_statement] = STATE(1355),
    [sym_while_statement] = STATE(1355),
    [sym_if_statement] = STATE(1355),
    [sym_case_statement] = STATE(1355),
    [sym_function_definition] = STATE(1355),
    [sym_subshell] = STATE(1355),
    [sym_pipeline] = STATE(1355),
    [sym_list] = STATE(1355),
    [sym_bracket_command] = STATE(1355),
    [sym_command] = STATE(1355),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(1356),
    [sym_declaration_command] = STATE(1355),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [845] = {
    [sym_for_statement] = STATE(1357),
    [sym_while_statement] = STATE(1357),
    [sym_if_statement] = STATE(1357),
    [sym_case_statement] = STATE(1357),
    [sym_function_definition] = STATE(1357),
    [sym_subshell] = STATE(1357),
    [sym_pipeline] = STATE(1357),
    [sym_list] = STATE(1357),
    [sym_bracket_command] = STATE(1357),
    [sym_command] = STATE(1357),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(1358),
    [sym_declaration_command] = STATE(1357),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [846] = {
    [sym_concatenation] = STATE(600),
    [sym_string] = STATE(594),
    [sym_simple_expansion] = STATE(594),
    [sym_expansion] = STATE(594),
    [sym_command_substitution] = STATE(594),
    [sym_process_substitution] = STATE(594),
    [aux_sym_for_statement_repeat1] = STATE(1359),
    [sym__special_characters] = ACTIONS(1116),
    [anon_sym_DQUOTE] = ACTIONS(1118),
    [sym_raw_string] = ACTIONS(1120),
    [anon_sym_DOLLAR] = ACTIONS(1122),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1124),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1126),
    [anon_sym_BQUOTE] = ACTIONS(1128),
    [anon_sym_LT_LPAREN] = ACTIONS(1130),
    [anon_sym_GT_LPAREN] = ACTIONS(1130),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1132),
  },
  [847] = {
    [sym__terminated_statement] = STATE(603),
    [sym_for_statement] = STATE(604),
    [sym_while_statement] = STATE(604),
    [sym_if_statement] = STATE(604),
    [sym_case_statement] = STATE(604),
    [sym_function_definition] = STATE(604),
    [sym_subshell] = STATE(604),
    [sym_pipeline] = STATE(604),
    [sym_list] = STATE(604),
    [sym_bracket_command] = STATE(604),
    [sym_command] = STATE(604),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(605),
    [sym_declaration_command] = STATE(604),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(1361),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_done] = ACTIONS(2701),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [848] = {
    [sym_file_redirect] = STATE(466),
    [sym_heredoc_redirect] = STATE(466),
    [sym_herestring_redirect] = STATE(466),
    [aux_sym_while_statement_repeat1] = STATE(1362),
    [sym_file_descriptor] = ACTIONS(804),
    [anon_sym_PIPE] = ACTIONS(2703),
    [anon_sym_RPAREN] = ACTIONS(2705),
    [anon_sym_PIPE_AMP] = ACTIONS(2705),
    [anon_sym_AMP_AMP] = ACTIONS(2705),
    [anon_sym_PIPE_PIPE] = ACTIONS(2705),
    [anon_sym_LT] = ACTIONS(810),
    [anon_sym_GT] = ACTIONS(810),
    [anon_sym_GT_GT] = ACTIONS(812),
    [anon_sym_AMP_GT] = ACTIONS(810),
    [anon_sym_AMP_GT_GT] = ACTIONS(812),
    [anon_sym_LT_AMP] = ACTIONS(812),
    [anon_sym_GT_AMP] = ACTIONS(812),
    [anon_sym_LT_LT] = ACTIONS(814),
    [anon_sym_LT_LT_DASH] = ACTIONS(816),
    [anon_sym_LT_LT_LT] = ACTIONS(818),
    [sym_comment] = ACTIONS(52),
  },
  [849] = {
    [sym__terminated_statement] = STATE(611),
    [sym_for_statement] = STATE(612),
    [sym_while_statement] = STATE(612),
    [sym_if_statement] = STATE(612),
    [sym_elif_clause] = STATE(613),
    [sym_else_clause] = STATE(1364),
    [sym_case_statement] = STATE(612),
    [sym_function_definition] = STATE(612),
    [sym_subshell] = STATE(612),
    [sym_pipeline] = STATE(612),
    [sym_list] = STATE(612),
    [sym_bracket_command] = STATE(612),
    [sym_command] = STATE(612),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(615),
    [sym_declaration_command] = STATE(612),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(1365),
    [aux_sym_if_statement_repeat1] = STATE(1366),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_fi] = ACTIONS(2707),
    [anon_sym_elif] = ACTIONS(1140),
    [anon_sym_else] = ACTIONS(1142),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [850] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(2709),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2709),
    [anon_sym_LF] = ACTIONS(2709),
    [anon_sym_AMP] = ACTIONS(2709),
  },
  [851] = {
    [anon_sym_in] = ACTIONS(2711),
    [sym_comment] = ACTIONS(52),
  },
  [852] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(2713),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2713),
    [anon_sym_LF] = ACTIONS(2713),
    [anon_sym_AMP] = ACTIONS(2713),
  },
  [853] = {
    [anon_sym_in] = ACTIONS(2715),
    [sym_comment] = ACTIONS(52),
  },
  [854] = {
    [anon_sym_RPAREN] = ACTIONS(2717),
    [sym_comment] = ACTIONS(52),
  },
  [855] = {
    [sym__terminated_statement] = STATE(640),
    [sym_for_statement] = STATE(641),
    [sym_while_statement] = STATE(641),
    [sym_if_statement] = STATE(641),
    [sym_case_statement] = STATE(641),
    [sym_function_definition] = STATE(641),
    [sym_subshell] = STATE(641),
    [sym_pipeline] = STATE(641),
    [sym_list] = STATE(641),
    [sym_bracket_command] = STATE(641),
    [sym_command] = STATE(641),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(642),
    [sym_declaration_command] = STATE(641),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(1373),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_RBRACE] = ACTIONS(2719),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [856] = {
    [sym_file_redirect] = STATE(1376),
    [sym_file_descriptor] = ACTIONS(2721),
    [anon_sym_PIPE] = ACTIONS(2723),
    [anon_sym_RPAREN] = ACTIONS(2725),
    [anon_sym_PIPE_AMP] = ACTIONS(2725),
    [anon_sym_AMP_AMP] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2727),
    [anon_sym_GT] = ACTIONS(2727),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_AMP_GT] = ACTIONS(2727),
    [anon_sym_AMP_GT_GT] = ACTIONS(2729),
    [anon_sym_LT_AMP] = ACTIONS(2729),
    [anon_sym_GT_AMP] = ACTIONS(2729),
    [sym_comment] = ACTIONS(52),
  },
  [857] = {
    [anon_sym_PIPE] = ACTIONS(2731),
    [anon_sym_RPAREN] = ACTIONS(2733),
    [anon_sym_PIPE_AMP] = ACTIONS(2733),
    [anon_sym_AMP_AMP] = ACTIONS(2733),
    [anon_sym_PIPE_PIPE] = ACTIONS(2733),
    [anon_sym_BQUOTE] = ACTIONS(2733),
    [sym_comment] = ACTIONS(52),
  },
  [858] = {
    [sym_file_descriptor] = ACTIONS(902),
    [sym_variable_name] = ACTIONS(902),
    [anon_sym_for] = ACTIONS(904),
    [anon_sym_while] = ACTIONS(904),
    [anon_sym_if] = ACTIONS(904),
    [anon_sym_case] = ACTIONS(904),
    [anon_sym_RPAREN] = ACTIONS(2735),
    [anon_sym_function] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(902),
    [anon_sym_LBRACK] = ACTIONS(904),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym_declare] = ACTIONS(904),
    [anon_sym_typeset] = ACTIONS(904),
    [anon_sym_export] = ACTIONS(904),
    [anon_sym_readonly] = ACTIONS(904),
    [anon_sym_local] = ACTIONS(904),
    [anon_sym_LT] = ACTIONS(904),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_GT_GT] = ACTIONS(902),
    [anon_sym_AMP_GT] = ACTIONS(904),
    [anon_sym_AMP_GT_GT] = ACTIONS(902),
    [anon_sym_LT_AMP] = ACTIONS(902),
    [anon_sym_GT_AMP] = ACTIONS(902),
    [sym__special_characters] = ACTIONS(906),
    [anon_sym_DQUOTE] = ACTIONS(902),
    [sym_raw_string] = ACTIONS(902),
    [anon_sym_DOLLAR] = ACTIONS(904),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(902),
    [anon_sym_BQUOTE] = ACTIONS(902),
    [anon_sym_LT_LPAREN] = ACTIONS(902),
    [anon_sym_GT_LPAREN] = ACTIONS(902),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(906),
  },
  [859] = {
    [anon_sym_PIPE] = ACTIONS(482),
    [anon_sym_RPAREN] = ACTIONS(2737),
    [anon_sym_SEMI_SEMI] = ACTIONS(2739),
    [anon_sym_PIPE_AMP] = ACTIONS(482),
    [anon_sym_AMP_AMP] = ACTIONS(488),
    [anon_sym_PIPE_PIPE] = ACTIONS(488),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2739),
    [anon_sym_LF] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2739),
  },
  [860] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(482),
    [anon_sym_RPAREN] = ACTIONS(2737),
    [anon_sym_SEMI_SEMI] = ACTIONS(2739),
    [anon_sym_PIPE_AMP] = ACTIONS(482),
    [anon_sym_AMP_AMP] = ACTIONS(488),
    [anon_sym_PIPE_PIPE] = ACTIONS(488),
    [anon_sym_LT] = ACTIONS(336),
    [anon_sym_GT] = ACTIONS(336),
    [anon_sym_GT_GT] = ACTIONS(336),
    [anon_sym_AMP_GT] = ACTIONS(336),
    [anon_sym_AMP_GT_GT] = ACTIONS(336),
    [anon_sym_LT_AMP] = ACTIONS(336),
    [anon_sym_GT_AMP] = ACTIONS(336),
    [sym__special_characters] = ACTIONS(336),
    [anon_sym_DQUOTE] = ACTIONS(336),
    [sym_raw_string] = ACTIONS(336),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(336),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(336),
    [anon_sym_BQUOTE] = ACTIONS(336),
    [anon_sym_LT_LPAREN] = ACTIONS(336),
    [anon_sym_GT_LPAREN] = ACTIONS(336),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(336),
    [anon_sym_SEMI] = ACTIONS(2739),
    [anon_sym_LF] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2739),
  },
  [861] = {
    [anon_sym_PIPE] = ACTIONS(2741),
    [anon_sym_RPAREN] = ACTIONS(2743),
    [anon_sym_PIPE_AMP] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2743),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_BQUOTE] = ACTIONS(2743),
    [sym_comment] = ACTIONS(52),
  },
  [862] = {
    [sym_concatenation] = STATE(1379),
    [sym_string] = STATE(1382),
    [sym_array] = STATE(1379),
    [sym_simple_expansion] = STATE(1382),
    [sym_expansion] = STATE(1382),
    [sym_command_substitution] = STATE(1382),
    [sym_process_substitution] = STATE(1382),
    [sym__empty_value] = ACTIONS(2745),
    [anon_sym_LPAREN] = ACTIONS(2747),
    [sym__special_characters] = ACTIONS(2749),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [sym_raw_string] = ACTIONS(2751),
    [anon_sym_DOLLAR] = ACTIONS(756),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(758),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2753),
  },
  [863] = {
    [sym_variable_name] = ACTIONS(394),
    [anon_sym_PIPE] = ACTIONS(1674),
    [anon_sym_RPAREN] = ACTIONS(394),
    [anon_sym_PIPE_AMP] = ACTIONS(394),
    [anon_sym_AMP_AMP] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [sym__special_characters] = ACTIONS(1674),
    [anon_sym_DQUOTE] = ACTIONS(394),
    [sym_raw_string] = ACTIONS(394),
    [anon_sym_DOLLAR] = ACTIONS(1674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(394),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(394),
    [anon_sym_BQUOTE] = ACTIONS(394),
    [anon_sym_LT_LPAREN] = ACTIONS(394),
    [anon_sym_GT_LPAREN] = ACTIONS(394),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1674),
    [sym_word] = ACTIONS(396),
  },
  [864] = {
    [sym_string] = STATE(1383),
    [sym_simple_expansion] = STATE(1383),
    [sym_expansion] = STATE(1383),
    [sym_command_substitution] = STATE(1383),
    [sym_process_substitution] = STATE(1383),
    [sym__special_characters] = ACTIONS(2755),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [sym_raw_string] = ACTIONS(2757),
    [anon_sym_DOLLAR] = ACTIONS(756),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(758),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2755),
  },
  [865] = {
    [aux_sym_concatenation_repeat1] = STATE(1384),
    [sym__concat] = ACTIONS(1704),
    [sym_variable_name] = ACTIONS(646),
    [anon_sym_PIPE] = ACTIONS(1300),
    [anon_sym_RPAREN] = ACTIONS(646),
    [anon_sym_PIPE_AMP] = ACTIONS(646),
    [anon_sym_AMP_AMP] = ACTIONS(646),
    [anon_sym_PIPE_PIPE] = ACTIONS(646),
    [sym__special_characters] = ACTIONS(1300),
    [anon_sym_DQUOTE] = ACTIONS(646),
    [sym_raw_string] = ACTIONS(646),
    [anon_sym_DOLLAR] = ACTIONS(1300),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(646),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(646),
    [anon_sym_BQUOTE] = ACTIONS(646),
    [anon_sym_LT_LPAREN] = ACTIONS(646),
    [anon_sym_GT_LPAREN] = ACTIONS(646),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1300),
    [sym_word] = ACTIONS(648),
  },
  [866] = {
    [sym__concat] = ACTIONS(650),
    [sym_variable_name] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(1302),
    [anon_sym_RPAREN] = ACTIONS(650),
    [anon_sym_PIPE_AMP] = ACTIONS(650),
    [anon_sym_AMP_AMP] = ACTIONS(650),
    [anon_sym_PIPE_PIPE] = ACTIONS(650),
    [sym__special_characters] = ACTIONS(1302),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [sym_raw_string] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(1302),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(650),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LT_LPAREN] = ACTIONS(650),
    [anon_sym_GT_LPAREN] = ACTIONS(650),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1302),
    [sym_word] = ACTIONS(652),
  },
  [867] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(2759),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [868] = {
    [sym__concat] = ACTIONS(680),
    [sym_variable_name] = ACTIONS(680),
    [anon_sym_PIPE] = ACTIONS(1306),
    [anon_sym_RPAREN] = ACTIONS(680),
    [anon_sym_PIPE_AMP] = ACTIONS(680),
    [anon_sym_AMP_AMP] = ACTIONS(680),
    [anon_sym_PIPE_PIPE] = ACTIONS(680),
    [sym__special_characters] = ACTIONS(1306),
    [anon_sym_DQUOTE] = ACTIONS(680),
    [sym_raw_string] = ACTIONS(680),
    [anon_sym_DOLLAR] = ACTIONS(1306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(680),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(680),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [anon_sym_LT_LPAREN] = ACTIONS(680),
    [anon_sym_GT_LPAREN] = ACTIONS(680),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1306),
    [sym_word] = ACTIONS(682),
  },
  [869] = {
    [sym__concat] = ACTIONS(684),
    [sym_variable_name] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(1308),
    [anon_sym_RPAREN] = ACTIONS(684),
    [anon_sym_PIPE_AMP] = ACTIONS(684),
    [anon_sym_AMP_AMP] = ACTIONS(684),
    [anon_sym_PIPE_PIPE] = ACTIONS(684),
    [sym__special_characters] = ACTIONS(1308),
    [anon_sym_DQUOTE] = ACTIONS(684),
    [sym_raw_string] = ACTIONS(684),
    [anon_sym_DOLLAR] = ACTIONS(1308),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(684),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(684),
    [anon_sym_BQUOTE] = ACTIONS(684),
    [anon_sym_LT_LPAREN] = ACTIONS(684),
    [anon_sym_GT_LPAREN] = ACTIONS(684),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1308),
    [sym_word] = ACTIONS(686),
  },
  [870] = {
    [sym__concat] = ACTIONS(688),
    [sym_variable_name] = ACTIONS(688),
    [anon_sym_PIPE] = ACTIONS(1310),
    [anon_sym_RPAREN] = ACTIONS(688),
    [anon_sym_PIPE_AMP] = ACTIONS(688),
    [anon_sym_AMP_AMP] = ACTIONS(688),
    [anon_sym_PIPE_PIPE] = ACTIONS(688),
    [sym__special_characters] = ACTIONS(1310),
    [anon_sym_DQUOTE] = ACTIONS(688),
    [sym_raw_string] = ACTIONS(688),
    [anon_sym_DOLLAR] = ACTIONS(1310),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(688),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(688),
    [anon_sym_BQUOTE] = ACTIONS(688),
    [anon_sym_LT_LPAREN] = ACTIONS(688),
    [anon_sym_GT_LPAREN] = ACTIONS(688),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1310),
    [sym_word] = ACTIONS(690),
  },
  [871] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(2761),
    [sym_comment] = ACTIONS(52),
  },
  [872] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1388),
    [anon_sym_RBRACE] = ACTIONS(2763),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [873] = {
    [sym_subscript] = STATE(1392),
    [sym_variable_name] = ACTIONS(2765),
    [anon_sym_DOLLAR] = ACTIONS(2767),
    [anon_sym_DASH] = ACTIONS(2767),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2767),
    [anon_sym_AT] = ACTIONS(2767),
    [anon_sym_QMARK] = ACTIONS(2767),
    [anon_sym_0] = ACTIONS(2771),
    [anon_sym__] = ACTIONS(2771),
  },
  [874] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1394),
    [anon_sym_RBRACE] = ACTIONS(2773),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [875] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1396),
    [anon_sym_RBRACE] = ACTIONS(2775),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [876] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(2777),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [877] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(2777),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [878] = {
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(2777),
    [sym_comment] = ACTIONS(52),
  },
  [879] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(2777),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [880] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(2779),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [881] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(2779),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [882] = {
    [sym_variable_assignment] = STATE(435),
    [sym_subscript] = STATE(436),
    [sym_concatenation] = STATE(435),
    [sym_string] = STATE(428),
    [sym_simple_expansion] = STATE(428),
    [sym_expansion] = STATE(428),
    [sym_command_substitution] = STATE(428),
    [sym_process_substitution] = STATE(428),
    [aux_sym_declaration_command_repeat1] = STATE(882),
    [sym_variable_name] = ACTIONS(2781),
    [anon_sym_PIPE] = ACTIONS(2784),
    [anon_sym_RPAREN] = ACTIONS(2786),
    [anon_sym_PIPE_AMP] = ACTIONS(2786),
    [anon_sym_AMP_AMP] = ACTIONS(2786),
    [anon_sym_PIPE_PIPE] = ACTIONS(2786),
    [sym__special_characters] = ACTIONS(2788),
    [anon_sym_DQUOTE] = ACTIONS(2791),
    [sym_raw_string] = ACTIONS(2794),
    [anon_sym_DOLLAR] = ACTIONS(2797),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2800),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2803),
    [anon_sym_BQUOTE] = ACTIONS(2806),
    [anon_sym_LT_LPAREN] = ACTIONS(2809),
    [anon_sym_GT_LPAREN] = ACTIONS(2809),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2812),
    [sym_word] = ACTIONS(2815),
  },
  [883] = {
    [sym_file_descriptor] = ACTIONS(1522),
    [sym__concat] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_RPAREN] = ACTIONS(1522),
    [anon_sym_PIPE_AMP] = ACTIONS(1522),
    [anon_sym_AMP_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1522),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_GT_GT] = ACTIONS(1522),
    [anon_sym_AMP_GT] = ACTIONS(2430),
    [anon_sym_AMP_GT_GT] = ACTIONS(1522),
    [anon_sym_LT_AMP] = ACTIONS(1522),
    [anon_sym_GT_AMP] = ACTIONS(1522),
    [anon_sym_LT_LT] = ACTIONS(2430),
    [anon_sym_LT_LT_DASH] = ACTIONS(1522),
    [anon_sym_LT_LT_LT] = ACTIONS(1522),
    [sym__special_characters] = ACTIONS(2430),
    [anon_sym_DQUOTE] = ACTIONS(1522),
    [sym_raw_string] = ACTIONS(1522),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1522),
    [anon_sym_BQUOTE] = ACTIONS(1522),
    [anon_sym_LT_LPAREN] = ACTIONS(1522),
    [anon_sym_GT_LPAREN] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2430),
  },
  [884] = {
    [aux_sym_concatenation_repeat1] = STATE(884),
    [sym_file_descriptor] = ACTIONS(1522),
    [sym__concat] = ACTIONS(2818),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_RPAREN] = ACTIONS(1522),
    [anon_sym_PIPE_AMP] = ACTIONS(1522),
    [anon_sym_AMP_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1522),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_GT_GT] = ACTIONS(1522),
    [anon_sym_AMP_GT] = ACTIONS(2430),
    [anon_sym_AMP_GT_GT] = ACTIONS(1522),
    [anon_sym_LT_AMP] = ACTIONS(1522),
    [anon_sym_GT_AMP] = ACTIONS(1522),
    [anon_sym_LT_LT] = ACTIONS(2430),
    [anon_sym_LT_LT_DASH] = ACTIONS(1522),
    [anon_sym_LT_LT_LT] = ACTIONS(1522),
    [sym__special_characters] = ACTIONS(2430),
    [anon_sym_DQUOTE] = ACTIONS(1522),
    [sym_raw_string] = ACTIONS(1522),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1522),
    [anon_sym_BQUOTE] = ACTIONS(1522),
    [anon_sym_LT_LPAREN] = ACTIONS(1522),
    [anon_sym_GT_LPAREN] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2430),
  },
  [885] = {
    [sym_file_descriptor] = ACTIONS(1553),
    [sym__concat] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(2435),
    [anon_sym_RPAREN] = ACTIONS(1553),
    [anon_sym_PIPE_AMP] = ACTIONS(1553),
    [anon_sym_AMP_AMP] = ACTIONS(1553),
    [anon_sym_PIPE_PIPE] = ACTIONS(1553),
    [anon_sym_LT] = ACTIONS(2435),
    [anon_sym_GT] = ACTIONS(2435),
    [anon_sym_GT_GT] = ACTIONS(1553),
    [anon_sym_AMP_GT] = ACTIONS(2435),
    [anon_sym_AMP_GT_GT] = ACTIONS(1553),
    [anon_sym_LT_AMP] = ACTIONS(1553),
    [anon_sym_GT_AMP] = ACTIONS(1553),
    [anon_sym_LT_LT] = ACTIONS(2435),
    [anon_sym_LT_LT_DASH] = ACTIONS(1553),
    [anon_sym_LT_LT_LT] = ACTIONS(1553),
    [sym__special_characters] = ACTIONS(2435),
    [anon_sym_DQUOTE] = ACTIONS(1553),
    [sym_raw_string] = ACTIONS(1553),
    [anon_sym_DOLLAR] = ACTIONS(2435),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1553),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1553),
    [anon_sym_BQUOTE] = ACTIONS(1553),
    [anon_sym_LT_LPAREN] = ACTIONS(1553),
    [anon_sym_GT_LPAREN] = ACTIONS(1553),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2435),
  },
  [886] = {
    [sym_concatenation] = STATE(1402),
    [sym_string] = STATE(1401),
    [sym_simple_expansion] = STATE(1401),
    [sym_expansion] = STATE(1401),
    [sym_command_substitution] = STATE(1401),
    [sym_process_substitution] = STATE(1401),
    [anon_sym_RBRACE] = ACTIONS(2821),
    [sym__special_characters] = ACTIONS(2823),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(2825),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2827),
  },
  [887] = {
    [sym_file_descriptor] = ACTIONS(1598),
    [sym__concat] = ACTIONS(1598),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_RPAREN] = ACTIONS(1598),
    [anon_sym_PIPE_AMP] = ACTIONS(1598),
    [anon_sym_AMP_AMP] = ACTIONS(1598),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_LT] = ACTIONS(2445),
    [anon_sym_GT] = ACTIONS(2445),
    [anon_sym_GT_GT] = ACTIONS(1598),
    [anon_sym_AMP_GT] = ACTIONS(2445),
    [anon_sym_AMP_GT_GT] = ACTIONS(1598),
    [anon_sym_LT_AMP] = ACTIONS(1598),
    [anon_sym_GT_AMP] = ACTIONS(1598),
    [anon_sym_LT_LT] = ACTIONS(2445),
    [anon_sym_LT_LT_DASH] = ACTIONS(1598),
    [anon_sym_LT_LT_LT] = ACTIONS(1598),
    [sym__special_characters] = ACTIONS(2445),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [sym_raw_string] = ACTIONS(1598),
    [anon_sym_DOLLAR] = ACTIONS(2445),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1598),
    [anon_sym_BQUOTE] = ACTIONS(1598),
    [anon_sym_LT_LPAREN] = ACTIONS(1598),
    [anon_sym_GT_LPAREN] = ACTIONS(1598),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2445),
  },
  [888] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(2829),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [889] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(2831),
    [sym_comment] = ACTIONS(52),
  },
  [890] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1406),
    [anon_sym_RBRACE] = ACTIONS(2833),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [891] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1408),
    [anon_sym_RBRACE] = ACTIONS(2835),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [892] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1409),
    [anon_sym_RBRACE] = ACTIONS(2821),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [893] = {
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(2455),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [anon_sym_LT] = ACTIONS(2455),
    [anon_sym_GT] = ACTIONS(2455),
    [anon_sym_GT_GT] = ACTIONS(1642),
    [anon_sym_AMP_GT] = ACTIONS(2455),
    [anon_sym_AMP_GT_GT] = ACTIONS(1642),
    [anon_sym_LT_AMP] = ACTIONS(1642),
    [anon_sym_GT_AMP] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(2455),
    [anon_sym_LT_LT_DASH] = ACTIONS(1642),
    [anon_sym_LT_LT_LT] = ACTIONS(1642),
    [sym__special_characters] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [sym_raw_string] = ACTIONS(1642),
    [anon_sym_DOLLAR] = ACTIONS(2455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [anon_sym_LT_LPAREN] = ACTIONS(1642),
    [anon_sym_GT_LPAREN] = ACTIONS(1642),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2455),
  },
  [894] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(2837),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [895] = {
    [sym_file_descriptor] = ACTIONS(1648),
    [sym__concat] = ACTIONS(1648),
    [anon_sym_PIPE] = ACTIONS(2459),
    [anon_sym_RPAREN] = ACTIONS(1648),
    [anon_sym_PIPE_AMP] = ACTIONS(1648),
    [anon_sym_AMP_AMP] = ACTIONS(1648),
    [anon_sym_PIPE_PIPE] = ACTIONS(1648),
    [anon_sym_LT] = ACTIONS(2459),
    [anon_sym_GT] = ACTIONS(2459),
    [anon_sym_GT_GT] = ACTIONS(1648),
    [anon_sym_AMP_GT] = ACTIONS(2459),
    [anon_sym_AMP_GT_GT] = ACTIONS(1648),
    [anon_sym_LT_AMP] = ACTIONS(1648),
    [anon_sym_GT_AMP] = ACTIONS(1648),
    [anon_sym_LT_LT] = ACTIONS(2459),
    [anon_sym_LT_LT_DASH] = ACTIONS(1648),
    [anon_sym_LT_LT_LT] = ACTIONS(1648),
    [sym__special_characters] = ACTIONS(2459),
    [anon_sym_DQUOTE] = ACTIONS(1648),
    [sym_raw_string] = ACTIONS(1648),
    [anon_sym_DOLLAR] = ACTIONS(2459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1648),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1648),
    [anon_sym_BQUOTE] = ACTIONS(1648),
    [anon_sym_LT_LPAREN] = ACTIONS(1648),
    [anon_sym_GT_LPAREN] = ACTIONS(1648),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2459),
  },
  [896] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(2821),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [897] = {
    [sym_file_descriptor] = ACTIONS(1762),
    [sym__concat] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(2461),
    [anon_sym_RPAREN] = ACTIONS(1762),
    [anon_sym_PIPE_AMP] = ACTIONS(1762),
    [anon_sym_AMP_AMP] = ACTIONS(1762),
    [anon_sym_PIPE_PIPE] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(2461),
    [anon_sym_GT] = ACTIONS(2461),
    [anon_sym_GT_GT] = ACTIONS(1762),
    [anon_sym_AMP_GT] = ACTIONS(2461),
    [anon_sym_AMP_GT_GT] = ACTIONS(1762),
    [anon_sym_LT_AMP] = ACTIONS(1762),
    [anon_sym_GT_AMP] = ACTIONS(1762),
    [anon_sym_LT_LT] = ACTIONS(2461),
    [anon_sym_LT_LT_DASH] = ACTIONS(1762),
    [anon_sym_LT_LT_LT] = ACTIONS(1762),
    [sym__special_characters] = ACTIONS(2461),
    [anon_sym_DQUOTE] = ACTIONS(1762),
    [sym_raw_string] = ACTIONS(1762),
    [anon_sym_DOLLAR] = ACTIONS(2461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1762),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1762),
    [anon_sym_BQUOTE] = ACTIONS(1762),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2461),
  },
  [898] = {
    [sym_file_descriptor] = ACTIONS(1902),
    [sym__concat] = ACTIONS(1902),
    [anon_sym_PIPE] = ACTIONS(2463),
    [anon_sym_RPAREN] = ACTIONS(1902),
    [anon_sym_PIPE_AMP] = ACTIONS(1902),
    [anon_sym_AMP_AMP] = ACTIONS(1902),
    [anon_sym_PIPE_PIPE] = ACTIONS(1902),
    [anon_sym_LT] = ACTIONS(2463),
    [anon_sym_GT] = ACTIONS(2463),
    [anon_sym_GT_GT] = ACTIONS(1902),
    [anon_sym_AMP_GT] = ACTIONS(2463),
    [anon_sym_AMP_GT_GT] = ACTIONS(1902),
    [anon_sym_LT_AMP] = ACTIONS(1902),
    [anon_sym_GT_AMP] = ACTIONS(1902),
    [anon_sym_LT_LT] = ACTIONS(2463),
    [anon_sym_LT_LT_DASH] = ACTIONS(1902),
    [anon_sym_LT_LT_LT] = ACTIONS(1902),
    [sym__special_characters] = ACTIONS(2463),
    [anon_sym_DQUOTE] = ACTIONS(1902),
    [sym_raw_string] = ACTIONS(1902),
    [anon_sym_DOLLAR] = ACTIONS(2463),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1902),
    [anon_sym_BQUOTE] = ACTIONS(1902),
    [anon_sym_LT_LPAREN] = ACTIONS(1902),
    [anon_sym_GT_LPAREN] = ACTIONS(1902),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2463),
  },
  [899] = {
    [sym_compound_statement] = STATE(1411),
    [anon_sym_LBRACE] = ACTIONS(1692),
    [sym_comment] = ACTIONS(52),
  },
  [900] = {
    [anon_sym_PIPE] = ACTIONS(2839),
    [anon_sym_RPAREN] = ACTIONS(2841),
    [anon_sym_PIPE_AMP] = ACTIONS(2841),
    [anon_sym_AMP_AMP] = ACTIONS(2841),
    [anon_sym_PIPE_PIPE] = ACTIONS(2841),
    [anon_sym_BQUOTE] = ACTIONS(2841),
    [sym_comment] = ACTIONS(52),
  },
  [901] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(2839),
    [anon_sym_RPAREN] = ACTIONS(2841),
    [anon_sym_PIPE_AMP] = ACTIONS(2841),
    [anon_sym_AMP_AMP] = ACTIONS(2841),
    [anon_sym_PIPE_PIPE] = ACTIONS(2841),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [902] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(2843),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(2843),
    [anon_sym_PIPE_PIPE] = ACTIONS(2843),
    [sym_comment] = ACTIONS(52),
  },
  [903] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(2843),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(2843),
    [anon_sym_PIPE_PIPE] = ACTIONS(2843),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [904] = {
    [sym_concatenation] = STATE(1414),
    [sym_string] = STATE(1413),
    [sym_simple_expansion] = STATE(1413),
    [sym_expansion] = STATE(1413),
    [sym_command_substitution] = STATE(1413),
    [sym_process_substitution] = STATE(1413),
    [sym__special_characters] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(1772),
    [sym_raw_string] = ACTIONS(2847),
    [anon_sym_DOLLAR] = ACTIONS(1776),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1778),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1780),
    [anon_sym_BQUOTE] = ACTIONS(1782),
    [anon_sym_LT_LPAREN] = ACTIONS(1784),
    [anon_sym_GT_LPAREN] = ACTIONS(1784),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2849),
  },
  [905] = {
    [aux_sym_concatenation_repeat1] = STATE(1416),
    [sym_file_descriptor] = ACTIONS(614),
    [sym__concat] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(618),
    [anon_sym_RPAREN] = ACTIONS(614),
    [anon_sym_PIPE_AMP] = ACTIONS(614),
    [anon_sym_AMP_AMP] = ACTIONS(614),
    [anon_sym_PIPE_PIPE] = ACTIONS(614),
    [anon_sym_LT] = ACTIONS(618),
    [anon_sym_GT] = ACTIONS(618),
    [anon_sym_GT_GT] = ACTIONS(614),
    [anon_sym_AMP_GT] = ACTIONS(618),
    [anon_sym_AMP_GT_GT] = ACTIONS(614),
    [anon_sym_LT_AMP] = ACTIONS(614),
    [anon_sym_GT_AMP] = ACTIONS(614),
    [anon_sym_LT_LT] = ACTIONS(618),
    [anon_sym_LT_LT_DASH] = ACTIONS(614),
    [anon_sym_LT_LT_LT] = ACTIONS(614),
    [sym_comment] = ACTIONS(52),
  },
  [906] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(1418),
    [anon_sym_DQUOTE] = ACTIONS(2853),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [907] = {
    [aux_sym_concatenation_repeat1] = STATE(1416),
    [sym_file_descriptor] = ACTIONS(622),
    [sym__concat] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(624),
    [anon_sym_RPAREN] = ACTIONS(622),
    [anon_sym_PIPE_AMP] = ACTIONS(622),
    [anon_sym_AMP_AMP] = ACTIONS(622),
    [anon_sym_PIPE_PIPE] = ACTIONS(622),
    [anon_sym_LT] = ACTIONS(624),
    [anon_sym_GT] = ACTIONS(624),
    [anon_sym_GT_GT] = ACTIONS(622),
    [anon_sym_AMP_GT] = ACTIONS(624),
    [anon_sym_AMP_GT_GT] = ACTIONS(622),
    [anon_sym_LT_AMP] = ACTIONS(622),
    [anon_sym_GT_AMP] = ACTIONS(622),
    [anon_sym_LT_LT] = ACTIONS(624),
    [anon_sym_LT_LT_DASH] = ACTIONS(622),
    [anon_sym_LT_LT_LT] = ACTIONS(622),
    [sym_comment] = ACTIONS(52),
  },
  [908] = {
    [sym_string] = STATE(1421),
    [anon_sym_DQUOTE] = ACTIONS(1772),
    [anon_sym_DOLLAR] = ACTIONS(2855),
    [anon_sym_POUND] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2857),
    [anon_sym_STAR] = ACTIONS(2855),
    [anon_sym_AT] = ACTIONS(2855),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_0] = ACTIONS(2859),
    [anon_sym__] = ACTIONS(2859),
  },
  [909] = {
    [sym_subscript] = STATE(1426),
    [sym_variable_name] = ACTIONS(2861),
    [anon_sym_DOLLAR] = ACTIONS(2863),
    [anon_sym_POUND] = ACTIONS(2865),
    [anon_sym_DASH] = ACTIONS(2863),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2867),
    [anon_sym_STAR] = ACTIONS(2863),
    [anon_sym_AT] = ACTIONS(2863),
    [anon_sym_QMARK] = ACTIONS(2863),
    [anon_sym_0] = ACTIONS(2869),
    [anon_sym__] = ACTIONS(2869),
  },
  [910] = {
    [sym_for_statement] = STATE(1427),
    [sym_while_statement] = STATE(1427),
    [sym_if_statement] = STATE(1427),
    [sym_case_statement] = STATE(1427),
    [sym_function_definition] = STATE(1427),
    [sym_subshell] = STATE(1427),
    [sym_pipeline] = STATE(1427),
    [sym_list] = STATE(1427),
    [sym_bracket_command] = STATE(1427),
    [sym_command] = STATE(1427),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(1428),
    [sym_declaration_command] = STATE(1427),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [911] = {
    [sym_for_statement] = STATE(1429),
    [sym_while_statement] = STATE(1429),
    [sym_if_statement] = STATE(1429),
    [sym_case_statement] = STATE(1429),
    [sym_function_definition] = STATE(1429),
    [sym_subshell] = STATE(1429),
    [sym_pipeline] = STATE(1429),
    [sym_list] = STATE(1429),
    [sym_bracket_command] = STATE(1429),
    [sym_command] = STATE(1429),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(1430),
    [sym_declaration_command] = STATE(1429),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [912] = {
    [sym_for_statement] = STATE(1431),
    [sym_while_statement] = STATE(1431),
    [sym_if_statement] = STATE(1431),
    [sym_case_statement] = STATE(1431),
    [sym_function_definition] = STATE(1431),
    [sym_subshell] = STATE(1431),
    [sym_pipeline] = STATE(1431),
    [sym_list] = STATE(1431),
    [sym_bracket_command] = STATE(1431),
    [sym_command] = STATE(1431),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(1432),
    [sym_declaration_command] = STATE(1431),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [913] = {
    [sym_file_descriptor] = ACTIONS(622),
    [anon_sym_PIPE] = ACTIONS(624),
    [anon_sym_RPAREN] = ACTIONS(622),
    [anon_sym_PIPE_AMP] = ACTIONS(622),
    [anon_sym_AMP_AMP] = ACTIONS(622),
    [anon_sym_PIPE_PIPE] = ACTIONS(622),
    [anon_sym_LT] = ACTIONS(624),
    [anon_sym_GT] = ACTIONS(624),
    [anon_sym_GT_GT] = ACTIONS(622),
    [anon_sym_AMP_GT] = ACTIONS(624),
    [anon_sym_AMP_GT_GT] = ACTIONS(622),
    [anon_sym_LT_AMP] = ACTIONS(622),
    [anon_sym_GT_AMP] = ACTIONS(622),
    [anon_sym_LT_LT] = ACTIONS(624),
    [anon_sym_LT_LT_DASH] = ACTIONS(622),
    [anon_sym_LT_LT_LT] = ACTIONS(622),
    [anon_sym_BQUOTE] = ACTIONS(622),
    [sym_comment] = ACTIONS(52),
  },
  [914] = {
    [sym_file_descriptor] = ACTIONS(1940),
    [anon_sym_PIPE] = ACTIONS(2871),
    [anon_sym_RPAREN] = ACTIONS(1940),
    [anon_sym_PIPE_AMP] = ACTIONS(1940),
    [anon_sym_AMP_AMP] = ACTIONS(1940),
    [anon_sym_PIPE_PIPE] = ACTIONS(1940),
    [anon_sym_LT] = ACTIONS(2871),
    [anon_sym_GT] = ACTIONS(2871),
    [anon_sym_GT_GT] = ACTIONS(1940),
    [anon_sym_AMP_GT] = ACTIONS(2871),
    [anon_sym_AMP_GT_GT] = ACTIONS(1940),
    [anon_sym_LT_AMP] = ACTIONS(1940),
    [anon_sym_GT_AMP] = ACTIONS(1940),
    [anon_sym_LT_LT] = ACTIONS(2871),
    [anon_sym_LT_LT_DASH] = ACTIONS(1940),
    [anon_sym_LT_LT_LT] = ACTIONS(1940),
    [anon_sym_BQUOTE] = ACTIONS(1940),
    [sym_comment] = ACTIONS(52),
  },
  [915] = {
    [sym_simple_expansion] = STATE(1012),
    [sym_expansion] = STATE(1012),
    [aux_sym_heredoc_repeat1] = STATE(1434),
    [sym__heredoc_middle] = ACTIONS(1944),
    [sym__heredoc_end] = ACTIONS(2873),
    [anon_sym_DOLLAR] = ACTIONS(1948),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1950),
    [sym_comment] = ACTIONS(52),
  },
  [916] = {
    [sym_file_descriptor] = ACTIONS(1952),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_RPAREN] = ACTIONS(1952),
    [anon_sym_PIPE_AMP] = ACTIONS(1952),
    [anon_sym_AMP_AMP] = ACTIONS(1952),
    [anon_sym_PIPE_PIPE] = ACTIONS(1952),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_GT] = ACTIONS(1952),
    [anon_sym_AMP_GT] = ACTIONS(2875),
    [anon_sym_AMP_GT_GT] = ACTIONS(1952),
    [anon_sym_LT_AMP] = ACTIONS(1952),
    [anon_sym_GT_AMP] = ACTIONS(1952),
    [anon_sym_LT_LT] = ACTIONS(2875),
    [anon_sym_LT_LT_DASH] = ACTIONS(1952),
    [anon_sym_LT_LT_LT] = ACTIONS(1952),
    [anon_sym_BQUOTE] = ACTIONS(1952),
    [sym_comment] = ACTIONS(52),
  },
  [917] = {
    [aux_sym_concatenation_repeat1] = STATE(1416),
    [sym_file_descriptor] = ACTIONS(1956),
    [sym__concat] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(2877),
    [anon_sym_RPAREN] = ACTIONS(1956),
    [anon_sym_PIPE_AMP] = ACTIONS(1956),
    [anon_sym_AMP_AMP] = ACTIONS(1956),
    [anon_sym_PIPE_PIPE] = ACTIONS(1956),
    [anon_sym_LT] = ACTIONS(2877),
    [anon_sym_GT] = ACTIONS(2877),
    [anon_sym_GT_GT] = ACTIONS(1956),
    [anon_sym_AMP_GT] = ACTIONS(2877),
    [anon_sym_AMP_GT_GT] = ACTIONS(1956),
    [anon_sym_LT_AMP] = ACTIONS(1956),
    [anon_sym_GT_AMP] = ACTIONS(1956),
    [anon_sym_LT_LT] = ACTIONS(2877),
    [anon_sym_LT_LT_DASH] = ACTIONS(1956),
    [anon_sym_LT_LT_LT] = ACTIONS(1956),
    [sym_comment] = ACTIONS(52),
  },
  [918] = {
    [aux_sym_concatenation_repeat1] = STATE(1416),
    [sym_file_descriptor] = ACTIONS(1960),
    [sym__concat] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(2879),
    [anon_sym_RPAREN] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(2879),
    [anon_sym_GT] = ACTIONS(2879),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(2879),
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(2879),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [sym_comment] = ACTIONS(52),
  },
  [919] = {
    [sym_file_descriptor] = ACTIONS(1960),
    [anon_sym_PIPE] = ACTIONS(2879),
    [anon_sym_RPAREN] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(2879),
    [anon_sym_GT] = ACTIONS(2879),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(2879),
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(2879),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [sym_comment] = ACTIONS(52),
  },
  [920] = {
    [sym_concatenation] = STATE(467),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_for_statement_repeat1] = STATE(920),
    [sym_file_descriptor] = ACTIONS(1389),
    [anon_sym_PIPE] = ACTIONS(1334),
    [anon_sym_RPAREN] = ACTIONS(1389),
    [anon_sym_PIPE_AMP] = ACTIONS(1389),
    [anon_sym_AMP_AMP] = ACTIONS(1389),
    [anon_sym_PIPE_PIPE] = ACTIONS(1389),
    [anon_sym_LT] = ACTIONS(1334),
    [anon_sym_GT] = ACTIONS(1334),
    [anon_sym_GT_GT] = ACTIONS(1389),
    [anon_sym_AMP_GT] = ACTIONS(1334),
    [anon_sym_AMP_GT_GT] = ACTIONS(1389),
    [anon_sym_LT_AMP] = ACTIONS(1389),
    [anon_sym_GT_AMP] = ACTIONS(1389),
    [anon_sym_LT_LT] = ACTIONS(1334),
    [anon_sym_LT_LT_DASH] = ACTIONS(1389),
    [anon_sym_LT_LT_LT] = ACTIONS(1389),
    [sym__special_characters] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2884),
    [sym_raw_string] = ACTIONS(2887),
    [anon_sym_DOLLAR] = ACTIONS(2890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2893),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2896),
    [anon_sym_BQUOTE] = ACTIONS(2899),
    [anon_sym_LT_LPAREN] = ACTIONS(2902),
    [anon_sym_GT_LPAREN] = ACTIONS(2902),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2905),
  },
  [921] = {
    [sym_file_redirect] = STATE(466),
    [sym_heredoc_redirect] = STATE(466),
    [sym_herestring_redirect] = STATE(466),
    [aux_sym_while_statement_repeat1] = STATE(922),
    [sym_file_descriptor] = ACTIONS(804),
    [anon_sym_PIPE] = ACTIONS(2908),
    [anon_sym_RPAREN] = ACTIONS(2910),
    [anon_sym_PIPE_AMP] = ACTIONS(2910),
    [anon_sym_AMP_AMP] = ACTIONS(2910),
    [anon_sym_PIPE_PIPE] = ACTIONS(2910),
    [anon_sym_LT] = ACTIONS(810),
    [anon_sym_GT] = ACTIONS(810),
    [anon_sym_GT_GT] = ACTIONS(812),
    [anon_sym_AMP_GT] = ACTIONS(810),
    [anon_sym_AMP_GT_GT] = ACTIONS(812),
    [anon_sym_LT_AMP] = ACTIONS(812),
    [anon_sym_GT_AMP] = ACTIONS(812),
    [anon_sym_LT_LT] = ACTIONS(814),
    [anon_sym_LT_LT_DASH] = ACTIONS(816),
    [anon_sym_LT_LT_LT] = ACTIONS(818),
    [sym_comment] = ACTIONS(52),
  },
  [922] = {
    [sym_file_redirect] = STATE(466),
    [sym_heredoc_redirect] = STATE(466),
    [sym_herestring_redirect] = STATE(466),
    [aux_sym_while_statement_repeat1] = STATE(922),
    [sym_file_descriptor] = ACTIONS(2912),
    [anon_sym_PIPE] = ACTIONS(2915),
    [anon_sym_RPAREN] = ACTIONS(2917),
    [anon_sym_PIPE_AMP] = ACTIONS(2917),
    [anon_sym_AMP_AMP] = ACTIONS(2917),
    [anon_sym_PIPE_PIPE] = ACTIONS(2917),
    [anon_sym_LT] = ACTIONS(2919),
    [anon_sym_GT] = ACTIONS(2919),
    [anon_sym_GT_GT] = ACTIONS(2922),
    [anon_sym_AMP_GT] = ACTIONS(2919),
    [anon_sym_AMP_GT_GT] = ACTIONS(2922),
    [anon_sym_LT_AMP] = ACTIONS(2922),
    [anon_sym_GT_AMP] = ACTIONS(2922),
    [anon_sym_LT_LT] = ACTIONS(2925),
    [anon_sym_LT_LT_DASH] = ACTIONS(2928),
    [anon_sym_LT_LT_LT] = ACTIONS(2931),
    [sym_comment] = ACTIONS(52),
  },
  [923] = {
    [sym_file_redirect] = STATE(466),
    [sym_heredoc_redirect] = STATE(466),
    [sym_herestring_redirect] = STATE(466),
    [sym_concatenation] = STATE(467),
    [sym_string] = STATE(465),
    [sym_simple_expansion] = STATE(465),
    [sym_expansion] = STATE(465),
    [sym_command_substitution] = STATE(465),
    [sym_process_substitution] = STATE(465),
    [aux_sym_for_statement_repeat1] = STATE(920),
    [aux_sym_while_statement_repeat1] = STATE(1435),
    [sym_file_descriptor] = ACTIONS(804),
    [anon_sym_PIPE] = ACTIONS(2908),
    [anon_sym_RPAREN] = ACTIONS(2910),
    [anon_sym_PIPE_AMP] = ACTIONS(2910),
    [anon_sym_AMP_AMP] = ACTIONS(2910),
    [anon_sym_PIPE_PIPE] = ACTIONS(2910),
    [anon_sym_LT] = ACTIONS(810),
    [anon_sym_GT] = ACTIONS(810),
    [anon_sym_GT_GT] = ACTIONS(812),
    [anon_sym_AMP_GT] = ACTIONS(810),
    [anon_sym_AMP_GT_GT] = ACTIONS(812),
    [anon_sym_LT_AMP] = ACTIONS(812),
    [anon_sym_GT_AMP] = ACTIONS(812),
    [anon_sym_LT_LT] = ACTIONS(814),
    [anon_sym_LT_LT_DASH] = ACTIONS(816),
    [anon_sym_LT_LT_LT] = ACTIONS(818),
    [sym__special_characters] = ACTIONS(820),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(824),
  },
  [924] = {
    [aux_sym_concatenation_repeat1] = STATE(1437),
    [sym_file_descriptor] = ACTIONS(1092),
    [sym__concat] = ACTIONS(2934),
    [sym_variable_name] = ACTIONS(1092),
    [anon_sym_PIPE] = ACTIONS(2681),
    [anon_sym_PIPE_AMP] = ACTIONS(1092),
    [anon_sym_AMP_AMP] = ACTIONS(1092),
    [anon_sym_PIPE_PIPE] = ACTIONS(1092),
    [anon_sym_LT] = ACTIONS(2681),
    [anon_sym_GT] = ACTIONS(2681),
    [anon_sym_GT_GT] = ACTIONS(1092),
    [anon_sym_AMP_GT] = ACTIONS(2681),
    [anon_sym_AMP_GT_GT] = ACTIONS(1092),
    [anon_sym_LT_AMP] = ACTIONS(1092),
    [anon_sym_GT_AMP] = ACTIONS(1092),
    [sym__special_characters] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(1092),
    [sym_raw_string] = ACTIONS(1092),
    [anon_sym_DOLLAR] = ACTIONS(2681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1092),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1092),
    [anon_sym_BQUOTE] = ACTIONS(1092),
    [anon_sym_LT_LPAREN] = ACTIONS(1092),
    [anon_sym_GT_LPAREN] = ACTIONS(1092),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2681),
  },
  [925] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(1439),
    [anon_sym_DQUOTE] = ACTIONS(2936),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [926] = {
    [aux_sym_concatenation_repeat1] = STATE(1437),
    [sym_file_descriptor] = ACTIONS(1068),
    [sym__concat] = ACTIONS(2934),
    [sym_variable_name] = ACTIONS(1068),
    [anon_sym_PIPE] = ACTIONS(2675),
    [anon_sym_PIPE_AMP] = ACTIONS(1068),
    [anon_sym_AMP_AMP] = ACTIONS(1068),
    [anon_sym_PIPE_PIPE] = ACTIONS(1068),
    [anon_sym_LT] = ACTIONS(2675),
    [anon_sym_GT] = ACTIONS(2675),
    [anon_sym_GT_GT] = ACTIONS(1068),
    [anon_sym_AMP_GT] = ACTIONS(2675),
    [anon_sym_AMP_GT_GT] = ACTIONS(1068),
    [anon_sym_LT_AMP] = ACTIONS(1068),
    [anon_sym_GT_AMP] = ACTIONS(1068),
    [sym__special_characters] = ACTIONS(2675),
    [anon_sym_DQUOTE] = ACTIONS(1068),
    [sym_raw_string] = ACTIONS(1068),
    [anon_sym_DOLLAR] = ACTIONS(2675),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1068),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1068),
    [anon_sym_BQUOTE] = ACTIONS(1068),
    [anon_sym_LT_LPAREN] = ACTIONS(1068),
    [anon_sym_GT_LPAREN] = ACTIONS(1068),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2675),
  },
  [927] = {
    [sym_string] = STATE(1442),
    [anon_sym_DQUOTE] = ACTIONS(1806),
    [anon_sym_DOLLAR] = ACTIONS(2938),
    [anon_sym_POUND] = ACTIONS(2938),
    [anon_sym_DASH] = ACTIONS(2938),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2940),
    [anon_sym_STAR] = ACTIONS(2938),
    [anon_sym_AT] = ACTIONS(2938),
    [anon_sym_QMARK] = ACTIONS(2938),
    [anon_sym_0] = ACTIONS(2942),
    [anon_sym__] = ACTIONS(2942),
  },
  [928] = {
    [sym_subscript] = STATE(1447),
    [sym_variable_name] = ACTIONS(2944),
    [anon_sym_DOLLAR] = ACTIONS(2946),
    [anon_sym_POUND] = ACTIONS(2948),
    [anon_sym_DASH] = ACTIONS(2946),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2950),
    [anon_sym_STAR] = ACTIONS(2946),
    [anon_sym_AT] = ACTIONS(2946),
    [anon_sym_QMARK] = ACTIONS(2946),
    [anon_sym_0] = ACTIONS(2952),
    [anon_sym__] = ACTIONS(2952),
  },
  [929] = {
    [sym_for_statement] = STATE(1448),
    [sym_while_statement] = STATE(1448),
    [sym_if_statement] = STATE(1448),
    [sym_case_statement] = STATE(1448),
    [sym_function_definition] = STATE(1448),
    [sym_subshell] = STATE(1448),
    [sym_pipeline] = STATE(1448),
    [sym_list] = STATE(1448),
    [sym_bracket_command] = STATE(1448),
    [sym_command] = STATE(1448),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(1449),
    [sym_declaration_command] = STATE(1448),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [930] = {
    [sym_for_statement] = STATE(1450),
    [sym_while_statement] = STATE(1450),
    [sym_if_statement] = STATE(1450),
    [sym_case_statement] = STATE(1450),
    [sym_function_definition] = STATE(1450),
    [sym_subshell] = STATE(1450),
    [sym_pipeline] = STATE(1450),
    [sym_list] = STATE(1450),
    [sym_bracket_command] = STATE(1450),
    [sym_command] = STATE(1450),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(1451),
    [sym_declaration_command] = STATE(1450),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [931] = {
    [sym_for_statement] = STATE(1452),
    [sym_while_statement] = STATE(1452),
    [sym_if_statement] = STATE(1452),
    [sym_case_statement] = STATE(1452),
    [sym_function_definition] = STATE(1452),
    [sym_subshell] = STATE(1452),
    [sym_pipeline] = STATE(1452),
    [sym_list] = STATE(1452),
    [sym_bracket_command] = STATE(1452),
    [sym_command] = STATE(1452),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(1453),
    [sym_declaration_command] = STATE(1452),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [932] = {
    [sym_file_redirect] = STATE(466),
    [sym_heredoc_redirect] = STATE(466),
    [sym_herestring_redirect] = STATE(466),
    [aux_sym_while_statement_repeat1] = STATE(1454),
    [sym_file_descriptor] = ACTIONS(880),
    [anon_sym_PIPE] = ACTIONS(2703),
    [anon_sym_PIPE_AMP] = ACTIONS(2705),
    [anon_sym_AMP_AMP] = ACTIONS(2705),
    [anon_sym_PIPE_PIPE] = ACTIONS(2705),
    [anon_sym_LT] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(882),
    [anon_sym_GT_GT] = ACTIONS(884),
    [anon_sym_AMP_GT] = ACTIONS(882),
    [anon_sym_AMP_GT_GT] = ACTIONS(884),
    [anon_sym_LT_AMP] = ACTIONS(884),
    [anon_sym_GT_AMP] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(814),
    [anon_sym_LT_LT_DASH] = ACTIONS(816),
    [anon_sym_LT_LT_LT] = ACTIONS(886),
    [anon_sym_BQUOTE] = ACTIONS(2705),
    [sym_comment] = ACTIONS(52),
  },
  [933] = {
    [anon_sym_RPAREN] = ACTIONS(2954),
    [sym_comment] = ACTIONS(52),
  },
  [934] = {
    [sym_file_redirect] = STATE(1376),
    [sym_file_descriptor] = ACTIONS(2956),
    [anon_sym_PIPE] = ACTIONS(2723),
    [anon_sym_PIPE_AMP] = ACTIONS(2725),
    [anon_sym_AMP_AMP] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2958),
    [anon_sym_GT] = ACTIONS(2958),
    [anon_sym_GT_GT] = ACTIONS(2960),
    [anon_sym_AMP_GT] = ACTIONS(2958),
    [anon_sym_AMP_GT_GT] = ACTIONS(2960),
    [anon_sym_LT_AMP] = ACTIONS(2960),
    [anon_sym_GT_AMP] = ACTIONS(2960),
    [anon_sym_BQUOTE] = ACTIONS(2725),
    [sym_comment] = ACTIONS(52),
  },
  [935] = {
    [sym_concatenation] = STATE(1379),
    [sym_string] = STATE(1459),
    [sym_array] = STATE(1379),
    [sym_simple_expansion] = STATE(1459),
    [sym_expansion] = STATE(1459),
    [sym_command_substitution] = STATE(1459),
    [sym_process_substitution] = STATE(1459),
    [sym__empty_value] = ACTIONS(2745),
    [anon_sym_LPAREN] = ACTIONS(2747),
    [sym__special_characters] = ACTIONS(2962),
    [anon_sym_DQUOTE] = ACTIONS(838),
    [sym_raw_string] = ACTIONS(2964),
    [anon_sym_DOLLAR] = ACTIONS(842),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(844),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(846),
    [anon_sym_BQUOTE] = ACTIONS(2966),
    [anon_sym_LT_LPAREN] = ACTIONS(848),
    [anon_sym_GT_LPAREN] = ACTIONS(848),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2968),
  },
  [936] = {
    [sym_string] = STATE(1460),
    [sym_simple_expansion] = STATE(1460),
    [sym_expansion] = STATE(1460),
    [sym_command_substitution] = STATE(1460),
    [sym_process_substitution] = STATE(1460),
    [sym__special_characters] = ACTIONS(2970),
    [anon_sym_DQUOTE] = ACTIONS(838),
    [sym_raw_string] = ACTIONS(2972),
    [anon_sym_DOLLAR] = ACTIONS(842),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(844),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(846),
    [anon_sym_BQUOTE] = ACTIONS(2966),
    [anon_sym_LT_LPAREN] = ACTIONS(848),
    [anon_sym_GT_LPAREN] = ACTIONS(848),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2970),
  },
  [937] = {
    [aux_sym_concatenation_repeat1] = STATE(1461),
    [sym__concat] = ACTIONS(1826),
    [sym_variable_name] = ACTIONS(646),
    [anon_sym_PIPE] = ACTIONS(1300),
    [anon_sym_PIPE_AMP] = ACTIONS(646),
    [anon_sym_AMP_AMP] = ACTIONS(646),
    [anon_sym_PIPE_PIPE] = ACTIONS(646),
    [sym__special_characters] = ACTIONS(1300),
    [anon_sym_DQUOTE] = ACTIONS(646),
    [sym_raw_string] = ACTIONS(646),
    [anon_sym_DOLLAR] = ACTIONS(1300),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(646),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(646),
    [anon_sym_BQUOTE] = ACTIONS(646),
    [anon_sym_LT_LPAREN] = ACTIONS(646),
    [anon_sym_GT_LPAREN] = ACTIONS(646),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1300),
    [sym_word] = ACTIONS(648),
  },
  [938] = {
    [sym__concat] = ACTIONS(650),
    [sym_variable_name] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(1302),
    [anon_sym_PIPE_AMP] = ACTIONS(650),
    [anon_sym_AMP_AMP] = ACTIONS(650),
    [anon_sym_PIPE_PIPE] = ACTIONS(650),
    [sym__special_characters] = ACTIONS(1302),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [sym_raw_string] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(1302),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(650),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LT_LPAREN] = ACTIONS(650),
    [anon_sym_GT_LPAREN] = ACTIONS(650),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1302),
    [sym_word] = ACTIONS(652),
  },
  [939] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(2974),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [940] = {
    [sym__concat] = ACTIONS(680),
    [sym_variable_name] = ACTIONS(680),
    [anon_sym_PIPE] = ACTIONS(1306),
    [anon_sym_PIPE_AMP] = ACTIONS(680),
    [anon_sym_AMP_AMP] = ACTIONS(680),
    [anon_sym_PIPE_PIPE] = ACTIONS(680),
    [sym__special_characters] = ACTIONS(1306),
    [anon_sym_DQUOTE] = ACTIONS(680),
    [sym_raw_string] = ACTIONS(680),
    [anon_sym_DOLLAR] = ACTIONS(1306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(680),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(680),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [anon_sym_LT_LPAREN] = ACTIONS(680),
    [anon_sym_GT_LPAREN] = ACTIONS(680),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1306),
    [sym_word] = ACTIONS(682),
  },
  [941] = {
    [sym__concat] = ACTIONS(684),
    [sym_variable_name] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(1308),
    [anon_sym_PIPE_AMP] = ACTIONS(684),
    [anon_sym_AMP_AMP] = ACTIONS(684),
    [anon_sym_PIPE_PIPE] = ACTIONS(684),
    [sym__special_characters] = ACTIONS(1308),
    [anon_sym_DQUOTE] = ACTIONS(684),
    [sym_raw_string] = ACTIONS(684),
    [anon_sym_DOLLAR] = ACTIONS(1308),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(684),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(684),
    [anon_sym_BQUOTE] = ACTIONS(684),
    [anon_sym_LT_LPAREN] = ACTIONS(684),
    [anon_sym_GT_LPAREN] = ACTIONS(684),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1308),
    [sym_word] = ACTIONS(686),
  },
  [942] = {
    [sym__concat] = ACTIONS(688),
    [sym_variable_name] = ACTIONS(688),
    [anon_sym_PIPE] = ACTIONS(1310),
    [anon_sym_PIPE_AMP] = ACTIONS(688),
    [anon_sym_AMP_AMP] = ACTIONS(688),
    [anon_sym_PIPE_PIPE] = ACTIONS(688),
    [sym__special_characters] = ACTIONS(1310),
    [anon_sym_DQUOTE] = ACTIONS(688),
    [sym_raw_string] = ACTIONS(688),
    [anon_sym_DOLLAR] = ACTIONS(1310),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(688),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(688),
    [anon_sym_BQUOTE] = ACTIONS(688),
    [anon_sym_LT_LPAREN] = ACTIONS(688),
    [anon_sym_GT_LPAREN] = ACTIONS(688),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1310),
    [sym_word] = ACTIONS(690),
  },
  [943] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(2976),
    [sym_comment] = ACTIONS(52),
  },
  [944] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1465),
    [anon_sym_RBRACE] = ACTIONS(2978),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [945] = {
    [sym_subscript] = STATE(1469),
    [sym_variable_name] = ACTIONS(2980),
    [anon_sym_DOLLAR] = ACTIONS(2982),
    [anon_sym_DASH] = ACTIONS(2982),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2984),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AT] = ACTIONS(2982),
    [anon_sym_QMARK] = ACTIONS(2982),
    [anon_sym_0] = ACTIONS(2986),
    [anon_sym__] = ACTIONS(2986),
  },
  [946] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1471),
    [anon_sym_RBRACE] = ACTIONS(2988),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [947] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1473),
    [anon_sym_RBRACE] = ACTIONS(2990),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [948] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(2992),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [949] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(2992),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [950] = {
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(2992),
    [sym_comment] = ACTIONS(52),
  },
  [951] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(2992),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [952] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(2994),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [953] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(2994),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [954] = {
    [sym_variable_assignment] = STATE(435),
    [sym_subscript] = STATE(483),
    [sym_concatenation] = STATE(435),
    [sym_string] = STATE(477),
    [sym_simple_expansion] = STATE(477),
    [sym_expansion] = STATE(477),
    [sym_command_substitution] = STATE(477),
    [sym_process_substitution] = STATE(477),
    [aux_sym_declaration_command_repeat1] = STATE(954),
    [sym_variable_name] = ACTIONS(2996),
    [anon_sym_PIPE] = ACTIONS(2784),
    [anon_sym_PIPE_AMP] = ACTIONS(2786),
    [anon_sym_AMP_AMP] = ACTIONS(2786),
    [anon_sym_PIPE_PIPE] = ACTIONS(2786),
    [sym__special_characters] = ACTIONS(2999),
    [anon_sym_DQUOTE] = ACTIONS(3002),
    [sym_raw_string] = ACTIONS(3005),
    [anon_sym_DOLLAR] = ACTIONS(3008),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3011),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3014),
    [anon_sym_BQUOTE] = ACTIONS(3017),
    [anon_sym_LT_LPAREN] = ACTIONS(3020),
    [anon_sym_GT_LPAREN] = ACTIONS(3020),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2812),
    [sym_word] = ACTIONS(3023),
  },
  [955] = {
    [sym_file_descriptor] = ACTIONS(1522),
    [sym__concat] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_PIPE_AMP] = ACTIONS(1522),
    [anon_sym_AMP_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1522),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_GT_GT] = ACTIONS(1522),
    [anon_sym_AMP_GT] = ACTIONS(2430),
    [anon_sym_AMP_GT_GT] = ACTIONS(1522),
    [anon_sym_LT_AMP] = ACTIONS(1522),
    [anon_sym_GT_AMP] = ACTIONS(1522),
    [anon_sym_LT_LT] = ACTIONS(2430),
    [anon_sym_LT_LT_DASH] = ACTIONS(1522),
    [anon_sym_LT_LT_LT] = ACTIONS(1522),
    [sym__special_characters] = ACTIONS(2430),
    [anon_sym_DQUOTE] = ACTIONS(1522),
    [sym_raw_string] = ACTIONS(1522),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1522),
    [anon_sym_BQUOTE] = ACTIONS(1522),
    [anon_sym_LT_LPAREN] = ACTIONS(1522),
    [anon_sym_GT_LPAREN] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2430),
  },
  [956] = {
    [aux_sym_concatenation_repeat1] = STATE(956),
    [sym_file_descriptor] = ACTIONS(1522),
    [sym__concat] = ACTIONS(3026),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_PIPE_AMP] = ACTIONS(1522),
    [anon_sym_AMP_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1522),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_GT_GT] = ACTIONS(1522),
    [anon_sym_AMP_GT] = ACTIONS(2430),
    [anon_sym_AMP_GT_GT] = ACTIONS(1522),
    [anon_sym_LT_AMP] = ACTIONS(1522),
    [anon_sym_GT_AMP] = ACTIONS(1522),
    [anon_sym_LT_LT] = ACTIONS(2430),
    [anon_sym_LT_LT_DASH] = ACTIONS(1522),
    [anon_sym_LT_LT_LT] = ACTIONS(1522),
    [sym__special_characters] = ACTIONS(2430),
    [anon_sym_DQUOTE] = ACTIONS(1522),
    [sym_raw_string] = ACTIONS(1522),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1522),
    [anon_sym_BQUOTE] = ACTIONS(1522),
    [anon_sym_LT_LPAREN] = ACTIONS(1522),
    [anon_sym_GT_LPAREN] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2430),
  },
  [957] = {
    [sym_file_descriptor] = ACTIONS(1553),
    [sym__concat] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(2435),
    [anon_sym_PIPE_AMP] = ACTIONS(1553),
    [anon_sym_AMP_AMP] = ACTIONS(1553),
    [anon_sym_PIPE_PIPE] = ACTIONS(1553),
    [anon_sym_LT] = ACTIONS(2435),
    [anon_sym_GT] = ACTIONS(2435),
    [anon_sym_GT_GT] = ACTIONS(1553),
    [anon_sym_AMP_GT] = ACTIONS(2435),
    [anon_sym_AMP_GT_GT] = ACTIONS(1553),
    [anon_sym_LT_AMP] = ACTIONS(1553),
    [anon_sym_GT_AMP] = ACTIONS(1553),
    [anon_sym_LT_LT] = ACTIONS(2435),
    [anon_sym_LT_LT_DASH] = ACTIONS(1553),
    [anon_sym_LT_LT_LT] = ACTIONS(1553),
    [sym__special_characters] = ACTIONS(2435),
    [anon_sym_DQUOTE] = ACTIONS(1553),
    [sym_raw_string] = ACTIONS(1553),
    [anon_sym_DOLLAR] = ACTIONS(2435),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1553),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1553),
    [anon_sym_BQUOTE] = ACTIONS(1553),
    [anon_sym_LT_LPAREN] = ACTIONS(1553),
    [anon_sym_GT_LPAREN] = ACTIONS(1553),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2435),
  },
  [958] = {
    [sym_concatenation] = STATE(1479),
    [sym_string] = STATE(1478),
    [sym_simple_expansion] = STATE(1478),
    [sym_expansion] = STATE(1478),
    [sym_command_substitution] = STATE(1478),
    [sym_process_substitution] = STATE(1478),
    [anon_sym_RBRACE] = ACTIONS(3029),
    [sym__special_characters] = ACTIONS(3031),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(3033),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3035),
  },
  [959] = {
    [sym_file_descriptor] = ACTIONS(1598),
    [sym__concat] = ACTIONS(1598),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_PIPE_AMP] = ACTIONS(1598),
    [anon_sym_AMP_AMP] = ACTIONS(1598),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_LT] = ACTIONS(2445),
    [anon_sym_GT] = ACTIONS(2445),
    [anon_sym_GT_GT] = ACTIONS(1598),
    [anon_sym_AMP_GT] = ACTIONS(2445),
    [anon_sym_AMP_GT_GT] = ACTIONS(1598),
    [anon_sym_LT_AMP] = ACTIONS(1598),
    [anon_sym_GT_AMP] = ACTIONS(1598),
    [anon_sym_LT_LT] = ACTIONS(2445),
    [anon_sym_LT_LT_DASH] = ACTIONS(1598),
    [anon_sym_LT_LT_LT] = ACTIONS(1598),
    [sym__special_characters] = ACTIONS(2445),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [sym_raw_string] = ACTIONS(1598),
    [anon_sym_DOLLAR] = ACTIONS(2445),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1598),
    [anon_sym_BQUOTE] = ACTIONS(1598),
    [anon_sym_LT_LPAREN] = ACTIONS(1598),
    [anon_sym_GT_LPAREN] = ACTIONS(1598),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2445),
  },
  [960] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3037),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [961] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(3039),
    [sym_comment] = ACTIONS(52),
  },
  [962] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1483),
    [anon_sym_RBRACE] = ACTIONS(3041),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [963] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1485),
    [anon_sym_RBRACE] = ACTIONS(3043),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [964] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1486),
    [anon_sym_RBRACE] = ACTIONS(3029),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [965] = {
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(2455),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [anon_sym_LT] = ACTIONS(2455),
    [anon_sym_GT] = ACTIONS(2455),
    [anon_sym_GT_GT] = ACTIONS(1642),
    [anon_sym_AMP_GT] = ACTIONS(2455),
    [anon_sym_AMP_GT_GT] = ACTIONS(1642),
    [anon_sym_LT_AMP] = ACTIONS(1642),
    [anon_sym_GT_AMP] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(2455),
    [anon_sym_LT_LT_DASH] = ACTIONS(1642),
    [anon_sym_LT_LT_LT] = ACTIONS(1642),
    [sym__special_characters] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [sym_raw_string] = ACTIONS(1642),
    [anon_sym_DOLLAR] = ACTIONS(2455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [anon_sym_LT_LPAREN] = ACTIONS(1642),
    [anon_sym_GT_LPAREN] = ACTIONS(1642),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2455),
  },
  [966] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3045),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [967] = {
    [sym_file_descriptor] = ACTIONS(1648),
    [sym__concat] = ACTIONS(1648),
    [anon_sym_PIPE] = ACTIONS(2459),
    [anon_sym_PIPE_AMP] = ACTIONS(1648),
    [anon_sym_AMP_AMP] = ACTIONS(1648),
    [anon_sym_PIPE_PIPE] = ACTIONS(1648),
    [anon_sym_LT] = ACTIONS(2459),
    [anon_sym_GT] = ACTIONS(2459),
    [anon_sym_GT_GT] = ACTIONS(1648),
    [anon_sym_AMP_GT] = ACTIONS(2459),
    [anon_sym_AMP_GT_GT] = ACTIONS(1648),
    [anon_sym_LT_AMP] = ACTIONS(1648),
    [anon_sym_GT_AMP] = ACTIONS(1648),
    [anon_sym_LT_LT] = ACTIONS(2459),
    [anon_sym_LT_LT_DASH] = ACTIONS(1648),
    [anon_sym_LT_LT_LT] = ACTIONS(1648),
    [sym__special_characters] = ACTIONS(2459),
    [anon_sym_DQUOTE] = ACTIONS(1648),
    [sym_raw_string] = ACTIONS(1648),
    [anon_sym_DOLLAR] = ACTIONS(2459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1648),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1648),
    [anon_sym_BQUOTE] = ACTIONS(1648),
    [anon_sym_LT_LPAREN] = ACTIONS(1648),
    [anon_sym_GT_LPAREN] = ACTIONS(1648),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2459),
  },
  [968] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3029),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [969] = {
    [sym_file_descriptor] = ACTIONS(1762),
    [sym__concat] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(2461),
    [anon_sym_PIPE_AMP] = ACTIONS(1762),
    [anon_sym_AMP_AMP] = ACTIONS(1762),
    [anon_sym_PIPE_PIPE] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(2461),
    [anon_sym_GT] = ACTIONS(2461),
    [anon_sym_GT_GT] = ACTIONS(1762),
    [anon_sym_AMP_GT] = ACTIONS(2461),
    [anon_sym_AMP_GT_GT] = ACTIONS(1762),
    [anon_sym_LT_AMP] = ACTIONS(1762),
    [anon_sym_GT_AMP] = ACTIONS(1762),
    [anon_sym_LT_LT] = ACTIONS(2461),
    [anon_sym_LT_LT_DASH] = ACTIONS(1762),
    [anon_sym_LT_LT_LT] = ACTIONS(1762),
    [sym__special_characters] = ACTIONS(2461),
    [anon_sym_DQUOTE] = ACTIONS(1762),
    [sym_raw_string] = ACTIONS(1762),
    [anon_sym_DOLLAR] = ACTIONS(2461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1762),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1762),
    [anon_sym_BQUOTE] = ACTIONS(1762),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2461),
  },
  [970] = {
    [sym_file_descriptor] = ACTIONS(1902),
    [sym__concat] = ACTIONS(1902),
    [anon_sym_PIPE] = ACTIONS(2463),
    [anon_sym_PIPE_AMP] = ACTIONS(1902),
    [anon_sym_AMP_AMP] = ACTIONS(1902),
    [anon_sym_PIPE_PIPE] = ACTIONS(1902),
    [anon_sym_LT] = ACTIONS(2463),
    [anon_sym_GT] = ACTIONS(2463),
    [anon_sym_GT_GT] = ACTIONS(1902),
    [anon_sym_AMP_GT] = ACTIONS(2463),
    [anon_sym_AMP_GT_GT] = ACTIONS(1902),
    [anon_sym_LT_AMP] = ACTIONS(1902),
    [anon_sym_GT_AMP] = ACTIONS(1902),
    [anon_sym_LT_LT] = ACTIONS(2463),
    [anon_sym_LT_LT_DASH] = ACTIONS(1902),
    [anon_sym_LT_LT_LT] = ACTIONS(1902),
    [sym__special_characters] = ACTIONS(2463),
    [anon_sym_DQUOTE] = ACTIONS(1902),
    [sym_raw_string] = ACTIONS(1902),
    [anon_sym_DOLLAR] = ACTIONS(2463),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1902),
    [anon_sym_BQUOTE] = ACTIONS(1902),
    [anon_sym_LT_LPAREN] = ACTIONS(1902),
    [anon_sym_GT_LPAREN] = ACTIONS(1902),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2463),
  },
  [971] = {
    [sym_compound_statement] = STATE(1488),
    [anon_sym_LBRACE] = ACTIONS(1692),
    [sym_comment] = ACTIONS(52),
  },
  [972] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(2839),
    [anon_sym_PIPE_AMP] = ACTIONS(2841),
    [anon_sym_AMP_AMP] = ACTIONS(2841),
    [anon_sym_PIPE_PIPE] = ACTIONS(2841),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(2841),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [973] = {
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(2843),
    [anon_sym_PIPE_PIPE] = ACTIONS(2843),
    [anon_sym_BQUOTE] = ACTIONS(2843),
    [sym_comment] = ACTIONS(52),
  },
  [974] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(2843),
    [anon_sym_PIPE_PIPE] = ACTIONS(2843),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [975] = {
    [sym_concatenation] = STATE(1414),
    [sym_string] = STATE(1490),
    [sym_simple_expansion] = STATE(1490),
    [sym_expansion] = STATE(1490),
    [sym_command_substitution] = STATE(1490),
    [sym_process_substitution] = STATE(1490),
    [sym__special_characters] = ACTIONS(3047),
    [anon_sym_DQUOTE] = ACTIONS(1880),
    [sym_raw_string] = ACTIONS(3049),
    [anon_sym_DOLLAR] = ACTIONS(1884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1888),
    [anon_sym_BQUOTE] = ACTIONS(1890),
    [anon_sym_LT_LPAREN] = ACTIONS(1892),
    [anon_sym_GT_LPAREN] = ACTIONS(1892),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3051),
  },
  [976] = {
    [aux_sym_concatenation_repeat1] = STATE(1492),
    [sym_file_descriptor] = ACTIONS(614),
    [sym__concat] = ACTIONS(3053),
    [anon_sym_PIPE] = ACTIONS(618),
    [anon_sym_PIPE_AMP] = ACTIONS(614),
    [anon_sym_AMP_AMP] = ACTIONS(614),
    [anon_sym_PIPE_PIPE] = ACTIONS(614),
    [anon_sym_LT] = ACTIONS(618),
    [anon_sym_GT] = ACTIONS(618),
    [anon_sym_GT_GT] = ACTIONS(614),
    [anon_sym_AMP_GT] = ACTIONS(618),
    [anon_sym_AMP_GT_GT] = ACTIONS(614),
    [anon_sym_LT_AMP] = ACTIONS(614),
    [anon_sym_GT_AMP] = ACTIONS(614),
    [anon_sym_LT_LT] = ACTIONS(618),
    [anon_sym_LT_LT_DASH] = ACTIONS(614),
    [anon_sym_LT_LT_LT] = ACTIONS(614),
    [anon_sym_BQUOTE] = ACTIONS(614),
    [sym_comment] = ACTIONS(52),
  },
  [977] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(1494),
    [anon_sym_DQUOTE] = ACTIONS(3055),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [978] = {
    [aux_sym_concatenation_repeat1] = STATE(1492),
    [sym_file_descriptor] = ACTIONS(622),
    [sym__concat] = ACTIONS(3053),
    [anon_sym_PIPE] = ACTIONS(624),
    [anon_sym_PIPE_AMP] = ACTIONS(622),
    [anon_sym_AMP_AMP] = ACTIONS(622),
    [anon_sym_PIPE_PIPE] = ACTIONS(622),
    [anon_sym_LT] = ACTIONS(624),
    [anon_sym_GT] = ACTIONS(624),
    [anon_sym_GT_GT] = ACTIONS(622),
    [anon_sym_AMP_GT] = ACTIONS(624),
    [anon_sym_AMP_GT_GT] = ACTIONS(622),
    [anon_sym_LT_AMP] = ACTIONS(622),
    [anon_sym_GT_AMP] = ACTIONS(622),
    [anon_sym_LT_LT] = ACTIONS(624),
    [anon_sym_LT_LT_DASH] = ACTIONS(622),
    [anon_sym_LT_LT_LT] = ACTIONS(622),
    [anon_sym_BQUOTE] = ACTIONS(622),
    [sym_comment] = ACTIONS(52),
  },
  [979] = {
    [sym_string] = STATE(1497),
    [anon_sym_DQUOTE] = ACTIONS(1880),
    [anon_sym_DOLLAR] = ACTIONS(3057),
    [anon_sym_POUND] = ACTIONS(3057),
    [anon_sym_DASH] = ACTIONS(3057),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3059),
    [anon_sym_STAR] = ACTIONS(3057),
    [anon_sym_AT] = ACTIONS(3057),
    [anon_sym_QMARK] = ACTIONS(3057),
    [anon_sym_0] = ACTIONS(3061),
    [anon_sym__] = ACTIONS(3061),
  },
  [980] = {
    [sym_subscript] = STATE(1502),
    [sym_variable_name] = ACTIONS(3063),
    [anon_sym_DOLLAR] = ACTIONS(3065),
    [anon_sym_POUND] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3065),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3069),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_AT] = ACTIONS(3065),
    [anon_sym_QMARK] = ACTIONS(3065),
    [anon_sym_0] = ACTIONS(3071),
    [anon_sym__] = ACTIONS(3071),
  },
  [981] = {
    [sym_for_statement] = STATE(1503),
    [sym_while_statement] = STATE(1503),
    [sym_if_statement] = STATE(1503),
    [sym_case_statement] = STATE(1503),
    [sym_function_definition] = STATE(1503),
    [sym_subshell] = STATE(1503),
    [sym_pipeline] = STATE(1503),
    [sym_list] = STATE(1503),
    [sym_bracket_command] = STATE(1503),
    [sym_command] = STATE(1503),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(1504),
    [sym_declaration_command] = STATE(1503),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [982] = {
    [sym_for_statement] = STATE(1505),
    [sym_while_statement] = STATE(1505),
    [sym_if_statement] = STATE(1505),
    [sym_case_statement] = STATE(1505),
    [sym_function_definition] = STATE(1505),
    [sym_subshell] = STATE(1505),
    [sym_pipeline] = STATE(1505),
    [sym_list] = STATE(1505),
    [sym_bracket_command] = STATE(1505),
    [sym_command] = STATE(1505),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(1506),
    [sym_declaration_command] = STATE(1505),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [983] = {
    [sym_for_statement] = STATE(1507),
    [sym_while_statement] = STATE(1507),
    [sym_if_statement] = STATE(1507),
    [sym_case_statement] = STATE(1507),
    [sym_function_definition] = STATE(1507),
    [sym_subshell] = STATE(1507),
    [sym_pipeline] = STATE(1507),
    [sym_list] = STATE(1507),
    [sym_bracket_command] = STATE(1507),
    [sym_command] = STATE(1507),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(1508),
    [sym_declaration_command] = STATE(1507),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [984] = {
    [aux_sym_concatenation_repeat1] = STATE(1492),
    [sym_file_descriptor] = ACTIONS(1956),
    [sym__concat] = ACTIONS(3053),
    [anon_sym_PIPE] = ACTIONS(2877),
    [anon_sym_PIPE_AMP] = ACTIONS(1956),
    [anon_sym_AMP_AMP] = ACTIONS(1956),
    [anon_sym_PIPE_PIPE] = ACTIONS(1956),
    [anon_sym_LT] = ACTIONS(2877),
    [anon_sym_GT] = ACTIONS(2877),
    [anon_sym_GT_GT] = ACTIONS(1956),
    [anon_sym_AMP_GT] = ACTIONS(2877),
    [anon_sym_AMP_GT_GT] = ACTIONS(1956),
    [anon_sym_LT_AMP] = ACTIONS(1956),
    [anon_sym_GT_AMP] = ACTIONS(1956),
    [anon_sym_LT_LT] = ACTIONS(2877),
    [anon_sym_LT_LT_DASH] = ACTIONS(1956),
    [anon_sym_LT_LT_LT] = ACTIONS(1956),
    [anon_sym_BQUOTE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(52),
  },
  [985] = {
    [aux_sym_concatenation_repeat1] = STATE(1492),
    [sym_file_descriptor] = ACTIONS(1960),
    [sym__concat] = ACTIONS(3053),
    [anon_sym_PIPE] = ACTIONS(2879),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(2879),
    [anon_sym_GT] = ACTIONS(2879),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(2879),
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(2879),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [sym_comment] = ACTIONS(52),
  },
  [986] = {
    [sym_concatenation] = STATE(467),
    [sym_string] = STATE(510),
    [sym_simple_expansion] = STATE(510),
    [sym_expansion] = STATE(510),
    [sym_command_substitution] = STATE(510),
    [sym_process_substitution] = STATE(510),
    [aux_sym_for_statement_repeat1] = STATE(986),
    [sym_file_descriptor] = ACTIONS(1389),
    [anon_sym_PIPE] = ACTIONS(1334),
    [anon_sym_PIPE_AMP] = ACTIONS(1389),
    [anon_sym_AMP_AMP] = ACTIONS(1389),
    [anon_sym_PIPE_PIPE] = ACTIONS(1389),
    [anon_sym_LT] = ACTIONS(1334),
    [anon_sym_GT] = ACTIONS(1334),
    [anon_sym_GT_GT] = ACTIONS(1389),
    [anon_sym_AMP_GT] = ACTIONS(1334),
    [anon_sym_AMP_GT_GT] = ACTIONS(1389),
    [anon_sym_LT_AMP] = ACTIONS(1389),
    [anon_sym_GT_AMP] = ACTIONS(1389),
    [anon_sym_LT_LT] = ACTIONS(1334),
    [anon_sym_LT_LT_DASH] = ACTIONS(1389),
    [anon_sym_LT_LT_LT] = ACTIONS(1389),
    [sym__special_characters] = ACTIONS(3073),
    [anon_sym_DQUOTE] = ACTIONS(3076),
    [sym_raw_string] = ACTIONS(3079),
    [anon_sym_DOLLAR] = ACTIONS(3082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3085),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3088),
    [anon_sym_BQUOTE] = ACTIONS(3091),
    [anon_sym_LT_LPAREN] = ACTIONS(3094),
    [anon_sym_GT_LPAREN] = ACTIONS(3094),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3097),
  },
  [987] = {
    [sym_file_redirect] = STATE(466),
    [sym_heredoc_redirect] = STATE(466),
    [sym_herestring_redirect] = STATE(466),
    [aux_sym_while_statement_repeat1] = STATE(988),
    [sym_file_descriptor] = ACTIONS(880),
    [anon_sym_PIPE] = ACTIONS(2908),
    [anon_sym_PIPE_AMP] = ACTIONS(2910),
    [anon_sym_AMP_AMP] = ACTIONS(2910),
    [anon_sym_PIPE_PIPE] = ACTIONS(2910),
    [anon_sym_LT] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(882),
    [anon_sym_GT_GT] = ACTIONS(884),
    [anon_sym_AMP_GT] = ACTIONS(882),
    [anon_sym_AMP_GT_GT] = ACTIONS(884),
    [anon_sym_LT_AMP] = ACTIONS(884),
    [anon_sym_GT_AMP] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(814),
    [anon_sym_LT_LT_DASH] = ACTIONS(816),
    [anon_sym_LT_LT_LT] = ACTIONS(886),
    [anon_sym_BQUOTE] = ACTIONS(2910),
    [sym_comment] = ACTIONS(52),
  },
  [988] = {
    [sym_file_redirect] = STATE(466),
    [sym_heredoc_redirect] = STATE(466),
    [sym_herestring_redirect] = STATE(466),
    [aux_sym_while_statement_repeat1] = STATE(988),
    [sym_file_descriptor] = ACTIONS(3100),
    [anon_sym_PIPE] = ACTIONS(2915),
    [anon_sym_PIPE_AMP] = ACTIONS(2917),
    [anon_sym_AMP_AMP] = ACTIONS(2917),
    [anon_sym_PIPE_PIPE] = ACTIONS(2917),
    [anon_sym_LT] = ACTIONS(3103),
    [anon_sym_GT] = ACTIONS(3103),
    [anon_sym_GT_GT] = ACTIONS(3106),
    [anon_sym_AMP_GT] = ACTIONS(3103),
    [anon_sym_AMP_GT_GT] = ACTIONS(3106),
    [anon_sym_LT_AMP] = ACTIONS(3106),
    [anon_sym_GT_AMP] = ACTIONS(3106),
    [anon_sym_LT_LT] = ACTIONS(2925),
    [anon_sym_LT_LT_DASH] = ACTIONS(2928),
    [anon_sym_LT_LT_LT] = ACTIONS(3109),
    [anon_sym_BQUOTE] = ACTIONS(2917),
    [sym_comment] = ACTIONS(52),
  },
  [989] = {
    [sym_file_redirect] = STATE(466),
    [sym_heredoc_redirect] = STATE(466),
    [sym_herestring_redirect] = STATE(466),
    [sym_concatenation] = STATE(467),
    [sym_string] = STATE(510),
    [sym_simple_expansion] = STATE(510),
    [sym_expansion] = STATE(510),
    [sym_command_substitution] = STATE(510),
    [sym_process_substitution] = STATE(510),
    [aux_sym_for_statement_repeat1] = STATE(986),
    [aux_sym_while_statement_repeat1] = STATE(1509),
    [sym_file_descriptor] = ACTIONS(880),
    [anon_sym_PIPE] = ACTIONS(2908),
    [anon_sym_PIPE_AMP] = ACTIONS(2910),
    [anon_sym_AMP_AMP] = ACTIONS(2910),
    [anon_sym_PIPE_PIPE] = ACTIONS(2910),
    [anon_sym_LT] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(882),
    [anon_sym_GT_GT] = ACTIONS(884),
    [anon_sym_AMP_GT] = ACTIONS(882),
    [anon_sym_AMP_GT_GT] = ACTIONS(884),
    [anon_sym_LT_AMP] = ACTIONS(884),
    [anon_sym_GT_AMP] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(814),
    [anon_sym_LT_LT_DASH] = ACTIONS(816),
    [anon_sym_LT_LT_LT] = ACTIONS(886),
    [sym__special_characters] = ACTIONS(888),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(890),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(2910),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(892),
  },
  [990] = {
    [sym_file_redirect] = STATE(1510),
    [sym_file_descriptor] = ACTIONS(1182),
    [anon_sym_PIPE] = ACTIONS(2249),
    [anon_sym_SEMI_SEMI] = ACTIONS(2249),
    [anon_sym_PIPE_AMP] = ACTIONS(2249),
    [anon_sym_AMP_AMP] = ACTIONS(2249),
    [anon_sym_PIPE_PIPE] = ACTIONS(2249),
    [anon_sym_LT] = ACTIONS(1186),
    [anon_sym_GT] = ACTIONS(1186),
    [anon_sym_GT_GT] = ACTIONS(1186),
    [anon_sym_AMP_GT] = ACTIONS(1186),
    [anon_sym_AMP_GT_GT] = ACTIONS(1186),
    [anon_sym_LT_AMP] = ACTIONS(1186),
    [anon_sym_GT_AMP] = ACTIONS(1186),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2249),
    [anon_sym_LF] = ACTIONS(2249),
    [anon_sym_AMP] = ACTIONS(2249),
  },
  [991] = {
    [aux_sym_concatenation_repeat1] = STATE(995),
    [sym_file_descriptor] = ACTIONS(1032),
    [sym__concat] = ACTIONS(1916),
    [anon_sym_PIPE] = ACTIONS(3112),
    [anon_sym_SEMI_SEMI] = ACTIONS(3112),
    [anon_sym_PIPE_AMP] = ACTIONS(3112),
    [anon_sym_AMP_AMP] = ACTIONS(3112),
    [anon_sym_PIPE_PIPE] = ACTIONS(3112),
    [anon_sym_LT] = ACTIONS(3112),
    [anon_sym_GT] = ACTIONS(3112),
    [anon_sym_GT_GT] = ACTIONS(3112),
    [anon_sym_AMP_GT] = ACTIONS(3112),
    [anon_sym_AMP_GT_GT] = ACTIONS(3112),
    [anon_sym_LT_AMP] = ACTIONS(3112),
    [anon_sym_GT_AMP] = ACTIONS(3112),
    [anon_sym_LT_LT] = ACTIONS(3112),
    [anon_sym_LT_LT_DASH] = ACTIONS(3112),
    [anon_sym_LT_LT_LT] = ACTIONS(3112),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3112),
    [anon_sym_LF] = ACTIONS(3112),
    [anon_sym_AMP] = ACTIONS(3112),
  },
  [992] = {
    [aux_sym_concatenation_repeat1] = STATE(995),
    [sym_file_descriptor] = ACTIONS(1036),
    [sym__concat] = ACTIONS(1916),
    [anon_sym_PIPE] = ACTIONS(3114),
    [anon_sym_SEMI_SEMI] = ACTIONS(3114),
    [anon_sym_PIPE_AMP] = ACTIONS(3114),
    [anon_sym_AMP_AMP] = ACTIONS(3114),
    [anon_sym_PIPE_PIPE] = ACTIONS(3114),
    [anon_sym_LT] = ACTIONS(3114),
    [anon_sym_GT] = ACTIONS(3114),
    [anon_sym_GT_GT] = ACTIONS(3114),
    [anon_sym_AMP_GT] = ACTIONS(3114),
    [anon_sym_AMP_GT_GT] = ACTIONS(3114),
    [anon_sym_LT_AMP] = ACTIONS(3114),
    [anon_sym_GT_AMP] = ACTIONS(3114),
    [anon_sym_LT_LT] = ACTIONS(3114),
    [anon_sym_LT_LT_DASH] = ACTIONS(3114),
    [anon_sym_LT_LT_LT] = ACTIONS(3114),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3114),
    [anon_sym_LF] = ACTIONS(3114),
    [anon_sym_AMP] = ACTIONS(3114),
  },
  [993] = {
    [sym_file_descriptor] = ACTIONS(1036),
    [anon_sym_PIPE] = ACTIONS(3114),
    [anon_sym_RPAREN] = ACTIONS(3114),
    [anon_sym_SEMI_SEMI] = ACTIONS(3114),
    [anon_sym_PIPE_AMP] = ACTIONS(3114),
    [anon_sym_AMP_AMP] = ACTIONS(3114),
    [anon_sym_PIPE_PIPE] = ACTIONS(3114),
    [anon_sym_LT] = ACTIONS(3114),
    [anon_sym_GT] = ACTIONS(3114),
    [anon_sym_GT_GT] = ACTIONS(3114),
    [anon_sym_AMP_GT] = ACTIONS(3114),
    [anon_sym_AMP_GT_GT] = ACTIONS(3114),
    [anon_sym_LT_AMP] = ACTIONS(3114),
    [anon_sym_GT_AMP] = ACTIONS(3114),
    [anon_sym_LT_LT] = ACTIONS(3114),
    [anon_sym_LT_LT_DASH] = ACTIONS(3114),
    [anon_sym_LT_LT_LT] = ACTIONS(3114),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3114),
    [anon_sym_LF] = ACTIONS(3114),
    [anon_sym_AMP] = ACTIONS(3114),
  },
  [994] = {
    [sym_string] = STATE(1511),
    [sym_simple_expansion] = STATE(1511),
    [sym_expansion] = STATE(1511),
    [sym_command_substitution] = STATE(1511),
    [sym_process_substitution] = STATE(1511),
    [sym__special_characters] = ACTIONS(3116),
    [anon_sym_DQUOTE] = ACTIONS(914),
    [sym_raw_string] = ACTIONS(3118),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(922),
    [anon_sym_BQUOTE] = ACTIONS(924),
    [anon_sym_LT_LPAREN] = ACTIONS(926),
    [anon_sym_GT_LPAREN] = ACTIONS(926),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3116),
  },
  [995] = {
    [aux_sym_concatenation_repeat1] = STATE(1512),
    [sym_file_descriptor] = ACTIONS(646),
    [sym__concat] = ACTIONS(1916),
    [anon_sym_PIPE] = ACTIONS(648),
    [anon_sym_SEMI_SEMI] = ACTIONS(648),
    [anon_sym_PIPE_AMP] = ACTIONS(648),
    [anon_sym_AMP_AMP] = ACTIONS(648),
    [anon_sym_PIPE_PIPE] = ACTIONS(648),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(648),
    [anon_sym_GT_GT] = ACTIONS(648),
    [anon_sym_AMP_GT] = ACTIONS(648),
    [anon_sym_AMP_GT_GT] = ACTIONS(648),
    [anon_sym_LT_AMP] = ACTIONS(648),
    [anon_sym_GT_AMP] = ACTIONS(648),
    [anon_sym_LT_LT] = ACTIONS(648),
    [anon_sym_LT_LT_DASH] = ACTIONS(648),
    [anon_sym_LT_LT_LT] = ACTIONS(648),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(648),
    [anon_sym_LF] = ACTIONS(648),
    [anon_sym_AMP] = ACTIONS(648),
  },
  [996] = {
    [sym_file_descriptor] = ACTIONS(650),
    [sym__concat] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(652),
    [anon_sym_SEMI_SEMI] = ACTIONS(652),
    [anon_sym_PIPE_AMP] = ACTIONS(652),
    [anon_sym_AMP_AMP] = ACTIONS(652),
    [anon_sym_PIPE_PIPE] = ACTIONS(652),
    [anon_sym_LT] = ACTIONS(652),
    [anon_sym_GT] = ACTIONS(652),
    [anon_sym_GT_GT] = ACTIONS(652),
    [anon_sym_AMP_GT] = ACTIONS(652),
    [anon_sym_AMP_GT_GT] = ACTIONS(652),
    [anon_sym_LT_AMP] = ACTIONS(652),
    [anon_sym_GT_AMP] = ACTIONS(652),
    [anon_sym_LT_LT] = ACTIONS(652),
    [anon_sym_LT_LT_DASH] = ACTIONS(652),
    [anon_sym_LT_LT_LT] = ACTIONS(652),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(652),
    [anon_sym_LF] = ACTIONS(652),
    [anon_sym_AMP] = ACTIONS(652),
  },
  [997] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(3120),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [998] = {
    [sym_file_descriptor] = ACTIONS(680),
    [sym__concat] = ACTIONS(680),
    [anon_sym_PIPE] = ACTIONS(682),
    [anon_sym_SEMI_SEMI] = ACTIONS(682),
    [anon_sym_PIPE_AMP] = ACTIONS(682),
    [anon_sym_AMP_AMP] = ACTIONS(682),
    [anon_sym_PIPE_PIPE] = ACTIONS(682),
    [anon_sym_LT] = ACTIONS(682),
    [anon_sym_GT] = ACTIONS(682),
    [anon_sym_GT_GT] = ACTIONS(682),
    [anon_sym_AMP_GT] = ACTIONS(682),
    [anon_sym_AMP_GT_GT] = ACTIONS(682),
    [anon_sym_LT_AMP] = ACTIONS(682),
    [anon_sym_GT_AMP] = ACTIONS(682),
    [anon_sym_LT_LT] = ACTIONS(682),
    [anon_sym_LT_LT_DASH] = ACTIONS(682),
    [anon_sym_LT_LT_LT] = ACTIONS(682),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(682),
    [anon_sym_LF] = ACTIONS(682),
    [anon_sym_AMP] = ACTIONS(682),
  },
  [999] = {
    [sym_file_descriptor] = ACTIONS(684),
    [sym__concat] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(686),
    [anon_sym_SEMI_SEMI] = ACTIONS(686),
    [anon_sym_PIPE_AMP] = ACTIONS(686),
    [anon_sym_AMP_AMP] = ACTIONS(686),
    [anon_sym_PIPE_PIPE] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(686),
    [anon_sym_GT] = ACTIONS(686),
    [anon_sym_GT_GT] = ACTIONS(686),
    [anon_sym_AMP_GT] = ACTIONS(686),
    [anon_sym_AMP_GT_GT] = ACTIONS(686),
    [anon_sym_LT_AMP] = ACTIONS(686),
    [anon_sym_GT_AMP] = ACTIONS(686),
    [anon_sym_LT_LT] = ACTIONS(686),
    [anon_sym_LT_LT_DASH] = ACTIONS(686),
    [anon_sym_LT_LT_LT] = ACTIONS(686),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(686),
    [anon_sym_LF] = ACTIONS(686),
    [anon_sym_AMP] = ACTIONS(686),
  },
  [1000] = {
    [sym_file_descriptor] = ACTIONS(688),
    [sym__concat] = ACTIONS(688),
    [anon_sym_PIPE] = ACTIONS(690),
    [anon_sym_SEMI_SEMI] = ACTIONS(690),
    [anon_sym_PIPE_AMP] = ACTIONS(690),
    [anon_sym_AMP_AMP] = ACTIONS(690),
    [anon_sym_PIPE_PIPE] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(690),
    [anon_sym_GT] = ACTIONS(690),
    [anon_sym_GT_GT] = ACTIONS(690),
    [anon_sym_AMP_GT] = ACTIONS(690),
    [anon_sym_AMP_GT_GT] = ACTIONS(690),
    [anon_sym_LT_AMP] = ACTIONS(690),
    [anon_sym_GT_AMP] = ACTIONS(690),
    [anon_sym_LT_LT] = ACTIONS(690),
    [anon_sym_LT_LT_DASH] = ACTIONS(690),
    [anon_sym_LT_LT_LT] = ACTIONS(690),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(690),
    [anon_sym_LF] = ACTIONS(690),
    [anon_sym_AMP] = ACTIONS(690),
  },
  [1001] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(3122),
    [sym_comment] = ACTIONS(52),
  },
  [1002] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1516),
    [anon_sym_RBRACE] = ACTIONS(3124),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1003] = {
    [sym_subscript] = STATE(1520),
    [sym_variable_name] = ACTIONS(3126),
    [anon_sym_DOLLAR] = ACTIONS(3128),
    [anon_sym_DASH] = ACTIONS(3128),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3130),
    [anon_sym_STAR] = ACTIONS(3128),
    [anon_sym_AT] = ACTIONS(3128),
    [anon_sym_QMARK] = ACTIONS(3128),
    [anon_sym_0] = ACTIONS(3132),
    [anon_sym__] = ACTIONS(3132),
  },
  [1004] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1522),
    [anon_sym_RBRACE] = ACTIONS(3134),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1005] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1524),
    [anon_sym_RBRACE] = ACTIONS(3136),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1006] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3138),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [1007] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3138),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1008] = {
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(3138),
    [sym_comment] = ACTIONS(52),
  },
  [1009] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(3138),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1010] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3140),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [1011] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3140),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1012] = {
    [sym__heredoc_middle] = ACTIONS(3142),
    [sym__heredoc_end] = ACTIONS(3142),
    [anon_sym_DOLLAR] = ACTIONS(3144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3142),
    [sym_comment] = ACTIONS(52),
  },
  [1013] = {
    [sym_file_descriptor] = ACTIONS(3146),
    [anon_sym_PIPE] = ACTIONS(3148),
    [anon_sym_RPAREN] = ACTIONS(3148),
    [anon_sym_SEMI_SEMI] = ACTIONS(3148),
    [anon_sym_PIPE_AMP] = ACTIONS(3148),
    [anon_sym_AMP_AMP] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(3148),
    [anon_sym_LT] = ACTIONS(3148),
    [anon_sym_GT] = ACTIONS(3148),
    [anon_sym_GT_GT] = ACTIONS(3148),
    [anon_sym_AMP_GT] = ACTIONS(3148),
    [anon_sym_AMP_GT_GT] = ACTIONS(3148),
    [anon_sym_LT_AMP] = ACTIONS(3148),
    [anon_sym_GT_AMP] = ACTIONS(3148),
    [anon_sym_LT_LT] = ACTIONS(3148),
    [anon_sym_LT_LT_DASH] = ACTIONS(3148),
    [anon_sym_LT_LT_LT] = ACTIONS(3148),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_LF] = ACTIONS(3148),
    [anon_sym_AMP] = ACTIONS(3148),
  },
  [1014] = {
    [sym_string] = STATE(1530),
    [anon_sym_DQUOTE] = ACTIONS(3150),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_POUND] = ACTIONS(3152),
    [anon_sym_DASH] = ACTIONS(3152),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3154),
    [anon_sym_STAR] = ACTIONS(3152),
    [anon_sym_AT] = ACTIONS(3152),
    [anon_sym_QMARK] = ACTIONS(3152),
    [anon_sym_0] = ACTIONS(3156),
    [anon_sym__] = ACTIONS(3156),
  },
  [1015] = {
    [sym_subscript] = STATE(1535),
    [sym_variable_name] = ACTIONS(3158),
    [anon_sym_DOLLAR] = ACTIONS(3160),
    [anon_sym_POUND] = ACTIONS(3162),
    [anon_sym_DASH] = ACTIONS(3160),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3164),
    [anon_sym_STAR] = ACTIONS(3160),
    [anon_sym_AT] = ACTIONS(3160),
    [anon_sym_QMARK] = ACTIONS(3160),
    [anon_sym_0] = ACTIONS(3166),
    [anon_sym__] = ACTIONS(3166),
  },
  [1016] = {
    [sym_simple_expansion] = STATE(1012),
    [sym_expansion] = STATE(1012),
    [aux_sym_heredoc_repeat1] = STATE(1537),
    [sym__heredoc_middle] = ACTIONS(1944),
    [sym__heredoc_end] = ACTIONS(3168),
    [anon_sym_DOLLAR] = ACTIONS(1948),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1950),
    [sym_comment] = ACTIONS(52),
  },
  [1017] = {
    [aux_sym_concatenation_repeat1] = STATE(355),
    [sym_file_descriptor] = ACTIONS(1092),
    [sym__concat] = ACTIONS(616),
    [sym_variable_name] = ACTIONS(1092),
    [anon_sym_LT] = ACTIONS(2681),
    [anon_sym_GT] = ACTIONS(2681),
    [anon_sym_GT_GT] = ACTIONS(1092),
    [anon_sym_AMP_GT] = ACTIONS(2681),
    [anon_sym_AMP_GT_GT] = ACTIONS(1092),
    [anon_sym_LT_AMP] = ACTIONS(1092),
    [anon_sym_GT_AMP] = ACTIONS(1092),
    [sym__special_characters] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(1092),
    [sym_raw_string] = ACTIONS(1092),
    [anon_sym_DOLLAR] = ACTIONS(2681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1092),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1092),
    [anon_sym_BQUOTE] = ACTIONS(1092),
    [anon_sym_LT_LPAREN] = ACTIONS(1092),
    [anon_sym_GT_LPAREN] = ACTIONS(1092),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2681),
  },
  [1018] = {
    [aux_sym_concatenation_repeat1] = STATE(355),
    [sym_file_descriptor] = ACTIONS(1068),
    [sym__concat] = ACTIONS(616),
    [sym_variable_name] = ACTIONS(1068),
    [anon_sym_LT] = ACTIONS(2675),
    [anon_sym_GT] = ACTIONS(2675),
    [anon_sym_GT_GT] = ACTIONS(1068),
    [anon_sym_AMP_GT] = ACTIONS(2675),
    [anon_sym_AMP_GT_GT] = ACTIONS(1068),
    [anon_sym_LT_AMP] = ACTIONS(1068),
    [anon_sym_GT_AMP] = ACTIONS(1068),
    [sym__special_characters] = ACTIONS(2675),
    [anon_sym_DQUOTE] = ACTIONS(1068),
    [sym_raw_string] = ACTIONS(1068),
    [anon_sym_DOLLAR] = ACTIONS(2675),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1068),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1068),
    [anon_sym_BQUOTE] = ACTIONS(1068),
    [anon_sym_LT_LPAREN] = ACTIONS(1068),
    [anon_sym_GT_LPAREN] = ACTIONS(1068),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2675),
  },
  [1019] = {
    [sym_file_redirect] = STATE(185),
    [sym_heredoc_redirect] = STATE(185),
    [sym_herestring_redirect] = STATE(185),
    [aux_sym_while_statement_repeat1] = STATE(538),
    [sym_file_descriptor] = ACTIONS(308),
    [anon_sym_PIPE] = ACTIONS(3170),
    [anon_sym_SEMI_SEMI] = ACTIONS(3170),
    [anon_sym_PIPE_AMP] = ACTIONS(3170),
    [anon_sym_AMP_AMP] = ACTIONS(3170),
    [anon_sym_PIPE_PIPE] = ACTIONS(3170),
    [anon_sym_LT] = ACTIONS(312),
    [anon_sym_GT] = ACTIONS(312),
    [anon_sym_GT_GT] = ACTIONS(312),
    [anon_sym_AMP_GT] = ACTIONS(312),
    [anon_sym_AMP_GT_GT] = ACTIONS(312),
    [anon_sym_LT_AMP] = ACTIONS(312),
    [anon_sym_GT_AMP] = ACTIONS(312),
    [anon_sym_LT_LT] = ACTIONS(314),
    [anon_sym_LT_LT_DASH] = ACTIONS(314),
    [anon_sym_LT_LT_LT] = ACTIONS(316),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3170),
    [anon_sym_LF] = ACTIONS(3170),
    [anon_sym_AMP] = ACTIONS(3170),
  },
  [1020] = {
    [sym__concat] = ACTIONS(3172),
    [anon_sym_EQ] = ACTIONS(3174),
    [anon_sym_PLUS_EQ] = ACTIONS(3174),
    [sym_comment] = ACTIONS(52),
  },
  [1021] = {
    [sym__concat] = ACTIONS(1522),
    [anon_sym_RBRACK] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
  },
  [1022] = {
    [anon_sym_EQ] = ACTIONS(3174),
    [anon_sym_PLUS_EQ] = ACTIONS(3174),
    [sym_comment] = ACTIONS(52),
  },
  [1023] = {
    [sym_string] = STATE(1021),
    [sym_simple_expansion] = STATE(1021),
    [sym_expansion] = STATE(1021),
    [sym_command_substitution] = STATE(1021),
    [sym_process_substitution] = STATE(1021),
    [sym__special_characters] = ACTIONS(2018),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(2016),
    [anon_sym_DOLLAR] = ACTIONS(360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(364),
    [anon_sym_BQUOTE] = ACTIONS(366),
    [anon_sym_LT_LPAREN] = ACTIONS(368),
    [anon_sym_GT_LPAREN] = ACTIONS(368),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2018),
  },
  [1024] = {
    [aux_sym_concatenation_repeat1] = STATE(1024),
    [sym__concat] = ACTIONS(3176),
    [anon_sym_RBRACK] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
  },
  [1025] = {
    [sym__concat] = ACTIONS(1553),
    [anon_sym_RBRACK] = ACTIONS(1553),
    [sym_comment] = ACTIONS(52),
  },
  [1026] = {
    [sym__concat] = ACTIONS(3179),
    [anon_sym_EQ] = ACTIONS(3181),
    [anon_sym_PLUS_EQ] = ACTIONS(3181),
    [sym_comment] = ACTIONS(52),
  },
  [1027] = {
    [anon_sym_EQ] = ACTIONS(3181),
    [anon_sym_PLUS_EQ] = ACTIONS(3181),
    [sym_comment] = ACTIONS(52),
  },
  [1028] = {
    [sym_concatenation] = STATE(1543),
    [sym_string] = STATE(1542),
    [sym_simple_expansion] = STATE(1542),
    [sym_expansion] = STATE(1542),
    [sym_command_substitution] = STATE(1542),
    [sym_process_substitution] = STATE(1542),
    [anon_sym_RBRACE] = ACTIONS(3183),
    [sym__special_characters] = ACTIONS(3185),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(3187),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3189),
  },
  [1029] = {
    [sym__concat] = ACTIONS(1598),
    [anon_sym_RBRACK] = ACTIONS(1598),
    [sym_comment] = ACTIONS(52),
  },
  [1030] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3191),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1031] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(3193),
    [sym_comment] = ACTIONS(52),
  },
  [1032] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1547),
    [anon_sym_RBRACE] = ACTIONS(3195),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1033] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1549),
    [anon_sym_RBRACE] = ACTIONS(3197),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1034] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1550),
    [anon_sym_RBRACE] = ACTIONS(3183),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1035] = {
    [sym__concat] = ACTIONS(1642),
    [anon_sym_RBRACK] = ACTIONS(1642),
    [sym_comment] = ACTIONS(52),
  },
  [1036] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3199),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1037] = {
    [sym__concat] = ACTIONS(1648),
    [anon_sym_RBRACK] = ACTIONS(1648),
    [sym_comment] = ACTIONS(52),
  },
  [1038] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3183),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1039] = {
    [sym__concat] = ACTIONS(1762),
    [anon_sym_RBRACK] = ACTIONS(1762),
    [sym_comment] = ACTIONS(52),
  },
  [1040] = {
    [sym__concat] = ACTIONS(1902),
    [anon_sym_RBRACK] = ACTIONS(1902),
    [sym_comment] = ACTIONS(52),
  },
  [1041] = {
    [sym_string] = STATE(1552),
    [sym_simple_expansion] = STATE(1552),
    [sym_expansion] = STATE(1552),
    [sym_command_substitution] = STATE(1552),
    [sym_process_substitution] = STATE(1552),
    [sym__special_characters] = ACTIONS(3201),
    [anon_sym_DQUOTE] = ACTIONS(1076),
    [sym_raw_string] = ACTIONS(3203),
    [anon_sym_DOLLAR] = ACTIONS(1080),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1084),
    [anon_sym_BQUOTE] = ACTIONS(1086),
    [anon_sym_LT_LPAREN] = ACTIONS(1088),
    [anon_sym_GT_LPAREN] = ACTIONS(1088),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3201),
  },
  [1042] = {
    [aux_sym_concatenation_repeat1] = STATE(1553),
    [sym__concat] = ACTIONS(2060),
    [anon_sym_RPAREN] = ACTIONS(646),
    [sym__special_characters] = ACTIONS(1300),
    [anon_sym_DQUOTE] = ACTIONS(646),
    [sym_raw_string] = ACTIONS(646),
    [anon_sym_DOLLAR] = ACTIONS(1300),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(646),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(646),
    [anon_sym_BQUOTE] = ACTIONS(646),
    [anon_sym_LT_LPAREN] = ACTIONS(646),
    [anon_sym_GT_LPAREN] = ACTIONS(646),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1300),
  },
  [1043] = {
    [sym__concat] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym__special_characters] = ACTIONS(1302),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [sym_raw_string] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(1302),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(650),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LT_LPAREN] = ACTIONS(650),
    [anon_sym_GT_LPAREN] = ACTIONS(650),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1302),
  },
  [1044] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(3205),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [1045] = {
    [sym__concat] = ACTIONS(680),
    [anon_sym_RPAREN] = ACTIONS(680),
    [sym__special_characters] = ACTIONS(1306),
    [anon_sym_DQUOTE] = ACTIONS(680),
    [sym_raw_string] = ACTIONS(680),
    [anon_sym_DOLLAR] = ACTIONS(1306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(680),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(680),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [anon_sym_LT_LPAREN] = ACTIONS(680),
    [anon_sym_GT_LPAREN] = ACTIONS(680),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1306),
  },
  [1046] = {
    [sym__concat] = ACTIONS(684),
    [anon_sym_RPAREN] = ACTIONS(684),
    [sym__special_characters] = ACTIONS(1308),
    [anon_sym_DQUOTE] = ACTIONS(684),
    [sym_raw_string] = ACTIONS(684),
    [anon_sym_DOLLAR] = ACTIONS(1308),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(684),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(684),
    [anon_sym_BQUOTE] = ACTIONS(684),
    [anon_sym_LT_LPAREN] = ACTIONS(684),
    [anon_sym_GT_LPAREN] = ACTIONS(684),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1308),
  },
  [1047] = {
    [sym__concat] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(688),
    [sym__special_characters] = ACTIONS(1310),
    [anon_sym_DQUOTE] = ACTIONS(688),
    [sym_raw_string] = ACTIONS(688),
    [anon_sym_DOLLAR] = ACTIONS(1310),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(688),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(688),
    [anon_sym_BQUOTE] = ACTIONS(688),
    [anon_sym_LT_LPAREN] = ACTIONS(688),
    [anon_sym_GT_LPAREN] = ACTIONS(688),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1310),
  },
  [1048] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(3207),
    [sym_comment] = ACTIONS(52),
  },
  [1049] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1557),
    [anon_sym_RBRACE] = ACTIONS(3209),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1050] = {
    [sym_subscript] = STATE(1561),
    [sym_variable_name] = ACTIONS(3211),
    [anon_sym_DOLLAR] = ACTIONS(3213),
    [anon_sym_DASH] = ACTIONS(3213),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3215),
    [anon_sym_STAR] = ACTIONS(3213),
    [anon_sym_AT] = ACTIONS(3213),
    [anon_sym_QMARK] = ACTIONS(3213),
    [anon_sym_0] = ACTIONS(3217),
    [anon_sym__] = ACTIONS(3217),
  },
  [1051] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1563),
    [anon_sym_RBRACE] = ACTIONS(3219),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1052] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1565),
    [anon_sym_RBRACE] = ACTIONS(3221),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1053] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3223),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [1054] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3223),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1055] = {
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(3223),
    [sym_comment] = ACTIONS(52),
  },
  [1056] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(3223),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1057] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3225),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [1058] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3225),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1059] = {
    [sym_file_descriptor] = ACTIONS(3227),
    [sym_variable_name] = ACTIONS(3227),
    [anon_sym_PIPE] = ACTIONS(3229),
    [anon_sym_RPAREN] = ACTIONS(3229),
    [anon_sym_SEMI_SEMI] = ACTIONS(3229),
    [anon_sym_PIPE_AMP] = ACTIONS(3229),
    [anon_sym_AMP_AMP] = ACTIONS(3229),
    [anon_sym_PIPE_PIPE] = ACTIONS(3229),
    [anon_sym_LT] = ACTIONS(3229),
    [anon_sym_GT] = ACTIONS(3229),
    [anon_sym_GT_GT] = ACTIONS(3229),
    [anon_sym_AMP_GT] = ACTIONS(3229),
    [anon_sym_AMP_GT_GT] = ACTIONS(3229),
    [anon_sym_LT_AMP] = ACTIONS(3229),
    [anon_sym_GT_AMP] = ACTIONS(3229),
    [sym__special_characters] = ACTIONS(3229),
    [anon_sym_DQUOTE] = ACTIONS(3229),
    [sym_raw_string] = ACTIONS(3229),
    [anon_sym_DOLLAR] = ACTIONS(3229),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3229),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3229),
    [anon_sym_BQUOTE] = ACTIONS(3229),
    [anon_sym_LT_LPAREN] = ACTIONS(3229),
    [anon_sym_GT_LPAREN] = ACTIONS(3229),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(3229),
    [anon_sym_SEMI] = ACTIONS(3229),
    [anon_sym_LF] = ACTIONS(3229),
    [anon_sym_AMP] = ACTIONS(3229),
  },
  [1060] = {
    [sym_concatenation] = STATE(572),
    [sym_string] = STATE(566),
    [sym_simple_expansion] = STATE(566),
    [sym_expansion] = STATE(566),
    [sym_command_substitution] = STATE(566),
    [sym_process_substitution] = STATE(566),
    [aux_sym_for_statement_repeat1] = STATE(1060),
    [anon_sym_RPAREN] = ACTIONS(1389),
    [sym__special_characters] = ACTIONS(3231),
    [anon_sym_DQUOTE] = ACTIONS(3234),
    [sym_raw_string] = ACTIONS(3237),
    [anon_sym_DOLLAR] = ACTIONS(3240),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3243),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3246),
    [anon_sym_BQUOTE] = ACTIONS(3249),
    [anon_sym_LT_LPAREN] = ACTIONS(3252),
    [anon_sym_GT_LPAREN] = ACTIONS(3252),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3255),
  },
  [1061] = {
    [sym_file_descriptor] = ACTIONS(1522),
    [sym__concat] = ACTIONS(1522),
    [sym_variable_name] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(1524),
    [anon_sym_SEMI_SEMI] = ACTIONS(1524),
    [anon_sym_PIPE_AMP] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1524),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_LT] = ACTIONS(1524),
    [anon_sym_GT] = ACTIONS(1524),
    [anon_sym_GT_GT] = ACTIONS(1524),
    [anon_sym_AMP_GT] = ACTIONS(1524),
    [anon_sym_AMP_GT_GT] = ACTIONS(1524),
    [anon_sym_LT_AMP] = ACTIONS(1524),
    [anon_sym_GT_AMP] = ACTIONS(1524),
    [sym__special_characters] = ACTIONS(1524),
    [anon_sym_DQUOTE] = ACTIONS(1524),
    [sym_raw_string] = ACTIONS(1524),
    [anon_sym_DOLLAR] = ACTIONS(1524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1524),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1524),
    [anon_sym_BQUOTE] = ACTIONS(1524),
    [anon_sym_LT_LPAREN] = ACTIONS(1524),
    [anon_sym_GT_LPAREN] = ACTIONS(1524),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1524),
    [anon_sym_SEMI] = ACTIONS(1524),
    [anon_sym_LF] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1524),
  },
  [1062] = {
    [aux_sym_concatenation_repeat1] = STATE(1062),
    [sym_file_descriptor] = ACTIONS(1522),
    [sym__concat] = ACTIONS(3258),
    [sym_variable_name] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(1524),
    [anon_sym_SEMI_SEMI] = ACTIONS(1524),
    [anon_sym_PIPE_AMP] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1524),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_LT] = ACTIONS(1524),
    [anon_sym_GT] = ACTIONS(1524),
    [anon_sym_GT_GT] = ACTIONS(1524),
    [anon_sym_AMP_GT] = ACTIONS(1524),
    [anon_sym_AMP_GT_GT] = ACTIONS(1524),
    [anon_sym_LT_AMP] = ACTIONS(1524),
    [anon_sym_GT_AMP] = ACTIONS(1524),
    [sym__special_characters] = ACTIONS(1524),
    [anon_sym_DQUOTE] = ACTIONS(1524),
    [sym_raw_string] = ACTIONS(1524),
    [anon_sym_DOLLAR] = ACTIONS(1524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1524),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1524),
    [anon_sym_BQUOTE] = ACTIONS(1524),
    [anon_sym_LT_LPAREN] = ACTIONS(1524),
    [anon_sym_GT_LPAREN] = ACTIONS(1524),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1524),
    [anon_sym_SEMI] = ACTIONS(1524),
    [anon_sym_LF] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1524),
  },
  [1063] = {
    [sym_file_descriptor] = ACTIONS(1553),
    [sym__concat] = ACTIONS(1553),
    [sym_variable_name] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(1555),
    [anon_sym_SEMI_SEMI] = ACTIONS(1555),
    [anon_sym_PIPE_AMP] = ACTIONS(1555),
    [anon_sym_AMP_AMP] = ACTIONS(1555),
    [anon_sym_PIPE_PIPE] = ACTIONS(1555),
    [anon_sym_LT] = ACTIONS(1555),
    [anon_sym_GT] = ACTIONS(1555),
    [anon_sym_GT_GT] = ACTIONS(1555),
    [anon_sym_AMP_GT] = ACTIONS(1555),
    [anon_sym_AMP_GT_GT] = ACTIONS(1555),
    [anon_sym_LT_AMP] = ACTIONS(1555),
    [anon_sym_GT_AMP] = ACTIONS(1555),
    [sym__special_characters] = ACTIONS(1555),
    [anon_sym_DQUOTE] = ACTIONS(1555),
    [sym_raw_string] = ACTIONS(1555),
    [anon_sym_DOLLAR] = ACTIONS(1555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1555),
    [anon_sym_BQUOTE] = ACTIONS(1555),
    [anon_sym_LT_LPAREN] = ACTIONS(1555),
    [anon_sym_GT_LPAREN] = ACTIONS(1555),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1555),
    [anon_sym_SEMI] = ACTIONS(1555),
    [anon_sym_LF] = ACTIONS(1555),
    [anon_sym_AMP] = ACTIONS(1555),
  },
  [1064] = {
    [sym_concatenation] = STATE(1571),
    [sym_string] = STATE(1570),
    [sym_simple_expansion] = STATE(1570),
    [sym_expansion] = STATE(1570),
    [sym_command_substitution] = STATE(1570),
    [sym_process_substitution] = STATE(1570),
    [anon_sym_RBRACE] = ACTIONS(3261),
    [sym__special_characters] = ACTIONS(3263),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(3265),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3267),
  },
  [1065] = {
    [sym_file_descriptor] = ACTIONS(1598),
    [sym__concat] = ACTIONS(1598),
    [sym_variable_name] = ACTIONS(1598),
    [anon_sym_PIPE] = ACTIONS(1600),
    [anon_sym_SEMI_SEMI] = ACTIONS(1600),
    [anon_sym_PIPE_AMP] = ACTIONS(1600),
    [anon_sym_AMP_AMP] = ACTIONS(1600),
    [anon_sym_PIPE_PIPE] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1600),
    [anon_sym_GT] = ACTIONS(1600),
    [anon_sym_GT_GT] = ACTIONS(1600),
    [anon_sym_AMP_GT] = ACTIONS(1600),
    [anon_sym_AMP_GT_GT] = ACTIONS(1600),
    [anon_sym_LT_AMP] = ACTIONS(1600),
    [anon_sym_GT_AMP] = ACTIONS(1600),
    [sym__special_characters] = ACTIONS(1600),
    [anon_sym_DQUOTE] = ACTIONS(1600),
    [sym_raw_string] = ACTIONS(1600),
    [anon_sym_DOLLAR] = ACTIONS(1600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1600),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1600),
    [anon_sym_BQUOTE] = ACTIONS(1600),
    [anon_sym_LT_LPAREN] = ACTIONS(1600),
    [anon_sym_GT_LPAREN] = ACTIONS(1600),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1600),
    [anon_sym_SEMI] = ACTIONS(1600),
    [anon_sym_LF] = ACTIONS(1600),
    [anon_sym_AMP] = ACTIONS(1600),
  },
  [1066] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3269),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1067] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(3271),
    [sym_comment] = ACTIONS(52),
  },
  [1068] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1575),
    [anon_sym_RBRACE] = ACTIONS(3273),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1069] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1577),
    [anon_sym_RBRACE] = ACTIONS(3275),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1070] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1578),
    [anon_sym_RBRACE] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1071] = {
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(1642),
    [sym_variable_name] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1644),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1644),
    [anon_sym_BQUOTE] = ACTIONS(1644),
    [anon_sym_LT_LPAREN] = ACTIONS(1644),
    [anon_sym_GT_LPAREN] = ACTIONS(1644),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [1072] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3277),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1073] = {
    [sym_file_descriptor] = ACTIONS(1648),
    [sym__concat] = ACTIONS(1648),
    [sym_variable_name] = ACTIONS(1648),
    [anon_sym_PIPE] = ACTIONS(1650),
    [anon_sym_SEMI_SEMI] = ACTIONS(1650),
    [anon_sym_PIPE_AMP] = ACTIONS(1650),
    [anon_sym_AMP_AMP] = ACTIONS(1650),
    [anon_sym_PIPE_PIPE] = ACTIONS(1650),
    [anon_sym_LT] = ACTIONS(1650),
    [anon_sym_GT] = ACTIONS(1650),
    [anon_sym_GT_GT] = ACTIONS(1650),
    [anon_sym_AMP_GT] = ACTIONS(1650),
    [anon_sym_AMP_GT_GT] = ACTIONS(1650),
    [anon_sym_LT_AMP] = ACTIONS(1650),
    [anon_sym_GT_AMP] = ACTIONS(1650),
    [sym__special_characters] = ACTIONS(1650),
    [anon_sym_DQUOTE] = ACTIONS(1650),
    [sym_raw_string] = ACTIONS(1650),
    [anon_sym_DOLLAR] = ACTIONS(1650),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1650),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1650),
    [anon_sym_BQUOTE] = ACTIONS(1650),
    [anon_sym_LT_LPAREN] = ACTIONS(1650),
    [anon_sym_GT_LPAREN] = ACTIONS(1650),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(1650),
    [anon_sym_LF] = ACTIONS(1650),
    [anon_sym_AMP] = ACTIONS(1650),
  },
  [1074] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1075] = {
    [sym_file_descriptor] = ACTIONS(1762),
    [sym__concat] = ACTIONS(1762),
    [sym_variable_name] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(1764),
    [anon_sym_SEMI_SEMI] = ACTIONS(1764),
    [anon_sym_PIPE_AMP] = ACTIONS(1764),
    [anon_sym_AMP_AMP] = ACTIONS(1764),
    [anon_sym_PIPE_PIPE] = ACTIONS(1764),
    [anon_sym_LT] = ACTIONS(1764),
    [anon_sym_GT] = ACTIONS(1764),
    [anon_sym_GT_GT] = ACTIONS(1764),
    [anon_sym_AMP_GT] = ACTIONS(1764),
    [anon_sym_AMP_GT_GT] = ACTIONS(1764),
    [anon_sym_LT_AMP] = ACTIONS(1764),
    [anon_sym_GT_AMP] = ACTIONS(1764),
    [sym__special_characters] = ACTIONS(1764),
    [anon_sym_DQUOTE] = ACTIONS(1764),
    [sym_raw_string] = ACTIONS(1764),
    [anon_sym_DOLLAR] = ACTIONS(1764),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1764),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1764),
    [anon_sym_BQUOTE] = ACTIONS(1764),
    [anon_sym_LT_LPAREN] = ACTIONS(1764),
    [anon_sym_GT_LPAREN] = ACTIONS(1764),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1764),
    [anon_sym_SEMI] = ACTIONS(1764),
    [anon_sym_LF] = ACTIONS(1764),
    [anon_sym_AMP] = ACTIONS(1764),
  },
  [1076] = {
    [sym_file_descriptor] = ACTIONS(1902),
    [sym__concat] = ACTIONS(1902),
    [sym_variable_name] = ACTIONS(1902),
    [anon_sym_PIPE] = ACTIONS(1904),
    [anon_sym_SEMI_SEMI] = ACTIONS(1904),
    [anon_sym_PIPE_AMP] = ACTIONS(1904),
    [anon_sym_AMP_AMP] = ACTIONS(1904),
    [anon_sym_PIPE_PIPE] = ACTIONS(1904),
    [anon_sym_LT] = ACTIONS(1904),
    [anon_sym_GT] = ACTIONS(1904),
    [anon_sym_GT_GT] = ACTIONS(1904),
    [anon_sym_AMP_GT] = ACTIONS(1904),
    [anon_sym_AMP_GT_GT] = ACTIONS(1904),
    [anon_sym_LT_AMP] = ACTIONS(1904),
    [anon_sym_GT_AMP] = ACTIONS(1904),
    [sym__special_characters] = ACTIONS(1904),
    [anon_sym_DQUOTE] = ACTIONS(1904),
    [sym_raw_string] = ACTIONS(1904),
    [anon_sym_DOLLAR] = ACTIONS(1904),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1904),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1904),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [anon_sym_LT_LPAREN] = ACTIONS(1904),
    [anon_sym_GT_LPAREN] = ACTIONS(1904),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1904),
    [anon_sym_SEMI] = ACTIONS(1904),
    [anon_sym_LF] = ACTIONS(1904),
    [anon_sym_AMP] = ACTIONS(1904),
  },
  [1077] = {
    [sym_string] = STATE(1580),
    [sym_simple_expansion] = STATE(1580),
    [sym_expansion] = STATE(1580),
    [sym_command_substitution] = STATE(1580),
    [sym_process_substitution] = STATE(1580),
    [sym__special_characters] = ACTIONS(3279),
    [anon_sym_DQUOTE] = ACTIONS(1118),
    [sym_raw_string] = ACTIONS(3281),
    [anon_sym_DOLLAR] = ACTIONS(1122),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1124),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1126),
    [anon_sym_BQUOTE] = ACTIONS(1128),
    [anon_sym_LT_LPAREN] = ACTIONS(1130),
    [anon_sym_GT_LPAREN] = ACTIONS(1130),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3279),
  },
  [1078] = {
    [aux_sym_concatenation_repeat1] = STATE(1581),
    [sym__concat] = ACTIONS(2108),
    [anon_sym_SEMI_SEMI] = ACTIONS(648),
    [sym__special_characters] = ACTIONS(648),
    [anon_sym_DQUOTE] = ACTIONS(648),
    [sym_raw_string] = ACTIONS(648),
    [anon_sym_DOLLAR] = ACTIONS(648),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(648),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(648),
    [anon_sym_BQUOTE] = ACTIONS(648),
    [anon_sym_LT_LPAREN] = ACTIONS(648),
    [anon_sym_GT_LPAREN] = ACTIONS(648),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(648),
    [anon_sym_SEMI] = ACTIONS(648),
    [anon_sym_LF] = ACTIONS(648),
    [anon_sym_AMP] = ACTIONS(648),
  },
  [1079] = {
    [sym__concat] = ACTIONS(650),
    [anon_sym_SEMI_SEMI] = ACTIONS(652),
    [sym__special_characters] = ACTIONS(652),
    [anon_sym_DQUOTE] = ACTIONS(652),
    [sym_raw_string] = ACTIONS(652),
    [anon_sym_DOLLAR] = ACTIONS(652),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(652),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(652),
    [anon_sym_BQUOTE] = ACTIONS(652),
    [anon_sym_LT_LPAREN] = ACTIONS(652),
    [anon_sym_GT_LPAREN] = ACTIONS(652),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(652),
    [anon_sym_SEMI] = ACTIONS(652),
    [anon_sym_LF] = ACTIONS(652),
    [anon_sym_AMP] = ACTIONS(652),
  },
  [1080] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(3283),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [1081] = {
    [sym__concat] = ACTIONS(680),
    [anon_sym_SEMI_SEMI] = ACTIONS(682),
    [sym__special_characters] = ACTIONS(682),
    [anon_sym_DQUOTE] = ACTIONS(682),
    [sym_raw_string] = ACTIONS(682),
    [anon_sym_DOLLAR] = ACTIONS(682),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(682),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(682),
    [anon_sym_BQUOTE] = ACTIONS(682),
    [anon_sym_LT_LPAREN] = ACTIONS(682),
    [anon_sym_GT_LPAREN] = ACTIONS(682),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(682),
    [anon_sym_SEMI] = ACTIONS(682),
    [anon_sym_LF] = ACTIONS(682),
    [anon_sym_AMP] = ACTIONS(682),
  },
  [1082] = {
    [sym__concat] = ACTIONS(684),
    [anon_sym_SEMI_SEMI] = ACTIONS(686),
    [sym__special_characters] = ACTIONS(686),
    [anon_sym_DQUOTE] = ACTIONS(686),
    [sym_raw_string] = ACTIONS(686),
    [anon_sym_DOLLAR] = ACTIONS(686),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(686),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(686),
    [anon_sym_BQUOTE] = ACTIONS(686),
    [anon_sym_LT_LPAREN] = ACTIONS(686),
    [anon_sym_GT_LPAREN] = ACTIONS(686),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(686),
    [anon_sym_SEMI] = ACTIONS(686),
    [anon_sym_LF] = ACTIONS(686),
    [anon_sym_AMP] = ACTIONS(686),
  },
  [1083] = {
    [sym__concat] = ACTIONS(688),
    [anon_sym_SEMI_SEMI] = ACTIONS(690),
    [sym__special_characters] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(690),
    [sym_raw_string] = ACTIONS(690),
    [anon_sym_DOLLAR] = ACTIONS(690),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(690),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(690),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [anon_sym_LT_LPAREN] = ACTIONS(690),
    [anon_sym_GT_LPAREN] = ACTIONS(690),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(690),
    [anon_sym_SEMI] = ACTIONS(690),
    [anon_sym_LF] = ACTIONS(690),
    [anon_sym_AMP] = ACTIONS(690),
  },
  [1084] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(3285),
    [sym_comment] = ACTIONS(52),
  },
  [1085] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1585),
    [anon_sym_RBRACE] = ACTIONS(3287),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1086] = {
    [sym_subscript] = STATE(1589),
    [sym_variable_name] = ACTIONS(3289),
    [anon_sym_DOLLAR] = ACTIONS(3291),
    [anon_sym_DASH] = ACTIONS(3291),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3293),
    [anon_sym_STAR] = ACTIONS(3291),
    [anon_sym_AT] = ACTIONS(3291),
    [anon_sym_QMARK] = ACTIONS(3291),
    [anon_sym_0] = ACTIONS(3295),
    [anon_sym__] = ACTIONS(3295),
  },
  [1087] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1591),
    [anon_sym_RBRACE] = ACTIONS(3297),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1088] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1593),
    [anon_sym_RBRACE] = ACTIONS(3299),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1089] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3301),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [1090] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3301),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1091] = {
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(3301),
    [sym_comment] = ACTIONS(52),
  },
  [1092] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(3301),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1093] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3303),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [1094] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3303),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1095] = {
    [sym_do_group] = STATE(1597),
    [anon_sym_do] = ACTIONS(3305),
    [sym_comment] = ACTIONS(52),
  },
  [1096] = {
    [sym_concatenation] = STATE(600),
    [sym_string] = STATE(594),
    [sym_simple_expansion] = STATE(594),
    [sym_expansion] = STATE(594),
    [sym_command_substitution] = STATE(594),
    [sym_process_substitution] = STATE(594),
    [aux_sym_for_statement_repeat1] = STATE(1096),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [sym__special_characters] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(3310),
    [sym_raw_string] = ACTIONS(3313),
    [anon_sym_DOLLAR] = ACTIONS(3316),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3319),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3322),
    [anon_sym_BQUOTE] = ACTIONS(3325),
    [anon_sym_LT_LPAREN] = ACTIONS(3328),
    [anon_sym_GT_LPAREN] = ACTIONS(3328),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(3313),
    [anon_sym_SEMI] = ACTIONS(1964),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_AMP] = ACTIONS(1964),
  },
  [1097] = {
    [sym_file_descriptor] = ACTIONS(902),
    [sym_variable_name] = ACTIONS(902),
    [anon_sym_for] = ACTIONS(904),
    [anon_sym_while] = ACTIONS(904),
    [anon_sym_done] = ACTIONS(904),
    [anon_sym_if] = ACTIONS(904),
    [anon_sym_case] = ACTIONS(904),
    [anon_sym_function] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(902),
    [anon_sym_LBRACK] = ACTIONS(904),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym_declare] = ACTIONS(904),
    [anon_sym_typeset] = ACTIONS(904),
    [anon_sym_export] = ACTIONS(904),
    [anon_sym_readonly] = ACTIONS(904),
    [anon_sym_local] = ACTIONS(904),
    [anon_sym_LT] = ACTIONS(904),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_GT_GT] = ACTIONS(902),
    [anon_sym_AMP_GT] = ACTIONS(904),
    [anon_sym_AMP_GT_GT] = ACTIONS(902),
    [anon_sym_LT_AMP] = ACTIONS(902),
    [anon_sym_GT_AMP] = ACTIONS(902),
    [sym__special_characters] = ACTIONS(906),
    [anon_sym_DQUOTE] = ACTIONS(902),
    [sym_raw_string] = ACTIONS(902),
    [anon_sym_DOLLAR] = ACTIONS(904),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(902),
    [anon_sym_BQUOTE] = ACTIONS(902),
    [anon_sym_LT_LPAREN] = ACTIONS(902),
    [anon_sym_GT_LPAREN] = ACTIONS(902),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(906),
  },
  [1098] = {
    [sym_file_descriptor] = ACTIONS(3331),
    [anon_sym_PIPE] = ACTIONS(3333),
    [anon_sym_RPAREN] = ACTIONS(3333),
    [anon_sym_SEMI_SEMI] = ACTIONS(3333),
    [anon_sym_PIPE_AMP] = ACTIONS(3333),
    [anon_sym_AMP_AMP] = ACTIONS(3333),
    [anon_sym_PIPE_PIPE] = ACTIONS(3333),
    [anon_sym_LT] = ACTIONS(3333),
    [anon_sym_GT] = ACTIONS(3333),
    [anon_sym_GT_GT] = ACTIONS(3333),
    [anon_sym_AMP_GT] = ACTIONS(3333),
    [anon_sym_AMP_GT_GT] = ACTIONS(3333),
    [anon_sym_LT_AMP] = ACTIONS(3333),
    [anon_sym_GT_AMP] = ACTIONS(3333),
    [anon_sym_LT_LT] = ACTIONS(3333),
    [anon_sym_LT_LT_DASH] = ACTIONS(3333),
    [anon_sym_LT_LT_LT] = ACTIONS(3333),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3333),
    [anon_sym_LF] = ACTIONS(3333),
    [anon_sym_AMP] = ACTIONS(3333),
  },
  [1099] = {
    [sym__terminated_statement] = STATE(603),
    [sym_for_statement] = STATE(604),
    [sym_while_statement] = STATE(604),
    [sym_if_statement] = STATE(604),
    [sym_case_statement] = STATE(604),
    [sym_function_definition] = STATE(604),
    [sym_subshell] = STATE(604),
    [sym_pipeline] = STATE(604),
    [sym_list] = STATE(604),
    [sym_bracket_command] = STATE(604),
    [sym_command] = STATE(604),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(605),
    [sym_declaration_command] = STATE(604),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(1099),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(946),
    [sym_variable_name] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(954),
    [anon_sym_while] = ACTIONS(957),
    [anon_sym_done] = ACTIONS(3335),
    [anon_sym_if] = ACTIONS(960),
    [anon_sym_case] = ACTIONS(963),
    [anon_sym_function] = ACTIONS(966),
    [anon_sym_LPAREN] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_typeset] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_local] = ACTIONS(978),
    [anon_sym_LT] = ACTIONS(981),
    [anon_sym_GT] = ACTIONS(981),
    [anon_sym_GT_GT] = ACTIONS(984),
    [anon_sym_AMP_GT] = ACTIONS(981),
    [anon_sym_AMP_GT_GT] = ACTIONS(984),
    [anon_sym_LT_AMP] = ACTIONS(984),
    [anon_sym_GT_AMP] = ACTIONS(984),
    [sym__special_characters] = ACTIONS(987),
    [anon_sym_DQUOTE] = ACTIONS(990),
    [sym_raw_string] = ACTIONS(993),
    [anon_sym_DOLLAR] = ACTIONS(996),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(999),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1002),
    [anon_sym_BQUOTE] = ACTIONS(1005),
    [anon_sym_LT_LPAREN] = ACTIONS(1008),
    [anon_sym_GT_LPAREN] = ACTIONS(1008),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1011),
  },
  [1100] = {
    [anon_sym_then] = ACTIONS(3337),
    [sym_comment] = ACTIONS(52),
  },
  [1101] = {
    [sym_file_descriptor] = ACTIONS(296),
    [sym_variable_name] = ACTIONS(296),
    [anon_sym_for] = ACTIONS(298),
    [anon_sym_while] = ACTIONS(298),
    [anon_sym_if] = ACTIONS(298),
    [anon_sym_fi] = ACTIONS(298),
    [anon_sym_case] = ACTIONS(298),
    [anon_sym_function] = ACTIONS(298),
    [anon_sym_LPAREN] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(296),
    [anon_sym_declare] = ACTIONS(298),
    [anon_sym_typeset] = ACTIONS(298),
    [anon_sym_export] = ACTIONS(298),
    [anon_sym_readonly] = ACTIONS(298),
    [anon_sym_local] = ACTIONS(298),
    [anon_sym_LT] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(298),
    [anon_sym_GT_GT] = ACTIONS(296),
    [anon_sym_AMP_GT] = ACTIONS(298),
    [anon_sym_AMP_GT_GT] = ACTIONS(296),
    [anon_sym_LT_AMP] = ACTIONS(296),
    [anon_sym_GT_AMP] = ACTIONS(296),
    [sym__special_characters] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(296),
    [sym_raw_string] = ACTIONS(296),
    [anon_sym_DOLLAR] = ACTIONS(298),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(296),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(296),
    [anon_sym_BQUOTE] = ACTIONS(296),
    [anon_sym_LT_LPAREN] = ACTIONS(296),
    [anon_sym_GT_LPAREN] = ACTIONS(296),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(300),
  },
  [1102] = {
    [anon_sym_PIPE] = ACTIONS(302),
    [anon_sym_SEMI_SEMI] = ACTIONS(3339),
    [anon_sym_PIPE_AMP] = ACTIONS(302),
    [anon_sym_AMP_AMP] = ACTIONS(306),
    [anon_sym_PIPE_PIPE] = ACTIONS(306),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3339),
    [anon_sym_LF] = ACTIONS(3339),
    [anon_sym_AMP] = ACTIONS(3339),
  },
  [1103] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(302),
    [anon_sym_SEMI_SEMI] = ACTIONS(3339),
    [anon_sym_PIPE_AMP] = ACTIONS(302),
    [anon_sym_AMP_AMP] = ACTIONS(306),
    [anon_sym_PIPE_PIPE] = ACTIONS(306),
    [anon_sym_LT] = ACTIONS(336),
    [anon_sym_GT] = ACTIONS(336),
    [anon_sym_GT_GT] = ACTIONS(336),
    [anon_sym_AMP_GT] = ACTIONS(336),
    [anon_sym_AMP_GT_GT] = ACTIONS(336),
    [anon_sym_LT_AMP] = ACTIONS(336),
    [anon_sym_GT_AMP] = ACTIONS(336),
    [sym__special_characters] = ACTIONS(336),
    [anon_sym_DQUOTE] = ACTIONS(336),
    [sym_raw_string] = ACTIONS(336),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(336),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(336),
    [anon_sym_BQUOTE] = ACTIONS(336),
    [anon_sym_LT_LPAREN] = ACTIONS(336),
    [anon_sym_GT_LPAREN] = ACTIONS(336),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(336),
    [anon_sym_SEMI] = ACTIONS(3339),
    [anon_sym_LF] = ACTIONS(3339),
    [anon_sym_AMP] = ACTIONS(3339),
  },
  [1104] = {
    [sym__terminated_statement] = STATE(1101),
    [sym_for_statement] = STATE(1102),
    [sym_while_statement] = STATE(1102),
    [sym_if_statement] = STATE(1102),
    [sym_case_statement] = STATE(1102),
    [sym_function_definition] = STATE(1102),
    [sym_subshell] = STATE(1102),
    [sym_pipeline] = STATE(1102),
    [sym_list] = STATE(1102),
    [sym_bracket_command] = STATE(1102),
    [sym_command] = STATE(1102),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(1103),
    [sym_declaration_command] = STATE(1102),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(1600),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_fi] = ACTIONS(3341),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [1105] = {
    [sym_file_descriptor] = ACTIONS(902),
    [sym_variable_name] = ACTIONS(902),
    [anon_sym_for] = ACTIONS(904),
    [anon_sym_while] = ACTIONS(904),
    [anon_sym_if] = ACTIONS(904),
    [anon_sym_fi] = ACTIONS(904),
    [anon_sym_elif] = ACTIONS(904),
    [anon_sym_else] = ACTIONS(904),
    [anon_sym_case] = ACTIONS(904),
    [anon_sym_function] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(902),
    [anon_sym_LBRACK] = ACTIONS(904),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym_declare] = ACTIONS(904),
    [anon_sym_typeset] = ACTIONS(904),
    [anon_sym_export] = ACTIONS(904),
    [anon_sym_readonly] = ACTIONS(904),
    [anon_sym_local] = ACTIONS(904),
    [anon_sym_LT] = ACTIONS(904),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_GT_GT] = ACTIONS(902),
    [anon_sym_AMP_GT] = ACTIONS(904),
    [anon_sym_AMP_GT_GT] = ACTIONS(902),
    [anon_sym_LT_AMP] = ACTIONS(902),
    [anon_sym_GT_AMP] = ACTIONS(902),
    [sym__special_characters] = ACTIONS(906),
    [anon_sym_DQUOTE] = ACTIONS(902),
    [sym_raw_string] = ACTIONS(902),
    [anon_sym_DOLLAR] = ACTIONS(904),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(902),
    [anon_sym_BQUOTE] = ACTIONS(902),
    [anon_sym_LT_LPAREN] = ACTIONS(902),
    [anon_sym_GT_LPAREN] = ACTIONS(902),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(906),
  },
  [1106] = {
    [anon_sym_PIPE] = ACTIONS(3343),
    [anon_sym_RPAREN] = ACTIONS(3343),
    [anon_sym_SEMI_SEMI] = ACTIONS(3343),
    [anon_sym_PIPE_AMP] = ACTIONS(3343),
    [anon_sym_AMP_AMP] = ACTIONS(3343),
    [anon_sym_PIPE_PIPE] = ACTIONS(3343),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3343),
    [anon_sym_LF] = ACTIONS(3343),
    [anon_sym_AMP] = ACTIONS(3343),
  },
  [1107] = {
    [anon_sym_fi] = ACTIONS(3345),
    [sym_comment] = ACTIONS(52),
  },
  [1108] = {
    [sym__terminated_statement] = STATE(611),
    [sym_for_statement] = STATE(612),
    [sym_while_statement] = STATE(612),
    [sym_if_statement] = STATE(612),
    [sym_case_statement] = STATE(612),
    [sym_function_definition] = STATE(612),
    [sym_subshell] = STATE(612),
    [sym_pipeline] = STATE(612),
    [sym_list] = STATE(612),
    [sym_bracket_command] = STATE(612),
    [sym_command] = STATE(612),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(615),
    [sym_declaration_command] = STATE(612),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(1108),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(946),
    [sym_variable_name] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(954),
    [anon_sym_while] = ACTIONS(957),
    [anon_sym_if] = ACTIONS(960),
    [anon_sym_fi] = ACTIONS(3335),
    [anon_sym_elif] = ACTIONS(3335),
    [anon_sym_else] = ACTIONS(3335),
    [anon_sym_case] = ACTIONS(963),
    [anon_sym_function] = ACTIONS(966),
    [anon_sym_LPAREN] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_typeset] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_local] = ACTIONS(978),
    [anon_sym_LT] = ACTIONS(981),
    [anon_sym_GT] = ACTIONS(981),
    [anon_sym_GT_GT] = ACTIONS(984),
    [anon_sym_AMP_GT] = ACTIONS(981),
    [anon_sym_AMP_GT_GT] = ACTIONS(984),
    [anon_sym_LT_AMP] = ACTIONS(984),
    [anon_sym_GT_AMP] = ACTIONS(984),
    [sym__special_characters] = ACTIONS(987),
    [anon_sym_DQUOTE] = ACTIONS(990),
    [sym_raw_string] = ACTIONS(993),
    [anon_sym_DOLLAR] = ACTIONS(996),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(999),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1002),
    [anon_sym_BQUOTE] = ACTIONS(1005),
    [anon_sym_LT_LPAREN] = ACTIONS(1008),
    [anon_sym_GT_LPAREN] = ACTIONS(1008),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1011),
  },
  [1109] = {
    [sym_elif_clause] = STATE(613),
    [sym_else_clause] = STATE(1602),
    [aux_sym_if_statement_repeat1] = STATE(1110),
    [anon_sym_fi] = ACTIONS(3345),
    [anon_sym_elif] = ACTIONS(2168),
    [anon_sym_else] = ACTIONS(2170),
    [sym_comment] = ACTIONS(52),
  },
  [1110] = {
    [sym_elif_clause] = STATE(613),
    [aux_sym_if_statement_repeat1] = STATE(1110),
    [anon_sym_fi] = ACTIONS(3347),
    [anon_sym_elif] = ACTIONS(3349),
    [anon_sym_else] = ACTIONS(3347),
    [sym_comment] = ACTIONS(52),
  },
  [1111] = {
    [anon_sym_PIPE] = ACTIONS(3352),
    [anon_sym_RPAREN] = ACTIONS(3352),
    [anon_sym_SEMI_SEMI] = ACTIONS(3352),
    [anon_sym_PIPE_AMP] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_PIPE_PIPE] = ACTIONS(3352),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3352),
    [anon_sym_LF] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3352),
  },
  [1112] = {
    [aux_sym_case_item_repeat1] = STATE(1606),
    [aux_sym_concatenation_repeat1] = STATE(1607),
    [sym__concat] = ACTIONS(3354),
    [anon_sym_PIPE] = ACTIONS(3356),
    [anon_sym_RPAREN] = ACTIONS(3358),
    [sym_comment] = ACTIONS(52),
  },
  [1113] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(1609),
    [anon_sym_DQUOTE] = ACTIONS(3360),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [1114] = {
    [aux_sym_case_item_repeat1] = STATE(1611),
    [aux_sym_concatenation_repeat1] = STATE(1607),
    [sym__concat] = ACTIONS(3354),
    [anon_sym_PIPE] = ACTIONS(3356),
    [anon_sym_RPAREN] = ACTIONS(3362),
    [sym_comment] = ACTIONS(52),
  },
  [1115] = {
    [sym_string] = STATE(1614),
    [anon_sym_DQUOTE] = ACTIONS(2176),
    [anon_sym_DOLLAR] = ACTIONS(3364),
    [anon_sym_POUND] = ACTIONS(3364),
    [anon_sym_DASH] = ACTIONS(3364),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3366),
    [anon_sym_STAR] = ACTIONS(3364),
    [anon_sym_AT] = ACTIONS(3364),
    [anon_sym_QMARK] = ACTIONS(3364),
    [anon_sym_0] = ACTIONS(3368),
    [anon_sym__] = ACTIONS(3368),
  },
  [1116] = {
    [sym_subscript] = STATE(1619),
    [sym_variable_name] = ACTIONS(3370),
    [anon_sym_DOLLAR] = ACTIONS(3372),
    [anon_sym_POUND] = ACTIONS(3374),
    [anon_sym_DASH] = ACTIONS(3372),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3376),
    [anon_sym_STAR] = ACTIONS(3372),
    [anon_sym_AT] = ACTIONS(3372),
    [anon_sym_QMARK] = ACTIONS(3372),
    [anon_sym_0] = ACTIONS(3378),
    [anon_sym__] = ACTIONS(3378),
  },
  [1117] = {
    [sym_for_statement] = STATE(1620),
    [sym_while_statement] = STATE(1620),
    [sym_if_statement] = STATE(1620),
    [sym_case_statement] = STATE(1620),
    [sym_function_definition] = STATE(1620),
    [sym_subshell] = STATE(1620),
    [sym_pipeline] = STATE(1620),
    [sym_list] = STATE(1620),
    [sym_bracket_command] = STATE(1620),
    [sym_command] = STATE(1620),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(1621),
    [sym_declaration_command] = STATE(1620),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [1118] = {
    [sym_for_statement] = STATE(1622),
    [sym_while_statement] = STATE(1622),
    [sym_if_statement] = STATE(1622),
    [sym_case_statement] = STATE(1622),
    [sym_function_definition] = STATE(1622),
    [sym_subshell] = STATE(1622),
    [sym_pipeline] = STATE(1622),
    [sym_list] = STATE(1622),
    [sym_bracket_command] = STATE(1622),
    [sym_command] = STATE(1622),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(1623),
    [sym_declaration_command] = STATE(1622),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [1119] = {
    [sym_for_statement] = STATE(1624),
    [sym_while_statement] = STATE(1624),
    [sym_if_statement] = STATE(1624),
    [sym_case_statement] = STATE(1624),
    [sym_function_definition] = STATE(1624),
    [sym_subshell] = STATE(1624),
    [sym_pipeline] = STATE(1624),
    [sym_list] = STATE(1624),
    [sym_bracket_command] = STATE(1624),
    [sym_command] = STATE(1624),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(1625),
    [sym_declaration_command] = STATE(1624),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [1120] = {
    [sym__special_characters] = ACTIONS(3380),
    [anon_sym_DQUOTE] = ACTIONS(3382),
    [sym_raw_string] = ACTIONS(3382),
    [anon_sym_DOLLAR] = ACTIONS(3380),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3382),
    [anon_sym_BQUOTE] = ACTIONS(3382),
    [anon_sym_LT_LPAREN] = ACTIONS(3382),
    [anon_sym_GT_LPAREN] = ACTIONS(3382),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3380),
  },
  [1121] = {
    [anon_sym_esac] = ACTIONS(3384),
    [sym_comment] = ACTIONS(52),
  },
  [1122] = {
    [aux_sym_case_item_repeat1] = STATE(1611),
    [anon_sym_PIPE] = ACTIONS(3356),
    [anon_sym_RPAREN] = ACTIONS(3362),
    [sym_comment] = ACTIONS(52),
  },
  [1123] = {
    [sym_case_item] = STATE(1120),
    [sym_last_case_item] = STATE(1627),
    [sym_concatenation] = STATE(1122),
    [sym_string] = STATE(1114),
    [sym_simple_expansion] = STATE(1114),
    [sym_expansion] = STATE(1114),
    [sym_command_substitution] = STATE(1114),
    [sym_process_substitution] = STATE(1114),
    [aux_sym_case_statement_repeat1] = STATE(1628),
    [sym__special_characters] = ACTIONS(2174),
    [anon_sym_DQUOTE] = ACTIONS(2176),
    [sym_raw_string] = ACTIONS(2178),
    [anon_sym_DOLLAR] = ACTIONS(2180),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2182),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2184),
    [anon_sym_BQUOTE] = ACTIONS(2186),
    [anon_sym_LT_LPAREN] = ACTIONS(2188),
    [anon_sym_GT_LPAREN] = ACTIONS(2188),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3386),
  },
  [1124] = {
    [sym_case_item] = STATE(1120),
    [sym_last_case_item] = STATE(1627),
    [sym_concatenation] = STATE(1122),
    [sym_string] = STATE(1114),
    [sym_simple_expansion] = STATE(1114),
    [sym_expansion] = STATE(1114),
    [sym_command_substitution] = STATE(1114),
    [sym_process_substitution] = STATE(1114),
    [aux_sym_case_statement_repeat1] = STATE(1630),
    [anon_sym_esac] = ACTIONS(3388),
    [sym__special_characters] = ACTIONS(2174),
    [anon_sym_DQUOTE] = ACTIONS(2176),
    [sym_raw_string] = ACTIONS(2178),
    [anon_sym_DOLLAR] = ACTIONS(2180),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2182),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2184),
    [anon_sym_BQUOTE] = ACTIONS(2186),
    [anon_sym_LT_LPAREN] = ACTIONS(2188),
    [anon_sym_GT_LPAREN] = ACTIONS(2188),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2190),
  },
  [1125] = {
    [anon_sym_PIPE] = ACTIONS(3390),
    [anon_sym_RPAREN] = ACTIONS(3390),
    [anon_sym_SEMI_SEMI] = ACTIONS(3390),
    [anon_sym_PIPE_AMP] = ACTIONS(3390),
    [anon_sym_AMP_AMP] = ACTIONS(3390),
    [anon_sym_PIPE_PIPE] = ACTIONS(3390),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3390),
    [anon_sym_LF] = ACTIONS(3390),
    [anon_sym_AMP] = ACTIONS(3390),
  },
  [1126] = {
    [anon_sym_esac] = ACTIONS(3392),
    [sym_comment] = ACTIONS(52),
  },
  [1127] = {
    [sym_case_item] = STATE(1120),
    [sym_last_case_item] = STATE(1632),
    [sym_concatenation] = STATE(1122),
    [sym_string] = STATE(1114),
    [sym_simple_expansion] = STATE(1114),
    [sym_expansion] = STATE(1114),
    [sym_command_substitution] = STATE(1114),
    [sym_process_substitution] = STATE(1114),
    [aux_sym_case_statement_repeat1] = STATE(1628),
    [sym__special_characters] = ACTIONS(2174),
    [anon_sym_DQUOTE] = ACTIONS(2176),
    [sym_raw_string] = ACTIONS(2178),
    [anon_sym_DOLLAR] = ACTIONS(2180),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2182),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2184),
    [anon_sym_BQUOTE] = ACTIONS(2186),
    [anon_sym_LT_LPAREN] = ACTIONS(2188),
    [anon_sym_GT_LPAREN] = ACTIONS(2188),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3386),
  },
  [1128] = {
    [sym_case_item] = STATE(1120),
    [sym_last_case_item] = STATE(1632),
    [sym_concatenation] = STATE(1122),
    [sym_string] = STATE(1114),
    [sym_simple_expansion] = STATE(1114),
    [sym_expansion] = STATE(1114),
    [sym_command_substitution] = STATE(1114),
    [sym_process_substitution] = STATE(1114),
    [aux_sym_case_statement_repeat1] = STATE(1634),
    [anon_sym_esac] = ACTIONS(3394),
    [sym__special_characters] = ACTIONS(2174),
    [anon_sym_DQUOTE] = ACTIONS(2176),
    [sym_raw_string] = ACTIONS(2178),
    [anon_sym_DOLLAR] = ACTIONS(2180),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2182),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2184),
    [anon_sym_BQUOTE] = ACTIONS(2186),
    [anon_sym_LT_LPAREN] = ACTIONS(2188),
    [anon_sym_GT_LPAREN] = ACTIONS(2188),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2190),
  },
  [1129] = {
    [sym__concat] = ACTIONS(2560),
    [anon_sym_in] = ACTIONS(2562),
    [anon_sym_SEMI_SEMI] = ACTIONS(2562),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym_LF] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(2562),
  },
  [1130] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(3396),
    [sym_comment] = ACTIONS(52),
  },
  [1131] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(3398),
    [sym_comment] = ACTIONS(52),
  },
  [1132] = {
    [anon_sym_RBRACE] = ACTIONS(3398),
    [sym_comment] = ACTIONS(52),
  },
  [1133] = {
    [sym__concat] = ACTIONS(2614),
    [anon_sym_in] = ACTIONS(2616),
    [anon_sym_SEMI_SEMI] = ACTIONS(2616),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2616),
    [anon_sym_LF] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2616),
  },
  [1134] = {
    [sym_concatenation] = STATE(1639),
    [sym_string] = STATE(1638),
    [sym_simple_expansion] = STATE(1638),
    [sym_expansion] = STATE(1638),
    [sym_command_substitution] = STATE(1638),
    [sym_process_substitution] = STATE(1638),
    [anon_sym_RBRACE] = ACTIONS(3398),
    [sym__special_characters] = ACTIONS(3400),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(3402),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3404),
  },
  [1135] = {
    [sym__concat] = ACTIONS(2659),
    [anon_sym_in] = ACTIONS(2661),
    [anon_sym_SEMI_SEMI] = ACTIONS(2661),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2661),
    [anon_sym_LF] = ACTIONS(2661),
    [anon_sym_AMP] = ACTIONS(2661),
  },
  [1136] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3406),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1137] = {
    [sym__concat] = ACTIONS(2665),
    [anon_sym_in] = ACTIONS(2667),
    [anon_sym_SEMI_SEMI] = ACTIONS(2667),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym_LF] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(2667),
  },
  [1138] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3408),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1139] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3398),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1140] = {
    [sym__concat] = ACTIONS(2671),
    [anon_sym_in] = ACTIONS(2673),
    [anon_sym_SEMI_SEMI] = ACTIONS(2673),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2673),
    [anon_sym_LF] = ACTIONS(2673),
    [anon_sym_AMP] = ACTIONS(2673),
  },
  [1141] = {
    [sym_file_redirect] = STATE(1642),
    [sym_file_descriptor] = ACTIONS(1182),
    [anon_sym_PIPE] = ACTIONS(3410),
    [anon_sym_SEMI_SEMI] = ACTIONS(3410),
    [anon_sym_PIPE_AMP] = ACTIONS(3410),
    [anon_sym_AMP_AMP] = ACTIONS(3410),
    [anon_sym_PIPE_PIPE] = ACTIONS(3410),
    [anon_sym_LT] = ACTIONS(1186),
    [anon_sym_GT] = ACTIONS(1186),
    [anon_sym_GT_GT] = ACTIONS(1186),
    [anon_sym_AMP_GT] = ACTIONS(1186),
    [anon_sym_AMP_GT_GT] = ACTIONS(1186),
    [anon_sym_LT_AMP] = ACTIONS(1186),
    [anon_sym_GT_AMP] = ACTIONS(1186),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3410),
    [anon_sym_LF] = ACTIONS(3410),
    [anon_sym_AMP] = ACTIONS(3410),
  },
  [1142] = {
    [sym_file_descriptor] = ACTIONS(902),
    [sym_variable_name] = ACTIONS(902),
    [anon_sym_for] = ACTIONS(904),
    [anon_sym_while] = ACTIONS(904),
    [anon_sym_if] = ACTIONS(904),
    [anon_sym_case] = ACTIONS(904),
    [anon_sym_function] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(902),
    [anon_sym_RBRACE] = ACTIONS(902),
    [anon_sym_LBRACK] = ACTIONS(904),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym_declare] = ACTIONS(904),
    [anon_sym_typeset] = ACTIONS(904),
    [anon_sym_export] = ACTIONS(904),
    [anon_sym_readonly] = ACTIONS(904),
    [anon_sym_local] = ACTIONS(904),
    [anon_sym_LT] = ACTIONS(904),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_GT_GT] = ACTIONS(902),
    [anon_sym_AMP_GT] = ACTIONS(904),
    [anon_sym_AMP_GT_GT] = ACTIONS(902),
    [anon_sym_LT_AMP] = ACTIONS(902),
    [anon_sym_GT_AMP] = ACTIONS(902),
    [sym__special_characters] = ACTIONS(906),
    [anon_sym_DQUOTE] = ACTIONS(902),
    [sym_raw_string] = ACTIONS(902),
    [anon_sym_DOLLAR] = ACTIONS(904),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(902),
    [anon_sym_BQUOTE] = ACTIONS(902),
    [anon_sym_LT_LPAREN] = ACTIONS(902),
    [anon_sym_GT_LPAREN] = ACTIONS(902),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(906),
  },
  [1143] = {
    [sym_file_descriptor] = ACTIONS(3412),
    [anon_sym_PIPE] = ACTIONS(3414),
    [anon_sym_RPAREN] = ACTIONS(3414),
    [anon_sym_SEMI_SEMI] = ACTIONS(3414),
    [anon_sym_PIPE_AMP] = ACTIONS(3414),
    [anon_sym_AMP_AMP] = ACTIONS(3414),
    [anon_sym_PIPE_PIPE] = ACTIONS(3414),
    [anon_sym_LT] = ACTIONS(3414),
    [anon_sym_GT] = ACTIONS(3414),
    [anon_sym_GT_GT] = ACTIONS(3414),
    [anon_sym_AMP_GT] = ACTIONS(3414),
    [anon_sym_AMP_GT_GT] = ACTIONS(3414),
    [anon_sym_LT_AMP] = ACTIONS(3414),
    [anon_sym_GT_AMP] = ACTIONS(3414),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3414),
    [anon_sym_LF] = ACTIONS(3414),
    [anon_sym_AMP] = ACTIONS(3414),
  },
  [1144] = {
    [sym__terminated_statement] = STATE(640),
    [sym_for_statement] = STATE(641),
    [sym_while_statement] = STATE(641),
    [sym_if_statement] = STATE(641),
    [sym_case_statement] = STATE(641),
    [sym_function_definition] = STATE(641),
    [sym_subshell] = STATE(641),
    [sym_pipeline] = STATE(641),
    [sym_list] = STATE(641),
    [sym_bracket_command] = STATE(641),
    [sym_command] = STATE(641),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(642),
    [sym_declaration_command] = STATE(641),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(1144),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(946),
    [sym_variable_name] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(954),
    [anon_sym_while] = ACTIONS(957),
    [anon_sym_if] = ACTIONS(960),
    [anon_sym_case] = ACTIONS(963),
    [anon_sym_function] = ACTIONS(966),
    [anon_sym_LPAREN] = ACTIONS(969),
    [anon_sym_RBRACE] = ACTIONS(952),
    [anon_sym_LBRACK] = ACTIONS(972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_typeset] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_local] = ACTIONS(978),
    [anon_sym_LT] = ACTIONS(981),
    [anon_sym_GT] = ACTIONS(981),
    [anon_sym_GT_GT] = ACTIONS(984),
    [anon_sym_AMP_GT] = ACTIONS(981),
    [anon_sym_AMP_GT_GT] = ACTIONS(984),
    [anon_sym_LT_AMP] = ACTIONS(984),
    [anon_sym_GT_AMP] = ACTIONS(984),
    [sym__special_characters] = ACTIONS(987),
    [anon_sym_DQUOTE] = ACTIONS(990),
    [sym_raw_string] = ACTIONS(993),
    [anon_sym_DOLLAR] = ACTIONS(996),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(999),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1002),
    [anon_sym_BQUOTE] = ACTIONS(1005),
    [anon_sym_LT_LPAREN] = ACTIONS(1008),
    [anon_sym_GT_LPAREN] = ACTIONS(1008),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1011),
  },
  [1145] = {
    [sym_concatenation] = STATE(1645),
    [sym_string] = STATE(1644),
    [sym_simple_expansion] = STATE(1644),
    [sym_expansion] = STATE(1644),
    [sym_command_substitution] = STATE(1644),
    [sym_process_substitution] = STATE(1644),
    [sym__special_characters] = ACTIONS(3416),
    [anon_sym_DQUOTE] = ACTIONS(2233),
    [sym_raw_string] = ACTIONS(3418),
    [anon_sym_DOLLAR] = ACTIONS(2237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2239),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2241),
    [anon_sym_BQUOTE] = ACTIONS(2243),
    [anon_sym_LT_LPAREN] = ACTIONS(2245),
    [anon_sym_GT_LPAREN] = ACTIONS(2245),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3420),
  },
  [1146] = {
    [aux_sym_concatenation_repeat1] = STATE(1647),
    [sym__concat] = ACTIONS(3422),
    [anon_sym_PIPE] = ACTIONS(1918),
    [anon_sym_SEMI_SEMI] = ACTIONS(1918),
    [anon_sym_PIPE_AMP] = ACTIONS(1918),
    [anon_sym_AMP_AMP] = ACTIONS(1918),
    [anon_sym_PIPE_PIPE] = ACTIONS(1918),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1918),
    [anon_sym_LF] = ACTIONS(1918),
    [anon_sym_AMP] = ACTIONS(1918),
  },
  [1147] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(1649),
    [anon_sym_DQUOTE] = ACTIONS(3424),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [1148] = {
    [aux_sym_concatenation_repeat1] = STATE(1647),
    [sym__concat] = ACTIONS(3422),
    [anon_sym_PIPE] = ACTIONS(1922),
    [anon_sym_SEMI_SEMI] = ACTIONS(1922),
    [anon_sym_PIPE_AMP] = ACTIONS(1922),
    [anon_sym_AMP_AMP] = ACTIONS(1922),
    [anon_sym_PIPE_PIPE] = ACTIONS(1922),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1922),
    [anon_sym_LF] = ACTIONS(1922),
    [anon_sym_AMP] = ACTIONS(1922),
  },
  [1149] = {
    [sym_string] = STATE(1652),
    [anon_sym_DQUOTE] = ACTIONS(2233),
    [anon_sym_DOLLAR] = ACTIONS(3426),
    [anon_sym_POUND] = ACTIONS(3426),
    [anon_sym_DASH] = ACTIONS(3426),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3428),
    [anon_sym_STAR] = ACTIONS(3426),
    [anon_sym_AT] = ACTIONS(3426),
    [anon_sym_QMARK] = ACTIONS(3426),
    [anon_sym_0] = ACTIONS(3430),
    [anon_sym__] = ACTIONS(3430),
  },
  [1150] = {
    [sym_subscript] = STATE(1657),
    [sym_variable_name] = ACTIONS(3432),
    [anon_sym_DOLLAR] = ACTIONS(3434),
    [anon_sym_POUND] = ACTIONS(3436),
    [anon_sym_DASH] = ACTIONS(3434),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3438),
    [anon_sym_STAR] = ACTIONS(3434),
    [anon_sym_AT] = ACTIONS(3434),
    [anon_sym_QMARK] = ACTIONS(3434),
    [anon_sym_0] = ACTIONS(3440),
    [anon_sym__] = ACTIONS(3440),
  },
  [1151] = {
    [sym_for_statement] = STATE(1658),
    [sym_while_statement] = STATE(1658),
    [sym_if_statement] = STATE(1658),
    [sym_case_statement] = STATE(1658),
    [sym_function_definition] = STATE(1658),
    [sym_subshell] = STATE(1658),
    [sym_pipeline] = STATE(1658),
    [sym_list] = STATE(1658),
    [sym_bracket_command] = STATE(1658),
    [sym_command] = STATE(1658),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(1659),
    [sym_declaration_command] = STATE(1658),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [1152] = {
    [sym_for_statement] = STATE(1660),
    [sym_while_statement] = STATE(1660),
    [sym_if_statement] = STATE(1660),
    [sym_case_statement] = STATE(1660),
    [sym_function_definition] = STATE(1660),
    [sym_subshell] = STATE(1660),
    [sym_pipeline] = STATE(1660),
    [sym_list] = STATE(1660),
    [sym_bracket_command] = STATE(1660),
    [sym_command] = STATE(1660),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(1661),
    [sym_declaration_command] = STATE(1660),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [1153] = {
    [sym_for_statement] = STATE(1662),
    [sym_while_statement] = STATE(1662),
    [sym_if_statement] = STATE(1662),
    [sym_case_statement] = STATE(1662),
    [sym_function_definition] = STATE(1662),
    [sym_subshell] = STATE(1662),
    [sym_pipeline] = STATE(1662),
    [sym_list] = STATE(1662),
    [sym_bracket_command] = STATE(1662),
    [sym_command] = STATE(1662),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(1663),
    [sym_declaration_command] = STATE(1662),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [1154] = {
    [anon_sym_PIPE] = ACTIONS(1922),
    [anon_sym_RPAREN] = ACTIONS(1922),
    [anon_sym_SEMI_SEMI] = ACTIONS(1922),
    [anon_sym_PIPE_AMP] = ACTIONS(1922),
    [anon_sym_AMP_AMP] = ACTIONS(1922),
    [anon_sym_PIPE_PIPE] = ACTIONS(1922),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1922),
    [anon_sym_LF] = ACTIONS(1922),
    [anon_sym_AMP] = ACTIONS(1922),
  },
  [1155] = {
    [sym_string] = STATE(1664),
    [sym_simple_expansion] = STATE(1664),
    [sym_expansion] = STATE(1664),
    [sym_command_substitution] = STATE(1664),
    [sym_process_substitution] = STATE(1664),
    [sym__special_characters] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(1190),
    [sym_raw_string] = ACTIONS(3444),
    [anon_sym_DOLLAR] = ACTIONS(1194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1198),
    [anon_sym_BQUOTE] = ACTIONS(1200),
    [anon_sym_LT_LPAREN] = ACTIONS(1202),
    [anon_sym_GT_LPAREN] = ACTIONS(1202),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3442),
  },
  [1156] = {
    [aux_sym_concatenation_repeat1] = STATE(1665),
    [sym_file_descriptor] = ACTIONS(646),
    [sym__concat] = ACTIONS(2251),
    [sym_variable_name] = ACTIONS(646),
    [anon_sym_PIPE] = ACTIONS(648),
    [anon_sym_RPAREN] = ACTIONS(648),
    [anon_sym_SEMI_SEMI] = ACTIONS(648),
    [anon_sym_PIPE_AMP] = ACTIONS(648),
    [anon_sym_AMP_AMP] = ACTIONS(648),
    [anon_sym_PIPE_PIPE] = ACTIONS(648),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(648),
    [anon_sym_GT_GT] = ACTIONS(648),
    [anon_sym_AMP_GT] = ACTIONS(648),
    [anon_sym_AMP_GT_GT] = ACTIONS(648),
    [anon_sym_LT_AMP] = ACTIONS(648),
    [anon_sym_GT_AMP] = ACTIONS(648),
    [sym__special_characters] = ACTIONS(648),
    [anon_sym_DQUOTE] = ACTIONS(648),
    [sym_raw_string] = ACTIONS(648),
    [anon_sym_DOLLAR] = ACTIONS(648),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(648),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(648),
    [anon_sym_BQUOTE] = ACTIONS(648),
    [anon_sym_LT_LPAREN] = ACTIONS(648),
    [anon_sym_GT_LPAREN] = ACTIONS(648),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(648),
    [anon_sym_SEMI] = ACTIONS(648),
    [anon_sym_LF] = ACTIONS(648),
    [anon_sym_AMP] = ACTIONS(648),
  },
  [1157] = {
    [sym_file_descriptor] = ACTIONS(650),
    [sym__concat] = ACTIONS(650),
    [sym_variable_name] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(652),
    [anon_sym_RPAREN] = ACTIONS(652),
    [anon_sym_SEMI_SEMI] = ACTIONS(652),
    [anon_sym_PIPE_AMP] = ACTIONS(652),
    [anon_sym_AMP_AMP] = ACTIONS(652),
    [anon_sym_PIPE_PIPE] = ACTIONS(652),
    [anon_sym_LT] = ACTIONS(652),
    [anon_sym_GT] = ACTIONS(652),
    [anon_sym_GT_GT] = ACTIONS(652),
    [anon_sym_AMP_GT] = ACTIONS(652),
    [anon_sym_AMP_GT_GT] = ACTIONS(652),
    [anon_sym_LT_AMP] = ACTIONS(652),
    [anon_sym_GT_AMP] = ACTIONS(652),
    [sym__special_characters] = ACTIONS(652),
    [anon_sym_DQUOTE] = ACTIONS(652),
    [sym_raw_string] = ACTIONS(652),
    [anon_sym_DOLLAR] = ACTIONS(652),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(652),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(652),
    [anon_sym_BQUOTE] = ACTIONS(652),
    [anon_sym_LT_LPAREN] = ACTIONS(652),
    [anon_sym_GT_LPAREN] = ACTIONS(652),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(652),
    [anon_sym_SEMI] = ACTIONS(652),
    [anon_sym_LF] = ACTIONS(652),
    [anon_sym_AMP] = ACTIONS(652),
  },
  [1158] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(3446),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [1159] = {
    [sym_file_descriptor] = ACTIONS(680),
    [sym__concat] = ACTIONS(680),
    [sym_variable_name] = ACTIONS(680),
    [anon_sym_PIPE] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(682),
    [anon_sym_SEMI_SEMI] = ACTIONS(682),
    [anon_sym_PIPE_AMP] = ACTIONS(682),
    [anon_sym_AMP_AMP] = ACTIONS(682),
    [anon_sym_PIPE_PIPE] = ACTIONS(682),
    [anon_sym_LT] = ACTIONS(682),
    [anon_sym_GT] = ACTIONS(682),
    [anon_sym_GT_GT] = ACTIONS(682),
    [anon_sym_AMP_GT] = ACTIONS(682),
    [anon_sym_AMP_GT_GT] = ACTIONS(682),
    [anon_sym_LT_AMP] = ACTIONS(682),
    [anon_sym_GT_AMP] = ACTIONS(682),
    [sym__special_characters] = ACTIONS(682),
    [anon_sym_DQUOTE] = ACTIONS(682),
    [sym_raw_string] = ACTIONS(682),
    [anon_sym_DOLLAR] = ACTIONS(682),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(682),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(682),
    [anon_sym_BQUOTE] = ACTIONS(682),
    [anon_sym_LT_LPAREN] = ACTIONS(682),
    [anon_sym_GT_LPAREN] = ACTIONS(682),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(682),
    [anon_sym_SEMI] = ACTIONS(682),
    [anon_sym_LF] = ACTIONS(682),
    [anon_sym_AMP] = ACTIONS(682),
  },
  [1160] = {
    [sym_file_descriptor] = ACTIONS(684),
    [sym__concat] = ACTIONS(684),
    [sym_variable_name] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(686),
    [anon_sym_RPAREN] = ACTIONS(686),
    [anon_sym_SEMI_SEMI] = ACTIONS(686),
    [anon_sym_PIPE_AMP] = ACTIONS(686),
    [anon_sym_AMP_AMP] = ACTIONS(686),
    [anon_sym_PIPE_PIPE] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(686),
    [anon_sym_GT] = ACTIONS(686),
    [anon_sym_GT_GT] = ACTIONS(686),
    [anon_sym_AMP_GT] = ACTIONS(686),
    [anon_sym_AMP_GT_GT] = ACTIONS(686),
    [anon_sym_LT_AMP] = ACTIONS(686),
    [anon_sym_GT_AMP] = ACTIONS(686),
    [sym__special_characters] = ACTIONS(686),
    [anon_sym_DQUOTE] = ACTIONS(686),
    [sym_raw_string] = ACTIONS(686),
    [anon_sym_DOLLAR] = ACTIONS(686),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(686),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(686),
    [anon_sym_BQUOTE] = ACTIONS(686),
    [anon_sym_LT_LPAREN] = ACTIONS(686),
    [anon_sym_GT_LPAREN] = ACTIONS(686),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(686),
    [anon_sym_SEMI] = ACTIONS(686),
    [anon_sym_LF] = ACTIONS(686),
    [anon_sym_AMP] = ACTIONS(686),
  },
  [1161] = {
    [sym_file_descriptor] = ACTIONS(688),
    [sym__concat] = ACTIONS(688),
    [sym_variable_name] = ACTIONS(688),
    [anon_sym_PIPE] = ACTIONS(690),
    [anon_sym_RPAREN] = ACTIONS(690),
    [anon_sym_SEMI_SEMI] = ACTIONS(690),
    [anon_sym_PIPE_AMP] = ACTIONS(690),
    [anon_sym_AMP_AMP] = ACTIONS(690),
    [anon_sym_PIPE_PIPE] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(690),
    [anon_sym_GT] = ACTIONS(690),
    [anon_sym_GT_GT] = ACTIONS(690),
    [anon_sym_AMP_GT] = ACTIONS(690),
    [anon_sym_AMP_GT_GT] = ACTIONS(690),
    [anon_sym_LT_AMP] = ACTIONS(690),
    [anon_sym_GT_AMP] = ACTIONS(690),
    [sym__special_characters] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(690),
    [sym_raw_string] = ACTIONS(690),
    [anon_sym_DOLLAR] = ACTIONS(690),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(690),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(690),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [anon_sym_LT_LPAREN] = ACTIONS(690),
    [anon_sym_GT_LPAREN] = ACTIONS(690),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(690),
    [anon_sym_SEMI] = ACTIONS(690),
    [anon_sym_LF] = ACTIONS(690),
    [anon_sym_AMP] = ACTIONS(690),
  },
  [1162] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(3448),
    [sym_comment] = ACTIONS(52),
  },
  [1163] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1669),
    [anon_sym_RBRACE] = ACTIONS(3450),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1164] = {
    [sym_subscript] = STATE(1673),
    [sym_variable_name] = ACTIONS(3452),
    [anon_sym_DOLLAR] = ACTIONS(3454),
    [anon_sym_DASH] = ACTIONS(3454),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3456),
    [anon_sym_STAR] = ACTIONS(3454),
    [anon_sym_AT] = ACTIONS(3454),
    [anon_sym_QMARK] = ACTIONS(3454),
    [anon_sym_0] = ACTIONS(3458),
    [anon_sym__] = ACTIONS(3458),
  },
  [1165] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1675),
    [anon_sym_RBRACE] = ACTIONS(3460),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1166] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1677),
    [anon_sym_RBRACE] = ACTIONS(3462),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1167] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3464),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [1168] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3464),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1169] = {
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(3464),
    [sym_comment] = ACTIONS(52),
  },
  [1170] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(3464),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1171] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3466),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [1172] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3466),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1173] = {
    [sym_file_redirect] = STATE(185),
    [sym_heredoc_redirect] = STATE(185),
    [sym_herestring_redirect] = STATE(185),
    [aux_sym_while_statement_repeat1] = STATE(711),
    [sym_file_descriptor] = ACTIONS(490),
    [anon_sym_PIPE] = ACTIONS(2154),
    [anon_sym_RPAREN] = ACTIONS(2154),
    [anon_sym_SEMI_SEMI] = ACTIONS(2154),
    [anon_sym_PIPE_AMP] = ACTIONS(2154),
    [anon_sym_AMP_AMP] = ACTIONS(2154),
    [anon_sym_PIPE_PIPE] = ACTIONS(2154),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_GT] = ACTIONS(492),
    [anon_sym_GT_GT] = ACTIONS(492),
    [anon_sym_AMP_GT] = ACTIONS(492),
    [anon_sym_AMP_GT_GT] = ACTIONS(492),
    [anon_sym_LT_AMP] = ACTIONS(492),
    [anon_sym_GT_AMP] = ACTIONS(492),
    [anon_sym_LT_LT] = ACTIONS(314),
    [anon_sym_LT_LT_DASH] = ACTIONS(314),
    [anon_sym_LT_LT_LT] = ACTIONS(494),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2154),
    [anon_sym_LF] = ACTIONS(2154),
    [anon_sym_AMP] = ACTIONS(2154),
  },
  [1174] = {
    [sym_compound_statement] = STATE(1680),
    [anon_sym_LBRACE] = ACTIONS(436),
    [sym_comment] = ACTIONS(52),
  },
  [1175] = {
    [anon_sym_LT] = ACTIONS(3468),
    [anon_sym_GT] = ACTIONS(3468),
    [anon_sym_GT_GT] = ACTIONS(3470),
    [anon_sym_AMP_GT] = ACTIONS(3468),
    [anon_sym_AMP_GT_GT] = ACTIONS(3470),
    [anon_sym_LT_AMP] = ACTIONS(3470),
    [anon_sym_GT_AMP] = ACTIONS(3470),
    [sym_comment] = ACTIONS(52),
  },
  [1176] = {
    [sym_concatenation] = STATE(1154),
    [sym_string] = STATE(1684),
    [sym_simple_expansion] = STATE(1684),
    [sym_expansion] = STATE(1684),
    [sym_command_substitution] = STATE(1684),
    [sym_process_substitution] = STATE(1684),
    [sym__special_characters] = ACTIONS(3472),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_raw_string] = ACTIONS(3476),
    [anon_sym_DOLLAR] = ACTIONS(3478),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3480),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3482),
    [anon_sym_BQUOTE] = ACTIONS(3484),
    [anon_sym_LT_LPAREN] = ACTIONS(3486),
    [anon_sym_GT_LPAREN] = ACTIONS(3486),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3488),
  },
  [1177] = {
    [aux_sym_concatenation_repeat1] = STATE(660),
    [sym__concat] = ACTIONS(1210),
    [sym_variable_name] = ACTIONS(1092),
    [anon_sym_PIPE] = ACTIONS(1096),
    [anon_sym_RPAREN] = ACTIONS(1096),
    [anon_sym_SEMI_SEMI] = ACTIONS(1096),
    [anon_sym_PIPE_AMP] = ACTIONS(1096),
    [anon_sym_AMP_AMP] = ACTIONS(1096),
    [anon_sym_PIPE_PIPE] = ACTIONS(1096),
    [sym__special_characters] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1096),
    [sym_raw_string] = ACTIONS(1096),
    [anon_sym_DOLLAR] = ACTIONS(1096),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1096),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1096),
    [anon_sym_BQUOTE] = ACTIONS(1096),
    [anon_sym_LT_LPAREN] = ACTIONS(1096),
    [anon_sym_GT_LPAREN] = ACTIONS(1096),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1096),
    [sym_word] = ACTIONS(1096),
    [anon_sym_SEMI] = ACTIONS(1096),
    [anon_sym_LF] = ACTIONS(1096),
    [anon_sym_AMP] = ACTIONS(1096),
  },
  [1178] = {
    [aux_sym_concatenation_repeat1] = STATE(660),
    [sym__concat] = ACTIONS(1210),
    [sym_variable_name] = ACTIONS(1068),
    [anon_sym_PIPE] = ACTIONS(1070),
    [anon_sym_RPAREN] = ACTIONS(1070),
    [anon_sym_SEMI_SEMI] = ACTIONS(1070),
    [anon_sym_PIPE_AMP] = ACTIONS(1070),
    [anon_sym_AMP_AMP] = ACTIONS(1070),
    [anon_sym_PIPE_PIPE] = ACTIONS(1070),
    [sym__special_characters] = ACTIONS(1070),
    [anon_sym_DQUOTE] = ACTIONS(1070),
    [sym_raw_string] = ACTIONS(1070),
    [anon_sym_DOLLAR] = ACTIONS(1070),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1070),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1070),
    [anon_sym_BQUOTE] = ACTIONS(1070),
    [anon_sym_LT_LPAREN] = ACTIONS(1070),
    [anon_sym_GT_LPAREN] = ACTIONS(1070),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1070),
    [sym_word] = ACTIONS(1070),
    [anon_sym_SEMI] = ACTIONS(1070),
    [anon_sym_LF] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(1070),
  },
  [1179] = {
    [sym__concat] = ACTIONS(1522),
    [sym_variable_name] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(1524),
    [anon_sym_RPAREN] = ACTIONS(1524),
    [anon_sym_SEMI_SEMI] = ACTIONS(1524),
    [anon_sym_PIPE_AMP] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1524),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [sym__special_characters] = ACTIONS(1524),
    [anon_sym_DQUOTE] = ACTIONS(1524),
    [sym_raw_string] = ACTIONS(1524),
    [anon_sym_DOLLAR] = ACTIONS(1524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1524),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1524),
    [anon_sym_BQUOTE] = ACTIONS(1524),
    [anon_sym_LT_LPAREN] = ACTIONS(1524),
    [anon_sym_GT_LPAREN] = ACTIONS(1524),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1524),
    [sym_word] = ACTIONS(1524),
    [anon_sym_SEMI] = ACTIONS(1524),
    [anon_sym_LF] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1524),
  },
  [1180] = {
    [aux_sym_concatenation_repeat1] = STATE(1180),
    [sym__concat] = ACTIONS(3490),
    [sym_variable_name] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(1524),
    [anon_sym_RPAREN] = ACTIONS(1524),
    [anon_sym_SEMI_SEMI] = ACTIONS(1524),
    [anon_sym_PIPE_AMP] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1524),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [sym__special_characters] = ACTIONS(1524),
    [anon_sym_DQUOTE] = ACTIONS(1524),
    [sym_raw_string] = ACTIONS(1524),
    [anon_sym_DOLLAR] = ACTIONS(1524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1524),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1524),
    [anon_sym_BQUOTE] = ACTIONS(1524),
    [anon_sym_LT_LPAREN] = ACTIONS(1524),
    [anon_sym_GT_LPAREN] = ACTIONS(1524),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1524),
    [sym_word] = ACTIONS(1524),
    [anon_sym_SEMI] = ACTIONS(1524),
    [anon_sym_LF] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1524),
  },
  [1181] = {
    [sym__concat] = ACTIONS(1553),
    [sym_variable_name] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(1555),
    [anon_sym_RPAREN] = ACTIONS(1555),
    [anon_sym_SEMI_SEMI] = ACTIONS(1555),
    [anon_sym_PIPE_AMP] = ACTIONS(1555),
    [anon_sym_AMP_AMP] = ACTIONS(1555),
    [anon_sym_PIPE_PIPE] = ACTIONS(1555),
    [sym__special_characters] = ACTIONS(1555),
    [anon_sym_DQUOTE] = ACTIONS(1555),
    [sym_raw_string] = ACTIONS(1555),
    [anon_sym_DOLLAR] = ACTIONS(1555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1555),
    [anon_sym_BQUOTE] = ACTIONS(1555),
    [anon_sym_LT_LPAREN] = ACTIONS(1555),
    [anon_sym_GT_LPAREN] = ACTIONS(1555),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1555),
    [sym_word] = ACTIONS(1555),
    [anon_sym_SEMI] = ACTIONS(1555),
    [anon_sym_LF] = ACTIONS(1555),
    [anon_sym_AMP] = ACTIONS(1555),
  },
  [1182] = {
    [sym_concatenation] = STATE(1693),
    [sym_string] = STATE(1692),
    [sym_simple_expansion] = STATE(1692),
    [sym_expansion] = STATE(1692),
    [sym_command_substitution] = STATE(1692),
    [sym_process_substitution] = STATE(1692),
    [anon_sym_RBRACE] = ACTIONS(3493),
    [sym__special_characters] = ACTIONS(3495),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(3497),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3499),
  },
  [1183] = {
    [sym__concat] = ACTIONS(1598),
    [sym_variable_name] = ACTIONS(1598),
    [anon_sym_PIPE] = ACTIONS(1600),
    [anon_sym_RPAREN] = ACTIONS(1600),
    [anon_sym_SEMI_SEMI] = ACTIONS(1600),
    [anon_sym_PIPE_AMP] = ACTIONS(1600),
    [anon_sym_AMP_AMP] = ACTIONS(1600),
    [anon_sym_PIPE_PIPE] = ACTIONS(1600),
    [sym__special_characters] = ACTIONS(1600),
    [anon_sym_DQUOTE] = ACTIONS(1600),
    [sym_raw_string] = ACTIONS(1600),
    [anon_sym_DOLLAR] = ACTIONS(1600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1600),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1600),
    [anon_sym_BQUOTE] = ACTIONS(1600),
    [anon_sym_LT_LPAREN] = ACTIONS(1600),
    [anon_sym_GT_LPAREN] = ACTIONS(1600),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1600),
    [sym_word] = ACTIONS(1600),
    [anon_sym_SEMI] = ACTIONS(1600),
    [anon_sym_LF] = ACTIONS(1600),
    [anon_sym_AMP] = ACTIONS(1600),
  },
  [1184] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3501),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1185] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(3503),
    [sym_comment] = ACTIONS(52),
  },
  [1186] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1697),
    [anon_sym_RBRACE] = ACTIONS(3505),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1187] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1699),
    [anon_sym_RBRACE] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1188] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1700),
    [anon_sym_RBRACE] = ACTIONS(3493),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1189] = {
    [sym__concat] = ACTIONS(1642),
    [sym_variable_name] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1644),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1644),
    [anon_sym_BQUOTE] = ACTIONS(1644),
    [anon_sym_LT_LPAREN] = ACTIONS(1644),
    [anon_sym_GT_LPAREN] = ACTIONS(1644),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1644),
    [sym_word] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [1190] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3509),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1191] = {
    [sym__concat] = ACTIONS(1648),
    [sym_variable_name] = ACTIONS(1648),
    [anon_sym_PIPE] = ACTIONS(1650),
    [anon_sym_RPAREN] = ACTIONS(1650),
    [anon_sym_SEMI_SEMI] = ACTIONS(1650),
    [anon_sym_PIPE_AMP] = ACTIONS(1650),
    [anon_sym_AMP_AMP] = ACTIONS(1650),
    [anon_sym_PIPE_PIPE] = ACTIONS(1650),
    [sym__special_characters] = ACTIONS(1650),
    [anon_sym_DQUOTE] = ACTIONS(1650),
    [sym_raw_string] = ACTIONS(1650),
    [anon_sym_DOLLAR] = ACTIONS(1650),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1650),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1650),
    [anon_sym_BQUOTE] = ACTIONS(1650),
    [anon_sym_LT_LPAREN] = ACTIONS(1650),
    [anon_sym_GT_LPAREN] = ACTIONS(1650),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1650),
    [sym_word] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(1650),
    [anon_sym_LF] = ACTIONS(1650),
    [anon_sym_AMP] = ACTIONS(1650),
  },
  [1192] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3493),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1193] = {
    [sym__concat] = ACTIONS(1762),
    [sym_variable_name] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(1764),
    [anon_sym_RPAREN] = ACTIONS(1764),
    [anon_sym_SEMI_SEMI] = ACTIONS(1764),
    [anon_sym_PIPE_AMP] = ACTIONS(1764),
    [anon_sym_AMP_AMP] = ACTIONS(1764),
    [anon_sym_PIPE_PIPE] = ACTIONS(1764),
    [sym__special_characters] = ACTIONS(1764),
    [anon_sym_DQUOTE] = ACTIONS(1764),
    [sym_raw_string] = ACTIONS(1764),
    [anon_sym_DOLLAR] = ACTIONS(1764),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1764),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1764),
    [anon_sym_BQUOTE] = ACTIONS(1764),
    [anon_sym_LT_LPAREN] = ACTIONS(1764),
    [anon_sym_GT_LPAREN] = ACTIONS(1764),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1764),
    [sym_word] = ACTIONS(1764),
    [anon_sym_SEMI] = ACTIONS(1764),
    [anon_sym_LF] = ACTIONS(1764),
    [anon_sym_AMP] = ACTIONS(1764),
  },
  [1194] = {
    [sym__concat] = ACTIONS(1902),
    [sym_variable_name] = ACTIONS(1902),
    [anon_sym_PIPE] = ACTIONS(1904),
    [anon_sym_RPAREN] = ACTIONS(1904),
    [anon_sym_SEMI_SEMI] = ACTIONS(1904),
    [anon_sym_PIPE_AMP] = ACTIONS(1904),
    [anon_sym_AMP_AMP] = ACTIONS(1904),
    [anon_sym_PIPE_PIPE] = ACTIONS(1904),
    [sym__special_characters] = ACTIONS(1904),
    [anon_sym_DQUOTE] = ACTIONS(1904),
    [sym_raw_string] = ACTIONS(1904),
    [anon_sym_DOLLAR] = ACTIONS(1904),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1904),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1904),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [anon_sym_LT_LPAREN] = ACTIONS(1904),
    [anon_sym_GT_LPAREN] = ACTIONS(1904),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1904),
    [sym_word] = ACTIONS(1904),
    [anon_sym_SEMI] = ACTIONS(1904),
    [anon_sym_LF] = ACTIONS(1904),
    [anon_sym_AMP] = ACTIONS(1904),
  },
  [1195] = {
    [sym_file_descriptor] = ACTIONS(2560),
    [sym__concat] = ACTIONS(2560),
    [anon_sym_PIPE] = ACTIONS(2562),
    [anon_sym_RPAREN] = ACTIONS(2562),
    [anon_sym_SEMI_SEMI] = ACTIONS(2562),
    [anon_sym_PIPE_AMP] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_PIPE_PIPE] = ACTIONS(2562),
    [anon_sym_LT] = ACTIONS(2562),
    [anon_sym_GT] = ACTIONS(2562),
    [anon_sym_GT_GT] = ACTIONS(2562),
    [anon_sym_AMP_GT] = ACTIONS(2562),
    [anon_sym_AMP_GT_GT] = ACTIONS(2562),
    [anon_sym_LT_AMP] = ACTIONS(2562),
    [anon_sym_GT_AMP] = ACTIONS(2562),
    [anon_sym_LT_LT] = ACTIONS(2562),
    [anon_sym_LT_LT_DASH] = ACTIONS(2562),
    [anon_sym_LT_LT_LT] = ACTIONS(2562),
    [sym__special_characters] = ACTIONS(2562),
    [anon_sym_DQUOTE] = ACTIONS(2562),
    [sym_raw_string] = ACTIONS(2562),
    [anon_sym_DOLLAR] = ACTIONS(2562),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2562),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2562),
    [anon_sym_BQUOTE] = ACTIONS(2562),
    [anon_sym_LT_LPAREN] = ACTIONS(2562),
    [anon_sym_GT_LPAREN] = ACTIONS(2562),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2562),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym_LF] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(2562),
  },
  [1196] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(3511),
    [sym_comment] = ACTIONS(52),
  },
  [1197] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(3513),
    [sym_comment] = ACTIONS(52),
  },
  [1198] = {
    [anon_sym_RBRACE] = ACTIONS(3513),
    [sym_comment] = ACTIONS(52),
  },
  [1199] = {
    [sym_file_descriptor] = ACTIONS(2614),
    [sym__concat] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2616),
    [anon_sym_RPAREN] = ACTIONS(2616),
    [anon_sym_SEMI_SEMI] = ACTIONS(2616),
    [anon_sym_PIPE_AMP] = ACTIONS(2616),
    [anon_sym_AMP_AMP] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2616),
    [anon_sym_LT] = ACTIONS(2616),
    [anon_sym_GT] = ACTIONS(2616),
    [anon_sym_GT_GT] = ACTIONS(2616),
    [anon_sym_AMP_GT] = ACTIONS(2616),
    [anon_sym_AMP_GT_GT] = ACTIONS(2616),
    [anon_sym_LT_AMP] = ACTIONS(2616),
    [anon_sym_GT_AMP] = ACTIONS(2616),
    [anon_sym_LT_LT] = ACTIONS(2616),
    [anon_sym_LT_LT_DASH] = ACTIONS(2616),
    [anon_sym_LT_LT_LT] = ACTIONS(2616),
    [sym__special_characters] = ACTIONS(2616),
    [anon_sym_DQUOTE] = ACTIONS(2616),
    [sym_raw_string] = ACTIONS(2616),
    [anon_sym_DOLLAR] = ACTIONS(2616),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2616),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2616),
    [anon_sym_BQUOTE] = ACTIONS(2616),
    [anon_sym_LT_LPAREN] = ACTIONS(2616),
    [anon_sym_GT_LPAREN] = ACTIONS(2616),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2616),
    [anon_sym_LF] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2616),
  },
  [1200] = {
    [sym_concatenation] = STATE(1706),
    [sym_string] = STATE(1705),
    [sym_simple_expansion] = STATE(1705),
    [sym_expansion] = STATE(1705),
    [sym_command_substitution] = STATE(1705),
    [sym_process_substitution] = STATE(1705),
    [anon_sym_RBRACE] = ACTIONS(3513),
    [sym__special_characters] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(3517),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3519),
  },
  [1201] = {
    [sym_file_descriptor] = ACTIONS(2659),
    [sym__concat] = ACTIONS(2659),
    [anon_sym_PIPE] = ACTIONS(2661),
    [anon_sym_RPAREN] = ACTIONS(2661),
    [anon_sym_SEMI_SEMI] = ACTIONS(2661),
    [anon_sym_PIPE_AMP] = ACTIONS(2661),
    [anon_sym_AMP_AMP] = ACTIONS(2661),
    [anon_sym_PIPE_PIPE] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(2661),
    [anon_sym_GT] = ACTIONS(2661),
    [anon_sym_GT_GT] = ACTIONS(2661),
    [anon_sym_AMP_GT] = ACTIONS(2661),
    [anon_sym_AMP_GT_GT] = ACTIONS(2661),
    [anon_sym_LT_AMP] = ACTIONS(2661),
    [anon_sym_GT_AMP] = ACTIONS(2661),
    [anon_sym_LT_LT] = ACTIONS(2661),
    [anon_sym_LT_LT_DASH] = ACTIONS(2661),
    [anon_sym_LT_LT_LT] = ACTIONS(2661),
    [sym__special_characters] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2661),
    [sym_raw_string] = ACTIONS(2661),
    [anon_sym_DOLLAR] = ACTIONS(2661),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2661),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2661),
    [anon_sym_BQUOTE] = ACTIONS(2661),
    [anon_sym_LT_LPAREN] = ACTIONS(2661),
    [anon_sym_GT_LPAREN] = ACTIONS(2661),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2661),
    [anon_sym_SEMI] = ACTIONS(2661),
    [anon_sym_LF] = ACTIONS(2661),
    [anon_sym_AMP] = ACTIONS(2661),
  },
  [1202] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3521),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1203] = {
    [sym_file_descriptor] = ACTIONS(2665),
    [sym__concat] = ACTIONS(2665),
    [anon_sym_PIPE] = ACTIONS(2667),
    [anon_sym_RPAREN] = ACTIONS(2667),
    [anon_sym_SEMI_SEMI] = ACTIONS(2667),
    [anon_sym_PIPE_AMP] = ACTIONS(2667),
    [anon_sym_AMP_AMP] = ACTIONS(2667),
    [anon_sym_PIPE_PIPE] = ACTIONS(2667),
    [anon_sym_LT] = ACTIONS(2667),
    [anon_sym_GT] = ACTIONS(2667),
    [anon_sym_GT_GT] = ACTIONS(2667),
    [anon_sym_AMP_GT] = ACTIONS(2667),
    [anon_sym_AMP_GT_GT] = ACTIONS(2667),
    [anon_sym_LT_AMP] = ACTIONS(2667),
    [anon_sym_GT_AMP] = ACTIONS(2667),
    [anon_sym_LT_LT] = ACTIONS(2667),
    [anon_sym_LT_LT_DASH] = ACTIONS(2667),
    [anon_sym_LT_LT_LT] = ACTIONS(2667),
    [sym__special_characters] = ACTIONS(2667),
    [anon_sym_DQUOTE] = ACTIONS(2667),
    [sym_raw_string] = ACTIONS(2667),
    [anon_sym_DOLLAR] = ACTIONS(2667),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2667),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2667),
    [anon_sym_BQUOTE] = ACTIONS(2667),
    [anon_sym_LT_LPAREN] = ACTIONS(2667),
    [anon_sym_GT_LPAREN] = ACTIONS(2667),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2667),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym_LF] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(2667),
  },
  [1204] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3523),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1205] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3513),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1206] = {
    [sym_file_descriptor] = ACTIONS(2671),
    [sym__concat] = ACTIONS(2671),
    [anon_sym_PIPE] = ACTIONS(2673),
    [anon_sym_RPAREN] = ACTIONS(2673),
    [anon_sym_SEMI_SEMI] = ACTIONS(2673),
    [anon_sym_PIPE_AMP] = ACTIONS(2673),
    [anon_sym_AMP_AMP] = ACTIONS(2673),
    [anon_sym_PIPE_PIPE] = ACTIONS(2673),
    [anon_sym_LT] = ACTIONS(2673),
    [anon_sym_GT] = ACTIONS(2673),
    [anon_sym_GT_GT] = ACTIONS(2673),
    [anon_sym_AMP_GT] = ACTIONS(2673),
    [anon_sym_AMP_GT_GT] = ACTIONS(2673),
    [anon_sym_LT_AMP] = ACTIONS(2673),
    [anon_sym_GT_AMP] = ACTIONS(2673),
    [anon_sym_LT_LT] = ACTIONS(2673),
    [anon_sym_LT_LT_DASH] = ACTIONS(2673),
    [anon_sym_LT_LT_LT] = ACTIONS(2673),
    [sym__special_characters] = ACTIONS(2673),
    [anon_sym_DQUOTE] = ACTIONS(2673),
    [sym_raw_string] = ACTIONS(2673),
    [anon_sym_DOLLAR] = ACTIONS(2673),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2673),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2673),
    [anon_sym_BQUOTE] = ACTIONS(2673),
    [anon_sym_LT_LPAREN] = ACTIONS(2673),
    [anon_sym_GT_LPAREN] = ACTIONS(2673),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2673),
    [anon_sym_SEMI] = ACTIONS(2673),
    [anon_sym_LF] = ACTIONS(2673),
    [anon_sym_AMP] = ACTIONS(2673),
  },
  [1207] = {
    [sym_file_redirect] = STATE(1510),
    [sym_file_descriptor] = ACTIONS(2273),
    [anon_sym_PIPE] = ACTIONS(2249),
    [anon_sym_RPAREN] = ACTIONS(2249),
    [anon_sym_SEMI_SEMI] = ACTIONS(2249),
    [anon_sym_PIPE_AMP] = ACTIONS(2249),
    [anon_sym_AMP_AMP] = ACTIONS(2249),
    [anon_sym_PIPE_PIPE] = ACTIONS(2249),
    [anon_sym_LT] = ACTIONS(2275),
    [anon_sym_GT] = ACTIONS(2275),
    [anon_sym_GT_GT] = ACTIONS(2275),
    [anon_sym_AMP_GT] = ACTIONS(2275),
    [anon_sym_AMP_GT_GT] = ACTIONS(2275),
    [anon_sym_LT_AMP] = ACTIONS(2275),
    [anon_sym_GT_AMP] = ACTIONS(2275),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2249),
    [anon_sym_LF] = ACTIONS(2249),
    [anon_sym_AMP] = ACTIONS(2249),
  },
  [1208] = {
    [aux_sym_concatenation_repeat1] = STATE(1211),
    [sym_file_descriptor] = ACTIONS(1032),
    [sym__concat] = ACTIONS(2375),
    [anon_sym_PIPE] = ACTIONS(3112),
    [anon_sym_RPAREN] = ACTIONS(3112),
    [anon_sym_SEMI_SEMI] = ACTIONS(3112),
    [anon_sym_PIPE_AMP] = ACTIONS(3112),
    [anon_sym_AMP_AMP] = ACTIONS(3112),
    [anon_sym_PIPE_PIPE] = ACTIONS(3112),
    [anon_sym_LT] = ACTIONS(3112),
    [anon_sym_GT] = ACTIONS(3112),
    [anon_sym_GT_GT] = ACTIONS(3112),
    [anon_sym_AMP_GT] = ACTIONS(3112),
    [anon_sym_AMP_GT_GT] = ACTIONS(3112),
    [anon_sym_LT_AMP] = ACTIONS(3112),
    [anon_sym_GT_AMP] = ACTIONS(3112),
    [anon_sym_LT_LT] = ACTIONS(3112),
    [anon_sym_LT_LT_DASH] = ACTIONS(3112),
    [anon_sym_LT_LT_LT] = ACTIONS(3112),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3112),
    [anon_sym_LF] = ACTIONS(3112),
    [anon_sym_AMP] = ACTIONS(3112),
  },
  [1209] = {
    [aux_sym_concatenation_repeat1] = STATE(1211),
    [sym_file_descriptor] = ACTIONS(1036),
    [sym__concat] = ACTIONS(2375),
    [anon_sym_PIPE] = ACTIONS(3114),
    [anon_sym_RPAREN] = ACTIONS(3114),
    [anon_sym_SEMI_SEMI] = ACTIONS(3114),
    [anon_sym_PIPE_AMP] = ACTIONS(3114),
    [anon_sym_AMP_AMP] = ACTIONS(3114),
    [anon_sym_PIPE_PIPE] = ACTIONS(3114),
    [anon_sym_LT] = ACTIONS(3114),
    [anon_sym_GT] = ACTIONS(3114),
    [anon_sym_GT_GT] = ACTIONS(3114),
    [anon_sym_AMP_GT] = ACTIONS(3114),
    [anon_sym_AMP_GT_GT] = ACTIONS(3114),
    [anon_sym_LT_AMP] = ACTIONS(3114),
    [anon_sym_GT_AMP] = ACTIONS(3114),
    [anon_sym_LT_LT] = ACTIONS(3114),
    [anon_sym_LT_LT_DASH] = ACTIONS(3114),
    [anon_sym_LT_LT_LT] = ACTIONS(3114),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3114),
    [anon_sym_LF] = ACTIONS(3114),
    [anon_sym_AMP] = ACTIONS(3114),
  },
  [1210] = {
    [sym_string] = STATE(1709),
    [sym_simple_expansion] = STATE(1709),
    [sym_expansion] = STATE(1709),
    [sym_command_substitution] = STATE(1709),
    [sym_process_substitution] = STATE(1709),
    [sym__special_characters] = ACTIONS(3525),
    [anon_sym_DQUOTE] = ACTIONS(1270),
    [sym_raw_string] = ACTIONS(3527),
    [anon_sym_DOLLAR] = ACTIONS(1274),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1276),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1278),
    [anon_sym_BQUOTE] = ACTIONS(1280),
    [anon_sym_LT_LPAREN] = ACTIONS(1282),
    [anon_sym_GT_LPAREN] = ACTIONS(1282),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3525),
  },
  [1211] = {
    [aux_sym_concatenation_repeat1] = STATE(1710),
    [sym_file_descriptor] = ACTIONS(646),
    [sym__concat] = ACTIONS(2375),
    [anon_sym_PIPE] = ACTIONS(648),
    [anon_sym_RPAREN] = ACTIONS(648),
    [anon_sym_SEMI_SEMI] = ACTIONS(648),
    [anon_sym_PIPE_AMP] = ACTIONS(648),
    [anon_sym_AMP_AMP] = ACTIONS(648),
    [anon_sym_PIPE_PIPE] = ACTIONS(648),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(648),
    [anon_sym_GT_GT] = ACTIONS(648),
    [anon_sym_AMP_GT] = ACTIONS(648),
    [anon_sym_AMP_GT_GT] = ACTIONS(648),
    [anon_sym_LT_AMP] = ACTIONS(648),
    [anon_sym_GT_AMP] = ACTIONS(648),
    [anon_sym_LT_LT] = ACTIONS(648),
    [anon_sym_LT_LT_DASH] = ACTIONS(648),
    [anon_sym_LT_LT_LT] = ACTIONS(648),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(648),
    [anon_sym_LF] = ACTIONS(648),
    [anon_sym_AMP] = ACTIONS(648),
  },
  [1212] = {
    [sym_file_descriptor] = ACTIONS(650),
    [sym__concat] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(652),
    [anon_sym_RPAREN] = ACTIONS(652),
    [anon_sym_SEMI_SEMI] = ACTIONS(652),
    [anon_sym_PIPE_AMP] = ACTIONS(652),
    [anon_sym_AMP_AMP] = ACTIONS(652),
    [anon_sym_PIPE_PIPE] = ACTIONS(652),
    [anon_sym_LT] = ACTIONS(652),
    [anon_sym_GT] = ACTIONS(652),
    [anon_sym_GT_GT] = ACTIONS(652),
    [anon_sym_AMP_GT] = ACTIONS(652),
    [anon_sym_AMP_GT_GT] = ACTIONS(652),
    [anon_sym_LT_AMP] = ACTIONS(652),
    [anon_sym_GT_AMP] = ACTIONS(652),
    [anon_sym_LT_LT] = ACTIONS(652),
    [anon_sym_LT_LT_DASH] = ACTIONS(652),
    [anon_sym_LT_LT_LT] = ACTIONS(652),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(652),
    [anon_sym_LF] = ACTIONS(652),
    [anon_sym_AMP] = ACTIONS(652),
  },
  [1213] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(3529),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [1214] = {
    [sym_file_descriptor] = ACTIONS(680),
    [sym__concat] = ACTIONS(680),
    [anon_sym_PIPE] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(682),
    [anon_sym_SEMI_SEMI] = ACTIONS(682),
    [anon_sym_PIPE_AMP] = ACTIONS(682),
    [anon_sym_AMP_AMP] = ACTIONS(682),
    [anon_sym_PIPE_PIPE] = ACTIONS(682),
    [anon_sym_LT] = ACTIONS(682),
    [anon_sym_GT] = ACTIONS(682),
    [anon_sym_GT_GT] = ACTIONS(682),
    [anon_sym_AMP_GT] = ACTIONS(682),
    [anon_sym_AMP_GT_GT] = ACTIONS(682),
    [anon_sym_LT_AMP] = ACTIONS(682),
    [anon_sym_GT_AMP] = ACTIONS(682),
    [anon_sym_LT_LT] = ACTIONS(682),
    [anon_sym_LT_LT_DASH] = ACTIONS(682),
    [anon_sym_LT_LT_LT] = ACTIONS(682),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(682),
    [anon_sym_LF] = ACTIONS(682),
    [anon_sym_AMP] = ACTIONS(682),
  },
  [1215] = {
    [sym_file_descriptor] = ACTIONS(684),
    [sym__concat] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(686),
    [anon_sym_RPAREN] = ACTIONS(686),
    [anon_sym_SEMI_SEMI] = ACTIONS(686),
    [anon_sym_PIPE_AMP] = ACTIONS(686),
    [anon_sym_AMP_AMP] = ACTIONS(686),
    [anon_sym_PIPE_PIPE] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(686),
    [anon_sym_GT] = ACTIONS(686),
    [anon_sym_GT_GT] = ACTIONS(686),
    [anon_sym_AMP_GT] = ACTIONS(686),
    [anon_sym_AMP_GT_GT] = ACTIONS(686),
    [anon_sym_LT_AMP] = ACTIONS(686),
    [anon_sym_GT_AMP] = ACTIONS(686),
    [anon_sym_LT_LT] = ACTIONS(686),
    [anon_sym_LT_LT_DASH] = ACTIONS(686),
    [anon_sym_LT_LT_LT] = ACTIONS(686),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(686),
    [anon_sym_LF] = ACTIONS(686),
    [anon_sym_AMP] = ACTIONS(686),
  },
  [1216] = {
    [sym_file_descriptor] = ACTIONS(688),
    [sym__concat] = ACTIONS(688),
    [anon_sym_PIPE] = ACTIONS(690),
    [anon_sym_RPAREN] = ACTIONS(690),
    [anon_sym_SEMI_SEMI] = ACTIONS(690),
    [anon_sym_PIPE_AMP] = ACTIONS(690),
    [anon_sym_AMP_AMP] = ACTIONS(690),
    [anon_sym_PIPE_PIPE] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(690),
    [anon_sym_GT] = ACTIONS(690),
    [anon_sym_GT_GT] = ACTIONS(690),
    [anon_sym_AMP_GT] = ACTIONS(690),
    [anon_sym_AMP_GT_GT] = ACTIONS(690),
    [anon_sym_LT_AMP] = ACTIONS(690),
    [anon_sym_GT_AMP] = ACTIONS(690),
    [anon_sym_LT_LT] = ACTIONS(690),
    [anon_sym_LT_LT_DASH] = ACTIONS(690),
    [anon_sym_LT_LT_LT] = ACTIONS(690),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(690),
    [anon_sym_LF] = ACTIONS(690),
    [anon_sym_AMP] = ACTIONS(690),
  },
  [1217] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(3531),
    [sym_comment] = ACTIONS(52),
  },
  [1218] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1714),
    [anon_sym_RBRACE] = ACTIONS(3533),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1219] = {
    [sym_subscript] = STATE(1718),
    [sym_variable_name] = ACTIONS(3535),
    [anon_sym_DOLLAR] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3537),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3539),
    [anon_sym_STAR] = ACTIONS(3537),
    [anon_sym_AT] = ACTIONS(3537),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_0] = ACTIONS(3541),
    [anon_sym__] = ACTIONS(3541),
  },
  [1220] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1720),
    [anon_sym_RBRACE] = ACTIONS(3543),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1221] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1722),
    [anon_sym_RBRACE] = ACTIONS(3545),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1222] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3547),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [1223] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3547),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1224] = {
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(3547),
    [sym_comment] = ACTIONS(52),
  },
  [1225] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(3547),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1226] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3549),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [1227] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3549),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1228] = {
    [anon_sym_PIPE] = ACTIONS(3551),
    [anon_sym_RPAREN] = ACTIONS(3551),
    [anon_sym_SEMI_SEMI] = ACTIONS(3551),
    [anon_sym_PIPE_AMP] = ACTIONS(3551),
    [anon_sym_AMP_AMP] = ACTIONS(3551),
    [anon_sym_PIPE_PIPE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3551),
    [anon_sym_LF] = ACTIONS(3551),
    [anon_sym_AMP] = ACTIONS(3551),
  },
  [1229] = {
    [sym_file_redirect] = STATE(185),
    [sym_heredoc_redirect] = STATE(185),
    [sym_herestring_redirect] = STATE(185),
    [aux_sym_while_statement_repeat1] = STATE(711),
    [sym_file_descriptor] = ACTIONS(490),
    [anon_sym_PIPE] = ACTIONS(3170),
    [anon_sym_RPAREN] = ACTIONS(3170),
    [anon_sym_SEMI_SEMI] = ACTIONS(3170),
    [anon_sym_PIPE_AMP] = ACTIONS(3170),
    [anon_sym_AMP_AMP] = ACTIONS(3170),
    [anon_sym_PIPE_PIPE] = ACTIONS(3170),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_GT] = ACTIONS(492),
    [anon_sym_GT_GT] = ACTIONS(492),
    [anon_sym_AMP_GT] = ACTIONS(492),
    [anon_sym_AMP_GT_GT] = ACTIONS(492),
    [anon_sym_LT_AMP] = ACTIONS(492),
    [anon_sym_GT_AMP] = ACTIONS(492),
    [anon_sym_LT_LT] = ACTIONS(314),
    [anon_sym_LT_LT_DASH] = ACTIONS(314),
    [anon_sym_LT_LT_LT] = ACTIONS(494),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3170),
    [anon_sym_LF] = ACTIONS(3170),
    [anon_sym_AMP] = ACTIONS(3170),
  },
  [1230] = {
    [sym__concat] = ACTIONS(2560),
    [anon_sym_RBRACK] = ACTIONS(3553),
    [sym__special_characters] = ACTIONS(2562),
    [anon_sym_DQUOTE] = ACTIONS(2560),
    [sym_raw_string] = ACTIONS(2560),
    [anon_sym_DOLLAR] = ACTIONS(3553),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2560),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2560),
    [anon_sym_BQUOTE] = ACTIONS(2560),
    [anon_sym_LT_LPAREN] = ACTIONS(2560),
    [anon_sym_GT_LPAREN] = ACTIONS(2560),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3553),
  },
  [1231] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(3555),
    [sym_comment] = ACTIONS(52),
  },
  [1232] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(3557),
    [sym_comment] = ACTIONS(52),
  },
  [1233] = {
    [anon_sym_RBRACE] = ACTIONS(3557),
    [sym_comment] = ACTIONS(52),
  },
  [1234] = {
    [sym__concat] = ACTIONS(2614),
    [anon_sym_RBRACK] = ACTIONS(3559),
    [sym__special_characters] = ACTIONS(2616),
    [anon_sym_DQUOTE] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(2614),
    [anon_sym_DOLLAR] = ACTIONS(3559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2614),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2614),
    [anon_sym_BQUOTE] = ACTIONS(2614),
    [anon_sym_LT_LPAREN] = ACTIONS(2614),
    [anon_sym_GT_LPAREN] = ACTIONS(2614),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3559),
  },
  [1235] = {
    [sym_concatenation] = STATE(1729),
    [sym_string] = STATE(1728),
    [sym_simple_expansion] = STATE(1728),
    [sym_expansion] = STATE(1728),
    [sym_command_substitution] = STATE(1728),
    [sym_process_substitution] = STATE(1728),
    [anon_sym_RBRACE] = ACTIONS(3557),
    [sym__special_characters] = ACTIONS(3561),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(3563),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3565),
  },
  [1236] = {
    [sym__concat] = ACTIONS(2659),
    [anon_sym_RBRACK] = ACTIONS(3567),
    [sym__special_characters] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2659),
    [sym_raw_string] = ACTIONS(2659),
    [anon_sym_DOLLAR] = ACTIONS(3567),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2659),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2659),
    [anon_sym_BQUOTE] = ACTIONS(2659),
    [anon_sym_LT_LPAREN] = ACTIONS(2659),
    [anon_sym_GT_LPAREN] = ACTIONS(2659),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3567),
  },
  [1237] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3569),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1238] = {
    [sym__concat] = ACTIONS(2665),
    [anon_sym_RBRACK] = ACTIONS(3571),
    [sym__special_characters] = ACTIONS(2667),
    [anon_sym_DQUOTE] = ACTIONS(2665),
    [sym_raw_string] = ACTIONS(2665),
    [anon_sym_DOLLAR] = ACTIONS(3571),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2665),
    [anon_sym_BQUOTE] = ACTIONS(2665),
    [anon_sym_LT_LPAREN] = ACTIONS(2665),
    [anon_sym_GT_LPAREN] = ACTIONS(2665),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3571),
  },
  [1239] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3573),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1240] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3557),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1241] = {
    [sym__concat] = ACTIONS(2671),
    [anon_sym_RBRACK] = ACTIONS(3575),
    [sym__special_characters] = ACTIONS(2673),
    [anon_sym_DQUOTE] = ACTIONS(2671),
    [sym_raw_string] = ACTIONS(2671),
    [anon_sym_DOLLAR] = ACTIONS(3575),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2671),
    [anon_sym_BQUOTE] = ACTIONS(2671),
    [anon_sym_LT_LPAREN] = ACTIONS(2671),
    [anon_sym_GT_LPAREN] = ACTIONS(2671),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3575),
  },
  [1242] = {
    [sym__concat] = ACTIONS(2560),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2560),
    [sym__special_characters] = ACTIONS(2562),
    [anon_sym_DQUOTE] = ACTIONS(2560),
    [sym_raw_string] = ACTIONS(2560),
    [anon_sym_DOLLAR] = ACTIONS(3553),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2560),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2560),
    [anon_sym_BQUOTE] = ACTIONS(2560),
    [anon_sym_LT_LPAREN] = ACTIONS(2560),
    [anon_sym_GT_LPAREN] = ACTIONS(2560),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3553),
  },
  [1243] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(3577),
    [sym_comment] = ACTIONS(52),
  },
  [1244] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(3579),
    [sym_comment] = ACTIONS(52),
  },
  [1245] = {
    [anon_sym_RBRACE] = ACTIONS(3579),
    [sym_comment] = ACTIONS(52),
  },
  [1246] = {
    [sym__concat] = ACTIONS(2614),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2614),
    [sym__special_characters] = ACTIONS(2616),
    [anon_sym_DQUOTE] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(2614),
    [anon_sym_DOLLAR] = ACTIONS(3559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2614),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2614),
    [anon_sym_BQUOTE] = ACTIONS(2614),
    [anon_sym_LT_LPAREN] = ACTIONS(2614),
    [anon_sym_GT_LPAREN] = ACTIONS(2614),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3559),
  },
  [1247] = {
    [sym_concatenation] = STATE(1736),
    [sym_string] = STATE(1735),
    [sym_simple_expansion] = STATE(1735),
    [sym_expansion] = STATE(1735),
    [sym_command_substitution] = STATE(1735),
    [sym_process_substitution] = STATE(1735),
    [anon_sym_RBRACE] = ACTIONS(3579),
    [sym__special_characters] = ACTIONS(3581),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(3583),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3585),
  },
  [1248] = {
    [sym__concat] = ACTIONS(2659),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2659),
    [sym__special_characters] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2659),
    [sym_raw_string] = ACTIONS(2659),
    [anon_sym_DOLLAR] = ACTIONS(3567),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2659),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2659),
    [anon_sym_BQUOTE] = ACTIONS(2659),
    [anon_sym_LT_LPAREN] = ACTIONS(2659),
    [anon_sym_GT_LPAREN] = ACTIONS(2659),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3567),
  },
  [1249] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3587),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1250] = {
    [sym__concat] = ACTIONS(2665),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2665),
    [sym__special_characters] = ACTIONS(2667),
    [anon_sym_DQUOTE] = ACTIONS(2665),
    [sym_raw_string] = ACTIONS(2665),
    [anon_sym_DOLLAR] = ACTIONS(3571),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2665),
    [anon_sym_BQUOTE] = ACTIONS(2665),
    [anon_sym_LT_LPAREN] = ACTIONS(2665),
    [anon_sym_GT_LPAREN] = ACTIONS(2665),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3571),
  },
  [1251] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3589),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1252] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3579),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1253] = {
    [sym__concat] = ACTIONS(2671),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2671),
    [sym__special_characters] = ACTIONS(2673),
    [anon_sym_DQUOTE] = ACTIONS(2671),
    [sym_raw_string] = ACTIONS(2671),
    [anon_sym_DOLLAR] = ACTIONS(3575),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2671),
    [anon_sym_BQUOTE] = ACTIONS(2671),
    [anon_sym_LT_LPAREN] = ACTIONS(2671),
    [anon_sym_GT_LPAREN] = ACTIONS(2671),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3575),
  },
  [1254] = {
    [sym_variable_name] = ACTIONS(2056),
    [anon_sym_PIPE] = ACTIONS(2058),
    [anon_sym_RPAREN] = ACTIONS(2058),
    [anon_sym_SEMI_SEMI] = ACTIONS(2058),
    [anon_sym_PIPE_AMP] = ACTIONS(2058),
    [anon_sym_AMP_AMP] = ACTIONS(2058),
    [anon_sym_PIPE_PIPE] = ACTIONS(2058),
    [sym__special_characters] = ACTIONS(2058),
    [anon_sym_DQUOTE] = ACTIONS(2058),
    [sym_raw_string] = ACTIONS(2058),
    [anon_sym_DOLLAR] = ACTIONS(2058),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2058),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2058),
    [anon_sym_BQUOTE] = ACTIONS(2058),
    [anon_sym_LT_LPAREN] = ACTIONS(2058),
    [anon_sym_GT_LPAREN] = ACTIONS(2058),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2058),
    [sym_word] = ACTIONS(2058),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym_LF] = ACTIONS(2058),
    [anon_sym_AMP] = ACTIONS(2058),
  },
  [1255] = {
    [sym_concatenation] = STATE(572),
    [sym_string] = STATE(566),
    [sym_simple_expansion] = STATE(566),
    [sym_expansion] = STATE(566),
    [sym_command_substitution] = STATE(566),
    [sym_process_substitution] = STATE(566),
    [aux_sym_for_statement_repeat1] = STATE(1060),
    [anon_sym_RPAREN] = ACTIONS(3591),
    [sym__special_characters] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1076),
    [sym_raw_string] = ACTIONS(1078),
    [anon_sym_DOLLAR] = ACTIONS(1080),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1084),
    [anon_sym_BQUOTE] = ACTIONS(1086),
    [anon_sym_LT_LPAREN] = ACTIONS(1088),
    [anon_sym_GT_LPAREN] = ACTIONS(1088),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1090),
  },
  [1256] = {
    [sym__concat] = ACTIONS(2560),
    [sym_variable_name] = ACTIONS(2560),
    [anon_sym_PIPE] = ACTIONS(2562),
    [anon_sym_SEMI_SEMI] = ACTIONS(2562),
    [anon_sym_PIPE_AMP] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_PIPE_PIPE] = ACTIONS(2562),
    [sym__special_characters] = ACTIONS(2562),
    [anon_sym_DQUOTE] = ACTIONS(2562),
    [sym_raw_string] = ACTIONS(2562),
    [anon_sym_DOLLAR] = ACTIONS(2562),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2562),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2562),
    [anon_sym_BQUOTE] = ACTIONS(2562),
    [anon_sym_LT_LPAREN] = ACTIONS(2562),
    [anon_sym_GT_LPAREN] = ACTIONS(2562),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2562),
    [sym_word] = ACTIONS(2562),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym_LF] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(2562),
  },
  [1257] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(3593),
    [sym_comment] = ACTIONS(52),
  },
  [1258] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(3595),
    [sym_comment] = ACTIONS(52),
  },
  [1259] = {
    [anon_sym_RBRACE] = ACTIONS(3595),
    [sym_comment] = ACTIONS(52),
  },
  [1260] = {
    [sym__concat] = ACTIONS(2614),
    [sym_variable_name] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2616),
    [anon_sym_SEMI_SEMI] = ACTIONS(2616),
    [anon_sym_PIPE_AMP] = ACTIONS(2616),
    [anon_sym_AMP_AMP] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2616),
    [sym__special_characters] = ACTIONS(2616),
    [anon_sym_DQUOTE] = ACTIONS(2616),
    [sym_raw_string] = ACTIONS(2616),
    [anon_sym_DOLLAR] = ACTIONS(2616),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2616),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2616),
    [anon_sym_BQUOTE] = ACTIONS(2616),
    [anon_sym_LT_LPAREN] = ACTIONS(2616),
    [anon_sym_GT_LPAREN] = ACTIONS(2616),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2616),
    [sym_word] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2616),
    [anon_sym_LF] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2616),
  },
  [1261] = {
    [sym_concatenation] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_simple_expansion] = STATE(1743),
    [sym_expansion] = STATE(1743),
    [sym_command_substitution] = STATE(1743),
    [sym_process_substitution] = STATE(1743),
    [anon_sym_RBRACE] = ACTIONS(3595),
    [sym__special_characters] = ACTIONS(3597),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(3599),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3601),
  },
  [1262] = {
    [sym__concat] = ACTIONS(2659),
    [sym_variable_name] = ACTIONS(2659),
    [anon_sym_PIPE] = ACTIONS(2661),
    [anon_sym_SEMI_SEMI] = ACTIONS(2661),
    [anon_sym_PIPE_AMP] = ACTIONS(2661),
    [anon_sym_AMP_AMP] = ACTIONS(2661),
    [anon_sym_PIPE_PIPE] = ACTIONS(2661),
    [sym__special_characters] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2661),
    [sym_raw_string] = ACTIONS(2661),
    [anon_sym_DOLLAR] = ACTIONS(2661),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2661),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2661),
    [anon_sym_BQUOTE] = ACTIONS(2661),
    [anon_sym_LT_LPAREN] = ACTIONS(2661),
    [anon_sym_GT_LPAREN] = ACTIONS(2661),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2661),
    [sym_word] = ACTIONS(2661),
    [anon_sym_SEMI] = ACTIONS(2661),
    [anon_sym_LF] = ACTIONS(2661),
    [anon_sym_AMP] = ACTIONS(2661),
  },
  [1263] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3603),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1264] = {
    [sym__concat] = ACTIONS(2665),
    [sym_variable_name] = ACTIONS(2665),
    [anon_sym_PIPE] = ACTIONS(2667),
    [anon_sym_SEMI_SEMI] = ACTIONS(2667),
    [anon_sym_PIPE_AMP] = ACTIONS(2667),
    [anon_sym_AMP_AMP] = ACTIONS(2667),
    [anon_sym_PIPE_PIPE] = ACTIONS(2667),
    [sym__special_characters] = ACTIONS(2667),
    [anon_sym_DQUOTE] = ACTIONS(2667),
    [sym_raw_string] = ACTIONS(2667),
    [anon_sym_DOLLAR] = ACTIONS(2667),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2667),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2667),
    [anon_sym_BQUOTE] = ACTIONS(2667),
    [anon_sym_LT_LPAREN] = ACTIONS(2667),
    [anon_sym_GT_LPAREN] = ACTIONS(2667),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2667),
    [sym_word] = ACTIONS(2667),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym_LF] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(2667),
  },
  [1265] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3605),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1266] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3595),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1267] = {
    [sym__concat] = ACTIONS(2671),
    [sym_variable_name] = ACTIONS(2671),
    [anon_sym_PIPE] = ACTIONS(2673),
    [anon_sym_SEMI_SEMI] = ACTIONS(2673),
    [anon_sym_PIPE_AMP] = ACTIONS(2673),
    [anon_sym_AMP_AMP] = ACTIONS(2673),
    [anon_sym_PIPE_PIPE] = ACTIONS(2673),
    [sym__special_characters] = ACTIONS(2673),
    [anon_sym_DQUOTE] = ACTIONS(2673),
    [sym_raw_string] = ACTIONS(2673),
    [anon_sym_DOLLAR] = ACTIONS(2673),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2673),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2673),
    [anon_sym_BQUOTE] = ACTIONS(2673),
    [anon_sym_LT_LPAREN] = ACTIONS(2673),
    [anon_sym_GT_LPAREN] = ACTIONS(2673),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2673),
    [sym_word] = ACTIONS(2673),
    [anon_sym_SEMI] = ACTIONS(2673),
    [anon_sym_LF] = ACTIONS(2673),
    [anon_sym_AMP] = ACTIONS(2673),
  },
  [1268] = {
    [sym_file_descriptor] = ACTIONS(2560),
    [sym__concat] = ACTIONS(2560),
    [sym_variable_name] = ACTIONS(2560),
    [anon_sym_LT] = ACTIONS(3553),
    [anon_sym_GT] = ACTIONS(3553),
    [anon_sym_GT_GT] = ACTIONS(2560),
    [anon_sym_AMP_GT] = ACTIONS(3553),
    [anon_sym_AMP_GT_GT] = ACTIONS(2560),
    [anon_sym_LT_AMP] = ACTIONS(2560),
    [anon_sym_GT_AMP] = ACTIONS(2560),
    [sym__special_characters] = ACTIONS(3553),
    [anon_sym_DQUOTE] = ACTIONS(2560),
    [sym_raw_string] = ACTIONS(2560),
    [anon_sym_DOLLAR] = ACTIONS(3553),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2560),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2560),
    [anon_sym_BQUOTE] = ACTIONS(2560),
    [anon_sym_LT_LPAREN] = ACTIONS(2560),
    [anon_sym_GT_LPAREN] = ACTIONS(2560),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3553),
  },
  [1269] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(3607),
    [sym_comment] = ACTIONS(52),
  },
  [1270] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(3609),
    [sym_comment] = ACTIONS(52),
  },
  [1271] = {
    [anon_sym_RBRACE] = ACTIONS(3609),
    [sym_comment] = ACTIONS(52),
  },
  [1272] = {
    [sym_file_descriptor] = ACTIONS(2614),
    [sym__concat] = ACTIONS(2614),
    [sym_variable_name] = ACTIONS(2614),
    [anon_sym_LT] = ACTIONS(3559),
    [anon_sym_GT] = ACTIONS(3559),
    [anon_sym_GT_GT] = ACTIONS(2614),
    [anon_sym_AMP_GT] = ACTIONS(3559),
    [anon_sym_AMP_GT_GT] = ACTIONS(2614),
    [anon_sym_LT_AMP] = ACTIONS(2614),
    [anon_sym_GT_AMP] = ACTIONS(2614),
    [sym__special_characters] = ACTIONS(3559),
    [anon_sym_DQUOTE] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(2614),
    [anon_sym_DOLLAR] = ACTIONS(3559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2614),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2614),
    [anon_sym_BQUOTE] = ACTIONS(2614),
    [anon_sym_LT_LPAREN] = ACTIONS(2614),
    [anon_sym_GT_LPAREN] = ACTIONS(2614),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3559),
  },
  [1273] = {
    [sym_concatenation] = STATE(1751),
    [sym_string] = STATE(1750),
    [sym_simple_expansion] = STATE(1750),
    [sym_expansion] = STATE(1750),
    [sym_command_substitution] = STATE(1750),
    [sym_process_substitution] = STATE(1750),
    [anon_sym_RBRACE] = ACTIONS(3609),
    [sym__special_characters] = ACTIONS(3611),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(3613),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3615),
  },
  [1274] = {
    [sym_file_descriptor] = ACTIONS(2659),
    [sym__concat] = ACTIONS(2659),
    [sym_variable_name] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(3567),
    [anon_sym_GT] = ACTIONS(3567),
    [anon_sym_GT_GT] = ACTIONS(2659),
    [anon_sym_AMP_GT] = ACTIONS(3567),
    [anon_sym_AMP_GT_GT] = ACTIONS(2659),
    [anon_sym_LT_AMP] = ACTIONS(2659),
    [anon_sym_GT_AMP] = ACTIONS(2659),
    [sym__special_characters] = ACTIONS(3567),
    [anon_sym_DQUOTE] = ACTIONS(2659),
    [sym_raw_string] = ACTIONS(2659),
    [anon_sym_DOLLAR] = ACTIONS(3567),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2659),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2659),
    [anon_sym_BQUOTE] = ACTIONS(2659),
    [anon_sym_LT_LPAREN] = ACTIONS(2659),
    [anon_sym_GT_LPAREN] = ACTIONS(2659),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3567),
  },
  [1275] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1276] = {
    [sym_file_descriptor] = ACTIONS(2665),
    [sym__concat] = ACTIONS(2665),
    [sym_variable_name] = ACTIONS(2665),
    [anon_sym_LT] = ACTIONS(3571),
    [anon_sym_GT] = ACTIONS(3571),
    [anon_sym_GT_GT] = ACTIONS(2665),
    [anon_sym_AMP_GT] = ACTIONS(3571),
    [anon_sym_AMP_GT_GT] = ACTIONS(2665),
    [anon_sym_LT_AMP] = ACTIONS(2665),
    [anon_sym_GT_AMP] = ACTIONS(2665),
    [sym__special_characters] = ACTIONS(3571),
    [anon_sym_DQUOTE] = ACTIONS(2665),
    [sym_raw_string] = ACTIONS(2665),
    [anon_sym_DOLLAR] = ACTIONS(3571),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2665),
    [anon_sym_BQUOTE] = ACTIONS(2665),
    [anon_sym_LT_LPAREN] = ACTIONS(2665),
    [anon_sym_GT_LPAREN] = ACTIONS(2665),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3571),
  },
  [1277] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3619),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1278] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3609),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1279] = {
    [sym_file_descriptor] = ACTIONS(2671),
    [sym__concat] = ACTIONS(2671),
    [sym_variable_name] = ACTIONS(2671),
    [anon_sym_LT] = ACTIONS(3575),
    [anon_sym_GT] = ACTIONS(3575),
    [anon_sym_GT_GT] = ACTIONS(2671),
    [anon_sym_AMP_GT] = ACTIONS(3575),
    [anon_sym_AMP_GT_GT] = ACTIONS(2671),
    [anon_sym_LT_AMP] = ACTIONS(2671),
    [anon_sym_GT_AMP] = ACTIONS(2671),
    [sym__special_characters] = ACTIONS(3575),
    [anon_sym_DQUOTE] = ACTIONS(2671),
    [sym_raw_string] = ACTIONS(2671),
    [anon_sym_DOLLAR] = ACTIONS(3575),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2671),
    [anon_sym_BQUOTE] = ACTIONS(2671),
    [anon_sym_LT_LPAREN] = ACTIONS(2671),
    [anon_sym_GT_LPAREN] = ACTIONS(2671),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3575),
  },
  [1280] = {
    [sym__concat] = ACTIONS(1553),
    [anon_sym_DQUOTE] = ACTIONS(1555),
    [sym__string_content] = ACTIONS(2435),
    [anon_sym_DOLLAR] = ACTIONS(1555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1555),
    [anon_sym_BQUOTE] = ACTIONS(1555),
    [sym_comment] = ACTIONS(168),
  },
  [1281] = {
    [sym__concat] = ACTIONS(2560),
    [anon_sym_DQUOTE] = ACTIONS(2562),
    [sym__string_content] = ACTIONS(3553),
    [anon_sym_DOLLAR] = ACTIONS(2562),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2562),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2562),
    [anon_sym_BQUOTE] = ACTIONS(2562),
    [sym_comment] = ACTIONS(168),
  },
  [1282] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(3621),
    [sym_comment] = ACTIONS(52),
  },
  [1283] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(52),
  },
  [1284] = {
    [anon_sym_RBRACE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(52),
  },
  [1285] = {
    [sym__concat] = ACTIONS(2614),
    [anon_sym_DQUOTE] = ACTIONS(2616),
    [sym__string_content] = ACTIONS(3559),
    [anon_sym_DOLLAR] = ACTIONS(2616),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2616),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2616),
    [anon_sym_BQUOTE] = ACTIONS(2616),
    [sym_comment] = ACTIONS(168),
  },
  [1286] = {
    [sym_concatenation] = STATE(1758),
    [sym_string] = STATE(1757),
    [sym_simple_expansion] = STATE(1757),
    [sym_expansion] = STATE(1757),
    [sym_command_substitution] = STATE(1757),
    [sym_process_substitution] = STATE(1757),
    [anon_sym_RBRACE] = ACTIONS(3623),
    [sym__special_characters] = ACTIONS(3625),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(3627),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3629),
  },
  [1287] = {
    [sym__concat] = ACTIONS(2659),
    [anon_sym_DQUOTE] = ACTIONS(2661),
    [sym__string_content] = ACTIONS(3567),
    [anon_sym_DOLLAR] = ACTIONS(2661),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2661),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2661),
    [anon_sym_BQUOTE] = ACTIONS(2661),
    [sym_comment] = ACTIONS(168),
  },
  [1288] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3631),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1289] = {
    [sym__concat] = ACTIONS(2665),
    [anon_sym_DQUOTE] = ACTIONS(2667),
    [sym__string_content] = ACTIONS(3571),
    [anon_sym_DOLLAR] = ACTIONS(2667),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2667),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2667),
    [anon_sym_BQUOTE] = ACTIONS(2667),
    [sym_comment] = ACTIONS(168),
  },
  [1290] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3633),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1291] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3623),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1292] = {
    [sym__concat] = ACTIONS(2671),
    [anon_sym_DQUOTE] = ACTIONS(2673),
    [sym__string_content] = ACTIONS(3575),
    [anon_sym_DOLLAR] = ACTIONS(2673),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2673),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2673),
    [anon_sym_BQUOTE] = ACTIONS(2673),
    [sym_comment] = ACTIONS(168),
  },
  [1293] = {
    [sym_string] = STATE(1021),
    [sym_simple_expansion] = STATE(1021),
    [sym_expansion] = STATE(1021),
    [sym_command_substitution] = STATE(1021),
    [sym_process_substitution] = STATE(1021),
    [anon_sym_RBRACK] = ACTIONS(3635),
    [sym__special_characters] = ACTIONS(2014),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(2016),
    [anon_sym_DOLLAR] = ACTIONS(360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(364),
    [anon_sym_BQUOTE] = ACTIONS(366),
    [anon_sym_LT_LPAREN] = ACTIONS(368),
    [anon_sym_GT_LPAREN] = ACTIONS(368),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2018),
  },
  [1294] = {
    [sym__concat] = ACTIONS(3637),
    [anon_sym_RBRACE] = ACTIONS(2022),
    [anon_sym_EQ] = ACTIONS(3639),
    [sym__special_characters] = ACTIONS(3641),
    [anon_sym_DQUOTE] = ACTIONS(2022),
    [sym_raw_string] = ACTIONS(2022),
    [anon_sym_DOLLAR] = ACTIONS(3639),
    [anon_sym_POUND] = ACTIONS(2022),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2022),
    [anon_sym_COLON] = ACTIONS(3639),
    [anon_sym_COLON_QMARK] = ACTIONS(3639),
    [anon_sym_COLON_DASH] = ACTIONS(3639),
    [anon_sym_PERCENT] = ACTIONS(3639),
    [anon_sym_SLASH] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2022),
    [anon_sym_BQUOTE] = ACTIONS(2022),
    [anon_sym_LT_LPAREN] = ACTIONS(2022),
    [anon_sym_GT_LPAREN] = ACTIONS(2022),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(3641),
  },
  [1295] = {
    [sym_string] = STATE(1021),
    [sym_simple_expansion] = STATE(1021),
    [sym_expansion] = STATE(1021),
    [sym_command_substitution] = STATE(1021),
    [sym_process_substitution] = STATE(1021),
    [anon_sym_RBRACK] = ACTIONS(3643),
    [sym__special_characters] = ACTIONS(2014),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(2016),
    [anon_sym_DOLLAR] = ACTIONS(360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(364),
    [anon_sym_BQUOTE] = ACTIONS(366),
    [anon_sym_LT_LPAREN] = ACTIONS(368),
    [anon_sym_GT_LPAREN] = ACTIONS(368),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2018),
  },
  [1296] = {
    [sym__concat] = ACTIONS(3645),
    [anon_sym_RBRACE] = ACTIONS(2032),
    [anon_sym_EQ] = ACTIONS(3647),
    [sym__special_characters] = ACTIONS(3649),
    [anon_sym_DQUOTE] = ACTIONS(2032),
    [sym_raw_string] = ACTIONS(2032),
    [anon_sym_DOLLAR] = ACTIONS(3647),
    [anon_sym_POUND] = ACTIONS(2032),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2032),
    [anon_sym_COLON] = ACTIONS(3647),
    [anon_sym_COLON_QMARK] = ACTIONS(3647),
    [anon_sym_COLON_DASH] = ACTIONS(3647),
    [anon_sym_PERCENT] = ACTIONS(3647),
    [anon_sym_SLASH] = ACTIONS(3647),
    [anon_sym_DASH] = ACTIONS(3647),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2032),
    [anon_sym_BQUOTE] = ACTIONS(2032),
    [anon_sym_LT_LPAREN] = ACTIONS(2032),
    [anon_sym_GT_LPAREN] = ACTIONS(2032),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(3649),
  },
  [1297] = {
    [anon_sym_RBRACK] = ACTIONS(3651),
    [sym_comment] = ACTIONS(52),
  },
  [1298] = {
    [sym_string] = STATE(1765),
    [sym_simple_expansion] = STATE(1765),
    [sym_expansion] = STATE(1765),
    [sym_command_substitution] = STATE(1765),
    [sym_process_substitution] = STATE(1765),
    [sym__special_characters] = ACTIONS(3653),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(3655),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3653),
  },
  [1299] = {
    [sym_file_descriptor] = ACTIONS(3657),
    [sym__concat] = ACTIONS(3657),
    [anon_sym_PIPE] = ACTIONS(3659),
    [anon_sym_SEMI_SEMI] = ACTIONS(3659),
    [anon_sym_PIPE_AMP] = ACTIONS(3659),
    [anon_sym_AMP_AMP] = ACTIONS(3659),
    [anon_sym_PIPE_PIPE] = ACTIONS(3659),
    [anon_sym_LT] = ACTIONS(3659),
    [anon_sym_GT] = ACTIONS(3659),
    [anon_sym_GT_GT] = ACTIONS(3659),
    [anon_sym_AMP_GT] = ACTIONS(3659),
    [anon_sym_AMP_GT_GT] = ACTIONS(3659),
    [anon_sym_LT_AMP] = ACTIONS(3659),
    [anon_sym_GT_AMP] = ACTIONS(3659),
    [anon_sym_LT_LT] = ACTIONS(3659),
    [anon_sym_LT_LT_DASH] = ACTIONS(3659),
    [anon_sym_LT_LT_LT] = ACTIONS(3659),
    [sym__special_characters] = ACTIONS(3659),
    [anon_sym_DQUOTE] = ACTIONS(3659),
    [sym_raw_string] = ACTIONS(3659),
    [anon_sym_DOLLAR] = ACTIONS(3659),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3659),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3659),
    [anon_sym_BQUOTE] = ACTIONS(3659),
    [anon_sym_LT_LPAREN] = ACTIONS(3659),
    [anon_sym_GT_LPAREN] = ACTIONS(3659),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(3659),
    [anon_sym_SEMI] = ACTIONS(3659),
    [anon_sym_LF] = ACTIONS(3659),
    [anon_sym_AMP] = ACTIONS(3659),
  },
  [1300] = {
    [aux_sym_concatenation_repeat1] = STATE(1766),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(646),
    [sym_comment] = ACTIONS(52),
  },
  [1301] = {
    [sym__concat] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [sym_comment] = ACTIONS(52),
  },
  [1302] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(3661),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [1303] = {
    [sym_file_descriptor] = ACTIONS(3663),
    [sym__concat] = ACTIONS(3663),
    [anon_sym_PIPE] = ACTIONS(3665),
    [anon_sym_SEMI_SEMI] = ACTIONS(3665),
    [anon_sym_PIPE_AMP] = ACTIONS(3665),
    [anon_sym_AMP_AMP] = ACTIONS(3665),
    [anon_sym_PIPE_PIPE] = ACTIONS(3665),
    [anon_sym_LT] = ACTIONS(3665),
    [anon_sym_GT] = ACTIONS(3665),
    [anon_sym_GT_GT] = ACTIONS(3665),
    [anon_sym_AMP_GT] = ACTIONS(3665),
    [anon_sym_AMP_GT_GT] = ACTIONS(3665),
    [anon_sym_LT_AMP] = ACTIONS(3665),
    [anon_sym_GT_AMP] = ACTIONS(3665),
    [anon_sym_LT_LT] = ACTIONS(3665),
    [anon_sym_LT_LT_DASH] = ACTIONS(3665),
    [anon_sym_LT_LT_LT] = ACTIONS(3665),
    [sym__special_characters] = ACTIONS(3665),
    [anon_sym_DQUOTE] = ACTIONS(3665),
    [sym_raw_string] = ACTIONS(3665),
    [anon_sym_DOLLAR] = ACTIONS(3665),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3665),
    [anon_sym_BQUOTE] = ACTIONS(3665),
    [anon_sym_LT_LPAREN] = ACTIONS(3665),
    [anon_sym_GT_LPAREN] = ACTIONS(3665),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(3665),
    [anon_sym_SEMI] = ACTIONS(3665),
    [anon_sym_LF] = ACTIONS(3665),
    [anon_sym_AMP] = ACTIONS(3665),
  },
  [1304] = {
    [sym__concat] = ACTIONS(680),
    [anon_sym_RBRACE] = ACTIONS(680),
    [sym_comment] = ACTIONS(52),
  },
  [1305] = {
    [sym__concat] = ACTIONS(684),
    [anon_sym_RBRACE] = ACTIONS(684),
    [sym_comment] = ACTIONS(52),
  },
  [1306] = {
    [sym__concat] = ACTIONS(688),
    [anon_sym_RBRACE] = ACTIONS(688),
    [sym_comment] = ACTIONS(52),
  },
  [1307] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(3667),
    [sym_comment] = ACTIONS(52),
  },
  [1308] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1770),
    [anon_sym_RBRACE] = ACTIONS(3669),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1309] = {
    [sym_subscript] = STATE(1774),
    [sym_variable_name] = ACTIONS(3671),
    [anon_sym_DOLLAR] = ACTIONS(3673),
    [anon_sym_DASH] = ACTIONS(3673),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3675),
    [anon_sym_STAR] = ACTIONS(3673),
    [anon_sym_AT] = ACTIONS(3673),
    [anon_sym_QMARK] = ACTIONS(3673),
    [anon_sym_0] = ACTIONS(3677),
    [anon_sym__] = ACTIONS(3677),
  },
  [1310] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1776),
    [anon_sym_RBRACE] = ACTIONS(3679),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1311] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1778),
    [anon_sym_RBRACE] = ACTIONS(3681),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1312] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3683),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [1313] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3683),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1314] = {
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(3683),
    [sym_comment] = ACTIONS(52),
  },
  [1315] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(3683),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1316] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3685),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [1317] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3685),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1318] = {
    [sym__concat] = ACTIONS(1522),
    [anon_sym_RBRACE] = ACTIONS(1522),
    [anon_sym_EQ] = ACTIONS(2430),
    [sym__special_characters] = ACTIONS(1524),
    [anon_sym_DQUOTE] = ACTIONS(1522),
    [sym_raw_string] = ACTIONS(1522),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [anon_sym_POUND] = ACTIONS(1522),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1522),
    [anon_sym_COLON] = ACTIONS(2430),
    [anon_sym_COLON_QMARK] = ACTIONS(2430),
    [anon_sym_COLON_DASH] = ACTIONS(2430),
    [anon_sym_PERCENT] = ACTIONS(2430),
    [anon_sym_SLASH] = ACTIONS(2430),
    [anon_sym_DASH] = ACTIONS(2430),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1522),
    [anon_sym_BQUOTE] = ACTIONS(1522),
    [anon_sym_LT_LPAREN] = ACTIONS(1522),
    [anon_sym_GT_LPAREN] = ACTIONS(1522),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1524),
  },
  [1319] = {
    [aux_sym_concatenation_repeat1] = STATE(1319),
    [sym__concat] = ACTIONS(3687),
    [anon_sym_RBRACE] = ACTIONS(1522),
    [anon_sym_EQ] = ACTIONS(2430),
    [sym__special_characters] = ACTIONS(1524),
    [anon_sym_DQUOTE] = ACTIONS(1522),
    [sym_raw_string] = ACTIONS(1522),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [anon_sym_POUND] = ACTIONS(1522),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1522),
    [anon_sym_COLON] = ACTIONS(2430),
    [anon_sym_COLON_QMARK] = ACTIONS(2430),
    [anon_sym_COLON_DASH] = ACTIONS(2430),
    [anon_sym_PERCENT] = ACTIONS(2430),
    [anon_sym_SLASH] = ACTIONS(2430),
    [anon_sym_DASH] = ACTIONS(2430),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1522),
    [anon_sym_BQUOTE] = ACTIONS(1522),
    [anon_sym_LT_LPAREN] = ACTIONS(1522),
    [anon_sym_GT_LPAREN] = ACTIONS(1522),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1524),
  },
  [1320] = {
    [sym__concat] = ACTIONS(1553),
    [anon_sym_RBRACE] = ACTIONS(1553),
    [anon_sym_EQ] = ACTIONS(2435),
    [sym__special_characters] = ACTIONS(1555),
    [anon_sym_DQUOTE] = ACTIONS(1553),
    [sym_raw_string] = ACTIONS(1553),
    [anon_sym_DOLLAR] = ACTIONS(2435),
    [anon_sym_POUND] = ACTIONS(1553),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1553),
    [anon_sym_COLON] = ACTIONS(2435),
    [anon_sym_COLON_QMARK] = ACTIONS(2435),
    [anon_sym_COLON_DASH] = ACTIONS(2435),
    [anon_sym_PERCENT] = ACTIONS(2435),
    [anon_sym_SLASH] = ACTIONS(2435),
    [anon_sym_DASH] = ACTIONS(2435),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1553),
    [anon_sym_BQUOTE] = ACTIONS(1553),
    [anon_sym_LT_LPAREN] = ACTIONS(1553),
    [anon_sym_GT_LPAREN] = ACTIONS(1553),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1555),
  },
  [1321] = {
    [sym_concatenation] = STATE(1784),
    [sym_string] = STATE(1783),
    [sym_simple_expansion] = STATE(1783),
    [sym_expansion] = STATE(1783),
    [sym_command_substitution] = STATE(1783),
    [sym_process_substitution] = STATE(1783),
    [anon_sym_RBRACE] = ACTIONS(3690),
    [sym__special_characters] = ACTIONS(3692),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(3694),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3696),
  },
  [1322] = {
    [sym__concat] = ACTIONS(1598),
    [anon_sym_RBRACE] = ACTIONS(1598),
    [anon_sym_EQ] = ACTIONS(2445),
    [sym__special_characters] = ACTIONS(1600),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [sym_raw_string] = ACTIONS(1598),
    [anon_sym_DOLLAR] = ACTIONS(2445),
    [anon_sym_POUND] = ACTIONS(1598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1598),
    [anon_sym_COLON] = ACTIONS(2445),
    [anon_sym_COLON_QMARK] = ACTIONS(2445),
    [anon_sym_COLON_DASH] = ACTIONS(2445),
    [anon_sym_PERCENT] = ACTIONS(2445),
    [anon_sym_SLASH] = ACTIONS(2445),
    [anon_sym_DASH] = ACTIONS(2445),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1598),
    [anon_sym_BQUOTE] = ACTIONS(1598),
    [anon_sym_LT_LPAREN] = ACTIONS(1598),
    [anon_sym_GT_LPAREN] = ACTIONS(1598),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1600),
  },
  [1323] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3698),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1324] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(3700),
    [sym_comment] = ACTIONS(52),
  },
  [1325] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1788),
    [anon_sym_RBRACE] = ACTIONS(3702),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1326] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1790),
    [anon_sym_RBRACE] = ACTIONS(3704),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1327] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1791),
    [anon_sym_RBRACE] = ACTIONS(3690),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1328] = {
    [sym__concat] = ACTIONS(1642),
    [anon_sym_RBRACE] = ACTIONS(1642),
    [anon_sym_EQ] = ACTIONS(2455),
    [sym__special_characters] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [sym_raw_string] = ACTIONS(1642),
    [anon_sym_DOLLAR] = ACTIONS(2455),
    [anon_sym_POUND] = ACTIONS(1642),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1642),
    [anon_sym_COLON] = ACTIONS(2455),
    [anon_sym_COLON_QMARK] = ACTIONS(2455),
    [anon_sym_COLON_DASH] = ACTIONS(2455),
    [anon_sym_PERCENT] = ACTIONS(2455),
    [anon_sym_SLASH] = ACTIONS(2455),
    [anon_sym_DASH] = ACTIONS(2455),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [anon_sym_LT_LPAREN] = ACTIONS(1642),
    [anon_sym_GT_LPAREN] = ACTIONS(1642),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1644),
  },
  [1329] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3706),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1330] = {
    [sym__concat] = ACTIONS(1648),
    [anon_sym_RBRACE] = ACTIONS(1648),
    [anon_sym_EQ] = ACTIONS(2459),
    [sym__special_characters] = ACTIONS(1650),
    [anon_sym_DQUOTE] = ACTIONS(1648),
    [sym_raw_string] = ACTIONS(1648),
    [anon_sym_DOLLAR] = ACTIONS(2459),
    [anon_sym_POUND] = ACTIONS(1648),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1648),
    [anon_sym_COLON] = ACTIONS(2459),
    [anon_sym_COLON_QMARK] = ACTIONS(2459),
    [anon_sym_COLON_DASH] = ACTIONS(2459),
    [anon_sym_PERCENT] = ACTIONS(2459),
    [anon_sym_SLASH] = ACTIONS(2459),
    [anon_sym_DASH] = ACTIONS(2459),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1648),
    [anon_sym_BQUOTE] = ACTIONS(1648),
    [anon_sym_LT_LPAREN] = ACTIONS(1648),
    [anon_sym_GT_LPAREN] = ACTIONS(1648),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1650),
  },
  [1331] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3690),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1332] = {
    [sym__concat] = ACTIONS(1762),
    [anon_sym_RBRACE] = ACTIONS(1762),
    [anon_sym_EQ] = ACTIONS(2461),
    [sym__special_characters] = ACTIONS(1764),
    [anon_sym_DQUOTE] = ACTIONS(1762),
    [sym_raw_string] = ACTIONS(1762),
    [anon_sym_DOLLAR] = ACTIONS(2461),
    [anon_sym_POUND] = ACTIONS(1762),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1762),
    [anon_sym_COLON] = ACTIONS(2461),
    [anon_sym_COLON_QMARK] = ACTIONS(2461),
    [anon_sym_COLON_DASH] = ACTIONS(2461),
    [anon_sym_PERCENT] = ACTIONS(2461),
    [anon_sym_SLASH] = ACTIONS(2461),
    [anon_sym_DASH] = ACTIONS(2461),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1762),
    [anon_sym_BQUOTE] = ACTIONS(1762),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1764),
  },
  [1333] = {
    [sym__concat] = ACTIONS(1902),
    [anon_sym_RBRACE] = ACTIONS(1902),
    [anon_sym_EQ] = ACTIONS(2463),
    [sym__special_characters] = ACTIONS(1904),
    [anon_sym_DQUOTE] = ACTIONS(1902),
    [sym_raw_string] = ACTIONS(1902),
    [anon_sym_DOLLAR] = ACTIONS(2463),
    [anon_sym_POUND] = ACTIONS(1902),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1902),
    [anon_sym_COLON] = ACTIONS(2463),
    [anon_sym_COLON_QMARK] = ACTIONS(2463),
    [anon_sym_COLON_DASH] = ACTIONS(2463),
    [anon_sym_PERCENT] = ACTIONS(2463),
    [anon_sym_SLASH] = ACTIONS(2463),
    [anon_sym_DASH] = ACTIONS(2463),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1902),
    [anon_sym_BQUOTE] = ACTIONS(1902),
    [anon_sym_LT_LPAREN] = ACTIONS(1902),
    [anon_sym_GT_LPAREN] = ACTIONS(1902),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1904),
  },
  [1334] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(3708),
    [sym_comment] = ACTIONS(52),
  },
  [1335] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(3710),
    [sym_comment] = ACTIONS(52),
  },
  [1336] = {
    [anon_sym_RBRACE] = ACTIONS(3710),
    [sym_comment] = ACTIONS(52),
  },
  [1337] = {
    [sym_file_descriptor] = ACTIONS(3712),
    [sym__concat] = ACTIONS(3712),
    [anon_sym_PIPE] = ACTIONS(3714),
    [anon_sym_SEMI_SEMI] = ACTIONS(3714),
    [anon_sym_PIPE_AMP] = ACTIONS(3714),
    [anon_sym_AMP_AMP] = ACTIONS(3714),
    [anon_sym_PIPE_PIPE] = ACTIONS(3714),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_GT] = ACTIONS(3714),
    [anon_sym_GT_GT] = ACTIONS(3714),
    [anon_sym_AMP_GT] = ACTIONS(3714),
    [anon_sym_AMP_GT_GT] = ACTIONS(3714),
    [anon_sym_LT_AMP] = ACTIONS(3714),
    [anon_sym_GT_AMP] = ACTIONS(3714),
    [anon_sym_LT_LT] = ACTIONS(3714),
    [anon_sym_LT_LT_DASH] = ACTIONS(3714),
    [anon_sym_LT_LT_LT] = ACTIONS(3714),
    [sym__special_characters] = ACTIONS(3714),
    [anon_sym_DQUOTE] = ACTIONS(3714),
    [sym_raw_string] = ACTIONS(3714),
    [anon_sym_DOLLAR] = ACTIONS(3714),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3714),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3714),
    [anon_sym_BQUOTE] = ACTIONS(3714),
    [anon_sym_LT_LPAREN] = ACTIONS(3714),
    [anon_sym_GT_LPAREN] = ACTIONS(3714),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(3714),
    [anon_sym_SEMI] = ACTIONS(3714),
    [anon_sym_LF] = ACTIONS(3714),
    [anon_sym_AMP] = ACTIONS(3714),
  },
  [1338] = {
    [sym_file_descriptor] = ACTIONS(3716),
    [sym__concat] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3718),
    [anon_sym_SEMI_SEMI] = ACTIONS(3718),
    [anon_sym_PIPE_AMP] = ACTIONS(3718),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_LT] = ACTIONS(3718),
    [anon_sym_GT] = ACTIONS(3718),
    [anon_sym_GT_GT] = ACTIONS(3718),
    [anon_sym_AMP_GT] = ACTIONS(3718),
    [anon_sym_AMP_GT_GT] = ACTIONS(3718),
    [anon_sym_LT_AMP] = ACTIONS(3718),
    [anon_sym_GT_AMP] = ACTIONS(3718),
    [anon_sym_LT_LT] = ACTIONS(3718),
    [anon_sym_LT_LT_DASH] = ACTIONS(3718),
    [anon_sym_LT_LT_LT] = ACTIONS(3718),
    [sym__special_characters] = ACTIONS(3718),
    [anon_sym_DQUOTE] = ACTIONS(3718),
    [sym_raw_string] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3718),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3718),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3718),
    [anon_sym_BQUOTE] = ACTIONS(3718),
    [anon_sym_LT_LPAREN] = ACTIONS(3718),
    [anon_sym_GT_LPAREN] = ACTIONS(3718),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(3718),
    [anon_sym_SEMI] = ACTIONS(3718),
    [anon_sym_LF] = ACTIONS(3718),
    [anon_sym_AMP] = ACTIONS(3718),
  },
  [1339] = {
    [sym_file_descriptor] = ACTIONS(2056),
    [sym_variable_name] = ACTIONS(2056),
    [anon_sym_PIPE] = ACTIONS(3720),
    [anon_sym_RPAREN] = ACTIONS(2056),
    [anon_sym_PIPE_AMP] = ACTIONS(2056),
    [anon_sym_AMP_AMP] = ACTIONS(2056),
    [anon_sym_PIPE_PIPE] = ACTIONS(2056),
    [anon_sym_LT] = ACTIONS(3720),
    [anon_sym_GT] = ACTIONS(3720),
    [anon_sym_GT_GT] = ACTIONS(2056),
    [anon_sym_AMP_GT] = ACTIONS(3720),
    [anon_sym_AMP_GT_GT] = ACTIONS(2056),
    [anon_sym_LT_AMP] = ACTIONS(2056),
    [anon_sym_GT_AMP] = ACTIONS(2056),
    [sym__special_characters] = ACTIONS(3720),
    [anon_sym_DQUOTE] = ACTIONS(2056),
    [sym_raw_string] = ACTIONS(2056),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2056),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2056),
    [anon_sym_BQUOTE] = ACTIONS(2056),
    [anon_sym_LT_LPAREN] = ACTIONS(2056),
    [anon_sym_GT_LPAREN] = ACTIONS(2056),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3720),
  },
  [1340] = {
    [sym_concatenation] = STATE(572),
    [sym_string] = STATE(566),
    [sym_simple_expansion] = STATE(566),
    [sym_expansion] = STATE(566),
    [sym_command_substitution] = STATE(566),
    [sym_process_substitution] = STATE(566),
    [aux_sym_for_statement_repeat1] = STATE(1060),
    [anon_sym_RPAREN] = ACTIONS(3722),
    [sym__special_characters] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1076),
    [sym_raw_string] = ACTIONS(1078),
    [anon_sym_DOLLAR] = ACTIONS(1080),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1084),
    [anon_sym_BQUOTE] = ACTIONS(1086),
    [anon_sym_LT_LPAREN] = ACTIONS(1088),
    [anon_sym_GT_LPAREN] = ACTIONS(1088),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1090),
  },
  [1341] = {
    [sym_string] = STATE(1796),
    [sym_simple_expansion] = STATE(1796),
    [sym_expansion] = STATE(1796),
    [sym_command_substitution] = STATE(1796),
    [sym_process_substitution] = STATE(1796),
    [sym__special_characters] = ACTIONS(3724),
    [anon_sym_DQUOTE] = ACTIONS(1658),
    [sym_raw_string] = ACTIONS(3726),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1666),
    [anon_sym_BQUOTE] = ACTIONS(1668),
    [anon_sym_LT_LPAREN] = ACTIONS(1670),
    [anon_sym_GT_LPAREN] = ACTIONS(1670),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3724),
  },
  [1342] = {
    [aux_sym_concatenation_repeat1] = STATE(1797),
    [sym_file_descriptor] = ACTIONS(646),
    [sym__concat] = ACTIONS(2679),
    [sym_variable_name] = ACTIONS(646),
    [anon_sym_PIPE] = ACTIONS(1300),
    [anon_sym_RPAREN] = ACTIONS(646),
    [anon_sym_PIPE_AMP] = ACTIONS(646),
    [anon_sym_AMP_AMP] = ACTIONS(646),
    [anon_sym_PIPE_PIPE] = ACTIONS(646),
    [anon_sym_LT] = ACTIONS(1300),
    [anon_sym_GT] = ACTIONS(1300),
    [anon_sym_GT_GT] = ACTIONS(646),
    [anon_sym_AMP_GT] = ACTIONS(1300),
    [anon_sym_AMP_GT_GT] = ACTIONS(646),
    [anon_sym_LT_AMP] = ACTIONS(646),
    [anon_sym_GT_AMP] = ACTIONS(646),
    [sym__special_characters] = ACTIONS(1300),
    [anon_sym_DQUOTE] = ACTIONS(646),
    [sym_raw_string] = ACTIONS(646),
    [anon_sym_DOLLAR] = ACTIONS(1300),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(646),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(646),
    [anon_sym_BQUOTE] = ACTIONS(646),
    [anon_sym_LT_LPAREN] = ACTIONS(646),
    [anon_sym_GT_LPAREN] = ACTIONS(646),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1300),
  },
  [1343] = {
    [sym_file_descriptor] = ACTIONS(650),
    [sym__concat] = ACTIONS(650),
    [sym_variable_name] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(1302),
    [anon_sym_RPAREN] = ACTIONS(650),
    [anon_sym_PIPE_AMP] = ACTIONS(650),
    [anon_sym_AMP_AMP] = ACTIONS(650),
    [anon_sym_PIPE_PIPE] = ACTIONS(650),
    [anon_sym_LT] = ACTIONS(1302),
    [anon_sym_GT] = ACTIONS(1302),
    [anon_sym_GT_GT] = ACTIONS(650),
    [anon_sym_AMP_GT] = ACTIONS(1302),
    [anon_sym_AMP_GT_GT] = ACTIONS(650),
    [anon_sym_LT_AMP] = ACTIONS(650),
    [anon_sym_GT_AMP] = ACTIONS(650),
    [sym__special_characters] = ACTIONS(1302),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [sym_raw_string] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(1302),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(650),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LT_LPAREN] = ACTIONS(650),
    [anon_sym_GT_LPAREN] = ACTIONS(650),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1302),
  },
  [1344] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(3728),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [1345] = {
    [sym_file_descriptor] = ACTIONS(680),
    [sym__concat] = ACTIONS(680),
    [sym_variable_name] = ACTIONS(680),
    [anon_sym_PIPE] = ACTIONS(1306),
    [anon_sym_RPAREN] = ACTIONS(680),
    [anon_sym_PIPE_AMP] = ACTIONS(680),
    [anon_sym_AMP_AMP] = ACTIONS(680),
    [anon_sym_PIPE_PIPE] = ACTIONS(680),
    [anon_sym_LT] = ACTIONS(1306),
    [anon_sym_GT] = ACTIONS(1306),
    [anon_sym_GT_GT] = ACTIONS(680),
    [anon_sym_AMP_GT] = ACTIONS(1306),
    [anon_sym_AMP_GT_GT] = ACTIONS(680),
    [anon_sym_LT_AMP] = ACTIONS(680),
    [anon_sym_GT_AMP] = ACTIONS(680),
    [sym__special_characters] = ACTIONS(1306),
    [anon_sym_DQUOTE] = ACTIONS(680),
    [sym_raw_string] = ACTIONS(680),
    [anon_sym_DOLLAR] = ACTIONS(1306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(680),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(680),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [anon_sym_LT_LPAREN] = ACTIONS(680),
    [anon_sym_GT_LPAREN] = ACTIONS(680),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1306),
  },
  [1346] = {
    [sym_file_descriptor] = ACTIONS(684),
    [sym__concat] = ACTIONS(684),
    [sym_variable_name] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(1308),
    [anon_sym_RPAREN] = ACTIONS(684),
    [anon_sym_PIPE_AMP] = ACTIONS(684),
    [anon_sym_AMP_AMP] = ACTIONS(684),
    [anon_sym_PIPE_PIPE] = ACTIONS(684),
    [anon_sym_LT] = ACTIONS(1308),
    [anon_sym_GT] = ACTIONS(1308),
    [anon_sym_GT_GT] = ACTIONS(684),
    [anon_sym_AMP_GT] = ACTIONS(1308),
    [anon_sym_AMP_GT_GT] = ACTIONS(684),
    [anon_sym_LT_AMP] = ACTIONS(684),
    [anon_sym_GT_AMP] = ACTIONS(684),
    [sym__special_characters] = ACTIONS(1308),
    [anon_sym_DQUOTE] = ACTIONS(684),
    [sym_raw_string] = ACTIONS(684),
    [anon_sym_DOLLAR] = ACTIONS(1308),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(684),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(684),
    [anon_sym_BQUOTE] = ACTIONS(684),
    [anon_sym_LT_LPAREN] = ACTIONS(684),
    [anon_sym_GT_LPAREN] = ACTIONS(684),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1308),
  },
  [1347] = {
    [sym_file_descriptor] = ACTIONS(688),
    [sym__concat] = ACTIONS(688),
    [sym_variable_name] = ACTIONS(688),
    [anon_sym_PIPE] = ACTIONS(1310),
    [anon_sym_RPAREN] = ACTIONS(688),
    [anon_sym_PIPE_AMP] = ACTIONS(688),
    [anon_sym_AMP_AMP] = ACTIONS(688),
    [anon_sym_PIPE_PIPE] = ACTIONS(688),
    [anon_sym_LT] = ACTIONS(1310),
    [anon_sym_GT] = ACTIONS(1310),
    [anon_sym_GT_GT] = ACTIONS(688),
    [anon_sym_AMP_GT] = ACTIONS(1310),
    [anon_sym_AMP_GT_GT] = ACTIONS(688),
    [anon_sym_LT_AMP] = ACTIONS(688),
    [anon_sym_GT_AMP] = ACTIONS(688),
    [sym__special_characters] = ACTIONS(1310),
    [anon_sym_DQUOTE] = ACTIONS(688),
    [sym_raw_string] = ACTIONS(688),
    [anon_sym_DOLLAR] = ACTIONS(1310),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(688),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(688),
    [anon_sym_BQUOTE] = ACTIONS(688),
    [anon_sym_LT_LPAREN] = ACTIONS(688),
    [anon_sym_GT_LPAREN] = ACTIONS(688),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1310),
  },
  [1348] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(3730),
    [sym_comment] = ACTIONS(52),
  },
  [1349] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1801),
    [anon_sym_RBRACE] = ACTIONS(3732),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1350] = {
    [sym_subscript] = STATE(1805),
    [sym_variable_name] = ACTIONS(3734),
    [anon_sym_DOLLAR] = ACTIONS(3736),
    [anon_sym_DASH] = ACTIONS(3736),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3738),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_AT] = ACTIONS(3736),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_0] = ACTIONS(3740),
    [anon_sym__] = ACTIONS(3740),
  },
  [1351] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1807),
    [anon_sym_RBRACE] = ACTIONS(3742),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1352] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1809),
    [anon_sym_RBRACE] = ACTIONS(3744),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1353] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3746),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [1354] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3746),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1355] = {
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(3746),
    [sym_comment] = ACTIONS(52),
  },
  [1356] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(3746),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1357] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3748),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [1358] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3748),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1359] = {
    [sym_concatenation] = STATE(600),
    [sym_string] = STATE(594),
    [sym_simple_expansion] = STATE(594),
    [sym_expansion] = STATE(594),
    [sym_command_substitution] = STATE(594),
    [sym_process_substitution] = STATE(594),
    [aux_sym_for_statement_repeat1] = STATE(1096),
    [anon_sym_SEMI_SEMI] = ACTIONS(3750),
    [sym__special_characters] = ACTIONS(2130),
    [anon_sym_DQUOTE] = ACTIONS(2132),
    [sym_raw_string] = ACTIONS(2134),
    [anon_sym_DOLLAR] = ACTIONS(2136),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2138),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2140),
    [anon_sym_BQUOTE] = ACTIONS(2142),
    [anon_sym_LT_LPAREN] = ACTIONS(2144),
    [anon_sym_GT_LPAREN] = ACTIONS(2144),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2134),
    [anon_sym_SEMI] = ACTIONS(3750),
    [anon_sym_LF] = ACTIONS(3750),
    [anon_sym_AMP] = ACTIONS(3750),
  },
  [1360] = {
    [sym_file_descriptor] = ACTIONS(2146),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_RPAREN] = ACTIONS(2146),
    [anon_sym_PIPE_AMP] = ACTIONS(2146),
    [anon_sym_AMP_AMP] = ACTIONS(2146),
    [anon_sym_PIPE_PIPE] = ACTIONS(2146),
    [anon_sym_LT] = ACTIONS(3752),
    [anon_sym_GT] = ACTIONS(3752),
    [anon_sym_GT_GT] = ACTIONS(2146),
    [anon_sym_AMP_GT] = ACTIONS(3752),
    [anon_sym_AMP_GT_GT] = ACTIONS(2146),
    [anon_sym_LT_AMP] = ACTIONS(2146),
    [anon_sym_GT_AMP] = ACTIONS(2146),
    [anon_sym_LT_LT] = ACTIONS(3752),
    [anon_sym_LT_LT_DASH] = ACTIONS(2146),
    [anon_sym_LT_LT_LT] = ACTIONS(2146),
    [anon_sym_BQUOTE] = ACTIONS(2146),
    [sym_comment] = ACTIONS(52),
  },
  [1361] = {
    [sym__terminated_statement] = STATE(603),
    [sym_for_statement] = STATE(604),
    [sym_while_statement] = STATE(604),
    [sym_if_statement] = STATE(604),
    [sym_case_statement] = STATE(604),
    [sym_function_definition] = STATE(604),
    [sym_subshell] = STATE(604),
    [sym_pipeline] = STATE(604),
    [sym_list] = STATE(604),
    [sym_bracket_command] = STATE(604),
    [sym_command] = STATE(604),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(605),
    [sym_declaration_command] = STATE(604),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(1099),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_done] = ACTIONS(3754),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [1362] = {
    [sym_file_redirect] = STATE(466),
    [sym_heredoc_redirect] = STATE(466),
    [sym_herestring_redirect] = STATE(466),
    [aux_sym_while_statement_repeat1] = STATE(922),
    [sym_file_descriptor] = ACTIONS(804),
    [anon_sym_PIPE] = ACTIONS(3756),
    [anon_sym_RPAREN] = ACTIONS(3758),
    [anon_sym_PIPE_AMP] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_LT] = ACTIONS(810),
    [anon_sym_GT] = ACTIONS(810),
    [anon_sym_GT_GT] = ACTIONS(812),
    [anon_sym_AMP_GT] = ACTIONS(810),
    [anon_sym_AMP_GT_GT] = ACTIONS(812),
    [anon_sym_LT_AMP] = ACTIONS(812),
    [anon_sym_GT_AMP] = ACTIONS(812),
    [anon_sym_LT_LT] = ACTIONS(814),
    [anon_sym_LT_LT_DASH] = ACTIONS(816),
    [anon_sym_LT_LT_LT] = ACTIONS(818),
    [sym_comment] = ACTIONS(52),
  },
  [1363] = {
    [anon_sym_PIPE] = ACTIONS(3760),
    [anon_sym_RPAREN] = ACTIONS(3762),
    [anon_sym_PIPE_AMP] = ACTIONS(3762),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3762),
    [anon_sym_BQUOTE] = ACTIONS(3762),
    [sym_comment] = ACTIONS(52),
  },
  [1364] = {
    [anon_sym_fi] = ACTIONS(3764),
    [sym_comment] = ACTIONS(52),
  },
  [1365] = {
    [sym__terminated_statement] = STATE(611),
    [sym_for_statement] = STATE(612),
    [sym_while_statement] = STATE(612),
    [sym_if_statement] = STATE(612),
    [sym_elif_clause] = STATE(613),
    [sym_else_clause] = STATE(1815),
    [sym_case_statement] = STATE(612),
    [sym_function_definition] = STATE(612),
    [sym_subshell] = STATE(612),
    [sym_pipeline] = STATE(612),
    [sym_list] = STATE(612),
    [sym_bracket_command] = STATE(612),
    [sym_command] = STATE(612),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(615),
    [sym_declaration_command] = STATE(612),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(1108),
    [aux_sym_if_statement_repeat1] = STATE(1816),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_fi] = ACTIONS(3766),
    [anon_sym_elif] = ACTIONS(1140),
    [anon_sym_else] = ACTIONS(1142),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [1366] = {
    [sym_elif_clause] = STATE(613),
    [sym_else_clause] = STATE(1815),
    [aux_sym_if_statement_repeat1] = STATE(1110),
    [anon_sym_fi] = ACTIONS(3764),
    [anon_sym_elif] = ACTIONS(2168),
    [anon_sym_else] = ACTIONS(2170),
    [sym_comment] = ACTIONS(52),
  },
  [1367] = {
    [sym_case_item] = STATE(1120),
    [sym_last_case_item] = STATE(1818),
    [sym_concatenation] = STATE(1122),
    [sym_string] = STATE(1114),
    [sym_simple_expansion] = STATE(1114),
    [sym_expansion] = STATE(1114),
    [sym_command_substitution] = STATE(1114),
    [sym_process_substitution] = STATE(1114),
    [aux_sym_case_statement_repeat1] = STATE(1819),
    [anon_sym_esac] = ACTIONS(3768),
    [sym__special_characters] = ACTIONS(2174),
    [anon_sym_DQUOTE] = ACTIONS(2176),
    [sym_raw_string] = ACTIONS(2178),
    [anon_sym_DOLLAR] = ACTIONS(2180),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2182),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2184),
    [anon_sym_BQUOTE] = ACTIONS(2186),
    [anon_sym_LT_LPAREN] = ACTIONS(2188),
    [anon_sym_GT_LPAREN] = ACTIONS(2188),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2190),
  },
  [1368] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(3770),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3770),
    [anon_sym_LF] = ACTIONS(3770),
    [anon_sym_AMP] = ACTIONS(3770),
  },
  [1369] = {
    [sym_case_item] = STATE(1120),
    [sym_last_case_item] = STATE(1822),
    [sym_concatenation] = STATE(1122),
    [sym_string] = STATE(1114),
    [sym_simple_expansion] = STATE(1114),
    [sym_expansion] = STATE(1114),
    [sym_command_substitution] = STATE(1114),
    [sym_process_substitution] = STATE(1114),
    [aux_sym_case_statement_repeat1] = STATE(1823),
    [anon_sym_esac] = ACTIONS(3772),
    [sym__special_characters] = ACTIONS(2174),
    [anon_sym_DQUOTE] = ACTIONS(2176),
    [sym_raw_string] = ACTIONS(2178),
    [anon_sym_DOLLAR] = ACTIONS(2180),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2182),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2184),
    [anon_sym_BQUOTE] = ACTIONS(2186),
    [anon_sym_LT_LPAREN] = ACTIONS(2188),
    [anon_sym_GT_LPAREN] = ACTIONS(2188),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2190),
  },
  [1370] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(3774),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3774),
    [anon_sym_LF] = ACTIONS(3774),
    [anon_sym_AMP] = ACTIONS(3774),
  },
  [1371] = {
    [sym_compound_statement] = STATE(1825),
    [anon_sym_LBRACE] = ACTIONS(1692),
    [sym_comment] = ACTIONS(52),
  },
  [1372] = {
    [sym_file_descriptor] = ACTIONS(2219),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_RPAREN] = ACTIONS(2219),
    [anon_sym_PIPE_AMP] = ACTIONS(2219),
    [anon_sym_AMP_AMP] = ACTIONS(2219),
    [anon_sym_PIPE_PIPE] = ACTIONS(2219),
    [anon_sym_LT] = ACTIONS(3776),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_GT_GT] = ACTIONS(2219),
    [anon_sym_AMP_GT] = ACTIONS(3776),
    [anon_sym_AMP_GT_GT] = ACTIONS(2219),
    [anon_sym_LT_AMP] = ACTIONS(2219),
    [anon_sym_GT_AMP] = ACTIONS(2219),
    [anon_sym_BQUOTE] = ACTIONS(2219),
    [sym_comment] = ACTIONS(52),
  },
  [1373] = {
    [sym__terminated_statement] = STATE(640),
    [sym_for_statement] = STATE(641),
    [sym_while_statement] = STATE(641),
    [sym_if_statement] = STATE(641),
    [sym_case_statement] = STATE(641),
    [sym_function_definition] = STATE(641),
    [sym_subshell] = STATE(641),
    [sym_pipeline] = STATE(641),
    [sym_list] = STATE(641),
    [sym_bracket_command] = STATE(641),
    [sym_command] = STATE(641),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(642),
    [sym_declaration_command] = STATE(641),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(1144),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_RBRACE] = ACTIONS(3778),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [1374] = {
    [anon_sym_LT] = ACTIONS(3780),
    [anon_sym_GT] = ACTIONS(3780),
    [anon_sym_GT_GT] = ACTIONS(3782),
    [anon_sym_AMP_GT] = ACTIONS(3780),
    [anon_sym_AMP_GT_GT] = ACTIONS(3782),
    [anon_sym_LT_AMP] = ACTIONS(3782),
    [anon_sym_GT_AMP] = ACTIONS(3782),
    [sym_comment] = ACTIONS(52),
  },
  [1375] = {
    [sym_concatenation] = STATE(1836),
    [sym_string] = STATE(1830),
    [sym_simple_expansion] = STATE(1830),
    [sym_expansion] = STATE(1830),
    [sym_command_substitution] = STATE(1830),
    [sym_process_substitution] = STATE(1830),
    [sym__special_characters] = ACTIONS(3784),
    [anon_sym_DQUOTE] = ACTIONS(3786),
    [sym_raw_string] = ACTIONS(3788),
    [anon_sym_DOLLAR] = ACTIONS(3790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3792),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3794),
    [anon_sym_BQUOTE] = ACTIONS(3796),
    [anon_sym_LT_LPAREN] = ACTIONS(3798),
    [anon_sym_GT_LPAREN] = ACTIONS(3798),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3800),
  },
  [1376] = {
    [anon_sym_PIPE] = ACTIONS(3802),
    [anon_sym_RPAREN] = ACTIONS(3804),
    [anon_sym_PIPE_AMP] = ACTIONS(3804),
    [anon_sym_AMP_AMP] = ACTIONS(3804),
    [anon_sym_PIPE_PIPE] = ACTIONS(3804),
    [anon_sym_BQUOTE] = ACTIONS(3804),
    [sym_comment] = ACTIONS(52),
  },
  [1377] = {
    [anon_sym_PIPE] = ACTIONS(3806),
    [anon_sym_RPAREN] = ACTIONS(3808),
    [anon_sym_PIPE_AMP] = ACTIONS(3808),
    [anon_sym_AMP_AMP] = ACTIONS(3808),
    [anon_sym_PIPE_PIPE] = ACTIONS(3808),
    [anon_sym_BQUOTE] = ACTIONS(3808),
    [sym_comment] = ACTIONS(52),
  },
  [1378] = {
    [sym_file_descriptor] = ACTIONS(902),
    [sym_variable_name] = ACTIONS(902),
    [anon_sym_for] = ACTIONS(904),
    [anon_sym_while] = ACTIONS(904),
    [anon_sym_if] = ACTIONS(904),
    [anon_sym_case] = ACTIONS(904),
    [anon_sym_RPAREN] = ACTIONS(3810),
    [anon_sym_function] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(902),
    [anon_sym_LBRACK] = ACTIONS(904),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym_declare] = ACTIONS(904),
    [anon_sym_typeset] = ACTIONS(904),
    [anon_sym_export] = ACTIONS(904),
    [anon_sym_readonly] = ACTIONS(904),
    [anon_sym_local] = ACTIONS(904),
    [anon_sym_LT] = ACTIONS(904),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_GT_GT] = ACTIONS(902),
    [anon_sym_AMP_GT] = ACTIONS(904),
    [anon_sym_AMP_GT_GT] = ACTIONS(902),
    [anon_sym_LT_AMP] = ACTIONS(902),
    [anon_sym_GT_AMP] = ACTIONS(902),
    [sym__special_characters] = ACTIONS(906),
    [anon_sym_DQUOTE] = ACTIONS(902),
    [sym_raw_string] = ACTIONS(902),
    [anon_sym_DOLLAR] = ACTIONS(904),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(902),
    [anon_sym_BQUOTE] = ACTIONS(902),
    [anon_sym_LT_LPAREN] = ACTIONS(902),
    [anon_sym_GT_LPAREN] = ACTIONS(902),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(906),
  },
  [1379] = {
    [sym_variable_name] = ACTIONS(1068),
    [anon_sym_PIPE] = ACTIONS(2675),
    [anon_sym_RPAREN] = ACTIONS(1068),
    [anon_sym_PIPE_AMP] = ACTIONS(1068),
    [anon_sym_AMP_AMP] = ACTIONS(1068),
    [anon_sym_PIPE_PIPE] = ACTIONS(1068),
    [sym__special_characters] = ACTIONS(2675),
    [anon_sym_DQUOTE] = ACTIONS(1068),
    [sym_raw_string] = ACTIONS(1068),
    [anon_sym_DOLLAR] = ACTIONS(2675),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1068),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1068),
    [anon_sym_BQUOTE] = ACTIONS(1068),
    [anon_sym_LT_LPAREN] = ACTIONS(1068),
    [anon_sym_GT_LPAREN] = ACTIONS(1068),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2675),
    [sym_word] = ACTIONS(1070),
  },
  [1380] = {
    [sym_concatenation] = STATE(572),
    [sym_string] = STATE(566),
    [sym_simple_expansion] = STATE(566),
    [sym_expansion] = STATE(566),
    [sym_command_substitution] = STATE(566),
    [sym_process_substitution] = STATE(566),
    [aux_sym_for_statement_repeat1] = STATE(1839),
    [anon_sym_RPAREN] = ACTIONS(3812),
    [sym__special_characters] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1076),
    [sym_raw_string] = ACTIONS(1078),
    [anon_sym_DOLLAR] = ACTIONS(1080),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1084),
    [anon_sym_BQUOTE] = ACTIONS(1086),
    [anon_sym_LT_LPAREN] = ACTIONS(1088),
    [anon_sym_GT_LPAREN] = ACTIONS(1088),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1090),
  },
  [1381] = {
    [aux_sym_concatenation_repeat1] = STATE(865),
    [sym__concat] = ACTIONS(1704),
    [sym_variable_name] = ACTIONS(1092),
    [anon_sym_PIPE] = ACTIONS(2681),
    [anon_sym_RPAREN] = ACTIONS(1092),
    [anon_sym_PIPE_AMP] = ACTIONS(1092),
    [anon_sym_AMP_AMP] = ACTIONS(1092),
    [anon_sym_PIPE_PIPE] = ACTIONS(1092),
    [sym__special_characters] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(1092),
    [sym_raw_string] = ACTIONS(1092),
    [anon_sym_DOLLAR] = ACTIONS(2681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1092),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1092),
    [anon_sym_BQUOTE] = ACTIONS(1092),
    [anon_sym_LT_LPAREN] = ACTIONS(1092),
    [anon_sym_GT_LPAREN] = ACTIONS(1092),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2681),
    [sym_word] = ACTIONS(1096),
  },
  [1382] = {
    [aux_sym_concatenation_repeat1] = STATE(865),
    [sym__concat] = ACTIONS(1704),
    [sym_variable_name] = ACTIONS(1068),
    [anon_sym_PIPE] = ACTIONS(2675),
    [anon_sym_RPAREN] = ACTIONS(1068),
    [anon_sym_PIPE_AMP] = ACTIONS(1068),
    [anon_sym_AMP_AMP] = ACTIONS(1068),
    [anon_sym_PIPE_PIPE] = ACTIONS(1068),
    [sym__special_characters] = ACTIONS(2675),
    [anon_sym_DQUOTE] = ACTIONS(1068),
    [sym_raw_string] = ACTIONS(1068),
    [anon_sym_DOLLAR] = ACTIONS(2675),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1068),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1068),
    [anon_sym_BQUOTE] = ACTIONS(1068),
    [anon_sym_LT_LPAREN] = ACTIONS(1068),
    [anon_sym_GT_LPAREN] = ACTIONS(1068),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2675),
    [sym_word] = ACTIONS(1070),
  },
  [1383] = {
    [sym__concat] = ACTIONS(1522),
    [sym_variable_name] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_RPAREN] = ACTIONS(1522),
    [anon_sym_PIPE_AMP] = ACTIONS(1522),
    [anon_sym_AMP_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1522),
    [sym__special_characters] = ACTIONS(2430),
    [anon_sym_DQUOTE] = ACTIONS(1522),
    [sym_raw_string] = ACTIONS(1522),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1522),
    [anon_sym_BQUOTE] = ACTIONS(1522),
    [anon_sym_LT_LPAREN] = ACTIONS(1522),
    [anon_sym_GT_LPAREN] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2430),
    [sym_word] = ACTIONS(1524),
  },
  [1384] = {
    [aux_sym_concatenation_repeat1] = STATE(1384),
    [sym__concat] = ACTIONS(3814),
    [sym_variable_name] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_RPAREN] = ACTIONS(1522),
    [anon_sym_PIPE_AMP] = ACTIONS(1522),
    [anon_sym_AMP_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1522),
    [sym__special_characters] = ACTIONS(2430),
    [anon_sym_DQUOTE] = ACTIONS(1522),
    [sym_raw_string] = ACTIONS(1522),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1522),
    [anon_sym_BQUOTE] = ACTIONS(1522),
    [anon_sym_LT_LPAREN] = ACTIONS(1522),
    [anon_sym_GT_LPAREN] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2430),
    [sym_word] = ACTIONS(1524),
  },
  [1385] = {
    [sym__concat] = ACTIONS(1553),
    [sym_variable_name] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(2435),
    [anon_sym_RPAREN] = ACTIONS(1553),
    [anon_sym_PIPE_AMP] = ACTIONS(1553),
    [anon_sym_AMP_AMP] = ACTIONS(1553),
    [anon_sym_PIPE_PIPE] = ACTIONS(1553),
    [sym__special_characters] = ACTIONS(2435),
    [anon_sym_DQUOTE] = ACTIONS(1553),
    [sym_raw_string] = ACTIONS(1553),
    [anon_sym_DOLLAR] = ACTIONS(2435),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1553),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1553),
    [anon_sym_BQUOTE] = ACTIONS(1553),
    [anon_sym_LT_LPAREN] = ACTIONS(1553),
    [anon_sym_GT_LPAREN] = ACTIONS(1553),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2435),
    [sym_word] = ACTIONS(1555),
  },
  [1386] = {
    [sym_concatenation] = STATE(1843),
    [sym_string] = STATE(1842),
    [sym_simple_expansion] = STATE(1842),
    [sym_expansion] = STATE(1842),
    [sym_command_substitution] = STATE(1842),
    [sym_process_substitution] = STATE(1842),
    [anon_sym_RBRACE] = ACTIONS(3817),
    [sym__special_characters] = ACTIONS(3819),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(3821),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3823),
  },
  [1387] = {
    [sym__concat] = ACTIONS(1598),
    [sym_variable_name] = ACTIONS(1598),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_RPAREN] = ACTIONS(1598),
    [anon_sym_PIPE_AMP] = ACTIONS(1598),
    [anon_sym_AMP_AMP] = ACTIONS(1598),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [sym__special_characters] = ACTIONS(2445),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [sym_raw_string] = ACTIONS(1598),
    [anon_sym_DOLLAR] = ACTIONS(2445),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1598),
    [anon_sym_BQUOTE] = ACTIONS(1598),
    [anon_sym_LT_LPAREN] = ACTIONS(1598),
    [anon_sym_GT_LPAREN] = ACTIONS(1598),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2445),
    [sym_word] = ACTIONS(1600),
  },
  [1388] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3825),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1389] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(3827),
    [sym_comment] = ACTIONS(52),
  },
  [1390] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1847),
    [anon_sym_RBRACE] = ACTIONS(3829),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1391] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1849),
    [anon_sym_RBRACE] = ACTIONS(3831),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1392] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1850),
    [anon_sym_RBRACE] = ACTIONS(3817),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1393] = {
    [sym__concat] = ACTIONS(1642),
    [sym_variable_name] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(2455),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [sym__special_characters] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [sym_raw_string] = ACTIONS(1642),
    [anon_sym_DOLLAR] = ACTIONS(2455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [anon_sym_LT_LPAREN] = ACTIONS(1642),
    [anon_sym_GT_LPAREN] = ACTIONS(1642),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2455),
    [sym_word] = ACTIONS(1644),
  },
  [1394] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3833),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1395] = {
    [sym__concat] = ACTIONS(1648),
    [sym_variable_name] = ACTIONS(1648),
    [anon_sym_PIPE] = ACTIONS(2459),
    [anon_sym_RPAREN] = ACTIONS(1648),
    [anon_sym_PIPE_AMP] = ACTIONS(1648),
    [anon_sym_AMP_AMP] = ACTIONS(1648),
    [anon_sym_PIPE_PIPE] = ACTIONS(1648),
    [sym__special_characters] = ACTIONS(2459),
    [anon_sym_DQUOTE] = ACTIONS(1648),
    [sym_raw_string] = ACTIONS(1648),
    [anon_sym_DOLLAR] = ACTIONS(2459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1648),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1648),
    [anon_sym_BQUOTE] = ACTIONS(1648),
    [anon_sym_LT_LPAREN] = ACTIONS(1648),
    [anon_sym_GT_LPAREN] = ACTIONS(1648),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2459),
    [sym_word] = ACTIONS(1650),
  },
  [1396] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3817),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1397] = {
    [sym__concat] = ACTIONS(1762),
    [sym_variable_name] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(2461),
    [anon_sym_RPAREN] = ACTIONS(1762),
    [anon_sym_PIPE_AMP] = ACTIONS(1762),
    [anon_sym_AMP_AMP] = ACTIONS(1762),
    [anon_sym_PIPE_PIPE] = ACTIONS(1762),
    [sym__special_characters] = ACTIONS(2461),
    [anon_sym_DQUOTE] = ACTIONS(1762),
    [sym_raw_string] = ACTIONS(1762),
    [anon_sym_DOLLAR] = ACTIONS(2461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1762),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1762),
    [anon_sym_BQUOTE] = ACTIONS(1762),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2461),
    [sym_word] = ACTIONS(1764),
  },
  [1398] = {
    [sym__concat] = ACTIONS(1902),
    [sym_variable_name] = ACTIONS(1902),
    [anon_sym_PIPE] = ACTIONS(2463),
    [anon_sym_RPAREN] = ACTIONS(1902),
    [anon_sym_PIPE_AMP] = ACTIONS(1902),
    [anon_sym_AMP_AMP] = ACTIONS(1902),
    [anon_sym_PIPE_PIPE] = ACTIONS(1902),
    [sym__special_characters] = ACTIONS(2463),
    [anon_sym_DQUOTE] = ACTIONS(1902),
    [sym_raw_string] = ACTIONS(1902),
    [anon_sym_DOLLAR] = ACTIONS(2463),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1902),
    [anon_sym_BQUOTE] = ACTIONS(1902),
    [anon_sym_LT_LPAREN] = ACTIONS(1902),
    [anon_sym_GT_LPAREN] = ACTIONS(1902),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2463),
    [sym_word] = ACTIONS(1904),
  },
  [1399] = {
    [sym_file_descriptor] = ACTIONS(2560),
    [sym__concat] = ACTIONS(2560),
    [anon_sym_PIPE] = ACTIONS(3553),
    [anon_sym_RPAREN] = ACTIONS(2560),
    [anon_sym_PIPE_AMP] = ACTIONS(2560),
    [anon_sym_AMP_AMP] = ACTIONS(2560),
    [anon_sym_PIPE_PIPE] = ACTIONS(2560),
    [anon_sym_LT] = ACTIONS(3553),
    [anon_sym_GT] = ACTIONS(3553),
    [anon_sym_GT_GT] = ACTIONS(2560),
    [anon_sym_AMP_GT] = ACTIONS(3553),
    [anon_sym_AMP_GT_GT] = ACTIONS(2560),
    [anon_sym_LT_AMP] = ACTIONS(2560),
    [anon_sym_GT_AMP] = ACTIONS(2560),
    [anon_sym_LT_LT] = ACTIONS(3553),
    [anon_sym_LT_LT_DASH] = ACTIONS(2560),
    [anon_sym_LT_LT_LT] = ACTIONS(2560),
    [sym__special_characters] = ACTIONS(3553),
    [anon_sym_DQUOTE] = ACTIONS(2560),
    [sym_raw_string] = ACTIONS(2560),
    [anon_sym_DOLLAR] = ACTIONS(3553),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2560),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2560),
    [anon_sym_BQUOTE] = ACTIONS(2560),
    [anon_sym_LT_LPAREN] = ACTIONS(2560),
    [anon_sym_GT_LPAREN] = ACTIONS(2560),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3553),
  },
  [1400] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(3835),
    [sym_comment] = ACTIONS(52),
  },
  [1401] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(3837),
    [sym_comment] = ACTIONS(52),
  },
  [1402] = {
    [anon_sym_RBRACE] = ACTIONS(3837),
    [sym_comment] = ACTIONS(52),
  },
  [1403] = {
    [sym_file_descriptor] = ACTIONS(2614),
    [sym__concat] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(3559),
    [anon_sym_RPAREN] = ACTIONS(2614),
    [anon_sym_PIPE_AMP] = ACTIONS(2614),
    [anon_sym_AMP_AMP] = ACTIONS(2614),
    [anon_sym_PIPE_PIPE] = ACTIONS(2614),
    [anon_sym_LT] = ACTIONS(3559),
    [anon_sym_GT] = ACTIONS(3559),
    [anon_sym_GT_GT] = ACTIONS(2614),
    [anon_sym_AMP_GT] = ACTIONS(3559),
    [anon_sym_AMP_GT_GT] = ACTIONS(2614),
    [anon_sym_LT_AMP] = ACTIONS(2614),
    [anon_sym_GT_AMP] = ACTIONS(2614),
    [anon_sym_LT_LT] = ACTIONS(3559),
    [anon_sym_LT_LT_DASH] = ACTIONS(2614),
    [anon_sym_LT_LT_LT] = ACTIONS(2614),
    [sym__special_characters] = ACTIONS(3559),
    [anon_sym_DQUOTE] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(2614),
    [anon_sym_DOLLAR] = ACTIONS(3559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2614),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2614),
    [anon_sym_BQUOTE] = ACTIONS(2614),
    [anon_sym_LT_LPAREN] = ACTIONS(2614),
    [anon_sym_GT_LPAREN] = ACTIONS(2614),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3559),
  },
  [1404] = {
    [sym_concatenation] = STATE(1856),
    [sym_string] = STATE(1855),
    [sym_simple_expansion] = STATE(1855),
    [sym_expansion] = STATE(1855),
    [sym_command_substitution] = STATE(1855),
    [sym_process_substitution] = STATE(1855),
    [anon_sym_RBRACE] = ACTIONS(3837),
    [sym__special_characters] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(3841),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3843),
  },
  [1405] = {
    [sym_file_descriptor] = ACTIONS(2659),
    [sym__concat] = ACTIONS(2659),
    [anon_sym_PIPE] = ACTIONS(3567),
    [anon_sym_RPAREN] = ACTIONS(2659),
    [anon_sym_PIPE_AMP] = ACTIONS(2659),
    [anon_sym_AMP_AMP] = ACTIONS(2659),
    [anon_sym_PIPE_PIPE] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(3567),
    [anon_sym_GT] = ACTIONS(3567),
    [anon_sym_GT_GT] = ACTIONS(2659),
    [anon_sym_AMP_GT] = ACTIONS(3567),
    [anon_sym_AMP_GT_GT] = ACTIONS(2659),
    [anon_sym_LT_AMP] = ACTIONS(2659),
    [anon_sym_GT_AMP] = ACTIONS(2659),
    [anon_sym_LT_LT] = ACTIONS(3567),
    [anon_sym_LT_LT_DASH] = ACTIONS(2659),
    [anon_sym_LT_LT_LT] = ACTIONS(2659),
    [sym__special_characters] = ACTIONS(3567),
    [anon_sym_DQUOTE] = ACTIONS(2659),
    [sym_raw_string] = ACTIONS(2659),
    [anon_sym_DOLLAR] = ACTIONS(3567),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2659),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2659),
    [anon_sym_BQUOTE] = ACTIONS(2659),
    [anon_sym_LT_LPAREN] = ACTIONS(2659),
    [anon_sym_GT_LPAREN] = ACTIONS(2659),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3567),
  },
  [1406] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1407] = {
    [sym_file_descriptor] = ACTIONS(2665),
    [sym__concat] = ACTIONS(2665),
    [anon_sym_PIPE] = ACTIONS(3571),
    [anon_sym_RPAREN] = ACTIONS(2665),
    [anon_sym_PIPE_AMP] = ACTIONS(2665),
    [anon_sym_AMP_AMP] = ACTIONS(2665),
    [anon_sym_PIPE_PIPE] = ACTIONS(2665),
    [anon_sym_LT] = ACTIONS(3571),
    [anon_sym_GT] = ACTIONS(3571),
    [anon_sym_GT_GT] = ACTIONS(2665),
    [anon_sym_AMP_GT] = ACTIONS(3571),
    [anon_sym_AMP_GT_GT] = ACTIONS(2665),
    [anon_sym_LT_AMP] = ACTIONS(2665),
    [anon_sym_GT_AMP] = ACTIONS(2665),
    [anon_sym_LT_LT] = ACTIONS(3571),
    [anon_sym_LT_LT_DASH] = ACTIONS(2665),
    [anon_sym_LT_LT_LT] = ACTIONS(2665),
    [sym__special_characters] = ACTIONS(3571),
    [anon_sym_DQUOTE] = ACTIONS(2665),
    [sym_raw_string] = ACTIONS(2665),
    [anon_sym_DOLLAR] = ACTIONS(3571),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2665),
    [anon_sym_BQUOTE] = ACTIONS(2665),
    [anon_sym_LT_LPAREN] = ACTIONS(2665),
    [anon_sym_GT_LPAREN] = ACTIONS(2665),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3571),
  },
  [1408] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3847),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1409] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3837),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1410] = {
    [sym_file_descriptor] = ACTIONS(2671),
    [sym__concat] = ACTIONS(2671),
    [anon_sym_PIPE] = ACTIONS(3575),
    [anon_sym_RPAREN] = ACTIONS(2671),
    [anon_sym_PIPE_AMP] = ACTIONS(2671),
    [anon_sym_AMP_AMP] = ACTIONS(2671),
    [anon_sym_PIPE_PIPE] = ACTIONS(2671),
    [anon_sym_LT] = ACTIONS(3575),
    [anon_sym_GT] = ACTIONS(3575),
    [anon_sym_GT_GT] = ACTIONS(2671),
    [anon_sym_AMP_GT] = ACTIONS(3575),
    [anon_sym_AMP_GT_GT] = ACTIONS(2671),
    [anon_sym_LT_AMP] = ACTIONS(2671),
    [anon_sym_GT_AMP] = ACTIONS(2671),
    [anon_sym_LT_LT] = ACTIONS(3575),
    [anon_sym_LT_LT_DASH] = ACTIONS(2671),
    [anon_sym_LT_LT_LT] = ACTIONS(2671),
    [sym__special_characters] = ACTIONS(3575),
    [anon_sym_DQUOTE] = ACTIONS(2671),
    [sym_raw_string] = ACTIONS(2671),
    [anon_sym_DOLLAR] = ACTIONS(3575),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2671),
    [anon_sym_BQUOTE] = ACTIONS(2671),
    [anon_sym_LT_LPAREN] = ACTIONS(2671),
    [anon_sym_GT_LPAREN] = ACTIONS(2671),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3575),
  },
  [1411] = {
    [sym_file_redirect] = STATE(1859),
    [sym_file_descriptor] = ACTIONS(2721),
    [anon_sym_PIPE] = ACTIONS(3802),
    [anon_sym_RPAREN] = ACTIONS(3804),
    [anon_sym_PIPE_AMP] = ACTIONS(3804),
    [anon_sym_AMP_AMP] = ACTIONS(3804),
    [anon_sym_PIPE_PIPE] = ACTIONS(3804),
    [anon_sym_LT] = ACTIONS(2727),
    [anon_sym_GT] = ACTIONS(2727),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_AMP_GT] = ACTIONS(2727),
    [anon_sym_AMP_GT_GT] = ACTIONS(2729),
    [anon_sym_LT_AMP] = ACTIONS(2729),
    [anon_sym_GT_AMP] = ACTIONS(2729),
    [sym_comment] = ACTIONS(52),
  },
  [1412] = {
    [aux_sym_concatenation_repeat1] = STATE(1416),
    [sym_file_descriptor] = ACTIONS(1032),
    [sym__concat] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(1034),
    [anon_sym_RPAREN] = ACTIONS(1032),
    [anon_sym_PIPE_AMP] = ACTIONS(1032),
    [anon_sym_AMP_AMP] = ACTIONS(1032),
    [anon_sym_PIPE_PIPE] = ACTIONS(1032),
    [anon_sym_LT] = ACTIONS(1034),
    [anon_sym_GT] = ACTIONS(1034),
    [anon_sym_GT_GT] = ACTIONS(1032),
    [anon_sym_AMP_GT] = ACTIONS(1034),
    [anon_sym_AMP_GT_GT] = ACTIONS(1032),
    [anon_sym_LT_AMP] = ACTIONS(1032),
    [anon_sym_GT_AMP] = ACTIONS(1032),
    [anon_sym_LT_LT] = ACTIONS(1034),
    [anon_sym_LT_LT_DASH] = ACTIONS(1032),
    [anon_sym_LT_LT_LT] = ACTIONS(1032),
    [sym_comment] = ACTIONS(52),
  },
  [1413] = {
    [aux_sym_concatenation_repeat1] = STATE(1416),
    [sym_file_descriptor] = ACTIONS(1036),
    [sym__concat] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(1038),
    [anon_sym_RPAREN] = ACTIONS(1036),
    [anon_sym_PIPE_AMP] = ACTIONS(1036),
    [anon_sym_AMP_AMP] = ACTIONS(1036),
    [anon_sym_PIPE_PIPE] = ACTIONS(1036),
    [anon_sym_LT] = ACTIONS(1038),
    [anon_sym_GT] = ACTIONS(1038),
    [anon_sym_GT_GT] = ACTIONS(1036),
    [anon_sym_AMP_GT] = ACTIONS(1038),
    [anon_sym_AMP_GT_GT] = ACTIONS(1036),
    [anon_sym_LT_AMP] = ACTIONS(1036),
    [anon_sym_GT_AMP] = ACTIONS(1036),
    [anon_sym_LT_LT] = ACTIONS(1038),
    [anon_sym_LT_LT_DASH] = ACTIONS(1036),
    [anon_sym_LT_LT_LT] = ACTIONS(1036),
    [sym_comment] = ACTIONS(52),
  },
  [1414] = {
    [sym_file_descriptor] = ACTIONS(1036),
    [anon_sym_PIPE] = ACTIONS(1038),
    [anon_sym_RPAREN] = ACTIONS(1036),
    [anon_sym_PIPE_AMP] = ACTIONS(1036),
    [anon_sym_AMP_AMP] = ACTIONS(1036),
    [anon_sym_PIPE_PIPE] = ACTIONS(1036),
    [anon_sym_LT] = ACTIONS(1038),
    [anon_sym_GT] = ACTIONS(1038),
    [anon_sym_GT_GT] = ACTIONS(1036),
    [anon_sym_AMP_GT] = ACTIONS(1038),
    [anon_sym_AMP_GT_GT] = ACTIONS(1036),
    [anon_sym_LT_AMP] = ACTIONS(1036),
    [anon_sym_GT_AMP] = ACTIONS(1036),
    [anon_sym_LT_LT] = ACTIONS(1038),
    [anon_sym_LT_LT_DASH] = ACTIONS(1036),
    [anon_sym_LT_LT_LT] = ACTIONS(1036),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_comment] = ACTIONS(52),
  },
  [1415] = {
    [sym_string] = STATE(1860),
    [sym_simple_expansion] = STATE(1860),
    [sym_expansion] = STATE(1860),
    [sym_command_substitution] = STATE(1860),
    [sym_process_substitution] = STATE(1860),
    [sym__special_characters] = ACTIONS(3849),
    [anon_sym_DQUOTE] = ACTIONS(1772),
    [sym_raw_string] = ACTIONS(3851),
    [anon_sym_DOLLAR] = ACTIONS(1776),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1778),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1780),
    [anon_sym_BQUOTE] = ACTIONS(1782),
    [anon_sym_LT_LPAREN] = ACTIONS(1784),
    [anon_sym_GT_LPAREN] = ACTIONS(1784),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3849),
  },
  [1416] = {
    [aux_sym_concatenation_repeat1] = STATE(1861),
    [sym_file_descriptor] = ACTIONS(646),
    [sym__concat] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(1300),
    [anon_sym_RPAREN] = ACTIONS(646),
    [anon_sym_PIPE_AMP] = ACTIONS(646),
    [anon_sym_AMP_AMP] = ACTIONS(646),
    [anon_sym_PIPE_PIPE] = ACTIONS(646),
    [anon_sym_LT] = ACTIONS(1300),
    [anon_sym_GT] = ACTIONS(1300),
    [anon_sym_GT_GT] = ACTIONS(646),
    [anon_sym_AMP_GT] = ACTIONS(1300),
    [anon_sym_AMP_GT_GT] = ACTIONS(646),
    [anon_sym_LT_AMP] = ACTIONS(646),
    [anon_sym_GT_AMP] = ACTIONS(646),
    [anon_sym_LT_LT] = ACTIONS(1300),
    [anon_sym_LT_LT_DASH] = ACTIONS(646),
    [anon_sym_LT_LT_LT] = ACTIONS(646),
    [sym_comment] = ACTIONS(52),
  },
  [1417] = {
    [sym_file_descriptor] = ACTIONS(650),
    [sym__concat] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(1302),
    [anon_sym_RPAREN] = ACTIONS(650),
    [anon_sym_PIPE_AMP] = ACTIONS(650),
    [anon_sym_AMP_AMP] = ACTIONS(650),
    [anon_sym_PIPE_PIPE] = ACTIONS(650),
    [anon_sym_LT] = ACTIONS(1302),
    [anon_sym_GT] = ACTIONS(1302),
    [anon_sym_GT_GT] = ACTIONS(650),
    [anon_sym_AMP_GT] = ACTIONS(1302),
    [anon_sym_AMP_GT_GT] = ACTIONS(650),
    [anon_sym_LT_AMP] = ACTIONS(650),
    [anon_sym_GT_AMP] = ACTIONS(650),
    [anon_sym_LT_LT] = ACTIONS(1302),
    [anon_sym_LT_LT_DASH] = ACTIONS(650),
    [anon_sym_LT_LT_LT] = ACTIONS(650),
    [sym_comment] = ACTIONS(52),
  },
  [1418] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(3853),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [1419] = {
    [sym_file_descriptor] = ACTIONS(680),
    [sym__concat] = ACTIONS(680),
    [anon_sym_PIPE] = ACTIONS(1306),
    [anon_sym_RPAREN] = ACTIONS(680),
    [anon_sym_PIPE_AMP] = ACTIONS(680),
    [anon_sym_AMP_AMP] = ACTIONS(680),
    [anon_sym_PIPE_PIPE] = ACTIONS(680),
    [anon_sym_LT] = ACTIONS(1306),
    [anon_sym_GT] = ACTIONS(1306),
    [anon_sym_GT_GT] = ACTIONS(680),
    [anon_sym_AMP_GT] = ACTIONS(1306),
    [anon_sym_AMP_GT_GT] = ACTIONS(680),
    [anon_sym_LT_AMP] = ACTIONS(680),
    [anon_sym_GT_AMP] = ACTIONS(680),
    [anon_sym_LT_LT] = ACTIONS(1306),
    [anon_sym_LT_LT_DASH] = ACTIONS(680),
    [anon_sym_LT_LT_LT] = ACTIONS(680),
    [sym_comment] = ACTIONS(52),
  },
  [1420] = {
    [sym_file_descriptor] = ACTIONS(684),
    [sym__concat] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(1308),
    [anon_sym_RPAREN] = ACTIONS(684),
    [anon_sym_PIPE_AMP] = ACTIONS(684),
    [anon_sym_AMP_AMP] = ACTIONS(684),
    [anon_sym_PIPE_PIPE] = ACTIONS(684),
    [anon_sym_LT] = ACTIONS(1308),
    [anon_sym_GT] = ACTIONS(1308),
    [anon_sym_GT_GT] = ACTIONS(684),
    [anon_sym_AMP_GT] = ACTIONS(1308),
    [anon_sym_AMP_GT_GT] = ACTIONS(684),
    [anon_sym_LT_AMP] = ACTIONS(684),
    [anon_sym_GT_AMP] = ACTIONS(684),
    [anon_sym_LT_LT] = ACTIONS(1308),
    [anon_sym_LT_LT_DASH] = ACTIONS(684),
    [anon_sym_LT_LT_LT] = ACTIONS(684),
    [sym_comment] = ACTIONS(52),
  },
  [1421] = {
    [sym_file_descriptor] = ACTIONS(688),
    [sym__concat] = ACTIONS(688),
    [anon_sym_PIPE] = ACTIONS(1310),
    [anon_sym_RPAREN] = ACTIONS(688),
    [anon_sym_PIPE_AMP] = ACTIONS(688),
    [anon_sym_AMP_AMP] = ACTIONS(688),
    [anon_sym_PIPE_PIPE] = ACTIONS(688),
    [anon_sym_LT] = ACTIONS(1310),
    [anon_sym_GT] = ACTIONS(1310),
    [anon_sym_GT_GT] = ACTIONS(688),
    [anon_sym_AMP_GT] = ACTIONS(1310),
    [anon_sym_AMP_GT_GT] = ACTIONS(688),
    [anon_sym_LT_AMP] = ACTIONS(688),
    [anon_sym_GT_AMP] = ACTIONS(688),
    [anon_sym_LT_LT] = ACTIONS(1310),
    [anon_sym_LT_LT_DASH] = ACTIONS(688),
    [anon_sym_LT_LT_LT] = ACTIONS(688),
    [sym_comment] = ACTIONS(52),
  },
  [1422] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(3855),
    [sym_comment] = ACTIONS(52),
  },
  [1423] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1865),
    [anon_sym_RBRACE] = ACTIONS(3857),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1424] = {
    [sym_subscript] = STATE(1869),
    [sym_variable_name] = ACTIONS(3859),
    [anon_sym_DOLLAR] = ACTIONS(3861),
    [anon_sym_DASH] = ACTIONS(3861),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3863),
    [anon_sym_STAR] = ACTIONS(3861),
    [anon_sym_AT] = ACTIONS(3861),
    [anon_sym_QMARK] = ACTIONS(3861),
    [anon_sym_0] = ACTIONS(3865),
    [anon_sym__] = ACTIONS(3865),
  },
  [1425] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1871),
    [anon_sym_RBRACE] = ACTIONS(3867),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1426] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1873),
    [anon_sym_RBRACE] = ACTIONS(3869),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1427] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3871),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [1428] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3871),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1429] = {
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(3871),
    [sym_comment] = ACTIONS(52),
  },
  [1430] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(3871),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1431] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3873),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [1432] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3873),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1433] = {
    [sym_file_descriptor] = ACTIONS(3146),
    [anon_sym_PIPE] = ACTIONS(3875),
    [anon_sym_RPAREN] = ACTIONS(3146),
    [anon_sym_PIPE_AMP] = ACTIONS(3146),
    [anon_sym_AMP_AMP] = ACTIONS(3146),
    [anon_sym_PIPE_PIPE] = ACTIONS(3146),
    [anon_sym_LT] = ACTIONS(3875),
    [anon_sym_GT] = ACTIONS(3875),
    [anon_sym_GT_GT] = ACTIONS(3146),
    [anon_sym_AMP_GT] = ACTIONS(3875),
    [anon_sym_AMP_GT_GT] = ACTIONS(3146),
    [anon_sym_LT_AMP] = ACTIONS(3146),
    [anon_sym_GT_AMP] = ACTIONS(3146),
    [anon_sym_LT_LT] = ACTIONS(3875),
    [anon_sym_LT_LT_DASH] = ACTIONS(3146),
    [anon_sym_LT_LT_LT] = ACTIONS(3146),
    [anon_sym_BQUOTE] = ACTIONS(3146),
    [sym_comment] = ACTIONS(52),
  },
  [1434] = {
    [sym_simple_expansion] = STATE(1012),
    [sym_expansion] = STATE(1012),
    [aux_sym_heredoc_repeat1] = STATE(1537),
    [sym__heredoc_middle] = ACTIONS(1944),
    [sym__heredoc_end] = ACTIONS(3877),
    [anon_sym_DOLLAR] = ACTIONS(1948),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1950),
    [sym_comment] = ACTIONS(52),
  },
  [1435] = {
    [sym_file_redirect] = STATE(466),
    [sym_heredoc_redirect] = STATE(466),
    [sym_herestring_redirect] = STATE(466),
    [aux_sym_while_statement_repeat1] = STATE(922),
    [sym_file_descriptor] = ACTIONS(804),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_RPAREN] = ACTIONS(3881),
    [anon_sym_PIPE_AMP] = ACTIONS(3881),
    [anon_sym_AMP_AMP] = ACTIONS(3881),
    [anon_sym_PIPE_PIPE] = ACTIONS(3881),
    [anon_sym_LT] = ACTIONS(810),
    [anon_sym_GT] = ACTIONS(810),
    [anon_sym_GT_GT] = ACTIONS(812),
    [anon_sym_AMP_GT] = ACTIONS(810),
    [anon_sym_AMP_GT_GT] = ACTIONS(812),
    [anon_sym_LT_AMP] = ACTIONS(812),
    [anon_sym_GT_AMP] = ACTIONS(812),
    [anon_sym_LT_LT] = ACTIONS(814),
    [anon_sym_LT_LT_DASH] = ACTIONS(816),
    [anon_sym_LT_LT_LT] = ACTIONS(818),
    [sym_comment] = ACTIONS(52),
  },
  [1436] = {
    [sym_string] = STATE(1877),
    [sym_simple_expansion] = STATE(1877),
    [sym_expansion] = STATE(1877),
    [sym_command_substitution] = STATE(1877),
    [sym_process_substitution] = STATE(1877),
    [sym__special_characters] = ACTIONS(3883),
    [anon_sym_DQUOTE] = ACTIONS(1806),
    [sym_raw_string] = ACTIONS(3885),
    [anon_sym_DOLLAR] = ACTIONS(1810),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1812),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1814),
    [anon_sym_BQUOTE] = ACTIONS(1816),
    [anon_sym_LT_LPAREN] = ACTIONS(1818),
    [anon_sym_GT_LPAREN] = ACTIONS(1818),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3883),
  },
  [1437] = {
    [aux_sym_concatenation_repeat1] = STATE(1878),
    [sym_file_descriptor] = ACTIONS(646),
    [sym__concat] = ACTIONS(2934),
    [sym_variable_name] = ACTIONS(646),
    [anon_sym_PIPE] = ACTIONS(1300),
    [anon_sym_PIPE_AMP] = ACTIONS(646),
    [anon_sym_AMP_AMP] = ACTIONS(646),
    [anon_sym_PIPE_PIPE] = ACTIONS(646),
    [anon_sym_LT] = ACTIONS(1300),
    [anon_sym_GT] = ACTIONS(1300),
    [anon_sym_GT_GT] = ACTIONS(646),
    [anon_sym_AMP_GT] = ACTIONS(1300),
    [anon_sym_AMP_GT_GT] = ACTIONS(646),
    [anon_sym_LT_AMP] = ACTIONS(646),
    [anon_sym_GT_AMP] = ACTIONS(646),
    [sym__special_characters] = ACTIONS(1300),
    [anon_sym_DQUOTE] = ACTIONS(646),
    [sym_raw_string] = ACTIONS(646),
    [anon_sym_DOLLAR] = ACTIONS(1300),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(646),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(646),
    [anon_sym_BQUOTE] = ACTIONS(646),
    [anon_sym_LT_LPAREN] = ACTIONS(646),
    [anon_sym_GT_LPAREN] = ACTIONS(646),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1300),
  },
  [1438] = {
    [sym_file_descriptor] = ACTIONS(650),
    [sym__concat] = ACTIONS(650),
    [sym_variable_name] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(1302),
    [anon_sym_PIPE_AMP] = ACTIONS(650),
    [anon_sym_AMP_AMP] = ACTIONS(650),
    [anon_sym_PIPE_PIPE] = ACTIONS(650),
    [anon_sym_LT] = ACTIONS(1302),
    [anon_sym_GT] = ACTIONS(1302),
    [anon_sym_GT_GT] = ACTIONS(650),
    [anon_sym_AMP_GT] = ACTIONS(1302),
    [anon_sym_AMP_GT_GT] = ACTIONS(650),
    [anon_sym_LT_AMP] = ACTIONS(650),
    [anon_sym_GT_AMP] = ACTIONS(650),
    [sym__special_characters] = ACTIONS(1302),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [sym_raw_string] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(1302),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(650),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LT_LPAREN] = ACTIONS(650),
    [anon_sym_GT_LPAREN] = ACTIONS(650),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1302),
  },
  [1439] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(3887),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [1440] = {
    [sym_file_descriptor] = ACTIONS(680),
    [sym__concat] = ACTIONS(680),
    [sym_variable_name] = ACTIONS(680),
    [anon_sym_PIPE] = ACTIONS(1306),
    [anon_sym_PIPE_AMP] = ACTIONS(680),
    [anon_sym_AMP_AMP] = ACTIONS(680),
    [anon_sym_PIPE_PIPE] = ACTIONS(680),
    [anon_sym_LT] = ACTIONS(1306),
    [anon_sym_GT] = ACTIONS(1306),
    [anon_sym_GT_GT] = ACTIONS(680),
    [anon_sym_AMP_GT] = ACTIONS(1306),
    [anon_sym_AMP_GT_GT] = ACTIONS(680),
    [anon_sym_LT_AMP] = ACTIONS(680),
    [anon_sym_GT_AMP] = ACTIONS(680),
    [sym__special_characters] = ACTIONS(1306),
    [anon_sym_DQUOTE] = ACTIONS(680),
    [sym_raw_string] = ACTIONS(680),
    [anon_sym_DOLLAR] = ACTIONS(1306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(680),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(680),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [anon_sym_LT_LPAREN] = ACTIONS(680),
    [anon_sym_GT_LPAREN] = ACTIONS(680),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1306),
  },
  [1441] = {
    [sym_file_descriptor] = ACTIONS(684),
    [sym__concat] = ACTIONS(684),
    [sym_variable_name] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(1308),
    [anon_sym_PIPE_AMP] = ACTIONS(684),
    [anon_sym_AMP_AMP] = ACTIONS(684),
    [anon_sym_PIPE_PIPE] = ACTIONS(684),
    [anon_sym_LT] = ACTIONS(1308),
    [anon_sym_GT] = ACTIONS(1308),
    [anon_sym_GT_GT] = ACTIONS(684),
    [anon_sym_AMP_GT] = ACTIONS(1308),
    [anon_sym_AMP_GT_GT] = ACTIONS(684),
    [anon_sym_LT_AMP] = ACTIONS(684),
    [anon_sym_GT_AMP] = ACTIONS(684),
    [sym__special_characters] = ACTIONS(1308),
    [anon_sym_DQUOTE] = ACTIONS(684),
    [sym_raw_string] = ACTIONS(684),
    [anon_sym_DOLLAR] = ACTIONS(1308),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(684),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(684),
    [anon_sym_BQUOTE] = ACTIONS(684),
    [anon_sym_LT_LPAREN] = ACTIONS(684),
    [anon_sym_GT_LPAREN] = ACTIONS(684),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1308),
  },
  [1442] = {
    [sym_file_descriptor] = ACTIONS(688),
    [sym__concat] = ACTIONS(688),
    [sym_variable_name] = ACTIONS(688),
    [anon_sym_PIPE] = ACTIONS(1310),
    [anon_sym_PIPE_AMP] = ACTIONS(688),
    [anon_sym_AMP_AMP] = ACTIONS(688),
    [anon_sym_PIPE_PIPE] = ACTIONS(688),
    [anon_sym_LT] = ACTIONS(1310),
    [anon_sym_GT] = ACTIONS(1310),
    [anon_sym_GT_GT] = ACTIONS(688),
    [anon_sym_AMP_GT] = ACTIONS(1310),
    [anon_sym_AMP_GT_GT] = ACTIONS(688),
    [anon_sym_LT_AMP] = ACTIONS(688),
    [anon_sym_GT_AMP] = ACTIONS(688),
    [sym__special_characters] = ACTIONS(1310),
    [anon_sym_DQUOTE] = ACTIONS(688),
    [sym_raw_string] = ACTIONS(688),
    [anon_sym_DOLLAR] = ACTIONS(1310),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(688),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(688),
    [anon_sym_BQUOTE] = ACTIONS(688),
    [anon_sym_LT_LPAREN] = ACTIONS(688),
    [anon_sym_GT_LPAREN] = ACTIONS(688),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1310),
  },
  [1443] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(3889),
    [sym_comment] = ACTIONS(52),
  },
  [1444] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1882),
    [anon_sym_RBRACE] = ACTIONS(3891),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1445] = {
    [sym_subscript] = STATE(1886),
    [sym_variable_name] = ACTIONS(3893),
    [anon_sym_DOLLAR] = ACTIONS(3895),
    [anon_sym_DASH] = ACTIONS(3895),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3897),
    [anon_sym_STAR] = ACTIONS(3895),
    [anon_sym_AT] = ACTIONS(3895),
    [anon_sym_QMARK] = ACTIONS(3895),
    [anon_sym_0] = ACTIONS(3899),
    [anon_sym__] = ACTIONS(3899),
  },
  [1446] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1888),
    [anon_sym_RBRACE] = ACTIONS(3901),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1447] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1890),
    [anon_sym_RBRACE] = ACTIONS(3903),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1448] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3905),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [1449] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3905),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1450] = {
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(3905),
    [sym_comment] = ACTIONS(52),
  },
  [1451] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(3905),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1452] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3907),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [1453] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3907),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1454] = {
    [sym_file_redirect] = STATE(466),
    [sym_heredoc_redirect] = STATE(466),
    [sym_herestring_redirect] = STATE(466),
    [aux_sym_while_statement_repeat1] = STATE(988),
    [sym_file_descriptor] = ACTIONS(880),
    [anon_sym_PIPE] = ACTIONS(3756),
    [anon_sym_PIPE_AMP] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_LT] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(882),
    [anon_sym_GT_GT] = ACTIONS(884),
    [anon_sym_AMP_GT] = ACTIONS(882),
    [anon_sym_AMP_GT_GT] = ACTIONS(884),
    [anon_sym_LT_AMP] = ACTIONS(884),
    [anon_sym_GT_AMP] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(814),
    [anon_sym_LT_LT_DASH] = ACTIONS(816),
    [anon_sym_LT_LT_LT] = ACTIONS(886),
    [anon_sym_BQUOTE] = ACTIONS(3758),
    [sym_comment] = ACTIONS(52),
  },
  [1455] = {
    [sym_compound_statement] = STATE(1893),
    [anon_sym_LBRACE] = ACTIONS(1692),
    [sym_comment] = ACTIONS(52),
  },
  [1456] = {
    [anon_sym_LT] = ACTIONS(3909),
    [anon_sym_GT] = ACTIONS(3909),
    [anon_sym_GT_GT] = ACTIONS(3911),
    [anon_sym_AMP_GT] = ACTIONS(3909),
    [anon_sym_AMP_GT_GT] = ACTIONS(3911),
    [anon_sym_LT_AMP] = ACTIONS(3911),
    [anon_sym_GT_AMP] = ACTIONS(3911),
    [sym_comment] = ACTIONS(52),
  },
  [1457] = {
    [sym_concatenation] = STATE(1836),
    [sym_string] = STATE(1897),
    [sym_simple_expansion] = STATE(1897),
    [sym_expansion] = STATE(1897),
    [sym_command_substitution] = STATE(1897),
    [sym_process_substitution] = STATE(1897),
    [sym__special_characters] = ACTIONS(3913),
    [anon_sym_DQUOTE] = ACTIONS(3915),
    [sym_raw_string] = ACTIONS(3917),
    [anon_sym_DOLLAR] = ACTIONS(3919),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3921),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3923),
    [anon_sym_BQUOTE] = ACTIONS(3925),
    [anon_sym_LT_LPAREN] = ACTIONS(3927),
    [anon_sym_GT_LPAREN] = ACTIONS(3927),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3929),
  },
  [1458] = {
    [aux_sym_concatenation_repeat1] = STATE(937),
    [sym__concat] = ACTIONS(1826),
    [sym_variable_name] = ACTIONS(1092),
    [anon_sym_PIPE] = ACTIONS(2681),
    [anon_sym_PIPE_AMP] = ACTIONS(1092),
    [anon_sym_AMP_AMP] = ACTIONS(1092),
    [anon_sym_PIPE_PIPE] = ACTIONS(1092),
    [sym__special_characters] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(1092),
    [sym_raw_string] = ACTIONS(1092),
    [anon_sym_DOLLAR] = ACTIONS(2681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1092),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1092),
    [anon_sym_BQUOTE] = ACTIONS(1092),
    [anon_sym_LT_LPAREN] = ACTIONS(1092),
    [anon_sym_GT_LPAREN] = ACTIONS(1092),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2681),
    [sym_word] = ACTIONS(1096),
  },
  [1459] = {
    [aux_sym_concatenation_repeat1] = STATE(937),
    [sym__concat] = ACTIONS(1826),
    [sym_variable_name] = ACTIONS(1068),
    [anon_sym_PIPE] = ACTIONS(2675),
    [anon_sym_PIPE_AMP] = ACTIONS(1068),
    [anon_sym_AMP_AMP] = ACTIONS(1068),
    [anon_sym_PIPE_PIPE] = ACTIONS(1068),
    [sym__special_characters] = ACTIONS(2675),
    [anon_sym_DQUOTE] = ACTIONS(1068),
    [sym_raw_string] = ACTIONS(1068),
    [anon_sym_DOLLAR] = ACTIONS(2675),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1068),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1068),
    [anon_sym_BQUOTE] = ACTIONS(1068),
    [anon_sym_LT_LPAREN] = ACTIONS(1068),
    [anon_sym_GT_LPAREN] = ACTIONS(1068),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2675),
    [sym_word] = ACTIONS(1070),
  },
  [1460] = {
    [sym__concat] = ACTIONS(1522),
    [sym_variable_name] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_PIPE_AMP] = ACTIONS(1522),
    [anon_sym_AMP_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1522),
    [sym__special_characters] = ACTIONS(2430),
    [anon_sym_DQUOTE] = ACTIONS(1522),
    [sym_raw_string] = ACTIONS(1522),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1522),
    [anon_sym_BQUOTE] = ACTIONS(1522),
    [anon_sym_LT_LPAREN] = ACTIONS(1522),
    [anon_sym_GT_LPAREN] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2430),
    [sym_word] = ACTIONS(1524),
  },
  [1461] = {
    [aux_sym_concatenation_repeat1] = STATE(1461),
    [sym__concat] = ACTIONS(3931),
    [sym_variable_name] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_PIPE_AMP] = ACTIONS(1522),
    [anon_sym_AMP_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1522),
    [sym__special_characters] = ACTIONS(2430),
    [anon_sym_DQUOTE] = ACTIONS(1522),
    [sym_raw_string] = ACTIONS(1522),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1522),
    [anon_sym_BQUOTE] = ACTIONS(1522),
    [anon_sym_LT_LPAREN] = ACTIONS(1522),
    [anon_sym_GT_LPAREN] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2430),
    [sym_word] = ACTIONS(1524),
  },
  [1462] = {
    [sym__concat] = ACTIONS(1553),
    [sym_variable_name] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(2435),
    [anon_sym_PIPE_AMP] = ACTIONS(1553),
    [anon_sym_AMP_AMP] = ACTIONS(1553),
    [anon_sym_PIPE_PIPE] = ACTIONS(1553),
    [sym__special_characters] = ACTIONS(2435),
    [anon_sym_DQUOTE] = ACTIONS(1553),
    [sym_raw_string] = ACTIONS(1553),
    [anon_sym_DOLLAR] = ACTIONS(2435),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1553),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1553),
    [anon_sym_BQUOTE] = ACTIONS(1553),
    [anon_sym_LT_LPAREN] = ACTIONS(1553),
    [anon_sym_GT_LPAREN] = ACTIONS(1553),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2435),
    [sym_word] = ACTIONS(1555),
  },
  [1463] = {
    [sym_concatenation] = STATE(1906),
    [sym_string] = STATE(1905),
    [sym_simple_expansion] = STATE(1905),
    [sym_expansion] = STATE(1905),
    [sym_command_substitution] = STATE(1905),
    [sym_process_substitution] = STATE(1905),
    [anon_sym_RBRACE] = ACTIONS(3934),
    [sym__special_characters] = ACTIONS(3936),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(3938),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3940),
  },
  [1464] = {
    [sym__concat] = ACTIONS(1598),
    [sym_variable_name] = ACTIONS(1598),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_PIPE_AMP] = ACTIONS(1598),
    [anon_sym_AMP_AMP] = ACTIONS(1598),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [sym__special_characters] = ACTIONS(2445),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [sym_raw_string] = ACTIONS(1598),
    [anon_sym_DOLLAR] = ACTIONS(2445),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1598),
    [anon_sym_BQUOTE] = ACTIONS(1598),
    [anon_sym_LT_LPAREN] = ACTIONS(1598),
    [anon_sym_GT_LPAREN] = ACTIONS(1598),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2445),
    [sym_word] = ACTIONS(1600),
  },
  [1465] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3942),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1466] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(3944),
    [sym_comment] = ACTIONS(52),
  },
  [1467] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1910),
    [anon_sym_RBRACE] = ACTIONS(3946),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1468] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1912),
    [anon_sym_RBRACE] = ACTIONS(3948),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1469] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1913),
    [anon_sym_RBRACE] = ACTIONS(3934),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1470] = {
    [sym__concat] = ACTIONS(1642),
    [sym_variable_name] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(2455),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [sym__special_characters] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [sym_raw_string] = ACTIONS(1642),
    [anon_sym_DOLLAR] = ACTIONS(2455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [anon_sym_LT_LPAREN] = ACTIONS(1642),
    [anon_sym_GT_LPAREN] = ACTIONS(1642),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2455),
    [sym_word] = ACTIONS(1644),
  },
  [1471] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3950),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1472] = {
    [sym__concat] = ACTIONS(1648),
    [sym_variable_name] = ACTIONS(1648),
    [anon_sym_PIPE] = ACTIONS(2459),
    [anon_sym_PIPE_AMP] = ACTIONS(1648),
    [anon_sym_AMP_AMP] = ACTIONS(1648),
    [anon_sym_PIPE_PIPE] = ACTIONS(1648),
    [sym__special_characters] = ACTIONS(2459),
    [anon_sym_DQUOTE] = ACTIONS(1648),
    [sym_raw_string] = ACTIONS(1648),
    [anon_sym_DOLLAR] = ACTIONS(2459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1648),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1648),
    [anon_sym_BQUOTE] = ACTIONS(1648),
    [anon_sym_LT_LPAREN] = ACTIONS(1648),
    [anon_sym_GT_LPAREN] = ACTIONS(1648),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2459),
    [sym_word] = ACTIONS(1650),
  },
  [1473] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3934),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1474] = {
    [sym__concat] = ACTIONS(1762),
    [sym_variable_name] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(2461),
    [anon_sym_PIPE_AMP] = ACTIONS(1762),
    [anon_sym_AMP_AMP] = ACTIONS(1762),
    [anon_sym_PIPE_PIPE] = ACTIONS(1762),
    [sym__special_characters] = ACTIONS(2461),
    [anon_sym_DQUOTE] = ACTIONS(1762),
    [sym_raw_string] = ACTIONS(1762),
    [anon_sym_DOLLAR] = ACTIONS(2461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1762),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1762),
    [anon_sym_BQUOTE] = ACTIONS(1762),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2461),
    [sym_word] = ACTIONS(1764),
  },
  [1475] = {
    [sym__concat] = ACTIONS(1902),
    [sym_variable_name] = ACTIONS(1902),
    [anon_sym_PIPE] = ACTIONS(2463),
    [anon_sym_PIPE_AMP] = ACTIONS(1902),
    [anon_sym_AMP_AMP] = ACTIONS(1902),
    [anon_sym_PIPE_PIPE] = ACTIONS(1902),
    [sym__special_characters] = ACTIONS(2463),
    [anon_sym_DQUOTE] = ACTIONS(1902),
    [sym_raw_string] = ACTIONS(1902),
    [anon_sym_DOLLAR] = ACTIONS(2463),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1902),
    [anon_sym_BQUOTE] = ACTIONS(1902),
    [anon_sym_LT_LPAREN] = ACTIONS(1902),
    [anon_sym_GT_LPAREN] = ACTIONS(1902),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2463),
    [sym_word] = ACTIONS(1904),
  },
  [1476] = {
    [sym_file_descriptor] = ACTIONS(2560),
    [sym__concat] = ACTIONS(2560),
    [anon_sym_PIPE] = ACTIONS(3553),
    [anon_sym_PIPE_AMP] = ACTIONS(2560),
    [anon_sym_AMP_AMP] = ACTIONS(2560),
    [anon_sym_PIPE_PIPE] = ACTIONS(2560),
    [anon_sym_LT] = ACTIONS(3553),
    [anon_sym_GT] = ACTIONS(3553),
    [anon_sym_GT_GT] = ACTIONS(2560),
    [anon_sym_AMP_GT] = ACTIONS(3553),
    [anon_sym_AMP_GT_GT] = ACTIONS(2560),
    [anon_sym_LT_AMP] = ACTIONS(2560),
    [anon_sym_GT_AMP] = ACTIONS(2560),
    [anon_sym_LT_LT] = ACTIONS(3553),
    [anon_sym_LT_LT_DASH] = ACTIONS(2560),
    [anon_sym_LT_LT_LT] = ACTIONS(2560),
    [sym__special_characters] = ACTIONS(3553),
    [anon_sym_DQUOTE] = ACTIONS(2560),
    [sym_raw_string] = ACTIONS(2560),
    [anon_sym_DOLLAR] = ACTIONS(3553),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2560),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2560),
    [anon_sym_BQUOTE] = ACTIONS(2560),
    [anon_sym_LT_LPAREN] = ACTIONS(2560),
    [anon_sym_GT_LPAREN] = ACTIONS(2560),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3553),
  },
  [1477] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(3952),
    [sym_comment] = ACTIONS(52),
  },
  [1478] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(3954),
    [sym_comment] = ACTIONS(52),
  },
  [1479] = {
    [anon_sym_RBRACE] = ACTIONS(3954),
    [sym_comment] = ACTIONS(52),
  },
  [1480] = {
    [sym_file_descriptor] = ACTIONS(2614),
    [sym__concat] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(3559),
    [anon_sym_PIPE_AMP] = ACTIONS(2614),
    [anon_sym_AMP_AMP] = ACTIONS(2614),
    [anon_sym_PIPE_PIPE] = ACTIONS(2614),
    [anon_sym_LT] = ACTIONS(3559),
    [anon_sym_GT] = ACTIONS(3559),
    [anon_sym_GT_GT] = ACTIONS(2614),
    [anon_sym_AMP_GT] = ACTIONS(3559),
    [anon_sym_AMP_GT_GT] = ACTIONS(2614),
    [anon_sym_LT_AMP] = ACTIONS(2614),
    [anon_sym_GT_AMP] = ACTIONS(2614),
    [anon_sym_LT_LT] = ACTIONS(3559),
    [anon_sym_LT_LT_DASH] = ACTIONS(2614),
    [anon_sym_LT_LT_LT] = ACTIONS(2614),
    [sym__special_characters] = ACTIONS(3559),
    [anon_sym_DQUOTE] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(2614),
    [anon_sym_DOLLAR] = ACTIONS(3559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2614),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2614),
    [anon_sym_BQUOTE] = ACTIONS(2614),
    [anon_sym_LT_LPAREN] = ACTIONS(2614),
    [anon_sym_GT_LPAREN] = ACTIONS(2614),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3559),
  },
  [1481] = {
    [sym_concatenation] = STATE(1919),
    [sym_string] = STATE(1918),
    [sym_simple_expansion] = STATE(1918),
    [sym_expansion] = STATE(1918),
    [sym_command_substitution] = STATE(1918),
    [sym_process_substitution] = STATE(1918),
    [anon_sym_RBRACE] = ACTIONS(3954),
    [sym__special_characters] = ACTIONS(3956),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(3958),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3960),
  },
  [1482] = {
    [sym_file_descriptor] = ACTIONS(2659),
    [sym__concat] = ACTIONS(2659),
    [anon_sym_PIPE] = ACTIONS(3567),
    [anon_sym_PIPE_AMP] = ACTIONS(2659),
    [anon_sym_AMP_AMP] = ACTIONS(2659),
    [anon_sym_PIPE_PIPE] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(3567),
    [anon_sym_GT] = ACTIONS(3567),
    [anon_sym_GT_GT] = ACTIONS(2659),
    [anon_sym_AMP_GT] = ACTIONS(3567),
    [anon_sym_AMP_GT_GT] = ACTIONS(2659),
    [anon_sym_LT_AMP] = ACTIONS(2659),
    [anon_sym_GT_AMP] = ACTIONS(2659),
    [anon_sym_LT_LT] = ACTIONS(3567),
    [anon_sym_LT_LT_DASH] = ACTIONS(2659),
    [anon_sym_LT_LT_LT] = ACTIONS(2659),
    [sym__special_characters] = ACTIONS(3567),
    [anon_sym_DQUOTE] = ACTIONS(2659),
    [sym_raw_string] = ACTIONS(2659),
    [anon_sym_DOLLAR] = ACTIONS(3567),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2659),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2659),
    [anon_sym_BQUOTE] = ACTIONS(2659),
    [anon_sym_LT_LPAREN] = ACTIONS(2659),
    [anon_sym_GT_LPAREN] = ACTIONS(2659),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3567),
  },
  [1483] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3962),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1484] = {
    [sym_file_descriptor] = ACTIONS(2665),
    [sym__concat] = ACTIONS(2665),
    [anon_sym_PIPE] = ACTIONS(3571),
    [anon_sym_PIPE_AMP] = ACTIONS(2665),
    [anon_sym_AMP_AMP] = ACTIONS(2665),
    [anon_sym_PIPE_PIPE] = ACTIONS(2665),
    [anon_sym_LT] = ACTIONS(3571),
    [anon_sym_GT] = ACTIONS(3571),
    [anon_sym_GT_GT] = ACTIONS(2665),
    [anon_sym_AMP_GT] = ACTIONS(3571),
    [anon_sym_AMP_GT_GT] = ACTIONS(2665),
    [anon_sym_LT_AMP] = ACTIONS(2665),
    [anon_sym_GT_AMP] = ACTIONS(2665),
    [anon_sym_LT_LT] = ACTIONS(3571),
    [anon_sym_LT_LT_DASH] = ACTIONS(2665),
    [anon_sym_LT_LT_LT] = ACTIONS(2665),
    [sym__special_characters] = ACTIONS(3571),
    [anon_sym_DQUOTE] = ACTIONS(2665),
    [sym_raw_string] = ACTIONS(2665),
    [anon_sym_DOLLAR] = ACTIONS(3571),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2665),
    [anon_sym_BQUOTE] = ACTIONS(2665),
    [anon_sym_LT_LPAREN] = ACTIONS(2665),
    [anon_sym_GT_LPAREN] = ACTIONS(2665),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3571),
  },
  [1485] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3964),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1486] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3954),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1487] = {
    [sym_file_descriptor] = ACTIONS(2671),
    [sym__concat] = ACTIONS(2671),
    [anon_sym_PIPE] = ACTIONS(3575),
    [anon_sym_PIPE_AMP] = ACTIONS(2671),
    [anon_sym_AMP_AMP] = ACTIONS(2671),
    [anon_sym_PIPE_PIPE] = ACTIONS(2671),
    [anon_sym_LT] = ACTIONS(3575),
    [anon_sym_GT] = ACTIONS(3575),
    [anon_sym_GT_GT] = ACTIONS(2671),
    [anon_sym_AMP_GT] = ACTIONS(3575),
    [anon_sym_AMP_GT_GT] = ACTIONS(2671),
    [anon_sym_LT_AMP] = ACTIONS(2671),
    [anon_sym_GT_AMP] = ACTIONS(2671),
    [anon_sym_LT_LT] = ACTIONS(3575),
    [anon_sym_LT_LT_DASH] = ACTIONS(2671),
    [anon_sym_LT_LT_LT] = ACTIONS(2671),
    [sym__special_characters] = ACTIONS(3575),
    [anon_sym_DQUOTE] = ACTIONS(2671),
    [sym_raw_string] = ACTIONS(2671),
    [anon_sym_DOLLAR] = ACTIONS(3575),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2671),
    [anon_sym_BQUOTE] = ACTIONS(2671),
    [anon_sym_LT_LPAREN] = ACTIONS(2671),
    [anon_sym_GT_LPAREN] = ACTIONS(2671),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3575),
  },
  [1488] = {
    [sym_file_redirect] = STATE(1859),
    [sym_file_descriptor] = ACTIONS(2956),
    [anon_sym_PIPE] = ACTIONS(3802),
    [anon_sym_PIPE_AMP] = ACTIONS(3804),
    [anon_sym_AMP_AMP] = ACTIONS(3804),
    [anon_sym_PIPE_PIPE] = ACTIONS(3804),
    [anon_sym_LT] = ACTIONS(2958),
    [anon_sym_GT] = ACTIONS(2958),
    [anon_sym_GT_GT] = ACTIONS(2960),
    [anon_sym_AMP_GT] = ACTIONS(2958),
    [anon_sym_AMP_GT_GT] = ACTIONS(2960),
    [anon_sym_LT_AMP] = ACTIONS(2960),
    [anon_sym_GT_AMP] = ACTIONS(2960),
    [anon_sym_BQUOTE] = ACTIONS(3804),
    [sym_comment] = ACTIONS(52),
  },
  [1489] = {
    [aux_sym_concatenation_repeat1] = STATE(1492),
    [sym_file_descriptor] = ACTIONS(1032),
    [sym__concat] = ACTIONS(3053),
    [anon_sym_PIPE] = ACTIONS(1034),
    [anon_sym_PIPE_AMP] = ACTIONS(1032),
    [anon_sym_AMP_AMP] = ACTIONS(1032),
    [anon_sym_PIPE_PIPE] = ACTIONS(1032),
    [anon_sym_LT] = ACTIONS(1034),
    [anon_sym_GT] = ACTIONS(1034),
    [anon_sym_GT_GT] = ACTIONS(1032),
    [anon_sym_AMP_GT] = ACTIONS(1034),
    [anon_sym_AMP_GT_GT] = ACTIONS(1032),
    [anon_sym_LT_AMP] = ACTIONS(1032),
    [anon_sym_GT_AMP] = ACTIONS(1032),
    [anon_sym_LT_LT] = ACTIONS(1034),
    [anon_sym_LT_LT_DASH] = ACTIONS(1032),
    [anon_sym_LT_LT_LT] = ACTIONS(1032),
    [anon_sym_BQUOTE] = ACTIONS(1032),
    [sym_comment] = ACTIONS(52),
  },
  [1490] = {
    [aux_sym_concatenation_repeat1] = STATE(1492),
    [sym_file_descriptor] = ACTIONS(1036),
    [sym__concat] = ACTIONS(3053),
    [anon_sym_PIPE] = ACTIONS(1038),
    [anon_sym_PIPE_AMP] = ACTIONS(1036),
    [anon_sym_AMP_AMP] = ACTIONS(1036),
    [anon_sym_PIPE_PIPE] = ACTIONS(1036),
    [anon_sym_LT] = ACTIONS(1038),
    [anon_sym_GT] = ACTIONS(1038),
    [anon_sym_GT_GT] = ACTIONS(1036),
    [anon_sym_AMP_GT] = ACTIONS(1038),
    [anon_sym_AMP_GT_GT] = ACTIONS(1036),
    [anon_sym_LT_AMP] = ACTIONS(1036),
    [anon_sym_GT_AMP] = ACTIONS(1036),
    [anon_sym_LT_LT] = ACTIONS(1038),
    [anon_sym_LT_LT_DASH] = ACTIONS(1036),
    [anon_sym_LT_LT_LT] = ACTIONS(1036),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_comment] = ACTIONS(52),
  },
  [1491] = {
    [sym_string] = STATE(1922),
    [sym_simple_expansion] = STATE(1922),
    [sym_expansion] = STATE(1922),
    [sym_command_substitution] = STATE(1922),
    [sym_process_substitution] = STATE(1922),
    [sym__special_characters] = ACTIONS(3966),
    [anon_sym_DQUOTE] = ACTIONS(1880),
    [sym_raw_string] = ACTIONS(3968),
    [anon_sym_DOLLAR] = ACTIONS(1884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1888),
    [anon_sym_BQUOTE] = ACTIONS(1890),
    [anon_sym_LT_LPAREN] = ACTIONS(1892),
    [anon_sym_GT_LPAREN] = ACTIONS(1892),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3966),
  },
  [1492] = {
    [aux_sym_concatenation_repeat1] = STATE(1923),
    [sym_file_descriptor] = ACTIONS(646),
    [sym__concat] = ACTIONS(3053),
    [anon_sym_PIPE] = ACTIONS(1300),
    [anon_sym_PIPE_AMP] = ACTIONS(646),
    [anon_sym_AMP_AMP] = ACTIONS(646),
    [anon_sym_PIPE_PIPE] = ACTIONS(646),
    [anon_sym_LT] = ACTIONS(1300),
    [anon_sym_GT] = ACTIONS(1300),
    [anon_sym_GT_GT] = ACTIONS(646),
    [anon_sym_AMP_GT] = ACTIONS(1300),
    [anon_sym_AMP_GT_GT] = ACTIONS(646),
    [anon_sym_LT_AMP] = ACTIONS(646),
    [anon_sym_GT_AMP] = ACTIONS(646),
    [anon_sym_LT_LT] = ACTIONS(1300),
    [anon_sym_LT_LT_DASH] = ACTIONS(646),
    [anon_sym_LT_LT_LT] = ACTIONS(646),
    [anon_sym_BQUOTE] = ACTIONS(646),
    [sym_comment] = ACTIONS(52),
  },
  [1493] = {
    [sym_file_descriptor] = ACTIONS(650),
    [sym__concat] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(1302),
    [anon_sym_PIPE_AMP] = ACTIONS(650),
    [anon_sym_AMP_AMP] = ACTIONS(650),
    [anon_sym_PIPE_PIPE] = ACTIONS(650),
    [anon_sym_LT] = ACTIONS(1302),
    [anon_sym_GT] = ACTIONS(1302),
    [anon_sym_GT_GT] = ACTIONS(650),
    [anon_sym_AMP_GT] = ACTIONS(1302),
    [anon_sym_AMP_GT_GT] = ACTIONS(650),
    [anon_sym_LT_AMP] = ACTIONS(650),
    [anon_sym_GT_AMP] = ACTIONS(650),
    [anon_sym_LT_LT] = ACTIONS(1302),
    [anon_sym_LT_LT_DASH] = ACTIONS(650),
    [anon_sym_LT_LT_LT] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [sym_comment] = ACTIONS(52),
  },
  [1494] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(3970),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [1495] = {
    [sym_file_descriptor] = ACTIONS(680),
    [sym__concat] = ACTIONS(680),
    [anon_sym_PIPE] = ACTIONS(1306),
    [anon_sym_PIPE_AMP] = ACTIONS(680),
    [anon_sym_AMP_AMP] = ACTIONS(680),
    [anon_sym_PIPE_PIPE] = ACTIONS(680),
    [anon_sym_LT] = ACTIONS(1306),
    [anon_sym_GT] = ACTIONS(1306),
    [anon_sym_GT_GT] = ACTIONS(680),
    [anon_sym_AMP_GT] = ACTIONS(1306),
    [anon_sym_AMP_GT_GT] = ACTIONS(680),
    [anon_sym_LT_AMP] = ACTIONS(680),
    [anon_sym_GT_AMP] = ACTIONS(680),
    [anon_sym_LT_LT] = ACTIONS(1306),
    [anon_sym_LT_LT_DASH] = ACTIONS(680),
    [anon_sym_LT_LT_LT] = ACTIONS(680),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_comment] = ACTIONS(52),
  },
  [1496] = {
    [sym_file_descriptor] = ACTIONS(684),
    [sym__concat] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(1308),
    [anon_sym_PIPE_AMP] = ACTIONS(684),
    [anon_sym_AMP_AMP] = ACTIONS(684),
    [anon_sym_PIPE_PIPE] = ACTIONS(684),
    [anon_sym_LT] = ACTIONS(1308),
    [anon_sym_GT] = ACTIONS(1308),
    [anon_sym_GT_GT] = ACTIONS(684),
    [anon_sym_AMP_GT] = ACTIONS(1308),
    [anon_sym_AMP_GT_GT] = ACTIONS(684),
    [anon_sym_LT_AMP] = ACTIONS(684),
    [anon_sym_GT_AMP] = ACTIONS(684),
    [anon_sym_LT_LT] = ACTIONS(1308),
    [anon_sym_LT_LT_DASH] = ACTIONS(684),
    [anon_sym_LT_LT_LT] = ACTIONS(684),
    [anon_sym_BQUOTE] = ACTIONS(684),
    [sym_comment] = ACTIONS(52),
  },
  [1497] = {
    [sym_file_descriptor] = ACTIONS(688),
    [sym__concat] = ACTIONS(688),
    [anon_sym_PIPE] = ACTIONS(1310),
    [anon_sym_PIPE_AMP] = ACTIONS(688),
    [anon_sym_AMP_AMP] = ACTIONS(688),
    [anon_sym_PIPE_PIPE] = ACTIONS(688),
    [anon_sym_LT] = ACTIONS(1310),
    [anon_sym_GT] = ACTIONS(1310),
    [anon_sym_GT_GT] = ACTIONS(688),
    [anon_sym_AMP_GT] = ACTIONS(1310),
    [anon_sym_AMP_GT_GT] = ACTIONS(688),
    [anon_sym_LT_AMP] = ACTIONS(688),
    [anon_sym_GT_AMP] = ACTIONS(688),
    [anon_sym_LT_LT] = ACTIONS(1310),
    [anon_sym_LT_LT_DASH] = ACTIONS(688),
    [anon_sym_LT_LT_LT] = ACTIONS(688),
    [anon_sym_BQUOTE] = ACTIONS(688),
    [sym_comment] = ACTIONS(52),
  },
  [1498] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(3972),
    [sym_comment] = ACTIONS(52),
  },
  [1499] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1927),
    [anon_sym_RBRACE] = ACTIONS(3974),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1500] = {
    [sym_subscript] = STATE(1931),
    [sym_variable_name] = ACTIONS(3976),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_DASH] = ACTIONS(3978),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3980),
    [anon_sym_STAR] = ACTIONS(3978),
    [anon_sym_AT] = ACTIONS(3978),
    [anon_sym_QMARK] = ACTIONS(3978),
    [anon_sym_0] = ACTIONS(3982),
    [anon_sym__] = ACTIONS(3982),
  },
  [1501] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1933),
    [anon_sym_RBRACE] = ACTIONS(3984),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1502] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1935),
    [anon_sym_RBRACE] = ACTIONS(3986),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1503] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3988),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [1504] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3988),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1505] = {
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(3988),
    [sym_comment] = ACTIONS(52),
  },
  [1506] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(3988),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1507] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3990),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [1508] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(3990),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1509] = {
    [sym_file_redirect] = STATE(466),
    [sym_heredoc_redirect] = STATE(466),
    [sym_herestring_redirect] = STATE(466),
    [aux_sym_while_statement_repeat1] = STATE(988),
    [sym_file_descriptor] = ACTIONS(880),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_PIPE_AMP] = ACTIONS(3881),
    [anon_sym_AMP_AMP] = ACTIONS(3881),
    [anon_sym_PIPE_PIPE] = ACTIONS(3881),
    [anon_sym_LT] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(882),
    [anon_sym_GT_GT] = ACTIONS(884),
    [anon_sym_AMP_GT] = ACTIONS(882),
    [anon_sym_AMP_GT_GT] = ACTIONS(884),
    [anon_sym_LT_AMP] = ACTIONS(884),
    [anon_sym_GT_AMP] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(814),
    [anon_sym_LT_LT_DASH] = ACTIONS(816),
    [anon_sym_LT_LT_LT] = ACTIONS(886),
    [anon_sym_BQUOTE] = ACTIONS(3881),
    [sym_comment] = ACTIONS(52),
  },
  [1510] = {
    [anon_sym_PIPE] = ACTIONS(3410),
    [anon_sym_RPAREN] = ACTIONS(3410),
    [anon_sym_SEMI_SEMI] = ACTIONS(3410),
    [anon_sym_PIPE_AMP] = ACTIONS(3410),
    [anon_sym_AMP_AMP] = ACTIONS(3410),
    [anon_sym_PIPE_PIPE] = ACTIONS(3410),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3410),
    [anon_sym_LF] = ACTIONS(3410),
    [anon_sym_AMP] = ACTIONS(3410),
  },
  [1511] = {
    [sym_file_descriptor] = ACTIONS(1522),
    [sym__concat] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(1524),
    [anon_sym_SEMI_SEMI] = ACTIONS(1524),
    [anon_sym_PIPE_AMP] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1524),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_LT] = ACTIONS(1524),
    [anon_sym_GT] = ACTIONS(1524),
    [anon_sym_GT_GT] = ACTIONS(1524),
    [anon_sym_AMP_GT] = ACTIONS(1524),
    [anon_sym_AMP_GT_GT] = ACTIONS(1524),
    [anon_sym_LT_AMP] = ACTIONS(1524),
    [anon_sym_GT_AMP] = ACTIONS(1524),
    [anon_sym_LT_LT] = ACTIONS(1524),
    [anon_sym_LT_LT_DASH] = ACTIONS(1524),
    [anon_sym_LT_LT_LT] = ACTIONS(1524),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1524),
    [anon_sym_LF] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1524),
  },
  [1512] = {
    [aux_sym_concatenation_repeat1] = STATE(1512),
    [sym_file_descriptor] = ACTIONS(1522),
    [sym__concat] = ACTIONS(3992),
    [anon_sym_PIPE] = ACTIONS(1524),
    [anon_sym_SEMI_SEMI] = ACTIONS(1524),
    [anon_sym_PIPE_AMP] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1524),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_LT] = ACTIONS(1524),
    [anon_sym_GT] = ACTIONS(1524),
    [anon_sym_GT_GT] = ACTIONS(1524),
    [anon_sym_AMP_GT] = ACTIONS(1524),
    [anon_sym_AMP_GT_GT] = ACTIONS(1524),
    [anon_sym_LT_AMP] = ACTIONS(1524),
    [anon_sym_GT_AMP] = ACTIONS(1524),
    [anon_sym_LT_LT] = ACTIONS(1524),
    [anon_sym_LT_LT_DASH] = ACTIONS(1524),
    [anon_sym_LT_LT_LT] = ACTIONS(1524),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1524),
    [anon_sym_LF] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1524),
  },
  [1513] = {
    [sym_file_descriptor] = ACTIONS(1553),
    [sym__concat] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(1555),
    [anon_sym_SEMI_SEMI] = ACTIONS(1555),
    [anon_sym_PIPE_AMP] = ACTIONS(1555),
    [anon_sym_AMP_AMP] = ACTIONS(1555),
    [anon_sym_PIPE_PIPE] = ACTIONS(1555),
    [anon_sym_LT] = ACTIONS(1555),
    [anon_sym_GT] = ACTIONS(1555),
    [anon_sym_GT_GT] = ACTIONS(1555),
    [anon_sym_AMP_GT] = ACTIONS(1555),
    [anon_sym_AMP_GT_GT] = ACTIONS(1555),
    [anon_sym_LT_AMP] = ACTIONS(1555),
    [anon_sym_GT_AMP] = ACTIONS(1555),
    [anon_sym_LT_LT] = ACTIONS(1555),
    [anon_sym_LT_LT_DASH] = ACTIONS(1555),
    [anon_sym_LT_LT_LT] = ACTIONS(1555),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1555),
    [anon_sym_LF] = ACTIONS(1555),
    [anon_sym_AMP] = ACTIONS(1555),
  },
  [1514] = {
    [sym_concatenation] = STATE(1941),
    [sym_string] = STATE(1940),
    [sym_simple_expansion] = STATE(1940),
    [sym_expansion] = STATE(1940),
    [sym_command_substitution] = STATE(1940),
    [sym_process_substitution] = STATE(1940),
    [anon_sym_RBRACE] = ACTIONS(3995),
    [sym__special_characters] = ACTIONS(3997),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(3999),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4001),
  },
  [1515] = {
    [sym_file_descriptor] = ACTIONS(1598),
    [sym__concat] = ACTIONS(1598),
    [anon_sym_PIPE] = ACTIONS(1600),
    [anon_sym_SEMI_SEMI] = ACTIONS(1600),
    [anon_sym_PIPE_AMP] = ACTIONS(1600),
    [anon_sym_AMP_AMP] = ACTIONS(1600),
    [anon_sym_PIPE_PIPE] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1600),
    [anon_sym_GT] = ACTIONS(1600),
    [anon_sym_GT_GT] = ACTIONS(1600),
    [anon_sym_AMP_GT] = ACTIONS(1600),
    [anon_sym_AMP_GT_GT] = ACTIONS(1600),
    [anon_sym_LT_AMP] = ACTIONS(1600),
    [anon_sym_GT_AMP] = ACTIONS(1600),
    [anon_sym_LT_LT] = ACTIONS(1600),
    [anon_sym_LT_LT_DASH] = ACTIONS(1600),
    [anon_sym_LT_LT_LT] = ACTIONS(1600),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1600),
    [anon_sym_LF] = ACTIONS(1600),
    [anon_sym_AMP] = ACTIONS(1600),
  },
  [1516] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4003),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1517] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(4005),
    [sym_comment] = ACTIONS(52),
  },
  [1518] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1945),
    [anon_sym_RBRACE] = ACTIONS(4007),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1519] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(4009),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1520] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1948),
    [anon_sym_RBRACE] = ACTIONS(3995),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1521] = {
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1644),
    [anon_sym_LT_LT_DASH] = ACTIONS(1644),
    [anon_sym_LT_LT_LT] = ACTIONS(1644),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [1522] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4011),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1523] = {
    [sym_file_descriptor] = ACTIONS(1648),
    [sym__concat] = ACTIONS(1648),
    [anon_sym_PIPE] = ACTIONS(1650),
    [anon_sym_SEMI_SEMI] = ACTIONS(1650),
    [anon_sym_PIPE_AMP] = ACTIONS(1650),
    [anon_sym_AMP_AMP] = ACTIONS(1650),
    [anon_sym_PIPE_PIPE] = ACTIONS(1650),
    [anon_sym_LT] = ACTIONS(1650),
    [anon_sym_GT] = ACTIONS(1650),
    [anon_sym_GT_GT] = ACTIONS(1650),
    [anon_sym_AMP_GT] = ACTIONS(1650),
    [anon_sym_AMP_GT_GT] = ACTIONS(1650),
    [anon_sym_LT_AMP] = ACTIONS(1650),
    [anon_sym_GT_AMP] = ACTIONS(1650),
    [anon_sym_LT_LT] = ACTIONS(1650),
    [anon_sym_LT_LT_DASH] = ACTIONS(1650),
    [anon_sym_LT_LT_LT] = ACTIONS(1650),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1650),
    [anon_sym_LF] = ACTIONS(1650),
    [anon_sym_AMP] = ACTIONS(1650),
  },
  [1524] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(3995),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1525] = {
    [sym_file_descriptor] = ACTIONS(1762),
    [sym__concat] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(1764),
    [anon_sym_SEMI_SEMI] = ACTIONS(1764),
    [anon_sym_PIPE_AMP] = ACTIONS(1764),
    [anon_sym_AMP_AMP] = ACTIONS(1764),
    [anon_sym_PIPE_PIPE] = ACTIONS(1764),
    [anon_sym_LT] = ACTIONS(1764),
    [anon_sym_GT] = ACTIONS(1764),
    [anon_sym_GT_GT] = ACTIONS(1764),
    [anon_sym_AMP_GT] = ACTIONS(1764),
    [anon_sym_AMP_GT_GT] = ACTIONS(1764),
    [anon_sym_LT_AMP] = ACTIONS(1764),
    [anon_sym_GT_AMP] = ACTIONS(1764),
    [anon_sym_LT_LT] = ACTIONS(1764),
    [anon_sym_LT_LT_DASH] = ACTIONS(1764),
    [anon_sym_LT_LT_LT] = ACTIONS(1764),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1764),
    [anon_sym_LF] = ACTIONS(1764),
    [anon_sym_AMP] = ACTIONS(1764),
  },
  [1526] = {
    [sym_file_descriptor] = ACTIONS(1902),
    [sym__concat] = ACTIONS(1902),
    [anon_sym_PIPE] = ACTIONS(1904),
    [anon_sym_SEMI_SEMI] = ACTIONS(1904),
    [anon_sym_PIPE_AMP] = ACTIONS(1904),
    [anon_sym_AMP_AMP] = ACTIONS(1904),
    [anon_sym_PIPE_PIPE] = ACTIONS(1904),
    [anon_sym_LT] = ACTIONS(1904),
    [anon_sym_GT] = ACTIONS(1904),
    [anon_sym_GT_GT] = ACTIONS(1904),
    [anon_sym_AMP_GT] = ACTIONS(1904),
    [anon_sym_AMP_GT_GT] = ACTIONS(1904),
    [anon_sym_LT_AMP] = ACTIONS(1904),
    [anon_sym_GT_AMP] = ACTIONS(1904),
    [anon_sym_LT_LT] = ACTIONS(1904),
    [anon_sym_LT_LT_DASH] = ACTIONS(1904),
    [anon_sym_LT_LT_LT] = ACTIONS(1904),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1904),
    [anon_sym_LF] = ACTIONS(1904),
    [anon_sym_AMP] = ACTIONS(1904),
  },
  [1527] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(1951),
    [anon_sym_DQUOTE] = ACTIONS(4013),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [1528] = {
    [sym__heredoc_middle] = ACTIONS(680),
    [sym__heredoc_end] = ACTIONS(680),
    [anon_sym_DOLLAR] = ACTIONS(1306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(680),
    [sym_comment] = ACTIONS(52),
  },
  [1529] = {
    [sym__heredoc_middle] = ACTIONS(684),
    [sym__heredoc_end] = ACTIONS(684),
    [anon_sym_DOLLAR] = ACTIONS(1308),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(684),
    [sym_comment] = ACTIONS(52),
  },
  [1530] = {
    [sym__heredoc_middle] = ACTIONS(688),
    [sym__heredoc_end] = ACTIONS(688),
    [anon_sym_DOLLAR] = ACTIONS(1310),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(688),
    [sym_comment] = ACTIONS(52),
  },
  [1531] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(4015),
    [sym_comment] = ACTIONS(52),
  },
  [1532] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1954),
    [anon_sym_RBRACE] = ACTIONS(4017),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1533] = {
    [sym_subscript] = STATE(1958),
    [sym_variable_name] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4021),
    [anon_sym_DASH] = ACTIONS(4021),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4023),
    [anon_sym_STAR] = ACTIONS(4021),
    [anon_sym_AT] = ACTIONS(4021),
    [anon_sym_QMARK] = ACTIONS(4021),
    [anon_sym_0] = ACTIONS(4025),
    [anon_sym__] = ACTIONS(4025),
  },
  [1534] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1960),
    [anon_sym_RBRACE] = ACTIONS(4027),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1535] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1962),
    [anon_sym_RBRACE] = ACTIONS(4029),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1536] = {
    [sym_file_descriptor] = ACTIONS(4031),
    [anon_sym_PIPE] = ACTIONS(4033),
    [anon_sym_RPAREN] = ACTIONS(4033),
    [anon_sym_SEMI_SEMI] = ACTIONS(4033),
    [anon_sym_PIPE_AMP] = ACTIONS(4033),
    [anon_sym_AMP_AMP] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(4033),
    [anon_sym_GT] = ACTIONS(4033),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_AMP_GT] = ACTIONS(4033),
    [anon_sym_AMP_GT_GT] = ACTIONS(4033),
    [anon_sym_LT_AMP] = ACTIONS(4033),
    [anon_sym_GT_AMP] = ACTIONS(4033),
    [anon_sym_LT_LT] = ACTIONS(4033),
    [anon_sym_LT_LT_DASH] = ACTIONS(4033),
    [anon_sym_LT_LT_LT] = ACTIONS(4033),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(4033),
    [anon_sym_LF] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4033),
  },
  [1537] = {
    [sym_simple_expansion] = STATE(1012),
    [sym_expansion] = STATE(1012),
    [aux_sym_heredoc_repeat1] = STATE(1537),
    [sym__heredoc_middle] = ACTIONS(4035),
    [sym__heredoc_end] = ACTIONS(4038),
    [anon_sym_DOLLAR] = ACTIONS(4040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4043),
    [sym_comment] = ACTIONS(52),
  },
  [1538] = {
    [anon_sym_EQ] = ACTIONS(4046),
    [anon_sym_PLUS_EQ] = ACTIONS(4046),
    [sym_comment] = ACTIONS(52),
  },
  [1539] = {
    [anon_sym_EQ] = ACTIONS(4048),
    [anon_sym_PLUS_EQ] = ACTIONS(4048),
    [sym_comment] = ACTIONS(52),
  },
  [1540] = {
    [sym__concat] = ACTIONS(2560),
    [anon_sym_RBRACK] = ACTIONS(2560),
    [sym_comment] = ACTIONS(52),
  },
  [1541] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4050),
    [sym_comment] = ACTIONS(52),
  },
  [1542] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4052),
    [sym_comment] = ACTIONS(52),
  },
  [1543] = {
    [anon_sym_RBRACE] = ACTIONS(4052),
    [sym_comment] = ACTIONS(52),
  },
  [1544] = {
    [sym__concat] = ACTIONS(2614),
    [anon_sym_RBRACK] = ACTIONS(2614),
    [sym_comment] = ACTIONS(52),
  },
  [1545] = {
    [sym_concatenation] = STATE(1967),
    [sym_string] = STATE(1966),
    [sym_simple_expansion] = STATE(1966),
    [sym_expansion] = STATE(1966),
    [sym_command_substitution] = STATE(1966),
    [sym_process_substitution] = STATE(1966),
    [anon_sym_RBRACE] = ACTIONS(4052),
    [sym__special_characters] = ACTIONS(4054),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(4056),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4058),
  },
  [1546] = {
    [sym__concat] = ACTIONS(2659),
    [anon_sym_RBRACK] = ACTIONS(2659),
    [sym_comment] = ACTIONS(52),
  },
  [1547] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4060),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1548] = {
    [sym__concat] = ACTIONS(2665),
    [anon_sym_RBRACK] = ACTIONS(2665),
    [sym_comment] = ACTIONS(52),
  },
  [1549] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4062),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1550] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4052),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1551] = {
    [sym__concat] = ACTIONS(2671),
    [anon_sym_RBRACK] = ACTIONS(2671),
    [sym_comment] = ACTIONS(52),
  },
  [1552] = {
    [sym__concat] = ACTIONS(1522),
    [anon_sym_RPAREN] = ACTIONS(1522),
    [sym__special_characters] = ACTIONS(2430),
    [anon_sym_DQUOTE] = ACTIONS(1522),
    [sym_raw_string] = ACTIONS(1522),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1522),
    [anon_sym_BQUOTE] = ACTIONS(1522),
    [anon_sym_LT_LPAREN] = ACTIONS(1522),
    [anon_sym_GT_LPAREN] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2430),
  },
  [1553] = {
    [aux_sym_concatenation_repeat1] = STATE(1553),
    [sym__concat] = ACTIONS(4064),
    [anon_sym_RPAREN] = ACTIONS(1522),
    [sym__special_characters] = ACTIONS(2430),
    [anon_sym_DQUOTE] = ACTIONS(1522),
    [sym_raw_string] = ACTIONS(1522),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1522),
    [anon_sym_BQUOTE] = ACTIONS(1522),
    [anon_sym_LT_LPAREN] = ACTIONS(1522),
    [anon_sym_GT_LPAREN] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2430),
  },
  [1554] = {
    [sym__concat] = ACTIONS(1553),
    [anon_sym_RPAREN] = ACTIONS(1553),
    [sym__special_characters] = ACTIONS(2435),
    [anon_sym_DQUOTE] = ACTIONS(1553),
    [sym_raw_string] = ACTIONS(1553),
    [anon_sym_DOLLAR] = ACTIONS(2435),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1553),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1553),
    [anon_sym_BQUOTE] = ACTIONS(1553),
    [anon_sym_LT_LPAREN] = ACTIONS(1553),
    [anon_sym_GT_LPAREN] = ACTIONS(1553),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2435),
  },
  [1555] = {
    [sym_concatenation] = STATE(1973),
    [sym_string] = STATE(1972),
    [sym_simple_expansion] = STATE(1972),
    [sym_expansion] = STATE(1972),
    [sym_command_substitution] = STATE(1972),
    [sym_process_substitution] = STATE(1972),
    [anon_sym_RBRACE] = ACTIONS(4067),
    [sym__special_characters] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(4071),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4073),
  },
  [1556] = {
    [sym__concat] = ACTIONS(1598),
    [anon_sym_RPAREN] = ACTIONS(1598),
    [sym__special_characters] = ACTIONS(2445),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [sym_raw_string] = ACTIONS(1598),
    [anon_sym_DOLLAR] = ACTIONS(2445),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1598),
    [anon_sym_BQUOTE] = ACTIONS(1598),
    [anon_sym_LT_LPAREN] = ACTIONS(1598),
    [anon_sym_GT_LPAREN] = ACTIONS(1598),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2445),
  },
  [1557] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4075),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1558] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(4077),
    [sym_comment] = ACTIONS(52),
  },
  [1559] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1977),
    [anon_sym_RBRACE] = ACTIONS(4079),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1560] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1979),
    [anon_sym_RBRACE] = ACTIONS(4081),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1561] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1980),
    [anon_sym_RBRACE] = ACTIONS(4067),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1562] = {
    [sym__concat] = ACTIONS(1642),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [sym__special_characters] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [sym_raw_string] = ACTIONS(1642),
    [anon_sym_DOLLAR] = ACTIONS(2455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [anon_sym_LT_LPAREN] = ACTIONS(1642),
    [anon_sym_GT_LPAREN] = ACTIONS(1642),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2455),
  },
  [1563] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4083),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1564] = {
    [sym__concat] = ACTIONS(1648),
    [anon_sym_RPAREN] = ACTIONS(1648),
    [sym__special_characters] = ACTIONS(2459),
    [anon_sym_DQUOTE] = ACTIONS(1648),
    [sym_raw_string] = ACTIONS(1648),
    [anon_sym_DOLLAR] = ACTIONS(2459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1648),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1648),
    [anon_sym_BQUOTE] = ACTIONS(1648),
    [anon_sym_LT_LPAREN] = ACTIONS(1648),
    [anon_sym_GT_LPAREN] = ACTIONS(1648),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2459),
  },
  [1565] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4067),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1566] = {
    [sym__concat] = ACTIONS(1762),
    [anon_sym_RPAREN] = ACTIONS(1762),
    [sym__special_characters] = ACTIONS(2461),
    [anon_sym_DQUOTE] = ACTIONS(1762),
    [sym_raw_string] = ACTIONS(1762),
    [anon_sym_DOLLAR] = ACTIONS(2461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1762),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1762),
    [anon_sym_BQUOTE] = ACTIONS(1762),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2461),
  },
  [1567] = {
    [sym__concat] = ACTIONS(1902),
    [anon_sym_RPAREN] = ACTIONS(1902),
    [sym__special_characters] = ACTIONS(2463),
    [anon_sym_DQUOTE] = ACTIONS(1902),
    [sym_raw_string] = ACTIONS(1902),
    [anon_sym_DOLLAR] = ACTIONS(2463),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1902),
    [anon_sym_BQUOTE] = ACTIONS(1902),
    [anon_sym_LT_LPAREN] = ACTIONS(1902),
    [anon_sym_GT_LPAREN] = ACTIONS(1902),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2463),
  },
  [1568] = {
    [sym_file_descriptor] = ACTIONS(2560),
    [sym__concat] = ACTIONS(2560),
    [sym_variable_name] = ACTIONS(2560),
    [anon_sym_PIPE] = ACTIONS(2562),
    [anon_sym_SEMI_SEMI] = ACTIONS(2562),
    [anon_sym_PIPE_AMP] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_PIPE_PIPE] = ACTIONS(2562),
    [anon_sym_LT] = ACTIONS(2562),
    [anon_sym_GT] = ACTIONS(2562),
    [anon_sym_GT_GT] = ACTIONS(2562),
    [anon_sym_AMP_GT] = ACTIONS(2562),
    [anon_sym_AMP_GT_GT] = ACTIONS(2562),
    [anon_sym_LT_AMP] = ACTIONS(2562),
    [anon_sym_GT_AMP] = ACTIONS(2562),
    [sym__special_characters] = ACTIONS(2562),
    [anon_sym_DQUOTE] = ACTIONS(2562),
    [sym_raw_string] = ACTIONS(2562),
    [anon_sym_DOLLAR] = ACTIONS(2562),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2562),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2562),
    [anon_sym_BQUOTE] = ACTIONS(2562),
    [anon_sym_LT_LPAREN] = ACTIONS(2562),
    [anon_sym_GT_LPAREN] = ACTIONS(2562),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2562),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym_LF] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(2562),
  },
  [1569] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4085),
    [sym_comment] = ACTIONS(52),
  },
  [1570] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4087),
    [sym_comment] = ACTIONS(52),
  },
  [1571] = {
    [anon_sym_RBRACE] = ACTIONS(4087),
    [sym_comment] = ACTIONS(52),
  },
  [1572] = {
    [sym_file_descriptor] = ACTIONS(2614),
    [sym__concat] = ACTIONS(2614),
    [sym_variable_name] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2616),
    [anon_sym_SEMI_SEMI] = ACTIONS(2616),
    [anon_sym_PIPE_AMP] = ACTIONS(2616),
    [anon_sym_AMP_AMP] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2616),
    [anon_sym_LT] = ACTIONS(2616),
    [anon_sym_GT] = ACTIONS(2616),
    [anon_sym_GT_GT] = ACTIONS(2616),
    [anon_sym_AMP_GT] = ACTIONS(2616),
    [anon_sym_AMP_GT_GT] = ACTIONS(2616),
    [anon_sym_LT_AMP] = ACTIONS(2616),
    [anon_sym_GT_AMP] = ACTIONS(2616),
    [sym__special_characters] = ACTIONS(2616),
    [anon_sym_DQUOTE] = ACTIONS(2616),
    [sym_raw_string] = ACTIONS(2616),
    [anon_sym_DOLLAR] = ACTIONS(2616),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2616),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2616),
    [anon_sym_BQUOTE] = ACTIONS(2616),
    [anon_sym_LT_LPAREN] = ACTIONS(2616),
    [anon_sym_GT_LPAREN] = ACTIONS(2616),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2616),
    [anon_sym_LF] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2616),
  },
  [1573] = {
    [sym_concatenation] = STATE(1986),
    [sym_string] = STATE(1985),
    [sym_simple_expansion] = STATE(1985),
    [sym_expansion] = STATE(1985),
    [sym_command_substitution] = STATE(1985),
    [sym_process_substitution] = STATE(1985),
    [anon_sym_RBRACE] = ACTIONS(4087),
    [sym__special_characters] = ACTIONS(4089),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(4091),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4093),
  },
  [1574] = {
    [sym_file_descriptor] = ACTIONS(2659),
    [sym__concat] = ACTIONS(2659),
    [sym_variable_name] = ACTIONS(2659),
    [anon_sym_PIPE] = ACTIONS(2661),
    [anon_sym_SEMI_SEMI] = ACTIONS(2661),
    [anon_sym_PIPE_AMP] = ACTIONS(2661),
    [anon_sym_AMP_AMP] = ACTIONS(2661),
    [anon_sym_PIPE_PIPE] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(2661),
    [anon_sym_GT] = ACTIONS(2661),
    [anon_sym_GT_GT] = ACTIONS(2661),
    [anon_sym_AMP_GT] = ACTIONS(2661),
    [anon_sym_AMP_GT_GT] = ACTIONS(2661),
    [anon_sym_LT_AMP] = ACTIONS(2661),
    [anon_sym_GT_AMP] = ACTIONS(2661),
    [sym__special_characters] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2661),
    [sym_raw_string] = ACTIONS(2661),
    [anon_sym_DOLLAR] = ACTIONS(2661),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2661),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2661),
    [anon_sym_BQUOTE] = ACTIONS(2661),
    [anon_sym_LT_LPAREN] = ACTIONS(2661),
    [anon_sym_GT_LPAREN] = ACTIONS(2661),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2661),
    [anon_sym_SEMI] = ACTIONS(2661),
    [anon_sym_LF] = ACTIONS(2661),
    [anon_sym_AMP] = ACTIONS(2661),
  },
  [1575] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4095),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1576] = {
    [sym_file_descriptor] = ACTIONS(2665),
    [sym__concat] = ACTIONS(2665),
    [sym_variable_name] = ACTIONS(2665),
    [anon_sym_PIPE] = ACTIONS(2667),
    [anon_sym_SEMI_SEMI] = ACTIONS(2667),
    [anon_sym_PIPE_AMP] = ACTIONS(2667),
    [anon_sym_AMP_AMP] = ACTIONS(2667),
    [anon_sym_PIPE_PIPE] = ACTIONS(2667),
    [anon_sym_LT] = ACTIONS(2667),
    [anon_sym_GT] = ACTIONS(2667),
    [anon_sym_GT_GT] = ACTIONS(2667),
    [anon_sym_AMP_GT] = ACTIONS(2667),
    [anon_sym_AMP_GT_GT] = ACTIONS(2667),
    [anon_sym_LT_AMP] = ACTIONS(2667),
    [anon_sym_GT_AMP] = ACTIONS(2667),
    [sym__special_characters] = ACTIONS(2667),
    [anon_sym_DQUOTE] = ACTIONS(2667),
    [sym_raw_string] = ACTIONS(2667),
    [anon_sym_DOLLAR] = ACTIONS(2667),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2667),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2667),
    [anon_sym_BQUOTE] = ACTIONS(2667),
    [anon_sym_LT_LPAREN] = ACTIONS(2667),
    [anon_sym_GT_LPAREN] = ACTIONS(2667),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2667),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym_LF] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(2667),
  },
  [1577] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4097),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1578] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4087),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1579] = {
    [sym_file_descriptor] = ACTIONS(2671),
    [sym__concat] = ACTIONS(2671),
    [sym_variable_name] = ACTIONS(2671),
    [anon_sym_PIPE] = ACTIONS(2673),
    [anon_sym_SEMI_SEMI] = ACTIONS(2673),
    [anon_sym_PIPE_AMP] = ACTIONS(2673),
    [anon_sym_AMP_AMP] = ACTIONS(2673),
    [anon_sym_PIPE_PIPE] = ACTIONS(2673),
    [anon_sym_LT] = ACTIONS(2673),
    [anon_sym_GT] = ACTIONS(2673),
    [anon_sym_GT_GT] = ACTIONS(2673),
    [anon_sym_AMP_GT] = ACTIONS(2673),
    [anon_sym_AMP_GT_GT] = ACTIONS(2673),
    [anon_sym_LT_AMP] = ACTIONS(2673),
    [anon_sym_GT_AMP] = ACTIONS(2673),
    [sym__special_characters] = ACTIONS(2673),
    [anon_sym_DQUOTE] = ACTIONS(2673),
    [sym_raw_string] = ACTIONS(2673),
    [anon_sym_DOLLAR] = ACTIONS(2673),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2673),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2673),
    [anon_sym_BQUOTE] = ACTIONS(2673),
    [anon_sym_LT_LPAREN] = ACTIONS(2673),
    [anon_sym_GT_LPAREN] = ACTIONS(2673),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2673),
    [anon_sym_SEMI] = ACTIONS(2673),
    [anon_sym_LF] = ACTIONS(2673),
    [anon_sym_AMP] = ACTIONS(2673),
  },
  [1580] = {
    [sym__concat] = ACTIONS(1522),
    [anon_sym_SEMI_SEMI] = ACTIONS(1524),
    [sym__special_characters] = ACTIONS(1524),
    [anon_sym_DQUOTE] = ACTIONS(1524),
    [sym_raw_string] = ACTIONS(1524),
    [anon_sym_DOLLAR] = ACTIONS(1524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1524),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1524),
    [anon_sym_BQUOTE] = ACTIONS(1524),
    [anon_sym_LT_LPAREN] = ACTIONS(1524),
    [anon_sym_GT_LPAREN] = ACTIONS(1524),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1524),
    [anon_sym_SEMI] = ACTIONS(1524),
    [anon_sym_LF] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1524),
  },
  [1581] = {
    [aux_sym_concatenation_repeat1] = STATE(1581),
    [sym__concat] = ACTIONS(4099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1524),
    [sym__special_characters] = ACTIONS(1524),
    [anon_sym_DQUOTE] = ACTIONS(1524),
    [sym_raw_string] = ACTIONS(1524),
    [anon_sym_DOLLAR] = ACTIONS(1524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1524),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1524),
    [anon_sym_BQUOTE] = ACTIONS(1524),
    [anon_sym_LT_LPAREN] = ACTIONS(1524),
    [anon_sym_GT_LPAREN] = ACTIONS(1524),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1524),
    [anon_sym_SEMI] = ACTIONS(1524),
    [anon_sym_LF] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1524),
  },
  [1582] = {
    [sym__concat] = ACTIONS(1553),
    [anon_sym_SEMI_SEMI] = ACTIONS(1555),
    [sym__special_characters] = ACTIONS(1555),
    [anon_sym_DQUOTE] = ACTIONS(1555),
    [sym_raw_string] = ACTIONS(1555),
    [anon_sym_DOLLAR] = ACTIONS(1555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1555),
    [anon_sym_BQUOTE] = ACTIONS(1555),
    [anon_sym_LT_LPAREN] = ACTIONS(1555),
    [anon_sym_GT_LPAREN] = ACTIONS(1555),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1555),
    [anon_sym_SEMI] = ACTIONS(1555),
    [anon_sym_LF] = ACTIONS(1555),
    [anon_sym_AMP] = ACTIONS(1555),
  },
  [1583] = {
    [sym_concatenation] = STATE(1992),
    [sym_string] = STATE(1991),
    [sym_simple_expansion] = STATE(1991),
    [sym_expansion] = STATE(1991),
    [sym_command_substitution] = STATE(1991),
    [sym_process_substitution] = STATE(1991),
    [anon_sym_RBRACE] = ACTIONS(4102),
    [sym__special_characters] = ACTIONS(4104),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(4106),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4108),
  },
  [1584] = {
    [sym__concat] = ACTIONS(1598),
    [anon_sym_SEMI_SEMI] = ACTIONS(1600),
    [sym__special_characters] = ACTIONS(1600),
    [anon_sym_DQUOTE] = ACTIONS(1600),
    [sym_raw_string] = ACTIONS(1600),
    [anon_sym_DOLLAR] = ACTIONS(1600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1600),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1600),
    [anon_sym_BQUOTE] = ACTIONS(1600),
    [anon_sym_LT_LPAREN] = ACTIONS(1600),
    [anon_sym_GT_LPAREN] = ACTIONS(1600),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1600),
    [anon_sym_SEMI] = ACTIONS(1600),
    [anon_sym_LF] = ACTIONS(1600),
    [anon_sym_AMP] = ACTIONS(1600),
  },
  [1585] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4110),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1586] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(4112),
    [sym_comment] = ACTIONS(52),
  },
  [1587] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1996),
    [anon_sym_RBRACE] = ACTIONS(4114),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1588] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1998),
    [anon_sym_RBRACE] = ACTIONS(4116),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1589] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(1999),
    [anon_sym_RBRACE] = ACTIONS(4102),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1590] = {
    [sym__concat] = ACTIONS(1642),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1644),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1644),
    [anon_sym_BQUOTE] = ACTIONS(1644),
    [anon_sym_LT_LPAREN] = ACTIONS(1644),
    [anon_sym_GT_LPAREN] = ACTIONS(1644),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [1591] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4118),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1592] = {
    [sym__concat] = ACTIONS(1648),
    [anon_sym_SEMI_SEMI] = ACTIONS(1650),
    [sym__special_characters] = ACTIONS(1650),
    [anon_sym_DQUOTE] = ACTIONS(1650),
    [sym_raw_string] = ACTIONS(1650),
    [anon_sym_DOLLAR] = ACTIONS(1650),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1650),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1650),
    [anon_sym_BQUOTE] = ACTIONS(1650),
    [anon_sym_LT_LPAREN] = ACTIONS(1650),
    [anon_sym_GT_LPAREN] = ACTIONS(1650),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(1650),
    [anon_sym_LF] = ACTIONS(1650),
    [anon_sym_AMP] = ACTIONS(1650),
  },
  [1593] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4102),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1594] = {
    [sym__concat] = ACTIONS(1762),
    [anon_sym_SEMI_SEMI] = ACTIONS(1764),
    [sym__special_characters] = ACTIONS(1764),
    [anon_sym_DQUOTE] = ACTIONS(1764),
    [sym_raw_string] = ACTIONS(1764),
    [anon_sym_DOLLAR] = ACTIONS(1764),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1764),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1764),
    [anon_sym_BQUOTE] = ACTIONS(1764),
    [anon_sym_LT_LPAREN] = ACTIONS(1764),
    [anon_sym_GT_LPAREN] = ACTIONS(1764),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1764),
    [anon_sym_SEMI] = ACTIONS(1764),
    [anon_sym_LF] = ACTIONS(1764),
    [anon_sym_AMP] = ACTIONS(1764),
  },
  [1595] = {
    [sym__concat] = ACTIONS(1902),
    [anon_sym_SEMI_SEMI] = ACTIONS(1904),
    [sym__special_characters] = ACTIONS(1904),
    [anon_sym_DQUOTE] = ACTIONS(1904),
    [sym_raw_string] = ACTIONS(1904),
    [anon_sym_DOLLAR] = ACTIONS(1904),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1904),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1904),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [anon_sym_LT_LPAREN] = ACTIONS(1904),
    [anon_sym_GT_LPAREN] = ACTIONS(1904),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1904),
    [anon_sym_SEMI] = ACTIONS(1904),
    [anon_sym_LF] = ACTIONS(1904),
    [anon_sym_AMP] = ACTIONS(1904),
  },
  [1596] = {
    [sym__terminated_statement] = STATE(603),
    [sym_for_statement] = STATE(604),
    [sym_while_statement] = STATE(604),
    [sym_if_statement] = STATE(604),
    [sym_case_statement] = STATE(604),
    [sym_function_definition] = STATE(604),
    [sym_subshell] = STATE(604),
    [sym_pipeline] = STATE(604),
    [sym_list] = STATE(604),
    [sym_bracket_command] = STATE(604),
    [sym_command] = STATE(604),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(605),
    [sym_declaration_command] = STATE(604),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(2002),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_done] = ACTIONS(4120),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [1597] = {
    [anon_sym_PIPE] = ACTIONS(4122),
    [anon_sym_RPAREN] = ACTIONS(4122),
    [anon_sym_SEMI_SEMI] = ACTIONS(4122),
    [anon_sym_PIPE_AMP] = ACTIONS(4122),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(4122),
    [anon_sym_LF] = ACTIONS(4122),
    [anon_sym_AMP] = ACTIONS(4122),
  },
  [1598] = {
    [sym__terminated_statement] = STATE(611),
    [sym_for_statement] = STATE(612),
    [sym_while_statement] = STATE(612),
    [sym_if_statement] = STATE(612),
    [sym_case_statement] = STATE(612),
    [sym_function_definition] = STATE(612),
    [sym_subshell] = STATE(612),
    [sym_pipeline] = STATE(612),
    [sym_list] = STATE(612),
    [sym_bracket_command] = STATE(612),
    [sym_command] = STATE(612),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(615),
    [sym_declaration_command] = STATE(612),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(2003),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_fi] = ACTIONS(4124),
    [anon_sym_elif] = ACTIONS(4124),
    [anon_sym_else] = ACTIONS(4124),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [1599] = {
    [sym_file_descriptor] = ACTIONS(902),
    [sym_variable_name] = ACTIONS(902),
    [anon_sym_for] = ACTIONS(904),
    [anon_sym_while] = ACTIONS(904),
    [anon_sym_if] = ACTIONS(904),
    [anon_sym_fi] = ACTIONS(904),
    [anon_sym_case] = ACTIONS(904),
    [anon_sym_function] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(902),
    [anon_sym_LBRACK] = ACTIONS(904),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym_declare] = ACTIONS(904),
    [anon_sym_typeset] = ACTIONS(904),
    [anon_sym_export] = ACTIONS(904),
    [anon_sym_readonly] = ACTIONS(904),
    [anon_sym_local] = ACTIONS(904),
    [anon_sym_LT] = ACTIONS(904),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_GT_GT] = ACTIONS(902),
    [anon_sym_AMP_GT] = ACTIONS(904),
    [anon_sym_AMP_GT_GT] = ACTIONS(902),
    [anon_sym_LT_AMP] = ACTIONS(902),
    [anon_sym_GT_AMP] = ACTIONS(902),
    [sym__special_characters] = ACTIONS(906),
    [anon_sym_DQUOTE] = ACTIONS(902),
    [sym_raw_string] = ACTIONS(902),
    [anon_sym_DOLLAR] = ACTIONS(904),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(902),
    [anon_sym_BQUOTE] = ACTIONS(902),
    [anon_sym_LT_LPAREN] = ACTIONS(902),
    [anon_sym_GT_LPAREN] = ACTIONS(902),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(906),
  },
  [1600] = {
    [sym__terminated_statement] = STATE(1101),
    [sym_for_statement] = STATE(1102),
    [sym_while_statement] = STATE(1102),
    [sym_if_statement] = STATE(1102),
    [sym_case_statement] = STATE(1102),
    [sym_function_definition] = STATE(1102),
    [sym_subshell] = STATE(1102),
    [sym_pipeline] = STATE(1102),
    [sym_list] = STATE(1102),
    [sym_bracket_command] = STATE(1102),
    [sym_command] = STATE(1102),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(1103),
    [sym_declaration_command] = STATE(1102),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(1600),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(946),
    [sym_variable_name] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(954),
    [anon_sym_while] = ACTIONS(957),
    [anon_sym_if] = ACTIONS(960),
    [anon_sym_fi] = ACTIONS(3335),
    [anon_sym_case] = ACTIONS(963),
    [anon_sym_function] = ACTIONS(966),
    [anon_sym_LPAREN] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_typeset] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_local] = ACTIONS(978),
    [anon_sym_LT] = ACTIONS(981),
    [anon_sym_GT] = ACTIONS(981),
    [anon_sym_GT_GT] = ACTIONS(984),
    [anon_sym_AMP_GT] = ACTIONS(981),
    [anon_sym_AMP_GT_GT] = ACTIONS(984),
    [anon_sym_LT_AMP] = ACTIONS(984),
    [anon_sym_GT_AMP] = ACTIONS(984),
    [sym__special_characters] = ACTIONS(987),
    [anon_sym_DQUOTE] = ACTIONS(990),
    [sym_raw_string] = ACTIONS(993),
    [anon_sym_DOLLAR] = ACTIONS(996),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(999),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1002),
    [anon_sym_BQUOTE] = ACTIONS(1005),
    [anon_sym_LT_LPAREN] = ACTIONS(1008),
    [anon_sym_GT_LPAREN] = ACTIONS(1008),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1011),
  },
  [1601] = {
    [anon_sym_PIPE] = ACTIONS(4126),
    [anon_sym_RPAREN] = ACTIONS(4126),
    [anon_sym_SEMI_SEMI] = ACTIONS(4126),
    [anon_sym_PIPE_AMP] = ACTIONS(4126),
    [anon_sym_AMP_AMP] = ACTIONS(4126),
    [anon_sym_PIPE_PIPE] = ACTIONS(4126),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(4126),
    [anon_sym_LF] = ACTIONS(4126),
    [anon_sym_AMP] = ACTIONS(4126),
  },
  [1602] = {
    [anon_sym_fi] = ACTIONS(4128),
    [sym_comment] = ACTIONS(52),
  },
  [1603] = {
    [sym_string] = STATE(2005),
    [sym_simple_expansion] = STATE(2005),
    [sym_expansion] = STATE(2005),
    [sym_command_substitution] = STATE(2005),
    [sym_process_substitution] = STATE(2005),
    [sym__special_characters] = ACTIONS(4130),
    [anon_sym_DQUOTE] = ACTIONS(2176),
    [sym_raw_string] = ACTIONS(4132),
    [anon_sym_DOLLAR] = ACTIONS(2180),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2182),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2184),
    [anon_sym_BQUOTE] = ACTIONS(2186),
    [anon_sym_LT_LPAREN] = ACTIONS(2188),
    [anon_sym_GT_LPAREN] = ACTIONS(2188),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4130),
  },
  [1604] = {
    [sym_concatenation] = STATE(2008),
    [sym_string] = STATE(2007),
    [sym_simple_expansion] = STATE(2007),
    [sym_expansion] = STATE(2007),
    [sym_command_substitution] = STATE(2007),
    [sym_process_substitution] = STATE(2007),
    [sym__special_characters] = ACTIONS(4134),
    [anon_sym_DQUOTE] = ACTIONS(2176),
    [sym_raw_string] = ACTIONS(4136),
    [anon_sym_DOLLAR] = ACTIONS(2180),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2182),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2184),
    [anon_sym_BQUOTE] = ACTIONS(2186),
    [anon_sym_LT_LPAREN] = ACTIONS(2188),
    [anon_sym_GT_LPAREN] = ACTIONS(2188),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4138),
  },
  [1605] = {
    [sym__terminated_statement] = STATE(2010),
    [sym_for_statement] = STATE(2011),
    [sym_while_statement] = STATE(2011),
    [sym_if_statement] = STATE(2011),
    [sym_case_statement] = STATE(2011),
    [sym_function_definition] = STATE(2011),
    [sym_subshell] = STATE(2011),
    [sym_pipeline] = STATE(2011),
    [sym_list] = STATE(2011),
    [sym_bracket_command] = STATE(2011),
    [sym_command] = STATE(2011),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(2012),
    [sym_declaration_command] = STATE(2011),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(2013),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_esac] = ACTIONS(4140),
    [anon_sym_SEMI_SEMI] = ACTIONS(4142),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [1606] = {
    [aux_sym_case_item_repeat1] = STATE(2015),
    [anon_sym_PIPE] = ACTIONS(3356),
    [anon_sym_RPAREN] = ACTIONS(4144),
    [sym_comment] = ACTIONS(52),
  },
  [1607] = {
    [aux_sym_concatenation_repeat1] = STATE(2016),
    [sym__concat] = ACTIONS(3354),
    [anon_sym_PIPE] = ACTIONS(646),
    [anon_sym_RPAREN] = ACTIONS(646),
    [sym_comment] = ACTIONS(52),
  },
  [1608] = {
    [sym__concat] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym_comment] = ACTIONS(52),
  },
  [1609] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(4146),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [1610] = {
    [sym__terminated_statement] = STATE(2010),
    [sym_for_statement] = STATE(2011),
    [sym_while_statement] = STATE(2011),
    [sym_if_statement] = STATE(2011),
    [sym_case_statement] = STATE(2011),
    [sym_function_definition] = STATE(2011),
    [sym_subshell] = STATE(2011),
    [sym_pipeline] = STATE(2011),
    [sym_list] = STATE(2011),
    [sym_bracket_command] = STATE(2011),
    [sym_command] = STATE(2011),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(2012),
    [sym_declaration_command] = STATE(2011),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(2019),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_esac] = ACTIONS(4148),
    [anon_sym_SEMI_SEMI] = ACTIONS(4150),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [1611] = {
    [aux_sym_case_item_repeat1] = STATE(2015),
    [anon_sym_PIPE] = ACTIONS(3356),
    [anon_sym_RPAREN] = ACTIONS(4152),
    [sym_comment] = ACTIONS(52),
  },
  [1612] = {
    [sym__concat] = ACTIONS(680),
    [anon_sym_PIPE] = ACTIONS(680),
    [anon_sym_RPAREN] = ACTIONS(680),
    [sym_comment] = ACTIONS(52),
  },
  [1613] = {
    [sym__concat] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(684),
    [anon_sym_RPAREN] = ACTIONS(684),
    [sym_comment] = ACTIONS(52),
  },
  [1614] = {
    [sym__concat] = ACTIONS(688),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(688),
    [sym_comment] = ACTIONS(52),
  },
  [1615] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(4154),
    [sym_comment] = ACTIONS(52),
  },
  [1616] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2023),
    [anon_sym_RBRACE] = ACTIONS(4156),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1617] = {
    [sym_subscript] = STATE(2027),
    [sym_variable_name] = ACTIONS(4158),
    [anon_sym_DOLLAR] = ACTIONS(4160),
    [anon_sym_DASH] = ACTIONS(4160),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4162),
    [anon_sym_STAR] = ACTIONS(4160),
    [anon_sym_AT] = ACTIONS(4160),
    [anon_sym_QMARK] = ACTIONS(4160),
    [anon_sym_0] = ACTIONS(4164),
    [anon_sym__] = ACTIONS(4164),
  },
  [1618] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2029),
    [anon_sym_RBRACE] = ACTIONS(4166),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1619] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2031),
    [anon_sym_RBRACE] = ACTIONS(4168),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1620] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(4170),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [1621] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(4170),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1622] = {
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(4170),
    [sym_comment] = ACTIONS(52),
  },
  [1623] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(4170),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1624] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(4172),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [1625] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(4172),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1626] = {
    [anon_sym_PIPE] = ACTIONS(4174),
    [anon_sym_RPAREN] = ACTIONS(4174),
    [anon_sym_SEMI_SEMI] = ACTIONS(4174),
    [anon_sym_PIPE_AMP] = ACTIONS(4174),
    [anon_sym_AMP_AMP] = ACTIONS(4174),
    [anon_sym_PIPE_PIPE] = ACTIONS(4174),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(4174),
    [anon_sym_LF] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(4174),
  },
  [1627] = {
    [anon_sym_esac] = ACTIONS(4176),
    [sym_comment] = ACTIONS(52),
  },
  [1628] = {
    [sym_case_item] = STATE(1120),
    [sym_concatenation] = STATE(2037),
    [sym_string] = STATE(2036),
    [sym_simple_expansion] = STATE(2036),
    [sym_expansion] = STATE(2036),
    [sym_command_substitution] = STATE(2036),
    [sym_process_substitution] = STATE(2036),
    [aux_sym_case_statement_repeat1] = STATE(1628),
    [sym__special_characters] = ACTIONS(4178),
    [anon_sym_DQUOTE] = ACTIONS(4181),
    [sym_raw_string] = ACTIONS(4184),
    [anon_sym_DOLLAR] = ACTIONS(4187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4190),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4193),
    [anon_sym_BQUOTE] = ACTIONS(4196),
    [anon_sym_LT_LPAREN] = ACTIONS(4199),
    [anon_sym_GT_LPAREN] = ACTIONS(4199),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4202),
  },
  [1629] = {
    [anon_sym_PIPE] = ACTIONS(4205),
    [anon_sym_RPAREN] = ACTIONS(4205),
    [anon_sym_SEMI_SEMI] = ACTIONS(4205),
    [anon_sym_PIPE_AMP] = ACTIONS(4205),
    [anon_sym_AMP_AMP] = ACTIONS(4205),
    [anon_sym_PIPE_PIPE] = ACTIONS(4205),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(4205),
    [anon_sym_LF] = ACTIONS(4205),
    [anon_sym_AMP] = ACTIONS(4205),
  },
  [1630] = {
    [sym_case_item] = STATE(1120),
    [sym_last_case_item] = STATE(2038),
    [sym_concatenation] = STATE(1122),
    [sym_string] = STATE(1114),
    [sym_simple_expansion] = STATE(1114),
    [sym_expansion] = STATE(1114),
    [sym_command_substitution] = STATE(1114),
    [sym_process_substitution] = STATE(1114),
    [aux_sym_case_statement_repeat1] = STATE(1628),
    [sym__special_characters] = ACTIONS(2174),
    [anon_sym_DQUOTE] = ACTIONS(2176),
    [sym_raw_string] = ACTIONS(2178),
    [anon_sym_DOLLAR] = ACTIONS(2180),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2182),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2184),
    [anon_sym_BQUOTE] = ACTIONS(2186),
    [anon_sym_LT_LPAREN] = ACTIONS(2188),
    [anon_sym_GT_LPAREN] = ACTIONS(2188),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3386),
  },
  [1631] = {
    [anon_sym_PIPE] = ACTIONS(4207),
    [anon_sym_RPAREN] = ACTIONS(4207),
    [anon_sym_SEMI_SEMI] = ACTIONS(4207),
    [anon_sym_PIPE_AMP] = ACTIONS(4207),
    [anon_sym_AMP_AMP] = ACTIONS(4207),
    [anon_sym_PIPE_PIPE] = ACTIONS(4207),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(4207),
    [anon_sym_LF] = ACTIONS(4207),
    [anon_sym_AMP] = ACTIONS(4207),
  },
  [1632] = {
    [anon_sym_esac] = ACTIONS(4209),
    [sym_comment] = ACTIONS(52),
  },
  [1633] = {
    [anon_sym_PIPE] = ACTIONS(4211),
    [anon_sym_RPAREN] = ACTIONS(4211),
    [anon_sym_SEMI_SEMI] = ACTIONS(4211),
    [anon_sym_PIPE_AMP] = ACTIONS(4211),
    [anon_sym_AMP_AMP] = ACTIONS(4211),
    [anon_sym_PIPE_PIPE] = ACTIONS(4211),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_LF] = ACTIONS(4211),
    [anon_sym_AMP] = ACTIONS(4211),
  },
  [1634] = {
    [sym_case_item] = STATE(1120),
    [sym_last_case_item] = STATE(2040),
    [sym_concatenation] = STATE(1122),
    [sym_string] = STATE(1114),
    [sym_simple_expansion] = STATE(1114),
    [sym_expansion] = STATE(1114),
    [sym_command_substitution] = STATE(1114),
    [sym_process_substitution] = STATE(1114),
    [aux_sym_case_statement_repeat1] = STATE(1628),
    [sym__special_characters] = ACTIONS(2174),
    [anon_sym_DQUOTE] = ACTIONS(2176),
    [sym_raw_string] = ACTIONS(2178),
    [anon_sym_DOLLAR] = ACTIONS(2180),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2182),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2184),
    [anon_sym_BQUOTE] = ACTIONS(2186),
    [anon_sym_LT_LPAREN] = ACTIONS(2188),
    [anon_sym_GT_LPAREN] = ACTIONS(2188),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3386),
  },
  [1635] = {
    [sym__concat] = ACTIONS(3657),
    [anon_sym_in] = ACTIONS(3659),
    [anon_sym_SEMI_SEMI] = ACTIONS(3659),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3659),
    [anon_sym_LF] = ACTIONS(3659),
    [anon_sym_AMP] = ACTIONS(3659),
  },
  [1636] = {
    [sym__concat] = ACTIONS(3663),
    [anon_sym_in] = ACTIONS(3665),
    [anon_sym_SEMI_SEMI] = ACTIONS(3665),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3665),
    [anon_sym_LF] = ACTIONS(3665),
    [anon_sym_AMP] = ACTIONS(3665),
  },
  [1637] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4213),
    [sym_comment] = ACTIONS(52),
  },
  [1638] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4215),
    [sym_comment] = ACTIONS(52),
  },
  [1639] = {
    [anon_sym_RBRACE] = ACTIONS(4215),
    [sym_comment] = ACTIONS(52),
  },
  [1640] = {
    [sym__concat] = ACTIONS(3712),
    [anon_sym_in] = ACTIONS(3714),
    [anon_sym_SEMI_SEMI] = ACTIONS(3714),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3714),
    [anon_sym_LF] = ACTIONS(3714),
    [anon_sym_AMP] = ACTIONS(3714),
  },
  [1641] = {
    [sym__concat] = ACTIONS(3716),
    [anon_sym_in] = ACTIONS(3718),
    [anon_sym_SEMI_SEMI] = ACTIONS(3718),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3718),
    [anon_sym_LF] = ACTIONS(3718),
    [anon_sym_AMP] = ACTIONS(3718),
  },
  [1642] = {
    [anon_sym_PIPE] = ACTIONS(4217),
    [anon_sym_RPAREN] = ACTIONS(4217),
    [anon_sym_SEMI_SEMI] = ACTIONS(4217),
    [anon_sym_PIPE_AMP] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4217),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(4217),
    [anon_sym_LF] = ACTIONS(4217),
    [anon_sym_AMP] = ACTIONS(4217),
  },
  [1643] = {
    [aux_sym_concatenation_repeat1] = STATE(1647),
    [sym__concat] = ACTIONS(3422),
    [anon_sym_PIPE] = ACTIONS(3112),
    [anon_sym_SEMI_SEMI] = ACTIONS(3112),
    [anon_sym_PIPE_AMP] = ACTIONS(3112),
    [anon_sym_AMP_AMP] = ACTIONS(3112),
    [anon_sym_PIPE_PIPE] = ACTIONS(3112),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3112),
    [anon_sym_LF] = ACTIONS(3112),
    [anon_sym_AMP] = ACTIONS(3112),
  },
  [1644] = {
    [aux_sym_concatenation_repeat1] = STATE(1647),
    [sym__concat] = ACTIONS(3422),
    [anon_sym_PIPE] = ACTIONS(3114),
    [anon_sym_SEMI_SEMI] = ACTIONS(3114),
    [anon_sym_PIPE_AMP] = ACTIONS(3114),
    [anon_sym_AMP_AMP] = ACTIONS(3114),
    [anon_sym_PIPE_PIPE] = ACTIONS(3114),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3114),
    [anon_sym_LF] = ACTIONS(3114),
    [anon_sym_AMP] = ACTIONS(3114),
  },
  [1645] = {
    [anon_sym_PIPE] = ACTIONS(3114),
    [anon_sym_RPAREN] = ACTIONS(3114),
    [anon_sym_SEMI_SEMI] = ACTIONS(3114),
    [anon_sym_PIPE_AMP] = ACTIONS(3114),
    [anon_sym_AMP_AMP] = ACTIONS(3114),
    [anon_sym_PIPE_PIPE] = ACTIONS(3114),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3114),
    [anon_sym_LF] = ACTIONS(3114),
    [anon_sym_AMP] = ACTIONS(3114),
  },
  [1646] = {
    [sym_string] = STATE(2043),
    [sym_simple_expansion] = STATE(2043),
    [sym_expansion] = STATE(2043),
    [sym_command_substitution] = STATE(2043),
    [sym_process_substitution] = STATE(2043),
    [sym__special_characters] = ACTIONS(4219),
    [anon_sym_DQUOTE] = ACTIONS(2233),
    [sym_raw_string] = ACTIONS(4221),
    [anon_sym_DOLLAR] = ACTIONS(2237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2239),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2241),
    [anon_sym_BQUOTE] = ACTIONS(2243),
    [anon_sym_LT_LPAREN] = ACTIONS(2245),
    [anon_sym_GT_LPAREN] = ACTIONS(2245),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4219),
  },
  [1647] = {
    [aux_sym_concatenation_repeat1] = STATE(2044),
    [sym__concat] = ACTIONS(3422),
    [anon_sym_PIPE] = ACTIONS(648),
    [anon_sym_SEMI_SEMI] = ACTIONS(648),
    [anon_sym_PIPE_AMP] = ACTIONS(648),
    [anon_sym_AMP_AMP] = ACTIONS(648),
    [anon_sym_PIPE_PIPE] = ACTIONS(648),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(648),
    [anon_sym_LF] = ACTIONS(648),
    [anon_sym_AMP] = ACTIONS(648),
  },
  [1648] = {
    [sym__concat] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(652),
    [anon_sym_SEMI_SEMI] = ACTIONS(652),
    [anon_sym_PIPE_AMP] = ACTIONS(652),
    [anon_sym_AMP_AMP] = ACTIONS(652),
    [anon_sym_PIPE_PIPE] = ACTIONS(652),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(652),
    [anon_sym_LF] = ACTIONS(652),
    [anon_sym_AMP] = ACTIONS(652),
  },
  [1649] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(4223),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [1650] = {
    [sym__concat] = ACTIONS(680),
    [anon_sym_PIPE] = ACTIONS(682),
    [anon_sym_SEMI_SEMI] = ACTIONS(682),
    [anon_sym_PIPE_AMP] = ACTIONS(682),
    [anon_sym_AMP_AMP] = ACTIONS(682),
    [anon_sym_PIPE_PIPE] = ACTIONS(682),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(682),
    [anon_sym_LF] = ACTIONS(682),
    [anon_sym_AMP] = ACTIONS(682),
  },
  [1651] = {
    [sym__concat] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(686),
    [anon_sym_SEMI_SEMI] = ACTIONS(686),
    [anon_sym_PIPE_AMP] = ACTIONS(686),
    [anon_sym_AMP_AMP] = ACTIONS(686),
    [anon_sym_PIPE_PIPE] = ACTIONS(686),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(686),
    [anon_sym_LF] = ACTIONS(686),
    [anon_sym_AMP] = ACTIONS(686),
  },
  [1652] = {
    [sym__concat] = ACTIONS(688),
    [anon_sym_PIPE] = ACTIONS(690),
    [anon_sym_SEMI_SEMI] = ACTIONS(690),
    [anon_sym_PIPE_AMP] = ACTIONS(690),
    [anon_sym_AMP_AMP] = ACTIONS(690),
    [anon_sym_PIPE_PIPE] = ACTIONS(690),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(690),
    [anon_sym_LF] = ACTIONS(690),
    [anon_sym_AMP] = ACTIONS(690),
  },
  [1653] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(4225),
    [sym_comment] = ACTIONS(52),
  },
  [1654] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2048),
    [anon_sym_RBRACE] = ACTIONS(4227),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1655] = {
    [sym_subscript] = STATE(2052),
    [sym_variable_name] = ACTIONS(4229),
    [anon_sym_DOLLAR] = ACTIONS(4231),
    [anon_sym_DASH] = ACTIONS(4231),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4233),
    [anon_sym_STAR] = ACTIONS(4231),
    [anon_sym_AT] = ACTIONS(4231),
    [anon_sym_QMARK] = ACTIONS(4231),
    [anon_sym_0] = ACTIONS(4235),
    [anon_sym__] = ACTIONS(4235),
  },
  [1656] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2054),
    [anon_sym_RBRACE] = ACTIONS(4237),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1657] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2056),
    [anon_sym_RBRACE] = ACTIONS(4239),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1658] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(4241),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [1659] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(4241),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1660] = {
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(4241),
    [sym_comment] = ACTIONS(52),
  },
  [1661] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(4241),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1662] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(4243),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [1663] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(4243),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [1664] = {
    [sym_file_descriptor] = ACTIONS(1522),
    [sym__concat] = ACTIONS(1522),
    [sym_variable_name] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(1524),
    [anon_sym_RPAREN] = ACTIONS(1524),
    [anon_sym_SEMI_SEMI] = ACTIONS(1524),
    [anon_sym_PIPE_AMP] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1524),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_LT] = ACTIONS(1524),
    [anon_sym_GT] = ACTIONS(1524),
    [anon_sym_GT_GT] = ACTIONS(1524),
    [anon_sym_AMP_GT] = ACTIONS(1524),
    [anon_sym_AMP_GT_GT] = ACTIONS(1524),
    [anon_sym_LT_AMP] = ACTIONS(1524),
    [anon_sym_GT_AMP] = ACTIONS(1524),
    [sym__special_characters] = ACTIONS(1524),
    [anon_sym_DQUOTE] = ACTIONS(1524),
    [sym_raw_string] = ACTIONS(1524),
    [anon_sym_DOLLAR] = ACTIONS(1524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1524),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1524),
    [anon_sym_BQUOTE] = ACTIONS(1524),
    [anon_sym_LT_LPAREN] = ACTIONS(1524),
    [anon_sym_GT_LPAREN] = ACTIONS(1524),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1524),
    [anon_sym_SEMI] = ACTIONS(1524),
    [anon_sym_LF] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1524),
  },
  [1665] = {
    [aux_sym_concatenation_repeat1] = STATE(1665),
    [sym_file_descriptor] = ACTIONS(1522),
    [sym__concat] = ACTIONS(4245),
    [sym_variable_name] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(1524),
    [anon_sym_RPAREN] = ACTIONS(1524),
    [anon_sym_SEMI_SEMI] = ACTIONS(1524),
    [anon_sym_PIPE_AMP] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1524),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_LT] = ACTIONS(1524),
    [anon_sym_GT] = ACTIONS(1524),
    [anon_sym_GT_GT] = ACTIONS(1524),
    [anon_sym_AMP_GT] = ACTIONS(1524),
    [anon_sym_AMP_GT_GT] = ACTIONS(1524),
    [anon_sym_LT_AMP] = ACTIONS(1524),
    [anon_sym_GT_AMP] = ACTIONS(1524),
    [sym__special_characters] = ACTIONS(1524),
    [anon_sym_DQUOTE] = ACTIONS(1524),
    [sym_raw_string] = ACTIONS(1524),
    [anon_sym_DOLLAR] = ACTIONS(1524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1524),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1524),
    [anon_sym_BQUOTE] = ACTIONS(1524),
    [anon_sym_LT_LPAREN] = ACTIONS(1524),
    [anon_sym_GT_LPAREN] = ACTIONS(1524),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1524),
    [anon_sym_SEMI] = ACTIONS(1524),
    [anon_sym_LF] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1524),
  },
  [1666] = {
    [sym_file_descriptor] = ACTIONS(1553),
    [sym__concat] = ACTIONS(1553),
    [sym_variable_name] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(1555),
    [anon_sym_RPAREN] = ACTIONS(1555),
    [anon_sym_SEMI_SEMI] = ACTIONS(1555),
    [anon_sym_PIPE_AMP] = ACTIONS(1555),
    [anon_sym_AMP_AMP] = ACTIONS(1555),
    [anon_sym_PIPE_PIPE] = ACTIONS(1555),
    [anon_sym_LT] = ACTIONS(1555),
    [anon_sym_GT] = ACTIONS(1555),
    [anon_sym_GT_GT] = ACTIONS(1555),
    [anon_sym_AMP_GT] = ACTIONS(1555),
    [anon_sym_AMP_GT_GT] = ACTIONS(1555),
    [anon_sym_LT_AMP] = ACTIONS(1555),
    [anon_sym_GT_AMP] = ACTIONS(1555),
    [sym__special_characters] = ACTIONS(1555),
    [anon_sym_DQUOTE] = ACTIONS(1555),
    [sym_raw_string] = ACTIONS(1555),
    [anon_sym_DOLLAR] = ACTIONS(1555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1555),
    [anon_sym_BQUOTE] = ACTIONS(1555),
    [anon_sym_LT_LPAREN] = ACTIONS(1555),
    [anon_sym_GT_LPAREN] = ACTIONS(1555),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1555),
    [anon_sym_SEMI] = ACTIONS(1555),
    [anon_sym_LF] = ACTIONS(1555),
    [anon_sym_AMP] = ACTIONS(1555),
  },
  [1667] = {
    [sym_concatenation] = STATE(2062),
    [sym_string] = STATE(2061),
    [sym_simple_expansion] = STATE(2061),
    [sym_expansion] = STATE(2061),
    [sym_command_substitution] = STATE(2061),
    [sym_process_substitution] = STATE(2061),
    [anon_sym_RBRACE] = ACTIONS(4248),
    [sym__special_characters] = ACTIONS(4250),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(4252),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4254),
  },
  [1668] = {
    [sym_file_descriptor] = ACTIONS(1598),
    [sym__concat] = ACTIONS(1598),
    [sym_variable_name] = ACTIONS(1598),
    [anon_sym_PIPE] = ACTIONS(1600),
    [anon_sym_RPAREN] = ACTIONS(1600),
    [anon_sym_SEMI_SEMI] = ACTIONS(1600),
    [anon_sym_PIPE_AMP] = ACTIONS(1600),
    [anon_sym_AMP_AMP] = ACTIONS(1600),
    [anon_sym_PIPE_PIPE] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1600),
    [anon_sym_GT] = ACTIONS(1600),
    [anon_sym_GT_GT] = ACTIONS(1600),
    [anon_sym_AMP_GT] = ACTIONS(1600),
    [anon_sym_AMP_GT_GT] = ACTIONS(1600),
    [anon_sym_LT_AMP] = ACTIONS(1600),
    [anon_sym_GT_AMP] = ACTIONS(1600),
    [sym__special_characters] = ACTIONS(1600),
    [anon_sym_DQUOTE] = ACTIONS(1600),
    [sym_raw_string] = ACTIONS(1600),
    [anon_sym_DOLLAR] = ACTIONS(1600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1600),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1600),
    [anon_sym_BQUOTE] = ACTIONS(1600),
    [anon_sym_LT_LPAREN] = ACTIONS(1600),
    [anon_sym_GT_LPAREN] = ACTIONS(1600),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1600),
    [anon_sym_SEMI] = ACTIONS(1600),
    [anon_sym_LF] = ACTIONS(1600),
    [anon_sym_AMP] = ACTIONS(1600),
  },
  [1669] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4256),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1670] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(4258),
    [sym_comment] = ACTIONS(52),
  },
  [1671] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2066),
    [anon_sym_RBRACE] = ACTIONS(4260),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1672] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2068),
    [anon_sym_RBRACE] = ACTIONS(4262),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1673] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2069),
    [anon_sym_RBRACE] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1674] = {
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(1642),
    [sym_variable_name] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1644),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1644),
    [anon_sym_BQUOTE] = ACTIONS(1644),
    [anon_sym_LT_LPAREN] = ACTIONS(1644),
    [anon_sym_GT_LPAREN] = ACTIONS(1644),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [1675] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4264),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1676] = {
    [sym_file_descriptor] = ACTIONS(1648),
    [sym__concat] = ACTIONS(1648),
    [sym_variable_name] = ACTIONS(1648),
    [anon_sym_PIPE] = ACTIONS(1650),
    [anon_sym_RPAREN] = ACTIONS(1650),
    [anon_sym_SEMI_SEMI] = ACTIONS(1650),
    [anon_sym_PIPE_AMP] = ACTIONS(1650),
    [anon_sym_AMP_AMP] = ACTIONS(1650),
    [anon_sym_PIPE_PIPE] = ACTIONS(1650),
    [anon_sym_LT] = ACTIONS(1650),
    [anon_sym_GT] = ACTIONS(1650),
    [anon_sym_GT_GT] = ACTIONS(1650),
    [anon_sym_AMP_GT] = ACTIONS(1650),
    [anon_sym_AMP_GT_GT] = ACTIONS(1650),
    [anon_sym_LT_AMP] = ACTIONS(1650),
    [anon_sym_GT_AMP] = ACTIONS(1650),
    [sym__special_characters] = ACTIONS(1650),
    [anon_sym_DQUOTE] = ACTIONS(1650),
    [sym_raw_string] = ACTIONS(1650),
    [anon_sym_DOLLAR] = ACTIONS(1650),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1650),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1650),
    [anon_sym_BQUOTE] = ACTIONS(1650),
    [anon_sym_LT_LPAREN] = ACTIONS(1650),
    [anon_sym_GT_LPAREN] = ACTIONS(1650),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(1650),
    [anon_sym_LF] = ACTIONS(1650),
    [anon_sym_AMP] = ACTIONS(1650),
  },
  [1677] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1678] = {
    [sym_file_descriptor] = ACTIONS(1762),
    [sym__concat] = ACTIONS(1762),
    [sym_variable_name] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(1764),
    [anon_sym_RPAREN] = ACTIONS(1764),
    [anon_sym_SEMI_SEMI] = ACTIONS(1764),
    [anon_sym_PIPE_AMP] = ACTIONS(1764),
    [anon_sym_AMP_AMP] = ACTIONS(1764),
    [anon_sym_PIPE_PIPE] = ACTIONS(1764),
    [anon_sym_LT] = ACTIONS(1764),
    [anon_sym_GT] = ACTIONS(1764),
    [anon_sym_GT_GT] = ACTIONS(1764),
    [anon_sym_AMP_GT] = ACTIONS(1764),
    [anon_sym_AMP_GT_GT] = ACTIONS(1764),
    [anon_sym_LT_AMP] = ACTIONS(1764),
    [anon_sym_GT_AMP] = ACTIONS(1764),
    [sym__special_characters] = ACTIONS(1764),
    [anon_sym_DQUOTE] = ACTIONS(1764),
    [sym_raw_string] = ACTIONS(1764),
    [anon_sym_DOLLAR] = ACTIONS(1764),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1764),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1764),
    [anon_sym_BQUOTE] = ACTIONS(1764),
    [anon_sym_LT_LPAREN] = ACTIONS(1764),
    [anon_sym_GT_LPAREN] = ACTIONS(1764),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1764),
    [anon_sym_SEMI] = ACTIONS(1764),
    [anon_sym_LF] = ACTIONS(1764),
    [anon_sym_AMP] = ACTIONS(1764),
  },
  [1679] = {
    [sym_file_descriptor] = ACTIONS(1902),
    [sym__concat] = ACTIONS(1902),
    [sym_variable_name] = ACTIONS(1902),
    [anon_sym_PIPE] = ACTIONS(1904),
    [anon_sym_RPAREN] = ACTIONS(1904),
    [anon_sym_SEMI_SEMI] = ACTIONS(1904),
    [anon_sym_PIPE_AMP] = ACTIONS(1904),
    [anon_sym_AMP_AMP] = ACTIONS(1904),
    [anon_sym_PIPE_PIPE] = ACTIONS(1904),
    [anon_sym_LT] = ACTIONS(1904),
    [anon_sym_GT] = ACTIONS(1904),
    [anon_sym_GT_GT] = ACTIONS(1904),
    [anon_sym_AMP_GT] = ACTIONS(1904),
    [anon_sym_AMP_GT_GT] = ACTIONS(1904),
    [anon_sym_LT_AMP] = ACTIONS(1904),
    [anon_sym_GT_AMP] = ACTIONS(1904),
    [sym__special_characters] = ACTIONS(1904),
    [anon_sym_DQUOTE] = ACTIONS(1904),
    [sym_raw_string] = ACTIONS(1904),
    [anon_sym_DOLLAR] = ACTIONS(1904),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1904),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1904),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [anon_sym_LT_LPAREN] = ACTIONS(1904),
    [anon_sym_GT_LPAREN] = ACTIONS(1904),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(1904),
    [anon_sym_SEMI] = ACTIONS(1904),
    [anon_sym_LF] = ACTIONS(1904),
    [anon_sym_AMP] = ACTIONS(1904),
  },
  [1680] = {
    [sym_file_redirect] = STATE(1642),
    [sym_file_descriptor] = ACTIONS(2273),
    [anon_sym_PIPE] = ACTIONS(3410),
    [anon_sym_RPAREN] = ACTIONS(3410),
    [anon_sym_SEMI_SEMI] = ACTIONS(3410),
    [anon_sym_PIPE_AMP] = ACTIONS(3410),
    [anon_sym_AMP_AMP] = ACTIONS(3410),
    [anon_sym_PIPE_PIPE] = ACTIONS(3410),
    [anon_sym_LT] = ACTIONS(2275),
    [anon_sym_GT] = ACTIONS(2275),
    [anon_sym_GT_GT] = ACTIONS(2275),
    [anon_sym_AMP_GT] = ACTIONS(2275),
    [anon_sym_AMP_GT_GT] = ACTIONS(2275),
    [anon_sym_LT_AMP] = ACTIONS(2275),
    [anon_sym_GT_AMP] = ACTIONS(2275),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3410),
    [anon_sym_LF] = ACTIONS(3410),
    [anon_sym_AMP] = ACTIONS(3410),
  },
  [1681] = {
    [sym_concatenation] = STATE(1645),
    [sym_string] = STATE(2072),
    [sym_simple_expansion] = STATE(2072),
    [sym_expansion] = STATE(2072),
    [sym_command_substitution] = STATE(2072),
    [sym_process_substitution] = STATE(2072),
    [sym__special_characters] = ACTIONS(4266),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_raw_string] = ACTIONS(4268),
    [anon_sym_DOLLAR] = ACTIONS(3478),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3480),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3482),
    [anon_sym_BQUOTE] = ACTIONS(3484),
    [anon_sym_LT_LPAREN] = ACTIONS(3486),
    [anon_sym_GT_LPAREN] = ACTIONS(3486),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4270),
  },
  [1682] = {
    [aux_sym_concatenation_repeat1] = STATE(2074),
    [sym__concat] = ACTIONS(4272),
    [anon_sym_PIPE] = ACTIONS(1918),
    [anon_sym_RPAREN] = ACTIONS(1918),
    [anon_sym_SEMI_SEMI] = ACTIONS(1918),
    [anon_sym_PIPE_AMP] = ACTIONS(1918),
    [anon_sym_AMP_AMP] = ACTIONS(1918),
    [anon_sym_PIPE_PIPE] = ACTIONS(1918),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1918),
    [anon_sym_LF] = ACTIONS(1918),
    [anon_sym_AMP] = ACTIONS(1918),
  },
  [1683] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(2076),
    [anon_sym_DQUOTE] = ACTIONS(4274),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [1684] = {
    [aux_sym_concatenation_repeat1] = STATE(2074),
    [sym__concat] = ACTIONS(4272),
    [anon_sym_PIPE] = ACTIONS(1922),
    [anon_sym_RPAREN] = ACTIONS(1922),
    [anon_sym_SEMI_SEMI] = ACTIONS(1922),
    [anon_sym_PIPE_AMP] = ACTIONS(1922),
    [anon_sym_AMP_AMP] = ACTIONS(1922),
    [anon_sym_PIPE_PIPE] = ACTIONS(1922),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1922),
    [anon_sym_LF] = ACTIONS(1922),
    [anon_sym_AMP] = ACTIONS(1922),
  },
  [1685] = {
    [sym_string] = STATE(2079),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [anon_sym_DOLLAR] = ACTIONS(4276),
    [anon_sym_POUND] = ACTIONS(4276),
    [anon_sym_DASH] = ACTIONS(4276),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4278),
    [anon_sym_STAR] = ACTIONS(4276),
    [anon_sym_AT] = ACTIONS(4276),
    [anon_sym_QMARK] = ACTIONS(4276),
    [anon_sym_0] = ACTIONS(4280),
    [anon_sym__] = ACTIONS(4280),
  },
  [1686] = {
    [sym_subscript] = STATE(2084),
    [sym_variable_name] = ACTIONS(4282),
    [anon_sym_DOLLAR] = ACTIONS(4284),
    [anon_sym_POUND] = ACTIONS(4286),
    [anon_sym_DASH] = ACTIONS(4284),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4288),
    [anon_sym_STAR] = ACTIONS(4284),
    [anon_sym_AT] = ACTIONS(4284),
    [anon_sym_QMARK] = ACTIONS(4284),
    [anon_sym_0] = ACTIONS(4290),
    [anon_sym__] = ACTIONS(4290),
  },
  [1687] = {
    [sym_for_statement] = STATE(2085),
    [sym_while_statement] = STATE(2085),
    [sym_if_statement] = STATE(2085),
    [sym_case_statement] = STATE(2085),
    [sym_function_definition] = STATE(2085),
    [sym_subshell] = STATE(2085),
    [sym_pipeline] = STATE(2085),
    [sym_list] = STATE(2085),
    [sym_bracket_command] = STATE(2085),
    [sym_command] = STATE(2085),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(2086),
    [sym_declaration_command] = STATE(2085),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [1688] = {
    [sym_for_statement] = STATE(2087),
    [sym_while_statement] = STATE(2087),
    [sym_if_statement] = STATE(2087),
    [sym_case_statement] = STATE(2087),
    [sym_function_definition] = STATE(2087),
    [sym_subshell] = STATE(2087),
    [sym_pipeline] = STATE(2087),
    [sym_list] = STATE(2087),
    [sym_bracket_command] = STATE(2087),
    [sym_command] = STATE(2087),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(2088),
    [sym_declaration_command] = STATE(2087),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [1689] = {
    [sym_for_statement] = STATE(2089),
    [sym_while_statement] = STATE(2089),
    [sym_if_statement] = STATE(2089),
    [sym_case_statement] = STATE(2089),
    [sym_function_definition] = STATE(2089),
    [sym_subshell] = STATE(2089),
    [sym_pipeline] = STATE(2089),
    [sym_list] = STATE(2089),
    [sym_bracket_command] = STATE(2089),
    [sym_command] = STATE(2089),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(2090),
    [sym_declaration_command] = STATE(2089),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [1690] = {
    [sym__concat] = ACTIONS(2560),
    [sym_variable_name] = ACTIONS(2560),
    [anon_sym_PIPE] = ACTIONS(2562),
    [anon_sym_RPAREN] = ACTIONS(2562),
    [anon_sym_SEMI_SEMI] = ACTIONS(2562),
    [anon_sym_PIPE_AMP] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_PIPE_PIPE] = ACTIONS(2562),
    [sym__special_characters] = ACTIONS(2562),
    [anon_sym_DQUOTE] = ACTIONS(2562),
    [sym_raw_string] = ACTIONS(2562),
    [anon_sym_DOLLAR] = ACTIONS(2562),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2562),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2562),
    [anon_sym_BQUOTE] = ACTIONS(2562),
    [anon_sym_LT_LPAREN] = ACTIONS(2562),
    [anon_sym_GT_LPAREN] = ACTIONS(2562),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2562),
    [sym_word] = ACTIONS(2562),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym_LF] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(2562),
  },
  [1691] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4292),
    [sym_comment] = ACTIONS(52),
  },
  [1692] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4294),
    [sym_comment] = ACTIONS(52),
  },
  [1693] = {
    [anon_sym_RBRACE] = ACTIONS(4294),
    [sym_comment] = ACTIONS(52),
  },
  [1694] = {
    [sym__concat] = ACTIONS(2614),
    [sym_variable_name] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2616),
    [anon_sym_RPAREN] = ACTIONS(2616),
    [anon_sym_SEMI_SEMI] = ACTIONS(2616),
    [anon_sym_PIPE_AMP] = ACTIONS(2616),
    [anon_sym_AMP_AMP] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2616),
    [sym__special_characters] = ACTIONS(2616),
    [anon_sym_DQUOTE] = ACTIONS(2616),
    [sym_raw_string] = ACTIONS(2616),
    [anon_sym_DOLLAR] = ACTIONS(2616),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2616),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2616),
    [anon_sym_BQUOTE] = ACTIONS(2616),
    [anon_sym_LT_LPAREN] = ACTIONS(2616),
    [anon_sym_GT_LPAREN] = ACTIONS(2616),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2616),
    [sym_word] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2616),
    [anon_sym_LF] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2616),
  },
  [1695] = {
    [sym_concatenation] = STATE(2095),
    [sym_string] = STATE(2094),
    [sym_simple_expansion] = STATE(2094),
    [sym_expansion] = STATE(2094),
    [sym_command_substitution] = STATE(2094),
    [sym_process_substitution] = STATE(2094),
    [anon_sym_RBRACE] = ACTIONS(4294),
    [sym__special_characters] = ACTIONS(4296),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(4298),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4300),
  },
  [1696] = {
    [sym__concat] = ACTIONS(2659),
    [sym_variable_name] = ACTIONS(2659),
    [anon_sym_PIPE] = ACTIONS(2661),
    [anon_sym_RPAREN] = ACTIONS(2661),
    [anon_sym_SEMI_SEMI] = ACTIONS(2661),
    [anon_sym_PIPE_AMP] = ACTIONS(2661),
    [anon_sym_AMP_AMP] = ACTIONS(2661),
    [anon_sym_PIPE_PIPE] = ACTIONS(2661),
    [sym__special_characters] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2661),
    [sym_raw_string] = ACTIONS(2661),
    [anon_sym_DOLLAR] = ACTIONS(2661),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2661),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2661),
    [anon_sym_BQUOTE] = ACTIONS(2661),
    [anon_sym_LT_LPAREN] = ACTIONS(2661),
    [anon_sym_GT_LPAREN] = ACTIONS(2661),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2661),
    [sym_word] = ACTIONS(2661),
    [anon_sym_SEMI] = ACTIONS(2661),
    [anon_sym_LF] = ACTIONS(2661),
    [anon_sym_AMP] = ACTIONS(2661),
  },
  [1697] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4302),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1698] = {
    [sym__concat] = ACTIONS(2665),
    [sym_variable_name] = ACTIONS(2665),
    [anon_sym_PIPE] = ACTIONS(2667),
    [anon_sym_RPAREN] = ACTIONS(2667),
    [anon_sym_SEMI_SEMI] = ACTIONS(2667),
    [anon_sym_PIPE_AMP] = ACTIONS(2667),
    [anon_sym_AMP_AMP] = ACTIONS(2667),
    [anon_sym_PIPE_PIPE] = ACTIONS(2667),
    [sym__special_characters] = ACTIONS(2667),
    [anon_sym_DQUOTE] = ACTIONS(2667),
    [sym_raw_string] = ACTIONS(2667),
    [anon_sym_DOLLAR] = ACTIONS(2667),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2667),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2667),
    [anon_sym_BQUOTE] = ACTIONS(2667),
    [anon_sym_LT_LPAREN] = ACTIONS(2667),
    [anon_sym_GT_LPAREN] = ACTIONS(2667),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2667),
    [sym_word] = ACTIONS(2667),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym_LF] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(2667),
  },
  [1699] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4304),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1700] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4294),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1701] = {
    [sym__concat] = ACTIONS(2671),
    [sym_variable_name] = ACTIONS(2671),
    [anon_sym_PIPE] = ACTIONS(2673),
    [anon_sym_RPAREN] = ACTIONS(2673),
    [anon_sym_SEMI_SEMI] = ACTIONS(2673),
    [anon_sym_PIPE_AMP] = ACTIONS(2673),
    [anon_sym_AMP_AMP] = ACTIONS(2673),
    [anon_sym_PIPE_PIPE] = ACTIONS(2673),
    [sym__special_characters] = ACTIONS(2673),
    [anon_sym_DQUOTE] = ACTIONS(2673),
    [sym_raw_string] = ACTIONS(2673),
    [anon_sym_DOLLAR] = ACTIONS(2673),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2673),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2673),
    [anon_sym_BQUOTE] = ACTIONS(2673),
    [anon_sym_LT_LPAREN] = ACTIONS(2673),
    [anon_sym_GT_LPAREN] = ACTIONS(2673),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2673),
    [sym_word] = ACTIONS(2673),
    [anon_sym_SEMI] = ACTIONS(2673),
    [anon_sym_LF] = ACTIONS(2673),
    [anon_sym_AMP] = ACTIONS(2673),
  },
  [1702] = {
    [sym_file_descriptor] = ACTIONS(3657),
    [sym__concat] = ACTIONS(3657),
    [anon_sym_PIPE] = ACTIONS(3659),
    [anon_sym_RPAREN] = ACTIONS(3659),
    [anon_sym_SEMI_SEMI] = ACTIONS(3659),
    [anon_sym_PIPE_AMP] = ACTIONS(3659),
    [anon_sym_AMP_AMP] = ACTIONS(3659),
    [anon_sym_PIPE_PIPE] = ACTIONS(3659),
    [anon_sym_LT] = ACTIONS(3659),
    [anon_sym_GT] = ACTIONS(3659),
    [anon_sym_GT_GT] = ACTIONS(3659),
    [anon_sym_AMP_GT] = ACTIONS(3659),
    [anon_sym_AMP_GT_GT] = ACTIONS(3659),
    [anon_sym_LT_AMP] = ACTIONS(3659),
    [anon_sym_GT_AMP] = ACTIONS(3659),
    [anon_sym_LT_LT] = ACTIONS(3659),
    [anon_sym_LT_LT_DASH] = ACTIONS(3659),
    [anon_sym_LT_LT_LT] = ACTIONS(3659),
    [sym__special_characters] = ACTIONS(3659),
    [anon_sym_DQUOTE] = ACTIONS(3659),
    [sym_raw_string] = ACTIONS(3659),
    [anon_sym_DOLLAR] = ACTIONS(3659),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3659),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3659),
    [anon_sym_BQUOTE] = ACTIONS(3659),
    [anon_sym_LT_LPAREN] = ACTIONS(3659),
    [anon_sym_GT_LPAREN] = ACTIONS(3659),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(3659),
    [anon_sym_SEMI] = ACTIONS(3659),
    [anon_sym_LF] = ACTIONS(3659),
    [anon_sym_AMP] = ACTIONS(3659),
  },
  [1703] = {
    [sym_file_descriptor] = ACTIONS(3663),
    [sym__concat] = ACTIONS(3663),
    [anon_sym_PIPE] = ACTIONS(3665),
    [anon_sym_RPAREN] = ACTIONS(3665),
    [anon_sym_SEMI_SEMI] = ACTIONS(3665),
    [anon_sym_PIPE_AMP] = ACTIONS(3665),
    [anon_sym_AMP_AMP] = ACTIONS(3665),
    [anon_sym_PIPE_PIPE] = ACTIONS(3665),
    [anon_sym_LT] = ACTIONS(3665),
    [anon_sym_GT] = ACTIONS(3665),
    [anon_sym_GT_GT] = ACTIONS(3665),
    [anon_sym_AMP_GT] = ACTIONS(3665),
    [anon_sym_AMP_GT_GT] = ACTIONS(3665),
    [anon_sym_LT_AMP] = ACTIONS(3665),
    [anon_sym_GT_AMP] = ACTIONS(3665),
    [anon_sym_LT_LT] = ACTIONS(3665),
    [anon_sym_LT_LT_DASH] = ACTIONS(3665),
    [anon_sym_LT_LT_LT] = ACTIONS(3665),
    [sym__special_characters] = ACTIONS(3665),
    [anon_sym_DQUOTE] = ACTIONS(3665),
    [sym_raw_string] = ACTIONS(3665),
    [anon_sym_DOLLAR] = ACTIONS(3665),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3665),
    [anon_sym_BQUOTE] = ACTIONS(3665),
    [anon_sym_LT_LPAREN] = ACTIONS(3665),
    [anon_sym_GT_LPAREN] = ACTIONS(3665),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(3665),
    [anon_sym_SEMI] = ACTIONS(3665),
    [anon_sym_LF] = ACTIONS(3665),
    [anon_sym_AMP] = ACTIONS(3665),
  },
  [1704] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4306),
    [sym_comment] = ACTIONS(52),
  },
  [1705] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4308),
    [sym_comment] = ACTIONS(52),
  },
  [1706] = {
    [anon_sym_RBRACE] = ACTIONS(4308),
    [sym_comment] = ACTIONS(52),
  },
  [1707] = {
    [sym_file_descriptor] = ACTIONS(3712),
    [sym__concat] = ACTIONS(3712),
    [anon_sym_PIPE] = ACTIONS(3714),
    [anon_sym_RPAREN] = ACTIONS(3714),
    [anon_sym_SEMI_SEMI] = ACTIONS(3714),
    [anon_sym_PIPE_AMP] = ACTIONS(3714),
    [anon_sym_AMP_AMP] = ACTIONS(3714),
    [anon_sym_PIPE_PIPE] = ACTIONS(3714),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_GT] = ACTIONS(3714),
    [anon_sym_GT_GT] = ACTIONS(3714),
    [anon_sym_AMP_GT] = ACTIONS(3714),
    [anon_sym_AMP_GT_GT] = ACTIONS(3714),
    [anon_sym_LT_AMP] = ACTIONS(3714),
    [anon_sym_GT_AMP] = ACTIONS(3714),
    [anon_sym_LT_LT] = ACTIONS(3714),
    [anon_sym_LT_LT_DASH] = ACTIONS(3714),
    [anon_sym_LT_LT_LT] = ACTIONS(3714),
    [sym__special_characters] = ACTIONS(3714),
    [anon_sym_DQUOTE] = ACTIONS(3714),
    [sym_raw_string] = ACTIONS(3714),
    [anon_sym_DOLLAR] = ACTIONS(3714),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3714),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3714),
    [anon_sym_BQUOTE] = ACTIONS(3714),
    [anon_sym_LT_LPAREN] = ACTIONS(3714),
    [anon_sym_GT_LPAREN] = ACTIONS(3714),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(3714),
    [anon_sym_SEMI] = ACTIONS(3714),
    [anon_sym_LF] = ACTIONS(3714),
    [anon_sym_AMP] = ACTIONS(3714),
  },
  [1708] = {
    [sym_file_descriptor] = ACTIONS(3716),
    [sym__concat] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3718),
    [anon_sym_RPAREN] = ACTIONS(3718),
    [anon_sym_SEMI_SEMI] = ACTIONS(3718),
    [anon_sym_PIPE_AMP] = ACTIONS(3718),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_LT] = ACTIONS(3718),
    [anon_sym_GT] = ACTIONS(3718),
    [anon_sym_GT_GT] = ACTIONS(3718),
    [anon_sym_AMP_GT] = ACTIONS(3718),
    [anon_sym_AMP_GT_GT] = ACTIONS(3718),
    [anon_sym_LT_AMP] = ACTIONS(3718),
    [anon_sym_GT_AMP] = ACTIONS(3718),
    [anon_sym_LT_LT] = ACTIONS(3718),
    [anon_sym_LT_LT_DASH] = ACTIONS(3718),
    [anon_sym_LT_LT_LT] = ACTIONS(3718),
    [sym__special_characters] = ACTIONS(3718),
    [anon_sym_DQUOTE] = ACTIONS(3718),
    [sym_raw_string] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3718),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3718),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3718),
    [anon_sym_BQUOTE] = ACTIONS(3718),
    [anon_sym_LT_LPAREN] = ACTIONS(3718),
    [anon_sym_GT_LPAREN] = ACTIONS(3718),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(3718),
    [anon_sym_SEMI] = ACTIONS(3718),
    [anon_sym_LF] = ACTIONS(3718),
    [anon_sym_AMP] = ACTIONS(3718),
  },
  [1709] = {
    [sym_file_descriptor] = ACTIONS(1522),
    [sym__concat] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(1524),
    [anon_sym_RPAREN] = ACTIONS(1524),
    [anon_sym_SEMI_SEMI] = ACTIONS(1524),
    [anon_sym_PIPE_AMP] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1524),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_LT] = ACTIONS(1524),
    [anon_sym_GT] = ACTIONS(1524),
    [anon_sym_GT_GT] = ACTIONS(1524),
    [anon_sym_AMP_GT] = ACTIONS(1524),
    [anon_sym_AMP_GT_GT] = ACTIONS(1524),
    [anon_sym_LT_AMP] = ACTIONS(1524),
    [anon_sym_GT_AMP] = ACTIONS(1524),
    [anon_sym_LT_LT] = ACTIONS(1524),
    [anon_sym_LT_LT_DASH] = ACTIONS(1524),
    [anon_sym_LT_LT_LT] = ACTIONS(1524),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1524),
    [anon_sym_LF] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1524),
  },
  [1710] = {
    [aux_sym_concatenation_repeat1] = STATE(1710),
    [sym_file_descriptor] = ACTIONS(1522),
    [sym__concat] = ACTIONS(4310),
    [anon_sym_PIPE] = ACTIONS(1524),
    [anon_sym_RPAREN] = ACTIONS(1524),
    [anon_sym_SEMI_SEMI] = ACTIONS(1524),
    [anon_sym_PIPE_AMP] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1524),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_LT] = ACTIONS(1524),
    [anon_sym_GT] = ACTIONS(1524),
    [anon_sym_GT_GT] = ACTIONS(1524),
    [anon_sym_AMP_GT] = ACTIONS(1524),
    [anon_sym_AMP_GT_GT] = ACTIONS(1524),
    [anon_sym_LT_AMP] = ACTIONS(1524),
    [anon_sym_GT_AMP] = ACTIONS(1524),
    [anon_sym_LT_LT] = ACTIONS(1524),
    [anon_sym_LT_LT_DASH] = ACTIONS(1524),
    [anon_sym_LT_LT_LT] = ACTIONS(1524),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1524),
    [anon_sym_LF] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1524),
  },
  [1711] = {
    [sym_file_descriptor] = ACTIONS(1553),
    [sym__concat] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(1555),
    [anon_sym_RPAREN] = ACTIONS(1555),
    [anon_sym_SEMI_SEMI] = ACTIONS(1555),
    [anon_sym_PIPE_AMP] = ACTIONS(1555),
    [anon_sym_AMP_AMP] = ACTIONS(1555),
    [anon_sym_PIPE_PIPE] = ACTIONS(1555),
    [anon_sym_LT] = ACTIONS(1555),
    [anon_sym_GT] = ACTIONS(1555),
    [anon_sym_GT_GT] = ACTIONS(1555),
    [anon_sym_AMP_GT] = ACTIONS(1555),
    [anon_sym_AMP_GT_GT] = ACTIONS(1555),
    [anon_sym_LT_AMP] = ACTIONS(1555),
    [anon_sym_GT_AMP] = ACTIONS(1555),
    [anon_sym_LT_LT] = ACTIONS(1555),
    [anon_sym_LT_LT_DASH] = ACTIONS(1555),
    [anon_sym_LT_LT_LT] = ACTIONS(1555),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1555),
    [anon_sym_LF] = ACTIONS(1555),
    [anon_sym_AMP] = ACTIONS(1555),
  },
  [1712] = {
    [sym_concatenation] = STATE(2103),
    [sym_string] = STATE(2102),
    [sym_simple_expansion] = STATE(2102),
    [sym_expansion] = STATE(2102),
    [sym_command_substitution] = STATE(2102),
    [sym_process_substitution] = STATE(2102),
    [anon_sym_RBRACE] = ACTIONS(4313),
    [sym__special_characters] = ACTIONS(4315),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(4317),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4319),
  },
  [1713] = {
    [sym_file_descriptor] = ACTIONS(1598),
    [sym__concat] = ACTIONS(1598),
    [anon_sym_PIPE] = ACTIONS(1600),
    [anon_sym_RPAREN] = ACTIONS(1600),
    [anon_sym_SEMI_SEMI] = ACTIONS(1600),
    [anon_sym_PIPE_AMP] = ACTIONS(1600),
    [anon_sym_AMP_AMP] = ACTIONS(1600),
    [anon_sym_PIPE_PIPE] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1600),
    [anon_sym_GT] = ACTIONS(1600),
    [anon_sym_GT_GT] = ACTIONS(1600),
    [anon_sym_AMP_GT] = ACTIONS(1600),
    [anon_sym_AMP_GT_GT] = ACTIONS(1600),
    [anon_sym_LT_AMP] = ACTIONS(1600),
    [anon_sym_GT_AMP] = ACTIONS(1600),
    [anon_sym_LT_LT] = ACTIONS(1600),
    [anon_sym_LT_LT_DASH] = ACTIONS(1600),
    [anon_sym_LT_LT_LT] = ACTIONS(1600),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1600),
    [anon_sym_LF] = ACTIONS(1600),
    [anon_sym_AMP] = ACTIONS(1600),
  },
  [1714] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4321),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1715] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(4323),
    [sym_comment] = ACTIONS(52),
  },
  [1716] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2107),
    [anon_sym_RBRACE] = ACTIONS(4325),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1717] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2109),
    [anon_sym_RBRACE] = ACTIONS(4327),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1718] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2110),
    [anon_sym_RBRACE] = ACTIONS(4313),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1719] = {
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1644),
    [anon_sym_LT_LT_DASH] = ACTIONS(1644),
    [anon_sym_LT_LT_LT] = ACTIONS(1644),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [1720] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4329),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1721] = {
    [sym_file_descriptor] = ACTIONS(1648),
    [sym__concat] = ACTIONS(1648),
    [anon_sym_PIPE] = ACTIONS(1650),
    [anon_sym_RPAREN] = ACTIONS(1650),
    [anon_sym_SEMI_SEMI] = ACTIONS(1650),
    [anon_sym_PIPE_AMP] = ACTIONS(1650),
    [anon_sym_AMP_AMP] = ACTIONS(1650),
    [anon_sym_PIPE_PIPE] = ACTIONS(1650),
    [anon_sym_LT] = ACTIONS(1650),
    [anon_sym_GT] = ACTIONS(1650),
    [anon_sym_GT_GT] = ACTIONS(1650),
    [anon_sym_AMP_GT] = ACTIONS(1650),
    [anon_sym_AMP_GT_GT] = ACTIONS(1650),
    [anon_sym_LT_AMP] = ACTIONS(1650),
    [anon_sym_GT_AMP] = ACTIONS(1650),
    [anon_sym_LT_LT] = ACTIONS(1650),
    [anon_sym_LT_LT_DASH] = ACTIONS(1650),
    [anon_sym_LT_LT_LT] = ACTIONS(1650),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1650),
    [anon_sym_LF] = ACTIONS(1650),
    [anon_sym_AMP] = ACTIONS(1650),
  },
  [1722] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4313),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1723] = {
    [sym_file_descriptor] = ACTIONS(1762),
    [sym__concat] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(1764),
    [anon_sym_RPAREN] = ACTIONS(1764),
    [anon_sym_SEMI_SEMI] = ACTIONS(1764),
    [anon_sym_PIPE_AMP] = ACTIONS(1764),
    [anon_sym_AMP_AMP] = ACTIONS(1764),
    [anon_sym_PIPE_PIPE] = ACTIONS(1764),
    [anon_sym_LT] = ACTIONS(1764),
    [anon_sym_GT] = ACTIONS(1764),
    [anon_sym_GT_GT] = ACTIONS(1764),
    [anon_sym_AMP_GT] = ACTIONS(1764),
    [anon_sym_AMP_GT_GT] = ACTIONS(1764),
    [anon_sym_LT_AMP] = ACTIONS(1764),
    [anon_sym_GT_AMP] = ACTIONS(1764),
    [anon_sym_LT_LT] = ACTIONS(1764),
    [anon_sym_LT_LT_DASH] = ACTIONS(1764),
    [anon_sym_LT_LT_LT] = ACTIONS(1764),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1764),
    [anon_sym_LF] = ACTIONS(1764),
    [anon_sym_AMP] = ACTIONS(1764),
  },
  [1724] = {
    [sym_file_descriptor] = ACTIONS(1902),
    [sym__concat] = ACTIONS(1902),
    [anon_sym_PIPE] = ACTIONS(1904),
    [anon_sym_RPAREN] = ACTIONS(1904),
    [anon_sym_SEMI_SEMI] = ACTIONS(1904),
    [anon_sym_PIPE_AMP] = ACTIONS(1904),
    [anon_sym_AMP_AMP] = ACTIONS(1904),
    [anon_sym_PIPE_PIPE] = ACTIONS(1904),
    [anon_sym_LT] = ACTIONS(1904),
    [anon_sym_GT] = ACTIONS(1904),
    [anon_sym_GT_GT] = ACTIONS(1904),
    [anon_sym_AMP_GT] = ACTIONS(1904),
    [anon_sym_AMP_GT_GT] = ACTIONS(1904),
    [anon_sym_LT_AMP] = ACTIONS(1904),
    [anon_sym_GT_AMP] = ACTIONS(1904),
    [anon_sym_LT_LT] = ACTIONS(1904),
    [anon_sym_LT_LT_DASH] = ACTIONS(1904),
    [anon_sym_LT_LT_LT] = ACTIONS(1904),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1904),
    [anon_sym_LF] = ACTIONS(1904),
    [anon_sym_AMP] = ACTIONS(1904),
  },
  [1725] = {
    [sym__concat] = ACTIONS(3657),
    [anon_sym_RBRACK] = ACTIONS(4331),
    [sym__special_characters] = ACTIONS(3659),
    [anon_sym_DQUOTE] = ACTIONS(3657),
    [sym_raw_string] = ACTIONS(3657),
    [anon_sym_DOLLAR] = ACTIONS(4331),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3657),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3657),
    [anon_sym_BQUOTE] = ACTIONS(3657),
    [anon_sym_LT_LPAREN] = ACTIONS(3657),
    [anon_sym_GT_LPAREN] = ACTIONS(3657),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4331),
  },
  [1726] = {
    [sym__concat] = ACTIONS(3663),
    [anon_sym_RBRACK] = ACTIONS(4333),
    [sym__special_characters] = ACTIONS(3665),
    [anon_sym_DQUOTE] = ACTIONS(3663),
    [sym_raw_string] = ACTIONS(3663),
    [anon_sym_DOLLAR] = ACTIONS(4333),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3663),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3663),
    [anon_sym_BQUOTE] = ACTIONS(3663),
    [anon_sym_LT_LPAREN] = ACTIONS(3663),
    [anon_sym_GT_LPAREN] = ACTIONS(3663),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4333),
  },
  [1727] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4335),
    [sym_comment] = ACTIONS(52),
  },
  [1728] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4337),
    [sym_comment] = ACTIONS(52),
  },
  [1729] = {
    [anon_sym_RBRACE] = ACTIONS(4337),
    [sym_comment] = ACTIONS(52),
  },
  [1730] = {
    [sym__concat] = ACTIONS(3712),
    [anon_sym_RBRACK] = ACTIONS(4339),
    [sym__special_characters] = ACTIONS(3714),
    [anon_sym_DQUOTE] = ACTIONS(3712),
    [sym_raw_string] = ACTIONS(3712),
    [anon_sym_DOLLAR] = ACTIONS(4339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3712),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3712),
    [anon_sym_BQUOTE] = ACTIONS(3712),
    [anon_sym_LT_LPAREN] = ACTIONS(3712),
    [anon_sym_GT_LPAREN] = ACTIONS(3712),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4339),
  },
  [1731] = {
    [sym__concat] = ACTIONS(3716),
    [anon_sym_RBRACK] = ACTIONS(4341),
    [sym__special_characters] = ACTIONS(3718),
    [anon_sym_DQUOTE] = ACTIONS(3716),
    [sym_raw_string] = ACTIONS(3716),
    [anon_sym_DOLLAR] = ACTIONS(4341),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3716),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3716),
    [anon_sym_BQUOTE] = ACTIONS(3716),
    [anon_sym_LT_LPAREN] = ACTIONS(3716),
    [anon_sym_GT_LPAREN] = ACTIONS(3716),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4341),
  },
  [1732] = {
    [sym__concat] = ACTIONS(3657),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3657),
    [sym__special_characters] = ACTIONS(3659),
    [anon_sym_DQUOTE] = ACTIONS(3657),
    [sym_raw_string] = ACTIONS(3657),
    [anon_sym_DOLLAR] = ACTIONS(4331),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3657),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3657),
    [anon_sym_BQUOTE] = ACTIONS(3657),
    [anon_sym_LT_LPAREN] = ACTIONS(3657),
    [anon_sym_GT_LPAREN] = ACTIONS(3657),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4331),
  },
  [1733] = {
    [sym__concat] = ACTIONS(3663),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3663),
    [sym__special_characters] = ACTIONS(3665),
    [anon_sym_DQUOTE] = ACTIONS(3663),
    [sym_raw_string] = ACTIONS(3663),
    [anon_sym_DOLLAR] = ACTIONS(4333),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3663),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3663),
    [anon_sym_BQUOTE] = ACTIONS(3663),
    [anon_sym_LT_LPAREN] = ACTIONS(3663),
    [anon_sym_GT_LPAREN] = ACTIONS(3663),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4333),
  },
  [1734] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4343),
    [sym_comment] = ACTIONS(52),
  },
  [1735] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4345),
    [sym_comment] = ACTIONS(52),
  },
  [1736] = {
    [anon_sym_RBRACE] = ACTIONS(4345),
    [sym_comment] = ACTIONS(52),
  },
  [1737] = {
    [sym__concat] = ACTIONS(3712),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3712),
    [sym__special_characters] = ACTIONS(3714),
    [anon_sym_DQUOTE] = ACTIONS(3712),
    [sym_raw_string] = ACTIONS(3712),
    [anon_sym_DOLLAR] = ACTIONS(4339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3712),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3712),
    [anon_sym_BQUOTE] = ACTIONS(3712),
    [anon_sym_LT_LPAREN] = ACTIONS(3712),
    [anon_sym_GT_LPAREN] = ACTIONS(3712),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4339),
  },
  [1738] = {
    [sym__concat] = ACTIONS(3716),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3716),
    [sym__special_characters] = ACTIONS(3718),
    [anon_sym_DQUOTE] = ACTIONS(3716),
    [sym_raw_string] = ACTIONS(3716),
    [anon_sym_DOLLAR] = ACTIONS(4341),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3716),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3716),
    [anon_sym_BQUOTE] = ACTIONS(3716),
    [anon_sym_LT_LPAREN] = ACTIONS(3716),
    [anon_sym_GT_LPAREN] = ACTIONS(3716),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4341),
  },
  [1739] = {
    [sym_variable_name] = ACTIONS(3227),
    [anon_sym_PIPE] = ACTIONS(3229),
    [anon_sym_RPAREN] = ACTIONS(3229),
    [anon_sym_SEMI_SEMI] = ACTIONS(3229),
    [anon_sym_PIPE_AMP] = ACTIONS(3229),
    [anon_sym_AMP_AMP] = ACTIONS(3229),
    [anon_sym_PIPE_PIPE] = ACTIONS(3229),
    [sym__special_characters] = ACTIONS(3229),
    [anon_sym_DQUOTE] = ACTIONS(3229),
    [sym_raw_string] = ACTIONS(3229),
    [anon_sym_DOLLAR] = ACTIONS(3229),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3229),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3229),
    [anon_sym_BQUOTE] = ACTIONS(3229),
    [anon_sym_LT_LPAREN] = ACTIONS(3229),
    [anon_sym_GT_LPAREN] = ACTIONS(3229),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3229),
    [sym_word] = ACTIONS(3229),
    [anon_sym_SEMI] = ACTIONS(3229),
    [anon_sym_LF] = ACTIONS(3229),
    [anon_sym_AMP] = ACTIONS(3229),
  },
  [1740] = {
    [sym__concat] = ACTIONS(3657),
    [sym_variable_name] = ACTIONS(3657),
    [anon_sym_PIPE] = ACTIONS(3659),
    [anon_sym_SEMI_SEMI] = ACTIONS(3659),
    [anon_sym_PIPE_AMP] = ACTIONS(3659),
    [anon_sym_AMP_AMP] = ACTIONS(3659),
    [anon_sym_PIPE_PIPE] = ACTIONS(3659),
    [sym__special_characters] = ACTIONS(3659),
    [anon_sym_DQUOTE] = ACTIONS(3659),
    [sym_raw_string] = ACTIONS(3659),
    [anon_sym_DOLLAR] = ACTIONS(3659),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3659),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3659),
    [anon_sym_BQUOTE] = ACTIONS(3659),
    [anon_sym_LT_LPAREN] = ACTIONS(3659),
    [anon_sym_GT_LPAREN] = ACTIONS(3659),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3659),
    [sym_word] = ACTIONS(3659),
    [anon_sym_SEMI] = ACTIONS(3659),
    [anon_sym_LF] = ACTIONS(3659),
    [anon_sym_AMP] = ACTIONS(3659),
  },
  [1741] = {
    [sym__concat] = ACTIONS(3663),
    [sym_variable_name] = ACTIONS(3663),
    [anon_sym_PIPE] = ACTIONS(3665),
    [anon_sym_SEMI_SEMI] = ACTIONS(3665),
    [anon_sym_PIPE_AMP] = ACTIONS(3665),
    [anon_sym_AMP_AMP] = ACTIONS(3665),
    [anon_sym_PIPE_PIPE] = ACTIONS(3665),
    [sym__special_characters] = ACTIONS(3665),
    [anon_sym_DQUOTE] = ACTIONS(3665),
    [sym_raw_string] = ACTIONS(3665),
    [anon_sym_DOLLAR] = ACTIONS(3665),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3665),
    [anon_sym_BQUOTE] = ACTIONS(3665),
    [anon_sym_LT_LPAREN] = ACTIONS(3665),
    [anon_sym_GT_LPAREN] = ACTIONS(3665),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3665),
    [sym_word] = ACTIONS(3665),
    [anon_sym_SEMI] = ACTIONS(3665),
    [anon_sym_LF] = ACTIONS(3665),
    [anon_sym_AMP] = ACTIONS(3665),
  },
  [1742] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4347),
    [sym_comment] = ACTIONS(52),
  },
  [1743] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4349),
    [sym_comment] = ACTIONS(52),
  },
  [1744] = {
    [anon_sym_RBRACE] = ACTIONS(4349),
    [sym_comment] = ACTIONS(52),
  },
  [1745] = {
    [sym__concat] = ACTIONS(3712),
    [sym_variable_name] = ACTIONS(3712),
    [anon_sym_PIPE] = ACTIONS(3714),
    [anon_sym_SEMI_SEMI] = ACTIONS(3714),
    [anon_sym_PIPE_AMP] = ACTIONS(3714),
    [anon_sym_AMP_AMP] = ACTIONS(3714),
    [anon_sym_PIPE_PIPE] = ACTIONS(3714),
    [sym__special_characters] = ACTIONS(3714),
    [anon_sym_DQUOTE] = ACTIONS(3714),
    [sym_raw_string] = ACTIONS(3714),
    [anon_sym_DOLLAR] = ACTIONS(3714),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3714),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3714),
    [anon_sym_BQUOTE] = ACTIONS(3714),
    [anon_sym_LT_LPAREN] = ACTIONS(3714),
    [anon_sym_GT_LPAREN] = ACTIONS(3714),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3714),
    [sym_word] = ACTIONS(3714),
    [anon_sym_SEMI] = ACTIONS(3714),
    [anon_sym_LF] = ACTIONS(3714),
    [anon_sym_AMP] = ACTIONS(3714),
  },
  [1746] = {
    [sym__concat] = ACTIONS(3716),
    [sym_variable_name] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3718),
    [anon_sym_SEMI_SEMI] = ACTIONS(3718),
    [anon_sym_PIPE_AMP] = ACTIONS(3718),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [sym__special_characters] = ACTIONS(3718),
    [anon_sym_DQUOTE] = ACTIONS(3718),
    [sym_raw_string] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3718),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3718),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3718),
    [anon_sym_BQUOTE] = ACTIONS(3718),
    [anon_sym_LT_LPAREN] = ACTIONS(3718),
    [anon_sym_GT_LPAREN] = ACTIONS(3718),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3718),
    [sym_word] = ACTIONS(3718),
    [anon_sym_SEMI] = ACTIONS(3718),
    [anon_sym_LF] = ACTIONS(3718),
    [anon_sym_AMP] = ACTIONS(3718),
  },
  [1747] = {
    [sym_file_descriptor] = ACTIONS(3657),
    [sym__concat] = ACTIONS(3657),
    [sym_variable_name] = ACTIONS(3657),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(3657),
    [anon_sym_AMP_GT] = ACTIONS(4331),
    [anon_sym_AMP_GT_GT] = ACTIONS(3657),
    [anon_sym_LT_AMP] = ACTIONS(3657),
    [anon_sym_GT_AMP] = ACTIONS(3657),
    [sym__special_characters] = ACTIONS(4331),
    [anon_sym_DQUOTE] = ACTIONS(3657),
    [sym_raw_string] = ACTIONS(3657),
    [anon_sym_DOLLAR] = ACTIONS(4331),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3657),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3657),
    [anon_sym_BQUOTE] = ACTIONS(3657),
    [anon_sym_LT_LPAREN] = ACTIONS(3657),
    [anon_sym_GT_LPAREN] = ACTIONS(3657),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4331),
  },
  [1748] = {
    [sym_file_descriptor] = ACTIONS(3663),
    [sym__concat] = ACTIONS(3663),
    [sym_variable_name] = ACTIONS(3663),
    [anon_sym_LT] = ACTIONS(4333),
    [anon_sym_GT] = ACTIONS(4333),
    [anon_sym_GT_GT] = ACTIONS(3663),
    [anon_sym_AMP_GT] = ACTIONS(4333),
    [anon_sym_AMP_GT_GT] = ACTIONS(3663),
    [anon_sym_LT_AMP] = ACTIONS(3663),
    [anon_sym_GT_AMP] = ACTIONS(3663),
    [sym__special_characters] = ACTIONS(4333),
    [anon_sym_DQUOTE] = ACTIONS(3663),
    [sym_raw_string] = ACTIONS(3663),
    [anon_sym_DOLLAR] = ACTIONS(4333),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3663),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3663),
    [anon_sym_BQUOTE] = ACTIONS(3663),
    [anon_sym_LT_LPAREN] = ACTIONS(3663),
    [anon_sym_GT_LPAREN] = ACTIONS(3663),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4333),
  },
  [1749] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4351),
    [sym_comment] = ACTIONS(52),
  },
  [1750] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4353),
    [sym_comment] = ACTIONS(52),
  },
  [1751] = {
    [anon_sym_RBRACE] = ACTIONS(4353),
    [sym_comment] = ACTIONS(52),
  },
  [1752] = {
    [sym_file_descriptor] = ACTIONS(3712),
    [sym__concat] = ACTIONS(3712),
    [sym_variable_name] = ACTIONS(3712),
    [anon_sym_LT] = ACTIONS(4339),
    [anon_sym_GT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(3712),
    [anon_sym_AMP_GT] = ACTIONS(4339),
    [anon_sym_AMP_GT_GT] = ACTIONS(3712),
    [anon_sym_LT_AMP] = ACTIONS(3712),
    [anon_sym_GT_AMP] = ACTIONS(3712),
    [sym__special_characters] = ACTIONS(4339),
    [anon_sym_DQUOTE] = ACTIONS(3712),
    [sym_raw_string] = ACTIONS(3712),
    [anon_sym_DOLLAR] = ACTIONS(4339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3712),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3712),
    [anon_sym_BQUOTE] = ACTIONS(3712),
    [anon_sym_LT_LPAREN] = ACTIONS(3712),
    [anon_sym_GT_LPAREN] = ACTIONS(3712),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4339),
  },
  [1753] = {
    [sym_file_descriptor] = ACTIONS(3716),
    [sym__concat] = ACTIONS(3716),
    [sym_variable_name] = ACTIONS(3716),
    [anon_sym_LT] = ACTIONS(4341),
    [anon_sym_GT] = ACTIONS(4341),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_AMP_GT] = ACTIONS(4341),
    [anon_sym_AMP_GT_GT] = ACTIONS(3716),
    [anon_sym_LT_AMP] = ACTIONS(3716),
    [anon_sym_GT_AMP] = ACTIONS(3716),
    [sym__special_characters] = ACTIONS(4341),
    [anon_sym_DQUOTE] = ACTIONS(3716),
    [sym_raw_string] = ACTIONS(3716),
    [anon_sym_DOLLAR] = ACTIONS(4341),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3716),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3716),
    [anon_sym_BQUOTE] = ACTIONS(3716),
    [anon_sym_LT_LPAREN] = ACTIONS(3716),
    [anon_sym_GT_LPAREN] = ACTIONS(3716),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4341),
  },
  [1754] = {
    [sym__concat] = ACTIONS(3657),
    [anon_sym_DQUOTE] = ACTIONS(3659),
    [sym__string_content] = ACTIONS(4331),
    [anon_sym_DOLLAR] = ACTIONS(3659),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3659),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3659),
    [anon_sym_BQUOTE] = ACTIONS(3659),
    [sym_comment] = ACTIONS(168),
  },
  [1755] = {
    [sym__concat] = ACTIONS(3663),
    [anon_sym_DQUOTE] = ACTIONS(3665),
    [sym__string_content] = ACTIONS(4333),
    [anon_sym_DOLLAR] = ACTIONS(3665),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3665),
    [anon_sym_BQUOTE] = ACTIONS(3665),
    [sym_comment] = ACTIONS(168),
  },
  [1756] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4355),
    [sym_comment] = ACTIONS(52),
  },
  [1757] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4357),
    [sym_comment] = ACTIONS(52),
  },
  [1758] = {
    [anon_sym_RBRACE] = ACTIONS(4357),
    [sym_comment] = ACTIONS(52),
  },
  [1759] = {
    [sym__concat] = ACTIONS(3712),
    [anon_sym_DQUOTE] = ACTIONS(3714),
    [sym__string_content] = ACTIONS(4339),
    [anon_sym_DOLLAR] = ACTIONS(3714),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3714),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3714),
    [anon_sym_BQUOTE] = ACTIONS(3714),
    [sym_comment] = ACTIONS(168),
  },
  [1760] = {
    [sym__concat] = ACTIONS(3716),
    [anon_sym_DQUOTE] = ACTIONS(3718),
    [sym__string_content] = ACTIONS(4341),
    [anon_sym_DOLLAR] = ACTIONS(3718),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3718),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3718),
    [anon_sym_BQUOTE] = ACTIONS(3718),
    [sym_comment] = ACTIONS(168),
  },
  [1761] = {
    [sym__concat] = ACTIONS(4359),
    [anon_sym_RBRACE] = ACTIONS(3174),
    [anon_sym_EQ] = ACTIONS(4361),
    [sym__special_characters] = ACTIONS(4363),
    [anon_sym_DQUOTE] = ACTIONS(3174),
    [sym_raw_string] = ACTIONS(3174),
    [anon_sym_DOLLAR] = ACTIONS(4361),
    [anon_sym_POUND] = ACTIONS(3174),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3174),
    [anon_sym_COLON] = ACTIONS(4361),
    [anon_sym_COLON_QMARK] = ACTIONS(4361),
    [anon_sym_COLON_DASH] = ACTIONS(4361),
    [anon_sym_PERCENT] = ACTIONS(4361),
    [anon_sym_SLASH] = ACTIONS(4361),
    [anon_sym_DASH] = ACTIONS(4361),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3174),
    [anon_sym_BQUOTE] = ACTIONS(3174),
    [anon_sym_LT_LPAREN] = ACTIONS(3174),
    [anon_sym_GT_LPAREN] = ACTIONS(3174),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(4363),
  },
  [1762] = {
    [anon_sym_RBRACE] = ACTIONS(3174),
    [anon_sym_EQ] = ACTIONS(4361),
    [sym__special_characters] = ACTIONS(4363),
    [anon_sym_DQUOTE] = ACTIONS(3174),
    [sym_raw_string] = ACTIONS(3174),
    [anon_sym_DOLLAR] = ACTIONS(4361),
    [anon_sym_POUND] = ACTIONS(3174),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3174),
    [anon_sym_COLON] = ACTIONS(4361),
    [anon_sym_COLON_QMARK] = ACTIONS(4361),
    [anon_sym_COLON_DASH] = ACTIONS(4361),
    [anon_sym_PERCENT] = ACTIONS(4361),
    [anon_sym_SLASH] = ACTIONS(4361),
    [anon_sym_DASH] = ACTIONS(4361),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3174),
    [anon_sym_BQUOTE] = ACTIONS(3174),
    [anon_sym_LT_LPAREN] = ACTIONS(3174),
    [anon_sym_GT_LPAREN] = ACTIONS(3174),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(4363),
  },
  [1763] = {
    [sym__concat] = ACTIONS(4365),
    [anon_sym_RBRACE] = ACTIONS(3181),
    [anon_sym_EQ] = ACTIONS(4367),
    [sym__special_characters] = ACTIONS(4369),
    [anon_sym_DQUOTE] = ACTIONS(3181),
    [sym_raw_string] = ACTIONS(3181),
    [anon_sym_DOLLAR] = ACTIONS(4367),
    [anon_sym_POUND] = ACTIONS(3181),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3181),
    [anon_sym_COLON] = ACTIONS(4367),
    [anon_sym_COLON_QMARK] = ACTIONS(4367),
    [anon_sym_COLON_DASH] = ACTIONS(4367),
    [anon_sym_PERCENT] = ACTIONS(4367),
    [anon_sym_SLASH] = ACTIONS(4367),
    [anon_sym_DASH] = ACTIONS(4367),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3181),
    [anon_sym_BQUOTE] = ACTIONS(3181),
    [anon_sym_LT_LPAREN] = ACTIONS(3181),
    [anon_sym_GT_LPAREN] = ACTIONS(3181),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(4369),
  },
  [1764] = {
    [anon_sym_RBRACE] = ACTIONS(3181),
    [anon_sym_EQ] = ACTIONS(4367),
    [sym__special_characters] = ACTIONS(4369),
    [anon_sym_DQUOTE] = ACTIONS(3181),
    [sym_raw_string] = ACTIONS(3181),
    [anon_sym_DOLLAR] = ACTIONS(4367),
    [anon_sym_POUND] = ACTIONS(3181),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3181),
    [anon_sym_COLON] = ACTIONS(4367),
    [anon_sym_COLON_QMARK] = ACTIONS(4367),
    [anon_sym_COLON_DASH] = ACTIONS(4367),
    [anon_sym_PERCENT] = ACTIONS(4367),
    [anon_sym_SLASH] = ACTIONS(4367),
    [anon_sym_DASH] = ACTIONS(4367),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3181),
    [anon_sym_BQUOTE] = ACTIONS(3181),
    [anon_sym_LT_LPAREN] = ACTIONS(3181),
    [anon_sym_GT_LPAREN] = ACTIONS(3181),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(4369),
  },
  [1765] = {
    [sym__concat] = ACTIONS(1522),
    [anon_sym_RBRACE] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
  },
  [1766] = {
    [aux_sym_concatenation_repeat1] = STATE(1766),
    [sym__concat] = ACTIONS(4371),
    [anon_sym_RBRACE] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
  },
  [1767] = {
    [sym__concat] = ACTIONS(1553),
    [anon_sym_RBRACE] = ACTIONS(1553),
    [sym_comment] = ACTIONS(52),
  },
  [1768] = {
    [sym_concatenation] = STATE(2127),
    [sym_string] = STATE(2126),
    [sym_simple_expansion] = STATE(2126),
    [sym_expansion] = STATE(2126),
    [sym_command_substitution] = STATE(2126),
    [sym_process_substitution] = STATE(2126),
    [anon_sym_RBRACE] = ACTIONS(4374),
    [sym__special_characters] = ACTIONS(4376),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(4378),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4380),
  },
  [1769] = {
    [sym__concat] = ACTIONS(1598),
    [anon_sym_RBRACE] = ACTIONS(1598),
    [sym_comment] = ACTIONS(52),
  },
  [1770] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1771] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(4384),
    [sym_comment] = ACTIONS(52),
  },
  [1772] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2131),
    [anon_sym_RBRACE] = ACTIONS(4386),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1773] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2133),
    [anon_sym_RBRACE] = ACTIONS(4388),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1774] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2134),
    [anon_sym_RBRACE] = ACTIONS(4374),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1775] = {
    [sym__concat] = ACTIONS(1642),
    [anon_sym_RBRACE] = ACTIONS(1642),
    [sym_comment] = ACTIONS(52),
  },
  [1776] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4390),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1777] = {
    [sym__concat] = ACTIONS(1648),
    [anon_sym_RBRACE] = ACTIONS(1648),
    [sym_comment] = ACTIONS(52),
  },
  [1778] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4374),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1779] = {
    [sym__concat] = ACTIONS(1762),
    [anon_sym_RBRACE] = ACTIONS(1762),
    [sym_comment] = ACTIONS(52),
  },
  [1780] = {
    [sym__concat] = ACTIONS(1902),
    [anon_sym_RBRACE] = ACTIONS(1902),
    [sym_comment] = ACTIONS(52),
  },
  [1781] = {
    [sym__concat] = ACTIONS(2560),
    [anon_sym_RBRACE] = ACTIONS(2560),
    [anon_sym_EQ] = ACTIONS(3553),
    [sym__special_characters] = ACTIONS(2562),
    [anon_sym_DQUOTE] = ACTIONS(2560),
    [sym_raw_string] = ACTIONS(2560),
    [anon_sym_DOLLAR] = ACTIONS(3553),
    [anon_sym_POUND] = ACTIONS(2560),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2560),
    [anon_sym_COLON] = ACTIONS(3553),
    [anon_sym_COLON_QMARK] = ACTIONS(3553),
    [anon_sym_COLON_DASH] = ACTIONS(3553),
    [anon_sym_PERCENT] = ACTIONS(3553),
    [anon_sym_SLASH] = ACTIONS(3553),
    [anon_sym_DASH] = ACTIONS(3553),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2560),
    [anon_sym_BQUOTE] = ACTIONS(2560),
    [anon_sym_LT_LPAREN] = ACTIONS(2560),
    [anon_sym_GT_LPAREN] = ACTIONS(2560),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2562),
  },
  [1782] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4392),
    [sym_comment] = ACTIONS(52),
  },
  [1783] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4394),
    [sym_comment] = ACTIONS(52),
  },
  [1784] = {
    [anon_sym_RBRACE] = ACTIONS(4394),
    [sym_comment] = ACTIONS(52),
  },
  [1785] = {
    [sym__concat] = ACTIONS(2614),
    [anon_sym_RBRACE] = ACTIONS(2614),
    [anon_sym_EQ] = ACTIONS(3559),
    [sym__special_characters] = ACTIONS(2616),
    [anon_sym_DQUOTE] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(2614),
    [anon_sym_DOLLAR] = ACTIONS(3559),
    [anon_sym_POUND] = ACTIONS(2614),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2614),
    [anon_sym_COLON] = ACTIONS(3559),
    [anon_sym_COLON_QMARK] = ACTIONS(3559),
    [anon_sym_COLON_DASH] = ACTIONS(3559),
    [anon_sym_PERCENT] = ACTIONS(3559),
    [anon_sym_SLASH] = ACTIONS(3559),
    [anon_sym_DASH] = ACTIONS(3559),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2614),
    [anon_sym_BQUOTE] = ACTIONS(2614),
    [anon_sym_LT_LPAREN] = ACTIONS(2614),
    [anon_sym_GT_LPAREN] = ACTIONS(2614),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2616),
  },
  [1786] = {
    [sym_concatenation] = STATE(2140),
    [sym_string] = STATE(2139),
    [sym_simple_expansion] = STATE(2139),
    [sym_expansion] = STATE(2139),
    [sym_command_substitution] = STATE(2139),
    [sym_process_substitution] = STATE(2139),
    [anon_sym_RBRACE] = ACTIONS(4394),
    [sym__special_characters] = ACTIONS(4396),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(4398),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4400),
  },
  [1787] = {
    [sym__concat] = ACTIONS(2659),
    [anon_sym_RBRACE] = ACTIONS(2659),
    [anon_sym_EQ] = ACTIONS(3567),
    [sym__special_characters] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2659),
    [sym_raw_string] = ACTIONS(2659),
    [anon_sym_DOLLAR] = ACTIONS(3567),
    [anon_sym_POUND] = ACTIONS(2659),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2659),
    [anon_sym_COLON] = ACTIONS(3567),
    [anon_sym_COLON_QMARK] = ACTIONS(3567),
    [anon_sym_COLON_DASH] = ACTIONS(3567),
    [anon_sym_PERCENT] = ACTIONS(3567),
    [anon_sym_SLASH] = ACTIONS(3567),
    [anon_sym_DASH] = ACTIONS(3567),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2659),
    [anon_sym_BQUOTE] = ACTIONS(2659),
    [anon_sym_LT_LPAREN] = ACTIONS(2659),
    [anon_sym_GT_LPAREN] = ACTIONS(2659),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2661),
  },
  [1788] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4402),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1789] = {
    [sym__concat] = ACTIONS(2665),
    [anon_sym_RBRACE] = ACTIONS(2665),
    [anon_sym_EQ] = ACTIONS(3571),
    [sym__special_characters] = ACTIONS(2667),
    [anon_sym_DQUOTE] = ACTIONS(2665),
    [sym_raw_string] = ACTIONS(2665),
    [anon_sym_DOLLAR] = ACTIONS(3571),
    [anon_sym_POUND] = ACTIONS(2665),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2665),
    [anon_sym_COLON] = ACTIONS(3571),
    [anon_sym_COLON_QMARK] = ACTIONS(3571),
    [anon_sym_COLON_DASH] = ACTIONS(3571),
    [anon_sym_PERCENT] = ACTIONS(3571),
    [anon_sym_SLASH] = ACTIONS(3571),
    [anon_sym_DASH] = ACTIONS(3571),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2665),
    [anon_sym_BQUOTE] = ACTIONS(2665),
    [anon_sym_LT_LPAREN] = ACTIONS(2665),
    [anon_sym_GT_LPAREN] = ACTIONS(2665),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2667),
  },
  [1790] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4404),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1791] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4394),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1792] = {
    [sym__concat] = ACTIONS(2671),
    [anon_sym_RBRACE] = ACTIONS(2671),
    [anon_sym_EQ] = ACTIONS(3575),
    [sym__special_characters] = ACTIONS(2673),
    [anon_sym_DQUOTE] = ACTIONS(2671),
    [sym_raw_string] = ACTIONS(2671),
    [anon_sym_DOLLAR] = ACTIONS(3575),
    [anon_sym_POUND] = ACTIONS(2671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2671),
    [anon_sym_COLON] = ACTIONS(3575),
    [anon_sym_COLON_QMARK] = ACTIONS(3575),
    [anon_sym_COLON_DASH] = ACTIONS(3575),
    [anon_sym_PERCENT] = ACTIONS(3575),
    [anon_sym_SLASH] = ACTIONS(3575),
    [anon_sym_DASH] = ACTIONS(3575),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2671),
    [anon_sym_BQUOTE] = ACTIONS(2671),
    [anon_sym_LT_LPAREN] = ACTIONS(2671),
    [anon_sym_GT_LPAREN] = ACTIONS(2671),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2673),
  },
  [1793] = {
    [sym_file_descriptor] = ACTIONS(4406),
    [sym__concat] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_SEMI_SEMI] = ACTIONS(4408),
    [anon_sym_PIPE_AMP] = ACTIONS(4408),
    [anon_sym_AMP_AMP] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4408),
    [anon_sym_LT] = ACTIONS(4408),
    [anon_sym_GT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_AMP_GT] = ACTIONS(4408),
    [anon_sym_AMP_GT_GT] = ACTIONS(4408),
    [anon_sym_LT_AMP] = ACTIONS(4408),
    [anon_sym_GT_AMP] = ACTIONS(4408),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_LT_LT_DASH] = ACTIONS(4408),
    [anon_sym_LT_LT_LT] = ACTIONS(4408),
    [sym__special_characters] = ACTIONS(4408),
    [anon_sym_DQUOTE] = ACTIONS(4408),
    [sym_raw_string] = ACTIONS(4408),
    [anon_sym_DOLLAR] = ACTIONS(4408),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4408),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4408),
    [anon_sym_BQUOTE] = ACTIONS(4408),
    [anon_sym_LT_LPAREN] = ACTIONS(4408),
    [anon_sym_GT_LPAREN] = ACTIONS(4408),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(4408),
    [anon_sym_SEMI] = ACTIONS(4408),
    [anon_sym_LF] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4408),
  },
  [1794] = {
    [sym_file_descriptor] = ACTIONS(4410),
    [sym__concat] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4412),
    [anon_sym_SEMI_SEMI] = ACTIONS(4412),
    [anon_sym_PIPE_AMP] = ACTIONS(4412),
    [anon_sym_AMP_AMP] = ACTIONS(4412),
    [anon_sym_PIPE_PIPE] = ACTIONS(4412),
    [anon_sym_LT] = ACTIONS(4412),
    [anon_sym_GT] = ACTIONS(4412),
    [anon_sym_GT_GT] = ACTIONS(4412),
    [anon_sym_AMP_GT] = ACTIONS(4412),
    [anon_sym_AMP_GT_GT] = ACTIONS(4412),
    [anon_sym_LT_AMP] = ACTIONS(4412),
    [anon_sym_GT_AMP] = ACTIONS(4412),
    [anon_sym_LT_LT] = ACTIONS(4412),
    [anon_sym_LT_LT_DASH] = ACTIONS(4412),
    [anon_sym_LT_LT_LT] = ACTIONS(4412),
    [sym__special_characters] = ACTIONS(4412),
    [anon_sym_DQUOTE] = ACTIONS(4412),
    [sym_raw_string] = ACTIONS(4412),
    [anon_sym_DOLLAR] = ACTIONS(4412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4412),
    [anon_sym_BQUOTE] = ACTIONS(4412),
    [anon_sym_LT_LPAREN] = ACTIONS(4412),
    [anon_sym_GT_LPAREN] = ACTIONS(4412),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(4412),
    [anon_sym_SEMI] = ACTIONS(4412),
    [anon_sym_LF] = ACTIONS(4412),
    [anon_sym_AMP] = ACTIONS(4412),
  },
  [1795] = {
    [sym_file_descriptor] = ACTIONS(3227),
    [sym_variable_name] = ACTIONS(3227),
    [anon_sym_PIPE] = ACTIONS(4414),
    [anon_sym_RPAREN] = ACTIONS(3227),
    [anon_sym_PIPE_AMP] = ACTIONS(3227),
    [anon_sym_AMP_AMP] = ACTIONS(3227),
    [anon_sym_PIPE_PIPE] = ACTIONS(3227),
    [anon_sym_LT] = ACTIONS(4414),
    [anon_sym_GT] = ACTIONS(4414),
    [anon_sym_GT_GT] = ACTIONS(3227),
    [anon_sym_AMP_GT] = ACTIONS(4414),
    [anon_sym_AMP_GT_GT] = ACTIONS(3227),
    [anon_sym_LT_AMP] = ACTIONS(3227),
    [anon_sym_GT_AMP] = ACTIONS(3227),
    [sym__special_characters] = ACTIONS(4414),
    [anon_sym_DQUOTE] = ACTIONS(3227),
    [sym_raw_string] = ACTIONS(3227),
    [anon_sym_DOLLAR] = ACTIONS(4414),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3227),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3227),
    [anon_sym_BQUOTE] = ACTIONS(3227),
    [anon_sym_LT_LPAREN] = ACTIONS(3227),
    [anon_sym_GT_LPAREN] = ACTIONS(3227),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4414),
  },
  [1796] = {
    [sym_file_descriptor] = ACTIONS(1522),
    [sym__concat] = ACTIONS(1522),
    [sym_variable_name] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_RPAREN] = ACTIONS(1522),
    [anon_sym_PIPE_AMP] = ACTIONS(1522),
    [anon_sym_AMP_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1522),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_GT_GT] = ACTIONS(1522),
    [anon_sym_AMP_GT] = ACTIONS(2430),
    [anon_sym_AMP_GT_GT] = ACTIONS(1522),
    [anon_sym_LT_AMP] = ACTIONS(1522),
    [anon_sym_GT_AMP] = ACTIONS(1522),
    [sym__special_characters] = ACTIONS(2430),
    [anon_sym_DQUOTE] = ACTIONS(1522),
    [sym_raw_string] = ACTIONS(1522),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1522),
    [anon_sym_BQUOTE] = ACTIONS(1522),
    [anon_sym_LT_LPAREN] = ACTIONS(1522),
    [anon_sym_GT_LPAREN] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2430),
  },
  [1797] = {
    [aux_sym_concatenation_repeat1] = STATE(1797),
    [sym_file_descriptor] = ACTIONS(1522),
    [sym__concat] = ACTIONS(4416),
    [sym_variable_name] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_RPAREN] = ACTIONS(1522),
    [anon_sym_PIPE_AMP] = ACTIONS(1522),
    [anon_sym_AMP_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1522),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_GT_GT] = ACTIONS(1522),
    [anon_sym_AMP_GT] = ACTIONS(2430),
    [anon_sym_AMP_GT_GT] = ACTIONS(1522),
    [anon_sym_LT_AMP] = ACTIONS(1522),
    [anon_sym_GT_AMP] = ACTIONS(1522),
    [sym__special_characters] = ACTIONS(2430),
    [anon_sym_DQUOTE] = ACTIONS(1522),
    [sym_raw_string] = ACTIONS(1522),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1522),
    [anon_sym_BQUOTE] = ACTIONS(1522),
    [anon_sym_LT_LPAREN] = ACTIONS(1522),
    [anon_sym_GT_LPAREN] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2430),
  },
  [1798] = {
    [sym_file_descriptor] = ACTIONS(1553),
    [sym__concat] = ACTIONS(1553),
    [sym_variable_name] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(2435),
    [anon_sym_RPAREN] = ACTIONS(1553),
    [anon_sym_PIPE_AMP] = ACTIONS(1553),
    [anon_sym_AMP_AMP] = ACTIONS(1553),
    [anon_sym_PIPE_PIPE] = ACTIONS(1553),
    [anon_sym_LT] = ACTIONS(2435),
    [anon_sym_GT] = ACTIONS(2435),
    [anon_sym_GT_GT] = ACTIONS(1553),
    [anon_sym_AMP_GT] = ACTIONS(2435),
    [anon_sym_AMP_GT_GT] = ACTIONS(1553),
    [anon_sym_LT_AMP] = ACTIONS(1553),
    [anon_sym_GT_AMP] = ACTIONS(1553),
    [sym__special_characters] = ACTIONS(2435),
    [anon_sym_DQUOTE] = ACTIONS(1553),
    [sym_raw_string] = ACTIONS(1553),
    [anon_sym_DOLLAR] = ACTIONS(2435),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1553),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1553),
    [anon_sym_BQUOTE] = ACTIONS(1553),
    [anon_sym_LT_LPAREN] = ACTIONS(1553),
    [anon_sym_GT_LPAREN] = ACTIONS(1553),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2435),
  },
  [1799] = {
    [sym_concatenation] = STATE(2146),
    [sym_string] = STATE(2145),
    [sym_simple_expansion] = STATE(2145),
    [sym_expansion] = STATE(2145),
    [sym_command_substitution] = STATE(2145),
    [sym_process_substitution] = STATE(2145),
    [anon_sym_RBRACE] = ACTIONS(4419),
    [sym__special_characters] = ACTIONS(4421),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(4423),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4425),
  },
  [1800] = {
    [sym_file_descriptor] = ACTIONS(1598),
    [sym__concat] = ACTIONS(1598),
    [sym_variable_name] = ACTIONS(1598),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_RPAREN] = ACTIONS(1598),
    [anon_sym_PIPE_AMP] = ACTIONS(1598),
    [anon_sym_AMP_AMP] = ACTIONS(1598),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_LT] = ACTIONS(2445),
    [anon_sym_GT] = ACTIONS(2445),
    [anon_sym_GT_GT] = ACTIONS(1598),
    [anon_sym_AMP_GT] = ACTIONS(2445),
    [anon_sym_AMP_GT_GT] = ACTIONS(1598),
    [anon_sym_LT_AMP] = ACTIONS(1598),
    [anon_sym_GT_AMP] = ACTIONS(1598),
    [sym__special_characters] = ACTIONS(2445),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [sym_raw_string] = ACTIONS(1598),
    [anon_sym_DOLLAR] = ACTIONS(2445),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1598),
    [anon_sym_BQUOTE] = ACTIONS(1598),
    [anon_sym_LT_LPAREN] = ACTIONS(1598),
    [anon_sym_GT_LPAREN] = ACTIONS(1598),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2445),
  },
  [1801] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4427),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1802] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(4429),
    [sym_comment] = ACTIONS(52),
  },
  [1803] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2150),
    [anon_sym_RBRACE] = ACTIONS(4431),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1804] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2152),
    [anon_sym_RBRACE] = ACTIONS(4433),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1805] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2153),
    [anon_sym_RBRACE] = ACTIONS(4419),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1806] = {
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(1642),
    [sym_variable_name] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(2455),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [anon_sym_LT] = ACTIONS(2455),
    [anon_sym_GT] = ACTIONS(2455),
    [anon_sym_GT_GT] = ACTIONS(1642),
    [anon_sym_AMP_GT] = ACTIONS(2455),
    [anon_sym_AMP_GT_GT] = ACTIONS(1642),
    [anon_sym_LT_AMP] = ACTIONS(1642),
    [anon_sym_GT_AMP] = ACTIONS(1642),
    [sym__special_characters] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [sym_raw_string] = ACTIONS(1642),
    [anon_sym_DOLLAR] = ACTIONS(2455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [anon_sym_LT_LPAREN] = ACTIONS(1642),
    [anon_sym_GT_LPAREN] = ACTIONS(1642),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2455),
  },
  [1807] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4435),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1808] = {
    [sym_file_descriptor] = ACTIONS(1648),
    [sym__concat] = ACTIONS(1648),
    [sym_variable_name] = ACTIONS(1648),
    [anon_sym_PIPE] = ACTIONS(2459),
    [anon_sym_RPAREN] = ACTIONS(1648),
    [anon_sym_PIPE_AMP] = ACTIONS(1648),
    [anon_sym_AMP_AMP] = ACTIONS(1648),
    [anon_sym_PIPE_PIPE] = ACTIONS(1648),
    [anon_sym_LT] = ACTIONS(2459),
    [anon_sym_GT] = ACTIONS(2459),
    [anon_sym_GT_GT] = ACTIONS(1648),
    [anon_sym_AMP_GT] = ACTIONS(2459),
    [anon_sym_AMP_GT_GT] = ACTIONS(1648),
    [anon_sym_LT_AMP] = ACTIONS(1648),
    [anon_sym_GT_AMP] = ACTIONS(1648),
    [sym__special_characters] = ACTIONS(2459),
    [anon_sym_DQUOTE] = ACTIONS(1648),
    [sym_raw_string] = ACTIONS(1648),
    [anon_sym_DOLLAR] = ACTIONS(2459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1648),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1648),
    [anon_sym_BQUOTE] = ACTIONS(1648),
    [anon_sym_LT_LPAREN] = ACTIONS(1648),
    [anon_sym_GT_LPAREN] = ACTIONS(1648),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2459),
  },
  [1809] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4419),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1810] = {
    [sym_file_descriptor] = ACTIONS(1762),
    [sym__concat] = ACTIONS(1762),
    [sym_variable_name] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(2461),
    [anon_sym_RPAREN] = ACTIONS(1762),
    [anon_sym_PIPE_AMP] = ACTIONS(1762),
    [anon_sym_AMP_AMP] = ACTIONS(1762),
    [anon_sym_PIPE_PIPE] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(2461),
    [anon_sym_GT] = ACTIONS(2461),
    [anon_sym_GT_GT] = ACTIONS(1762),
    [anon_sym_AMP_GT] = ACTIONS(2461),
    [anon_sym_AMP_GT_GT] = ACTIONS(1762),
    [anon_sym_LT_AMP] = ACTIONS(1762),
    [anon_sym_GT_AMP] = ACTIONS(1762),
    [sym__special_characters] = ACTIONS(2461),
    [anon_sym_DQUOTE] = ACTIONS(1762),
    [sym_raw_string] = ACTIONS(1762),
    [anon_sym_DOLLAR] = ACTIONS(2461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1762),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1762),
    [anon_sym_BQUOTE] = ACTIONS(1762),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2461),
  },
  [1811] = {
    [sym_file_descriptor] = ACTIONS(1902),
    [sym__concat] = ACTIONS(1902),
    [sym_variable_name] = ACTIONS(1902),
    [anon_sym_PIPE] = ACTIONS(2463),
    [anon_sym_RPAREN] = ACTIONS(1902),
    [anon_sym_PIPE_AMP] = ACTIONS(1902),
    [anon_sym_AMP_AMP] = ACTIONS(1902),
    [anon_sym_PIPE_PIPE] = ACTIONS(1902),
    [anon_sym_LT] = ACTIONS(2463),
    [anon_sym_GT] = ACTIONS(2463),
    [anon_sym_GT_GT] = ACTIONS(1902),
    [anon_sym_AMP_GT] = ACTIONS(2463),
    [anon_sym_AMP_GT_GT] = ACTIONS(1902),
    [anon_sym_LT_AMP] = ACTIONS(1902),
    [anon_sym_GT_AMP] = ACTIONS(1902),
    [sym__special_characters] = ACTIONS(2463),
    [anon_sym_DQUOTE] = ACTIONS(1902),
    [sym_raw_string] = ACTIONS(1902),
    [anon_sym_DOLLAR] = ACTIONS(2463),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1902),
    [anon_sym_BQUOTE] = ACTIONS(1902),
    [anon_sym_LT_LPAREN] = ACTIONS(1902),
    [anon_sym_GT_LPAREN] = ACTIONS(1902),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2463),
  },
  [1812] = {
    [sym_do_group] = STATE(2156),
    [anon_sym_do] = ACTIONS(4437),
    [sym_comment] = ACTIONS(52),
  },
  [1813] = {
    [sym_file_descriptor] = ACTIONS(3331),
    [anon_sym_PIPE] = ACTIONS(4439),
    [anon_sym_RPAREN] = ACTIONS(3331),
    [anon_sym_PIPE_AMP] = ACTIONS(3331),
    [anon_sym_AMP_AMP] = ACTIONS(3331),
    [anon_sym_PIPE_PIPE] = ACTIONS(3331),
    [anon_sym_LT] = ACTIONS(4439),
    [anon_sym_GT] = ACTIONS(4439),
    [anon_sym_GT_GT] = ACTIONS(3331),
    [anon_sym_AMP_GT] = ACTIONS(4439),
    [anon_sym_AMP_GT_GT] = ACTIONS(3331),
    [anon_sym_LT_AMP] = ACTIONS(3331),
    [anon_sym_GT_AMP] = ACTIONS(3331),
    [anon_sym_LT_LT] = ACTIONS(4439),
    [anon_sym_LT_LT_DASH] = ACTIONS(3331),
    [anon_sym_LT_LT_LT] = ACTIONS(3331),
    [anon_sym_BQUOTE] = ACTIONS(3331),
    [sym_comment] = ACTIONS(52),
  },
  [1814] = {
    [anon_sym_PIPE] = ACTIONS(4441),
    [anon_sym_RPAREN] = ACTIONS(4443),
    [anon_sym_PIPE_AMP] = ACTIONS(4443),
    [anon_sym_AMP_AMP] = ACTIONS(4443),
    [anon_sym_PIPE_PIPE] = ACTIONS(4443),
    [anon_sym_BQUOTE] = ACTIONS(4443),
    [sym_comment] = ACTIONS(52),
  },
  [1815] = {
    [anon_sym_fi] = ACTIONS(4445),
    [sym_comment] = ACTIONS(52),
  },
  [1816] = {
    [sym_elif_clause] = STATE(613),
    [sym_else_clause] = STATE(2158),
    [aux_sym_if_statement_repeat1] = STATE(1110),
    [anon_sym_fi] = ACTIONS(4445),
    [anon_sym_elif] = ACTIONS(2168),
    [anon_sym_else] = ACTIONS(2170),
    [sym_comment] = ACTIONS(52),
  },
  [1817] = {
    [anon_sym_PIPE] = ACTIONS(4447),
    [anon_sym_RPAREN] = ACTIONS(4449),
    [anon_sym_PIPE_AMP] = ACTIONS(4449),
    [anon_sym_AMP_AMP] = ACTIONS(4449),
    [anon_sym_PIPE_PIPE] = ACTIONS(4449),
    [anon_sym_BQUOTE] = ACTIONS(4449),
    [sym_comment] = ACTIONS(52),
  },
  [1818] = {
    [anon_sym_esac] = ACTIONS(4451),
    [sym_comment] = ACTIONS(52),
  },
  [1819] = {
    [sym_case_item] = STATE(1120),
    [sym_last_case_item] = STATE(2160),
    [sym_concatenation] = STATE(1122),
    [sym_string] = STATE(1114),
    [sym_simple_expansion] = STATE(1114),
    [sym_expansion] = STATE(1114),
    [sym_command_substitution] = STATE(1114),
    [sym_process_substitution] = STATE(1114),
    [aux_sym_case_statement_repeat1] = STATE(1628),
    [sym__special_characters] = ACTIONS(2174),
    [anon_sym_DQUOTE] = ACTIONS(2176),
    [sym_raw_string] = ACTIONS(2178),
    [anon_sym_DOLLAR] = ACTIONS(2180),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2182),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2184),
    [anon_sym_BQUOTE] = ACTIONS(2186),
    [anon_sym_LT_LPAREN] = ACTIONS(2188),
    [anon_sym_GT_LPAREN] = ACTIONS(2188),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3386),
  },
  [1820] = {
    [sym_case_item] = STATE(1120),
    [sym_last_case_item] = STATE(2160),
    [sym_concatenation] = STATE(1122),
    [sym_string] = STATE(1114),
    [sym_simple_expansion] = STATE(1114),
    [sym_expansion] = STATE(1114),
    [sym_command_substitution] = STATE(1114),
    [sym_process_substitution] = STATE(1114),
    [aux_sym_case_statement_repeat1] = STATE(2162),
    [anon_sym_esac] = ACTIONS(4453),
    [sym__special_characters] = ACTIONS(2174),
    [anon_sym_DQUOTE] = ACTIONS(2176),
    [sym_raw_string] = ACTIONS(2178),
    [anon_sym_DOLLAR] = ACTIONS(2180),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2182),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2184),
    [anon_sym_BQUOTE] = ACTIONS(2186),
    [anon_sym_LT_LPAREN] = ACTIONS(2188),
    [anon_sym_GT_LPAREN] = ACTIONS(2188),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2190),
  },
  [1821] = {
    [anon_sym_PIPE] = ACTIONS(4455),
    [anon_sym_RPAREN] = ACTIONS(4457),
    [anon_sym_PIPE_AMP] = ACTIONS(4457),
    [anon_sym_AMP_AMP] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(4457),
    [anon_sym_BQUOTE] = ACTIONS(4457),
    [sym_comment] = ACTIONS(52),
  },
  [1822] = {
    [anon_sym_esac] = ACTIONS(4459),
    [sym_comment] = ACTIONS(52),
  },
  [1823] = {
    [sym_case_item] = STATE(1120),
    [sym_last_case_item] = STATE(2164),
    [sym_concatenation] = STATE(1122),
    [sym_string] = STATE(1114),
    [sym_simple_expansion] = STATE(1114),
    [sym_expansion] = STATE(1114),
    [sym_command_substitution] = STATE(1114),
    [sym_process_substitution] = STATE(1114),
    [aux_sym_case_statement_repeat1] = STATE(1628),
    [sym__special_characters] = ACTIONS(2174),
    [anon_sym_DQUOTE] = ACTIONS(2176),
    [sym_raw_string] = ACTIONS(2178),
    [anon_sym_DOLLAR] = ACTIONS(2180),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2182),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2184),
    [anon_sym_BQUOTE] = ACTIONS(2186),
    [anon_sym_LT_LPAREN] = ACTIONS(2188),
    [anon_sym_GT_LPAREN] = ACTIONS(2188),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3386),
  },
  [1824] = {
    [sym_case_item] = STATE(1120),
    [sym_last_case_item] = STATE(2164),
    [sym_concatenation] = STATE(1122),
    [sym_string] = STATE(1114),
    [sym_simple_expansion] = STATE(1114),
    [sym_expansion] = STATE(1114),
    [sym_command_substitution] = STATE(1114),
    [sym_process_substitution] = STATE(1114),
    [aux_sym_case_statement_repeat1] = STATE(2166),
    [anon_sym_esac] = ACTIONS(4461),
    [sym__special_characters] = ACTIONS(2174),
    [anon_sym_DQUOTE] = ACTIONS(2176),
    [sym_raw_string] = ACTIONS(2178),
    [anon_sym_DOLLAR] = ACTIONS(2180),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2182),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2184),
    [anon_sym_BQUOTE] = ACTIONS(2186),
    [anon_sym_LT_LPAREN] = ACTIONS(2188),
    [anon_sym_GT_LPAREN] = ACTIONS(2188),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2190),
  },
  [1825] = {
    [sym_file_redirect] = STATE(2167),
    [sym_file_descriptor] = ACTIONS(2721),
    [anon_sym_PIPE] = ACTIONS(4463),
    [anon_sym_RPAREN] = ACTIONS(4465),
    [anon_sym_PIPE_AMP] = ACTIONS(4465),
    [anon_sym_AMP_AMP] = ACTIONS(4465),
    [anon_sym_PIPE_PIPE] = ACTIONS(4465),
    [anon_sym_LT] = ACTIONS(2727),
    [anon_sym_GT] = ACTIONS(2727),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_AMP_GT] = ACTIONS(2727),
    [anon_sym_AMP_GT_GT] = ACTIONS(2729),
    [anon_sym_LT_AMP] = ACTIONS(2729),
    [anon_sym_GT_AMP] = ACTIONS(2729),
    [sym_comment] = ACTIONS(52),
  },
  [1826] = {
    [sym_file_descriptor] = ACTIONS(3412),
    [anon_sym_PIPE] = ACTIONS(4467),
    [anon_sym_RPAREN] = ACTIONS(3412),
    [anon_sym_PIPE_AMP] = ACTIONS(3412),
    [anon_sym_AMP_AMP] = ACTIONS(3412),
    [anon_sym_PIPE_PIPE] = ACTIONS(3412),
    [anon_sym_LT] = ACTIONS(4467),
    [anon_sym_GT] = ACTIONS(4467),
    [anon_sym_GT_GT] = ACTIONS(3412),
    [anon_sym_AMP_GT] = ACTIONS(4467),
    [anon_sym_AMP_GT_GT] = ACTIONS(3412),
    [anon_sym_LT_AMP] = ACTIONS(3412),
    [anon_sym_GT_AMP] = ACTIONS(3412),
    [anon_sym_BQUOTE] = ACTIONS(3412),
    [sym_comment] = ACTIONS(52),
  },
  [1827] = {
    [sym_concatenation] = STATE(2170),
    [sym_string] = STATE(2169),
    [sym_simple_expansion] = STATE(2169),
    [sym_expansion] = STATE(2169),
    [sym_command_substitution] = STATE(2169),
    [sym_process_substitution] = STATE(2169),
    [sym__special_characters] = ACTIONS(4469),
    [anon_sym_DQUOTE] = ACTIONS(3786),
    [sym_raw_string] = ACTIONS(4471),
    [anon_sym_DOLLAR] = ACTIONS(3790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3792),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3794),
    [anon_sym_BQUOTE] = ACTIONS(3796),
    [anon_sym_LT_LPAREN] = ACTIONS(3798),
    [anon_sym_GT_LPAREN] = ACTIONS(3798),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4473),
  },
  [1828] = {
    [aux_sym_concatenation_repeat1] = STATE(2172),
    [sym__concat] = ACTIONS(4475),
    [anon_sym_PIPE] = ACTIONS(618),
    [anon_sym_RPAREN] = ACTIONS(614),
    [anon_sym_PIPE_AMP] = ACTIONS(614),
    [anon_sym_AMP_AMP] = ACTIONS(614),
    [anon_sym_PIPE_PIPE] = ACTIONS(614),
    [sym_comment] = ACTIONS(52),
  },
  [1829] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(2174),
    [anon_sym_DQUOTE] = ACTIONS(4477),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [1830] = {
    [aux_sym_concatenation_repeat1] = STATE(2172),
    [sym__concat] = ACTIONS(4475),
    [anon_sym_PIPE] = ACTIONS(624),
    [anon_sym_RPAREN] = ACTIONS(622),
    [anon_sym_PIPE_AMP] = ACTIONS(622),
    [anon_sym_AMP_AMP] = ACTIONS(622),
    [anon_sym_PIPE_PIPE] = ACTIONS(622),
    [sym_comment] = ACTIONS(52),
  },
  [1831] = {
    [sym_string] = STATE(2177),
    [anon_sym_DQUOTE] = ACTIONS(3786),
    [anon_sym_DOLLAR] = ACTIONS(4479),
    [anon_sym_POUND] = ACTIONS(4479),
    [anon_sym_DASH] = ACTIONS(4479),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4481),
    [anon_sym_STAR] = ACTIONS(4479),
    [anon_sym_AT] = ACTIONS(4479),
    [anon_sym_QMARK] = ACTIONS(4479),
    [anon_sym_0] = ACTIONS(4483),
    [anon_sym__] = ACTIONS(4483),
  },
  [1832] = {
    [sym_subscript] = STATE(2182),
    [sym_variable_name] = ACTIONS(4485),
    [anon_sym_DOLLAR] = ACTIONS(4487),
    [anon_sym_POUND] = ACTIONS(4489),
    [anon_sym_DASH] = ACTIONS(4487),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4491),
    [anon_sym_STAR] = ACTIONS(4487),
    [anon_sym_AT] = ACTIONS(4487),
    [anon_sym_QMARK] = ACTIONS(4487),
    [anon_sym_0] = ACTIONS(4493),
    [anon_sym__] = ACTIONS(4493),
  },
  [1833] = {
    [sym_for_statement] = STATE(2183),
    [sym_while_statement] = STATE(2183),
    [sym_if_statement] = STATE(2183),
    [sym_case_statement] = STATE(2183),
    [sym_function_definition] = STATE(2183),
    [sym_subshell] = STATE(2183),
    [sym_pipeline] = STATE(2183),
    [sym_list] = STATE(2183),
    [sym_bracket_command] = STATE(2183),
    [sym_command] = STATE(2183),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(2184),
    [sym_declaration_command] = STATE(2183),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [1834] = {
    [sym_for_statement] = STATE(2185),
    [sym_while_statement] = STATE(2185),
    [sym_if_statement] = STATE(2185),
    [sym_case_statement] = STATE(2185),
    [sym_function_definition] = STATE(2185),
    [sym_subshell] = STATE(2185),
    [sym_pipeline] = STATE(2185),
    [sym_list] = STATE(2185),
    [sym_bracket_command] = STATE(2185),
    [sym_command] = STATE(2185),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(2186),
    [sym_declaration_command] = STATE(2185),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [1835] = {
    [sym_for_statement] = STATE(2187),
    [sym_while_statement] = STATE(2187),
    [sym_if_statement] = STATE(2187),
    [sym_case_statement] = STATE(2187),
    [sym_function_definition] = STATE(2187),
    [sym_subshell] = STATE(2187),
    [sym_pipeline] = STATE(2187),
    [sym_list] = STATE(2187),
    [sym_bracket_command] = STATE(2187),
    [sym_command] = STATE(2187),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(2188),
    [sym_declaration_command] = STATE(2187),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [1836] = {
    [anon_sym_PIPE] = ACTIONS(624),
    [anon_sym_RPAREN] = ACTIONS(622),
    [anon_sym_PIPE_AMP] = ACTIONS(622),
    [anon_sym_AMP_AMP] = ACTIONS(622),
    [anon_sym_PIPE_PIPE] = ACTIONS(622),
    [anon_sym_BQUOTE] = ACTIONS(622),
    [sym_comment] = ACTIONS(52),
  },
  [1837] = {
    [anon_sym_PIPE] = ACTIONS(4495),
    [anon_sym_RPAREN] = ACTIONS(4497),
    [anon_sym_PIPE_AMP] = ACTIONS(4497),
    [anon_sym_AMP_AMP] = ACTIONS(4497),
    [anon_sym_PIPE_PIPE] = ACTIONS(4497),
    [anon_sym_BQUOTE] = ACTIONS(4497),
    [sym_comment] = ACTIONS(52),
  },
  [1838] = {
    [sym_variable_name] = ACTIONS(2056),
    [anon_sym_PIPE] = ACTIONS(3720),
    [anon_sym_RPAREN] = ACTIONS(2056),
    [anon_sym_PIPE_AMP] = ACTIONS(2056),
    [anon_sym_AMP_AMP] = ACTIONS(2056),
    [anon_sym_PIPE_PIPE] = ACTIONS(2056),
    [sym__special_characters] = ACTIONS(3720),
    [anon_sym_DQUOTE] = ACTIONS(2056),
    [sym_raw_string] = ACTIONS(2056),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2056),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2056),
    [anon_sym_BQUOTE] = ACTIONS(2056),
    [anon_sym_LT_LPAREN] = ACTIONS(2056),
    [anon_sym_GT_LPAREN] = ACTIONS(2056),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3720),
    [sym_word] = ACTIONS(2058),
  },
  [1839] = {
    [sym_concatenation] = STATE(572),
    [sym_string] = STATE(566),
    [sym_simple_expansion] = STATE(566),
    [sym_expansion] = STATE(566),
    [sym_command_substitution] = STATE(566),
    [sym_process_substitution] = STATE(566),
    [aux_sym_for_statement_repeat1] = STATE(1060),
    [anon_sym_RPAREN] = ACTIONS(4499),
    [sym__special_characters] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1076),
    [sym_raw_string] = ACTIONS(1078),
    [anon_sym_DOLLAR] = ACTIONS(1080),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1084),
    [anon_sym_BQUOTE] = ACTIONS(1086),
    [anon_sym_LT_LPAREN] = ACTIONS(1088),
    [anon_sym_GT_LPAREN] = ACTIONS(1088),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1090),
  },
  [1840] = {
    [sym__concat] = ACTIONS(2560),
    [sym_variable_name] = ACTIONS(2560),
    [anon_sym_PIPE] = ACTIONS(3553),
    [anon_sym_RPAREN] = ACTIONS(2560),
    [anon_sym_PIPE_AMP] = ACTIONS(2560),
    [anon_sym_AMP_AMP] = ACTIONS(2560),
    [anon_sym_PIPE_PIPE] = ACTIONS(2560),
    [sym__special_characters] = ACTIONS(3553),
    [anon_sym_DQUOTE] = ACTIONS(2560),
    [sym_raw_string] = ACTIONS(2560),
    [anon_sym_DOLLAR] = ACTIONS(3553),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2560),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2560),
    [anon_sym_BQUOTE] = ACTIONS(2560),
    [anon_sym_LT_LPAREN] = ACTIONS(2560),
    [anon_sym_GT_LPAREN] = ACTIONS(2560),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3553),
    [sym_word] = ACTIONS(2562),
  },
  [1841] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4501),
    [sym_comment] = ACTIONS(52),
  },
  [1842] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4503),
    [sym_comment] = ACTIONS(52),
  },
  [1843] = {
    [anon_sym_RBRACE] = ACTIONS(4503),
    [sym_comment] = ACTIONS(52),
  },
  [1844] = {
    [sym__concat] = ACTIONS(2614),
    [sym_variable_name] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(3559),
    [anon_sym_RPAREN] = ACTIONS(2614),
    [anon_sym_PIPE_AMP] = ACTIONS(2614),
    [anon_sym_AMP_AMP] = ACTIONS(2614),
    [anon_sym_PIPE_PIPE] = ACTIONS(2614),
    [sym__special_characters] = ACTIONS(3559),
    [anon_sym_DQUOTE] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(2614),
    [anon_sym_DOLLAR] = ACTIONS(3559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2614),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2614),
    [anon_sym_BQUOTE] = ACTIONS(2614),
    [anon_sym_LT_LPAREN] = ACTIONS(2614),
    [anon_sym_GT_LPAREN] = ACTIONS(2614),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3559),
    [sym_word] = ACTIONS(2616),
  },
  [1845] = {
    [sym_concatenation] = STATE(2194),
    [sym_string] = STATE(2193),
    [sym_simple_expansion] = STATE(2193),
    [sym_expansion] = STATE(2193),
    [sym_command_substitution] = STATE(2193),
    [sym_process_substitution] = STATE(2193),
    [anon_sym_RBRACE] = ACTIONS(4503),
    [sym__special_characters] = ACTIONS(4505),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(4507),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4509),
  },
  [1846] = {
    [sym__concat] = ACTIONS(2659),
    [sym_variable_name] = ACTIONS(2659),
    [anon_sym_PIPE] = ACTIONS(3567),
    [anon_sym_RPAREN] = ACTIONS(2659),
    [anon_sym_PIPE_AMP] = ACTIONS(2659),
    [anon_sym_AMP_AMP] = ACTIONS(2659),
    [anon_sym_PIPE_PIPE] = ACTIONS(2659),
    [sym__special_characters] = ACTIONS(3567),
    [anon_sym_DQUOTE] = ACTIONS(2659),
    [sym_raw_string] = ACTIONS(2659),
    [anon_sym_DOLLAR] = ACTIONS(3567),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2659),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2659),
    [anon_sym_BQUOTE] = ACTIONS(2659),
    [anon_sym_LT_LPAREN] = ACTIONS(2659),
    [anon_sym_GT_LPAREN] = ACTIONS(2659),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3567),
    [sym_word] = ACTIONS(2661),
  },
  [1847] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4511),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1848] = {
    [sym__concat] = ACTIONS(2665),
    [sym_variable_name] = ACTIONS(2665),
    [anon_sym_PIPE] = ACTIONS(3571),
    [anon_sym_RPAREN] = ACTIONS(2665),
    [anon_sym_PIPE_AMP] = ACTIONS(2665),
    [anon_sym_AMP_AMP] = ACTIONS(2665),
    [anon_sym_PIPE_PIPE] = ACTIONS(2665),
    [sym__special_characters] = ACTIONS(3571),
    [anon_sym_DQUOTE] = ACTIONS(2665),
    [sym_raw_string] = ACTIONS(2665),
    [anon_sym_DOLLAR] = ACTIONS(3571),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2665),
    [anon_sym_BQUOTE] = ACTIONS(2665),
    [anon_sym_LT_LPAREN] = ACTIONS(2665),
    [anon_sym_GT_LPAREN] = ACTIONS(2665),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3571),
    [sym_word] = ACTIONS(2667),
  },
  [1849] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4513),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1850] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4503),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1851] = {
    [sym__concat] = ACTIONS(2671),
    [sym_variable_name] = ACTIONS(2671),
    [anon_sym_PIPE] = ACTIONS(3575),
    [anon_sym_RPAREN] = ACTIONS(2671),
    [anon_sym_PIPE_AMP] = ACTIONS(2671),
    [anon_sym_AMP_AMP] = ACTIONS(2671),
    [anon_sym_PIPE_PIPE] = ACTIONS(2671),
    [sym__special_characters] = ACTIONS(3575),
    [anon_sym_DQUOTE] = ACTIONS(2671),
    [sym_raw_string] = ACTIONS(2671),
    [anon_sym_DOLLAR] = ACTIONS(3575),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2671),
    [anon_sym_BQUOTE] = ACTIONS(2671),
    [anon_sym_LT_LPAREN] = ACTIONS(2671),
    [anon_sym_GT_LPAREN] = ACTIONS(2671),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3575),
    [sym_word] = ACTIONS(2673),
  },
  [1852] = {
    [sym_file_descriptor] = ACTIONS(3657),
    [sym__concat] = ACTIONS(3657),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_RPAREN] = ACTIONS(3657),
    [anon_sym_PIPE_AMP] = ACTIONS(3657),
    [anon_sym_AMP_AMP] = ACTIONS(3657),
    [anon_sym_PIPE_PIPE] = ACTIONS(3657),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(3657),
    [anon_sym_AMP_GT] = ACTIONS(4331),
    [anon_sym_AMP_GT_GT] = ACTIONS(3657),
    [anon_sym_LT_AMP] = ACTIONS(3657),
    [anon_sym_GT_AMP] = ACTIONS(3657),
    [anon_sym_LT_LT] = ACTIONS(4331),
    [anon_sym_LT_LT_DASH] = ACTIONS(3657),
    [anon_sym_LT_LT_LT] = ACTIONS(3657),
    [sym__special_characters] = ACTIONS(4331),
    [anon_sym_DQUOTE] = ACTIONS(3657),
    [sym_raw_string] = ACTIONS(3657),
    [anon_sym_DOLLAR] = ACTIONS(4331),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3657),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3657),
    [anon_sym_BQUOTE] = ACTIONS(3657),
    [anon_sym_LT_LPAREN] = ACTIONS(3657),
    [anon_sym_GT_LPAREN] = ACTIONS(3657),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4331),
  },
  [1853] = {
    [sym_file_descriptor] = ACTIONS(3663),
    [sym__concat] = ACTIONS(3663),
    [anon_sym_PIPE] = ACTIONS(4333),
    [anon_sym_RPAREN] = ACTIONS(3663),
    [anon_sym_PIPE_AMP] = ACTIONS(3663),
    [anon_sym_AMP_AMP] = ACTIONS(3663),
    [anon_sym_PIPE_PIPE] = ACTIONS(3663),
    [anon_sym_LT] = ACTIONS(4333),
    [anon_sym_GT] = ACTIONS(4333),
    [anon_sym_GT_GT] = ACTIONS(3663),
    [anon_sym_AMP_GT] = ACTIONS(4333),
    [anon_sym_AMP_GT_GT] = ACTIONS(3663),
    [anon_sym_LT_AMP] = ACTIONS(3663),
    [anon_sym_GT_AMP] = ACTIONS(3663),
    [anon_sym_LT_LT] = ACTIONS(4333),
    [anon_sym_LT_LT_DASH] = ACTIONS(3663),
    [anon_sym_LT_LT_LT] = ACTIONS(3663),
    [sym__special_characters] = ACTIONS(4333),
    [anon_sym_DQUOTE] = ACTIONS(3663),
    [sym_raw_string] = ACTIONS(3663),
    [anon_sym_DOLLAR] = ACTIONS(4333),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3663),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3663),
    [anon_sym_BQUOTE] = ACTIONS(3663),
    [anon_sym_LT_LPAREN] = ACTIONS(3663),
    [anon_sym_GT_LPAREN] = ACTIONS(3663),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4333),
  },
  [1854] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4515),
    [sym_comment] = ACTIONS(52),
  },
  [1855] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4517),
    [sym_comment] = ACTIONS(52),
  },
  [1856] = {
    [anon_sym_RBRACE] = ACTIONS(4517),
    [sym_comment] = ACTIONS(52),
  },
  [1857] = {
    [sym_file_descriptor] = ACTIONS(3712),
    [sym__concat] = ACTIONS(3712),
    [anon_sym_PIPE] = ACTIONS(4339),
    [anon_sym_RPAREN] = ACTIONS(3712),
    [anon_sym_PIPE_AMP] = ACTIONS(3712),
    [anon_sym_AMP_AMP] = ACTIONS(3712),
    [anon_sym_PIPE_PIPE] = ACTIONS(3712),
    [anon_sym_LT] = ACTIONS(4339),
    [anon_sym_GT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(3712),
    [anon_sym_AMP_GT] = ACTIONS(4339),
    [anon_sym_AMP_GT_GT] = ACTIONS(3712),
    [anon_sym_LT_AMP] = ACTIONS(3712),
    [anon_sym_GT_AMP] = ACTIONS(3712),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_LT_LT_DASH] = ACTIONS(3712),
    [anon_sym_LT_LT_LT] = ACTIONS(3712),
    [sym__special_characters] = ACTIONS(4339),
    [anon_sym_DQUOTE] = ACTIONS(3712),
    [sym_raw_string] = ACTIONS(3712),
    [anon_sym_DOLLAR] = ACTIONS(4339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3712),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3712),
    [anon_sym_BQUOTE] = ACTIONS(3712),
    [anon_sym_LT_LPAREN] = ACTIONS(3712),
    [anon_sym_GT_LPAREN] = ACTIONS(3712),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4339),
  },
  [1858] = {
    [sym_file_descriptor] = ACTIONS(3716),
    [sym__concat] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(4341),
    [anon_sym_RPAREN] = ACTIONS(3716),
    [anon_sym_PIPE_AMP] = ACTIONS(3716),
    [anon_sym_AMP_AMP] = ACTIONS(3716),
    [anon_sym_PIPE_PIPE] = ACTIONS(3716),
    [anon_sym_LT] = ACTIONS(4341),
    [anon_sym_GT] = ACTIONS(4341),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_AMP_GT] = ACTIONS(4341),
    [anon_sym_AMP_GT_GT] = ACTIONS(3716),
    [anon_sym_LT_AMP] = ACTIONS(3716),
    [anon_sym_GT_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(4341),
    [anon_sym_LT_LT_DASH] = ACTIONS(3716),
    [anon_sym_LT_LT_LT] = ACTIONS(3716),
    [sym__special_characters] = ACTIONS(4341),
    [anon_sym_DQUOTE] = ACTIONS(3716),
    [sym_raw_string] = ACTIONS(3716),
    [anon_sym_DOLLAR] = ACTIONS(4341),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3716),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3716),
    [anon_sym_BQUOTE] = ACTIONS(3716),
    [anon_sym_LT_LPAREN] = ACTIONS(3716),
    [anon_sym_GT_LPAREN] = ACTIONS(3716),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4341),
  },
  [1859] = {
    [anon_sym_PIPE] = ACTIONS(4463),
    [anon_sym_RPAREN] = ACTIONS(4465),
    [anon_sym_PIPE_AMP] = ACTIONS(4465),
    [anon_sym_AMP_AMP] = ACTIONS(4465),
    [anon_sym_PIPE_PIPE] = ACTIONS(4465),
    [anon_sym_BQUOTE] = ACTIONS(4465),
    [sym_comment] = ACTIONS(52),
  },
  [1860] = {
    [sym_file_descriptor] = ACTIONS(1522),
    [sym__concat] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_RPAREN] = ACTIONS(1522),
    [anon_sym_PIPE_AMP] = ACTIONS(1522),
    [anon_sym_AMP_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1522),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_GT_GT] = ACTIONS(1522),
    [anon_sym_AMP_GT] = ACTIONS(2430),
    [anon_sym_AMP_GT_GT] = ACTIONS(1522),
    [anon_sym_LT_AMP] = ACTIONS(1522),
    [anon_sym_GT_AMP] = ACTIONS(1522),
    [anon_sym_LT_LT] = ACTIONS(2430),
    [anon_sym_LT_LT_DASH] = ACTIONS(1522),
    [anon_sym_LT_LT_LT] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
  },
  [1861] = {
    [aux_sym_concatenation_repeat1] = STATE(1861),
    [sym_file_descriptor] = ACTIONS(1522),
    [sym__concat] = ACTIONS(4519),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_RPAREN] = ACTIONS(1522),
    [anon_sym_PIPE_AMP] = ACTIONS(1522),
    [anon_sym_AMP_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1522),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_GT_GT] = ACTIONS(1522),
    [anon_sym_AMP_GT] = ACTIONS(2430),
    [anon_sym_AMP_GT_GT] = ACTIONS(1522),
    [anon_sym_LT_AMP] = ACTIONS(1522),
    [anon_sym_GT_AMP] = ACTIONS(1522),
    [anon_sym_LT_LT] = ACTIONS(2430),
    [anon_sym_LT_LT_DASH] = ACTIONS(1522),
    [anon_sym_LT_LT_LT] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
  },
  [1862] = {
    [sym_file_descriptor] = ACTIONS(1553),
    [sym__concat] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(2435),
    [anon_sym_RPAREN] = ACTIONS(1553),
    [anon_sym_PIPE_AMP] = ACTIONS(1553),
    [anon_sym_AMP_AMP] = ACTIONS(1553),
    [anon_sym_PIPE_PIPE] = ACTIONS(1553),
    [anon_sym_LT] = ACTIONS(2435),
    [anon_sym_GT] = ACTIONS(2435),
    [anon_sym_GT_GT] = ACTIONS(1553),
    [anon_sym_AMP_GT] = ACTIONS(2435),
    [anon_sym_AMP_GT_GT] = ACTIONS(1553),
    [anon_sym_LT_AMP] = ACTIONS(1553),
    [anon_sym_GT_AMP] = ACTIONS(1553),
    [anon_sym_LT_LT] = ACTIONS(2435),
    [anon_sym_LT_LT_DASH] = ACTIONS(1553),
    [anon_sym_LT_LT_LT] = ACTIONS(1553),
    [sym_comment] = ACTIONS(52),
  },
  [1863] = {
    [sym_concatenation] = STATE(2202),
    [sym_string] = STATE(2201),
    [sym_simple_expansion] = STATE(2201),
    [sym_expansion] = STATE(2201),
    [sym_command_substitution] = STATE(2201),
    [sym_process_substitution] = STATE(2201),
    [anon_sym_RBRACE] = ACTIONS(4522),
    [sym__special_characters] = ACTIONS(4524),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(4526),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4528),
  },
  [1864] = {
    [sym_file_descriptor] = ACTIONS(1598),
    [sym__concat] = ACTIONS(1598),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_RPAREN] = ACTIONS(1598),
    [anon_sym_PIPE_AMP] = ACTIONS(1598),
    [anon_sym_AMP_AMP] = ACTIONS(1598),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_LT] = ACTIONS(2445),
    [anon_sym_GT] = ACTIONS(2445),
    [anon_sym_GT_GT] = ACTIONS(1598),
    [anon_sym_AMP_GT] = ACTIONS(2445),
    [anon_sym_AMP_GT_GT] = ACTIONS(1598),
    [anon_sym_LT_AMP] = ACTIONS(1598),
    [anon_sym_GT_AMP] = ACTIONS(1598),
    [anon_sym_LT_LT] = ACTIONS(2445),
    [anon_sym_LT_LT_DASH] = ACTIONS(1598),
    [anon_sym_LT_LT_LT] = ACTIONS(1598),
    [sym_comment] = ACTIONS(52),
  },
  [1865] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4530),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1866] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(4532),
    [sym_comment] = ACTIONS(52),
  },
  [1867] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2206),
    [anon_sym_RBRACE] = ACTIONS(4534),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1868] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2208),
    [anon_sym_RBRACE] = ACTIONS(4536),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1869] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2209),
    [anon_sym_RBRACE] = ACTIONS(4522),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1870] = {
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(2455),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [anon_sym_LT] = ACTIONS(2455),
    [anon_sym_GT] = ACTIONS(2455),
    [anon_sym_GT_GT] = ACTIONS(1642),
    [anon_sym_AMP_GT] = ACTIONS(2455),
    [anon_sym_AMP_GT_GT] = ACTIONS(1642),
    [anon_sym_LT_AMP] = ACTIONS(1642),
    [anon_sym_GT_AMP] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(2455),
    [anon_sym_LT_LT_DASH] = ACTIONS(1642),
    [anon_sym_LT_LT_LT] = ACTIONS(1642),
    [sym_comment] = ACTIONS(52),
  },
  [1871] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4538),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1872] = {
    [sym_file_descriptor] = ACTIONS(1648),
    [sym__concat] = ACTIONS(1648),
    [anon_sym_PIPE] = ACTIONS(2459),
    [anon_sym_RPAREN] = ACTIONS(1648),
    [anon_sym_PIPE_AMP] = ACTIONS(1648),
    [anon_sym_AMP_AMP] = ACTIONS(1648),
    [anon_sym_PIPE_PIPE] = ACTIONS(1648),
    [anon_sym_LT] = ACTIONS(2459),
    [anon_sym_GT] = ACTIONS(2459),
    [anon_sym_GT_GT] = ACTIONS(1648),
    [anon_sym_AMP_GT] = ACTIONS(2459),
    [anon_sym_AMP_GT_GT] = ACTIONS(1648),
    [anon_sym_LT_AMP] = ACTIONS(1648),
    [anon_sym_GT_AMP] = ACTIONS(1648),
    [anon_sym_LT_LT] = ACTIONS(2459),
    [anon_sym_LT_LT_DASH] = ACTIONS(1648),
    [anon_sym_LT_LT_LT] = ACTIONS(1648),
    [sym_comment] = ACTIONS(52),
  },
  [1873] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4522),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1874] = {
    [sym_file_descriptor] = ACTIONS(1762),
    [sym__concat] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(2461),
    [anon_sym_RPAREN] = ACTIONS(1762),
    [anon_sym_PIPE_AMP] = ACTIONS(1762),
    [anon_sym_AMP_AMP] = ACTIONS(1762),
    [anon_sym_PIPE_PIPE] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(2461),
    [anon_sym_GT] = ACTIONS(2461),
    [anon_sym_GT_GT] = ACTIONS(1762),
    [anon_sym_AMP_GT] = ACTIONS(2461),
    [anon_sym_AMP_GT_GT] = ACTIONS(1762),
    [anon_sym_LT_AMP] = ACTIONS(1762),
    [anon_sym_GT_AMP] = ACTIONS(1762),
    [anon_sym_LT_LT] = ACTIONS(2461),
    [anon_sym_LT_LT_DASH] = ACTIONS(1762),
    [anon_sym_LT_LT_LT] = ACTIONS(1762),
    [sym_comment] = ACTIONS(52),
  },
  [1875] = {
    [sym_file_descriptor] = ACTIONS(1902),
    [sym__concat] = ACTIONS(1902),
    [anon_sym_PIPE] = ACTIONS(2463),
    [anon_sym_RPAREN] = ACTIONS(1902),
    [anon_sym_PIPE_AMP] = ACTIONS(1902),
    [anon_sym_AMP_AMP] = ACTIONS(1902),
    [anon_sym_PIPE_PIPE] = ACTIONS(1902),
    [anon_sym_LT] = ACTIONS(2463),
    [anon_sym_GT] = ACTIONS(2463),
    [anon_sym_GT_GT] = ACTIONS(1902),
    [anon_sym_AMP_GT] = ACTIONS(2463),
    [anon_sym_AMP_GT_GT] = ACTIONS(1902),
    [anon_sym_LT_AMP] = ACTIONS(1902),
    [anon_sym_GT_AMP] = ACTIONS(1902),
    [anon_sym_LT_LT] = ACTIONS(2463),
    [anon_sym_LT_LT_DASH] = ACTIONS(1902),
    [anon_sym_LT_LT_LT] = ACTIONS(1902),
    [sym_comment] = ACTIONS(52),
  },
  [1876] = {
    [sym_file_descriptor] = ACTIONS(4031),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_RPAREN] = ACTIONS(4031),
    [anon_sym_PIPE_AMP] = ACTIONS(4031),
    [anon_sym_AMP_AMP] = ACTIONS(4031),
    [anon_sym_PIPE_PIPE] = ACTIONS(4031),
    [anon_sym_LT] = ACTIONS(4540),
    [anon_sym_GT] = ACTIONS(4540),
    [anon_sym_GT_GT] = ACTIONS(4031),
    [anon_sym_AMP_GT] = ACTIONS(4540),
    [anon_sym_AMP_GT_GT] = ACTIONS(4031),
    [anon_sym_LT_AMP] = ACTIONS(4031),
    [anon_sym_GT_AMP] = ACTIONS(4031),
    [anon_sym_LT_LT] = ACTIONS(4540),
    [anon_sym_LT_LT_DASH] = ACTIONS(4031),
    [anon_sym_LT_LT_LT] = ACTIONS(4031),
    [anon_sym_BQUOTE] = ACTIONS(4031),
    [sym_comment] = ACTIONS(52),
  },
  [1877] = {
    [sym_file_descriptor] = ACTIONS(1522),
    [sym__concat] = ACTIONS(1522),
    [sym_variable_name] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_PIPE_AMP] = ACTIONS(1522),
    [anon_sym_AMP_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1522),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_GT_GT] = ACTIONS(1522),
    [anon_sym_AMP_GT] = ACTIONS(2430),
    [anon_sym_AMP_GT_GT] = ACTIONS(1522),
    [anon_sym_LT_AMP] = ACTIONS(1522),
    [anon_sym_GT_AMP] = ACTIONS(1522),
    [sym__special_characters] = ACTIONS(2430),
    [anon_sym_DQUOTE] = ACTIONS(1522),
    [sym_raw_string] = ACTIONS(1522),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1522),
    [anon_sym_BQUOTE] = ACTIONS(1522),
    [anon_sym_LT_LPAREN] = ACTIONS(1522),
    [anon_sym_GT_LPAREN] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2430),
  },
  [1878] = {
    [aux_sym_concatenation_repeat1] = STATE(1878),
    [sym_file_descriptor] = ACTIONS(1522),
    [sym__concat] = ACTIONS(4542),
    [sym_variable_name] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_PIPE_AMP] = ACTIONS(1522),
    [anon_sym_AMP_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1522),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_GT_GT] = ACTIONS(1522),
    [anon_sym_AMP_GT] = ACTIONS(2430),
    [anon_sym_AMP_GT_GT] = ACTIONS(1522),
    [anon_sym_LT_AMP] = ACTIONS(1522),
    [anon_sym_GT_AMP] = ACTIONS(1522),
    [sym__special_characters] = ACTIONS(2430),
    [anon_sym_DQUOTE] = ACTIONS(1522),
    [sym_raw_string] = ACTIONS(1522),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1522),
    [anon_sym_BQUOTE] = ACTIONS(1522),
    [anon_sym_LT_LPAREN] = ACTIONS(1522),
    [anon_sym_GT_LPAREN] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2430),
  },
  [1879] = {
    [sym_file_descriptor] = ACTIONS(1553),
    [sym__concat] = ACTIONS(1553),
    [sym_variable_name] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(2435),
    [anon_sym_PIPE_AMP] = ACTIONS(1553),
    [anon_sym_AMP_AMP] = ACTIONS(1553),
    [anon_sym_PIPE_PIPE] = ACTIONS(1553),
    [anon_sym_LT] = ACTIONS(2435),
    [anon_sym_GT] = ACTIONS(2435),
    [anon_sym_GT_GT] = ACTIONS(1553),
    [anon_sym_AMP_GT] = ACTIONS(2435),
    [anon_sym_AMP_GT_GT] = ACTIONS(1553),
    [anon_sym_LT_AMP] = ACTIONS(1553),
    [anon_sym_GT_AMP] = ACTIONS(1553),
    [sym__special_characters] = ACTIONS(2435),
    [anon_sym_DQUOTE] = ACTIONS(1553),
    [sym_raw_string] = ACTIONS(1553),
    [anon_sym_DOLLAR] = ACTIONS(2435),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1553),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1553),
    [anon_sym_BQUOTE] = ACTIONS(1553),
    [anon_sym_LT_LPAREN] = ACTIONS(1553),
    [anon_sym_GT_LPAREN] = ACTIONS(1553),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2435),
  },
  [1880] = {
    [sym_concatenation] = STATE(2214),
    [sym_string] = STATE(2213),
    [sym_simple_expansion] = STATE(2213),
    [sym_expansion] = STATE(2213),
    [sym_command_substitution] = STATE(2213),
    [sym_process_substitution] = STATE(2213),
    [anon_sym_RBRACE] = ACTIONS(4545),
    [sym__special_characters] = ACTIONS(4547),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(4549),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4551),
  },
  [1881] = {
    [sym_file_descriptor] = ACTIONS(1598),
    [sym__concat] = ACTIONS(1598),
    [sym_variable_name] = ACTIONS(1598),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_PIPE_AMP] = ACTIONS(1598),
    [anon_sym_AMP_AMP] = ACTIONS(1598),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_LT] = ACTIONS(2445),
    [anon_sym_GT] = ACTIONS(2445),
    [anon_sym_GT_GT] = ACTIONS(1598),
    [anon_sym_AMP_GT] = ACTIONS(2445),
    [anon_sym_AMP_GT_GT] = ACTIONS(1598),
    [anon_sym_LT_AMP] = ACTIONS(1598),
    [anon_sym_GT_AMP] = ACTIONS(1598),
    [sym__special_characters] = ACTIONS(2445),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [sym_raw_string] = ACTIONS(1598),
    [anon_sym_DOLLAR] = ACTIONS(2445),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1598),
    [anon_sym_BQUOTE] = ACTIONS(1598),
    [anon_sym_LT_LPAREN] = ACTIONS(1598),
    [anon_sym_GT_LPAREN] = ACTIONS(1598),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2445),
  },
  [1882] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4553),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1883] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(4555),
    [sym_comment] = ACTIONS(52),
  },
  [1884] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2218),
    [anon_sym_RBRACE] = ACTIONS(4557),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1885] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2220),
    [anon_sym_RBRACE] = ACTIONS(4559),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1886] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2221),
    [anon_sym_RBRACE] = ACTIONS(4545),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1887] = {
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(1642),
    [sym_variable_name] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(2455),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [anon_sym_LT] = ACTIONS(2455),
    [anon_sym_GT] = ACTIONS(2455),
    [anon_sym_GT_GT] = ACTIONS(1642),
    [anon_sym_AMP_GT] = ACTIONS(2455),
    [anon_sym_AMP_GT_GT] = ACTIONS(1642),
    [anon_sym_LT_AMP] = ACTIONS(1642),
    [anon_sym_GT_AMP] = ACTIONS(1642),
    [sym__special_characters] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [sym_raw_string] = ACTIONS(1642),
    [anon_sym_DOLLAR] = ACTIONS(2455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [anon_sym_LT_LPAREN] = ACTIONS(1642),
    [anon_sym_GT_LPAREN] = ACTIONS(1642),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2455),
  },
  [1888] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4561),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1889] = {
    [sym_file_descriptor] = ACTIONS(1648),
    [sym__concat] = ACTIONS(1648),
    [sym_variable_name] = ACTIONS(1648),
    [anon_sym_PIPE] = ACTIONS(2459),
    [anon_sym_PIPE_AMP] = ACTIONS(1648),
    [anon_sym_AMP_AMP] = ACTIONS(1648),
    [anon_sym_PIPE_PIPE] = ACTIONS(1648),
    [anon_sym_LT] = ACTIONS(2459),
    [anon_sym_GT] = ACTIONS(2459),
    [anon_sym_GT_GT] = ACTIONS(1648),
    [anon_sym_AMP_GT] = ACTIONS(2459),
    [anon_sym_AMP_GT_GT] = ACTIONS(1648),
    [anon_sym_LT_AMP] = ACTIONS(1648),
    [anon_sym_GT_AMP] = ACTIONS(1648),
    [sym__special_characters] = ACTIONS(2459),
    [anon_sym_DQUOTE] = ACTIONS(1648),
    [sym_raw_string] = ACTIONS(1648),
    [anon_sym_DOLLAR] = ACTIONS(2459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1648),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1648),
    [anon_sym_BQUOTE] = ACTIONS(1648),
    [anon_sym_LT_LPAREN] = ACTIONS(1648),
    [anon_sym_GT_LPAREN] = ACTIONS(1648),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2459),
  },
  [1890] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4545),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1891] = {
    [sym_file_descriptor] = ACTIONS(1762),
    [sym__concat] = ACTIONS(1762),
    [sym_variable_name] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(2461),
    [anon_sym_PIPE_AMP] = ACTIONS(1762),
    [anon_sym_AMP_AMP] = ACTIONS(1762),
    [anon_sym_PIPE_PIPE] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(2461),
    [anon_sym_GT] = ACTIONS(2461),
    [anon_sym_GT_GT] = ACTIONS(1762),
    [anon_sym_AMP_GT] = ACTIONS(2461),
    [anon_sym_AMP_GT_GT] = ACTIONS(1762),
    [anon_sym_LT_AMP] = ACTIONS(1762),
    [anon_sym_GT_AMP] = ACTIONS(1762),
    [sym__special_characters] = ACTIONS(2461),
    [anon_sym_DQUOTE] = ACTIONS(1762),
    [sym_raw_string] = ACTIONS(1762),
    [anon_sym_DOLLAR] = ACTIONS(2461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1762),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1762),
    [anon_sym_BQUOTE] = ACTIONS(1762),
    [anon_sym_LT_LPAREN] = ACTIONS(1762),
    [anon_sym_GT_LPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2461),
  },
  [1892] = {
    [sym_file_descriptor] = ACTIONS(1902),
    [sym__concat] = ACTIONS(1902),
    [sym_variable_name] = ACTIONS(1902),
    [anon_sym_PIPE] = ACTIONS(2463),
    [anon_sym_PIPE_AMP] = ACTIONS(1902),
    [anon_sym_AMP_AMP] = ACTIONS(1902),
    [anon_sym_PIPE_PIPE] = ACTIONS(1902),
    [anon_sym_LT] = ACTIONS(2463),
    [anon_sym_GT] = ACTIONS(2463),
    [anon_sym_GT_GT] = ACTIONS(1902),
    [anon_sym_AMP_GT] = ACTIONS(2463),
    [anon_sym_AMP_GT_GT] = ACTIONS(1902),
    [anon_sym_LT_AMP] = ACTIONS(1902),
    [anon_sym_GT_AMP] = ACTIONS(1902),
    [sym__special_characters] = ACTIONS(2463),
    [anon_sym_DQUOTE] = ACTIONS(1902),
    [sym_raw_string] = ACTIONS(1902),
    [anon_sym_DOLLAR] = ACTIONS(2463),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1902),
    [anon_sym_BQUOTE] = ACTIONS(1902),
    [anon_sym_LT_LPAREN] = ACTIONS(1902),
    [anon_sym_GT_LPAREN] = ACTIONS(1902),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(2463),
  },
  [1893] = {
    [sym_file_redirect] = STATE(2167),
    [sym_file_descriptor] = ACTIONS(2956),
    [anon_sym_PIPE] = ACTIONS(4463),
    [anon_sym_PIPE_AMP] = ACTIONS(4465),
    [anon_sym_AMP_AMP] = ACTIONS(4465),
    [anon_sym_PIPE_PIPE] = ACTIONS(4465),
    [anon_sym_LT] = ACTIONS(2958),
    [anon_sym_GT] = ACTIONS(2958),
    [anon_sym_GT_GT] = ACTIONS(2960),
    [anon_sym_AMP_GT] = ACTIONS(2958),
    [anon_sym_AMP_GT_GT] = ACTIONS(2960),
    [anon_sym_LT_AMP] = ACTIONS(2960),
    [anon_sym_GT_AMP] = ACTIONS(2960),
    [anon_sym_BQUOTE] = ACTIONS(4465),
    [sym_comment] = ACTIONS(52),
  },
  [1894] = {
    [sym_concatenation] = STATE(2170),
    [sym_string] = STATE(2224),
    [sym_simple_expansion] = STATE(2224),
    [sym_expansion] = STATE(2224),
    [sym_command_substitution] = STATE(2224),
    [sym_process_substitution] = STATE(2224),
    [sym__special_characters] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(3915),
    [sym_raw_string] = ACTIONS(4565),
    [anon_sym_DOLLAR] = ACTIONS(3919),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3921),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3923),
    [anon_sym_BQUOTE] = ACTIONS(3925),
    [anon_sym_LT_LPAREN] = ACTIONS(3927),
    [anon_sym_GT_LPAREN] = ACTIONS(3927),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4567),
  },
  [1895] = {
    [aux_sym_concatenation_repeat1] = STATE(2226),
    [sym__concat] = ACTIONS(4569),
    [anon_sym_PIPE] = ACTIONS(618),
    [anon_sym_PIPE_AMP] = ACTIONS(614),
    [anon_sym_AMP_AMP] = ACTIONS(614),
    [anon_sym_PIPE_PIPE] = ACTIONS(614),
    [anon_sym_BQUOTE] = ACTIONS(614),
    [sym_comment] = ACTIONS(52),
  },
  [1896] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(2228),
    [anon_sym_DQUOTE] = ACTIONS(4571),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [1897] = {
    [aux_sym_concatenation_repeat1] = STATE(2226),
    [sym__concat] = ACTIONS(4569),
    [anon_sym_PIPE] = ACTIONS(624),
    [anon_sym_PIPE_AMP] = ACTIONS(622),
    [anon_sym_AMP_AMP] = ACTIONS(622),
    [anon_sym_PIPE_PIPE] = ACTIONS(622),
    [anon_sym_BQUOTE] = ACTIONS(622),
    [sym_comment] = ACTIONS(52),
  },
  [1898] = {
    [sym_string] = STATE(2231),
    [anon_sym_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(4573),
    [anon_sym_POUND] = ACTIONS(4573),
    [anon_sym_DASH] = ACTIONS(4573),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4575),
    [anon_sym_STAR] = ACTIONS(4573),
    [anon_sym_AT] = ACTIONS(4573),
    [anon_sym_QMARK] = ACTIONS(4573),
    [anon_sym_0] = ACTIONS(4577),
    [anon_sym__] = ACTIONS(4577),
  },
  [1899] = {
    [sym_subscript] = STATE(2236),
    [sym_variable_name] = ACTIONS(4579),
    [anon_sym_DOLLAR] = ACTIONS(4581),
    [anon_sym_POUND] = ACTIONS(4583),
    [anon_sym_DASH] = ACTIONS(4581),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4585),
    [anon_sym_STAR] = ACTIONS(4581),
    [anon_sym_AT] = ACTIONS(4581),
    [anon_sym_QMARK] = ACTIONS(4581),
    [anon_sym_0] = ACTIONS(4587),
    [anon_sym__] = ACTIONS(4587),
  },
  [1900] = {
    [sym_for_statement] = STATE(2237),
    [sym_while_statement] = STATE(2237),
    [sym_if_statement] = STATE(2237),
    [sym_case_statement] = STATE(2237),
    [sym_function_definition] = STATE(2237),
    [sym_subshell] = STATE(2237),
    [sym_pipeline] = STATE(2237),
    [sym_list] = STATE(2237),
    [sym_bracket_command] = STATE(2237),
    [sym_command] = STATE(2237),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(2238),
    [sym_declaration_command] = STATE(2237),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [1901] = {
    [sym_for_statement] = STATE(2239),
    [sym_while_statement] = STATE(2239),
    [sym_if_statement] = STATE(2239),
    [sym_case_statement] = STATE(2239),
    [sym_function_definition] = STATE(2239),
    [sym_subshell] = STATE(2239),
    [sym_pipeline] = STATE(2239),
    [sym_list] = STATE(2239),
    [sym_bracket_command] = STATE(2239),
    [sym_command] = STATE(2239),
    [sym_command_name] = STATE(169),
    [sym_variable_assignment] = STATE(2240),
    [sym_declaration_command] = STATE(2239),
    [sym_subscript] = STATE(171),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(161),
    [sym_simple_expansion] = STATE(161),
    [sym_expansion] = STATE(161),
    [sym_command_substitution] = STATE(161),
    [sym_process_substitution] = STATE(161),
    [aux_sym_command_repeat1] = STATE(172),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(266),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(268),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(272),
    [anon_sym_typeset] = ACTIONS(272),
    [anon_sym_export] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(272),
    [anon_sym_local] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(290),
  },
  [1902] = {
    [sym_for_statement] = STATE(2241),
    [sym_while_statement] = STATE(2241),
    [sym_if_statement] = STATE(2241),
    [sym_case_statement] = STATE(2241),
    [sym_function_definition] = STATE(2241),
    [sym_subshell] = STATE(2241),
    [sym_pipeline] = STATE(2241),
    [sym_list] = STATE(2241),
    [sym_bracket_command] = STATE(2241),
    [sym_command] = STATE(2241),
    [sym_command_name] = STATE(150),
    [sym_variable_assignment] = STATE(2242),
    [sym_declaration_command] = STATE(2241),
    [sym_subscript] = STATE(152),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(153),
    [sym_string] = STATE(142),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [aux_sym_command_repeat1] = STATE(154),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(230),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(246),
    [anon_sym_typeset] = ACTIONS(246),
    [anon_sym_export] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_local] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(264),
  },
  [1903] = {
    [sym__concat] = ACTIONS(2560),
    [sym_variable_name] = ACTIONS(2560),
    [anon_sym_PIPE] = ACTIONS(3553),
    [anon_sym_PIPE_AMP] = ACTIONS(2560),
    [anon_sym_AMP_AMP] = ACTIONS(2560),
    [anon_sym_PIPE_PIPE] = ACTIONS(2560),
    [sym__special_characters] = ACTIONS(3553),
    [anon_sym_DQUOTE] = ACTIONS(2560),
    [sym_raw_string] = ACTIONS(2560),
    [anon_sym_DOLLAR] = ACTIONS(3553),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2560),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2560),
    [anon_sym_BQUOTE] = ACTIONS(2560),
    [anon_sym_LT_LPAREN] = ACTIONS(2560),
    [anon_sym_GT_LPAREN] = ACTIONS(2560),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3553),
    [sym_word] = ACTIONS(2562),
  },
  [1904] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4589),
    [sym_comment] = ACTIONS(52),
  },
  [1905] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4591),
    [sym_comment] = ACTIONS(52),
  },
  [1906] = {
    [anon_sym_RBRACE] = ACTIONS(4591),
    [sym_comment] = ACTIONS(52),
  },
  [1907] = {
    [sym__concat] = ACTIONS(2614),
    [sym_variable_name] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(3559),
    [anon_sym_PIPE_AMP] = ACTIONS(2614),
    [anon_sym_AMP_AMP] = ACTIONS(2614),
    [anon_sym_PIPE_PIPE] = ACTIONS(2614),
    [sym__special_characters] = ACTIONS(3559),
    [anon_sym_DQUOTE] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(2614),
    [anon_sym_DOLLAR] = ACTIONS(3559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2614),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2614),
    [anon_sym_BQUOTE] = ACTIONS(2614),
    [anon_sym_LT_LPAREN] = ACTIONS(2614),
    [anon_sym_GT_LPAREN] = ACTIONS(2614),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3559),
    [sym_word] = ACTIONS(2616),
  },
  [1908] = {
    [sym_concatenation] = STATE(2247),
    [sym_string] = STATE(2246),
    [sym_simple_expansion] = STATE(2246),
    [sym_expansion] = STATE(2246),
    [sym_command_substitution] = STATE(2246),
    [sym_process_substitution] = STATE(2246),
    [anon_sym_RBRACE] = ACTIONS(4591),
    [sym__special_characters] = ACTIONS(4593),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(4595),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4597),
  },
  [1909] = {
    [sym__concat] = ACTIONS(2659),
    [sym_variable_name] = ACTIONS(2659),
    [anon_sym_PIPE] = ACTIONS(3567),
    [anon_sym_PIPE_AMP] = ACTIONS(2659),
    [anon_sym_AMP_AMP] = ACTIONS(2659),
    [anon_sym_PIPE_PIPE] = ACTIONS(2659),
    [sym__special_characters] = ACTIONS(3567),
    [anon_sym_DQUOTE] = ACTIONS(2659),
    [sym_raw_string] = ACTIONS(2659),
    [anon_sym_DOLLAR] = ACTIONS(3567),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2659),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2659),
    [anon_sym_BQUOTE] = ACTIONS(2659),
    [anon_sym_LT_LPAREN] = ACTIONS(2659),
    [anon_sym_GT_LPAREN] = ACTIONS(2659),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3567),
    [sym_word] = ACTIONS(2661),
  },
  [1910] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4599),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1911] = {
    [sym__concat] = ACTIONS(2665),
    [sym_variable_name] = ACTIONS(2665),
    [anon_sym_PIPE] = ACTIONS(3571),
    [anon_sym_PIPE_AMP] = ACTIONS(2665),
    [anon_sym_AMP_AMP] = ACTIONS(2665),
    [anon_sym_PIPE_PIPE] = ACTIONS(2665),
    [sym__special_characters] = ACTIONS(3571),
    [anon_sym_DQUOTE] = ACTIONS(2665),
    [sym_raw_string] = ACTIONS(2665),
    [anon_sym_DOLLAR] = ACTIONS(3571),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2665),
    [anon_sym_BQUOTE] = ACTIONS(2665),
    [anon_sym_LT_LPAREN] = ACTIONS(2665),
    [anon_sym_GT_LPAREN] = ACTIONS(2665),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3571),
    [sym_word] = ACTIONS(2667),
  },
  [1912] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4601),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1913] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4591),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1914] = {
    [sym__concat] = ACTIONS(2671),
    [sym_variable_name] = ACTIONS(2671),
    [anon_sym_PIPE] = ACTIONS(3575),
    [anon_sym_PIPE_AMP] = ACTIONS(2671),
    [anon_sym_AMP_AMP] = ACTIONS(2671),
    [anon_sym_PIPE_PIPE] = ACTIONS(2671),
    [sym__special_characters] = ACTIONS(3575),
    [anon_sym_DQUOTE] = ACTIONS(2671),
    [sym_raw_string] = ACTIONS(2671),
    [anon_sym_DOLLAR] = ACTIONS(3575),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2671),
    [anon_sym_BQUOTE] = ACTIONS(2671),
    [anon_sym_LT_LPAREN] = ACTIONS(2671),
    [anon_sym_GT_LPAREN] = ACTIONS(2671),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3575),
    [sym_word] = ACTIONS(2673),
  },
  [1915] = {
    [sym_file_descriptor] = ACTIONS(3657),
    [sym__concat] = ACTIONS(3657),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_PIPE_AMP] = ACTIONS(3657),
    [anon_sym_AMP_AMP] = ACTIONS(3657),
    [anon_sym_PIPE_PIPE] = ACTIONS(3657),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(3657),
    [anon_sym_AMP_GT] = ACTIONS(4331),
    [anon_sym_AMP_GT_GT] = ACTIONS(3657),
    [anon_sym_LT_AMP] = ACTIONS(3657),
    [anon_sym_GT_AMP] = ACTIONS(3657),
    [anon_sym_LT_LT] = ACTIONS(4331),
    [anon_sym_LT_LT_DASH] = ACTIONS(3657),
    [anon_sym_LT_LT_LT] = ACTIONS(3657),
    [sym__special_characters] = ACTIONS(4331),
    [anon_sym_DQUOTE] = ACTIONS(3657),
    [sym_raw_string] = ACTIONS(3657),
    [anon_sym_DOLLAR] = ACTIONS(4331),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3657),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3657),
    [anon_sym_BQUOTE] = ACTIONS(3657),
    [anon_sym_LT_LPAREN] = ACTIONS(3657),
    [anon_sym_GT_LPAREN] = ACTIONS(3657),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4331),
  },
  [1916] = {
    [sym_file_descriptor] = ACTIONS(3663),
    [sym__concat] = ACTIONS(3663),
    [anon_sym_PIPE] = ACTIONS(4333),
    [anon_sym_PIPE_AMP] = ACTIONS(3663),
    [anon_sym_AMP_AMP] = ACTIONS(3663),
    [anon_sym_PIPE_PIPE] = ACTIONS(3663),
    [anon_sym_LT] = ACTIONS(4333),
    [anon_sym_GT] = ACTIONS(4333),
    [anon_sym_GT_GT] = ACTIONS(3663),
    [anon_sym_AMP_GT] = ACTIONS(4333),
    [anon_sym_AMP_GT_GT] = ACTIONS(3663),
    [anon_sym_LT_AMP] = ACTIONS(3663),
    [anon_sym_GT_AMP] = ACTIONS(3663),
    [anon_sym_LT_LT] = ACTIONS(4333),
    [anon_sym_LT_LT_DASH] = ACTIONS(3663),
    [anon_sym_LT_LT_LT] = ACTIONS(3663),
    [sym__special_characters] = ACTIONS(4333),
    [anon_sym_DQUOTE] = ACTIONS(3663),
    [sym_raw_string] = ACTIONS(3663),
    [anon_sym_DOLLAR] = ACTIONS(4333),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3663),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3663),
    [anon_sym_BQUOTE] = ACTIONS(3663),
    [anon_sym_LT_LPAREN] = ACTIONS(3663),
    [anon_sym_GT_LPAREN] = ACTIONS(3663),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4333),
  },
  [1917] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4603),
    [sym_comment] = ACTIONS(52),
  },
  [1918] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4605),
    [sym_comment] = ACTIONS(52),
  },
  [1919] = {
    [anon_sym_RBRACE] = ACTIONS(4605),
    [sym_comment] = ACTIONS(52),
  },
  [1920] = {
    [sym_file_descriptor] = ACTIONS(3712),
    [sym__concat] = ACTIONS(3712),
    [anon_sym_PIPE] = ACTIONS(4339),
    [anon_sym_PIPE_AMP] = ACTIONS(3712),
    [anon_sym_AMP_AMP] = ACTIONS(3712),
    [anon_sym_PIPE_PIPE] = ACTIONS(3712),
    [anon_sym_LT] = ACTIONS(4339),
    [anon_sym_GT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(3712),
    [anon_sym_AMP_GT] = ACTIONS(4339),
    [anon_sym_AMP_GT_GT] = ACTIONS(3712),
    [anon_sym_LT_AMP] = ACTIONS(3712),
    [anon_sym_GT_AMP] = ACTIONS(3712),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_LT_LT_DASH] = ACTIONS(3712),
    [anon_sym_LT_LT_LT] = ACTIONS(3712),
    [sym__special_characters] = ACTIONS(4339),
    [anon_sym_DQUOTE] = ACTIONS(3712),
    [sym_raw_string] = ACTIONS(3712),
    [anon_sym_DOLLAR] = ACTIONS(4339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3712),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3712),
    [anon_sym_BQUOTE] = ACTIONS(3712),
    [anon_sym_LT_LPAREN] = ACTIONS(3712),
    [anon_sym_GT_LPAREN] = ACTIONS(3712),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4339),
  },
  [1921] = {
    [sym_file_descriptor] = ACTIONS(3716),
    [sym__concat] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(4341),
    [anon_sym_PIPE_AMP] = ACTIONS(3716),
    [anon_sym_AMP_AMP] = ACTIONS(3716),
    [anon_sym_PIPE_PIPE] = ACTIONS(3716),
    [anon_sym_LT] = ACTIONS(4341),
    [anon_sym_GT] = ACTIONS(4341),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_AMP_GT] = ACTIONS(4341),
    [anon_sym_AMP_GT_GT] = ACTIONS(3716),
    [anon_sym_LT_AMP] = ACTIONS(3716),
    [anon_sym_GT_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(4341),
    [anon_sym_LT_LT_DASH] = ACTIONS(3716),
    [anon_sym_LT_LT_LT] = ACTIONS(3716),
    [sym__special_characters] = ACTIONS(4341),
    [anon_sym_DQUOTE] = ACTIONS(3716),
    [sym_raw_string] = ACTIONS(3716),
    [anon_sym_DOLLAR] = ACTIONS(4341),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3716),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3716),
    [anon_sym_BQUOTE] = ACTIONS(3716),
    [anon_sym_LT_LPAREN] = ACTIONS(3716),
    [anon_sym_GT_LPAREN] = ACTIONS(3716),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4341),
  },
  [1922] = {
    [sym_file_descriptor] = ACTIONS(1522),
    [sym__concat] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_PIPE_AMP] = ACTIONS(1522),
    [anon_sym_AMP_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1522),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_GT_GT] = ACTIONS(1522),
    [anon_sym_AMP_GT] = ACTIONS(2430),
    [anon_sym_AMP_GT_GT] = ACTIONS(1522),
    [anon_sym_LT_AMP] = ACTIONS(1522),
    [anon_sym_GT_AMP] = ACTIONS(1522),
    [anon_sym_LT_LT] = ACTIONS(2430),
    [anon_sym_LT_LT_DASH] = ACTIONS(1522),
    [anon_sym_LT_LT_LT] = ACTIONS(1522),
    [anon_sym_BQUOTE] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
  },
  [1923] = {
    [aux_sym_concatenation_repeat1] = STATE(1923),
    [sym_file_descriptor] = ACTIONS(1522),
    [sym__concat] = ACTIONS(4607),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_PIPE_AMP] = ACTIONS(1522),
    [anon_sym_AMP_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1522),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_GT_GT] = ACTIONS(1522),
    [anon_sym_AMP_GT] = ACTIONS(2430),
    [anon_sym_AMP_GT_GT] = ACTIONS(1522),
    [anon_sym_LT_AMP] = ACTIONS(1522),
    [anon_sym_GT_AMP] = ACTIONS(1522),
    [anon_sym_LT_LT] = ACTIONS(2430),
    [anon_sym_LT_LT_DASH] = ACTIONS(1522),
    [anon_sym_LT_LT_LT] = ACTIONS(1522),
    [anon_sym_BQUOTE] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
  },
  [1924] = {
    [sym_file_descriptor] = ACTIONS(1553),
    [sym__concat] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(2435),
    [anon_sym_PIPE_AMP] = ACTIONS(1553),
    [anon_sym_AMP_AMP] = ACTIONS(1553),
    [anon_sym_PIPE_PIPE] = ACTIONS(1553),
    [anon_sym_LT] = ACTIONS(2435),
    [anon_sym_GT] = ACTIONS(2435),
    [anon_sym_GT_GT] = ACTIONS(1553),
    [anon_sym_AMP_GT] = ACTIONS(2435),
    [anon_sym_AMP_GT_GT] = ACTIONS(1553),
    [anon_sym_LT_AMP] = ACTIONS(1553),
    [anon_sym_GT_AMP] = ACTIONS(1553),
    [anon_sym_LT_LT] = ACTIONS(2435),
    [anon_sym_LT_LT_DASH] = ACTIONS(1553),
    [anon_sym_LT_LT_LT] = ACTIONS(1553),
    [anon_sym_BQUOTE] = ACTIONS(1553),
    [sym_comment] = ACTIONS(52),
  },
  [1925] = {
    [sym_concatenation] = STATE(2255),
    [sym_string] = STATE(2254),
    [sym_simple_expansion] = STATE(2254),
    [sym_expansion] = STATE(2254),
    [sym_command_substitution] = STATE(2254),
    [sym_process_substitution] = STATE(2254),
    [anon_sym_RBRACE] = ACTIONS(4610),
    [sym__special_characters] = ACTIONS(4612),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(4614),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4616),
  },
  [1926] = {
    [sym_file_descriptor] = ACTIONS(1598),
    [sym__concat] = ACTIONS(1598),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_PIPE_AMP] = ACTIONS(1598),
    [anon_sym_AMP_AMP] = ACTIONS(1598),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_LT] = ACTIONS(2445),
    [anon_sym_GT] = ACTIONS(2445),
    [anon_sym_GT_GT] = ACTIONS(1598),
    [anon_sym_AMP_GT] = ACTIONS(2445),
    [anon_sym_AMP_GT_GT] = ACTIONS(1598),
    [anon_sym_LT_AMP] = ACTIONS(1598),
    [anon_sym_GT_AMP] = ACTIONS(1598),
    [anon_sym_LT_LT] = ACTIONS(2445),
    [anon_sym_LT_LT_DASH] = ACTIONS(1598),
    [anon_sym_LT_LT_LT] = ACTIONS(1598),
    [anon_sym_BQUOTE] = ACTIONS(1598),
    [sym_comment] = ACTIONS(52),
  },
  [1927] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4618),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1928] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(4620),
    [sym_comment] = ACTIONS(52),
  },
  [1929] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2259),
    [anon_sym_RBRACE] = ACTIONS(4622),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1930] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2261),
    [anon_sym_RBRACE] = ACTIONS(4624),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1931] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2262),
    [anon_sym_RBRACE] = ACTIONS(4610),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1932] = {
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(2455),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [anon_sym_LT] = ACTIONS(2455),
    [anon_sym_GT] = ACTIONS(2455),
    [anon_sym_GT_GT] = ACTIONS(1642),
    [anon_sym_AMP_GT] = ACTIONS(2455),
    [anon_sym_AMP_GT_GT] = ACTIONS(1642),
    [anon_sym_LT_AMP] = ACTIONS(1642),
    [anon_sym_GT_AMP] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(2455),
    [anon_sym_LT_LT_DASH] = ACTIONS(1642),
    [anon_sym_LT_LT_LT] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [sym_comment] = ACTIONS(52),
  },
  [1933] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4626),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1934] = {
    [sym_file_descriptor] = ACTIONS(1648),
    [sym__concat] = ACTIONS(1648),
    [anon_sym_PIPE] = ACTIONS(2459),
    [anon_sym_PIPE_AMP] = ACTIONS(1648),
    [anon_sym_AMP_AMP] = ACTIONS(1648),
    [anon_sym_PIPE_PIPE] = ACTIONS(1648),
    [anon_sym_LT] = ACTIONS(2459),
    [anon_sym_GT] = ACTIONS(2459),
    [anon_sym_GT_GT] = ACTIONS(1648),
    [anon_sym_AMP_GT] = ACTIONS(2459),
    [anon_sym_AMP_GT_GT] = ACTIONS(1648),
    [anon_sym_LT_AMP] = ACTIONS(1648),
    [anon_sym_GT_AMP] = ACTIONS(1648),
    [anon_sym_LT_LT] = ACTIONS(2459),
    [anon_sym_LT_LT_DASH] = ACTIONS(1648),
    [anon_sym_LT_LT_LT] = ACTIONS(1648),
    [anon_sym_BQUOTE] = ACTIONS(1648),
    [sym_comment] = ACTIONS(52),
  },
  [1935] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4610),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1936] = {
    [sym_file_descriptor] = ACTIONS(1762),
    [sym__concat] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(2461),
    [anon_sym_PIPE_AMP] = ACTIONS(1762),
    [anon_sym_AMP_AMP] = ACTIONS(1762),
    [anon_sym_PIPE_PIPE] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(2461),
    [anon_sym_GT] = ACTIONS(2461),
    [anon_sym_GT_GT] = ACTIONS(1762),
    [anon_sym_AMP_GT] = ACTIONS(2461),
    [anon_sym_AMP_GT_GT] = ACTIONS(1762),
    [anon_sym_LT_AMP] = ACTIONS(1762),
    [anon_sym_GT_AMP] = ACTIONS(1762),
    [anon_sym_LT_LT] = ACTIONS(2461),
    [anon_sym_LT_LT_DASH] = ACTIONS(1762),
    [anon_sym_LT_LT_LT] = ACTIONS(1762),
    [anon_sym_BQUOTE] = ACTIONS(1762),
    [sym_comment] = ACTIONS(52),
  },
  [1937] = {
    [sym_file_descriptor] = ACTIONS(1902),
    [sym__concat] = ACTIONS(1902),
    [anon_sym_PIPE] = ACTIONS(2463),
    [anon_sym_PIPE_AMP] = ACTIONS(1902),
    [anon_sym_AMP_AMP] = ACTIONS(1902),
    [anon_sym_PIPE_PIPE] = ACTIONS(1902),
    [anon_sym_LT] = ACTIONS(2463),
    [anon_sym_GT] = ACTIONS(2463),
    [anon_sym_GT_GT] = ACTIONS(1902),
    [anon_sym_AMP_GT] = ACTIONS(2463),
    [anon_sym_AMP_GT_GT] = ACTIONS(1902),
    [anon_sym_LT_AMP] = ACTIONS(1902),
    [anon_sym_GT_AMP] = ACTIONS(1902),
    [anon_sym_LT_LT] = ACTIONS(2463),
    [anon_sym_LT_LT_DASH] = ACTIONS(1902),
    [anon_sym_LT_LT_LT] = ACTIONS(1902),
    [anon_sym_BQUOTE] = ACTIONS(1902),
    [sym_comment] = ACTIONS(52),
  },
  [1938] = {
    [sym_file_descriptor] = ACTIONS(2560),
    [sym__concat] = ACTIONS(2560),
    [anon_sym_PIPE] = ACTIONS(2562),
    [anon_sym_SEMI_SEMI] = ACTIONS(2562),
    [anon_sym_PIPE_AMP] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_PIPE_PIPE] = ACTIONS(2562),
    [anon_sym_LT] = ACTIONS(2562),
    [anon_sym_GT] = ACTIONS(2562),
    [anon_sym_GT_GT] = ACTIONS(2562),
    [anon_sym_AMP_GT] = ACTIONS(2562),
    [anon_sym_AMP_GT_GT] = ACTIONS(2562),
    [anon_sym_LT_AMP] = ACTIONS(2562),
    [anon_sym_GT_AMP] = ACTIONS(2562),
    [anon_sym_LT_LT] = ACTIONS(2562),
    [anon_sym_LT_LT_DASH] = ACTIONS(2562),
    [anon_sym_LT_LT_LT] = ACTIONS(2562),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym_LF] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(2562),
  },
  [1939] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4628),
    [sym_comment] = ACTIONS(52),
  },
  [1940] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4630),
    [sym_comment] = ACTIONS(52),
  },
  [1941] = {
    [anon_sym_RBRACE] = ACTIONS(4630),
    [sym_comment] = ACTIONS(52),
  },
  [1942] = {
    [sym_file_descriptor] = ACTIONS(2614),
    [sym__concat] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2616),
    [anon_sym_SEMI_SEMI] = ACTIONS(2616),
    [anon_sym_PIPE_AMP] = ACTIONS(2616),
    [anon_sym_AMP_AMP] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2616),
    [anon_sym_LT] = ACTIONS(2616),
    [anon_sym_GT] = ACTIONS(2616),
    [anon_sym_GT_GT] = ACTIONS(2616),
    [anon_sym_AMP_GT] = ACTIONS(2616),
    [anon_sym_AMP_GT_GT] = ACTIONS(2616),
    [anon_sym_LT_AMP] = ACTIONS(2616),
    [anon_sym_GT_AMP] = ACTIONS(2616),
    [anon_sym_LT_LT] = ACTIONS(2616),
    [anon_sym_LT_LT_DASH] = ACTIONS(2616),
    [anon_sym_LT_LT_LT] = ACTIONS(2616),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2616),
    [anon_sym_LF] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2616),
  },
  [1943] = {
    [sym_concatenation] = STATE(2268),
    [sym_string] = STATE(2267),
    [sym_simple_expansion] = STATE(2267),
    [sym_expansion] = STATE(2267),
    [sym_command_substitution] = STATE(2267),
    [sym_process_substitution] = STATE(2267),
    [anon_sym_RBRACE] = ACTIONS(4630),
    [sym__special_characters] = ACTIONS(4632),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(4634),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4636),
  },
  [1944] = {
    [sym_file_descriptor] = ACTIONS(2659),
    [sym__concat] = ACTIONS(2659),
    [anon_sym_PIPE] = ACTIONS(2661),
    [anon_sym_SEMI_SEMI] = ACTIONS(2661),
    [anon_sym_PIPE_AMP] = ACTIONS(2661),
    [anon_sym_AMP_AMP] = ACTIONS(2661),
    [anon_sym_PIPE_PIPE] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(2661),
    [anon_sym_GT] = ACTIONS(2661),
    [anon_sym_GT_GT] = ACTIONS(2661),
    [anon_sym_AMP_GT] = ACTIONS(2661),
    [anon_sym_AMP_GT_GT] = ACTIONS(2661),
    [anon_sym_LT_AMP] = ACTIONS(2661),
    [anon_sym_GT_AMP] = ACTIONS(2661),
    [anon_sym_LT_LT] = ACTIONS(2661),
    [anon_sym_LT_LT_DASH] = ACTIONS(2661),
    [anon_sym_LT_LT_LT] = ACTIONS(2661),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2661),
    [anon_sym_LF] = ACTIONS(2661),
    [anon_sym_AMP] = ACTIONS(2661),
  },
  [1945] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4638),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1946] = {
    [sym_file_descriptor] = ACTIONS(2665),
    [sym__concat] = ACTIONS(2665),
    [anon_sym_PIPE] = ACTIONS(2667),
    [anon_sym_SEMI_SEMI] = ACTIONS(2667),
    [anon_sym_PIPE_AMP] = ACTIONS(2667),
    [anon_sym_AMP_AMP] = ACTIONS(2667),
    [anon_sym_PIPE_PIPE] = ACTIONS(2667),
    [anon_sym_LT] = ACTIONS(2667),
    [anon_sym_GT] = ACTIONS(2667),
    [anon_sym_GT_GT] = ACTIONS(2667),
    [anon_sym_AMP_GT] = ACTIONS(2667),
    [anon_sym_AMP_GT_GT] = ACTIONS(2667),
    [anon_sym_LT_AMP] = ACTIONS(2667),
    [anon_sym_GT_AMP] = ACTIONS(2667),
    [anon_sym_LT_LT] = ACTIONS(2667),
    [anon_sym_LT_LT_DASH] = ACTIONS(2667),
    [anon_sym_LT_LT_LT] = ACTIONS(2667),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym_LF] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(2667),
  },
  [1947] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4640),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1948] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4630),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1949] = {
    [sym_file_descriptor] = ACTIONS(2671),
    [sym__concat] = ACTIONS(2671),
    [anon_sym_PIPE] = ACTIONS(2673),
    [anon_sym_SEMI_SEMI] = ACTIONS(2673),
    [anon_sym_PIPE_AMP] = ACTIONS(2673),
    [anon_sym_AMP_AMP] = ACTIONS(2673),
    [anon_sym_PIPE_PIPE] = ACTIONS(2673),
    [anon_sym_LT] = ACTIONS(2673),
    [anon_sym_GT] = ACTIONS(2673),
    [anon_sym_GT_GT] = ACTIONS(2673),
    [anon_sym_AMP_GT] = ACTIONS(2673),
    [anon_sym_AMP_GT_GT] = ACTIONS(2673),
    [anon_sym_LT_AMP] = ACTIONS(2673),
    [anon_sym_GT_AMP] = ACTIONS(2673),
    [anon_sym_LT_LT] = ACTIONS(2673),
    [anon_sym_LT_LT_DASH] = ACTIONS(2673),
    [anon_sym_LT_LT_LT] = ACTIONS(2673),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2673),
    [anon_sym_LF] = ACTIONS(2673),
    [anon_sym_AMP] = ACTIONS(2673),
  },
  [1950] = {
    [sym__heredoc_middle] = ACTIONS(650),
    [sym__heredoc_end] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(1302),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(650),
    [sym_comment] = ACTIONS(52),
  },
  [1951] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(4642),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [1952] = {
    [sym_concatenation] = STATE(2275),
    [sym_string] = STATE(2274),
    [sym_simple_expansion] = STATE(2274),
    [sym_expansion] = STATE(2274),
    [sym_command_substitution] = STATE(2274),
    [sym_process_substitution] = STATE(2274),
    [anon_sym_RBRACE] = ACTIONS(4644),
    [sym__special_characters] = ACTIONS(4646),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(4648),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4650),
  },
  [1953] = {
    [sym__heredoc_middle] = ACTIONS(1598),
    [sym__heredoc_end] = ACTIONS(1598),
    [anon_sym_DOLLAR] = ACTIONS(2445),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1598),
    [sym_comment] = ACTIONS(52),
  },
  [1954] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4652),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1955] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(4654),
    [sym_comment] = ACTIONS(52),
  },
  [1956] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2279),
    [anon_sym_RBRACE] = ACTIONS(4656),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1957] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2281),
    [anon_sym_RBRACE] = ACTIONS(4658),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1958] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2282),
    [anon_sym_RBRACE] = ACTIONS(4644),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1959] = {
    [sym__heredoc_middle] = ACTIONS(1642),
    [sym__heredoc_end] = ACTIONS(1642),
    [anon_sym_DOLLAR] = ACTIONS(2455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1642),
    [sym_comment] = ACTIONS(52),
  },
  [1960] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4660),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1961] = {
    [sym__heredoc_middle] = ACTIONS(1648),
    [sym__heredoc_end] = ACTIONS(1648),
    [anon_sym_DOLLAR] = ACTIONS(2459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1648),
    [sym_comment] = ACTIONS(52),
  },
  [1962] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4644),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1963] = {
    [sym__concat] = ACTIONS(3657),
    [anon_sym_RBRACK] = ACTIONS(3657),
    [sym_comment] = ACTIONS(52),
  },
  [1964] = {
    [sym__concat] = ACTIONS(3663),
    [anon_sym_RBRACK] = ACTIONS(3663),
    [sym_comment] = ACTIONS(52),
  },
  [1965] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4662),
    [sym_comment] = ACTIONS(52),
  },
  [1966] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4664),
    [sym_comment] = ACTIONS(52),
  },
  [1967] = {
    [anon_sym_RBRACE] = ACTIONS(4664),
    [sym_comment] = ACTIONS(52),
  },
  [1968] = {
    [sym__concat] = ACTIONS(3712),
    [anon_sym_RBRACK] = ACTIONS(3712),
    [sym_comment] = ACTIONS(52),
  },
  [1969] = {
    [sym__concat] = ACTIONS(3716),
    [anon_sym_RBRACK] = ACTIONS(3716),
    [sym_comment] = ACTIONS(52),
  },
  [1970] = {
    [sym__concat] = ACTIONS(2560),
    [anon_sym_RPAREN] = ACTIONS(2560),
    [sym__special_characters] = ACTIONS(3553),
    [anon_sym_DQUOTE] = ACTIONS(2560),
    [sym_raw_string] = ACTIONS(2560),
    [anon_sym_DOLLAR] = ACTIONS(3553),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2560),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2560),
    [anon_sym_BQUOTE] = ACTIONS(2560),
    [anon_sym_LT_LPAREN] = ACTIONS(2560),
    [anon_sym_GT_LPAREN] = ACTIONS(2560),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3553),
  },
  [1971] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4666),
    [sym_comment] = ACTIONS(52),
  },
  [1972] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4668),
    [sym_comment] = ACTIONS(52),
  },
  [1973] = {
    [anon_sym_RBRACE] = ACTIONS(4668),
    [sym_comment] = ACTIONS(52),
  },
  [1974] = {
    [sym__concat] = ACTIONS(2614),
    [anon_sym_RPAREN] = ACTIONS(2614),
    [sym__special_characters] = ACTIONS(3559),
    [anon_sym_DQUOTE] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(2614),
    [anon_sym_DOLLAR] = ACTIONS(3559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2614),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2614),
    [anon_sym_BQUOTE] = ACTIONS(2614),
    [anon_sym_LT_LPAREN] = ACTIONS(2614),
    [anon_sym_GT_LPAREN] = ACTIONS(2614),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3559),
  },
  [1975] = {
    [sym_concatenation] = STATE(2290),
    [sym_string] = STATE(2289),
    [sym_simple_expansion] = STATE(2289),
    [sym_expansion] = STATE(2289),
    [sym_command_substitution] = STATE(2289),
    [sym_process_substitution] = STATE(2289),
    [anon_sym_RBRACE] = ACTIONS(4668),
    [sym__special_characters] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(4672),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4674),
  },
  [1976] = {
    [sym__concat] = ACTIONS(2659),
    [anon_sym_RPAREN] = ACTIONS(2659),
    [sym__special_characters] = ACTIONS(3567),
    [anon_sym_DQUOTE] = ACTIONS(2659),
    [sym_raw_string] = ACTIONS(2659),
    [anon_sym_DOLLAR] = ACTIONS(3567),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2659),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2659),
    [anon_sym_BQUOTE] = ACTIONS(2659),
    [anon_sym_LT_LPAREN] = ACTIONS(2659),
    [anon_sym_GT_LPAREN] = ACTIONS(2659),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3567),
  },
  [1977] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4676),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1978] = {
    [sym__concat] = ACTIONS(2665),
    [anon_sym_RPAREN] = ACTIONS(2665),
    [sym__special_characters] = ACTIONS(3571),
    [anon_sym_DQUOTE] = ACTIONS(2665),
    [sym_raw_string] = ACTIONS(2665),
    [anon_sym_DOLLAR] = ACTIONS(3571),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2665),
    [anon_sym_BQUOTE] = ACTIONS(2665),
    [anon_sym_LT_LPAREN] = ACTIONS(2665),
    [anon_sym_GT_LPAREN] = ACTIONS(2665),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3571),
  },
  [1979] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4678),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1980] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4668),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1981] = {
    [sym__concat] = ACTIONS(2671),
    [anon_sym_RPAREN] = ACTIONS(2671),
    [sym__special_characters] = ACTIONS(3575),
    [anon_sym_DQUOTE] = ACTIONS(2671),
    [sym_raw_string] = ACTIONS(2671),
    [anon_sym_DOLLAR] = ACTIONS(3575),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2671),
    [anon_sym_BQUOTE] = ACTIONS(2671),
    [anon_sym_LT_LPAREN] = ACTIONS(2671),
    [anon_sym_GT_LPAREN] = ACTIONS(2671),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3575),
  },
  [1982] = {
    [sym_file_descriptor] = ACTIONS(3657),
    [sym__concat] = ACTIONS(3657),
    [sym_variable_name] = ACTIONS(3657),
    [anon_sym_PIPE] = ACTIONS(3659),
    [anon_sym_SEMI_SEMI] = ACTIONS(3659),
    [anon_sym_PIPE_AMP] = ACTIONS(3659),
    [anon_sym_AMP_AMP] = ACTIONS(3659),
    [anon_sym_PIPE_PIPE] = ACTIONS(3659),
    [anon_sym_LT] = ACTIONS(3659),
    [anon_sym_GT] = ACTIONS(3659),
    [anon_sym_GT_GT] = ACTIONS(3659),
    [anon_sym_AMP_GT] = ACTIONS(3659),
    [anon_sym_AMP_GT_GT] = ACTIONS(3659),
    [anon_sym_LT_AMP] = ACTIONS(3659),
    [anon_sym_GT_AMP] = ACTIONS(3659),
    [sym__special_characters] = ACTIONS(3659),
    [anon_sym_DQUOTE] = ACTIONS(3659),
    [sym_raw_string] = ACTIONS(3659),
    [anon_sym_DOLLAR] = ACTIONS(3659),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3659),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3659),
    [anon_sym_BQUOTE] = ACTIONS(3659),
    [anon_sym_LT_LPAREN] = ACTIONS(3659),
    [anon_sym_GT_LPAREN] = ACTIONS(3659),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(3659),
    [anon_sym_SEMI] = ACTIONS(3659),
    [anon_sym_LF] = ACTIONS(3659),
    [anon_sym_AMP] = ACTIONS(3659),
  },
  [1983] = {
    [sym_file_descriptor] = ACTIONS(3663),
    [sym__concat] = ACTIONS(3663),
    [sym_variable_name] = ACTIONS(3663),
    [anon_sym_PIPE] = ACTIONS(3665),
    [anon_sym_SEMI_SEMI] = ACTIONS(3665),
    [anon_sym_PIPE_AMP] = ACTIONS(3665),
    [anon_sym_AMP_AMP] = ACTIONS(3665),
    [anon_sym_PIPE_PIPE] = ACTIONS(3665),
    [anon_sym_LT] = ACTIONS(3665),
    [anon_sym_GT] = ACTIONS(3665),
    [anon_sym_GT_GT] = ACTIONS(3665),
    [anon_sym_AMP_GT] = ACTIONS(3665),
    [anon_sym_AMP_GT_GT] = ACTIONS(3665),
    [anon_sym_LT_AMP] = ACTIONS(3665),
    [anon_sym_GT_AMP] = ACTIONS(3665),
    [sym__special_characters] = ACTIONS(3665),
    [anon_sym_DQUOTE] = ACTIONS(3665),
    [sym_raw_string] = ACTIONS(3665),
    [anon_sym_DOLLAR] = ACTIONS(3665),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3665),
    [anon_sym_BQUOTE] = ACTIONS(3665),
    [anon_sym_LT_LPAREN] = ACTIONS(3665),
    [anon_sym_GT_LPAREN] = ACTIONS(3665),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(3665),
    [anon_sym_SEMI] = ACTIONS(3665),
    [anon_sym_LF] = ACTIONS(3665),
    [anon_sym_AMP] = ACTIONS(3665),
  },
  [1984] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4680),
    [sym_comment] = ACTIONS(52),
  },
  [1985] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4682),
    [sym_comment] = ACTIONS(52),
  },
  [1986] = {
    [anon_sym_RBRACE] = ACTIONS(4682),
    [sym_comment] = ACTIONS(52),
  },
  [1987] = {
    [sym_file_descriptor] = ACTIONS(3712),
    [sym__concat] = ACTIONS(3712),
    [sym_variable_name] = ACTIONS(3712),
    [anon_sym_PIPE] = ACTIONS(3714),
    [anon_sym_SEMI_SEMI] = ACTIONS(3714),
    [anon_sym_PIPE_AMP] = ACTIONS(3714),
    [anon_sym_AMP_AMP] = ACTIONS(3714),
    [anon_sym_PIPE_PIPE] = ACTIONS(3714),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_GT] = ACTIONS(3714),
    [anon_sym_GT_GT] = ACTIONS(3714),
    [anon_sym_AMP_GT] = ACTIONS(3714),
    [anon_sym_AMP_GT_GT] = ACTIONS(3714),
    [anon_sym_LT_AMP] = ACTIONS(3714),
    [anon_sym_GT_AMP] = ACTIONS(3714),
    [sym__special_characters] = ACTIONS(3714),
    [anon_sym_DQUOTE] = ACTIONS(3714),
    [sym_raw_string] = ACTIONS(3714),
    [anon_sym_DOLLAR] = ACTIONS(3714),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3714),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3714),
    [anon_sym_BQUOTE] = ACTIONS(3714),
    [anon_sym_LT_LPAREN] = ACTIONS(3714),
    [anon_sym_GT_LPAREN] = ACTIONS(3714),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(3714),
    [anon_sym_SEMI] = ACTIONS(3714),
    [anon_sym_LF] = ACTIONS(3714),
    [anon_sym_AMP] = ACTIONS(3714),
  },
  [1988] = {
    [sym_file_descriptor] = ACTIONS(3716),
    [sym__concat] = ACTIONS(3716),
    [sym_variable_name] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3718),
    [anon_sym_SEMI_SEMI] = ACTIONS(3718),
    [anon_sym_PIPE_AMP] = ACTIONS(3718),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_LT] = ACTIONS(3718),
    [anon_sym_GT] = ACTIONS(3718),
    [anon_sym_GT_GT] = ACTIONS(3718),
    [anon_sym_AMP_GT] = ACTIONS(3718),
    [anon_sym_AMP_GT_GT] = ACTIONS(3718),
    [anon_sym_LT_AMP] = ACTIONS(3718),
    [anon_sym_GT_AMP] = ACTIONS(3718),
    [sym__special_characters] = ACTIONS(3718),
    [anon_sym_DQUOTE] = ACTIONS(3718),
    [sym_raw_string] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3718),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3718),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3718),
    [anon_sym_BQUOTE] = ACTIONS(3718),
    [anon_sym_LT_LPAREN] = ACTIONS(3718),
    [anon_sym_GT_LPAREN] = ACTIONS(3718),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(3718),
    [anon_sym_SEMI] = ACTIONS(3718),
    [anon_sym_LF] = ACTIONS(3718),
    [anon_sym_AMP] = ACTIONS(3718),
  },
  [1989] = {
    [sym__concat] = ACTIONS(2560),
    [anon_sym_SEMI_SEMI] = ACTIONS(2562),
    [sym__special_characters] = ACTIONS(2562),
    [anon_sym_DQUOTE] = ACTIONS(2562),
    [sym_raw_string] = ACTIONS(2562),
    [anon_sym_DOLLAR] = ACTIONS(2562),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2562),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2562),
    [anon_sym_BQUOTE] = ACTIONS(2562),
    [anon_sym_LT_LPAREN] = ACTIONS(2562),
    [anon_sym_GT_LPAREN] = ACTIONS(2562),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2562),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym_LF] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(2562),
  },
  [1990] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4684),
    [sym_comment] = ACTIONS(52),
  },
  [1991] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4686),
    [sym_comment] = ACTIONS(52),
  },
  [1992] = {
    [anon_sym_RBRACE] = ACTIONS(4686),
    [sym_comment] = ACTIONS(52),
  },
  [1993] = {
    [sym__concat] = ACTIONS(2614),
    [anon_sym_SEMI_SEMI] = ACTIONS(2616),
    [sym__special_characters] = ACTIONS(2616),
    [anon_sym_DQUOTE] = ACTIONS(2616),
    [sym_raw_string] = ACTIONS(2616),
    [anon_sym_DOLLAR] = ACTIONS(2616),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2616),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2616),
    [anon_sym_BQUOTE] = ACTIONS(2616),
    [anon_sym_LT_LPAREN] = ACTIONS(2616),
    [anon_sym_GT_LPAREN] = ACTIONS(2616),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2616),
    [anon_sym_LF] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2616),
  },
  [1994] = {
    [sym_concatenation] = STATE(2299),
    [sym_string] = STATE(2298),
    [sym_simple_expansion] = STATE(2298),
    [sym_expansion] = STATE(2298),
    [sym_command_substitution] = STATE(2298),
    [sym_process_substitution] = STATE(2298),
    [anon_sym_RBRACE] = ACTIONS(4686),
    [sym__special_characters] = ACTIONS(4688),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(4690),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4692),
  },
  [1995] = {
    [sym__concat] = ACTIONS(2659),
    [anon_sym_SEMI_SEMI] = ACTIONS(2661),
    [sym__special_characters] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2661),
    [sym_raw_string] = ACTIONS(2661),
    [anon_sym_DOLLAR] = ACTIONS(2661),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2661),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2661),
    [anon_sym_BQUOTE] = ACTIONS(2661),
    [anon_sym_LT_LPAREN] = ACTIONS(2661),
    [anon_sym_GT_LPAREN] = ACTIONS(2661),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2661),
    [anon_sym_SEMI] = ACTIONS(2661),
    [anon_sym_LF] = ACTIONS(2661),
    [anon_sym_AMP] = ACTIONS(2661),
  },
  [1996] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4694),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1997] = {
    [sym__concat] = ACTIONS(2665),
    [anon_sym_SEMI_SEMI] = ACTIONS(2667),
    [sym__special_characters] = ACTIONS(2667),
    [anon_sym_DQUOTE] = ACTIONS(2667),
    [sym_raw_string] = ACTIONS(2667),
    [anon_sym_DOLLAR] = ACTIONS(2667),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2667),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2667),
    [anon_sym_BQUOTE] = ACTIONS(2667),
    [anon_sym_LT_LPAREN] = ACTIONS(2667),
    [anon_sym_GT_LPAREN] = ACTIONS(2667),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2667),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym_LF] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(2667),
  },
  [1998] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4696),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [1999] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4686),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2000] = {
    [sym__concat] = ACTIONS(2671),
    [anon_sym_SEMI_SEMI] = ACTIONS(2673),
    [sym__special_characters] = ACTIONS(2673),
    [anon_sym_DQUOTE] = ACTIONS(2673),
    [sym_raw_string] = ACTIONS(2673),
    [anon_sym_DOLLAR] = ACTIONS(2673),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2673),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2673),
    [anon_sym_BQUOTE] = ACTIONS(2673),
    [anon_sym_LT_LPAREN] = ACTIONS(2673),
    [anon_sym_GT_LPAREN] = ACTIONS(2673),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2673),
    [anon_sym_SEMI] = ACTIONS(2673),
    [anon_sym_LF] = ACTIONS(2673),
    [anon_sym_AMP] = ACTIONS(2673),
  },
  [2001] = {
    [anon_sym_PIPE] = ACTIONS(2148),
    [anon_sym_RPAREN] = ACTIONS(2148),
    [anon_sym_SEMI_SEMI] = ACTIONS(2148),
    [anon_sym_PIPE_AMP] = ACTIONS(2148),
    [anon_sym_AMP_AMP] = ACTIONS(2148),
    [anon_sym_PIPE_PIPE] = ACTIONS(2148),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2148),
    [anon_sym_LF] = ACTIONS(2148),
    [anon_sym_AMP] = ACTIONS(2148),
  },
  [2002] = {
    [sym__terminated_statement] = STATE(603),
    [sym_for_statement] = STATE(604),
    [sym_while_statement] = STATE(604),
    [sym_if_statement] = STATE(604),
    [sym_case_statement] = STATE(604),
    [sym_function_definition] = STATE(604),
    [sym_subshell] = STATE(604),
    [sym_pipeline] = STATE(604),
    [sym_list] = STATE(604),
    [sym_bracket_command] = STATE(604),
    [sym_command] = STATE(604),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(605),
    [sym_declaration_command] = STATE(604),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(1099),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_done] = ACTIONS(4698),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [2003] = {
    [sym__terminated_statement] = STATE(611),
    [sym_for_statement] = STATE(612),
    [sym_while_statement] = STATE(612),
    [sym_if_statement] = STATE(612),
    [sym_case_statement] = STATE(612),
    [sym_function_definition] = STATE(612),
    [sym_subshell] = STATE(612),
    [sym_pipeline] = STATE(612),
    [sym_list] = STATE(612),
    [sym_bracket_command] = STATE(612),
    [sym_command] = STATE(612),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(615),
    [sym_declaration_command] = STATE(612),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(1108),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_fi] = ACTIONS(4700),
    [anon_sym_elif] = ACTIONS(4700),
    [anon_sym_else] = ACTIONS(4700),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [2004] = {
    [anon_sym_PIPE] = ACTIONS(4702),
    [anon_sym_RPAREN] = ACTIONS(4702),
    [anon_sym_SEMI_SEMI] = ACTIONS(4702),
    [anon_sym_PIPE_AMP] = ACTIONS(4702),
    [anon_sym_AMP_AMP] = ACTIONS(4702),
    [anon_sym_PIPE_PIPE] = ACTIONS(4702),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(4702),
    [anon_sym_LF] = ACTIONS(4702),
    [anon_sym_AMP] = ACTIONS(4702),
  },
  [2005] = {
    [sym__concat] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(1522),
    [anon_sym_RPAREN] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
  },
  [2006] = {
    [aux_sym_concatenation_repeat1] = STATE(1607),
    [sym__concat] = ACTIONS(3354),
    [anon_sym_PIPE] = ACTIONS(4704),
    [anon_sym_RPAREN] = ACTIONS(4704),
    [sym_comment] = ACTIONS(52),
  },
  [2007] = {
    [aux_sym_concatenation_repeat1] = STATE(1607),
    [sym__concat] = ACTIONS(3354),
    [anon_sym_PIPE] = ACTIONS(4706),
    [anon_sym_RPAREN] = ACTIONS(4706),
    [sym_comment] = ACTIONS(52),
  },
  [2008] = {
    [anon_sym_PIPE] = ACTIONS(4706),
    [anon_sym_RPAREN] = ACTIONS(4706),
    [sym_comment] = ACTIONS(52),
  },
  [2009] = {
    [anon_sym_esac] = ACTIONS(4708),
    [sym__special_characters] = ACTIONS(4710),
    [anon_sym_DQUOTE] = ACTIONS(4712),
    [sym_raw_string] = ACTIONS(4712),
    [anon_sym_DOLLAR] = ACTIONS(4710),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4712),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4712),
    [anon_sym_BQUOTE] = ACTIONS(4712),
    [anon_sym_LT_LPAREN] = ACTIONS(4712),
    [anon_sym_GT_LPAREN] = ACTIONS(4712),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4714),
  },
  [2010] = {
    [sym_file_descriptor] = ACTIONS(296),
    [sym_variable_name] = ACTIONS(296),
    [anon_sym_for] = ACTIONS(298),
    [anon_sym_while] = ACTIONS(298),
    [anon_sym_if] = ACTIONS(298),
    [anon_sym_case] = ACTIONS(298),
    [anon_sym_esac] = ACTIONS(298),
    [anon_sym_SEMI_SEMI] = ACTIONS(296),
    [anon_sym_function] = ACTIONS(298),
    [anon_sym_LPAREN] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(296),
    [anon_sym_declare] = ACTIONS(298),
    [anon_sym_typeset] = ACTIONS(298),
    [anon_sym_export] = ACTIONS(298),
    [anon_sym_readonly] = ACTIONS(298),
    [anon_sym_local] = ACTIONS(298),
    [anon_sym_LT] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(298),
    [anon_sym_GT_GT] = ACTIONS(296),
    [anon_sym_AMP_GT] = ACTIONS(298),
    [anon_sym_AMP_GT_GT] = ACTIONS(296),
    [anon_sym_LT_AMP] = ACTIONS(296),
    [anon_sym_GT_AMP] = ACTIONS(296),
    [sym__special_characters] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(296),
    [sym_raw_string] = ACTIONS(296),
    [anon_sym_DOLLAR] = ACTIONS(298),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(296),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(296),
    [anon_sym_BQUOTE] = ACTIONS(296),
    [anon_sym_LT_LPAREN] = ACTIONS(296),
    [anon_sym_GT_LPAREN] = ACTIONS(296),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(300),
  },
  [2011] = {
    [anon_sym_PIPE] = ACTIONS(302),
    [anon_sym_SEMI_SEMI] = ACTIONS(4716),
    [anon_sym_PIPE_AMP] = ACTIONS(302),
    [anon_sym_AMP_AMP] = ACTIONS(306),
    [anon_sym_PIPE_PIPE] = ACTIONS(306),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(4716),
    [anon_sym_LF] = ACTIONS(4716),
    [anon_sym_AMP] = ACTIONS(4716),
  },
  [2012] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(302),
    [anon_sym_SEMI_SEMI] = ACTIONS(4716),
    [anon_sym_PIPE_AMP] = ACTIONS(302),
    [anon_sym_AMP_AMP] = ACTIONS(306),
    [anon_sym_PIPE_PIPE] = ACTIONS(306),
    [anon_sym_LT] = ACTIONS(336),
    [anon_sym_GT] = ACTIONS(336),
    [anon_sym_GT_GT] = ACTIONS(336),
    [anon_sym_AMP_GT] = ACTIONS(336),
    [anon_sym_AMP_GT_GT] = ACTIONS(336),
    [anon_sym_LT_AMP] = ACTIONS(336),
    [anon_sym_GT_AMP] = ACTIONS(336),
    [sym__special_characters] = ACTIONS(336),
    [anon_sym_DQUOTE] = ACTIONS(336),
    [sym_raw_string] = ACTIONS(336),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(336),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(336),
    [anon_sym_BQUOTE] = ACTIONS(336),
    [anon_sym_LT_LPAREN] = ACTIONS(336),
    [anon_sym_GT_LPAREN] = ACTIONS(336),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(336),
    [anon_sym_SEMI] = ACTIONS(4716),
    [anon_sym_LF] = ACTIONS(4716),
    [anon_sym_AMP] = ACTIONS(4716),
  },
  [2013] = {
    [sym__terminated_statement] = STATE(2010),
    [sym_for_statement] = STATE(2011),
    [sym_while_statement] = STATE(2011),
    [sym_if_statement] = STATE(2011),
    [sym_case_statement] = STATE(2011),
    [sym_function_definition] = STATE(2011),
    [sym_subshell] = STATE(2011),
    [sym_pipeline] = STATE(2011),
    [sym_list] = STATE(2011),
    [sym_bracket_command] = STATE(2011),
    [sym_command] = STATE(2011),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(2012),
    [sym_declaration_command] = STATE(2011),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(2305),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_esac] = ACTIONS(4708),
    [anon_sym_SEMI_SEMI] = ACTIONS(4718),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [2014] = {
    [sym__terminated_statement] = STATE(2010),
    [sym_for_statement] = STATE(2011),
    [sym_while_statement] = STATE(2011),
    [sym_if_statement] = STATE(2011),
    [sym_case_statement] = STATE(2011),
    [sym_function_definition] = STATE(2011),
    [sym_subshell] = STATE(2011),
    [sym_pipeline] = STATE(2011),
    [sym_list] = STATE(2011),
    [sym_bracket_command] = STATE(2011),
    [sym_command] = STATE(2011),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(2012),
    [sym_declaration_command] = STATE(2011),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(2306),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_esac] = ACTIONS(4708),
    [anon_sym_SEMI_SEMI] = ACTIONS(4718),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [2015] = {
    [aux_sym_case_item_repeat1] = STATE(2015),
    [anon_sym_PIPE] = ACTIONS(4720),
    [anon_sym_RPAREN] = ACTIONS(4706),
    [sym_comment] = ACTIONS(52),
  },
  [2016] = {
    [aux_sym_concatenation_repeat1] = STATE(2016),
    [sym__concat] = ACTIONS(4723),
    [anon_sym_PIPE] = ACTIONS(1522),
    [anon_sym_RPAREN] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
  },
  [2017] = {
    [sym__concat] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(1553),
    [anon_sym_RPAREN] = ACTIONS(1553),
    [sym_comment] = ACTIONS(52),
  },
  [2018] = {
    [anon_sym_esac] = ACTIONS(4726),
    [sym__special_characters] = ACTIONS(4728),
    [anon_sym_DQUOTE] = ACTIONS(4730),
    [sym_raw_string] = ACTIONS(4730),
    [anon_sym_DOLLAR] = ACTIONS(4728),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4730),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4730),
    [anon_sym_BQUOTE] = ACTIONS(4730),
    [anon_sym_LT_LPAREN] = ACTIONS(4730),
    [anon_sym_GT_LPAREN] = ACTIONS(4730),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4732),
  },
  [2019] = {
    [sym__terminated_statement] = STATE(2010),
    [sym_for_statement] = STATE(2011),
    [sym_while_statement] = STATE(2011),
    [sym_if_statement] = STATE(2011),
    [sym_case_statement] = STATE(2011),
    [sym_function_definition] = STATE(2011),
    [sym_subshell] = STATE(2011),
    [sym_pipeline] = STATE(2011),
    [sym_list] = STATE(2011),
    [sym_bracket_command] = STATE(2011),
    [sym_command] = STATE(2011),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(2012),
    [sym_declaration_command] = STATE(2011),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(2305),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_esac] = ACTIONS(4726),
    [anon_sym_SEMI_SEMI] = ACTIONS(4734),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [2020] = {
    [sym__terminated_statement] = STATE(2010),
    [sym_for_statement] = STATE(2011),
    [sym_while_statement] = STATE(2011),
    [sym_if_statement] = STATE(2011),
    [sym_case_statement] = STATE(2011),
    [sym_function_definition] = STATE(2011),
    [sym_subshell] = STATE(2011),
    [sym_pipeline] = STATE(2011),
    [sym_list] = STATE(2011),
    [sym_bracket_command] = STATE(2011),
    [sym_command] = STATE(2011),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(2012),
    [sym_declaration_command] = STATE(2011),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(2308),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_esac] = ACTIONS(4726),
    [anon_sym_SEMI_SEMI] = ACTIONS(4734),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [2021] = {
    [sym_concatenation] = STATE(2312),
    [sym_string] = STATE(2311),
    [sym_simple_expansion] = STATE(2311),
    [sym_expansion] = STATE(2311),
    [sym_command_substitution] = STATE(2311),
    [sym_process_substitution] = STATE(2311),
    [anon_sym_RBRACE] = ACTIONS(4736),
    [sym__special_characters] = ACTIONS(4738),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(4740),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4742),
  },
  [2022] = {
    [sym__concat] = ACTIONS(1598),
    [anon_sym_PIPE] = ACTIONS(1598),
    [anon_sym_RPAREN] = ACTIONS(1598),
    [sym_comment] = ACTIONS(52),
  },
  [2023] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4744),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2024] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(4746),
    [sym_comment] = ACTIONS(52),
  },
  [2025] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2316),
    [anon_sym_RBRACE] = ACTIONS(4748),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2026] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2318),
    [anon_sym_RBRACE] = ACTIONS(4750),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2027] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2319),
    [anon_sym_RBRACE] = ACTIONS(4736),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2028] = {
    [sym__concat] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(1642),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [sym_comment] = ACTIONS(52),
  },
  [2029] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4752),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2030] = {
    [sym__concat] = ACTIONS(1648),
    [anon_sym_PIPE] = ACTIONS(1648),
    [anon_sym_RPAREN] = ACTIONS(1648),
    [sym_comment] = ACTIONS(52),
  },
  [2031] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4736),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2032] = {
    [sym__concat] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(1762),
    [anon_sym_RPAREN] = ACTIONS(1762),
    [sym_comment] = ACTIONS(52),
  },
  [2033] = {
    [sym__concat] = ACTIONS(1902),
    [anon_sym_PIPE] = ACTIONS(1902),
    [anon_sym_RPAREN] = ACTIONS(1902),
    [sym_comment] = ACTIONS(52),
  },
  [2034] = {
    [anon_sym_PIPE] = ACTIONS(4754),
    [anon_sym_RPAREN] = ACTIONS(4754),
    [anon_sym_SEMI_SEMI] = ACTIONS(4754),
    [anon_sym_PIPE_AMP] = ACTIONS(4754),
    [anon_sym_AMP_AMP] = ACTIONS(4754),
    [anon_sym_PIPE_PIPE] = ACTIONS(4754),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(4754),
    [anon_sym_LF] = ACTIONS(4754),
    [anon_sym_AMP] = ACTIONS(4754),
  },
  [2035] = {
    [aux_sym_case_item_repeat1] = STATE(2322),
    [aux_sym_concatenation_repeat1] = STATE(1607),
    [sym__concat] = ACTIONS(3354),
    [anon_sym_PIPE] = ACTIONS(3356),
    [anon_sym_RPAREN] = ACTIONS(4756),
    [sym_comment] = ACTIONS(52),
  },
  [2036] = {
    [aux_sym_case_item_repeat1] = STATE(2324),
    [aux_sym_concatenation_repeat1] = STATE(1607),
    [sym__concat] = ACTIONS(3354),
    [anon_sym_PIPE] = ACTIONS(3356),
    [anon_sym_RPAREN] = ACTIONS(4758),
    [sym_comment] = ACTIONS(52),
  },
  [2037] = {
    [aux_sym_case_item_repeat1] = STATE(2324),
    [anon_sym_PIPE] = ACTIONS(3356),
    [anon_sym_RPAREN] = ACTIONS(4758),
    [sym_comment] = ACTIONS(52),
  },
  [2038] = {
    [anon_sym_esac] = ACTIONS(4760),
    [sym_comment] = ACTIONS(52),
  },
  [2039] = {
    [anon_sym_PIPE] = ACTIONS(4762),
    [anon_sym_RPAREN] = ACTIONS(4762),
    [anon_sym_SEMI_SEMI] = ACTIONS(4762),
    [anon_sym_PIPE_AMP] = ACTIONS(4762),
    [anon_sym_AMP_AMP] = ACTIONS(4762),
    [anon_sym_PIPE_PIPE] = ACTIONS(4762),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(4762),
    [anon_sym_LF] = ACTIONS(4762),
    [anon_sym_AMP] = ACTIONS(4762),
  },
  [2040] = {
    [anon_sym_esac] = ACTIONS(4764),
    [sym_comment] = ACTIONS(52),
  },
  [2041] = {
    [sym__concat] = ACTIONS(4406),
    [anon_sym_in] = ACTIONS(4408),
    [anon_sym_SEMI_SEMI] = ACTIONS(4408),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(4408),
    [anon_sym_LF] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4408),
  },
  [2042] = {
    [sym__concat] = ACTIONS(4410),
    [anon_sym_in] = ACTIONS(4412),
    [anon_sym_SEMI_SEMI] = ACTIONS(4412),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(4412),
    [anon_sym_LF] = ACTIONS(4412),
    [anon_sym_AMP] = ACTIONS(4412),
  },
  [2043] = {
    [sym__concat] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(1524),
    [anon_sym_SEMI_SEMI] = ACTIONS(1524),
    [anon_sym_PIPE_AMP] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1524),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1524),
    [anon_sym_LF] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1524),
  },
  [2044] = {
    [aux_sym_concatenation_repeat1] = STATE(2044),
    [sym__concat] = ACTIONS(4766),
    [anon_sym_PIPE] = ACTIONS(1524),
    [anon_sym_SEMI_SEMI] = ACTIONS(1524),
    [anon_sym_PIPE_AMP] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1524),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1524),
    [anon_sym_LF] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1524),
  },
  [2045] = {
    [sym__concat] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(1555),
    [anon_sym_SEMI_SEMI] = ACTIONS(1555),
    [anon_sym_PIPE_AMP] = ACTIONS(1555),
    [anon_sym_AMP_AMP] = ACTIONS(1555),
    [anon_sym_PIPE_PIPE] = ACTIONS(1555),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1555),
    [anon_sym_LF] = ACTIONS(1555),
    [anon_sym_AMP] = ACTIONS(1555),
  },
  [2046] = {
    [sym_concatenation] = STATE(2330),
    [sym_string] = STATE(2329),
    [sym_simple_expansion] = STATE(2329),
    [sym_expansion] = STATE(2329),
    [sym_command_substitution] = STATE(2329),
    [sym_process_substitution] = STATE(2329),
    [anon_sym_RBRACE] = ACTIONS(4769),
    [sym__special_characters] = ACTIONS(4771),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(4773),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4775),
  },
  [2047] = {
    [sym__concat] = ACTIONS(1598),
    [anon_sym_PIPE] = ACTIONS(1600),
    [anon_sym_SEMI_SEMI] = ACTIONS(1600),
    [anon_sym_PIPE_AMP] = ACTIONS(1600),
    [anon_sym_AMP_AMP] = ACTIONS(1600),
    [anon_sym_PIPE_PIPE] = ACTIONS(1600),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1600),
    [anon_sym_LF] = ACTIONS(1600),
    [anon_sym_AMP] = ACTIONS(1600),
  },
  [2048] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4777),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2049] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(4779),
    [sym_comment] = ACTIONS(52),
  },
  [2050] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2334),
    [anon_sym_RBRACE] = ACTIONS(4781),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2051] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2336),
    [anon_sym_RBRACE] = ACTIONS(4783),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2052] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2337),
    [anon_sym_RBRACE] = ACTIONS(4769),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2053] = {
    [sym__concat] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [2054] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4785),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2055] = {
    [sym__concat] = ACTIONS(1648),
    [anon_sym_PIPE] = ACTIONS(1650),
    [anon_sym_SEMI_SEMI] = ACTIONS(1650),
    [anon_sym_PIPE_AMP] = ACTIONS(1650),
    [anon_sym_AMP_AMP] = ACTIONS(1650),
    [anon_sym_PIPE_PIPE] = ACTIONS(1650),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1650),
    [anon_sym_LF] = ACTIONS(1650),
    [anon_sym_AMP] = ACTIONS(1650),
  },
  [2056] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4769),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2057] = {
    [sym__concat] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(1764),
    [anon_sym_SEMI_SEMI] = ACTIONS(1764),
    [anon_sym_PIPE_AMP] = ACTIONS(1764),
    [anon_sym_AMP_AMP] = ACTIONS(1764),
    [anon_sym_PIPE_PIPE] = ACTIONS(1764),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1764),
    [anon_sym_LF] = ACTIONS(1764),
    [anon_sym_AMP] = ACTIONS(1764),
  },
  [2058] = {
    [sym__concat] = ACTIONS(1902),
    [anon_sym_PIPE] = ACTIONS(1904),
    [anon_sym_SEMI_SEMI] = ACTIONS(1904),
    [anon_sym_PIPE_AMP] = ACTIONS(1904),
    [anon_sym_AMP_AMP] = ACTIONS(1904),
    [anon_sym_PIPE_PIPE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1904),
    [anon_sym_LF] = ACTIONS(1904),
    [anon_sym_AMP] = ACTIONS(1904),
  },
  [2059] = {
    [sym_file_descriptor] = ACTIONS(2560),
    [sym__concat] = ACTIONS(2560),
    [sym_variable_name] = ACTIONS(2560),
    [anon_sym_PIPE] = ACTIONS(2562),
    [anon_sym_RPAREN] = ACTIONS(2562),
    [anon_sym_SEMI_SEMI] = ACTIONS(2562),
    [anon_sym_PIPE_AMP] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_PIPE_PIPE] = ACTIONS(2562),
    [anon_sym_LT] = ACTIONS(2562),
    [anon_sym_GT] = ACTIONS(2562),
    [anon_sym_GT_GT] = ACTIONS(2562),
    [anon_sym_AMP_GT] = ACTIONS(2562),
    [anon_sym_AMP_GT_GT] = ACTIONS(2562),
    [anon_sym_LT_AMP] = ACTIONS(2562),
    [anon_sym_GT_AMP] = ACTIONS(2562),
    [sym__special_characters] = ACTIONS(2562),
    [anon_sym_DQUOTE] = ACTIONS(2562),
    [sym_raw_string] = ACTIONS(2562),
    [anon_sym_DOLLAR] = ACTIONS(2562),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2562),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2562),
    [anon_sym_BQUOTE] = ACTIONS(2562),
    [anon_sym_LT_LPAREN] = ACTIONS(2562),
    [anon_sym_GT_LPAREN] = ACTIONS(2562),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2562),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym_LF] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(2562),
  },
  [2060] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4787),
    [sym_comment] = ACTIONS(52),
  },
  [2061] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4789),
    [sym_comment] = ACTIONS(52),
  },
  [2062] = {
    [anon_sym_RBRACE] = ACTIONS(4789),
    [sym_comment] = ACTIONS(52),
  },
  [2063] = {
    [sym_file_descriptor] = ACTIONS(2614),
    [sym__concat] = ACTIONS(2614),
    [sym_variable_name] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2616),
    [anon_sym_RPAREN] = ACTIONS(2616),
    [anon_sym_SEMI_SEMI] = ACTIONS(2616),
    [anon_sym_PIPE_AMP] = ACTIONS(2616),
    [anon_sym_AMP_AMP] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2616),
    [anon_sym_LT] = ACTIONS(2616),
    [anon_sym_GT] = ACTIONS(2616),
    [anon_sym_GT_GT] = ACTIONS(2616),
    [anon_sym_AMP_GT] = ACTIONS(2616),
    [anon_sym_AMP_GT_GT] = ACTIONS(2616),
    [anon_sym_LT_AMP] = ACTIONS(2616),
    [anon_sym_GT_AMP] = ACTIONS(2616),
    [sym__special_characters] = ACTIONS(2616),
    [anon_sym_DQUOTE] = ACTIONS(2616),
    [sym_raw_string] = ACTIONS(2616),
    [anon_sym_DOLLAR] = ACTIONS(2616),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2616),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2616),
    [anon_sym_BQUOTE] = ACTIONS(2616),
    [anon_sym_LT_LPAREN] = ACTIONS(2616),
    [anon_sym_GT_LPAREN] = ACTIONS(2616),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2616),
    [anon_sym_LF] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2616),
  },
  [2064] = {
    [sym_concatenation] = STATE(2343),
    [sym_string] = STATE(2342),
    [sym_simple_expansion] = STATE(2342),
    [sym_expansion] = STATE(2342),
    [sym_command_substitution] = STATE(2342),
    [sym_process_substitution] = STATE(2342),
    [anon_sym_RBRACE] = ACTIONS(4789),
    [sym__special_characters] = ACTIONS(4791),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(4793),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4795),
  },
  [2065] = {
    [sym_file_descriptor] = ACTIONS(2659),
    [sym__concat] = ACTIONS(2659),
    [sym_variable_name] = ACTIONS(2659),
    [anon_sym_PIPE] = ACTIONS(2661),
    [anon_sym_RPAREN] = ACTIONS(2661),
    [anon_sym_SEMI_SEMI] = ACTIONS(2661),
    [anon_sym_PIPE_AMP] = ACTIONS(2661),
    [anon_sym_AMP_AMP] = ACTIONS(2661),
    [anon_sym_PIPE_PIPE] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(2661),
    [anon_sym_GT] = ACTIONS(2661),
    [anon_sym_GT_GT] = ACTIONS(2661),
    [anon_sym_AMP_GT] = ACTIONS(2661),
    [anon_sym_AMP_GT_GT] = ACTIONS(2661),
    [anon_sym_LT_AMP] = ACTIONS(2661),
    [anon_sym_GT_AMP] = ACTIONS(2661),
    [sym__special_characters] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2661),
    [sym_raw_string] = ACTIONS(2661),
    [anon_sym_DOLLAR] = ACTIONS(2661),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2661),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2661),
    [anon_sym_BQUOTE] = ACTIONS(2661),
    [anon_sym_LT_LPAREN] = ACTIONS(2661),
    [anon_sym_GT_LPAREN] = ACTIONS(2661),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2661),
    [anon_sym_SEMI] = ACTIONS(2661),
    [anon_sym_LF] = ACTIONS(2661),
    [anon_sym_AMP] = ACTIONS(2661),
  },
  [2066] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4797),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2067] = {
    [sym_file_descriptor] = ACTIONS(2665),
    [sym__concat] = ACTIONS(2665),
    [sym_variable_name] = ACTIONS(2665),
    [anon_sym_PIPE] = ACTIONS(2667),
    [anon_sym_RPAREN] = ACTIONS(2667),
    [anon_sym_SEMI_SEMI] = ACTIONS(2667),
    [anon_sym_PIPE_AMP] = ACTIONS(2667),
    [anon_sym_AMP_AMP] = ACTIONS(2667),
    [anon_sym_PIPE_PIPE] = ACTIONS(2667),
    [anon_sym_LT] = ACTIONS(2667),
    [anon_sym_GT] = ACTIONS(2667),
    [anon_sym_GT_GT] = ACTIONS(2667),
    [anon_sym_AMP_GT] = ACTIONS(2667),
    [anon_sym_AMP_GT_GT] = ACTIONS(2667),
    [anon_sym_LT_AMP] = ACTIONS(2667),
    [anon_sym_GT_AMP] = ACTIONS(2667),
    [sym__special_characters] = ACTIONS(2667),
    [anon_sym_DQUOTE] = ACTIONS(2667),
    [sym_raw_string] = ACTIONS(2667),
    [anon_sym_DOLLAR] = ACTIONS(2667),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2667),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2667),
    [anon_sym_BQUOTE] = ACTIONS(2667),
    [anon_sym_LT_LPAREN] = ACTIONS(2667),
    [anon_sym_GT_LPAREN] = ACTIONS(2667),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2667),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym_LF] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(2667),
  },
  [2068] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4799),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2069] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4789),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2070] = {
    [sym_file_descriptor] = ACTIONS(2671),
    [sym__concat] = ACTIONS(2671),
    [sym_variable_name] = ACTIONS(2671),
    [anon_sym_PIPE] = ACTIONS(2673),
    [anon_sym_RPAREN] = ACTIONS(2673),
    [anon_sym_SEMI_SEMI] = ACTIONS(2673),
    [anon_sym_PIPE_AMP] = ACTIONS(2673),
    [anon_sym_AMP_AMP] = ACTIONS(2673),
    [anon_sym_PIPE_PIPE] = ACTIONS(2673),
    [anon_sym_LT] = ACTIONS(2673),
    [anon_sym_GT] = ACTIONS(2673),
    [anon_sym_GT_GT] = ACTIONS(2673),
    [anon_sym_AMP_GT] = ACTIONS(2673),
    [anon_sym_AMP_GT_GT] = ACTIONS(2673),
    [anon_sym_LT_AMP] = ACTIONS(2673),
    [anon_sym_GT_AMP] = ACTIONS(2673),
    [sym__special_characters] = ACTIONS(2673),
    [anon_sym_DQUOTE] = ACTIONS(2673),
    [sym_raw_string] = ACTIONS(2673),
    [anon_sym_DOLLAR] = ACTIONS(2673),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2673),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2673),
    [anon_sym_BQUOTE] = ACTIONS(2673),
    [anon_sym_LT_LPAREN] = ACTIONS(2673),
    [anon_sym_GT_LPAREN] = ACTIONS(2673),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(2673),
    [anon_sym_SEMI] = ACTIONS(2673),
    [anon_sym_LF] = ACTIONS(2673),
    [anon_sym_AMP] = ACTIONS(2673),
  },
  [2071] = {
    [aux_sym_concatenation_repeat1] = STATE(2074),
    [sym__concat] = ACTIONS(4272),
    [anon_sym_PIPE] = ACTIONS(3112),
    [anon_sym_RPAREN] = ACTIONS(3112),
    [anon_sym_SEMI_SEMI] = ACTIONS(3112),
    [anon_sym_PIPE_AMP] = ACTIONS(3112),
    [anon_sym_AMP_AMP] = ACTIONS(3112),
    [anon_sym_PIPE_PIPE] = ACTIONS(3112),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3112),
    [anon_sym_LF] = ACTIONS(3112),
    [anon_sym_AMP] = ACTIONS(3112),
  },
  [2072] = {
    [aux_sym_concatenation_repeat1] = STATE(2074),
    [sym__concat] = ACTIONS(4272),
    [anon_sym_PIPE] = ACTIONS(3114),
    [anon_sym_RPAREN] = ACTIONS(3114),
    [anon_sym_SEMI_SEMI] = ACTIONS(3114),
    [anon_sym_PIPE_AMP] = ACTIONS(3114),
    [anon_sym_AMP_AMP] = ACTIONS(3114),
    [anon_sym_PIPE_PIPE] = ACTIONS(3114),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3114),
    [anon_sym_LF] = ACTIONS(3114),
    [anon_sym_AMP] = ACTIONS(3114),
  },
  [2073] = {
    [sym_string] = STATE(2346),
    [sym_simple_expansion] = STATE(2346),
    [sym_expansion] = STATE(2346),
    [sym_command_substitution] = STATE(2346),
    [sym_process_substitution] = STATE(2346),
    [sym__special_characters] = ACTIONS(4801),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_raw_string] = ACTIONS(4803),
    [anon_sym_DOLLAR] = ACTIONS(3478),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3480),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3482),
    [anon_sym_BQUOTE] = ACTIONS(3484),
    [anon_sym_LT_LPAREN] = ACTIONS(3486),
    [anon_sym_GT_LPAREN] = ACTIONS(3486),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4801),
  },
  [2074] = {
    [aux_sym_concatenation_repeat1] = STATE(2347),
    [sym__concat] = ACTIONS(4272),
    [anon_sym_PIPE] = ACTIONS(648),
    [anon_sym_RPAREN] = ACTIONS(648),
    [anon_sym_SEMI_SEMI] = ACTIONS(648),
    [anon_sym_PIPE_AMP] = ACTIONS(648),
    [anon_sym_AMP_AMP] = ACTIONS(648),
    [anon_sym_PIPE_PIPE] = ACTIONS(648),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(648),
    [anon_sym_LF] = ACTIONS(648),
    [anon_sym_AMP] = ACTIONS(648),
  },
  [2075] = {
    [sym__concat] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(652),
    [anon_sym_RPAREN] = ACTIONS(652),
    [anon_sym_SEMI_SEMI] = ACTIONS(652),
    [anon_sym_PIPE_AMP] = ACTIONS(652),
    [anon_sym_AMP_AMP] = ACTIONS(652),
    [anon_sym_PIPE_PIPE] = ACTIONS(652),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(652),
    [anon_sym_LF] = ACTIONS(652),
    [anon_sym_AMP] = ACTIONS(652),
  },
  [2076] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(4805),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [2077] = {
    [sym__concat] = ACTIONS(680),
    [anon_sym_PIPE] = ACTIONS(682),
    [anon_sym_RPAREN] = ACTIONS(682),
    [anon_sym_SEMI_SEMI] = ACTIONS(682),
    [anon_sym_PIPE_AMP] = ACTIONS(682),
    [anon_sym_AMP_AMP] = ACTIONS(682),
    [anon_sym_PIPE_PIPE] = ACTIONS(682),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(682),
    [anon_sym_LF] = ACTIONS(682),
    [anon_sym_AMP] = ACTIONS(682),
  },
  [2078] = {
    [sym__concat] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(686),
    [anon_sym_RPAREN] = ACTIONS(686),
    [anon_sym_SEMI_SEMI] = ACTIONS(686),
    [anon_sym_PIPE_AMP] = ACTIONS(686),
    [anon_sym_AMP_AMP] = ACTIONS(686),
    [anon_sym_PIPE_PIPE] = ACTIONS(686),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(686),
    [anon_sym_LF] = ACTIONS(686),
    [anon_sym_AMP] = ACTIONS(686),
  },
  [2079] = {
    [sym__concat] = ACTIONS(688),
    [anon_sym_PIPE] = ACTIONS(690),
    [anon_sym_RPAREN] = ACTIONS(690),
    [anon_sym_SEMI_SEMI] = ACTIONS(690),
    [anon_sym_PIPE_AMP] = ACTIONS(690),
    [anon_sym_AMP_AMP] = ACTIONS(690),
    [anon_sym_PIPE_PIPE] = ACTIONS(690),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(690),
    [anon_sym_LF] = ACTIONS(690),
    [anon_sym_AMP] = ACTIONS(690),
  },
  [2080] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(4807),
    [sym_comment] = ACTIONS(52),
  },
  [2081] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2351),
    [anon_sym_RBRACE] = ACTIONS(4809),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2082] = {
    [sym_subscript] = STATE(2355),
    [sym_variable_name] = ACTIONS(4811),
    [anon_sym_DOLLAR] = ACTIONS(4813),
    [anon_sym_DASH] = ACTIONS(4813),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4815),
    [anon_sym_STAR] = ACTIONS(4813),
    [anon_sym_AT] = ACTIONS(4813),
    [anon_sym_QMARK] = ACTIONS(4813),
    [anon_sym_0] = ACTIONS(4817),
    [anon_sym__] = ACTIONS(4817),
  },
  [2083] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2357),
    [anon_sym_RBRACE] = ACTIONS(4819),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2084] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2359),
    [anon_sym_RBRACE] = ACTIONS(4821),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2085] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(4823),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [2086] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(4823),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [2087] = {
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(4823),
    [sym_comment] = ACTIONS(52),
  },
  [2088] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(4823),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [2089] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(4825),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [2090] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(4825),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [2091] = {
    [sym__concat] = ACTIONS(3657),
    [sym_variable_name] = ACTIONS(3657),
    [anon_sym_PIPE] = ACTIONS(3659),
    [anon_sym_RPAREN] = ACTIONS(3659),
    [anon_sym_SEMI_SEMI] = ACTIONS(3659),
    [anon_sym_PIPE_AMP] = ACTIONS(3659),
    [anon_sym_AMP_AMP] = ACTIONS(3659),
    [anon_sym_PIPE_PIPE] = ACTIONS(3659),
    [sym__special_characters] = ACTIONS(3659),
    [anon_sym_DQUOTE] = ACTIONS(3659),
    [sym_raw_string] = ACTIONS(3659),
    [anon_sym_DOLLAR] = ACTIONS(3659),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3659),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3659),
    [anon_sym_BQUOTE] = ACTIONS(3659),
    [anon_sym_LT_LPAREN] = ACTIONS(3659),
    [anon_sym_GT_LPAREN] = ACTIONS(3659),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3659),
    [sym_word] = ACTIONS(3659),
    [anon_sym_SEMI] = ACTIONS(3659),
    [anon_sym_LF] = ACTIONS(3659),
    [anon_sym_AMP] = ACTIONS(3659),
  },
  [2092] = {
    [sym__concat] = ACTIONS(3663),
    [sym_variable_name] = ACTIONS(3663),
    [anon_sym_PIPE] = ACTIONS(3665),
    [anon_sym_RPAREN] = ACTIONS(3665),
    [anon_sym_SEMI_SEMI] = ACTIONS(3665),
    [anon_sym_PIPE_AMP] = ACTIONS(3665),
    [anon_sym_AMP_AMP] = ACTIONS(3665),
    [anon_sym_PIPE_PIPE] = ACTIONS(3665),
    [sym__special_characters] = ACTIONS(3665),
    [anon_sym_DQUOTE] = ACTIONS(3665),
    [sym_raw_string] = ACTIONS(3665),
    [anon_sym_DOLLAR] = ACTIONS(3665),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3665),
    [anon_sym_BQUOTE] = ACTIONS(3665),
    [anon_sym_LT_LPAREN] = ACTIONS(3665),
    [anon_sym_GT_LPAREN] = ACTIONS(3665),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3665),
    [sym_word] = ACTIONS(3665),
    [anon_sym_SEMI] = ACTIONS(3665),
    [anon_sym_LF] = ACTIONS(3665),
    [anon_sym_AMP] = ACTIONS(3665),
  },
  [2093] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4827),
    [sym_comment] = ACTIONS(52),
  },
  [2094] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4829),
    [sym_comment] = ACTIONS(52),
  },
  [2095] = {
    [anon_sym_RBRACE] = ACTIONS(4829),
    [sym_comment] = ACTIONS(52),
  },
  [2096] = {
    [sym__concat] = ACTIONS(3712),
    [sym_variable_name] = ACTIONS(3712),
    [anon_sym_PIPE] = ACTIONS(3714),
    [anon_sym_RPAREN] = ACTIONS(3714),
    [anon_sym_SEMI_SEMI] = ACTIONS(3714),
    [anon_sym_PIPE_AMP] = ACTIONS(3714),
    [anon_sym_AMP_AMP] = ACTIONS(3714),
    [anon_sym_PIPE_PIPE] = ACTIONS(3714),
    [sym__special_characters] = ACTIONS(3714),
    [anon_sym_DQUOTE] = ACTIONS(3714),
    [sym_raw_string] = ACTIONS(3714),
    [anon_sym_DOLLAR] = ACTIONS(3714),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3714),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3714),
    [anon_sym_BQUOTE] = ACTIONS(3714),
    [anon_sym_LT_LPAREN] = ACTIONS(3714),
    [anon_sym_GT_LPAREN] = ACTIONS(3714),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3714),
    [sym_word] = ACTIONS(3714),
    [anon_sym_SEMI] = ACTIONS(3714),
    [anon_sym_LF] = ACTIONS(3714),
    [anon_sym_AMP] = ACTIONS(3714),
  },
  [2097] = {
    [sym__concat] = ACTIONS(3716),
    [sym_variable_name] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3718),
    [anon_sym_RPAREN] = ACTIONS(3718),
    [anon_sym_SEMI_SEMI] = ACTIONS(3718),
    [anon_sym_PIPE_AMP] = ACTIONS(3718),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [sym__special_characters] = ACTIONS(3718),
    [anon_sym_DQUOTE] = ACTIONS(3718),
    [sym_raw_string] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3718),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3718),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3718),
    [anon_sym_BQUOTE] = ACTIONS(3718),
    [anon_sym_LT_LPAREN] = ACTIONS(3718),
    [anon_sym_GT_LPAREN] = ACTIONS(3718),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3718),
    [sym_word] = ACTIONS(3718),
    [anon_sym_SEMI] = ACTIONS(3718),
    [anon_sym_LF] = ACTIONS(3718),
    [anon_sym_AMP] = ACTIONS(3718),
  },
  [2098] = {
    [sym_file_descriptor] = ACTIONS(4406),
    [sym__concat] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_RPAREN] = ACTIONS(4408),
    [anon_sym_SEMI_SEMI] = ACTIONS(4408),
    [anon_sym_PIPE_AMP] = ACTIONS(4408),
    [anon_sym_AMP_AMP] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4408),
    [anon_sym_LT] = ACTIONS(4408),
    [anon_sym_GT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_AMP_GT] = ACTIONS(4408),
    [anon_sym_AMP_GT_GT] = ACTIONS(4408),
    [anon_sym_LT_AMP] = ACTIONS(4408),
    [anon_sym_GT_AMP] = ACTIONS(4408),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_LT_LT_DASH] = ACTIONS(4408),
    [anon_sym_LT_LT_LT] = ACTIONS(4408),
    [sym__special_characters] = ACTIONS(4408),
    [anon_sym_DQUOTE] = ACTIONS(4408),
    [sym_raw_string] = ACTIONS(4408),
    [anon_sym_DOLLAR] = ACTIONS(4408),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4408),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4408),
    [anon_sym_BQUOTE] = ACTIONS(4408),
    [anon_sym_LT_LPAREN] = ACTIONS(4408),
    [anon_sym_GT_LPAREN] = ACTIONS(4408),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(4408),
    [anon_sym_SEMI] = ACTIONS(4408),
    [anon_sym_LF] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4408),
  },
  [2099] = {
    [sym_file_descriptor] = ACTIONS(4410),
    [sym__concat] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4412),
    [anon_sym_RPAREN] = ACTIONS(4412),
    [anon_sym_SEMI_SEMI] = ACTIONS(4412),
    [anon_sym_PIPE_AMP] = ACTIONS(4412),
    [anon_sym_AMP_AMP] = ACTIONS(4412),
    [anon_sym_PIPE_PIPE] = ACTIONS(4412),
    [anon_sym_LT] = ACTIONS(4412),
    [anon_sym_GT] = ACTIONS(4412),
    [anon_sym_GT_GT] = ACTIONS(4412),
    [anon_sym_AMP_GT] = ACTIONS(4412),
    [anon_sym_AMP_GT_GT] = ACTIONS(4412),
    [anon_sym_LT_AMP] = ACTIONS(4412),
    [anon_sym_GT_AMP] = ACTIONS(4412),
    [anon_sym_LT_LT] = ACTIONS(4412),
    [anon_sym_LT_LT_DASH] = ACTIONS(4412),
    [anon_sym_LT_LT_LT] = ACTIONS(4412),
    [sym__special_characters] = ACTIONS(4412),
    [anon_sym_DQUOTE] = ACTIONS(4412),
    [sym_raw_string] = ACTIONS(4412),
    [anon_sym_DOLLAR] = ACTIONS(4412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4412),
    [anon_sym_BQUOTE] = ACTIONS(4412),
    [anon_sym_LT_LPAREN] = ACTIONS(4412),
    [anon_sym_GT_LPAREN] = ACTIONS(4412),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(4412),
    [anon_sym_SEMI] = ACTIONS(4412),
    [anon_sym_LF] = ACTIONS(4412),
    [anon_sym_AMP] = ACTIONS(4412),
  },
  [2100] = {
    [sym_file_descriptor] = ACTIONS(2560),
    [sym__concat] = ACTIONS(2560),
    [anon_sym_PIPE] = ACTIONS(2562),
    [anon_sym_RPAREN] = ACTIONS(2562),
    [anon_sym_SEMI_SEMI] = ACTIONS(2562),
    [anon_sym_PIPE_AMP] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_PIPE_PIPE] = ACTIONS(2562),
    [anon_sym_LT] = ACTIONS(2562),
    [anon_sym_GT] = ACTIONS(2562),
    [anon_sym_GT_GT] = ACTIONS(2562),
    [anon_sym_AMP_GT] = ACTIONS(2562),
    [anon_sym_AMP_GT_GT] = ACTIONS(2562),
    [anon_sym_LT_AMP] = ACTIONS(2562),
    [anon_sym_GT_AMP] = ACTIONS(2562),
    [anon_sym_LT_LT] = ACTIONS(2562),
    [anon_sym_LT_LT_DASH] = ACTIONS(2562),
    [anon_sym_LT_LT_LT] = ACTIONS(2562),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym_LF] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(2562),
  },
  [2101] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4831),
    [sym_comment] = ACTIONS(52),
  },
  [2102] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4833),
    [sym_comment] = ACTIONS(52),
  },
  [2103] = {
    [anon_sym_RBRACE] = ACTIONS(4833),
    [sym_comment] = ACTIONS(52),
  },
  [2104] = {
    [sym_file_descriptor] = ACTIONS(2614),
    [sym__concat] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2616),
    [anon_sym_RPAREN] = ACTIONS(2616),
    [anon_sym_SEMI_SEMI] = ACTIONS(2616),
    [anon_sym_PIPE_AMP] = ACTIONS(2616),
    [anon_sym_AMP_AMP] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2616),
    [anon_sym_LT] = ACTIONS(2616),
    [anon_sym_GT] = ACTIONS(2616),
    [anon_sym_GT_GT] = ACTIONS(2616),
    [anon_sym_AMP_GT] = ACTIONS(2616),
    [anon_sym_AMP_GT_GT] = ACTIONS(2616),
    [anon_sym_LT_AMP] = ACTIONS(2616),
    [anon_sym_GT_AMP] = ACTIONS(2616),
    [anon_sym_LT_LT] = ACTIONS(2616),
    [anon_sym_LT_LT_DASH] = ACTIONS(2616),
    [anon_sym_LT_LT_LT] = ACTIONS(2616),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2616),
    [anon_sym_LF] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2616),
  },
  [2105] = {
    [sym_concatenation] = STATE(2368),
    [sym_string] = STATE(2367),
    [sym_simple_expansion] = STATE(2367),
    [sym_expansion] = STATE(2367),
    [sym_command_substitution] = STATE(2367),
    [sym_process_substitution] = STATE(2367),
    [anon_sym_RBRACE] = ACTIONS(4833),
    [sym__special_characters] = ACTIONS(4835),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(4837),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4839),
  },
  [2106] = {
    [sym_file_descriptor] = ACTIONS(2659),
    [sym__concat] = ACTIONS(2659),
    [anon_sym_PIPE] = ACTIONS(2661),
    [anon_sym_RPAREN] = ACTIONS(2661),
    [anon_sym_SEMI_SEMI] = ACTIONS(2661),
    [anon_sym_PIPE_AMP] = ACTIONS(2661),
    [anon_sym_AMP_AMP] = ACTIONS(2661),
    [anon_sym_PIPE_PIPE] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(2661),
    [anon_sym_GT] = ACTIONS(2661),
    [anon_sym_GT_GT] = ACTIONS(2661),
    [anon_sym_AMP_GT] = ACTIONS(2661),
    [anon_sym_AMP_GT_GT] = ACTIONS(2661),
    [anon_sym_LT_AMP] = ACTIONS(2661),
    [anon_sym_GT_AMP] = ACTIONS(2661),
    [anon_sym_LT_LT] = ACTIONS(2661),
    [anon_sym_LT_LT_DASH] = ACTIONS(2661),
    [anon_sym_LT_LT_LT] = ACTIONS(2661),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2661),
    [anon_sym_LF] = ACTIONS(2661),
    [anon_sym_AMP] = ACTIONS(2661),
  },
  [2107] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4841),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2108] = {
    [sym_file_descriptor] = ACTIONS(2665),
    [sym__concat] = ACTIONS(2665),
    [anon_sym_PIPE] = ACTIONS(2667),
    [anon_sym_RPAREN] = ACTIONS(2667),
    [anon_sym_SEMI_SEMI] = ACTIONS(2667),
    [anon_sym_PIPE_AMP] = ACTIONS(2667),
    [anon_sym_AMP_AMP] = ACTIONS(2667),
    [anon_sym_PIPE_PIPE] = ACTIONS(2667),
    [anon_sym_LT] = ACTIONS(2667),
    [anon_sym_GT] = ACTIONS(2667),
    [anon_sym_GT_GT] = ACTIONS(2667),
    [anon_sym_AMP_GT] = ACTIONS(2667),
    [anon_sym_AMP_GT_GT] = ACTIONS(2667),
    [anon_sym_LT_AMP] = ACTIONS(2667),
    [anon_sym_GT_AMP] = ACTIONS(2667),
    [anon_sym_LT_LT] = ACTIONS(2667),
    [anon_sym_LT_LT_DASH] = ACTIONS(2667),
    [anon_sym_LT_LT_LT] = ACTIONS(2667),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym_LF] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(2667),
  },
  [2109] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4843),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2110] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4833),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2111] = {
    [sym_file_descriptor] = ACTIONS(2671),
    [sym__concat] = ACTIONS(2671),
    [anon_sym_PIPE] = ACTIONS(2673),
    [anon_sym_RPAREN] = ACTIONS(2673),
    [anon_sym_SEMI_SEMI] = ACTIONS(2673),
    [anon_sym_PIPE_AMP] = ACTIONS(2673),
    [anon_sym_AMP_AMP] = ACTIONS(2673),
    [anon_sym_PIPE_PIPE] = ACTIONS(2673),
    [anon_sym_LT] = ACTIONS(2673),
    [anon_sym_GT] = ACTIONS(2673),
    [anon_sym_GT_GT] = ACTIONS(2673),
    [anon_sym_AMP_GT] = ACTIONS(2673),
    [anon_sym_AMP_GT_GT] = ACTIONS(2673),
    [anon_sym_LT_AMP] = ACTIONS(2673),
    [anon_sym_GT_AMP] = ACTIONS(2673),
    [anon_sym_LT_LT] = ACTIONS(2673),
    [anon_sym_LT_LT_DASH] = ACTIONS(2673),
    [anon_sym_LT_LT_LT] = ACTIONS(2673),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2673),
    [anon_sym_LF] = ACTIONS(2673),
    [anon_sym_AMP] = ACTIONS(2673),
  },
  [2112] = {
    [sym__concat] = ACTIONS(4406),
    [anon_sym_RBRACK] = ACTIONS(4845),
    [sym__special_characters] = ACTIONS(4408),
    [anon_sym_DQUOTE] = ACTIONS(4406),
    [sym_raw_string] = ACTIONS(4406),
    [anon_sym_DOLLAR] = ACTIONS(4845),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4406),
    [anon_sym_BQUOTE] = ACTIONS(4406),
    [anon_sym_LT_LPAREN] = ACTIONS(4406),
    [anon_sym_GT_LPAREN] = ACTIONS(4406),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4845),
  },
  [2113] = {
    [sym__concat] = ACTIONS(4410),
    [anon_sym_RBRACK] = ACTIONS(4847),
    [sym__special_characters] = ACTIONS(4412),
    [anon_sym_DQUOTE] = ACTIONS(4410),
    [sym_raw_string] = ACTIONS(4410),
    [anon_sym_DOLLAR] = ACTIONS(4847),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4410),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4410),
    [anon_sym_BQUOTE] = ACTIONS(4410),
    [anon_sym_LT_LPAREN] = ACTIONS(4410),
    [anon_sym_GT_LPAREN] = ACTIONS(4410),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4847),
  },
  [2114] = {
    [sym__concat] = ACTIONS(4406),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4406),
    [sym__special_characters] = ACTIONS(4408),
    [anon_sym_DQUOTE] = ACTIONS(4406),
    [sym_raw_string] = ACTIONS(4406),
    [anon_sym_DOLLAR] = ACTIONS(4845),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4406),
    [anon_sym_BQUOTE] = ACTIONS(4406),
    [anon_sym_LT_LPAREN] = ACTIONS(4406),
    [anon_sym_GT_LPAREN] = ACTIONS(4406),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4845),
  },
  [2115] = {
    [sym__concat] = ACTIONS(4410),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4410),
    [sym__special_characters] = ACTIONS(4412),
    [anon_sym_DQUOTE] = ACTIONS(4410),
    [sym_raw_string] = ACTIONS(4410),
    [anon_sym_DOLLAR] = ACTIONS(4847),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4410),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4410),
    [anon_sym_BQUOTE] = ACTIONS(4410),
    [anon_sym_LT_LPAREN] = ACTIONS(4410),
    [anon_sym_GT_LPAREN] = ACTIONS(4410),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4847),
  },
  [2116] = {
    [sym__concat] = ACTIONS(4406),
    [sym_variable_name] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_SEMI_SEMI] = ACTIONS(4408),
    [anon_sym_PIPE_AMP] = ACTIONS(4408),
    [anon_sym_AMP_AMP] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4408),
    [sym__special_characters] = ACTIONS(4408),
    [anon_sym_DQUOTE] = ACTIONS(4408),
    [sym_raw_string] = ACTIONS(4408),
    [anon_sym_DOLLAR] = ACTIONS(4408),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4408),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4408),
    [anon_sym_BQUOTE] = ACTIONS(4408),
    [anon_sym_LT_LPAREN] = ACTIONS(4408),
    [anon_sym_GT_LPAREN] = ACTIONS(4408),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4408),
    [sym_word] = ACTIONS(4408),
    [anon_sym_SEMI] = ACTIONS(4408),
    [anon_sym_LF] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4408),
  },
  [2117] = {
    [sym__concat] = ACTIONS(4410),
    [sym_variable_name] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4412),
    [anon_sym_SEMI_SEMI] = ACTIONS(4412),
    [anon_sym_PIPE_AMP] = ACTIONS(4412),
    [anon_sym_AMP_AMP] = ACTIONS(4412),
    [anon_sym_PIPE_PIPE] = ACTIONS(4412),
    [sym__special_characters] = ACTIONS(4412),
    [anon_sym_DQUOTE] = ACTIONS(4412),
    [sym_raw_string] = ACTIONS(4412),
    [anon_sym_DOLLAR] = ACTIONS(4412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4412),
    [anon_sym_BQUOTE] = ACTIONS(4412),
    [anon_sym_LT_LPAREN] = ACTIONS(4412),
    [anon_sym_GT_LPAREN] = ACTIONS(4412),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4412),
    [sym_word] = ACTIONS(4412),
    [anon_sym_SEMI] = ACTIONS(4412),
    [anon_sym_LF] = ACTIONS(4412),
    [anon_sym_AMP] = ACTIONS(4412),
  },
  [2118] = {
    [sym_file_descriptor] = ACTIONS(4406),
    [sym__concat] = ACTIONS(4406),
    [sym_variable_name] = ACTIONS(4406),
    [anon_sym_LT] = ACTIONS(4845),
    [anon_sym_GT] = ACTIONS(4845),
    [anon_sym_GT_GT] = ACTIONS(4406),
    [anon_sym_AMP_GT] = ACTIONS(4845),
    [anon_sym_AMP_GT_GT] = ACTIONS(4406),
    [anon_sym_LT_AMP] = ACTIONS(4406),
    [anon_sym_GT_AMP] = ACTIONS(4406),
    [sym__special_characters] = ACTIONS(4845),
    [anon_sym_DQUOTE] = ACTIONS(4406),
    [sym_raw_string] = ACTIONS(4406),
    [anon_sym_DOLLAR] = ACTIONS(4845),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4406),
    [anon_sym_BQUOTE] = ACTIONS(4406),
    [anon_sym_LT_LPAREN] = ACTIONS(4406),
    [anon_sym_GT_LPAREN] = ACTIONS(4406),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4845),
  },
  [2119] = {
    [sym_file_descriptor] = ACTIONS(4410),
    [sym__concat] = ACTIONS(4410),
    [sym_variable_name] = ACTIONS(4410),
    [anon_sym_LT] = ACTIONS(4847),
    [anon_sym_GT] = ACTIONS(4847),
    [anon_sym_GT_GT] = ACTIONS(4410),
    [anon_sym_AMP_GT] = ACTIONS(4847),
    [anon_sym_AMP_GT_GT] = ACTIONS(4410),
    [anon_sym_LT_AMP] = ACTIONS(4410),
    [anon_sym_GT_AMP] = ACTIONS(4410),
    [sym__special_characters] = ACTIONS(4847),
    [anon_sym_DQUOTE] = ACTIONS(4410),
    [sym_raw_string] = ACTIONS(4410),
    [anon_sym_DOLLAR] = ACTIONS(4847),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4410),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4410),
    [anon_sym_BQUOTE] = ACTIONS(4410),
    [anon_sym_LT_LPAREN] = ACTIONS(4410),
    [anon_sym_GT_LPAREN] = ACTIONS(4410),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4847),
  },
  [2120] = {
    [sym__concat] = ACTIONS(4406),
    [anon_sym_DQUOTE] = ACTIONS(4408),
    [sym__string_content] = ACTIONS(4845),
    [anon_sym_DOLLAR] = ACTIONS(4408),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4408),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4408),
    [anon_sym_BQUOTE] = ACTIONS(4408),
    [sym_comment] = ACTIONS(168),
  },
  [2121] = {
    [sym__concat] = ACTIONS(4410),
    [anon_sym_DQUOTE] = ACTIONS(4412),
    [sym__string_content] = ACTIONS(4847),
    [anon_sym_DOLLAR] = ACTIONS(4412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4412),
    [anon_sym_BQUOTE] = ACTIONS(4412),
    [sym_comment] = ACTIONS(168),
  },
  [2122] = {
    [anon_sym_RBRACE] = ACTIONS(4046),
    [anon_sym_EQ] = ACTIONS(4849),
    [sym__special_characters] = ACTIONS(4851),
    [anon_sym_DQUOTE] = ACTIONS(4046),
    [sym_raw_string] = ACTIONS(4046),
    [anon_sym_DOLLAR] = ACTIONS(4849),
    [anon_sym_POUND] = ACTIONS(4046),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4046),
    [anon_sym_COLON] = ACTIONS(4849),
    [anon_sym_COLON_QMARK] = ACTIONS(4849),
    [anon_sym_COLON_DASH] = ACTIONS(4849),
    [anon_sym_PERCENT] = ACTIONS(4849),
    [anon_sym_SLASH] = ACTIONS(4849),
    [anon_sym_DASH] = ACTIONS(4849),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4046),
    [anon_sym_BQUOTE] = ACTIONS(4046),
    [anon_sym_LT_LPAREN] = ACTIONS(4046),
    [anon_sym_GT_LPAREN] = ACTIONS(4046),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(4851),
  },
  [2123] = {
    [anon_sym_RBRACE] = ACTIONS(4048),
    [anon_sym_EQ] = ACTIONS(4853),
    [sym__special_characters] = ACTIONS(4855),
    [anon_sym_DQUOTE] = ACTIONS(4048),
    [sym_raw_string] = ACTIONS(4048),
    [anon_sym_DOLLAR] = ACTIONS(4853),
    [anon_sym_POUND] = ACTIONS(4048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4048),
    [anon_sym_COLON] = ACTIONS(4853),
    [anon_sym_COLON_QMARK] = ACTIONS(4853),
    [anon_sym_COLON_DASH] = ACTIONS(4853),
    [anon_sym_PERCENT] = ACTIONS(4853),
    [anon_sym_SLASH] = ACTIONS(4853),
    [anon_sym_DASH] = ACTIONS(4853),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4048),
    [anon_sym_BQUOTE] = ACTIONS(4048),
    [anon_sym_LT_LPAREN] = ACTIONS(4048),
    [anon_sym_GT_LPAREN] = ACTIONS(4048),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(4855),
  },
  [2124] = {
    [sym__concat] = ACTIONS(2560),
    [anon_sym_RBRACE] = ACTIONS(2560),
    [sym_comment] = ACTIONS(52),
  },
  [2125] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4857),
    [sym_comment] = ACTIONS(52),
  },
  [2126] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4859),
    [sym_comment] = ACTIONS(52),
  },
  [2127] = {
    [anon_sym_RBRACE] = ACTIONS(4859),
    [sym_comment] = ACTIONS(52),
  },
  [2128] = {
    [sym__concat] = ACTIONS(2614),
    [anon_sym_RBRACE] = ACTIONS(2614),
    [sym_comment] = ACTIONS(52),
  },
  [2129] = {
    [sym_concatenation] = STATE(2375),
    [sym_string] = STATE(2374),
    [sym_simple_expansion] = STATE(2374),
    [sym_expansion] = STATE(2374),
    [sym_command_substitution] = STATE(2374),
    [sym_process_substitution] = STATE(2374),
    [anon_sym_RBRACE] = ACTIONS(4859),
    [sym__special_characters] = ACTIONS(4861),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(4863),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4865),
  },
  [2130] = {
    [sym__concat] = ACTIONS(2659),
    [anon_sym_RBRACE] = ACTIONS(2659),
    [sym_comment] = ACTIONS(52),
  },
  [2131] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4867),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2132] = {
    [sym__concat] = ACTIONS(2665),
    [anon_sym_RBRACE] = ACTIONS(2665),
    [sym_comment] = ACTIONS(52),
  },
  [2133] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4869),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2134] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4859),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2135] = {
    [sym__concat] = ACTIONS(2671),
    [anon_sym_RBRACE] = ACTIONS(2671),
    [sym_comment] = ACTIONS(52),
  },
  [2136] = {
    [sym__concat] = ACTIONS(3657),
    [anon_sym_RBRACE] = ACTIONS(3657),
    [anon_sym_EQ] = ACTIONS(4331),
    [sym__special_characters] = ACTIONS(3659),
    [anon_sym_DQUOTE] = ACTIONS(3657),
    [sym_raw_string] = ACTIONS(3657),
    [anon_sym_DOLLAR] = ACTIONS(4331),
    [anon_sym_POUND] = ACTIONS(3657),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3657),
    [anon_sym_COLON] = ACTIONS(4331),
    [anon_sym_COLON_QMARK] = ACTIONS(4331),
    [anon_sym_COLON_DASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4331),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3657),
    [anon_sym_BQUOTE] = ACTIONS(3657),
    [anon_sym_LT_LPAREN] = ACTIONS(3657),
    [anon_sym_GT_LPAREN] = ACTIONS(3657),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(3659),
  },
  [2137] = {
    [sym__concat] = ACTIONS(3663),
    [anon_sym_RBRACE] = ACTIONS(3663),
    [anon_sym_EQ] = ACTIONS(4333),
    [sym__special_characters] = ACTIONS(3665),
    [anon_sym_DQUOTE] = ACTIONS(3663),
    [sym_raw_string] = ACTIONS(3663),
    [anon_sym_DOLLAR] = ACTIONS(4333),
    [anon_sym_POUND] = ACTIONS(3663),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3663),
    [anon_sym_COLON] = ACTIONS(4333),
    [anon_sym_COLON_QMARK] = ACTIONS(4333),
    [anon_sym_COLON_DASH] = ACTIONS(4333),
    [anon_sym_PERCENT] = ACTIONS(4333),
    [anon_sym_SLASH] = ACTIONS(4333),
    [anon_sym_DASH] = ACTIONS(4333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3663),
    [anon_sym_BQUOTE] = ACTIONS(3663),
    [anon_sym_LT_LPAREN] = ACTIONS(3663),
    [anon_sym_GT_LPAREN] = ACTIONS(3663),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(3665),
  },
  [2138] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4871),
    [sym_comment] = ACTIONS(52),
  },
  [2139] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4873),
    [sym_comment] = ACTIONS(52),
  },
  [2140] = {
    [anon_sym_RBRACE] = ACTIONS(4873),
    [sym_comment] = ACTIONS(52),
  },
  [2141] = {
    [sym__concat] = ACTIONS(3712),
    [anon_sym_RBRACE] = ACTIONS(3712),
    [anon_sym_EQ] = ACTIONS(4339),
    [sym__special_characters] = ACTIONS(3714),
    [anon_sym_DQUOTE] = ACTIONS(3712),
    [sym_raw_string] = ACTIONS(3712),
    [anon_sym_DOLLAR] = ACTIONS(4339),
    [anon_sym_POUND] = ACTIONS(3712),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3712),
    [anon_sym_COLON] = ACTIONS(4339),
    [anon_sym_COLON_QMARK] = ACTIONS(4339),
    [anon_sym_COLON_DASH] = ACTIONS(4339),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4339),
    [anon_sym_DASH] = ACTIONS(4339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3712),
    [anon_sym_BQUOTE] = ACTIONS(3712),
    [anon_sym_LT_LPAREN] = ACTIONS(3712),
    [anon_sym_GT_LPAREN] = ACTIONS(3712),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(3714),
  },
  [2142] = {
    [sym__concat] = ACTIONS(3716),
    [anon_sym_RBRACE] = ACTIONS(3716),
    [anon_sym_EQ] = ACTIONS(4341),
    [sym__special_characters] = ACTIONS(3718),
    [anon_sym_DQUOTE] = ACTIONS(3716),
    [sym_raw_string] = ACTIONS(3716),
    [anon_sym_DOLLAR] = ACTIONS(4341),
    [anon_sym_POUND] = ACTIONS(3716),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3716),
    [anon_sym_COLON] = ACTIONS(4341),
    [anon_sym_COLON_QMARK] = ACTIONS(4341),
    [anon_sym_COLON_DASH] = ACTIONS(4341),
    [anon_sym_PERCENT] = ACTIONS(4341),
    [anon_sym_SLASH] = ACTIONS(4341),
    [anon_sym_DASH] = ACTIONS(4341),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3716),
    [anon_sym_BQUOTE] = ACTIONS(3716),
    [anon_sym_LT_LPAREN] = ACTIONS(3716),
    [anon_sym_GT_LPAREN] = ACTIONS(3716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(3718),
  },
  [2143] = {
    [sym_file_descriptor] = ACTIONS(2560),
    [sym__concat] = ACTIONS(2560),
    [sym_variable_name] = ACTIONS(2560),
    [anon_sym_PIPE] = ACTIONS(3553),
    [anon_sym_RPAREN] = ACTIONS(2560),
    [anon_sym_PIPE_AMP] = ACTIONS(2560),
    [anon_sym_AMP_AMP] = ACTIONS(2560),
    [anon_sym_PIPE_PIPE] = ACTIONS(2560),
    [anon_sym_LT] = ACTIONS(3553),
    [anon_sym_GT] = ACTIONS(3553),
    [anon_sym_GT_GT] = ACTIONS(2560),
    [anon_sym_AMP_GT] = ACTIONS(3553),
    [anon_sym_AMP_GT_GT] = ACTIONS(2560),
    [anon_sym_LT_AMP] = ACTIONS(2560),
    [anon_sym_GT_AMP] = ACTIONS(2560),
    [sym__special_characters] = ACTIONS(3553),
    [anon_sym_DQUOTE] = ACTIONS(2560),
    [sym_raw_string] = ACTIONS(2560),
    [anon_sym_DOLLAR] = ACTIONS(3553),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2560),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2560),
    [anon_sym_BQUOTE] = ACTIONS(2560),
    [anon_sym_LT_LPAREN] = ACTIONS(2560),
    [anon_sym_GT_LPAREN] = ACTIONS(2560),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3553),
  },
  [2144] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4875),
    [sym_comment] = ACTIONS(52),
  },
  [2145] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4877),
    [sym_comment] = ACTIONS(52),
  },
  [2146] = {
    [anon_sym_RBRACE] = ACTIONS(4877),
    [sym_comment] = ACTIONS(52),
  },
  [2147] = {
    [sym_file_descriptor] = ACTIONS(2614),
    [sym__concat] = ACTIONS(2614),
    [sym_variable_name] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(3559),
    [anon_sym_RPAREN] = ACTIONS(2614),
    [anon_sym_PIPE_AMP] = ACTIONS(2614),
    [anon_sym_AMP_AMP] = ACTIONS(2614),
    [anon_sym_PIPE_PIPE] = ACTIONS(2614),
    [anon_sym_LT] = ACTIONS(3559),
    [anon_sym_GT] = ACTIONS(3559),
    [anon_sym_GT_GT] = ACTIONS(2614),
    [anon_sym_AMP_GT] = ACTIONS(3559),
    [anon_sym_AMP_GT_GT] = ACTIONS(2614),
    [anon_sym_LT_AMP] = ACTIONS(2614),
    [anon_sym_GT_AMP] = ACTIONS(2614),
    [sym__special_characters] = ACTIONS(3559),
    [anon_sym_DQUOTE] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(2614),
    [anon_sym_DOLLAR] = ACTIONS(3559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2614),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2614),
    [anon_sym_BQUOTE] = ACTIONS(2614),
    [anon_sym_LT_LPAREN] = ACTIONS(2614),
    [anon_sym_GT_LPAREN] = ACTIONS(2614),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3559),
  },
  [2148] = {
    [sym_concatenation] = STATE(2384),
    [sym_string] = STATE(2383),
    [sym_simple_expansion] = STATE(2383),
    [sym_expansion] = STATE(2383),
    [sym_command_substitution] = STATE(2383),
    [sym_process_substitution] = STATE(2383),
    [anon_sym_RBRACE] = ACTIONS(4877),
    [sym__special_characters] = ACTIONS(4879),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(4881),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4883),
  },
  [2149] = {
    [sym_file_descriptor] = ACTIONS(2659),
    [sym__concat] = ACTIONS(2659),
    [sym_variable_name] = ACTIONS(2659),
    [anon_sym_PIPE] = ACTIONS(3567),
    [anon_sym_RPAREN] = ACTIONS(2659),
    [anon_sym_PIPE_AMP] = ACTIONS(2659),
    [anon_sym_AMP_AMP] = ACTIONS(2659),
    [anon_sym_PIPE_PIPE] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(3567),
    [anon_sym_GT] = ACTIONS(3567),
    [anon_sym_GT_GT] = ACTIONS(2659),
    [anon_sym_AMP_GT] = ACTIONS(3567),
    [anon_sym_AMP_GT_GT] = ACTIONS(2659),
    [anon_sym_LT_AMP] = ACTIONS(2659),
    [anon_sym_GT_AMP] = ACTIONS(2659),
    [sym__special_characters] = ACTIONS(3567),
    [anon_sym_DQUOTE] = ACTIONS(2659),
    [sym_raw_string] = ACTIONS(2659),
    [anon_sym_DOLLAR] = ACTIONS(3567),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2659),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2659),
    [anon_sym_BQUOTE] = ACTIONS(2659),
    [anon_sym_LT_LPAREN] = ACTIONS(2659),
    [anon_sym_GT_LPAREN] = ACTIONS(2659),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3567),
  },
  [2150] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4885),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2151] = {
    [sym_file_descriptor] = ACTIONS(2665),
    [sym__concat] = ACTIONS(2665),
    [sym_variable_name] = ACTIONS(2665),
    [anon_sym_PIPE] = ACTIONS(3571),
    [anon_sym_RPAREN] = ACTIONS(2665),
    [anon_sym_PIPE_AMP] = ACTIONS(2665),
    [anon_sym_AMP_AMP] = ACTIONS(2665),
    [anon_sym_PIPE_PIPE] = ACTIONS(2665),
    [anon_sym_LT] = ACTIONS(3571),
    [anon_sym_GT] = ACTIONS(3571),
    [anon_sym_GT_GT] = ACTIONS(2665),
    [anon_sym_AMP_GT] = ACTIONS(3571),
    [anon_sym_AMP_GT_GT] = ACTIONS(2665),
    [anon_sym_LT_AMP] = ACTIONS(2665),
    [anon_sym_GT_AMP] = ACTIONS(2665),
    [sym__special_characters] = ACTIONS(3571),
    [anon_sym_DQUOTE] = ACTIONS(2665),
    [sym_raw_string] = ACTIONS(2665),
    [anon_sym_DOLLAR] = ACTIONS(3571),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2665),
    [anon_sym_BQUOTE] = ACTIONS(2665),
    [anon_sym_LT_LPAREN] = ACTIONS(2665),
    [anon_sym_GT_LPAREN] = ACTIONS(2665),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3571),
  },
  [2152] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4887),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2153] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4877),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2154] = {
    [sym_file_descriptor] = ACTIONS(2671),
    [sym__concat] = ACTIONS(2671),
    [sym_variable_name] = ACTIONS(2671),
    [anon_sym_PIPE] = ACTIONS(3575),
    [anon_sym_RPAREN] = ACTIONS(2671),
    [anon_sym_PIPE_AMP] = ACTIONS(2671),
    [anon_sym_AMP_AMP] = ACTIONS(2671),
    [anon_sym_PIPE_PIPE] = ACTIONS(2671),
    [anon_sym_LT] = ACTIONS(3575),
    [anon_sym_GT] = ACTIONS(3575),
    [anon_sym_GT_GT] = ACTIONS(2671),
    [anon_sym_AMP_GT] = ACTIONS(3575),
    [anon_sym_AMP_GT_GT] = ACTIONS(2671),
    [anon_sym_LT_AMP] = ACTIONS(2671),
    [anon_sym_GT_AMP] = ACTIONS(2671),
    [sym__special_characters] = ACTIONS(3575),
    [anon_sym_DQUOTE] = ACTIONS(2671),
    [sym_raw_string] = ACTIONS(2671),
    [anon_sym_DOLLAR] = ACTIONS(3575),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2671),
    [anon_sym_BQUOTE] = ACTIONS(2671),
    [anon_sym_LT_LPAREN] = ACTIONS(2671),
    [anon_sym_GT_LPAREN] = ACTIONS(2671),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3575),
  },
  [2155] = {
    [sym__terminated_statement] = STATE(603),
    [sym_for_statement] = STATE(604),
    [sym_while_statement] = STATE(604),
    [sym_if_statement] = STATE(604),
    [sym_case_statement] = STATE(604),
    [sym_function_definition] = STATE(604),
    [sym_subshell] = STATE(604),
    [sym_pipeline] = STATE(604),
    [sym_list] = STATE(604),
    [sym_bracket_command] = STATE(604),
    [sym_command] = STATE(604),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(605),
    [sym_declaration_command] = STATE(604),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(2388),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_done] = ACTIONS(4889),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [2156] = {
    [anon_sym_PIPE] = ACTIONS(4891),
    [anon_sym_RPAREN] = ACTIONS(4893),
    [anon_sym_PIPE_AMP] = ACTIONS(4893),
    [anon_sym_AMP_AMP] = ACTIONS(4893),
    [anon_sym_PIPE_PIPE] = ACTIONS(4893),
    [anon_sym_BQUOTE] = ACTIONS(4893),
    [sym_comment] = ACTIONS(52),
  },
  [2157] = {
    [anon_sym_PIPE] = ACTIONS(4895),
    [anon_sym_RPAREN] = ACTIONS(4897),
    [anon_sym_PIPE_AMP] = ACTIONS(4897),
    [anon_sym_AMP_AMP] = ACTIONS(4897),
    [anon_sym_PIPE_PIPE] = ACTIONS(4897),
    [anon_sym_BQUOTE] = ACTIONS(4897),
    [sym_comment] = ACTIONS(52),
  },
  [2158] = {
    [anon_sym_fi] = ACTIONS(4899),
    [sym_comment] = ACTIONS(52),
  },
  [2159] = {
    [anon_sym_PIPE] = ACTIONS(4901),
    [anon_sym_RPAREN] = ACTIONS(4903),
    [anon_sym_PIPE_AMP] = ACTIONS(4903),
    [anon_sym_AMP_AMP] = ACTIONS(4903),
    [anon_sym_PIPE_PIPE] = ACTIONS(4903),
    [anon_sym_BQUOTE] = ACTIONS(4903),
    [sym_comment] = ACTIONS(52),
  },
  [2160] = {
    [anon_sym_esac] = ACTIONS(4905),
    [sym_comment] = ACTIONS(52),
  },
  [2161] = {
    [anon_sym_PIPE] = ACTIONS(4907),
    [anon_sym_RPAREN] = ACTIONS(4909),
    [anon_sym_PIPE_AMP] = ACTIONS(4909),
    [anon_sym_AMP_AMP] = ACTIONS(4909),
    [anon_sym_PIPE_PIPE] = ACTIONS(4909),
    [anon_sym_BQUOTE] = ACTIONS(4909),
    [sym_comment] = ACTIONS(52),
  },
  [2162] = {
    [sym_case_item] = STATE(1120),
    [sym_last_case_item] = STATE(2391),
    [sym_concatenation] = STATE(1122),
    [sym_string] = STATE(1114),
    [sym_simple_expansion] = STATE(1114),
    [sym_expansion] = STATE(1114),
    [sym_command_substitution] = STATE(1114),
    [sym_process_substitution] = STATE(1114),
    [aux_sym_case_statement_repeat1] = STATE(1628),
    [sym__special_characters] = ACTIONS(2174),
    [anon_sym_DQUOTE] = ACTIONS(2176),
    [sym_raw_string] = ACTIONS(2178),
    [anon_sym_DOLLAR] = ACTIONS(2180),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2182),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2184),
    [anon_sym_BQUOTE] = ACTIONS(2186),
    [anon_sym_LT_LPAREN] = ACTIONS(2188),
    [anon_sym_GT_LPAREN] = ACTIONS(2188),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3386),
  },
  [2163] = {
    [anon_sym_PIPE] = ACTIONS(4911),
    [anon_sym_RPAREN] = ACTIONS(4913),
    [anon_sym_PIPE_AMP] = ACTIONS(4913),
    [anon_sym_AMP_AMP] = ACTIONS(4913),
    [anon_sym_PIPE_PIPE] = ACTIONS(4913),
    [anon_sym_BQUOTE] = ACTIONS(4913),
    [sym_comment] = ACTIONS(52),
  },
  [2164] = {
    [anon_sym_esac] = ACTIONS(4915),
    [sym_comment] = ACTIONS(52),
  },
  [2165] = {
    [anon_sym_PIPE] = ACTIONS(4917),
    [anon_sym_RPAREN] = ACTIONS(4919),
    [anon_sym_PIPE_AMP] = ACTIONS(4919),
    [anon_sym_AMP_AMP] = ACTIONS(4919),
    [anon_sym_PIPE_PIPE] = ACTIONS(4919),
    [anon_sym_BQUOTE] = ACTIONS(4919),
    [sym_comment] = ACTIONS(52),
  },
  [2166] = {
    [sym_case_item] = STATE(1120),
    [sym_last_case_item] = STATE(2393),
    [sym_concatenation] = STATE(1122),
    [sym_string] = STATE(1114),
    [sym_simple_expansion] = STATE(1114),
    [sym_expansion] = STATE(1114),
    [sym_command_substitution] = STATE(1114),
    [sym_process_substitution] = STATE(1114),
    [aux_sym_case_statement_repeat1] = STATE(1628),
    [sym__special_characters] = ACTIONS(2174),
    [anon_sym_DQUOTE] = ACTIONS(2176),
    [sym_raw_string] = ACTIONS(2178),
    [anon_sym_DOLLAR] = ACTIONS(2180),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2182),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2184),
    [anon_sym_BQUOTE] = ACTIONS(2186),
    [anon_sym_LT_LPAREN] = ACTIONS(2188),
    [anon_sym_GT_LPAREN] = ACTIONS(2188),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3386),
  },
  [2167] = {
    [anon_sym_PIPE] = ACTIONS(4921),
    [anon_sym_RPAREN] = ACTIONS(4923),
    [anon_sym_PIPE_AMP] = ACTIONS(4923),
    [anon_sym_AMP_AMP] = ACTIONS(4923),
    [anon_sym_PIPE_PIPE] = ACTIONS(4923),
    [anon_sym_BQUOTE] = ACTIONS(4923),
    [sym_comment] = ACTIONS(52),
  },
  [2168] = {
    [aux_sym_concatenation_repeat1] = STATE(2172),
    [sym__concat] = ACTIONS(4475),
    [anon_sym_PIPE] = ACTIONS(1034),
    [anon_sym_RPAREN] = ACTIONS(1032),
    [anon_sym_PIPE_AMP] = ACTIONS(1032),
    [anon_sym_AMP_AMP] = ACTIONS(1032),
    [anon_sym_PIPE_PIPE] = ACTIONS(1032),
    [sym_comment] = ACTIONS(52),
  },
  [2169] = {
    [aux_sym_concatenation_repeat1] = STATE(2172),
    [sym__concat] = ACTIONS(4475),
    [anon_sym_PIPE] = ACTIONS(1038),
    [anon_sym_RPAREN] = ACTIONS(1036),
    [anon_sym_PIPE_AMP] = ACTIONS(1036),
    [anon_sym_AMP_AMP] = ACTIONS(1036),
    [anon_sym_PIPE_PIPE] = ACTIONS(1036),
    [sym_comment] = ACTIONS(52),
  },
  [2170] = {
    [anon_sym_PIPE] = ACTIONS(1038),
    [anon_sym_RPAREN] = ACTIONS(1036),
    [anon_sym_PIPE_AMP] = ACTIONS(1036),
    [anon_sym_AMP_AMP] = ACTIONS(1036),
    [anon_sym_PIPE_PIPE] = ACTIONS(1036),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_comment] = ACTIONS(52),
  },
  [2171] = {
    [sym_string] = STATE(2394),
    [sym_simple_expansion] = STATE(2394),
    [sym_expansion] = STATE(2394),
    [sym_command_substitution] = STATE(2394),
    [sym_process_substitution] = STATE(2394),
    [sym__special_characters] = ACTIONS(4925),
    [anon_sym_DQUOTE] = ACTIONS(3786),
    [sym_raw_string] = ACTIONS(4927),
    [anon_sym_DOLLAR] = ACTIONS(3790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3792),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3794),
    [anon_sym_BQUOTE] = ACTIONS(3796),
    [anon_sym_LT_LPAREN] = ACTIONS(3798),
    [anon_sym_GT_LPAREN] = ACTIONS(3798),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4925),
  },
  [2172] = {
    [aux_sym_concatenation_repeat1] = STATE(2395),
    [sym__concat] = ACTIONS(4475),
    [anon_sym_PIPE] = ACTIONS(1300),
    [anon_sym_RPAREN] = ACTIONS(646),
    [anon_sym_PIPE_AMP] = ACTIONS(646),
    [anon_sym_AMP_AMP] = ACTIONS(646),
    [anon_sym_PIPE_PIPE] = ACTIONS(646),
    [sym_comment] = ACTIONS(52),
  },
  [2173] = {
    [sym__concat] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(1302),
    [anon_sym_RPAREN] = ACTIONS(650),
    [anon_sym_PIPE_AMP] = ACTIONS(650),
    [anon_sym_AMP_AMP] = ACTIONS(650),
    [anon_sym_PIPE_PIPE] = ACTIONS(650),
    [sym_comment] = ACTIONS(52),
  },
  [2174] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(4929),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [2175] = {
    [sym__concat] = ACTIONS(680),
    [anon_sym_PIPE] = ACTIONS(1306),
    [anon_sym_RPAREN] = ACTIONS(680),
    [anon_sym_PIPE_AMP] = ACTIONS(680),
    [anon_sym_AMP_AMP] = ACTIONS(680),
    [anon_sym_PIPE_PIPE] = ACTIONS(680),
    [sym_comment] = ACTIONS(52),
  },
  [2176] = {
    [sym__concat] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(1308),
    [anon_sym_RPAREN] = ACTIONS(684),
    [anon_sym_PIPE_AMP] = ACTIONS(684),
    [anon_sym_AMP_AMP] = ACTIONS(684),
    [anon_sym_PIPE_PIPE] = ACTIONS(684),
    [sym_comment] = ACTIONS(52),
  },
  [2177] = {
    [sym__concat] = ACTIONS(688),
    [anon_sym_PIPE] = ACTIONS(1310),
    [anon_sym_RPAREN] = ACTIONS(688),
    [anon_sym_PIPE_AMP] = ACTIONS(688),
    [anon_sym_AMP_AMP] = ACTIONS(688),
    [anon_sym_PIPE_PIPE] = ACTIONS(688),
    [sym_comment] = ACTIONS(52),
  },
  [2178] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(4931),
    [sym_comment] = ACTIONS(52),
  },
  [2179] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2399),
    [anon_sym_RBRACE] = ACTIONS(4933),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2180] = {
    [sym_subscript] = STATE(2403),
    [sym_variable_name] = ACTIONS(4935),
    [anon_sym_DOLLAR] = ACTIONS(4937),
    [anon_sym_DASH] = ACTIONS(4937),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4939),
    [anon_sym_STAR] = ACTIONS(4937),
    [anon_sym_AT] = ACTIONS(4937),
    [anon_sym_QMARK] = ACTIONS(4937),
    [anon_sym_0] = ACTIONS(4941),
    [anon_sym__] = ACTIONS(4941),
  },
  [2181] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2405),
    [anon_sym_RBRACE] = ACTIONS(4943),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2182] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2407),
    [anon_sym_RBRACE] = ACTIONS(4945),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2183] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(4947),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [2184] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(4947),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [2185] = {
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(4947),
    [sym_comment] = ACTIONS(52),
  },
  [2186] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(4947),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [2187] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(4949),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [2188] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(4949),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [2189] = {
    [sym_variable_name] = ACTIONS(3227),
    [anon_sym_PIPE] = ACTIONS(4414),
    [anon_sym_RPAREN] = ACTIONS(3227),
    [anon_sym_PIPE_AMP] = ACTIONS(3227),
    [anon_sym_AMP_AMP] = ACTIONS(3227),
    [anon_sym_PIPE_PIPE] = ACTIONS(3227),
    [sym__special_characters] = ACTIONS(4414),
    [anon_sym_DQUOTE] = ACTIONS(3227),
    [sym_raw_string] = ACTIONS(3227),
    [anon_sym_DOLLAR] = ACTIONS(4414),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3227),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3227),
    [anon_sym_BQUOTE] = ACTIONS(3227),
    [anon_sym_LT_LPAREN] = ACTIONS(3227),
    [anon_sym_GT_LPAREN] = ACTIONS(3227),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4414),
    [sym_word] = ACTIONS(3229),
  },
  [2190] = {
    [sym__concat] = ACTIONS(3657),
    [sym_variable_name] = ACTIONS(3657),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_RPAREN] = ACTIONS(3657),
    [anon_sym_PIPE_AMP] = ACTIONS(3657),
    [anon_sym_AMP_AMP] = ACTIONS(3657),
    [anon_sym_PIPE_PIPE] = ACTIONS(3657),
    [sym__special_characters] = ACTIONS(4331),
    [anon_sym_DQUOTE] = ACTIONS(3657),
    [sym_raw_string] = ACTIONS(3657),
    [anon_sym_DOLLAR] = ACTIONS(4331),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3657),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3657),
    [anon_sym_BQUOTE] = ACTIONS(3657),
    [anon_sym_LT_LPAREN] = ACTIONS(3657),
    [anon_sym_GT_LPAREN] = ACTIONS(3657),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4331),
    [sym_word] = ACTIONS(3659),
  },
  [2191] = {
    [sym__concat] = ACTIONS(3663),
    [sym_variable_name] = ACTIONS(3663),
    [anon_sym_PIPE] = ACTIONS(4333),
    [anon_sym_RPAREN] = ACTIONS(3663),
    [anon_sym_PIPE_AMP] = ACTIONS(3663),
    [anon_sym_AMP_AMP] = ACTIONS(3663),
    [anon_sym_PIPE_PIPE] = ACTIONS(3663),
    [sym__special_characters] = ACTIONS(4333),
    [anon_sym_DQUOTE] = ACTIONS(3663),
    [sym_raw_string] = ACTIONS(3663),
    [anon_sym_DOLLAR] = ACTIONS(4333),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3663),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3663),
    [anon_sym_BQUOTE] = ACTIONS(3663),
    [anon_sym_LT_LPAREN] = ACTIONS(3663),
    [anon_sym_GT_LPAREN] = ACTIONS(3663),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4333),
    [sym_word] = ACTIONS(3665),
  },
  [2192] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4951),
    [sym_comment] = ACTIONS(52),
  },
  [2193] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(52),
  },
  [2194] = {
    [anon_sym_RBRACE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(52),
  },
  [2195] = {
    [sym__concat] = ACTIONS(3712),
    [sym_variable_name] = ACTIONS(3712),
    [anon_sym_PIPE] = ACTIONS(4339),
    [anon_sym_RPAREN] = ACTIONS(3712),
    [anon_sym_PIPE_AMP] = ACTIONS(3712),
    [anon_sym_AMP_AMP] = ACTIONS(3712),
    [anon_sym_PIPE_PIPE] = ACTIONS(3712),
    [sym__special_characters] = ACTIONS(4339),
    [anon_sym_DQUOTE] = ACTIONS(3712),
    [sym_raw_string] = ACTIONS(3712),
    [anon_sym_DOLLAR] = ACTIONS(4339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3712),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3712),
    [anon_sym_BQUOTE] = ACTIONS(3712),
    [anon_sym_LT_LPAREN] = ACTIONS(3712),
    [anon_sym_GT_LPAREN] = ACTIONS(3712),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4339),
    [sym_word] = ACTIONS(3714),
  },
  [2196] = {
    [sym__concat] = ACTIONS(3716),
    [sym_variable_name] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(4341),
    [anon_sym_RPAREN] = ACTIONS(3716),
    [anon_sym_PIPE_AMP] = ACTIONS(3716),
    [anon_sym_AMP_AMP] = ACTIONS(3716),
    [anon_sym_PIPE_PIPE] = ACTIONS(3716),
    [sym__special_characters] = ACTIONS(4341),
    [anon_sym_DQUOTE] = ACTIONS(3716),
    [sym_raw_string] = ACTIONS(3716),
    [anon_sym_DOLLAR] = ACTIONS(4341),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3716),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3716),
    [anon_sym_BQUOTE] = ACTIONS(3716),
    [anon_sym_LT_LPAREN] = ACTIONS(3716),
    [anon_sym_GT_LPAREN] = ACTIONS(3716),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4341),
    [sym_word] = ACTIONS(3718),
  },
  [2197] = {
    [sym_file_descriptor] = ACTIONS(4406),
    [sym__concat] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4845),
    [anon_sym_RPAREN] = ACTIONS(4406),
    [anon_sym_PIPE_AMP] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_LT] = ACTIONS(4845),
    [anon_sym_GT] = ACTIONS(4845),
    [anon_sym_GT_GT] = ACTIONS(4406),
    [anon_sym_AMP_GT] = ACTIONS(4845),
    [anon_sym_AMP_GT_GT] = ACTIONS(4406),
    [anon_sym_LT_AMP] = ACTIONS(4406),
    [anon_sym_GT_AMP] = ACTIONS(4406),
    [anon_sym_LT_LT] = ACTIONS(4845),
    [anon_sym_LT_LT_DASH] = ACTIONS(4406),
    [anon_sym_LT_LT_LT] = ACTIONS(4406),
    [sym__special_characters] = ACTIONS(4845),
    [anon_sym_DQUOTE] = ACTIONS(4406),
    [sym_raw_string] = ACTIONS(4406),
    [anon_sym_DOLLAR] = ACTIONS(4845),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4406),
    [anon_sym_BQUOTE] = ACTIONS(4406),
    [anon_sym_LT_LPAREN] = ACTIONS(4406),
    [anon_sym_GT_LPAREN] = ACTIONS(4406),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4845),
  },
  [2198] = {
    [sym_file_descriptor] = ACTIONS(4410),
    [sym__concat] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4847),
    [anon_sym_RPAREN] = ACTIONS(4410),
    [anon_sym_PIPE_AMP] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [anon_sym_LT] = ACTIONS(4847),
    [anon_sym_GT] = ACTIONS(4847),
    [anon_sym_GT_GT] = ACTIONS(4410),
    [anon_sym_AMP_GT] = ACTIONS(4847),
    [anon_sym_AMP_GT_GT] = ACTIONS(4410),
    [anon_sym_LT_AMP] = ACTIONS(4410),
    [anon_sym_GT_AMP] = ACTIONS(4410),
    [anon_sym_LT_LT] = ACTIONS(4847),
    [anon_sym_LT_LT_DASH] = ACTIONS(4410),
    [anon_sym_LT_LT_LT] = ACTIONS(4410),
    [sym__special_characters] = ACTIONS(4847),
    [anon_sym_DQUOTE] = ACTIONS(4410),
    [sym_raw_string] = ACTIONS(4410),
    [anon_sym_DOLLAR] = ACTIONS(4847),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4410),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4410),
    [anon_sym_BQUOTE] = ACTIONS(4410),
    [anon_sym_LT_LPAREN] = ACTIONS(4410),
    [anon_sym_GT_LPAREN] = ACTIONS(4410),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4847),
  },
  [2199] = {
    [sym_file_descriptor] = ACTIONS(2560),
    [sym__concat] = ACTIONS(2560),
    [anon_sym_PIPE] = ACTIONS(3553),
    [anon_sym_RPAREN] = ACTIONS(2560),
    [anon_sym_PIPE_AMP] = ACTIONS(2560),
    [anon_sym_AMP_AMP] = ACTIONS(2560),
    [anon_sym_PIPE_PIPE] = ACTIONS(2560),
    [anon_sym_LT] = ACTIONS(3553),
    [anon_sym_GT] = ACTIONS(3553),
    [anon_sym_GT_GT] = ACTIONS(2560),
    [anon_sym_AMP_GT] = ACTIONS(3553),
    [anon_sym_AMP_GT_GT] = ACTIONS(2560),
    [anon_sym_LT_AMP] = ACTIONS(2560),
    [anon_sym_GT_AMP] = ACTIONS(2560),
    [anon_sym_LT_LT] = ACTIONS(3553),
    [anon_sym_LT_LT_DASH] = ACTIONS(2560),
    [anon_sym_LT_LT_LT] = ACTIONS(2560),
    [sym_comment] = ACTIONS(52),
  },
  [2200] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4955),
    [sym_comment] = ACTIONS(52),
  },
  [2201] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4957),
    [sym_comment] = ACTIONS(52),
  },
  [2202] = {
    [anon_sym_RBRACE] = ACTIONS(4957),
    [sym_comment] = ACTIONS(52),
  },
  [2203] = {
    [sym_file_descriptor] = ACTIONS(2614),
    [sym__concat] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(3559),
    [anon_sym_RPAREN] = ACTIONS(2614),
    [anon_sym_PIPE_AMP] = ACTIONS(2614),
    [anon_sym_AMP_AMP] = ACTIONS(2614),
    [anon_sym_PIPE_PIPE] = ACTIONS(2614),
    [anon_sym_LT] = ACTIONS(3559),
    [anon_sym_GT] = ACTIONS(3559),
    [anon_sym_GT_GT] = ACTIONS(2614),
    [anon_sym_AMP_GT] = ACTIONS(3559),
    [anon_sym_AMP_GT_GT] = ACTIONS(2614),
    [anon_sym_LT_AMP] = ACTIONS(2614),
    [anon_sym_GT_AMP] = ACTIONS(2614),
    [anon_sym_LT_LT] = ACTIONS(3559),
    [anon_sym_LT_LT_DASH] = ACTIONS(2614),
    [anon_sym_LT_LT_LT] = ACTIONS(2614),
    [sym_comment] = ACTIONS(52),
  },
  [2204] = {
    [sym_concatenation] = STATE(2416),
    [sym_string] = STATE(2415),
    [sym_simple_expansion] = STATE(2415),
    [sym_expansion] = STATE(2415),
    [sym_command_substitution] = STATE(2415),
    [sym_process_substitution] = STATE(2415),
    [anon_sym_RBRACE] = ACTIONS(4957),
    [sym__special_characters] = ACTIONS(4959),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(4961),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4963),
  },
  [2205] = {
    [sym_file_descriptor] = ACTIONS(2659),
    [sym__concat] = ACTIONS(2659),
    [anon_sym_PIPE] = ACTIONS(3567),
    [anon_sym_RPAREN] = ACTIONS(2659),
    [anon_sym_PIPE_AMP] = ACTIONS(2659),
    [anon_sym_AMP_AMP] = ACTIONS(2659),
    [anon_sym_PIPE_PIPE] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(3567),
    [anon_sym_GT] = ACTIONS(3567),
    [anon_sym_GT_GT] = ACTIONS(2659),
    [anon_sym_AMP_GT] = ACTIONS(3567),
    [anon_sym_AMP_GT_GT] = ACTIONS(2659),
    [anon_sym_LT_AMP] = ACTIONS(2659),
    [anon_sym_GT_AMP] = ACTIONS(2659),
    [anon_sym_LT_LT] = ACTIONS(3567),
    [anon_sym_LT_LT_DASH] = ACTIONS(2659),
    [anon_sym_LT_LT_LT] = ACTIONS(2659),
    [sym_comment] = ACTIONS(52),
  },
  [2206] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4965),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2207] = {
    [sym_file_descriptor] = ACTIONS(2665),
    [sym__concat] = ACTIONS(2665),
    [anon_sym_PIPE] = ACTIONS(3571),
    [anon_sym_RPAREN] = ACTIONS(2665),
    [anon_sym_PIPE_AMP] = ACTIONS(2665),
    [anon_sym_AMP_AMP] = ACTIONS(2665),
    [anon_sym_PIPE_PIPE] = ACTIONS(2665),
    [anon_sym_LT] = ACTIONS(3571),
    [anon_sym_GT] = ACTIONS(3571),
    [anon_sym_GT_GT] = ACTIONS(2665),
    [anon_sym_AMP_GT] = ACTIONS(3571),
    [anon_sym_AMP_GT_GT] = ACTIONS(2665),
    [anon_sym_LT_AMP] = ACTIONS(2665),
    [anon_sym_GT_AMP] = ACTIONS(2665),
    [anon_sym_LT_LT] = ACTIONS(3571),
    [anon_sym_LT_LT_DASH] = ACTIONS(2665),
    [anon_sym_LT_LT_LT] = ACTIONS(2665),
    [sym_comment] = ACTIONS(52),
  },
  [2208] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4967),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2209] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4957),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2210] = {
    [sym_file_descriptor] = ACTIONS(2671),
    [sym__concat] = ACTIONS(2671),
    [anon_sym_PIPE] = ACTIONS(3575),
    [anon_sym_RPAREN] = ACTIONS(2671),
    [anon_sym_PIPE_AMP] = ACTIONS(2671),
    [anon_sym_AMP_AMP] = ACTIONS(2671),
    [anon_sym_PIPE_PIPE] = ACTIONS(2671),
    [anon_sym_LT] = ACTIONS(3575),
    [anon_sym_GT] = ACTIONS(3575),
    [anon_sym_GT_GT] = ACTIONS(2671),
    [anon_sym_AMP_GT] = ACTIONS(3575),
    [anon_sym_AMP_GT_GT] = ACTIONS(2671),
    [anon_sym_LT_AMP] = ACTIONS(2671),
    [anon_sym_GT_AMP] = ACTIONS(2671),
    [anon_sym_LT_LT] = ACTIONS(3575),
    [anon_sym_LT_LT_DASH] = ACTIONS(2671),
    [anon_sym_LT_LT_LT] = ACTIONS(2671),
    [sym_comment] = ACTIONS(52),
  },
  [2211] = {
    [sym_file_descriptor] = ACTIONS(2560),
    [sym__concat] = ACTIONS(2560),
    [sym_variable_name] = ACTIONS(2560),
    [anon_sym_PIPE] = ACTIONS(3553),
    [anon_sym_PIPE_AMP] = ACTIONS(2560),
    [anon_sym_AMP_AMP] = ACTIONS(2560),
    [anon_sym_PIPE_PIPE] = ACTIONS(2560),
    [anon_sym_LT] = ACTIONS(3553),
    [anon_sym_GT] = ACTIONS(3553),
    [anon_sym_GT_GT] = ACTIONS(2560),
    [anon_sym_AMP_GT] = ACTIONS(3553),
    [anon_sym_AMP_GT_GT] = ACTIONS(2560),
    [anon_sym_LT_AMP] = ACTIONS(2560),
    [anon_sym_GT_AMP] = ACTIONS(2560),
    [sym__special_characters] = ACTIONS(3553),
    [anon_sym_DQUOTE] = ACTIONS(2560),
    [sym_raw_string] = ACTIONS(2560),
    [anon_sym_DOLLAR] = ACTIONS(3553),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2560),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2560),
    [anon_sym_BQUOTE] = ACTIONS(2560),
    [anon_sym_LT_LPAREN] = ACTIONS(2560),
    [anon_sym_GT_LPAREN] = ACTIONS(2560),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3553),
  },
  [2212] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4969),
    [sym_comment] = ACTIONS(52),
  },
  [2213] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(4971),
    [sym_comment] = ACTIONS(52),
  },
  [2214] = {
    [anon_sym_RBRACE] = ACTIONS(4971),
    [sym_comment] = ACTIONS(52),
  },
  [2215] = {
    [sym_file_descriptor] = ACTIONS(2614),
    [sym__concat] = ACTIONS(2614),
    [sym_variable_name] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(3559),
    [anon_sym_PIPE_AMP] = ACTIONS(2614),
    [anon_sym_AMP_AMP] = ACTIONS(2614),
    [anon_sym_PIPE_PIPE] = ACTIONS(2614),
    [anon_sym_LT] = ACTIONS(3559),
    [anon_sym_GT] = ACTIONS(3559),
    [anon_sym_GT_GT] = ACTIONS(2614),
    [anon_sym_AMP_GT] = ACTIONS(3559),
    [anon_sym_AMP_GT_GT] = ACTIONS(2614),
    [anon_sym_LT_AMP] = ACTIONS(2614),
    [anon_sym_GT_AMP] = ACTIONS(2614),
    [sym__special_characters] = ACTIONS(3559),
    [anon_sym_DQUOTE] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(2614),
    [anon_sym_DOLLAR] = ACTIONS(3559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2614),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2614),
    [anon_sym_BQUOTE] = ACTIONS(2614),
    [anon_sym_LT_LPAREN] = ACTIONS(2614),
    [anon_sym_GT_LPAREN] = ACTIONS(2614),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3559),
  },
  [2216] = {
    [sym_concatenation] = STATE(2423),
    [sym_string] = STATE(2422),
    [sym_simple_expansion] = STATE(2422),
    [sym_expansion] = STATE(2422),
    [sym_command_substitution] = STATE(2422),
    [sym_process_substitution] = STATE(2422),
    [anon_sym_RBRACE] = ACTIONS(4971),
    [sym__special_characters] = ACTIONS(4973),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(4975),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4977),
  },
  [2217] = {
    [sym_file_descriptor] = ACTIONS(2659),
    [sym__concat] = ACTIONS(2659),
    [sym_variable_name] = ACTIONS(2659),
    [anon_sym_PIPE] = ACTIONS(3567),
    [anon_sym_PIPE_AMP] = ACTIONS(2659),
    [anon_sym_AMP_AMP] = ACTIONS(2659),
    [anon_sym_PIPE_PIPE] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(3567),
    [anon_sym_GT] = ACTIONS(3567),
    [anon_sym_GT_GT] = ACTIONS(2659),
    [anon_sym_AMP_GT] = ACTIONS(3567),
    [anon_sym_AMP_GT_GT] = ACTIONS(2659),
    [anon_sym_LT_AMP] = ACTIONS(2659),
    [anon_sym_GT_AMP] = ACTIONS(2659),
    [sym__special_characters] = ACTIONS(3567),
    [anon_sym_DQUOTE] = ACTIONS(2659),
    [sym_raw_string] = ACTIONS(2659),
    [anon_sym_DOLLAR] = ACTIONS(3567),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2659),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2659),
    [anon_sym_BQUOTE] = ACTIONS(2659),
    [anon_sym_LT_LPAREN] = ACTIONS(2659),
    [anon_sym_GT_LPAREN] = ACTIONS(2659),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3567),
  },
  [2218] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4979),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2219] = {
    [sym_file_descriptor] = ACTIONS(2665),
    [sym__concat] = ACTIONS(2665),
    [sym_variable_name] = ACTIONS(2665),
    [anon_sym_PIPE] = ACTIONS(3571),
    [anon_sym_PIPE_AMP] = ACTIONS(2665),
    [anon_sym_AMP_AMP] = ACTIONS(2665),
    [anon_sym_PIPE_PIPE] = ACTIONS(2665),
    [anon_sym_LT] = ACTIONS(3571),
    [anon_sym_GT] = ACTIONS(3571),
    [anon_sym_GT_GT] = ACTIONS(2665),
    [anon_sym_AMP_GT] = ACTIONS(3571),
    [anon_sym_AMP_GT_GT] = ACTIONS(2665),
    [anon_sym_LT_AMP] = ACTIONS(2665),
    [anon_sym_GT_AMP] = ACTIONS(2665),
    [sym__special_characters] = ACTIONS(3571),
    [anon_sym_DQUOTE] = ACTIONS(2665),
    [sym_raw_string] = ACTIONS(2665),
    [anon_sym_DOLLAR] = ACTIONS(3571),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2665),
    [anon_sym_BQUOTE] = ACTIONS(2665),
    [anon_sym_LT_LPAREN] = ACTIONS(2665),
    [anon_sym_GT_LPAREN] = ACTIONS(2665),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3571),
  },
  [2220] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4981),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2221] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(4971),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2222] = {
    [sym_file_descriptor] = ACTIONS(2671),
    [sym__concat] = ACTIONS(2671),
    [sym_variable_name] = ACTIONS(2671),
    [anon_sym_PIPE] = ACTIONS(3575),
    [anon_sym_PIPE_AMP] = ACTIONS(2671),
    [anon_sym_AMP_AMP] = ACTIONS(2671),
    [anon_sym_PIPE_PIPE] = ACTIONS(2671),
    [anon_sym_LT] = ACTIONS(3575),
    [anon_sym_GT] = ACTIONS(3575),
    [anon_sym_GT_GT] = ACTIONS(2671),
    [anon_sym_AMP_GT] = ACTIONS(3575),
    [anon_sym_AMP_GT_GT] = ACTIONS(2671),
    [anon_sym_LT_AMP] = ACTIONS(2671),
    [anon_sym_GT_AMP] = ACTIONS(2671),
    [sym__special_characters] = ACTIONS(3575),
    [anon_sym_DQUOTE] = ACTIONS(2671),
    [sym_raw_string] = ACTIONS(2671),
    [anon_sym_DOLLAR] = ACTIONS(3575),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2671),
    [anon_sym_BQUOTE] = ACTIONS(2671),
    [anon_sym_LT_LPAREN] = ACTIONS(2671),
    [anon_sym_GT_LPAREN] = ACTIONS(2671),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(3575),
  },
  [2223] = {
    [aux_sym_concatenation_repeat1] = STATE(2226),
    [sym__concat] = ACTIONS(4569),
    [anon_sym_PIPE] = ACTIONS(1034),
    [anon_sym_PIPE_AMP] = ACTIONS(1032),
    [anon_sym_AMP_AMP] = ACTIONS(1032),
    [anon_sym_PIPE_PIPE] = ACTIONS(1032),
    [anon_sym_BQUOTE] = ACTIONS(1032),
    [sym_comment] = ACTIONS(52),
  },
  [2224] = {
    [aux_sym_concatenation_repeat1] = STATE(2226),
    [sym__concat] = ACTIONS(4569),
    [anon_sym_PIPE] = ACTIONS(1038),
    [anon_sym_PIPE_AMP] = ACTIONS(1036),
    [anon_sym_AMP_AMP] = ACTIONS(1036),
    [anon_sym_PIPE_PIPE] = ACTIONS(1036),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_comment] = ACTIONS(52),
  },
  [2225] = {
    [sym_string] = STATE(2426),
    [sym_simple_expansion] = STATE(2426),
    [sym_expansion] = STATE(2426),
    [sym_command_substitution] = STATE(2426),
    [sym_process_substitution] = STATE(2426),
    [sym__special_characters] = ACTIONS(4983),
    [anon_sym_DQUOTE] = ACTIONS(3915),
    [sym_raw_string] = ACTIONS(4985),
    [anon_sym_DOLLAR] = ACTIONS(3919),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3921),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3923),
    [anon_sym_BQUOTE] = ACTIONS(3925),
    [anon_sym_LT_LPAREN] = ACTIONS(3927),
    [anon_sym_GT_LPAREN] = ACTIONS(3927),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4983),
  },
  [2226] = {
    [aux_sym_concatenation_repeat1] = STATE(2427),
    [sym__concat] = ACTIONS(4569),
    [anon_sym_PIPE] = ACTIONS(1300),
    [anon_sym_PIPE_AMP] = ACTIONS(646),
    [anon_sym_AMP_AMP] = ACTIONS(646),
    [anon_sym_PIPE_PIPE] = ACTIONS(646),
    [anon_sym_BQUOTE] = ACTIONS(646),
    [sym_comment] = ACTIONS(52),
  },
  [2227] = {
    [sym__concat] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(1302),
    [anon_sym_PIPE_AMP] = ACTIONS(650),
    [anon_sym_AMP_AMP] = ACTIONS(650),
    [anon_sym_PIPE_PIPE] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [sym_comment] = ACTIONS(52),
  },
  [2228] = {
    [sym_simple_expansion] = STATE(116),
    [sym_expansion] = STATE(116),
    [sym_command_substitution] = STATE(116),
    [aux_sym_string_repeat1] = STATE(389),
    [anon_sym_DQUOTE] = ACTIONS(4987),
    [sym__string_content] = ACTIONS(198),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [sym_comment] = ACTIONS(168),
  },
  [2229] = {
    [sym__concat] = ACTIONS(680),
    [anon_sym_PIPE] = ACTIONS(1306),
    [anon_sym_PIPE_AMP] = ACTIONS(680),
    [anon_sym_AMP_AMP] = ACTIONS(680),
    [anon_sym_PIPE_PIPE] = ACTIONS(680),
    [anon_sym_BQUOTE] = ACTIONS(680),
    [sym_comment] = ACTIONS(52),
  },
  [2230] = {
    [sym__concat] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(1308),
    [anon_sym_PIPE_AMP] = ACTIONS(684),
    [anon_sym_AMP_AMP] = ACTIONS(684),
    [anon_sym_PIPE_PIPE] = ACTIONS(684),
    [anon_sym_BQUOTE] = ACTIONS(684),
    [sym_comment] = ACTIONS(52),
  },
  [2231] = {
    [sym__concat] = ACTIONS(688),
    [anon_sym_PIPE] = ACTIONS(1310),
    [anon_sym_PIPE_AMP] = ACTIONS(688),
    [anon_sym_AMP_AMP] = ACTIONS(688),
    [anon_sym_PIPE_PIPE] = ACTIONS(688),
    [anon_sym_BQUOTE] = ACTIONS(688),
    [sym_comment] = ACTIONS(52),
  },
  [2232] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(4989),
    [sym_comment] = ACTIONS(52),
  },
  [2233] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2431),
    [anon_sym_RBRACE] = ACTIONS(4991),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2234] = {
    [sym_subscript] = STATE(2435),
    [sym_variable_name] = ACTIONS(4993),
    [anon_sym_DOLLAR] = ACTIONS(4995),
    [anon_sym_DASH] = ACTIONS(4995),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4997),
    [anon_sym_STAR] = ACTIONS(4995),
    [anon_sym_AT] = ACTIONS(4995),
    [anon_sym_QMARK] = ACTIONS(4995),
    [anon_sym_0] = ACTIONS(4999),
    [anon_sym__] = ACTIONS(4999),
  },
  [2235] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2437),
    [anon_sym_RBRACE] = ACTIONS(5001),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2236] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2439),
    [anon_sym_RBRACE] = ACTIONS(5003),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2237] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(5005),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [2238] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(5005),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [2239] = {
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(5005),
    [sym_comment] = ACTIONS(52),
  },
  [2240] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(5005),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [2241] = {
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(5007),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [sym_comment] = ACTIONS(52),
  },
  [2242] = {
    [sym_file_descriptor] = ACTIONS(334),
    [sym_variable_name] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(5007),
    [anon_sym_PIPE_AMP] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(338),
    [anon_sym_GT_GT] = ACTIONS(334),
    [anon_sym_AMP_GT] = ACTIONS(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(334),
    [anon_sym_LT_AMP] = ACTIONS(334),
    [anon_sym_GT_AMP] = ACTIONS(334),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [anon_sym_LT_LPAREN] = ACTIONS(334),
    [anon_sym_GT_LPAREN] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(338),
  },
  [2243] = {
    [sym__concat] = ACTIONS(3657),
    [sym_variable_name] = ACTIONS(3657),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_PIPE_AMP] = ACTIONS(3657),
    [anon_sym_AMP_AMP] = ACTIONS(3657),
    [anon_sym_PIPE_PIPE] = ACTIONS(3657),
    [sym__special_characters] = ACTIONS(4331),
    [anon_sym_DQUOTE] = ACTIONS(3657),
    [sym_raw_string] = ACTIONS(3657),
    [anon_sym_DOLLAR] = ACTIONS(4331),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3657),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3657),
    [anon_sym_BQUOTE] = ACTIONS(3657),
    [anon_sym_LT_LPAREN] = ACTIONS(3657),
    [anon_sym_GT_LPAREN] = ACTIONS(3657),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4331),
    [sym_word] = ACTIONS(3659),
  },
  [2244] = {
    [sym__concat] = ACTIONS(3663),
    [sym_variable_name] = ACTIONS(3663),
    [anon_sym_PIPE] = ACTIONS(4333),
    [anon_sym_PIPE_AMP] = ACTIONS(3663),
    [anon_sym_AMP_AMP] = ACTIONS(3663),
    [anon_sym_PIPE_PIPE] = ACTIONS(3663),
    [sym__special_characters] = ACTIONS(4333),
    [anon_sym_DQUOTE] = ACTIONS(3663),
    [sym_raw_string] = ACTIONS(3663),
    [anon_sym_DOLLAR] = ACTIONS(4333),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3663),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3663),
    [anon_sym_BQUOTE] = ACTIONS(3663),
    [anon_sym_LT_LPAREN] = ACTIONS(3663),
    [anon_sym_GT_LPAREN] = ACTIONS(3663),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4333),
    [sym_word] = ACTIONS(3665),
  },
  [2245] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5009),
    [sym_comment] = ACTIONS(52),
  },
  [2246] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5011),
    [sym_comment] = ACTIONS(52),
  },
  [2247] = {
    [anon_sym_RBRACE] = ACTIONS(5011),
    [sym_comment] = ACTIONS(52),
  },
  [2248] = {
    [sym__concat] = ACTIONS(3712),
    [sym_variable_name] = ACTIONS(3712),
    [anon_sym_PIPE] = ACTIONS(4339),
    [anon_sym_PIPE_AMP] = ACTIONS(3712),
    [anon_sym_AMP_AMP] = ACTIONS(3712),
    [anon_sym_PIPE_PIPE] = ACTIONS(3712),
    [sym__special_characters] = ACTIONS(4339),
    [anon_sym_DQUOTE] = ACTIONS(3712),
    [sym_raw_string] = ACTIONS(3712),
    [anon_sym_DOLLAR] = ACTIONS(4339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3712),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3712),
    [anon_sym_BQUOTE] = ACTIONS(3712),
    [anon_sym_LT_LPAREN] = ACTIONS(3712),
    [anon_sym_GT_LPAREN] = ACTIONS(3712),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4339),
    [sym_word] = ACTIONS(3714),
  },
  [2249] = {
    [sym__concat] = ACTIONS(3716),
    [sym_variable_name] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(4341),
    [anon_sym_PIPE_AMP] = ACTIONS(3716),
    [anon_sym_AMP_AMP] = ACTIONS(3716),
    [anon_sym_PIPE_PIPE] = ACTIONS(3716),
    [sym__special_characters] = ACTIONS(4341),
    [anon_sym_DQUOTE] = ACTIONS(3716),
    [sym_raw_string] = ACTIONS(3716),
    [anon_sym_DOLLAR] = ACTIONS(4341),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3716),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3716),
    [anon_sym_BQUOTE] = ACTIONS(3716),
    [anon_sym_LT_LPAREN] = ACTIONS(3716),
    [anon_sym_GT_LPAREN] = ACTIONS(3716),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4341),
    [sym_word] = ACTIONS(3718),
  },
  [2250] = {
    [sym_file_descriptor] = ACTIONS(4406),
    [sym__concat] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4845),
    [anon_sym_PIPE_AMP] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_LT] = ACTIONS(4845),
    [anon_sym_GT] = ACTIONS(4845),
    [anon_sym_GT_GT] = ACTIONS(4406),
    [anon_sym_AMP_GT] = ACTIONS(4845),
    [anon_sym_AMP_GT_GT] = ACTIONS(4406),
    [anon_sym_LT_AMP] = ACTIONS(4406),
    [anon_sym_GT_AMP] = ACTIONS(4406),
    [anon_sym_LT_LT] = ACTIONS(4845),
    [anon_sym_LT_LT_DASH] = ACTIONS(4406),
    [anon_sym_LT_LT_LT] = ACTIONS(4406),
    [sym__special_characters] = ACTIONS(4845),
    [anon_sym_DQUOTE] = ACTIONS(4406),
    [sym_raw_string] = ACTIONS(4406),
    [anon_sym_DOLLAR] = ACTIONS(4845),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4406),
    [anon_sym_BQUOTE] = ACTIONS(4406),
    [anon_sym_LT_LPAREN] = ACTIONS(4406),
    [anon_sym_GT_LPAREN] = ACTIONS(4406),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4845),
  },
  [2251] = {
    [sym_file_descriptor] = ACTIONS(4410),
    [sym__concat] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4847),
    [anon_sym_PIPE_AMP] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [anon_sym_LT] = ACTIONS(4847),
    [anon_sym_GT] = ACTIONS(4847),
    [anon_sym_GT_GT] = ACTIONS(4410),
    [anon_sym_AMP_GT] = ACTIONS(4847),
    [anon_sym_AMP_GT_GT] = ACTIONS(4410),
    [anon_sym_LT_AMP] = ACTIONS(4410),
    [anon_sym_GT_AMP] = ACTIONS(4410),
    [anon_sym_LT_LT] = ACTIONS(4847),
    [anon_sym_LT_LT_DASH] = ACTIONS(4410),
    [anon_sym_LT_LT_LT] = ACTIONS(4410),
    [sym__special_characters] = ACTIONS(4847),
    [anon_sym_DQUOTE] = ACTIONS(4410),
    [sym_raw_string] = ACTIONS(4410),
    [anon_sym_DOLLAR] = ACTIONS(4847),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4410),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4410),
    [anon_sym_BQUOTE] = ACTIONS(4410),
    [anon_sym_LT_LPAREN] = ACTIONS(4410),
    [anon_sym_GT_LPAREN] = ACTIONS(4410),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4847),
  },
  [2252] = {
    [sym_file_descriptor] = ACTIONS(2560),
    [sym__concat] = ACTIONS(2560),
    [anon_sym_PIPE] = ACTIONS(3553),
    [anon_sym_PIPE_AMP] = ACTIONS(2560),
    [anon_sym_AMP_AMP] = ACTIONS(2560),
    [anon_sym_PIPE_PIPE] = ACTIONS(2560),
    [anon_sym_LT] = ACTIONS(3553),
    [anon_sym_GT] = ACTIONS(3553),
    [anon_sym_GT_GT] = ACTIONS(2560),
    [anon_sym_AMP_GT] = ACTIONS(3553),
    [anon_sym_AMP_GT_GT] = ACTIONS(2560),
    [anon_sym_LT_AMP] = ACTIONS(2560),
    [anon_sym_GT_AMP] = ACTIONS(2560),
    [anon_sym_LT_LT] = ACTIONS(3553),
    [anon_sym_LT_LT_DASH] = ACTIONS(2560),
    [anon_sym_LT_LT_LT] = ACTIONS(2560),
    [anon_sym_BQUOTE] = ACTIONS(2560),
    [sym_comment] = ACTIONS(52),
  },
  [2253] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5013),
    [sym_comment] = ACTIONS(52),
  },
  [2254] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5015),
    [sym_comment] = ACTIONS(52),
  },
  [2255] = {
    [anon_sym_RBRACE] = ACTIONS(5015),
    [sym_comment] = ACTIONS(52),
  },
  [2256] = {
    [sym_file_descriptor] = ACTIONS(2614),
    [sym__concat] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(3559),
    [anon_sym_PIPE_AMP] = ACTIONS(2614),
    [anon_sym_AMP_AMP] = ACTIONS(2614),
    [anon_sym_PIPE_PIPE] = ACTIONS(2614),
    [anon_sym_LT] = ACTIONS(3559),
    [anon_sym_GT] = ACTIONS(3559),
    [anon_sym_GT_GT] = ACTIONS(2614),
    [anon_sym_AMP_GT] = ACTIONS(3559),
    [anon_sym_AMP_GT_GT] = ACTIONS(2614),
    [anon_sym_LT_AMP] = ACTIONS(2614),
    [anon_sym_GT_AMP] = ACTIONS(2614),
    [anon_sym_LT_LT] = ACTIONS(3559),
    [anon_sym_LT_LT_DASH] = ACTIONS(2614),
    [anon_sym_LT_LT_LT] = ACTIONS(2614),
    [anon_sym_BQUOTE] = ACTIONS(2614),
    [sym_comment] = ACTIONS(52),
  },
  [2257] = {
    [sym_concatenation] = STATE(2448),
    [sym_string] = STATE(2447),
    [sym_simple_expansion] = STATE(2447),
    [sym_expansion] = STATE(2447),
    [sym_command_substitution] = STATE(2447),
    [sym_process_substitution] = STATE(2447),
    [anon_sym_RBRACE] = ACTIONS(5015),
    [sym__special_characters] = ACTIONS(5017),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(5019),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(5021),
  },
  [2258] = {
    [sym_file_descriptor] = ACTIONS(2659),
    [sym__concat] = ACTIONS(2659),
    [anon_sym_PIPE] = ACTIONS(3567),
    [anon_sym_PIPE_AMP] = ACTIONS(2659),
    [anon_sym_AMP_AMP] = ACTIONS(2659),
    [anon_sym_PIPE_PIPE] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(3567),
    [anon_sym_GT] = ACTIONS(3567),
    [anon_sym_GT_GT] = ACTIONS(2659),
    [anon_sym_AMP_GT] = ACTIONS(3567),
    [anon_sym_AMP_GT_GT] = ACTIONS(2659),
    [anon_sym_LT_AMP] = ACTIONS(2659),
    [anon_sym_GT_AMP] = ACTIONS(2659),
    [anon_sym_LT_LT] = ACTIONS(3567),
    [anon_sym_LT_LT_DASH] = ACTIONS(2659),
    [anon_sym_LT_LT_LT] = ACTIONS(2659),
    [anon_sym_BQUOTE] = ACTIONS(2659),
    [sym_comment] = ACTIONS(52),
  },
  [2259] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(5023),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2260] = {
    [sym_file_descriptor] = ACTIONS(2665),
    [sym__concat] = ACTIONS(2665),
    [anon_sym_PIPE] = ACTIONS(3571),
    [anon_sym_PIPE_AMP] = ACTIONS(2665),
    [anon_sym_AMP_AMP] = ACTIONS(2665),
    [anon_sym_PIPE_PIPE] = ACTIONS(2665),
    [anon_sym_LT] = ACTIONS(3571),
    [anon_sym_GT] = ACTIONS(3571),
    [anon_sym_GT_GT] = ACTIONS(2665),
    [anon_sym_AMP_GT] = ACTIONS(3571),
    [anon_sym_AMP_GT_GT] = ACTIONS(2665),
    [anon_sym_LT_AMP] = ACTIONS(2665),
    [anon_sym_GT_AMP] = ACTIONS(2665),
    [anon_sym_LT_LT] = ACTIONS(3571),
    [anon_sym_LT_LT_DASH] = ACTIONS(2665),
    [anon_sym_LT_LT_LT] = ACTIONS(2665),
    [anon_sym_BQUOTE] = ACTIONS(2665),
    [sym_comment] = ACTIONS(52),
  },
  [2261] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(5025),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2262] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(5015),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2263] = {
    [sym_file_descriptor] = ACTIONS(2671),
    [sym__concat] = ACTIONS(2671),
    [anon_sym_PIPE] = ACTIONS(3575),
    [anon_sym_PIPE_AMP] = ACTIONS(2671),
    [anon_sym_AMP_AMP] = ACTIONS(2671),
    [anon_sym_PIPE_PIPE] = ACTIONS(2671),
    [anon_sym_LT] = ACTIONS(3575),
    [anon_sym_GT] = ACTIONS(3575),
    [anon_sym_GT_GT] = ACTIONS(2671),
    [anon_sym_AMP_GT] = ACTIONS(3575),
    [anon_sym_AMP_GT_GT] = ACTIONS(2671),
    [anon_sym_LT_AMP] = ACTIONS(2671),
    [anon_sym_GT_AMP] = ACTIONS(2671),
    [anon_sym_LT_LT] = ACTIONS(3575),
    [anon_sym_LT_LT_DASH] = ACTIONS(2671),
    [anon_sym_LT_LT_LT] = ACTIONS(2671),
    [anon_sym_BQUOTE] = ACTIONS(2671),
    [sym_comment] = ACTIONS(52),
  },
  [2264] = {
    [sym_file_descriptor] = ACTIONS(3657),
    [sym__concat] = ACTIONS(3657),
    [anon_sym_PIPE] = ACTIONS(3659),
    [anon_sym_SEMI_SEMI] = ACTIONS(3659),
    [anon_sym_PIPE_AMP] = ACTIONS(3659),
    [anon_sym_AMP_AMP] = ACTIONS(3659),
    [anon_sym_PIPE_PIPE] = ACTIONS(3659),
    [anon_sym_LT] = ACTIONS(3659),
    [anon_sym_GT] = ACTIONS(3659),
    [anon_sym_GT_GT] = ACTIONS(3659),
    [anon_sym_AMP_GT] = ACTIONS(3659),
    [anon_sym_AMP_GT_GT] = ACTIONS(3659),
    [anon_sym_LT_AMP] = ACTIONS(3659),
    [anon_sym_GT_AMP] = ACTIONS(3659),
    [anon_sym_LT_LT] = ACTIONS(3659),
    [anon_sym_LT_LT_DASH] = ACTIONS(3659),
    [anon_sym_LT_LT_LT] = ACTIONS(3659),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3659),
    [anon_sym_LF] = ACTIONS(3659),
    [anon_sym_AMP] = ACTIONS(3659),
  },
  [2265] = {
    [sym_file_descriptor] = ACTIONS(3663),
    [sym__concat] = ACTIONS(3663),
    [anon_sym_PIPE] = ACTIONS(3665),
    [anon_sym_SEMI_SEMI] = ACTIONS(3665),
    [anon_sym_PIPE_AMP] = ACTIONS(3665),
    [anon_sym_AMP_AMP] = ACTIONS(3665),
    [anon_sym_PIPE_PIPE] = ACTIONS(3665),
    [anon_sym_LT] = ACTIONS(3665),
    [anon_sym_GT] = ACTIONS(3665),
    [anon_sym_GT_GT] = ACTIONS(3665),
    [anon_sym_AMP_GT] = ACTIONS(3665),
    [anon_sym_AMP_GT_GT] = ACTIONS(3665),
    [anon_sym_LT_AMP] = ACTIONS(3665),
    [anon_sym_GT_AMP] = ACTIONS(3665),
    [anon_sym_LT_LT] = ACTIONS(3665),
    [anon_sym_LT_LT_DASH] = ACTIONS(3665),
    [anon_sym_LT_LT_LT] = ACTIONS(3665),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3665),
    [anon_sym_LF] = ACTIONS(3665),
    [anon_sym_AMP] = ACTIONS(3665),
  },
  [2266] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5027),
    [sym_comment] = ACTIONS(52),
  },
  [2267] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5029),
    [sym_comment] = ACTIONS(52),
  },
  [2268] = {
    [anon_sym_RBRACE] = ACTIONS(5029),
    [sym_comment] = ACTIONS(52),
  },
  [2269] = {
    [sym_file_descriptor] = ACTIONS(3712),
    [sym__concat] = ACTIONS(3712),
    [anon_sym_PIPE] = ACTIONS(3714),
    [anon_sym_SEMI_SEMI] = ACTIONS(3714),
    [anon_sym_PIPE_AMP] = ACTIONS(3714),
    [anon_sym_AMP_AMP] = ACTIONS(3714),
    [anon_sym_PIPE_PIPE] = ACTIONS(3714),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_GT] = ACTIONS(3714),
    [anon_sym_GT_GT] = ACTIONS(3714),
    [anon_sym_AMP_GT] = ACTIONS(3714),
    [anon_sym_AMP_GT_GT] = ACTIONS(3714),
    [anon_sym_LT_AMP] = ACTIONS(3714),
    [anon_sym_GT_AMP] = ACTIONS(3714),
    [anon_sym_LT_LT] = ACTIONS(3714),
    [anon_sym_LT_LT_DASH] = ACTIONS(3714),
    [anon_sym_LT_LT_LT] = ACTIONS(3714),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3714),
    [anon_sym_LF] = ACTIONS(3714),
    [anon_sym_AMP] = ACTIONS(3714),
  },
  [2270] = {
    [sym_file_descriptor] = ACTIONS(3716),
    [sym__concat] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3718),
    [anon_sym_SEMI_SEMI] = ACTIONS(3718),
    [anon_sym_PIPE_AMP] = ACTIONS(3718),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_LT] = ACTIONS(3718),
    [anon_sym_GT] = ACTIONS(3718),
    [anon_sym_GT_GT] = ACTIONS(3718),
    [anon_sym_AMP_GT] = ACTIONS(3718),
    [anon_sym_AMP_GT_GT] = ACTIONS(3718),
    [anon_sym_LT_AMP] = ACTIONS(3718),
    [anon_sym_GT_AMP] = ACTIONS(3718),
    [anon_sym_LT_LT] = ACTIONS(3718),
    [anon_sym_LT_LT_DASH] = ACTIONS(3718),
    [anon_sym_LT_LT_LT] = ACTIONS(3718),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3718),
    [anon_sym_LF] = ACTIONS(3718),
    [anon_sym_AMP] = ACTIONS(3718),
  },
  [2271] = {
    [sym__heredoc_middle] = ACTIONS(1553),
    [sym__heredoc_end] = ACTIONS(1553),
    [anon_sym_DOLLAR] = ACTIONS(2435),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1553),
    [sym_comment] = ACTIONS(52),
  },
  [2272] = {
    [sym__heredoc_middle] = ACTIONS(2560),
    [sym__heredoc_end] = ACTIONS(2560),
    [anon_sym_DOLLAR] = ACTIONS(3553),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2560),
    [sym_comment] = ACTIONS(52),
  },
  [2273] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5031),
    [sym_comment] = ACTIONS(52),
  },
  [2274] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5033),
    [sym_comment] = ACTIONS(52),
  },
  [2275] = {
    [anon_sym_RBRACE] = ACTIONS(5033),
    [sym_comment] = ACTIONS(52),
  },
  [2276] = {
    [sym__heredoc_middle] = ACTIONS(2614),
    [sym__heredoc_end] = ACTIONS(2614),
    [anon_sym_DOLLAR] = ACTIONS(3559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2614),
    [sym_comment] = ACTIONS(52),
  },
  [2277] = {
    [sym_concatenation] = STATE(2457),
    [sym_string] = STATE(2456),
    [sym_simple_expansion] = STATE(2456),
    [sym_expansion] = STATE(2456),
    [sym_command_substitution] = STATE(2456),
    [sym_process_substitution] = STATE(2456),
    [anon_sym_RBRACE] = ACTIONS(5033),
    [sym__special_characters] = ACTIONS(5035),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(5037),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(5039),
  },
  [2278] = {
    [sym__heredoc_middle] = ACTIONS(2659),
    [sym__heredoc_end] = ACTIONS(2659),
    [anon_sym_DOLLAR] = ACTIONS(3567),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2659),
    [sym_comment] = ACTIONS(52),
  },
  [2279] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(5041),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2280] = {
    [sym__heredoc_middle] = ACTIONS(2665),
    [sym__heredoc_end] = ACTIONS(2665),
    [anon_sym_DOLLAR] = ACTIONS(3571),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2665),
    [sym_comment] = ACTIONS(52),
  },
  [2281] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(5043),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2282] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(5033),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2283] = {
    [sym__heredoc_middle] = ACTIONS(2671),
    [sym__heredoc_end] = ACTIONS(2671),
    [anon_sym_DOLLAR] = ACTIONS(3575),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2671),
    [sym_comment] = ACTIONS(52),
  },
  [2284] = {
    [sym__concat] = ACTIONS(4406),
    [anon_sym_RBRACK] = ACTIONS(4406),
    [sym_comment] = ACTIONS(52),
  },
  [2285] = {
    [sym__concat] = ACTIONS(4410),
    [anon_sym_RBRACK] = ACTIONS(4410),
    [sym_comment] = ACTIONS(52),
  },
  [2286] = {
    [sym__concat] = ACTIONS(3657),
    [anon_sym_RPAREN] = ACTIONS(3657),
    [sym__special_characters] = ACTIONS(4331),
    [anon_sym_DQUOTE] = ACTIONS(3657),
    [sym_raw_string] = ACTIONS(3657),
    [anon_sym_DOLLAR] = ACTIONS(4331),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3657),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3657),
    [anon_sym_BQUOTE] = ACTIONS(3657),
    [anon_sym_LT_LPAREN] = ACTIONS(3657),
    [anon_sym_GT_LPAREN] = ACTIONS(3657),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4331),
  },
  [2287] = {
    [sym__concat] = ACTIONS(3663),
    [anon_sym_RPAREN] = ACTIONS(3663),
    [sym__special_characters] = ACTIONS(4333),
    [anon_sym_DQUOTE] = ACTIONS(3663),
    [sym_raw_string] = ACTIONS(3663),
    [anon_sym_DOLLAR] = ACTIONS(4333),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3663),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3663),
    [anon_sym_BQUOTE] = ACTIONS(3663),
    [anon_sym_LT_LPAREN] = ACTIONS(3663),
    [anon_sym_GT_LPAREN] = ACTIONS(3663),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4333),
  },
  [2288] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5045),
    [sym_comment] = ACTIONS(52),
  },
  [2289] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5047),
    [sym_comment] = ACTIONS(52),
  },
  [2290] = {
    [anon_sym_RBRACE] = ACTIONS(5047),
    [sym_comment] = ACTIONS(52),
  },
  [2291] = {
    [sym__concat] = ACTIONS(3712),
    [anon_sym_RPAREN] = ACTIONS(3712),
    [sym__special_characters] = ACTIONS(4339),
    [anon_sym_DQUOTE] = ACTIONS(3712),
    [sym_raw_string] = ACTIONS(3712),
    [anon_sym_DOLLAR] = ACTIONS(4339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3712),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3712),
    [anon_sym_BQUOTE] = ACTIONS(3712),
    [anon_sym_LT_LPAREN] = ACTIONS(3712),
    [anon_sym_GT_LPAREN] = ACTIONS(3712),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4339),
  },
  [2292] = {
    [sym__concat] = ACTIONS(3716),
    [anon_sym_RPAREN] = ACTIONS(3716),
    [sym__special_characters] = ACTIONS(4341),
    [anon_sym_DQUOTE] = ACTIONS(3716),
    [sym_raw_string] = ACTIONS(3716),
    [anon_sym_DOLLAR] = ACTIONS(4341),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3716),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3716),
    [anon_sym_BQUOTE] = ACTIONS(3716),
    [anon_sym_LT_LPAREN] = ACTIONS(3716),
    [anon_sym_GT_LPAREN] = ACTIONS(3716),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4341),
  },
  [2293] = {
    [sym_file_descriptor] = ACTIONS(4406),
    [sym__concat] = ACTIONS(4406),
    [sym_variable_name] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_SEMI_SEMI] = ACTIONS(4408),
    [anon_sym_PIPE_AMP] = ACTIONS(4408),
    [anon_sym_AMP_AMP] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4408),
    [anon_sym_LT] = ACTIONS(4408),
    [anon_sym_GT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_AMP_GT] = ACTIONS(4408),
    [anon_sym_AMP_GT_GT] = ACTIONS(4408),
    [anon_sym_LT_AMP] = ACTIONS(4408),
    [anon_sym_GT_AMP] = ACTIONS(4408),
    [sym__special_characters] = ACTIONS(4408),
    [anon_sym_DQUOTE] = ACTIONS(4408),
    [sym_raw_string] = ACTIONS(4408),
    [anon_sym_DOLLAR] = ACTIONS(4408),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4408),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4408),
    [anon_sym_BQUOTE] = ACTIONS(4408),
    [anon_sym_LT_LPAREN] = ACTIONS(4408),
    [anon_sym_GT_LPAREN] = ACTIONS(4408),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(4408),
    [anon_sym_SEMI] = ACTIONS(4408),
    [anon_sym_LF] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4408),
  },
  [2294] = {
    [sym_file_descriptor] = ACTIONS(4410),
    [sym__concat] = ACTIONS(4410),
    [sym_variable_name] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4412),
    [anon_sym_SEMI_SEMI] = ACTIONS(4412),
    [anon_sym_PIPE_AMP] = ACTIONS(4412),
    [anon_sym_AMP_AMP] = ACTIONS(4412),
    [anon_sym_PIPE_PIPE] = ACTIONS(4412),
    [anon_sym_LT] = ACTIONS(4412),
    [anon_sym_GT] = ACTIONS(4412),
    [anon_sym_GT_GT] = ACTIONS(4412),
    [anon_sym_AMP_GT] = ACTIONS(4412),
    [anon_sym_AMP_GT_GT] = ACTIONS(4412),
    [anon_sym_LT_AMP] = ACTIONS(4412),
    [anon_sym_GT_AMP] = ACTIONS(4412),
    [sym__special_characters] = ACTIONS(4412),
    [anon_sym_DQUOTE] = ACTIONS(4412),
    [sym_raw_string] = ACTIONS(4412),
    [anon_sym_DOLLAR] = ACTIONS(4412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4412),
    [anon_sym_BQUOTE] = ACTIONS(4412),
    [anon_sym_LT_LPAREN] = ACTIONS(4412),
    [anon_sym_GT_LPAREN] = ACTIONS(4412),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(4412),
    [anon_sym_SEMI] = ACTIONS(4412),
    [anon_sym_LF] = ACTIONS(4412),
    [anon_sym_AMP] = ACTIONS(4412),
  },
  [2295] = {
    [sym__concat] = ACTIONS(3657),
    [anon_sym_SEMI_SEMI] = ACTIONS(3659),
    [sym__special_characters] = ACTIONS(3659),
    [anon_sym_DQUOTE] = ACTIONS(3659),
    [sym_raw_string] = ACTIONS(3659),
    [anon_sym_DOLLAR] = ACTIONS(3659),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3659),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3659),
    [anon_sym_BQUOTE] = ACTIONS(3659),
    [anon_sym_LT_LPAREN] = ACTIONS(3659),
    [anon_sym_GT_LPAREN] = ACTIONS(3659),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(3659),
    [anon_sym_SEMI] = ACTIONS(3659),
    [anon_sym_LF] = ACTIONS(3659),
    [anon_sym_AMP] = ACTIONS(3659),
  },
  [2296] = {
    [sym__concat] = ACTIONS(3663),
    [anon_sym_SEMI_SEMI] = ACTIONS(3665),
    [sym__special_characters] = ACTIONS(3665),
    [anon_sym_DQUOTE] = ACTIONS(3665),
    [sym_raw_string] = ACTIONS(3665),
    [anon_sym_DOLLAR] = ACTIONS(3665),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3665),
    [anon_sym_BQUOTE] = ACTIONS(3665),
    [anon_sym_LT_LPAREN] = ACTIONS(3665),
    [anon_sym_GT_LPAREN] = ACTIONS(3665),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(3665),
    [anon_sym_SEMI] = ACTIONS(3665),
    [anon_sym_LF] = ACTIONS(3665),
    [anon_sym_AMP] = ACTIONS(3665),
  },
  [2297] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5049),
    [sym_comment] = ACTIONS(52),
  },
  [2298] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5051),
    [sym_comment] = ACTIONS(52),
  },
  [2299] = {
    [anon_sym_RBRACE] = ACTIONS(5051),
    [sym_comment] = ACTIONS(52),
  },
  [2300] = {
    [sym__concat] = ACTIONS(3712),
    [anon_sym_SEMI_SEMI] = ACTIONS(3714),
    [sym__special_characters] = ACTIONS(3714),
    [anon_sym_DQUOTE] = ACTIONS(3714),
    [sym_raw_string] = ACTIONS(3714),
    [anon_sym_DOLLAR] = ACTIONS(3714),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3714),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3714),
    [anon_sym_BQUOTE] = ACTIONS(3714),
    [anon_sym_LT_LPAREN] = ACTIONS(3714),
    [anon_sym_GT_LPAREN] = ACTIONS(3714),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(3714),
    [anon_sym_SEMI] = ACTIONS(3714),
    [anon_sym_LF] = ACTIONS(3714),
    [anon_sym_AMP] = ACTIONS(3714),
  },
  [2301] = {
    [sym__concat] = ACTIONS(3716),
    [anon_sym_SEMI_SEMI] = ACTIONS(3718),
    [sym__special_characters] = ACTIONS(3718),
    [anon_sym_DQUOTE] = ACTIONS(3718),
    [sym_raw_string] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3718),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3718),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3718),
    [anon_sym_BQUOTE] = ACTIONS(3718),
    [anon_sym_LT_LPAREN] = ACTIONS(3718),
    [anon_sym_GT_LPAREN] = ACTIONS(3718),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(3718),
    [anon_sym_SEMI] = ACTIONS(3718),
    [anon_sym_LF] = ACTIONS(3718),
    [anon_sym_AMP] = ACTIONS(3718),
  },
  [2302] = {
    [anon_sym_PIPE] = ACTIONS(3333),
    [anon_sym_RPAREN] = ACTIONS(3333),
    [anon_sym_SEMI_SEMI] = ACTIONS(3333),
    [anon_sym_PIPE_AMP] = ACTIONS(3333),
    [anon_sym_AMP_AMP] = ACTIONS(3333),
    [anon_sym_PIPE_PIPE] = ACTIONS(3333),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3333),
    [anon_sym_LF] = ACTIONS(3333),
    [anon_sym_AMP] = ACTIONS(3333),
  },
  [2303] = {
    [sym_file_descriptor] = ACTIONS(902),
    [sym_variable_name] = ACTIONS(902),
    [anon_sym_for] = ACTIONS(904),
    [anon_sym_while] = ACTIONS(904),
    [anon_sym_if] = ACTIONS(904),
    [anon_sym_case] = ACTIONS(904),
    [anon_sym_esac] = ACTIONS(904),
    [anon_sym_SEMI_SEMI] = ACTIONS(902),
    [anon_sym_function] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(902),
    [anon_sym_LBRACK] = ACTIONS(904),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym_declare] = ACTIONS(904),
    [anon_sym_typeset] = ACTIONS(904),
    [anon_sym_export] = ACTIONS(904),
    [anon_sym_readonly] = ACTIONS(904),
    [anon_sym_local] = ACTIONS(904),
    [anon_sym_LT] = ACTIONS(904),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_GT_GT] = ACTIONS(902),
    [anon_sym_AMP_GT] = ACTIONS(904),
    [anon_sym_AMP_GT_GT] = ACTIONS(902),
    [anon_sym_LT_AMP] = ACTIONS(902),
    [anon_sym_GT_AMP] = ACTIONS(902),
    [sym__special_characters] = ACTIONS(906),
    [anon_sym_DQUOTE] = ACTIONS(902),
    [sym_raw_string] = ACTIONS(902),
    [anon_sym_DOLLAR] = ACTIONS(904),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(902),
    [anon_sym_BQUOTE] = ACTIONS(902),
    [anon_sym_LT_LPAREN] = ACTIONS(902),
    [anon_sym_GT_LPAREN] = ACTIONS(902),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(906),
  },
  [2304] = {
    [anon_sym_esac] = ACTIONS(5053),
    [sym__special_characters] = ACTIONS(5055),
    [anon_sym_DQUOTE] = ACTIONS(5057),
    [sym_raw_string] = ACTIONS(5057),
    [anon_sym_DOLLAR] = ACTIONS(5055),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5057),
    [anon_sym_BQUOTE] = ACTIONS(5057),
    [anon_sym_LT_LPAREN] = ACTIONS(5057),
    [anon_sym_GT_LPAREN] = ACTIONS(5057),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(5059),
  },
  [2305] = {
    [sym__terminated_statement] = STATE(2010),
    [sym_for_statement] = STATE(2011),
    [sym_while_statement] = STATE(2011),
    [sym_if_statement] = STATE(2011),
    [sym_case_statement] = STATE(2011),
    [sym_function_definition] = STATE(2011),
    [sym_subshell] = STATE(2011),
    [sym_pipeline] = STATE(2011),
    [sym_list] = STATE(2011),
    [sym_bracket_command] = STATE(2011),
    [sym_command] = STATE(2011),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(2012),
    [sym_declaration_command] = STATE(2011),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(2305),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(946),
    [sym_variable_name] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(954),
    [anon_sym_while] = ACTIONS(957),
    [anon_sym_if] = ACTIONS(960),
    [anon_sym_case] = ACTIONS(963),
    [anon_sym_esac] = ACTIONS(3335),
    [anon_sym_SEMI_SEMI] = ACTIONS(952),
    [anon_sym_function] = ACTIONS(966),
    [anon_sym_LPAREN] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_typeset] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_local] = ACTIONS(978),
    [anon_sym_LT] = ACTIONS(981),
    [anon_sym_GT] = ACTIONS(981),
    [anon_sym_GT_GT] = ACTIONS(984),
    [anon_sym_AMP_GT] = ACTIONS(981),
    [anon_sym_AMP_GT_GT] = ACTIONS(984),
    [anon_sym_LT_AMP] = ACTIONS(984),
    [anon_sym_GT_AMP] = ACTIONS(984),
    [sym__special_characters] = ACTIONS(987),
    [anon_sym_DQUOTE] = ACTIONS(990),
    [sym_raw_string] = ACTIONS(993),
    [anon_sym_DOLLAR] = ACTIONS(996),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(999),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1002),
    [anon_sym_BQUOTE] = ACTIONS(1005),
    [anon_sym_LT_LPAREN] = ACTIONS(1008),
    [anon_sym_GT_LPAREN] = ACTIONS(1008),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1011),
  },
  [2306] = {
    [sym__terminated_statement] = STATE(2010),
    [sym_for_statement] = STATE(2011),
    [sym_while_statement] = STATE(2011),
    [sym_if_statement] = STATE(2011),
    [sym_case_statement] = STATE(2011),
    [sym_function_definition] = STATE(2011),
    [sym_subshell] = STATE(2011),
    [sym_pipeline] = STATE(2011),
    [sym_list] = STATE(2011),
    [sym_bracket_command] = STATE(2011),
    [sym_command] = STATE(2011),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(2012),
    [sym_declaration_command] = STATE(2011),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(2305),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_esac] = ACTIONS(5053),
    [anon_sym_SEMI_SEMI] = ACTIONS(5061),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [2307] = {
    [anon_sym_esac] = ACTIONS(5063),
    [sym__special_characters] = ACTIONS(5065),
    [anon_sym_DQUOTE] = ACTIONS(5067),
    [sym_raw_string] = ACTIONS(5067),
    [anon_sym_DOLLAR] = ACTIONS(5065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5067),
    [anon_sym_BQUOTE] = ACTIONS(5067),
    [anon_sym_LT_LPAREN] = ACTIONS(5067),
    [anon_sym_GT_LPAREN] = ACTIONS(5067),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(5069),
  },
  [2308] = {
    [sym__terminated_statement] = STATE(2010),
    [sym_for_statement] = STATE(2011),
    [sym_while_statement] = STATE(2011),
    [sym_if_statement] = STATE(2011),
    [sym_case_statement] = STATE(2011),
    [sym_function_definition] = STATE(2011),
    [sym_subshell] = STATE(2011),
    [sym_pipeline] = STATE(2011),
    [sym_list] = STATE(2011),
    [sym_bracket_command] = STATE(2011),
    [sym_command] = STATE(2011),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(2012),
    [sym_declaration_command] = STATE(2011),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(2305),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_esac] = ACTIONS(5063),
    [anon_sym_SEMI_SEMI] = ACTIONS(5071),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [2309] = {
    [sym__concat] = ACTIONS(2560),
    [anon_sym_PIPE] = ACTIONS(2560),
    [anon_sym_RPAREN] = ACTIONS(2560),
    [sym_comment] = ACTIONS(52),
  },
  [2310] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5073),
    [sym_comment] = ACTIONS(52),
  },
  [2311] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5075),
    [sym_comment] = ACTIONS(52),
  },
  [2312] = {
    [anon_sym_RBRACE] = ACTIONS(5075),
    [sym_comment] = ACTIONS(52),
  },
  [2313] = {
    [sym__concat] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2614),
    [anon_sym_RPAREN] = ACTIONS(2614),
    [sym_comment] = ACTIONS(52),
  },
  [2314] = {
    [sym_concatenation] = STATE(2470),
    [sym_string] = STATE(2469),
    [sym_simple_expansion] = STATE(2469),
    [sym_expansion] = STATE(2469),
    [sym_command_substitution] = STATE(2469),
    [sym_process_substitution] = STATE(2469),
    [anon_sym_RBRACE] = ACTIONS(5075),
    [sym__special_characters] = ACTIONS(5077),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(5079),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(5081),
  },
  [2315] = {
    [sym__concat] = ACTIONS(2659),
    [anon_sym_PIPE] = ACTIONS(2659),
    [anon_sym_RPAREN] = ACTIONS(2659),
    [sym_comment] = ACTIONS(52),
  },
  [2316] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(5083),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2317] = {
    [sym__concat] = ACTIONS(2665),
    [anon_sym_PIPE] = ACTIONS(2665),
    [anon_sym_RPAREN] = ACTIONS(2665),
    [sym_comment] = ACTIONS(52),
  },
  [2318] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(5085),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2319] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(5075),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2320] = {
    [sym__concat] = ACTIONS(2671),
    [anon_sym_PIPE] = ACTIONS(2671),
    [anon_sym_RPAREN] = ACTIONS(2671),
    [sym_comment] = ACTIONS(52),
  },
  [2321] = {
    [sym__terminated_statement] = STATE(24),
    [sym_for_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_case_statement] = STATE(25),
    [sym_function_definition] = STATE(25),
    [sym_subshell] = STATE(25),
    [sym_pipeline] = STATE(25),
    [sym_list] = STATE(25),
    [sym_bracket_command] = STATE(25),
    [sym_command] = STATE(25),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(27),
    [sym_declaration_command] = STATE(25),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(2474),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_SEMI_SEMI] = ACTIONS(5087),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [2322] = {
    [aux_sym_case_item_repeat1] = STATE(2015),
    [anon_sym_PIPE] = ACTIONS(3356),
    [anon_sym_RPAREN] = ACTIONS(5089),
    [sym_comment] = ACTIONS(52),
  },
  [2323] = {
    [sym__terminated_statement] = STATE(24),
    [sym_for_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_case_statement] = STATE(25),
    [sym_function_definition] = STATE(25),
    [sym_subshell] = STATE(25),
    [sym_pipeline] = STATE(25),
    [sym_list] = STATE(25),
    [sym_bracket_command] = STATE(25),
    [sym_command] = STATE(25),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(27),
    [sym_declaration_command] = STATE(25),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(2477),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_SEMI_SEMI] = ACTIONS(5091),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [2324] = {
    [aux_sym_case_item_repeat1] = STATE(2015),
    [anon_sym_PIPE] = ACTIONS(3356),
    [anon_sym_RPAREN] = ACTIONS(5093),
    [sym_comment] = ACTIONS(52),
  },
  [2325] = {
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_RPAREN] = ACTIONS(5095),
    [anon_sym_SEMI_SEMI] = ACTIONS(5095),
    [anon_sym_PIPE_AMP] = ACTIONS(5095),
    [anon_sym_AMP_AMP] = ACTIONS(5095),
    [anon_sym_PIPE_PIPE] = ACTIONS(5095),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(5095),
    [anon_sym_LF] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
  },
  [2326] = {
    [anon_sym_PIPE] = ACTIONS(5097),
    [anon_sym_RPAREN] = ACTIONS(5097),
    [anon_sym_SEMI_SEMI] = ACTIONS(5097),
    [anon_sym_PIPE_AMP] = ACTIONS(5097),
    [anon_sym_AMP_AMP] = ACTIONS(5097),
    [anon_sym_PIPE_PIPE] = ACTIONS(5097),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(5097),
    [anon_sym_LF] = ACTIONS(5097),
    [anon_sym_AMP] = ACTIONS(5097),
  },
  [2327] = {
    [sym__concat] = ACTIONS(2560),
    [anon_sym_PIPE] = ACTIONS(2562),
    [anon_sym_SEMI_SEMI] = ACTIONS(2562),
    [anon_sym_PIPE_AMP] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_PIPE_PIPE] = ACTIONS(2562),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym_LF] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(2562),
  },
  [2328] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5099),
    [sym_comment] = ACTIONS(52),
  },
  [2329] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5101),
    [sym_comment] = ACTIONS(52),
  },
  [2330] = {
    [anon_sym_RBRACE] = ACTIONS(5101),
    [sym_comment] = ACTIONS(52),
  },
  [2331] = {
    [sym__concat] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2616),
    [anon_sym_SEMI_SEMI] = ACTIONS(2616),
    [anon_sym_PIPE_AMP] = ACTIONS(2616),
    [anon_sym_AMP_AMP] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2616),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2616),
    [anon_sym_LF] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2616),
  },
  [2332] = {
    [sym_concatenation] = STATE(2483),
    [sym_string] = STATE(2482),
    [sym_simple_expansion] = STATE(2482),
    [sym_expansion] = STATE(2482),
    [sym_command_substitution] = STATE(2482),
    [sym_process_substitution] = STATE(2482),
    [anon_sym_RBRACE] = ACTIONS(5101),
    [sym__special_characters] = ACTIONS(5103),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(5105),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(5107),
  },
  [2333] = {
    [sym__concat] = ACTIONS(2659),
    [anon_sym_PIPE] = ACTIONS(2661),
    [anon_sym_SEMI_SEMI] = ACTIONS(2661),
    [anon_sym_PIPE_AMP] = ACTIONS(2661),
    [anon_sym_AMP_AMP] = ACTIONS(2661),
    [anon_sym_PIPE_PIPE] = ACTIONS(2661),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2661),
    [anon_sym_LF] = ACTIONS(2661),
    [anon_sym_AMP] = ACTIONS(2661),
  },
  [2334] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(5109),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2335] = {
    [sym__concat] = ACTIONS(2665),
    [anon_sym_PIPE] = ACTIONS(2667),
    [anon_sym_SEMI_SEMI] = ACTIONS(2667),
    [anon_sym_PIPE_AMP] = ACTIONS(2667),
    [anon_sym_AMP_AMP] = ACTIONS(2667),
    [anon_sym_PIPE_PIPE] = ACTIONS(2667),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym_LF] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(2667),
  },
  [2336] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(5111),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2337] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(5101),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2338] = {
    [sym__concat] = ACTIONS(2671),
    [anon_sym_PIPE] = ACTIONS(2673),
    [anon_sym_SEMI_SEMI] = ACTIONS(2673),
    [anon_sym_PIPE_AMP] = ACTIONS(2673),
    [anon_sym_AMP_AMP] = ACTIONS(2673),
    [anon_sym_PIPE_PIPE] = ACTIONS(2673),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2673),
    [anon_sym_LF] = ACTIONS(2673),
    [anon_sym_AMP] = ACTIONS(2673),
  },
  [2339] = {
    [sym_file_descriptor] = ACTIONS(3657),
    [sym__concat] = ACTIONS(3657),
    [sym_variable_name] = ACTIONS(3657),
    [anon_sym_PIPE] = ACTIONS(3659),
    [anon_sym_RPAREN] = ACTIONS(3659),
    [anon_sym_SEMI_SEMI] = ACTIONS(3659),
    [anon_sym_PIPE_AMP] = ACTIONS(3659),
    [anon_sym_AMP_AMP] = ACTIONS(3659),
    [anon_sym_PIPE_PIPE] = ACTIONS(3659),
    [anon_sym_LT] = ACTIONS(3659),
    [anon_sym_GT] = ACTIONS(3659),
    [anon_sym_GT_GT] = ACTIONS(3659),
    [anon_sym_AMP_GT] = ACTIONS(3659),
    [anon_sym_AMP_GT_GT] = ACTIONS(3659),
    [anon_sym_LT_AMP] = ACTIONS(3659),
    [anon_sym_GT_AMP] = ACTIONS(3659),
    [sym__special_characters] = ACTIONS(3659),
    [anon_sym_DQUOTE] = ACTIONS(3659),
    [sym_raw_string] = ACTIONS(3659),
    [anon_sym_DOLLAR] = ACTIONS(3659),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3659),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3659),
    [anon_sym_BQUOTE] = ACTIONS(3659),
    [anon_sym_LT_LPAREN] = ACTIONS(3659),
    [anon_sym_GT_LPAREN] = ACTIONS(3659),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(3659),
    [anon_sym_SEMI] = ACTIONS(3659),
    [anon_sym_LF] = ACTIONS(3659),
    [anon_sym_AMP] = ACTIONS(3659),
  },
  [2340] = {
    [sym_file_descriptor] = ACTIONS(3663),
    [sym__concat] = ACTIONS(3663),
    [sym_variable_name] = ACTIONS(3663),
    [anon_sym_PIPE] = ACTIONS(3665),
    [anon_sym_RPAREN] = ACTIONS(3665),
    [anon_sym_SEMI_SEMI] = ACTIONS(3665),
    [anon_sym_PIPE_AMP] = ACTIONS(3665),
    [anon_sym_AMP_AMP] = ACTIONS(3665),
    [anon_sym_PIPE_PIPE] = ACTIONS(3665),
    [anon_sym_LT] = ACTIONS(3665),
    [anon_sym_GT] = ACTIONS(3665),
    [anon_sym_GT_GT] = ACTIONS(3665),
    [anon_sym_AMP_GT] = ACTIONS(3665),
    [anon_sym_AMP_GT_GT] = ACTIONS(3665),
    [anon_sym_LT_AMP] = ACTIONS(3665),
    [anon_sym_GT_AMP] = ACTIONS(3665),
    [sym__special_characters] = ACTIONS(3665),
    [anon_sym_DQUOTE] = ACTIONS(3665),
    [sym_raw_string] = ACTIONS(3665),
    [anon_sym_DOLLAR] = ACTIONS(3665),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3665),
    [anon_sym_BQUOTE] = ACTIONS(3665),
    [anon_sym_LT_LPAREN] = ACTIONS(3665),
    [anon_sym_GT_LPAREN] = ACTIONS(3665),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(3665),
    [anon_sym_SEMI] = ACTIONS(3665),
    [anon_sym_LF] = ACTIONS(3665),
    [anon_sym_AMP] = ACTIONS(3665),
  },
  [2341] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5113),
    [sym_comment] = ACTIONS(52),
  },
  [2342] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5115),
    [sym_comment] = ACTIONS(52),
  },
  [2343] = {
    [anon_sym_RBRACE] = ACTIONS(5115),
    [sym_comment] = ACTIONS(52),
  },
  [2344] = {
    [sym_file_descriptor] = ACTIONS(3712),
    [sym__concat] = ACTIONS(3712),
    [sym_variable_name] = ACTIONS(3712),
    [anon_sym_PIPE] = ACTIONS(3714),
    [anon_sym_RPAREN] = ACTIONS(3714),
    [anon_sym_SEMI_SEMI] = ACTIONS(3714),
    [anon_sym_PIPE_AMP] = ACTIONS(3714),
    [anon_sym_AMP_AMP] = ACTIONS(3714),
    [anon_sym_PIPE_PIPE] = ACTIONS(3714),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_GT] = ACTIONS(3714),
    [anon_sym_GT_GT] = ACTIONS(3714),
    [anon_sym_AMP_GT] = ACTIONS(3714),
    [anon_sym_AMP_GT_GT] = ACTIONS(3714),
    [anon_sym_LT_AMP] = ACTIONS(3714),
    [anon_sym_GT_AMP] = ACTIONS(3714),
    [sym__special_characters] = ACTIONS(3714),
    [anon_sym_DQUOTE] = ACTIONS(3714),
    [sym_raw_string] = ACTIONS(3714),
    [anon_sym_DOLLAR] = ACTIONS(3714),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3714),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3714),
    [anon_sym_BQUOTE] = ACTIONS(3714),
    [anon_sym_LT_LPAREN] = ACTIONS(3714),
    [anon_sym_GT_LPAREN] = ACTIONS(3714),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(3714),
    [anon_sym_SEMI] = ACTIONS(3714),
    [anon_sym_LF] = ACTIONS(3714),
    [anon_sym_AMP] = ACTIONS(3714),
  },
  [2345] = {
    [sym_file_descriptor] = ACTIONS(3716),
    [sym__concat] = ACTIONS(3716),
    [sym_variable_name] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3718),
    [anon_sym_RPAREN] = ACTIONS(3718),
    [anon_sym_SEMI_SEMI] = ACTIONS(3718),
    [anon_sym_PIPE_AMP] = ACTIONS(3718),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_LT] = ACTIONS(3718),
    [anon_sym_GT] = ACTIONS(3718),
    [anon_sym_GT_GT] = ACTIONS(3718),
    [anon_sym_AMP_GT] = ACTIONS(3718),
    [anon_sym_AMP_GT_GT] = ACTIONS(3718),
    [anon_sym_LT_AMP] = ACTIONS(3718),
    [anon_sym_GT_AMP] = ACTIONS(3718),
    [sym__special_characters] = ACTIONS(3718),
    [anon_sym_DQUOTE] = ACTIONS(3718),
    [sym_raw_string] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3718),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3718),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3718),
    [anon_sym_BQUOTE] = ACTIONS(3718),
    [anon_sym_LT_LPAREN] = ACTIONS(3718),
    [anon_sym_GT_LPAREN] = ACTIONS(3718),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(3718),
    [anon_sym_SEMI] = ACTIONS(3718),
    [anon_sym_LF] = ACTIONS(3718),
    [anon_sym_AMP] = ACTIONS(3718),
  },
  [2346] = {
    [sym__concat] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(1524),
    [anon_sym_RPAREN] = ACTIONS(1524),
    [anon_sym_SEMI_SEMI] = ACTIONS(1524),
    [anon_sym_PIPE_AMP] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1524),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1524),
    [anon_sym_LF] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1524),
  },
  [2347] = {
    [aux_sym_concatenation_repeat1] = STATE(2347),
    [sym__concat] = ACTIONS(5117),
    [anon_sym_PIPE] = ACTIONS(1524),
    [anon_sym_RPAREN] = ACTIONS(1524),
    [anon_sym_SEMI_SEMI] = ACTIONS(1524),
    [anon_sym_PIPE_AMP] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1524),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1524),
    [anon_sym_LF] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1524),
  },
  [2348] = {
    [sym__concat] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(1555),
    [anon_sym_RPAREN] = ACTIONS(1555),
    [anon_sym_SEMI_SEMI] = ACTIONS(1555),
    [anon_sym_PIPE_AMP] = ACTIONS(1555),
    [anon_sym_AMP_AMP] = ACTIONS(1555),
    [anon_sym_PIPE_PIPE] = ACTIONS(1555),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1555),
    [anon_sym_LF] = ACTIONS(1555),
    [anon_sym_AMP] = ACTIONS(1555),
  },
  [2349] = {
    [sym_concatenation] = STATE(2491),
    [sym_string] = STATE(2490),
    [sym_simple_expansion] = STATE(2490),
    [sym_expansion] = STATE(2490),
    [sym_command_substitution] = STATE(2490),
    [sym_process_substitution] = STATE(2490),
    [anon_sym_RBRACE] = ACTIONS(5120),
    [sym__special_characters] = ACTIONS(5122),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(5124),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(5126),
  },
  [2350] = {
    [sym__concat] = ACTIONS(1598),
    [anon_sym_PIPE] = ACTIONS(1600),
    [anon_sym_RPAREN] = ACTIONS(1600),
    [anon_sym_SEMI_SEMI] = ACTIONS(1600),
    [anon_sym_PIPE_AMP] = ACTIONS(1600),
    [anon_sym_AMP_AMP] = ACTIONS(1600),
    [anon_sym_PIPE_PIPE] = ACTIONS(1600),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1600),
    [anon_sym_LF] = ACTIONS(1600),
    [anon_sym_AMP] = ACTIONS(1600),
  },
  [2351] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(5128),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2352] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(5130),
    [sym_comment] = ACTIONS(52),
  },
  [2353] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2495),
    [anon_sym_RBRACE] = ACTIONS(5132),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2354] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2497),
    [anon_sym_RBRACE] = ACTIONS(5134),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2355] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2498),
    [anon_sym_RBRACE] = ACTIONS(5120),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2356] = {
    [sym__concat] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [2357] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(5136),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2358] = {
    [sym__concat] = ACTIONS(1648),
    [anon_sym_PIPE] = ACTIONS(1650),
    [anon_sym_RPAREN] = ACTIONS(1650),
    [anon_sym_SEMI_SEMI] = ACTIONS(1650),
    [anon_sym_PIPE_AMP] = ACTIONS(1650),
    [anon_sym_AMP_AMP] = ACTIONS(1650),
    [anon_sym_PIPE_PIPE] = ACTIONS(1650),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1650),
    [anon_sym_LF] = ACTIONS(1650),
    [anon_sym_AMP] = ACTIONS(1650),
  },
  [2359] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(5120),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2360] = {
    [sym__concat] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(1764),
    [anon_sym_RPAREN] = ACTIONS(1764),
    [anon_sym_SEMI_SEMI] = ACTIONS(1764),
    [anon_sym_PIPE_AMP] = ACTIONS(1764),
    [anon_sym_AMP_AMP] = ACTIONS(1764),
    [anon_sym_PIPE_PIPE] = ACTIONS(1764),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1764),
    [anon_sym_LF] = ACTIONS(1764),
    [anon_sym_AMP] = ACTIONS(1764),
  },
  [2361] = {
    [sym__concat] = ACTIONS(1902),
    [anon_sym_PIPE] = ACTIONS(1904),
    [anon_sym_RPAREN] = ACTIONS(1904),
    [anon_sym_SEMI_SEMI] = ACTIONS(1904),
    [anon_sym_PIPE_AMP] = ACTIONS(1904),
    [anon_sym_AMP_AMP] = ACTIONS(1904),
    [anon_sym_PIPE_PIPE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(1904),
    [anon_sym_LF] = ACTIONS(1904),
    [anon_sym_AMP] = ACTIONS(1904),
  },
  [2362] = {
    [sym__concat] = ACTIONS(4406),
    [sym_variable_name] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_RPAREN] = ACTIONS(4408),
    [anon_sym_SEMI_SEMI] = ACTIONS(4408),
    [anon_sym_PIPE_AMP] = ACTIONS(4408),
    [anon_sym_AMP_AMP] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4408),
    [sym__special_characters] = ACTIONS(4408),
    [anon_sym_DQUOTE] = ACTIONS(4408),
    [sym_raw_string] = ACTIONS(4408),
    [anon_sym_DOLLAR] = ACTIONS(4408),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4408),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4408),
    [anon_sym_BQUOTE] = ACTIONS(4408),
    [anon_sym_LT_LPAREN] = ACTIONS(4408),
    [anon_sym_GT_LPAREN] = ACTIONS(4408),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4408),
    [sym_word] = ACTIONS(4408),
    [anon_sym_SEMI] = ACTIONS(4408),
    [anon_sym_LF] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4408),
  },
  [2363] = {
    [sym__concat] = ACTIONS(4410),
    [sym_variable_name] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4412),
    [anon_sym_RPAREN] = ACTIONS(4412),
    [anon_sym_SEMI_SEMI] = ACTIONS(4412),
    [anon_sym_PIPE_AMP] = ACTIONS(4412),
    [anon_sym_AMP_AMP] = ACTIONS(4412),
    [anon_sym_PIPE_PIPE] = ACTIONS(4412),
    [sym__special_characters] = ACTIONS(4412),
    [anon_sym_DQUOTE] = ACTIONS(4412),
    [sym_raw_string] = ACTIONS(4412),
    [anon_sym_DOLLAR] = ACTIONS(4412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4412),
    [anon_sym_BQUOTE] = ACTIONS(4412),
    [anon_sym_LT_LPAREN] = ACTIONS(4412),
    [anon_sym_GT_LPAREN] = ACTIONS(4412),
    [sym_comment] = ACTIONS(168),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4412),
    [sym_word] = ACTIONS(4412),
    [anon_sym_SEMI] = ACTIONS(4412),
    [anon_sym_LF] = ACTIONS(4412),
    [anon_sym_AMP] = ACTIONS(4412),
  },
  [2364] = {
    [sym_file_descriptor] = ACTIONS(3657),
    [sym__concat] = ACTIONS(3657),
    [anon_sym_PIPE] = ACTIONS(3659),
    [anon_sym_RPAREN] = ACTIONS(3659),
    [anon_sym_SEMI_SEMI] = ACTIONS(3659),
    [anon_sym_PIPE_AMP] = ACTIONS(3659),
    [anon_sym_AMP_AMP] = ACTIONS(3659),
    [anon_sym_PIPE_PIPE] = ACTIONS(3659),
    [anon_sym_LT] = ACTIONS(3659),
    [anon_sym_GT] = ACTIONS(3659),
    [anon_sym_GT_GT] = ACTIONS(3659),
    [anon_sym_AMP_GT] = ACTIONS(3659),
    [anon_sym_AMP_GT_GT] = ACTIONS(3659),
    [anon_sym_LT_AMP] = ACTIONS(3659),
    [anon_sym_GT_AMP] = ACTIONS(3659),
    [anon_sym_LT_LT] = ACTIONS(3659),
    [anon_sym_LT_LT_DASH] = ACTIONS(3659),
    [anon_sym_LT_LT_LT] = ACTIONS(3659),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3659),
    [anon_sym_LF] = ACTIONS(3659),
    [anon_sym_AMP] = ACTIONS(3659),
  },
  [2365] = {
    [sym_file_descriptor] = ACTIONS(3663),
    [sym__concat] = ACTIONS(3663),
    [anon_sym_PIPE] = ACTIONS(3665),
    [anon_sym_RPAREN] = ACTIONS(3665),
    [anon_sym_SEMI_SEMI] = ACTIONS(3665),
    [anon_sym_PIPE_AMP] = ACTIONS(3665),
    [anon_sym_AMP_AMP] = ACTIONS(3665),
    [anon_sym_PIPE_PIPE] = ACTIONS(3665),
    [anon_sym_LT] = ACTIONS(3665),
    [anon_sym_GT] = ACTIONS(3665),
    [anon_sym_GT_GT] = ACTIONS(3665),
    [anon_sym_AMP_GT] = ACTIONS(3665),
    [anon_sym_AMP_GT_GT] = ACTIONS(3665),
    [anon_sym_LT_AMP] = ACTIONS(3665),
    [anon_sym_GT_AMP] = ACTIONS(3665),
    [anon_sym_LT_LT] = ACTIONS(3665),
    [anon_sym_LT_LT_DASH] = ACTIONS(3665),
    [anon_sym_LT_LT_LT] = ACTIONS(3665),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3665),
    [anon_sym_LF] = ACTIONS(3665),
    [anon_sym_AMP] = ACTIONS(3665),
  },
  [2366] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5138),
    [sym_comment] = ACTIONS(52),
  },
  [2367] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5140),
    [sym_comment] = ACTIONS(52),
  },
  [2368] = {
    [anon_sym_RBRACE] = ACTIONS(5140),
    [sym_comment] = ACTIONS(52),
  },
  [2369] = {
    [sym_file_descriptor] = ACTIONS(3712),
    [sym__concat] = ACTIONS(3712),
    [anon_sym_PIPE] = ACTIONS(3714),
    [anon_sym_RPAREN] = ACTIONS(3714),
    [anon_sym_SEMI_SEMI] = ACTIONS(3714),
    [anon_sym_PIPE_AMP] = ACTIONS(3714),
    [anon_sym_AMP_AMP] = ACTIONS(3714),
    [anon_sym_PIPE_PIPE] = ACTIONS(3714),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_GT] = ACTIONS(3714),
    [anon_sym_GT_GT] = ACTIONS(3714),
    [anon_sym_AMP_GT] = ACTIONS(3714),
    [anon_sym_AMP_GT_GT] = ACTIONS(3714),
    [anon_sym_LT_AMP] = ACTIONS(3714),
    [anon_sym_GT_AMP] = ACTIONS(3714),
    [anon_sym_LT_LT] = ACTIONS(3714),
    [anon_sym_LT_LT_DASH] = ACTIONS(3714),
    [anon_sym_LT_LT_LT] = ACTIONS(3714),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3714),
    [anon_sym_LF] = ACTIONS(3714),
    [anon_sym_AMP] = ACTIONS(3714),
  },
  [2370] = {
    [sym_file_descriptor] = ACTIONS(3716),
    [sym__concat] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3718),
    [anon_sym_RPAREN] = ACTIONS(3718),
    [anon_sym_SEMI_SEMI] = ACTIONS(3718),
    [anon_sym_PIPE_AMP] = ACTIONS(3718),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_LT] = ACTIONS(3718),
    [anon_sym_GT] = ACTIONS(3718),
    [anon_sym_GT_GT] = ACTIONS(3718),
    [anon_sym_AMP_GT] = ACTIONS(3718),
    [anon_sym_AMP_GT_GT] = ACTIONS(3718),
    [anon_sym_LT_AMP] = ACTIONS(3718),
    [anon_sym_GT_AMP] = ACTIONS(3718),
    [anon_sym_LT_LT] = ACTIONS(3718),
    [anon_sym_LT_LT_DASH] = ACTIONS(3718),
    [anon_sym_LT_LT_LT] = ACTIONS(3718),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3718),
    [anon_sym_LF] = ACTIONS(3718),
    [anon_sym_AMP] = ACTIONS(3718),
  },
  [2371] = {
    [sym__concat] = ACTIONS(3657),
    [anon_sym_RBRACE] = ACTIONS(3657),
    [sym_comment] = ACTIONS(52),
  },
  [2372] = {
    [sym__concat] = ACTIONS(3663),
    [anon_sym_RBRACE] = ACTIONS(3663),
    [sym_comment] = ACTIONS(52),
  },
  [2373] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5142),
    [sym_comment] = ACTIONS(52),
  },
  [2374] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5144),
    [sym_comment] = ACTIONS(52),
  },
  [2375] = {
    [anon_sym_RBRACE] = ACTIONS(5144),
    [sym_comment] = ACTIONS(52),
  },
  [2376] = {
    [sym__concat] = ACTIONS(3712),
    [anon_sym_RBRACE] = ACTIONS(3712),
    [sym_comment] = ACTIONS(52),
  },
  [2377] = {
    [sym__concat] = ACTIONS(3716),
    [anon_sym_RBRACE] = ACTIONS(3716),
    [sym_comment] = ACTIONS(52),
  },
  [2378] = {
    [sym__concat] = ACTIONS(4406),
    [anon_sym_RBRACE] = ACTIONS(4406),
    [anon_sym_EQ] = ACTIONS(4845),
    [sym__special_characters] = ACTIONS(4408),
    [anon_sym_DQUOTE] = ACTIONS(4406),
    [sym_raw_string] = ACTIONS(4406),
    [anon_sym_DOLLAR] = ACTIONS(4845),
    [anon_sym_POUND] = ACTIONS(4406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4406),
    [anon_sym_COLON] = ACTIONS(4845),
    [anon_sym_COLON_QMARK] = ACTIONS(4845),
    [anon_sym_COLON_DASH] = ACTIONS(4845),
    [anon_sym_PERCENT] = ACTIONS(4845),
    [anon_sym_SLASH] = ACTIONS(4845),
    [anon_sym_DASH] = ACTIONS(4845),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4406),
    [anon_sym_BQUOTE] = ACTIONS(4406),
    [anon_sym_LT_LPAREN] = ACTIONS(4406),
    [anon_sym_GT_LPAREN] = ACTIONS(4406),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(4408),
  },
  [2379] = {
    [sym__concat] = ACTIONS(4410),
    [anon_sym_RBRACE] = ACTIONS(4410),
    [anon_sym_EQ] = ACTIONS(4847),
    [sym__special_characters] = ACTIONS(4412),
    [anon_sym_DQUOTE] = ACTIONS(4410),
    [sym_raw_string] = ACTIONS(4410),
    [anon_sym_DOLLAR] = ACTIONS(4847),
    [anon_sym_POUND] = ACTIONS(4410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4410),
    [anon_sym_COLON] = ACTIONS(4847),
    [anon_sym_COLON_QMARK] = ACTIONS(4847),
    [anon_sym_COLON_DASH] = ACTIONS(4847),
    [anon_sym_PERCENT] = ACTIONS(4847),
    [anon_sym_SLASH] = ACTIONS(4847),
    [anon_sym_DASH] = ACTIONS(4847),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4410),
    [anon_sym_BQUOTE] = ACTIONS(4410),
    [anon_sym_LT_LPAREN] = ACTIONS(4410),
    [anon_sym_GT_LPAREN] = ACTIONS(4410),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(4412),
  },
  [2380] = {
    [sym_file_descriptor] = ACTIONS(3657),
    [sym__concat] = ACTIONS(3657),
    [sym_variable_name] = ACTIONS(3657),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_RPAREN] = ACTIONS(3657),
    [anon_sym_PIPE_AMP] = ACTIONS(3657),
    [anon_sym_AMP_AMP] = ACTIONS(3657),
    [anon_sym_PIPE_PIPE] = ACTIONS(3657),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(3657),
    [anon_sym_AMP_GT] = ACTIONS(4331),
    [anon_sym_AMP_GT_GT] = ACTIONS(3657),
    [anon_sym_LT_AMP] = ACTIONS(3657),
    [anon_sym_GT_AMP] = ACTIONS(3657),
    [sym__special_characters] = ACTIONS(4331),
    [anon_sym_DQUOTE] = ACTIONS(3657),
    [sym_raw_string] = ACTIONS(3657),
    [anon_sym_DOLLAR] = ACTIONS(4331),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3657),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3657),
    [anon_sym_BQUOTE] = ACTIONS(3657),
    [anon_sym_LT_LPAREN] = ACTIONS(3657),
    [anon_sym_GT_LPAREN] = ACTIONS(3657),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4331),
  },
  [2381] = {
    [sym_file_descriptor] = ACTIONS(3663),
    [sym__concat] = ACTIONS(3663),
    [sym_variable_name] = ACTIONS(3663),
    [anon_sym_PIPE] = ACTIONS(4333),
    [anon_sym_RPAREN] = ACTIONS(3663),
    [anon_sym_PIPE_AMP] = ACTIONS(3663),
    [anon_sym_AMP_AMP] = ACTIONS(3663),
    [anon_sym_PIPE_PIPE] = ACTIONS(3663),
    [anon_sym_LT] = ACTIONS(4333),
    [anon_sym_GT] = ACTIONS(4333),
    [anon_sym_GT_GT] = ACTIONS(3663),
    [anon_sym_AMP_GT] = ACTIONS(4333),
    [anon_sym_AMP_GT_GT] = ACTIONS(3663),
    [anon_sym_LT_AMP] = ACTIONS(3663),
    [anon_sym_GT_AMP] = ACTIONS(3663),
    [sym__special_characters] = ACTIONS(4333),
    [anon_sym_DQUOTE] = ACTIONS(3663),
    [sym_raw_string] = ACTIONS(3663),
    [anon_sym_DOLLAR] = ACTIONS(4333),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3663),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3663),
    [anon_sym_BQUOTE] = ACTIONS(3663),
    [anon_sym_LT_LPAREN] = ACTIONS(3663),
    [anon_sym_GT_LPAREN] = ACTIONS(3663),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4333),
  },
  [2382] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5146),
    [sym_comment] = ACTIONS(52),
  },
  [2383] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5148),
    [sym_comment] = ACTIONS(52),
  },
  [2384] = {
    [anon_sym_RBRACE] = ACTIONS(5148),
    [sym_comment] = ACTIONS(52),
  },
  [2385] = {
    [sym_file_descriptor] = ACTIONS(3712),
    [sym__concat] = ACTIONS(3712),
    [sym_variable_name] = ACTIONS(3712),
    [anon_sym_PIPE] = ACTIONS(4339),
    [anon_sym_RPAREN] = ACTIONS(3712),
    [anon_sym_PIPE_AMP] = ACTIONS(3712),
    [anon_sym_AMP_AMP] = ACTIONS(3712),
    [anon_sym_PIPE_PIPE] = ACTIONS(3712),
    [anon_sym_LT] = ACTIONS(4339),
    [anon_sym_GT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(3712),
    [anon_sym_AMP_GT] = ACTIONS(4339),
    [anon_sym_AMP_GT_GT] = ACTIONS(3712),
    [anon_sym_LT_AMP] = ACTIONS(3712),
    [anon_sym_GT_AMP] = ACTIONS(3712),
    [sym__special_characters] = ACTIONS(4339),
    [anon_sym_DQUOTE] = ACTIONS(3712),
    [sym_raw_string] = ACTIONS(3712),
    [anon_sym_DOLLAR] = ACTIONS(4339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3712),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3712),
    [anon_sym_BQUOTE] = ACTIONS(3712),
    [anon_sym_LT_LPAREN] = ACTIONS(3712),
    [anon_sym_GT_LPAREN] = ACTIONS(3712),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4339),
  },
  [2386] = {
    [sym_file_descriptor] = ACTIONS(3716),
    [sym__concat] = ACTIONS(3716),
    [sym_variable_name] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(4341),
    [anon_sym_RPAREN] = ACTIONS(3716),
    [anon_sym_PIPE_AMP] = ACTIONS(3716),
    [anon_sym_AMP_AMP] = ACTIONS(3716),
    [anon_sym_PIPE_PIPE] = ACTIONS(3716),
    [anon_sym_LT] = ACTIONS(4341),
    [anon_sym_GT] = ACTIONS(4341),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_AMP_GT] = ACTIONS(4341),
    [anon_sym_AMP_GT_GT] = ACTIONS(3716),
    [anon_sym_LT_AMP] = ACTIONS(3716),
    [anon_sym_GT_AMP] = ACTIONS(3716),
    [sym__special_characters] = ACTIONS(4341),
    [anon_sym_DQUOTE] = ACTIONS(3716),
    [sym_raw_string] = ACTIONS(3716),
    [anon_sym_DOLLAR] = ACTIONS(4341),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3716),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3716),
    [anon_sym_BQUOTE] = ACTIONS(3716),
    [anon_sym_LT_LPAREN] = ACTIONS(3716),
    [anon_sym_GT_LPAREN] = ACTIONS(3716),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4341),
  },
  [2387] = {
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_RPAREN] = ACTIONS(2146),
    [anon_sym_PIPE_AMP] = ACTIONS(2146),
    [anon_sym_AMP_AMP] = ACTIONS(2146),
    [anon_sym_PIPE_PIPE] = ACTIONS(2146),
    [anon_sym_BQUOTE] = ACTIONS(2146),
    [sym_comment] = ACTIONS(52),
  },
  [2388] = {
    [sym__terminated_statement] = STATE(603),
    [sym_for_statement] = STATE(604),
    [sym_while_statement] = STATE(604),
    [sym_if_statement] = STATE(604),
    [sym_case_statement] = STATE(604),
    [sym_function_definition] = STATE(604),
    [sym_subshell] = STATE(604),
    [sym_pipeline] = STATE(604),
    [sym_list] = STATE(604),
    [sym_bracket_command] = STATE(604),
    [sym_command] = STATE(604),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(605),
    [sym_declaration_command] = STATE(604),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(1099),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_done] = ACTIONS(5150),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [2389] = {
    [anon_sym_PIPE] = ACTIONS(5152),
    [anon_sym_RPAREN] = ACTIONS(5154),
    [anon_sym_PIPE_AMP] = ACTIONS(5154),
    [anon_sym_AMP_AMP] = ACTIONS(5154),
    [anon_sym_PIPE_PIPE] = ACTIONS(5154),
    [anon_sym_BQUOTE] = ACTIONS(5154),
    [sym_comment] = ACTIONS(52),
  },
  [2390] = {
    [anon_sym_PIPE] = ACTIONS(5156),
    [anon_sym_RPAREN] = ACTIONS(5158),
    [anon_sym_PIPE_AMP] = ACTIONS(5158),
    [anon_sym_AMP_AMP] = ACTIONS(5158),
    [anon_sym_PIPE_PIPE] = ACTIONS(5158),
    [anon_sym_BQUOTE] = ACTIONS(5158),
    [sym_comment] = ACTIONS(52),
  },
  [2391] = {
    [anon_sym_esac] = ACTIONS(5160),
    [sym_comment] = ACTIONS(52),
  },
  [2392] = {
    [anon_sym_PIPE] = ACTIONS(5162),
    [anon_sym_RPAREN] = ACTIONS(5164),
    [anon_sym_PIPE_AMP] = ACTIONS(5164),
    [anon_sym_AMP_AMP] = ACTIONS(5164),
    [anon_sym_PIPE_PIPE] = ACTIONS(5164),
    [anon_sym_BQUOTE] = ACTIONS(5164),
    [sym_comment] = ACTIONS(52),
  },
  [2393] = {
    [anon_sym_esac] = ACTIONS(5166),
    [sym_comment] = ACTIONS(52),
  },
  [2394] = {
    [sym__concat] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_RPAREN] = ACTIONS(1522),
    [anon_sym_PIPE_AMP] = ACTIONS(1522),
    [anon_sym_AMP_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
  },
  [2395] = {
    [aux_sym_concatenation_repeat1] = STATE(2395),
    [sym__concat] = ACTIONS(5168),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_RPAREN] = ACTIONS(1522),
    [anon_sym_PIPE_AMP] = ACTIONS(1522),
    [anon_sym_AMP_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
  },
  [2396] = {
    [sym__concat] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(2435),
    [anon_sym_RPAREN] = ACTIONS(1553),
    [anon_sym_PIPE_AMP] = ACTIONS(1553),
    [anon_sym_AMP_AMP] = ACTIONS(1553),
    [anon_sym_PIPE_PIPE] = ACTIONS(1553),
    [sym_comment] = ACTIONS(52),
  },
  [2397] = {
    [sym_concatenation] = STATE(2512),
    [sym_string] = STATE(2511),
    [sym_simple_expansion] = STATE(2511),
    [sym_expansion] = STATE(2511),
    [sym_command_substitution] = STATE(2511),
    [sym_process_substitution] = STATE(2511),
    [anon_sym_RBRACE] = ACTIONS(5171),
    [sym__special_characters] = ACTIONS(5173),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(5175),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(5177),
  },
  [2398] = {
    [sym__concat] = ACTIONS(1598),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_RPAREN] = ACTIONS(1598),
    [anon_sym_PIPE_AMP] = ACTIONS(1598),
    [anon_sym_AMP_AMP] = ACTIONS(1598),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [sym_comment] = ACTIONS(52),
  },
  [2399] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(5179),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2400] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(5181),
    [sym_comment] = ACTIONS(52),
  },
  [2401] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2516),
    [anon_sym_RBRACE] = ACTIONS(5183),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2402] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2518),
    [anon_sym_RBRACE] = ACTIONS(5185),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2403] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2519),
    [anon_sym_RBRACE] = ACTIONS(5171),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2404] = {
    [sym__concat] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(2455),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [sym_comment] = ACTIONS(52),
  },
  [2405] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(5187),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2406] = {
    [sym__concat] = ACTIONS(1648),
    [anon_sym_PIPE] = ACTIONS(2459),
    [anon_sym_RPAREN] = ACTIONS(1648),
    [anon_sym_PIPE_AMP] = ACTIONS(1648),
    [anon_sym_AMP_AMP] = ACTIONS(1648),
    [anon_sym_PIPE_PIPE] = ACTIONS(1648),
    [sym_comment] = ACTIONS(52),
  },
  [2407] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(5171),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2408] = {
    [sym__concat] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(2461),
    [anon_sym_RPAREN] = ACTIONS(1762),
    [anon_sym_PIPE_AMP] = ACTIONS(1762),
    [anon_sym_AMP_AMP] = ACTIONS(1762),
    [anon_sym_PIPE_PIPE] = ACTIONS(1762),
    [sym_comment] = ACTIONS(52),
  },
  [2409] = {
    [sym__concat] = ACTIONS(1902),
    [anon_sym_PIPE] = ACTIONS(2463),
    [anon_sym_RPAREN] = ACTIONS(1902),
    [anon_sym_PIPE_AMP] = ACTIONS(1902),
    [anon_sym_AMP_AMP] = ACTIONS(1902),
    [anon_sym_PIPE_PIPE] = ACTIONS(1902),
    [sym_comment] = ACTIONS(52),
  },
  [2410] = {
    [sym__concat] = ACTIONS(4406),
    [sym_variable_name] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4845),
    [anon_sym_RPAREN] = ACTIONS(4406),
    [anon_sym_PIPE_AMP] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [sym__special_characters] = ACTIONS(4845),
    [anon_sym_DQUOTE] = ACTIONS(4406),
    [sym_raw_string] = ACTIONS(4406),
    [anon_sym_DOLLAR] = ACTIONS(4845),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4406),
    [anon_sym_BQUOTE] = ACTIONS(4406),
    [anon_sym_LT_LPAREN] = ACTIONS(4406),
    [anon_sym_GT_LPAREN] = ACTIONS(4406),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4845),
    [sym_word] = ACTIONS(4408),
  },
  [2411] = {
    [sym__concat] = ACTIONS(4410),
    [sym_variable_name] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4847),
    [anon_sym_RPAREN] = ACTIONS(4410),
    [anon_sym_PIPE_AMP] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [sym__special_characters] = ACTIONS(4847),
    [anon_sym_DQUOTE] = ACTIONS(4410),
    [sym_raw_string] = ACTIONS(4410),
    [anon_sym_DOLLAR] = ACTIONS(4847),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4410),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4410),
    [anon_sym_BQUOTE] = ACTIONS(4410),
    [anon_sym_LT_LPAREN] = ACTIONS(4410),
    [anon_sym_GT_LPAREN] = ACTIONS(4410),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4847),
    [sym_word] = ACTIONS(4412),
  },
  [2412] = {
    [sym_file_descriptor] = ACTIONS(3657),
    [sym__concat] = ACTIONS(3657),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_RPAREN] = ACTIONS(3657),
    [anon_sym_PIPE_AMP] = ACTIONS(3657),
    [anon_sym_AMP_AMP] = ACTIONS(3657),
    [anon_sym_PIPE_PIPE] = ACTIONS(3657),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(3657),
    [anon_sym_AMP_GT] = ACTIONS(4331),
    [anon_sym_AMP_GT_GT] = ACTIONS(3657),
    [anon_sym_LT_AMP] = ACTIONS(3657),
    [anon_sym_GT_AMP] = ACTIONS(3657),
    [anon_sym_LT_LT] = ACTIONS(4331),
    [anon_sym_LT_LT_DASH] = ACTIONS(3657),
    [anon_sym_LT_LT_LT] = ACTIONS(3657),
    [sym_comment] = ACTIONS(52),
  },
  [2413] = {
    [sym_file_descriptor] = ACTIONS(3663),
    [sym__concat] = ACTIONS(3663),
    [anon_sym_PIPE] = ACTIONS(4333),
    [anon_sym_RPAREN] = ACTIONS(3663),
    [anon_sym_PIPE_AMP] = ACTIONS(3663),
    [anon_sym_AMP_AMP] = ACTIONS(3663),
    [anon_sym_PIPE_PIPE] = ACTIONS(3663),
    [anon_sym_LT] = ACTIONS(4333),
    [anon_sym_GT] = ACTIONS(4333),
    [anon_sym_GT_GT] = ACTIONS(3663),
    [anon_sym_AMP_GT] = ACTIONS(4333),
    [anon_sym_AMP_GT_GT] = ACTIONS(3663),
    [anon_sym_LT_AMP] = ACTIONS(3663),
    [anon_sym_GT_AMP] = ACTIONS(3663),
    [anon_sym_LT_LT] = ACTIONS(4333),
    [anon_sym_LT_LT_DASH] = ACTIONS(3663),
    [anon_sym_LT_LT_LT] = ACTIONS(3663),
    [sym_comment] = ACTIONS(52),
  },
  [2414] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5189),
    [sym_comment] = ACTIONS(52),
  },
  [2415] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5191),
    [sym_comment] = ACTIONS(52),
  },
  [2416] = {
    [anon_sym_RBRACE] = ACTIONS(5191),
    [sym_comment] = ACTIONS(52),
  },
  [2417] = {
    [sym_file_descriptor] = ACTIONS(3712),
    [sym__concat] = ACTIONS(3712),
    [anon_sym_PIPE] = ACTIONS(4339),
    [anon_sym_RPAREN] = ACTIONS(3712),
    [anon_sym_PIPE_AMP] = ACTIONS(3712),
    [anon_sym_AMP_AMP] = ACTIONS(3712),
    [anon_sym_PIPE_PIPE] = ACTIONS(3712),
    [anon_sym_LT] = ACTIONS(4339),
    [anon_sym_GT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(3712),
    [anon_sym_AMP_GT] = ACTIONS(4339),
    [anon_sym_AMP_GT_GT] = ACTIONS(3712),
    [anon_sym_LT_AMP] = ACTIONS(3712),
    [anon_sym_GT_AMP] = ACTIONS(3712),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_LT_LT_DASH] = ACTIONS(3712),
    [anon_sym_LT_LT_LT] = ACTIONS(3712),
    [sym_comment] = ACTIONS(52),
  },
  [2418] = {
    [sym_file_descriptor] = ACTIONS(3716),
    [sym__concat] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(4341),
    [anon_sym_RPAREN] = ACTIONS(3716),
    [anon_sym_PIPE_AMP] = ACTIONS(3716),
    [anon_sym_AMP_AMP] = ACTIONS(3716),
    [anon_sym_PIPE_PIPE] = ACTIONS(3716),
    [anon_sym_LT] = ACTIONS(4341),
    [anon_sym_GT] = ACTIONS(4341),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_AMP_GT] = ACTIONS(4341),
    [anon_sym_AMP_GT_GT] = ACTIONS(3716),
    [anon_sym_LT_AMP] = ACTIONS(3716),
    [anon_sym_GT_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(4341),
    [anon_sym_LT_LT_DASH] = ACTIONS(3716),
    [anon_sym_LT_LT_LT] = ACTIONS(3716),
    [sym_comment] = ACTIONS(52),
  },
  [2419] = {
    [sym_file_descriptor] = ACTIONS(3657),
    [sym__concat] = ACTIONS(3657),
    [sym_variable_name] = ACTIONS(3657),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_PIPE_AMP] = ACTIONS(3657),
    [anon_sym_AMP_AMP] = ACTIONS(3657),
    [anon_sym_PIPE_PIPE] = ACTIONS(3657),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(3657),
    [anon_sym_AMP_GT] = ACTIONS(4331),
    [anon_sym_AMP_GT_GT] = ACTIONS(3657),
    [anon_sym_LT_AMP] = ACTIONS(3657),
    [anon_sym_GT_AMP] = ACTIONS(3657),
    [sym__special_characters] = ACTIONS(4331),
    [anon_sym_DQUOTE] = ACTIONS(3657),
    [sym_raw_string] = ACTIONS(3657),
    [anon_sym_DOLLAR] = ACTIONS(4331),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3657),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3657),
    [anon_sym_BQUOTE] = ACTIONS(3657),
    [anon_sym_LT_LPAREN] = ACTIONS(3657),
    [anon_sym_GT_LPAREN] = ACTIONS(3657),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4331),
  },
  [2420] = {
    [sym_file_descriptor] = ACTIONS(3663),
    [sym__concat] = ACTIONS(3663),
    [sym_variable_name] = ACTIONS(3663),
    [anon_sym_PIPE] = ACTIONS(4333),
    [anon_sym_PIPE_AMP] = ACTIONS(3663),
    [anon_sym_AMP_AMP] = ACTIONS(3663),
    [anon_sym_PIPE_PIPE] = ACTIONS(3663),
    [anon_sym_LT] = ACTIONS(4333),
    [anon_sym_GT] = ACTIONS(4333),
    [anon_sym_GT_GT] = ACTIONS(3663),
    [anon_sym_AMP_GT] = ACTIONS(4333),
    [anon_sym_AMP_GT_GT] = ACTIONS(3663),
    [anon_sym_LT_AMP] = ACTIONS(3663),
    [anon_sym_GT_AMP] = ACTIONS(3663),
    [sym__special_characters] = ACTIONS(4333),
    [anon_sym_DQUOTE] = ACTIONS(3663),
    [sym_raw_string] = ACTIONS(3663),
    [anon_sym_DOLLAR] = ACTIONS(4333),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3663),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3663),
    [anon_sym_BQUOTE] = ACTIONS(3663),
    [anon_sym_LT_LPAREN] = ACTIONS(3663),
    [anon_sym_GT_LPAREN] = ACTIONS(3663),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4333),
  },
  [2421] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5193),
    [sym_comment] = ACTIONS(52),
  },
  [2422] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5195),
    [sym_comment] = ACTIONS(52),
  },
  [2423] = {
    [anon_sym_RBRACE] = ACTIONS(5195),
    [sym_comment] = ACTIONS(52),
  },
  [2424] = {
    [sym_file_descriptor] = ACTIONS(3712),
    [sym__concat] = ACTIONS(3712),
    [sym_variable_name] = ACTIONS(3712),
    [anon_sym_PIPE] = ACTIONS(4339),
    [anon_sym_PIPE_AMP] = ACTIONS(3712),
    [anon_sym_AMP_AMP] = ACTIONS(3712),
    [anon_sym_PIPE_PIPE] = ACTIONS(3712),
    [anon_sym_LT] = ACTIONS(4339),
    [anon_sym_GT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(3712),
    [anon_sym_AMP_GT] = ACTIONS(4339),
    [anon_sym_AMP_GT_GT] = ACTIONS(3712),
    [anon_sym_LT_AMP] = ACTIONS(3712),
    [anon_sym_GT_AMP] = ACTIONS(3712),
    [sym__special_characters] = ACTIONS(4339),
    [anon_sym_DQUOTE] = ACTIONS(3712),
    [sym_raw_string] = ACTIONS(3712),
    [anon_sym_DOLLAR] = ACTIONS(4339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3712),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3712),
    [anon_sym_BQUOTE] = ACTIONS(3712),
    [anon_sym_LT_LPAREN] = ACTIONS(3712),
    [anon_sym_GT_LPAREN] = ACTIONS(3712),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4339),
  },
  [2425] = {
    [sym_file_descriptor] = ACTIONS(3716),
    [sym__concat] = ACTIONS(3716),
    [sym_variable_name] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(4341),
    [anon_sym_PIPE_AMP] = ACTIONS(3716),
    [anon_sym_AMP_AMP] = ACTIONS(3716),
    [anon_sym_PIPE_PIPE] = ACTIONS(3716),
    [anon_sym_LT] = ACTIONS(4341),
    [anon_sym_GT] = ACTIONS(4341),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_AMP_GT] = ACTIONS(4341),
    [anon_sym_AMP_GT_GT] = ACTIONS(3716),
    [anon_sym_LT_AMP] = ACTIONS(3716),
    [anon_sym_GT_AMP] = ACTIONS(3716),
    [sym__special_characters] = ACTIONS(4341),
    [anon_sym_DQUOTE] = ACTIONS(3716),
    [sym_raw_string] = ACTIONS(3716),
    [anon_sym_DOLLAR] = ACTIONS(4341),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3716),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3716),
    [anon_sym_BQUOTE] = ACTIONS(3716),
    [anon_sym_LT_LPAREN] = ACTIONS(3716),
    [anon_sym_GT_LPAREN] = ACTIONS(3716),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4341),
  },
  [2426] = {
    [sym__concat] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_PIPE_AMP] = ACTIONS(1522),
    [anon_sym_AMP_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1522),
    [anon_sym_BQUOTE] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
  },
  [2427] = {
    [aux_sym_concatenation_repeat1] = STATE(2427),
    [sym__concat] = ACTIONS(5197),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_PIPE_AMP] = ACTIONS(1522),
    [anon_sym_AMP_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1522),
    [anon_sym_BQUOTE] = ACTIONS(1522),
    [sym_comment] = ACTIONS(52),
  },
  [2428] = {
    [sym__concat] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(2435),
    [anon_sym_PIPE_AMP] = ACTIONS(1553),
    [anon_sym_AMP_AMP] = ACTIONS(1553),
    [anon_sym_PIPE_PIPE] = ACTIONS(1553),
    [anon_sym_BQUOTE] = ACTIONS(1553),
    [sym_comment] = ACTIONS(52),
  },
  [2429] = {
    [sym_concatenation] = STATE(2528),
    [sym_string] = STATE(2527),
    [sym_simple_expansion] = STATE(2527),
    [sym_expansion] = STATE(2527),
    [sym_command_substitution] = STATE(2527),
    [sym_process_substitution] = STATE(2527),
    [anon_sym_RBRACE] = ACTIONS(5200),
    [sym__special_characters] = ACTIONS(5202),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(5204),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(5206),
  },
  [2430] = {
    [sym__concat] = ACTIONS(1598),
    [anon_sym_PIPE] = ACTIONS(2445),
    [anon_sym_PIPE_AMP] = ACTIONS(1598),
    [anon_sym_AMP_AMP] = ACTIONS(1598),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_BQUOTE] = ACTIONS(1598),
    [sym_comment] = ACTIONS(52),
  },
  [2431] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(5208),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2432] = {
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(5210),
    [sym_comment] = ACTIONS(52),
  },
  [2433] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2532),
    [anon_sym_RBRACE] = ACTIONS(5212),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2434] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2534),
    [anon_sym_RBRACE] = ACTIONS(5214),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2435] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(2535),
    [anon_sym_RBRACE] = ACTIONS(5200),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2436] = {
    [sym__concat] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(2455),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [sym_comment] = ACTIONS(52),
  },
  [2437] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(5216),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2438] = {
    [sym__concat] = ACTIONS(1648),
    [anon_sym_PIPE] = ACTIONS(2459),
    [anon_sym_PIPE_AMP] = ACTIONS(1648),
    [anon_sym_AMP_AMP] = ACTIONS(1648),
    [anon_sym_PIPE_PIPE] = ACTIONS(1648),
    [anon_sym_BQUOTE] = ACTIONS(1648),
    [sym_comment] = ACTIONS(52),
  },
  [2439] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(5200),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2440] = {
    [sym__concat] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(2461),
    [anon_sym_PIPE_AMP] = ACTIONS(1762),
    [anon_sym_AMP_AMP] = ACTIONS(1762),
    [anon_sym_PIPE_PIPE] = ACTIONS(1762),
    [anon_sym_BQUOTE] = ACTIONS(1762),
    [sym_comment] = ACTIONS(52),
  },
  [2441] = {
    [sym__concat] = ACTIONS(1902),
    [anon_sym_PIPE] = ACTIONS(2463),
    [anon_sym_PIPE_AMP] = ACTIONS(1902),
    [anon_sym_AMP_AMP] = ACTIONS(1902),
    [anon_sym_PIPE_PIPE] = ACTIONS(1902),
    [anon_sym_BQUOTE] = ACTIONS(1902),
    [sym_comment] = ACTIONS(52),
  },
  [2442] = {
    [sym__concat] = ACTIONS(4406),
    [sym_variable_name] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4845),
    [anon_sym_PIPE_AMP] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [sym__special_characters] = ACTIONS(4845),
    [anon_sym_DQUOTE] = ACTIONS(4406),
    [sym_raw_string] = ACTIONS(4406),
    [anon_sym_DOLLAR] = ACTIONS(4845),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4406),
    [anon_sym_BQUOTE] = ACTIONS(4406),
    [anon_sym_LT_LPAREN] = ACTIONS(4406),
    [anon_sym_GT_LPAREN] = ACTIONS(4406),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4845),
    [sym_word] = ACTIONS(4408),
  },
  [2443] = {
    [sym__concat] = ACTIONS(4410),
    [sym_variable_name] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4847),
    [anon_sym_PIPE_AMP] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [sym__special_characters] = ACTIONS(4847),
    [anon_sym_DQUOTE] = ACTIONS(4410),
    [sym_raw_string] = ACTIONS(4410),
    [anon_sym_DOLLAR] = ACTIONS(4847),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4410),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4410),
    [anon_sym_BQUOTE] = ACTIONS(4410),
    [anon_sym_LT_LPAREN] = ACTIONS(4410),
    [anon_sym_GT_LPAREN] = ACTIONS(4410),
    [sym_comment] = ACTIONS(52),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4847),
    [sym_word] = ACTIONS(4412),
  },
  [2444] = {
    [sym_file_descriptor] = ACTIONS(3657),
    [sym__concat] = ACTIONS(3657),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_PIPE_AMP] = ACTIONS(3657),
    [anon_sym_AMP_AMP] = ACTIONS(3657),
    [anon_sym_PIPE_PIPE] = ACTIONS(3657),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_GT_GT] = ACTIONS(3657),
    [anon_sym_AMP_GT] = ACTIONS(4331),
    [anon_sym_AMP_GT_GT] = ACTIONS(3657),
    [anon_sym_LT_AMP] = ACTIONS(3657),
    [anon_sym_GT_AMP] = ACTIONS(3657),
    [anon_sym_LT_LT] = ACTIONS(4331),
    [anon_sym_LT_LT_DASH] = ACTIONS(3657),
    [anon_sym_LT_LT_LT] = ACTIONS(3657),
    [anon_sym_BQUOTE] = ACTIONS(3657),
    [sym_comment] = ACTIONS(52),
  },
  [2445] = {
    [sym_file_descriptor] = ACTIONS(3663),
    [sym__concat] = ACTIONS(3663),
    [anon_sym_PIPE] = ACTIONS(4333),
    [anon_sym_PIPE_AMP] = ACTIONS(3663),
    [anon_sym_AMP_AMP] = ACTIONS(3663),
    [anon_sym_PIPE_PIPE] = ACTIONS(3663),
    [anon_sym_LT] = ACTIONS(4333),
    [anon_sym_GT] = ACTIONS(4333),
    [anon_sym_GT_GT] = ACTIONS(3663),
    [anon_sym_AMP_GT] = ACTIONS(4333),
    [anon_sym_AMP_GT_GT] = ACTIONS(3663),
    [anon_sym_LT_AMP] = ACTIONS(3663),
    [anon_sym_GT_AMP] = ACTIONS(3663),
    [anon_sym_LT_LT] = ACTIONS(4333),
    [anon_sym_LT_LT_DASH] = ACTIONS(3663),
    [anon_sym_LT_LT_LT] = ACTIONS(3663),
    [anon_sym_BQUOTE] = ACTIONS(3663),
    [sym_comment] = ACTIONS(52),
  },
  [2446] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5218),
    [sym_comment] = ACTIONS(52),
  },
  [2447] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5220),
    [sym_comment] = ACTIONS(52),
  },
  [2448] = {
    [anon_sym_RBRACE] = ACTIONS(5220),
    [sym_comment] = ACTIONS(52),
  },
  [2449] = {
    [sym_file_descriptor] = ACTIONS(3712),
    [sym__concat] = ACTIONS(3712),
    [anon_sym_PIPE] = ACTIONS(4339),
    [anon_sym_PIPE_AMP] = ACTIONS(3712),
    [anon_sym_AMP_AMP] = ACTIONS(3712),
    [anon_sym_PIPE_PIPE] = ACTIONS(3712),
    [anon_sym_LT] = ACTIONS(4339),
    [anon_sym_GT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(3712),
    [anon_sym_AMP_GT] = ACTIONS(4339),
    [anon_sym_AMP_GT_GT] = ACTIONS(3712),
    [anon_sym_LT_AMP] = ACTIONS(3712),
    [anon_sym_GT_AMP] = ACTIONS(3712),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_LT_LT_DASH] = ACTIONS(3712),
    [anon_sym_LT_LT_LT] = ACTIONS(3712),
    [anon_sym_BQUOTE] = ACTIONS(3712),
    [sym_comment] = ACTIONS(52),
  },
  [2450] = {
    [sym_file_descriptor] = ACTIONS(3716),
    [sym__concat] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(4341),
    [anon_sym_PIPE_AMP] = ACTIONS(3716),
    [anon_sym_AMP_AMP] = ACTIONS(3716),
    [anon_sym_PIPE_PIPE] = ACTIONS(3716),
    [anon_sym_LT] = ACTIONS(4341),
    [anon_sym_GT] = ACTIONS(4341),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_AMP_GT] = ACTIONS(4341),
    [anon_sym_AMP_GT_GT] = ACTIONS(3716),
    [anon_sym_LT_AMP] = ACTIONS(3716),
    [anon_sym_GT_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(4341),
    [anon_sym_LT_LT_DASH] = ACTIONS(3716),
    [anon_sym_LT_LT_LT] = ACTIONS(3716),
    [anon_sym_BQUOTE] = ACTIONS(3716),
    [sym_comment] = ACTIONS(52),
  },
  [2451] = {
    [sym_file_descriptor] = ACTIONS(4406),
    [sym__concat] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_SEMI_SEMI] = ACTIONS(4408),
    [anon_sym_PIPE_AMP] = ACTIONS(4408),
    [anon_sym_AMP_AMP] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4408),
    [anon_sym_LT] = ACTIONS(4408),
    [anon_sym_GT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_AMP_GT] = ACTIONS(4408),
    [anon_sym_AMP_GT_GT] = ACTIONS(4408),
    [anon_sym_LT_AMP] = ACTIONS(4408),
    [anon_sym_GT_AMP] = ACTIONS(4408),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_LT_LT_DASH] = ACTIONS(4408),
    [anon_sym_LT_LT_LT] = ACTIONS(4408),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(4408),
    [anon_sym_LF] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4408),
  },
  [2452] = {
    [sym_file_descriptor] = ACTIONS(4410),
    [sym__concat] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4412),
    [anon_sym_SEMI_SEMI] = ACTIONS(4412),
    [anon_sym_PIPE_AMP] = ACTIONS(4412),
    [anon_sym_AMP_AMP] = ACTIONS(4412),
    [anon_sym_PIPE_PIPE] = ACTIONS(4412),
    [anon_sym_LT] = ACTIONS(4412),
    [anon_sym_GT] = ACTIONS(4412),
    [anon_sym_GT_GT] = ACTIONS(4412),
    [anon_sym_AMP_GT] = ACTIONS(4412),
    [anon_sym_AMP_GT_GT] = ACTIONS(4412),
    [anon_sym_LT_AMP] = ACTIONS(4412),
    [anon_sym_GT_AMP] = ACTIONS(4412),
    [anon_sym_LT_LT] = ACTIONS(4412),
    [anon_sym_LT_LT_DASH] = ACTIONS(4412),
    [anon_sym_LT_LT_LT] = ACTIONS(4412),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(4412),
    [anon_sym_LF] = ACTIONS(4412),
    [anon_sym_AMP] = ACTIONS(4412),
  },
  [2453] = {
    [sym__heredoc_middle] = ACTIONS(3657),
    [sym__heredoc_end] = ACTIONS(3657),
    [anon_sym_DOLLAR] = ACTIONS(4331),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3657),
    [sym_comment] = ACTIONS(52),
  },
  [2454] = {
    [sym__heredoc_middle] = ACTIONS(3663),
    [sym__heredoc_end] = ACTIONS(3663),
    [anon_sym_DOLLAR] = ACTIONS(4333),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3663),
    [sym_comment] = ACTIONS(52),
  },
  [2455] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5222),
    [sym_comment] = ACTIONS(52),
  },
  [2456] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5224),
    [sym_comment] = ACTIONS(52),
  },
  [2457] = {
    [anon_sym_RBRACE] = ACTIONS(5224),
    [sym_comment] = ACTIONS(52),
  },
  [2458] = {
    [sym__heredoc_middle] = ACTIONS(3712),
    [sym__heredoc_end] = ACTIONS(3712),
    [anon_sym_DOLLAR] = ACTIONS(4339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3712),
    [sym_comment] = ACTIONS(52),
  },
  [2459] = {
    [sym__heredoc_middle] = ACTIONS(3716),
    [sym__heredoc_end] = ACTIONS(3716),
    [anon_sym_DOLLAR] = ACTIONS(4341),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3716),
    [sym_comment] = ACTIONS(52),
  },
  [2460] = {
    [sym__concat] = ACTIONS(4406),
    [anon_sym_RPAREN] = ACTIONS(4406),
    [sym__special_characters] = ACTIONS(4845),
    [anon_sym_DQUOTE] = ACTIONS(4406),
    [sym_raw_string] = ACTIONS(4406),
    [anon_sym_DOLLAR] = ACTIONS(4845),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4406),
    [anon_sym_BQUOTE] = ACTIONS(4406),
    [anon_sym_LT_LPAREN] = ACTIONS(4406),
    [anon_sym_GT_LPAREN] = ACTIONS(4406),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4845),
  },
  [2461] = {
    [sym__concat] = ACTIONS(4410),
    [anon_sym_RPAREN] = ACTIONS(4410),
    [sym__special_characters] = ACTIONS(4847),
    [anon_sym_DQUOTE] = ACTIONS(4410),
    [sym_raw_string] = ACTIONS(4410),
    [anon_sym_DOLLAR] = ACTIONS(4847),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4410),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4410),
    [anon_sym_BQUOTE] = ACTIONS(4410),
    [anon_sym_LT_LPAREN] = ACTIONS(4410),
    [anon_sym_GT_LPAREN] = ACTIONS(4410),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4847),
  },
  [2462] = {
    [sym__concat] = ACTIONS(4406),
    [anon_sym_SEMI_SEMI] = ACTIONS(4408),
    [sym__special_characters] = ACTIONS(4408),
    [anon_sym_DQUOTE] = ACTIONS(4408),
    [sym_raw_string] = ACTIONS(4408),
    [anon_sym_DOLLAR] = ACTIONS(4408),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4408),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4408),
    [anon_sym_BQUOTE] = ACTIONS(4408),
    [anon_sym_LT_LPAREN] = ACTIONS(4408),
    [anon_sym_GT_LPAREN] = ACTIONS(4408),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(4408),
    [anon_sym_SEMI] = ACTIONS(4408),
    [anon_sym_LF] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4408),
  },
  [2463] = {
    [sym__concat] = ACTIONS(4410),
    [anon_sym_SEMI_SEMI] = ACTIONS(4412),
    [sym__special_characters] = ACTIONS(4412),
    [anon_sym_DQUOTE] = ACTIONS(4412),
    [sym_raw_string] = ACTIONS(4412),
    [anon_sym_DOLLAR] = ACTIONS(4412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4412),
    [anon_sym_BQUOTE] = ACTIONS(4412),
    [anon_sym_LT_LPAREN] = ACTIONS(4412),
    [anon_sym_GT_LPAREN] = ACTIONS(4412),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(4412),
    [anon_sym_SEMI] = ACTIONS(4412),
    [anon_sym_LF] = ACTIONS(4412),
    [anon_sym_AMP] = ACTIONS(4412),
  },
  [2464] = {
    [anon_sym_esac] = ACTIONS(5226),
    [sym__special_characters] = ACTIONS(5228),
    [anon_sym_DQUOTE] = ACTIONS(5230),
    [sym_raw_string] = ACTIONS(5230),
    [anon_sym_DOLLAR] = ACTIONS(5228),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5230),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5230),
    [anon_sym_BQUOTE] = ACTIONS(5230),
    [anon_sym_LT_LPAREN] = ACTIONS(5230),
    [anon_sym_GT_LPAREN] = ACTIONS(5230),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(5232),
  },
  [2465] = {
    [anon_sym_esac] = ACTIONS(5234),
    [sym__special_characters] = ACTIONS(5236),
    [anon_sym_DQUOTE] = ACTIONS(5238),
    [sym_raw_string] = ACTIONS(5238),
    [anon_sym_DOLLAR] = ACTIONS(5236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5238),
    [anon_sym_BQUOTE] = ACTIONS(5238),
    [anon_sym_LT_LPAREN] = ACTIONS(5238),
    [anon_sym_GT_LPAREN] = ACTIONS(5238),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(5240),
  },
  [2466] = {
    [sym__concat] = ACTIONS(3657),
    [anon_sym_PIPE] = ACTIONS(3657),
    [anon_sym_RPAREN] = ACTIONS(3657),
    [sym_comment] = ACTIONS(52),
  },
  [2467] = {
    [sym__concat] = ACTIONS(3663),
    [anon_sym_PIPE] = ACTIONS(3663),
    [anon_sym_RPAREN] = ACTIONS(3663),
    [sym_comment] = ACTIONS(52),
  },
  [2468] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5242),
    [sym_comment] = ACTIONS(52),
  },
  [2469] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5244),
    [sym_comment] = ACTIONS(52),
  },
  [2470] = {
    [anon_sym_RBRACE] = ACTIONS(5244),
    [sym_comment] = ACTIONS(52),
  },
  [2471] = {
    [sym__concat] = ACTIONS(3712),
    [anon_sym_PIPE] = ACTIONS(3712),
    [anon_sym_RPAREN] = ACTIONS(3712),
    [sym_comment] = ACTIONS(52),
  },
  [2472] = {
    [sym__concat] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_RPAREN] = ACTIONS(3716),
    [sym_comment] = ACTIONS(52),
  },
  [2473] = {
    [sym__special_characters] = ACTIONS(4710),
    [anon_sym_DQUOTE] = ACTIONS(4712),
    [sym_raw_string] = ACTIONS(4712),
    [anon_sym_DOLLAR] = ACTIONS(4710),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4712),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4712),
    [anon_sym_BQUOTE] = ACTIONS(4712),
    [anon_sym_LT_LPAREN] = ACTIONS(4712),
    [anon_sym_GT_LPAREN] = ACTIONS(4712),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4710),
  },
  [2474] = {
    [sym__terminated_statement] = STATE(24),
    [sym_for_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_case_statement] = STATE(25),
    [sym_function_definition] = STATE(25),
    [sym_subshell] = STATE(25),
    [sym_pipeline] = STATE(25),
    [sym_list] = STATE(25),
    [sym_bracket_command] = STATE(25),
    [sym_command] = STATE(25),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(27),
    [sym_declaration_command] = STATE(25),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(2544),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_SEMI_SEMI] = ACTIONS(5246),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [2475] = {
    [sym__terminated_statement] = STATE(24),
    [sym_for_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_case_statement] = STATE(25),
    [sym_function_definition] = STATE(25),
    [sym_subshell] = STATE(25),
    [sym_pipeline] = STATE(25),
    [sym_list] = STATE(25),
    [sym_bracket_command] = STATE(25),
    [sym_command] = STATE(25),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(27),
    [sym_declaration_command] = STATE(25),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(2545),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_SEMI_SEMI] = ACTIONS(5246),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [2476] = {
    [sym__special_characters] = ACTIONS(4728),
    [anon_sym_DQUOTE] = ACTIONS(4730),
    [sym_raw_string] = ACTIONS(4730),
    [anon_sym_DOLLAR] = ACTIONS(4728),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4730),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4730),
    [anon_sym_BQUOTE] = ACTIONS(4730),
    [anon_sym_LT_LPAREN] = ACTIONS(4730),
    [anon_sym_GT_LPAREN] = ACTIONS(4730),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4728),
  },
  [2477] = {
    [sym__terminated_statement] = STATE(24),
    [sym_for_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_case_statement] = STATE(25),
    [sym_function_definition] = STATE(25),
    [sym_subshell] = STATE(25),
    [sym_pipeline] = STATE(25),
    [sym_list] = STATE(25),
    [sym_bracket_command] = STATE(25),
    [sym_command] = STATE(25),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(27),
    [sym_declaration_command] = STATE(25),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(2544),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_SEMI_SEMI] = ACTIONS(5248),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [2478] = {
    [sym__terminated_statement] = STATE(24),
    [sym_for_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_case_statement] = STATE(25),
    [sym_function_definition] = STATE(25),
    [sym_subshell] = STATE(25),
    [sym_pipeline] = STATE(25),
    [sym_list] = STATE(25),
    [sym_bracket_command] = STATE(25),
    [sym_command] = STATE(25),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(27),
    [sym_declaration_command] = STATE(25),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(2547),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_SEMI_SEMI] = ACTIONS(5248),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [2479] = {
    [sym__concat] = ACTIONS(3657),
    [anon_sym_PIPE] = ACTIONS(3659),
    [anon_sym_SEMI_SEMI] = ACTIONS(3659),
    [anon_sym_PIPE_AMP] = ACTIONS(3659),
    [anon_sym_AMP_AMP] = ACTIONS(3659),
    [anon_sym_PIPE_PIPE] = ACTIONS(3659),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3659),
    [anon_sym_LF] = ACTIONS(3659),
    [anon_sym_AMP] = ACTIONS(3659),
  },
  [2480] = {
    [sym__concat] = ACTIONS(3663),
    [anon_sym_PIPE] = ACTIONS(3665),
    [anon_sym_SEMI_SEMI] = ACTIONS(3665),
    [anon_sym_PIPE_AMP] = ACTIONS(3665),
    [anon_sym_AMP_AMP] = ACTIONS(3665),
    [anon_sym_PIPE_PIPE] = ACTIONS(3665),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3665),
    [anon_sym_LF] = ACTIONS(3665),
    [anon_sym_AMP] = ACTIONS(3665),
  },
  [2481] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5250),
    [sym_comment] = ACTIONS(52),
  },
  [2482] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5252),
    [sym_comment] = ACTIONS(52),
  },
  [2483] = {
    [anon_sym_RBRACE] = ACTIONS(5252),
    [sym_comment] = ACTIONS(52),
  },
  [2484] = {
    [sym__concat] = ACTIONS(3712),
    [anon_sym_PIPE] = ACTIONS(3714),
    [anon_sym_SEMI_SEMI] = ACTIONS(3714),
    [anon_sym_PIPE_AMP] = ACTIONS(3714),
    [anon_sym_AMP_AMP] = ACTIONS(3714),
    [anon_sym_PIPE_PIPE] = ACTIONS(3714),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3714),
    [anon_sym_LF] = ACTIONS(3714),
    [anon_sym_AMP] = ACTIONS(3714),
  },
  [2485] = {
    [sym__concat] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3718),
    [anon_sym_SEMI_SEMI] = ACTIONS(3718),
    [anon_sym_PIPE_AMP] = ACTIONS(3718),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3718),
    [anon_sym_LF] = ACTIONS(3718),
    [anon_sym_AMP] = ACTIONS(3718),
  },
  [2486] = {
    [sym_file_descriptor] = ACTIONS(4406),
    [sym__concat] = ACTIONS(4406),
    [sym_variable_name] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_RPAREN] = ACTIONS(4408),
    [anon_sym_SEMI_SEMI] = ACTIONS(4408),
    [anon_sym_PIPE_AMP] = ACTIONS(4408),
    [anon_sym_AMP_AMP] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4408),
    [anon_sym_LT] = ACTIONS(4408),
    [anon_sym_GT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_AMP_GT] = ACTIONS(4408),
    [anon_sym_AMP_GT_GT] = ACTIONS(4408),
    [anon_sym_LT_AMP] = ACTIONS(4408),
    [anon_sym_GT_AMP] = ACTIONS(4408),
    [sym__special_characters] = ACTIONS(4408),
    [anon_sym_DQUOTE] = ACTIONS(4408),
    [sym_raw_string] = ACTIONS(4408),
    [anon_sym_DOLLAR] = ACTIONS(4408),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4408),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4408),
    [anon_sym_BQUOTE] = ACTIONS(4408),
    [anon_sym_LT_LPAREN] = ACTIONS(4408),
    [anon_sym_GT_LPAREN] = ACTIONS(4408),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(4408),
    [anon_sym_SEMI] = ACTIONS(4408),
    [anon_sym_LF] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4408),
  },
  [2487] = {
    [sym_file_descriptor] = ACTIONS(4410),
    [sym__concat] = ACTIONS(4410),
    [sym_variable_name] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4412),
    [anon_sym_RPAREN] = ACTIONS(4412),
    [anon_sym_SEMI_SEMI] = ACTIONS(4412),
    [anon_sym_PIPE_AMP] = ACTIONS(4412),
    [anon_sym_AMP_AMP] = ACTIONS(4412),
    [anon_sym_PIPE_PIPE] = ACTIONS(4412),
    [anon_sym_LT] = ACTIONS(4412),
    [anon_sym_GT] = ACTIONS(4412),
    [anon_sym_GT_GT] = ACTIONS(4412),
    [anon_sym_AMP_GT] = ACTIONS(4412),
    [anon_sym_AMP_GT_GT] = ACTIONS(4412),
    [anon_sym_LT_AMP] = ACTIONS(4412),
    [anon_sym_GT_AMP] = ACTIONS(4412),
    [sym__special_characters] = ACTIONS(4412),
    [anon_sym_DQUOTE] = ACTIONS(4412),
    [sym_raw_string] = ACTIONS(4412),
    [anon_sym_DOLLAR] = ACTIONS(4412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4412),
    [anon_sym_BQUOTE] = ACTIONS(4412),
    [anon_sym_LT_LPAREN] = ACTIONS(4412),
    [anon_sym_GT_LPAREN] = ACTIONS(4412),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(4412),
    [anon_sym_SEMI] = ACTIONS(4412),
    [anon_sym_LF] = ACTIONS(4412),
    [anon_sym_AMP] = ACTIONS(4412),
  },
  [2488] = {
    [sym__concat] = ACTIONS(2560),
    [anon_sym_PIPE] = ACTIONS(2562),
    [anon_sym_RPAREN] = ACTIONS(2562),
    [anon_sym_SEMI_SEMI] = ACTIONS(2562),
    [anon_sym_PIPE_AMP] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_PIPE_PIPE] = ACTIONS(2562),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym_LF] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(2562),
  },
  [2489] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5254),
    [sym_comment] = ACTIONS(52),
  },
  [2490] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5256),
    [sym_comment] = ACTIONS(52),
  },
  [2491] = {
    [anon_sym_RBRACE] = ACTIONS(5256),
    [sym_comment] = ACTIONS(52),
  },
  [2492] = {
    [sym__concat] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2616),
    [anon_sym_RPAREN] = ACTIONS(2616),
    [anon_sym_SEMI_SEMI] = ACTIONS(2616),
    [anon_sym_PIPE_AMP] = ACTIONS(2616),
    [anon_sym_AMP_AMP] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2616),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2616),
    [anon_sym_LF] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2616),
  },
  [2493] = {
    [sym_concatenation] = STATE(2554),
    [sym_string] = STATE(2553),
    [sym_simple_expansion] = STATE(2553),
    [sym_expansion] = STATE(2553),
    [sym_command_substitution] = STATE(2553),
    [sym_process_substitution] = STATE(2553),
    [anon_sym_RBRACE] = ACTIONS(5256),
    [sym__special_characters] = ACTIONS(5258),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(5260),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(5262),
  },
  [2494] = {
    [sym__concat] = ACTIONS(2659),
    [anon_sym_PIPE] = ACTIONS(2661),
    [anon_sym_RPAREN] = ACTIONS(2661),
    [anon_sym_SEMI_SEMI] = ACTIONS(2661),
    [anon_sym_PIPE_AMP] = ACTIONS(2661),
    [anon_sym_AMP_AMP] = ACTIONS(2661),
    [anon_sym_PIPE_PIPE] = ACTIONS(2661),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2661),
    [anon_sym_LF] = ACTIONS(2661),
    [anon_sym_AMP] = ACTIONS(2661),
  },
  [2495] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(5264),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2496] = {
    [sym__concat] = ACTIONS(2665),
    [anon_sym_PIPE] = ACTIONS(2667),
    [anon_sym_RPAREN] = ACTIONS(2667),
    [anon_sym_SEMI_SEMI] = ACTIONS(2667),
    [anon_sym_PIPE_AMP] = ACTIONS(2667),
    [anon_sym_AMP_AMP] = ACTIONS(2667),
    [anon_sym_PIPE_PIPE] = ACTIONS(2667),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym_LF] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(2667),
  },
  [2497] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(5266),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2498] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(5256),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2499] = {
    [sym__concat] = ACTIONS(2671),
    [anon_sym_PIPE] = ACTIONS(2673),
    [anon_sym_RPAREN] = ACTIONS(2673),
    [anon_sym_SEMI_SEMI] = ACTIONS(2673),
    [anon_sym_PIPE_AMP] = ACTIONS(2673),
    [anon_sym_AMP_AMP] = ACTIONS(2673),
    [anon_sym_PIPE_PIPE] = ACTIONS(2673),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(2673),
    [anon_sym_LF] = ACTIONS(2673),
    [anon_sym_AMP] = ACTIONS(2673),
  },
  [2500] = {
    [sym_file_descriptor] = ACTIONS(4406),
    [sym__concat] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_RPAREN] = ACTIONS(4408),
    [anon_sym_SEMI_SEMI] = ACTIONS(4408),
    [anon_sym_PIPE_AMP] = ACTIONS(4408),
    [anon_sym_AMP_AMP] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4408),
    [anon_sym_LT] = ACTIONS(4408),
    [anon_sym_GT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_AMP_GT] = ACTIONS(4408),
    [anon_sym_AMP_GT_GT] = ACTIONS(4408),
    [anon_sym_LT_AMP] = ACTIONS(4408),
    [anon_sym_GT_AMP] = ACTIONS(4408),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_LT_LT_DASH] = ACTIONS(4408),
    [anon_sym_LT_LT_LT] = ACTIONS(4408),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(4408),
    [anon_sym_LF] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4408),
  },
  [2501] = {
    [sym_file_descriptor] = ACTIONS(4410),
    [sym__concat] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4412),
    [anon_sym_RPAREN] = ACTIONS(4412),
    [anon_sym_SEMI_SEMI] = ACTIONS(4412),
    [anon_sym_PIPE_AMP] = ACTIONS(4412),
    [anon_sym_AMP_AMP] = ACTIONS(4412),
    [anon_sym_PIPE_PIPE] = ACTIONS(4412),
    [anon_sym_LT] = ACTIONS(4412),
    [anon_sym_GT] = ACTIONS(4412),
    [anon_sym_GT_GT] = ACTIONS(4412),
    [anon_sym_AMP_GT] = ACTIONS(4412),
    [anon_sym_AMP_GT_GT] = ACTIONS(4412),
    [anon_sym_LT_AMP] = ACTIONS(4412),
    [anon_sym_GT_AMP] = ACTIONS(4412),
    [anon_sym_LT_LT] = ACTIONS(4412),
    [anon_sym_LT_LT_DASH] = ACTIONS(4412),
    [anon_sym_LT_LT_LT] = ACTIONS(4412),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(4412),
    [anon_sym_LF] = ACTIONS(4412),
    [anon_sym_AMP] = ACTIONS(4412),
  },
  [2502] = {
    [sym__concat] = ACTIONS(4406),
    [anon_sym_RBRACE] = ACTIONS(4406),
    [sym_comment] = ACTIONS(52),
  },
  [2503] = {
    [sym__concat] = ACTIONS(4410),
    [anon_sym_RBRACE] = ACTIONS(4410),
    [sym_comment] = ACTIONS(52),
  },
  [2504] = {
    [sym_file_descriptor] = ACTIONS(4406),
    [sym__concat] = ACTIONS(4406),
    [sym_variable_name] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4845),
    [anon_sym_RPAREN] = ACTIONS(4406),
    [anon_sym_PIPE_AMP] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_LT] = ACTIONS(4845),
    [anon_sym_GT] = ACTIONS(4845),
    [anon_sym_GT_GT] = ACTIONS(4406),
    [anon_sym_AMP_GT] = ACTIONS(4845),
    [anon_sym_AMP_GT_GT] = ACTIONS(4406),
    [anon_sym_LT_AMP] = ACTIONS(4406),
    [anon_sym_GT_AMP] = ACTIONS(4406),
    [sym__special_characters] = ACTIONS(4845),
    [anon_sym_DQUOTE] = ACTIONS(4406),
    [sym_raw_string] = ACTIONS(4406),
    [anon_sym_DOLLAR] = ACTIONS(4845),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4406),
    [anon_sym_BQUOTE] = ACTIONS(4406),
    [anon_sym_LT_LPAREN] = ACTIONS(4406),
    [anon_sym_GT_LPAREN] = ACTIONS(4406),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4845),
  },
  [2505] = {
    [sym_file_descriptor] = ACTIONS(4410),
    [sym__concat] = ACTIONS(4410),
    [sym_variable_name] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4847),
    [anon_sym_RPAREN] = ACTIONS(4410),
    [anon_sym_PIPE_AMP] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [anon_sym_LT] = ACTIONS(4847),
    [anon_sym_GT] = ACTIONS(4847),
    [anon_sym_GT_GT] = ACTIONS(4410),
    [anon_sym_AMP_GT] = ACTIONS(4847),
    [anon_sym_AMP_GT_GT] = ACTIONS(4410),
    [anon_sym_LT_AMP] = ACTIONS(4410),
    [anon_sym_GT_AMP] = ACTIONS(4410),
    [sym__special_characters] = ACTIONS(4847),
    [anon_sym_DQUOTE] = ACTIONS(4410),
    [sym_raw_string] = ACTIONS(4410),
    [anon_sym_DOLLAR] = ACTIONS(4847),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4410),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4410),
    [anon_sym_BQUOTE] = ACTIONS(4410),
    [anon_sym_LT_LPAREN] = ACTIONS(4410),
    [anon_sym_GT_LPAREN] = ACTIONS(4410),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4847),
  },
  [2506] = {
    [anon_sym_PIPE] = ACTIONS(4439),
    [anon_sym_RPAREN] = ACTIONS(3331),
    [anon_sym_PIPE_AMP] = ACTIONS(3331),
    [anon_sym_AMP_AMP] = ACTIONS(3331),
    [anon_sym_PIPE_PIPE] = ACTIONS(3331),
    [anon_sym_BQUOTE] = ACTIONS(3331),
    [sym_comment] = ACTIONS(52),
  },
  [2507] = {
    [anon_sym_PIPE] = ACTIONS(5268),
    [anon_sym_RPAREN] = ACTIONS(5270),
    [anon_sym_PIPE_AMP] = ACTIONS(5270),
    [anon_sym_AMP_AMP] = ACTIONS(5270),
    [anon_sym_PIPE_PIPE] = ACTIONS(5270),
    [anon_sym_BQUOTE] = ACTIONS(5270),
    [sym_comment] = ACTIONS(52),
  },
  [2508] = {
    [anon_sym_PIPE] = ACTIONS(5272),
    [anon_sym_RPAREN] = ACTIONS(5274),
    [anon_sym_PIPE_AMP] = ACTIONS(5274),
    [anon_sym_AMP_AMP] = ACTIONS(5274),
    [anon_sym_PIPE_PIPE] = ACTIONS(5274),
    [anon_sym_BQUOTE] = ACTIONS(5274),
    [sym_comment] = ACTIONS(52),
  },
  [2509] = {
    [sym__concat] = ACTIONS(2560),
    [anon_sym_PIPE] = ACTIONS(3553),
    [anon_sym_RPAREN] = ACTIONS(2560),
    [anon_sym_PIPE_AMP] = ACTIONS(2560),
    [anon_sym_AMP_AMP] = ACTIONS(2560),
    [anon_sym_PIPE_PIPE] = ACTIONS(2560),
    [sym_comment] = ACTIONS(52),
  },
  [2510] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5276),
    [sym_comment] = ACTIONS(52),
  },
  [2511] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5278),
    [sym_comment] = ACTIONS(52),
  },
  [2512] = {
    [anon_sym_RBRACE] = ACTIONS(5278),
    [sym_comment] = ACTIONS(52),
  },
  [2513] = {
    [sym__concat] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(3559),
    [anon_sym_RPAREN] = ACTIONS(2614),
    [anon_sym_PIPE_AMP] = ACTIONS(2614),
    [anon_sym_AMP_AMP] = ACTIONS(2614),
    [anon_sym_PIPE_PIPE] = ACTIONS(2614),
    [sym_comment] = ACTIONS(52),
  },
  [2514] = {
    [sym_concatenation] = STATE(2561),
    [sym_string] = STATE(2560),
    [sym_simple_expansion] = STATE(2560),
    [sym_expansion] = STATE(2560),
    [sym_command_substitution] = STATE(2560),
    [sym_process_substitution] = STATE(2560),
    [anon_sym_RBRACE] = ACTIONS(5278),
    [sym__special_characters] = ACTIONS(5280),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(5282),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(5284),
  },
  [2515] = {
    [sym__concat] = ACTIONS(2659),
    [anon_sym_PIPE] = ACTIONS(3567),
    [anon_sym_RPAREN] = ACTIONS(2659),
    [anon_sym_PIPE_AMP] = ACTIONS(2659),
    [anon_sym_AMP_AMP] = ACTIONS(2659),
    [anon_sym_PIPE_PIPE] = ACTIONS(2659),
    [sym_comment] = ACTIONS(52),
  },
  [2516] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(5286),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2517] = {
    [sym__concat] = ACTIONS(2665),
    [anon_sym_PIPE] = ACTIONS(3571),
    [anon_sym_RPAREN] = ACTIONS(2665),
    [anon_sym_PIPE_AMP] = ACTIONS(2665),
    [anon_sym_AMP_AMP] = ACTIONS(2665),
    [anon_sym_PIPE_PIPE] = ACTIONS(2665),
    [sym_comment] = ACTIONS(52),
  },
  [2518] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(5288),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2519] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(5278),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2520] = {
    [sym__concat] = ACTIONS(2671),
    [anon_sym_PIPE] = ACTIONS(3575),
    [anon_sym_RPAREN] = ACTIONS(2671),
    [anon_sym_PIPE_AMP] = ACTIONS(2671),
    [anon_sym_AMP_AMP] = ACTIONS(2671),
    [anon_sym_PIPE_PIPE] = ACTIONS(2671),
    [sym_comment] = ACTIONS(52),
  },
  [2521] = {
    [sym_file_descriptor] = ACTIONS(4406),
    [sym__concat] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4845),
    [anon_sym_RPAREN] = ACTIONS(4406),
    [anon_sym_PIPE_AMP] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_LT] = ACTIONS(4845),
    [anon_sym_GT] = ACTIONS(4845),
    [anon_sym_GT_GT] = ACTIONS(4406),
    [anon_sym_AMP_GT] = ACTIONS(4845),
    [anon_sym_AMP_GT_GT] = ACTIONS(4406),
    [anon_sym_LT_AMP] = ACTIONS(4406),
    [anon_sym_GT_AMP] = ACTIONS(4406),
    [anon_sym_LT_LT] = ACTIONS(4845),
    [anon_sym_LT_LT_DASH] = ACTIONS(4406),
    [anon_sym_LT_LT_LT] = ACTIONS(4406),
    [sym_comment] = ACTIONS(52),
  },
  [2522] = {
    [sym_file_descriptor] = ACTIONS(4410),
    [sym__concat] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4847),
    [anon_sym_RPAREN] = ACTIONS(4410),
    [anon_sym_PIPE_AMP] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [anon_sym_LT] = ACTIONS(4847),
    [anon_sym_GT] = ACTIONS(4847),
    [anon_sym_GT_GT] = ACTIONS(4410),
    [anon_sym_AMP_GT] = ACTIONS(4847),
    [anon_sym_AMP_GT_GT] = ACTIONS(4410),
    [anon_sym_LT_AMP] = ACTIONS(4410),
    [anon_sym_GT_AMP] = ACTIONS(4410),
    [anon_sym_LT_LT] = ACTIONS(4847),
    [anon_sym_LT_LT_DASH] = ACTIONS(4410),
    [anon_sym_LT_LT_LT] = ACTIONS(4410),
    [sym_comment] = ACTIONS(52),
  },
  [2523] = {
    [sym_file_descriptor] = ACTIONS(4406),
    [sym__concat] = ACTIONS(4406),
    [sym_variable_name] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4845),
    [anon_sym_PIPE_AMP] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_LT] = ACTIONS(4845),
    [anon_sym_GT] = ACTIONS(4845),
    [anon_sym_GT_GT] = ACTIONS(4406),
    [anon_sym_AMP_GT] = ACTIONS(4845),
    [anon_sym_AMP_GT_GT] = ACTIONS(4406),
    [anon_sym_LT_AMP] = ACTIONS(4406),
    [anon_sym_GT_AMP] = ACTIONS(4406),
    [sym__special_characters] = ACTIONS(4845),
    [anon_sym_DQUOTE] = ACTIONS(4406),
    [sym_raw_string] = ACTIONS(4406),
    [anon_sym_DOLLAR] = ACTIONS(4845),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4406),
    [anon_sym_BQUOTE] = ACTIONS(4406),
    [anon_sym_LT_LPAREN] = ACTIONS(4406),
    [anon_sym_GT_LPAREN] = ACTIONS(4406),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4845),
  },
  [2524] = {
    [sym_file_descriptor] = ACTIONS(4410),
    [sym__concat] = ACTIONS(4410),
    [sym_variable_name] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4847),
    [anon_sym_PIPE_AMP] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [anon_sym_LT] = ACTIONS(4847),
    [anon_sym_GT] = ACTIONS(4847),
    [anon_sym_GT_GT] = ACTIONS(4410),
    [anon_sym_AMP_GT] = ACTIONS(4847),
    [anon_sym_AMP_GT_GT] = ACTIONS(4410),
    [anon_sym_LT_AMP] = ACTIONS(4410),
    [anon_sym_GT_AMP] = ACTIONS(4410),
    [sym__special_characters] = ACTIONS(4847),
    [anon_sym_DQUOTE] = ACTIONS(4410),
    [sym_raw_string] = ACTIONS(4410),
    [anon_sym_DOLLAR] = ACTIONS(4847),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4410),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4410),
    [anon_sym_BQUOTE] = ACTIONS(4410),
    [anon_sym_LT_LPAREN] = ACTIONS(4410),
    [anon_sym_GT_LPAREN] = ACTIONS(4410),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(4847),
  },
  [2525] = {
    [sym__concat] = ACTIONS(2560),
    [anon_sym_PIPE] = ACTIONS(3553),
    [anon_sym_PIPE_AMP] = ACTIONS(2560),
    [anon_sym_AMP_AMP] = ACTIONS(2560),
    [anon_sym_PIPE_PIPE] = ACTIONS(2560),
    [anon_sym_BQUOTE] = ACTIONS(2560),
    [sym_comment] = ACTIONS(52),
  },
  [2526] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5290),
    [sym_comment] = ACTIONS(52),
  },
  [2527] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5292),
    [sym_comment] = ACTIONS(52),
  },
  [2528] = {
    [anon_sym_RBRACE] = ACTIONS(5292),
    [sym_comment] = ACTIONS(52),
  },
  [2529] = {
    [sym__concat] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(3559),
    [anon_sym_PIPE_AMP] = ACTIONS(2614),
    [anon_sym_AMP_AMP] = ACTIONS(2614),
    [anon_sym_PIPE_PIPE] = ACTIONS(2614),
    [anon_sym_BQUOTE] = ACTIONS(2614),
    [sym_comment] = ACTIONS(52),
  },
  [2530] = {
    [sym_concatenation] = STATE(2568),
    [sym_string] = STATE(2567),
    [sym_simple_expansion] = STATE(2567),
    [sym_expansion] = STATE(2567),
    [sym_command_substitution] = STATE(2567),
    [sym_process_substitution] = STATE(2567),
    [anon_sym_RBRACE] = ACTIONS(5292),
    [sym__special_characters] = ACTIONS(5294),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [sym_raw_string] = ACTIONS(5296),
    [anon_sym_DOLLAR] = ACTIONS(1586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(5298),
  },
  [2531] = {
    [sym__concat] = ACTIONS(2659),
    [anon_sym_PIPE] = ACTIONS(3567),
    [anon_sym_PIPE_AMP] = ACTIONS(2659),
    [anon_sym_AMP_AMP] = ACTIONS(2659),
    [anon_sym_PIPE_PIPE] = ACTIONS(2659),
    [anon_sym_BQUOTE] = ACTIONS(2659),
    [sym_comment] = ACTIONS(52),
  },
  [2532] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(5300),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2533] = {
    [sym__concat] = ACTIONS(2665),
    [anon_sym_PIPE] = ACTIONS(3571),
    [anon_sym_PIPE_AMP] = ACTIONS(2665),
    [anon_sym_AMP_AMP] = ACTIONS(2665),
    [anon_sym_PIPE_PIPE] = ACTIONS(2665),
    [anon_sym_BQUOTE] = ACTIONS(2665),
    [sym_comment] = ACTIONS(52),
  },
  [2534] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(5302),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2535] = {
    [sym_concatenation] = STATE(393),
    [sym_string] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(5292),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(702),
    [sym_raw_string] = ACTIONS(704),
    [anon_sym_DOLLAR] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LT_LPAREN] = ACTIONS(716),
    [anon_sym_GT_LPAREN] = ACTIONS(716),
    [sym_comment] = ACTIONS(168),
    [sym_word] = ACTIONS(718),
  },
  [2536] = {
    [sym__concat] = ACTIONS(2671),
    [anon_sym_PIPE] = ACTIONS(3575),
    [anon_sym_PIPE_AMP] = ACTIONS(2671),
    [anon_sym_AMP_AMP] = ACTIONS(2671),
    [anon_sym_PIPE_PIPE] = ACTIONS(2671),
    [anon_sym_BQUOTE] = ACTIONS(2671),
    [sym_comment] = ACTIONS(52),
  },
  [2537] = {
    [sym_file_descriptor] = ACTIONS(4406),
    [sym__concat] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4845),
    [anon_sym_PIPE_AMP] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_LT] = ACTIONS(4845),
    [anon_sym_GT] = ACTIONS(4845),
    [anon_sym_GT_GT] = ACTIONS(4406),
    [anon_sym_AMP_GT] = ACTIONS(4845),
    [anon_sym_AMP_GT_GT] = ACTIONS(4406),
    [anon_sym_LT_AMP] = ACTIONS(4406),
    [anon_sym_GT_AMP] = ACTIONS(4406),
    [anon_sym_LT_LT] = ACTIONS(4845),
    [anon_sym_LT_LT_DASH] = ACTIONS(4406),
    [anon_sym_LT_LT_LT] = ACTIONS(4406),
    [anon_sym_BQUOTE] = ACTIONS(4406),
    [sym_comment] = ACTIONS(52),
  },
  [2538] = {
    [sym_file_descriptor] = ACTIONS(4410),
    [sym__concat] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4847),
    [anon_sym_PIPE_AMP] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [anon_sym_LT] = ACTIONS(4847),
    [anon_sym_GT] = ACTIONS(4847),
    [anon_sym_GT_GT] = ACTIONS(4410),
    [anon_sym_AMP_GT] = ACTIONS(4847),
    [anon_sym_AMP_GT_GT] = ACTIONS(4410),
    [anon_sym_LT_AMP] = ACTIONS(4410),
    [anon_sym_GT_AMP] = ACTIONS(4410),
    [anon_sym_LT_LT] = ACTIONS(4847),
    [anon_sym_LT_LT_DASH] = ACTIONS(4410),
    [anon_sym_LT_LT_LT] = ACTIONS(4410),
    [anon_sym_BQUOTE] = ACTIONS(4410),
    [sym_comment] = ACTIONS(52),
  },
  [2539] = {
    [sym__heredoc_middle] = ACTIONS(4406),
    [sym__heredoc_end] = ACTIONS(4406),
    [anon_sym_DOLLAR] = ACTIONS(4845),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4406),
    [sym_comment] = ACTIONS(52),
  },
  [2540] = {
    [sym__heredoc_middle] = ACTIONS(4410),
    [sym__heredoc_end] = ACTIONS(4410),
    [anon_sym_DOLLAR] = ACTIONS(4847),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4410),
    [sym_comment] = ACTIONS(52),
  },
  [2541] = {
    [sym__concat] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4406),
    [anon_sym_RPAREN] = ACTIONS(4406),
    [sym_comment] = ACTIONS(52),
  },
  [2542] = {
    [sym__concat] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4410),
    [anon_sym_RPAREN] = ACTIONS(4410),
    [sym_comment] = ACTIONS(52),
  },
  [2543] = {
    [sym__special_characters] = ACTIONS(5055),
    [anon_sym_DQUOTE] = ACTIONS(5057),
    [sym_raw_string] = ACTIONS(5057),
    [anon_sym_DOLLAR] = ACTIONS(5055),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5057),
    [anon_sym_BQUOTE] = ACTIONS(5057),
    [anon_sym_LT_LPAREN] = ACTIONS(5057),
    [anon_sym_GT_LPAREN] = ACTIONS(5057),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(5055),
  },
  [2544] = {
    [sym__terminated_statement] = STATE(24),
    [sym_for_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_case_statement] = STATE(25),
    [sym_function_definition] = STATE(25),
    [sym_subshell] = STATE(25),
    [sym_pipeline] = STATE(25),
    [sym_list] = STATE(25),
    [sym_bracket_command] = STATE(25),
    [sym_command] = STATE(25),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(27),
    [sym_declaration_command] = STATE(25),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(2544),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(946),
    [sym_variable_name] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(954),
    [anon_sym_while] = ACTIONS(957),
    [anon_sym_if] = ACTIONS(960),
    [anon_sym_case] = ACTIONS(963),
    [anon_sym_SEMI_SEMI] = ACTIONS(952),
    [anon_sym_function] = ACTIONS(966),
    [anon_sym_LPAREN] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_typeset] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_local] = ACTIONS(978),
    [anon_sym_LT] = ACTIONS(981),
    [anon_sym_GT] = ACTIONS(981),
    [anon_sym_GT_GT] = ACTIONS(984),
    [anon_sym_AMP_GT] = ACTIONS(981),
    [anon_sym_AMP_GT_GT] = ACTIONS(984),
    [anon_sym_LT_AMP] = ACTIONS(984),
    [anon_sym_GT_AMP] = ACTIONS(984),
    [sym__special_characters] = ACTIONS(987),
    [anon_sym_DQUOTE] = ACTIONS(990),
    [sym_raw_string] = ACTIONS(993),
    [anon_sym_DOLLAR] = ACTIONS(996),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(999),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1002),
    [anon_sym_BQUOTE] = ACTIONS(1005),
    [anon_sym_LT_LPAREN] = ACTIONS(1008),
    [anon_sym_GT_LPAREN] = ACTIONS(1008),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(1011),
  },
  [2545] = {
    [sym__terminated_statement] = STATE(24),
    [sym_for_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_case_statement] = STATE(25),
    [sym_function_definition] = STATE(25),
    [sym_subshell] = STATE(25),
    [sym_pipeline] = STATE(25),
    [sym_list] = STATE(25),
    [sym_bracket_command] = STATE(25),
    [sym_command] = STATE(25),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(27),
    [sym_declaration_command] = STATE(25),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(2544),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_SEMI_SEMI] = ACTIONS(5304),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [2546] = {
    [sym__special_characters] = ACTIONS(5065),
    [anon_sym_DQUOTE] = ACTIONS(5067),
    [sym_raw_string] = ACTIONS(5067),
    [anon_sym_DOLLAR] = ACTIONS(5065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5067),
    [anon_sym_BQUOTE] = ACTIONS(5067),
    [anon_sym_LT_LPAREN] = ACTIONS(5067),
    [anon_sym_GT_LPAREN] = ACTIONS(5067),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(5065),
  },
  [2547] = {
    [sym__terminated_statement] = STATE(24),
    [sym_for_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_case_statement] = STATE(25),
    [sym_function_definition] = STATE(25),
    [sym_subshell] = STATE(25),
    [sym_pipeline] = STATE(25),
    [sym_list] = STATE(25),
    [sym_bracket_command] = STATE(25),
    [sym_command] = STATE(25),
    [sym_command_name] = STATE(26),
    [sym_variable_assignment] = STATE(27),
    [sym_declaration_command] = STATE(25),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(29),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(16),
    [sym_simple_expansion] = STATE(16),
    [sym_expansion] = STATE(16),
    [sym_command_substitution] = STATE(16),
    [sym_process_substitution] = STATE(16),
    [aux_sym_program_repeat1] = STATE(2544),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_SEMI_SEMI] = ACTIONS(5306),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [sym__special_characters] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(54),
  },
  [2548] = {
    [sym__concat] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_SEMI_SEMI] = ACTIONS(4408),
    [anon_sym_PIPE_AMP] = ACTIONS(4408),
    [anon_sym_AMP_AMP] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4408),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(4408),
    [anon_sym_LF] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4408),
  },
  [2549] = {
    [sym__concat] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4412),
    [anon_sym_SEMI_SEMI] = ACTIONS(4412),
    [anon_sym_PIPE_AMP] = ACTIONS(4412),
    [anon_sym_AMP_AMP] = ACTIONS(4412),
    [anon_sym_PIPE_PIPE] = ACTIONS(4412),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(4412),
    [anon_sym_LF] = ACTIONS(4412),
    [anon_sym_AMP] = ACTIONS(4412),
  },
  [2550] = {
    [sym__concat] = ACTIONS(3657),
    [anon_sym_PIPE] = ACTIONS(3659),
    [anon_sym_RPAREN] = ACTIONS(3659),
    [anon_sym_SEMI_SEMI] = ACTIONS(3659),
    [anon_sym_PIPE_AMP] = ACTIONS(3659),
    [anon_sym_AMP_AMP] = ACTIONS(3659),
    [anon_sym_PIPE_PIPE] = ACTIONS(3659),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3659),
    [anon_sym_LF] = ACTIONS(3659),
    [anon_sym_AMP] = ACTIONS(3659),
  },
  [2551] = {
    [sym__concat] = ACTIONS(3663),
    [anon_sym_PIPE] = ACTIONS(3665),
    [anon_sym_RPAREN] = ACTIONS(3665),
    [anon_sym_SEMI_SEMI] = ACTIONS(3665),
    [anon_sym_PIPE_AMP] = ACTIONS(3665),
    [anon_sym_AMP_AMP] = ACTIONS(3665),
    [anon_sym_PIPE_PIPE] = ACTIONS(3665),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3665),
    [anon_sym_LF] = ACTIONS(3665),
    [anon_sym_AMP] = ACTIONS(3665),
  },
  [2552] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5308),
    [sym_comment] = ACTIONS(52),
  },
  [2553] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5310),
    [sym_comment] = ACTIONS(52),
  },
  [2554] = {
    [anon_sym_RBRACE] = ACTIONS(5310),
    [sym_comment] = ACTIONS(52),
  },
  [2555] = {
    [sym__concat] = ACTIONS(3712),
    [anon_sym_PIPE] = ACTIONS(3714),
    [anon_sym_RPAREN] = ACTIONS(3714),
    [anon_sym_SEMI_SEMI] = ACTIONS(3714),
    [anon_sym_PIPE_AMP] = ACTIONS(3714),
    [anon_sym_AMP_AMP] = ACTIONS(3714),
    [anon_sym_PIPE_PIPE] = ACTIONS(3714),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3714),
    [anon_sym_LF] = ACTIONS(3714),
    [anon_sym_AMP] = ACTIONS(3714),
  },
  [2556] = {
    [sym__concat] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3718),
    [anon_sym_RPAREN] = ACTIONS(3718),
    [anon_sym_SEMI_SEMI] = ACTIONS(3718),
    [anon_sym_PIPE_AMP] = ACTIONS(3718),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(3718),
    [anon_sym_LF] = ACTIONS(3718),
    [anon_sym_AMP] = ACTIONS(3718),
  },
  [2557] = {
    [sym__concat] = ACTIONS(3657),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_RPAREN] = ACTIONS(3657),
    [anon_sym_PIPE_AMP] = ACTIONS(3657),
    [anon_sym_AMP_AMP] = ACTIONS(3657),
    [anon_sym_PIPE_PIPE] = ACTIONS(3657),
    [sym_comment] = ACTIONS(52),
  },
  [2558] = {
    [sym__concat] = ACTIONS(3663),
    [anon_sym_PIPE] = ACTIONS(4333),
    [anon_sym_RPAREN] = ACTIONS(3663),
    [anon_sym_PIPE_AMP] = ACTIONS(3663),
    [anon_sym_AMP_AMP] = ACTIONS(3663),
    [anon_sym_PIPE_PIPE] = ACTIONS(3663),
    [sym_comment] = ACTIONS(52),
  },
  [2559] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5312),
    [sym_comment] = ACTIONS(52),
  },
  [2560] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5314),
    [sym_comment] = ACTIONS(52),
  },
  [2561] = {
    [anon_sym_RBRACE] = ACTIONS(5314),
    [sym_comment] = ACTIONS(52),
  },
  [2562] = {
    [sym__concat] = ACTIONS(3712),
    [anon_sym_PIPE] = ACTIONS(4339),
    [anon_sym_RPAREN] = ACTIONS(3712),
    [anon_sym_PIPE_AMP] = ACTIONS(3712),
    [anon_sym_AMP_AMP] = ACTIONS(3712),
    [anon_sym_PIPE_PIPE] = ACTIONS(3712),
    [sym_comment] = ACTIONS(52),
  },
  [2563] = {
    [sym__concat] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(4341),
    [anon_sym_RPAREN] = ACTIONS(3716),
    [anon_sym_PIPE_AMP] = ACTIONS(3716),
    [anon_sym_AMP_AMP] = ACTIONS(3716),
    [anon_sym_PIPE_PIPE] = ACTIONS(3716),
    [sym_comment] = ACTIONS(52),
  },
  [2564] = {
    [sym__concat] = ACTIONS(3657),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_PIPE_AMP] = ACTIONS(3657),
    [anon_sym_AMP_AMP] = ACTIONS(3657),
    [anon_sym_PIPE_PIPE] = ACTIONS(3657),
    [anon_sym_BQUOTE] = ACTIONS(3657),
    [sym_comment] = ACTIONS(52),
  },
  [2565] = {
    [sym__concat] = ACTIONS(3663),
    [anon_sym_PIPE] = ACTIONS(4333),
    [anon_sym_PIPE_AMP] = ACTIONS(3663),
    [anon_sym_AMP_AMP] = ACTIONS(3663),
    [anon_sym_PIPE_PIPE] = ACTIONS(3663),
    [anon_sym_BQUOTE] = ACTIONS(3663),
    [sym_comment] = ACTIONS(52),
  },
  [2566] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5316),
    [sym_comment] = ACTIONS(52),
  },
  [2567] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym__concat] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(5318),
    [sym_comment] = ACTIONS(52),
  },
  [2568] = {
    [anon_sym_RBRACE] = ACTIONS(5318),
    [sym_comment] = ACTIONS(52),
  },
  [2569] = {
    [sym__concat] = ACTIONS(3712),
    [anon_sym_PIPE] = ACTIONS(4339),
    [anon_sym_PIPE_AMP] = ACTIONS(3712),
    [anon_sym_AMP_AMP] = ACTIONS(3712),
    [anon_sym_PIPE_PIPE] = ACTIONS(3712),
    [anon_sym_BQUOTE] = ACTIONS(3712),
    [sym_comment] = ACTIONS(52),
  },
  [2570] = {
    [sym__concat] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(4341),
    [anon_sym_PIPE_AMP] = ACTIONS(3716),
    [anon_sym_AMP_AMP] = ACTIONS(3716),
    [anon_sym_PIPE_PIPE] = ACTIONS(3716),
    [anon_sym_BQUOTE] = ACTIONS(3716),
    [sym_comment] = ACTIONS(52),
  },
  [2571] = {
    [sym__special_characters] = ACTIONS(5228),
    [anon_sym_DQUOTE] = ACTIONS(5230),
    [sym_raw_string] = ACTIONS(5230),
    [anon_sym_DOLLAR] = ACTIONS(5228),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5230),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5230),
    [anon_sym_BQUOTE] = ACTIONS(5230),
    [anon_sym_LT_LPAREN] = ACTIONS(5230),
    [anon_sym_GT_LPAREN] = ACTIONS(5230),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(5228),
  },
  [2572] = {
    [sym__special_characters] = ACTIONS(5236),
    [anon_sym_DQUOTE] = ACTIONS(5238),
    [sym_raw_string] = ACTIONS(5238),
    [anon_sym_DOLLAR] = ACTIONS(5236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5238),
    [anon_sym_BQUOTE] = ACTIONS(5238),
    [anon_sym_LT_LPAREN] = ACTIONS(5238),
    [anon_sym_GT_LPAREN] = ACTIONS(5238),
    [sym_comment] = ACTIONS(52),
    [sym_word] = ACTIONS(5236),
  },
  [2573] = {
    [sym__concat] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_RPAREN] = ACTIONS(4408),
    [anon_sym_SEMI_SEMI] = ACTIONS(4408),
    [anon_sym_PIPE_AMP] = ACTIONS(4408),
    [anon_sym_AMP_AMP] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4408),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(4408),
    [anon_sym_LF] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4408),
  },
  [2574] = {
    [sym__concat] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4412),
    [anon_sym_RPAREN] = ACTIONS(4412),
    [anon_sym_SEMI_SEMI] = ACTIONS(4412),
    [anon_sym_PIPE_AMP] = ACTIONS(4412),
    [anon_sym_AMP_AMP] = ACTIONS(4412),
    [anon_sym_PIPE_PIPE] = ACTIONS(4412),
    [sym_comment] = ACTIONS(168),
    [anon_sym_SEMI] = ACTIONS(4412),
    [anon_sym_LF] = ACTIONS(4412),
    [anon_sym_AMP] = ACTIONS(4412),
  },
  [2575] = {
    [sym__concat] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4845),
    [anon_sym_RPAREN] = ACTIONS(4406),
    [anon_sym_PIPE_AMP] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [sym_comment] = ACTIONS(52),
  },
  [2576] = {
    [sym__concat] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4847),
    [anon_sym_RPAREN] = ACTIONS(4410),
    [anon_sym_PIPE_AMP] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [sym_comment] = ACTIONS(52),
  },
  [2577] = {
    [sym__concat] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4845),
    [anon_sym_PIPE_AMP] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_BQUOTE] = ACTIONS(4406),
    [sym_comment] = ACTIONS(52),
  },
  [2578] = {
    [sym__concat] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4847),
    [anon_sym_PIPE_AMP] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [anon_sym_BQUOTE] = ACTIONS(4410),
    [sym_comment] = ACTIONS(52),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false, .depends_on_lookahead = false},
  [1] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(),
  [3] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, RECOVER(),
  [5] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, SHIFT_EXTRA(), RECOVER(),
  [8] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2),
  [10] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(3),
  [12] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_program, 0),
  [14] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(4),
  [16] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(5),
  [18] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(6),
  [20] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(7),
  [22] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(8),
  [24] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(9),
  [26] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(10),
  [28] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(11),
  [30] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(12),
  [32] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(13),
  [34] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(13),
  [36] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(14),
  [38] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(15),
  [40] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(16),
  [42] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(17),
  [44] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(18),
  [46] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(19),
  [48] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(20),
  [50] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(21),
  [52] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT_EXTRA(),
  [54] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(22),
  [56] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(33),
  [58] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(33),
  [60] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(34),
  [62] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(35),
  [64] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(37),
  [66] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(42),
  [68] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(43),
  [70] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(44),
  [72] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(45),
  [74] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(46),
  [76] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(47),
  [78] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(48),
  [80] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(49),
  [82] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(44),
  [84] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(51),
  [86] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(52),
  [88] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(53),
  [90] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(54),
  [92] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(55),
  [94] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(56),
  [96] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(57),
  [98] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(58),
  [100] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(59),
  [102] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(60),
  [104] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(61),
  [106] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(62),
  [108] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(63),
  [110] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(64),
  [112] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(71),
  [114] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(72),
  [116] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(73),
  [118] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(74),
  [120] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(75),
  [122] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(76),
  [124] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(77),
  [126] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(78),
  [128] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(73),
  [130] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(81),
  [132] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(82),
  [134] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(83),
  [136] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(84),
  [138] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(85),
  [140] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(86),
  [142] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(87),
  [144] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(88),
  [146] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(83),
  [148] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(91),
  [150] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_declaration_command, 1),
  [152] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(92),
  [154] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(93),
  [156] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(94),
  [158] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(95),
  [160] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(96),
  [162] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(97),
  [164] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(98),
  [166] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(99),
  [168] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT_EXTRA(),
  [170] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(100),
  [172] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(104),
  [174] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(105),
  [176] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(106),
  [178] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(107),
  [180] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(108),
  [182] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(109),
  [184] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(110),
  [186] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(111),
  [188] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(106),
  [190] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1, .alias_sequence_id = 1),
  [192] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(113),
  [194] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1, .alias_sequence_id = 1),
  [196] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(115),
  [198] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(116),
  [200] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(117),
  [202] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(118),
  [204] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(119),
  [206] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(120),
  [208] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1),
  [210] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1),
  [212] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(122),
  [214] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(123),
  [216] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(122),
  [218] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(125),
  [220] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(126),
  [222] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(127),
  [224] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(128),
  [226] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(126),
  [228] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(130),
  [230] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(131),
  [232] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(132),
  [234] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(133),
  [236] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(134),
  [238] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(135),
  [240] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(136),
  [242] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(137),
  [244] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(138),
  [246] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(139),
  [248] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(140),
  [250] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(141),
  [252] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(142),
  [254] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(143),
  [256] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(144),
  [258] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(145),
  [260] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(146),
  [262] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(147),
  [264] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(148),
  [266] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(155),
  [268] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(156),
  [270] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(157),
  [272] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(158),
  [274] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(159),
  [276] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(160),
  [278] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(161),
  [280] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(162),
  [282] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(163),
  [284] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(164),
  [286] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(165),
  [288] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(166),
  [290] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(167),
  [292] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(175),
  [294] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, ACCEPT_INPUT(),
  [296] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 1),
  [298] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 1),
  [300] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 1),
  [302] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(176),
  [304] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(177),
  [306] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(178),
  [308] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(179),
  [310] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 1),
  [312] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(180),
  [314] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(181),
  [316] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(182),
  [318] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(183),
  [320] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(15),
  [322] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(184),
  [324] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(17),
  [326] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(18),
  [328] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(19),
  [330] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(20),
  [332] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(21),
  [334] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1, .fragile = true),
  [336] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1, .fragile = true),
  [338] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat1, 1, .fragile = true),
  [340] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_program, 1),
  [342] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(190),
  [344] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(14),
  [346] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(16),
  [348] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(194),
  [350] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(195),
  [352] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(195),
  [354] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(197),
  [356] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(198),
  [358] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(199),
  [360] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(200),
  [362] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(201),
  [364] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(202),
  [366] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(203),
  [368] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(204),
  [370] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(199),
  [372] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(206),
  [374] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(207),
  [376] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(208),
  [378] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(209),
  [380] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(210),
  [382] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(211),
  [384] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(212),
  [386] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(213),
  [388] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(214),
  [390] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(215),
  [392] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(210),
  [394] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_variable_assignment, 2),
  [396] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_variable_assignment, 2),
  [398] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(216),
  [400] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(217),
  [402] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(219),
  [404] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(220),
  [406] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(221),
  [408] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(222),
  [410] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(223),
  [412] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(225),
  [414] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(227),
  [416] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(228),
  [418] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(229),
  [420] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(230),
  [422] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(229),
  [424] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(232),
  [426] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(233),
  [428] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(234),
  [430] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(235),
  [432] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(233),
  [434] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(243),
  [436] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(244),
  [438] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(246),
  [440] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(248),
  [442] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(249),
  [444] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(250),
  [446] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(251),
  [448] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(252),
  [450] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(253),
  [452] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(254),
  [454] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(255),
  [456] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(256),
  [458] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(257),
  [460] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(260),
  [462] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(262),
  [464] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(264),
  [466] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(265),
  [468] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(264),
  [470] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(267),
  [472] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(268),
  [474] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(269),
  [476] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(270),
  [478] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(268),
  [480] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(278),
  [482] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(279),
  [484] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(280),
  [486] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(281),
  [488] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(282),
  [490] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(283),
  [492] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(284),
  [494] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(285),
  [496] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(286),
  [498] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(57),
  [500] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(287),
  [502] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(59),
  [504] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(60),
  [506] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(61),
  [508] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(62),
  [510] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(63),
  [512] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(56),
  [514] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(58),
  [516] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(294),
  [518] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 1, .alias_sequence_id = 1),
  [520] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 1, .alias_sequence_id = 1),
  [522] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 1, .alias_sequence_id = 1),
  [524] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(296),
  [526] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [528] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [530] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [532] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(298),
  [534] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(299),
  [536] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(298),
  [538] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(301),
  [540] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(302),
  [542] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(303),
  [544] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(304),
  [546] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(302),
  [548] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(312),
  [550] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(71),
  [552] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(314),
  [554] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(316),
  [556] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(318),
  [558] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(319),
  [560] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(318),
  [562] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(321),
  [564] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(322),
  [566] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(323),
  [568] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(324),
  [570] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(322),
  [572] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(312),
  [574] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(81),
  [576] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(333),
  [578] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(335),
  [580] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 1),
  [582] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 1),
  [584] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(337),
  [586] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [588] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [590] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(93),
  [592] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(339),
  [594] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(340),
  [596] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(339),
  [598] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(342),
  [600] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(343),
  [602] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(344),
  [604] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(345),
  [606] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(343),
  [608] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 2),
  [610] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 2),
  [612] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_declaration_command, 2),
  [614] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 2, .alias_sequence_id = 3),
  [616] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(354),
  [618] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_file_redirect, 2, .alias_sequence_id = 3),
  [620] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(356),
  [622] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 2),
  [624] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_file_redirect, 2),
  [626] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(358),
  [628] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(359),
  [630] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(358),
  [632] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(361),
  [634] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(362),
  [636] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(363),
  [638] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(364),
  [640] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(362),
  [642] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(372),
  [644] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(372),
  [646] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_concatenation, 2),
  [648] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_concatenation, 2),
  [650] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_string, 2),
  [652] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_string, 2),
  [654] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(374),
  [656] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 1),
  [658] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_string_repeat1, 1),
  [660] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(375),
  [662] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(376),
  [664] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(377),
  [666] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(376),
  [668] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(379),
  [670] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(380),
  [672] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(381),
  [674] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(382),
  [676] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(380),
  [678] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(388),
  [680] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 4),
  [682] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 4),
  [684] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 5),
  [686] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 5),
  [688] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2),
  [690] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2),
  [692] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(390),
  [694] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(391),
  [696] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(392),
  [698] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(393),
  [700] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(394),
  [702] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(395),
  [704] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(396),
  [706] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(397),
  [708] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(393),
  [710] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(398),
  [712] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(399),
  [714] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(400),
  [716] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(401),
  [718] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(396),
  [720] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(403),
  [722] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(404),
  [724] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(405),
  [726] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(404),
  [728] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(407),
  [730] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(409),
  [732] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(411),
  [734] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(413),
  [736] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(416),
  [738] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(417),
  [740] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(417),
  [742] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(419),
  [744] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(425),
  [746] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_declaration_command, 1),
  [748] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_declaration_command, 1),
  [750] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(426),
  [752] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(427),
  [754] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(428),
  [756] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(429),
  [758] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(430),
  [760] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(431),
  [762] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(432),
  [764] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(433),
  [766] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(434),
  [768] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(428),
  [770] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(438),
  [772] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command_name, 1, .alias_sequence_id = 1),
  [774] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(440),
  [776] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command_name, 1),
  [778] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(442),
  [780] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(443),
  [782] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(442),
  [784] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(445),
  [786] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(446),
  [788] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(447),
  [790] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(448),
  [792] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(446),
  [794] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(456),
  [796] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(457),
  [798] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(458),
  [800] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(457),
  [802] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(459),
  [804] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(460),
  [806] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 1),
  [808] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 1),
  [810] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(461),
  [812] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(461),
  [814] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(462),
  [816] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(462),
  [818] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(463),
  [820] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(464),
  [822] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(465),
  [824] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(465),
  [826] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(140),
  [828] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(142),
  [830] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(471),
  [832] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(473),
  [834] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(474),
  [836] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(475),
  [838] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(476),
  [840] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(477),
  [842] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(478),
  [844] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(479),
  [846] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(480),
  [848] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(482),
  [850] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(477),
  [852] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(485),
  [854] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(487),
  [856] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(489),
  [858] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(490),
  [860] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(489),
  [862] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(492),
  [864] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(493),
  [866] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(494),
  [868] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(495),
  [870] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(493),
  [872] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(503),
  [874] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(504),
  [876] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(504),
  [878] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(505),
  [880] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(506),
  [882] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(507),
  [884] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(507),
  [886] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(508),
  [888] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(509),
  [890] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(510),
  [892] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(510),
  [894] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(159),
  [896] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(161),
  [898] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(514),
  [900] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(515),
  [902] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym__terminated_statement, 2),
  [904] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym__terminated_statement, 2),
  [906] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym__terminated_statement, 2),
  [908] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(520),
  [910] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(520),
  [912] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(521),
  [914] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(522),
  [916] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(523),
  [918] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(524),
  [920] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(525),
  [922] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(526),
  [924] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(527),
  [926] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(528),
  [928] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(523),
  [930] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(530),
  [932] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(531),
  [934] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(533),
  [936] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(534),
  [938] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(534),
  [940] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 1),
  [942] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 1),
  [944] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 2),
  [946] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2),
  [949] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3),
  [952] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2),
  [954] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4),
  [957] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(5),
  [960] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(6),
  [963] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(7),
  [966] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(8),
  [969] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(9),
  [972] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(10),
  [975] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(11),
  [978] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(12),
  [981] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(13),
  [984] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(13),
  [987] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(14),
  [990] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(15),
  [993] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(16),
  [996] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(17),
  [999] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(18),
  [1002] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(19),
  [1005] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(20),
  [1008] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(21),
  [1011] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(22),
  [1014] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(539),
  [1016] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(2),
  [1019] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(190),
  [1022] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(13),
  [1025] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(13),
  [1028] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat1, 2),
  [1030] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 2),
  [1032] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 3, .alias_sequence_id = 6),
  [1034] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_file_redirect, 3, .alias_sequence_id = 6),
  [1036] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 3),
  [1038] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_file_redirect, 3),
  [1040] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(541),
  [1042] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(542),
  [1044] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(544),
  [1046] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(546),
  [1048] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(547),
  [1050] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(548),
  [1052] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(549),
  [1054] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(548),
  [1056] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(551),
  [1058] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(552),
  [1060] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(553),
  [1062] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(554),
  [1064] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(552),
  [1066] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(562),
  [1068] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym__assignment, 2),
  [1070] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym__assignment, 2),
  [1072] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(563),
  [1074] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(564),
  [1076] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(565),
  [1078] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(566),
  [1080] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(567),
  [1082] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(568),
  [1084] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(569),
  [1086] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(570),
  [1088] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(571),
  [1090] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(566),
  [1092] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym__assignment, 2, .alias_sequence_id = 3),
  [1094] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(574),
  [1096] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym__assignment, 2, .alias_sequence_id = 3),
  [1098] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(576),
  [1100] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(578),
  [1102] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(579),
  [1104] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(578),
  [1106] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(581),
  [1108] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(582),
  [1110] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(583),
  [1112] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(584),
  [1114] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(582),
  [1116] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(592),
  [1118] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(593),
  [1120] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(594),
  [1122] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(595),
  [1124] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(596),
  [1126] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(597),
  [1128] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(598),
  [1130] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(599),
  [1132] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(594),
  [1134] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(602),
  [1136] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_while_statement, 3),
  [1138] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(608),
  [1140] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(609),
  [1142] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(610),
  [1144] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(618),
  [1146] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(618),
  [1148] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(619),
  [1150] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(620),
  [1152] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(622),
  [1154] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(623),
  [1156] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(624),
  [1158] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(625),
  [1160] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(626),
  [1162] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(628),
  [1164] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(629),
  [1166] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(630),
  [1168] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(629),
  [1170] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(632),
  [1172] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(634),
  [1174] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(636),
  [1176] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(637),
  [1178] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(638),
  [1180] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(639),
  [1182] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(644),
  [1184] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 3),
  [1186] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(645),
  [1188] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(647),
  [1190] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(648),
  [1192] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(649),
  [1194] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(650),
  [1196] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(651),
  [1198] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(652),
  [1200] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(653),
  [1202] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(654),
  [1204] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(649),
  [1206] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(656),
  [1208] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(658),
  [1210] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(659),
  [1212] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(661),
  [1214] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(251),
  [1216] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(663),
  [1218] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(664),
  [1220] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(663),
  [1222] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(666),
  [1224] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(667),
  [1226] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(668),
  [1228] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(669),
  [1230] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(667),
  [1232] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(678),
  [1234] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(678),
  [1236] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(680),
  [1238] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(681),
  [1240] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(682),
  [1242] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(684),
  [1244] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(685),
  [1246] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(686),
  [1248] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(685),
  [1250] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(688),
  [1252] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(690),
  [1254] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(692),
  [1256] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(693),
  [1258] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(694),
  [1260] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subshell, 3),
  [1262] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(695),
  [1264] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(698),
  [1266] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(698),
  [1268] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(699),
  [1270] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(700),
  [1272] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(701),
  [1274] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(702),
  [1276] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(703),
  [1278] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(704),
  [1280] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(705),
  [1282] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(706),
  [1284] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(701),
  [1286] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(707),
  [1288] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(708),
  [1290] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(708),
  [1292] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(695),
  [1294] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(712),
  [1296] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(714),
  [1298] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(714),
  [1300] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_concatenation, 2),
  [1302] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_string, 2),
  [1304] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(716),
  [1306] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 4),
  [1308] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 5),
  [1310] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_simple_expansion, 2),
  [1312] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(717),
  [1314] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(718),
  [1316] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(720),
  [1318] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(721),
  [1320] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(722),
  [1322] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(721),
  [1324] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(724),
  [1326] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(726),
  [1328] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(728),
  [1330] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(729),
  [1332] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_bracket_command, 3),
  [1334] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [1336] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(71),
  [1339] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(72),
  [1342] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(73),
  [1345] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(74),
  [1348] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(75),
  [1351] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(76),
  [1354] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(77),
  [1357] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(78),
  [1360] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(73),
  [1363] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(730),
  [1365] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(730),
  [1367] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(732),
  [1369] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(733),
  [1371] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(734),
  [1373] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(736),
  [1375] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(737),
  [1377] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(738),
  [1379] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(737),
  [1381] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(740),
  [1383] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(742),
  [1385] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(744),
  [1387] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(745),
  [1389] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [1391] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(81),
  [1394] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(82),
  [1397] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(83),
  [1400] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(84),
  [1403] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(85),
  [1406] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(86),
  [1409] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(87),
  [1412] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(88),
  [1415] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(83),
  [1418] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(746),
  [1420] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(747),
  [1422] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(748),
  [1424] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(749),
  [1426] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(95),
  [1428] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(96),
  [1430] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(97),
  [1432] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(98),
  [1434] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(99),
  [1436] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(749),
  [1438] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(750),
  [1440] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(750),
  [1442] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(752),
  [1444] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(753),
  [1446] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(754),
  [1448] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(756),
  [1450] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(757),
  [1452] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(758),
  [1454] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(757),
  [1456] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(760),
  [1458] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(762),
  [1460] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(764),
  [1462] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(765),
  [1464] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(91),
  [1467] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [1469] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(92),
  [1472] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(93),
  [1475] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(94),
  [1478] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(95),
  [1481] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(96),
  [1484] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(97),
  [1487] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(98),
  [1490] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(99),
  [1493] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(100),
  [1496] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(766),
  [1498] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(766),
  [1500] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(768),
  [1502] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(769),
  [1504] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(770),
  [1506] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(772),
  [1508] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(773),
  [1510] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(774),
  [1512] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(773),
  [1514] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(776),
  [1516] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(778),
  [1518] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(780),
  [1520] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(781),
  [1522] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [1524] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [1526] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(113),
  [1529] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 2),
  [1531] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_string_repeat1, 2),
  [1533] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(782),
  [1535] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(784),
  [1537] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(785),
  [1539] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(787),
  [1541] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(788),
  [1543] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(789),
  [1545] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(788),
  [1547] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(791),
  [1549] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(793),
  [1551] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(795),
  [1553] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_string, 3),
  [1555] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_string, 3),
  [1557] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(116),
  [1560] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(117),
  [1563] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(118),
  [1566] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(119),
  [1569] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(120),
  [1572] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(796),
  [1574] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(797),
  [1576] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(797),
  [1578] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(799),
  [1580] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(800),
  [1582] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(801),
  [1584] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(802),
  [1586] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(803),
  [1588] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(804),
  [1590] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(805),
  [1592] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(806),
  [1594] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(807),
  [1596] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(802),
  [1598] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3, .alias_sequence_id = 4),
  [1600] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3, .alias_sequence_id = 4),
  [1602] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_expansion_repeat1, 1),
  [1604] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_expansion_repeat1, 1),
  [1606] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_expansion_repeat1, 1),
  [1608] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(809),
  [1610] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_expansion_repeat1, 1, .alias_sequence_id = 1),
  [1612] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_expansion_repeat1, 1, .alias_sequence_id = 1),
  [1614] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_expansion_repeat1, 1, .alias_sequence_id = 1),
  [1616] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(811),
  [1618] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(813),
  [1620] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(814),
  [1622] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(813),
  [1624] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(816),
  [1626] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(817),
  [1628] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(818),
  [1630] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(819),
  [1632] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(817),
  [1634] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(827),
  [1636] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(829),
  [1638] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(830),
  [1640] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(832),
  [1642] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3, .alias_sequence_id = 5),
  [1644] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3, .alias_sequence_id = 5),
  [1646] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(835),
  [1648] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3),
  [1650] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3),
  [1652] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(836),
  [1654] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(837),
  [1656] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(838),
  [1658] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(839),
  [1660] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(840),
  [1662] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(841),
  [1664] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(842),
  [1666] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(843),
  [1668] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(844),
  [1670] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(845),
  [1672] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(840),
  [1674] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_variable_assignment, 2),
  [1676] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(846),
  [1678] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(847),
  [1680] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(849),
  [1682] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(850),
  [1684] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(851),
  [1686] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(852),
  [1688] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(853),
  [1690] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(854),
  [1692] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(855),
  [1694] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(857),
  [1696] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(858),
  [1698] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(861),
  [1700] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(861),
  [1702] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(862),
  [1704] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(864),
  [1706] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 1),
  [1708] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(866),
  [1710] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [1712] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(868),
  [1714] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(869),
  [1716] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(868),
  [1718] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(871),
  [1720] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(872),
  [1722] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(873),
  [1724] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(874),
  [1726] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(872),
  [1728] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 2),
  [1730] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_declaration_command, 2),
  [1732] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_declaration_command, 2),
  [1734] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(883),
  [1736] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(883),
  [1738] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(885),
  [1740] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(886),
  [1742] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(887),
  [1744] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(889),
  [1746] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(890),
  [1748] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(891),
  [1750] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(890),
  [1752] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(893),
  [1754] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(895),
  [1756] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(897),
  [1758] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(898),
  [1760] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(899),
  [1762] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3),
  [1764] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3),
  [1766] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(904),
  [1768] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(904),
  [1770] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(905),
  [1772] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(906),
  [1774] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(907),
  [1776] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(908),
  [1778] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(909),
  [1780] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(910),
  [1782] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(911),
  [1784] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(912),
  [1786] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(907),
  [1788] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(914),
  [1790] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(915),
  [1792] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(917),
  [1794] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(918),
  [1796] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(918),
  [1798] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_while_statement_repeat1, 1),
  [1800] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 2),
  [1802] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 2),
  [1804] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(924),
  [1806] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(925),
  [1808] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(926),
  [1810] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(927),
  [1812] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(928),
  [1814] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(929),
  [1816] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(930),
  [1818] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(931),
  [1820] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(926),
  [1822] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(933),
  [1824] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(935),
  [1826] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(936),
  [1828] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(938),
  [1830] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(940),
  [1832] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(941),
  [1834] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(940),
  [1836] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(943),
  [1838] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(944),
  [1840] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(945),
  [1842] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(946),
  [1844] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(944),
  [1846] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(955),
  [1848] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(955),
  [1850] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(957),
  [1852] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(958),
  [1854] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(959),
  [1856] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(961),
  [1858] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(962),
  [1860] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(963),
  [1862] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(962),
  [1864] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(965),
  [1866] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(967),
  [1868] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(969),
  [1870] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(970),
  [1872] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(971),
  [1874] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(975),
  [1876] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(975),
  [1878] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(976),
  [1880] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(977),
  [1882] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(978),
  [1884] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(979),
  [1886] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(980),
  [1888] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(981),
  [1890] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(982),
  [1892] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(983),
  [1894] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(978),
  [1896] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(984),
  [1898] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(985),
  [1900] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(985),
  [1902] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_process_substitution, 3),
  [1904] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_process_substitution, 3),
  [1906] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_pipeline, 3),
  [1908] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_list, 3, .fragile = true),
  [1910] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(991),
  [1912] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(992),
  [1914] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(992),
  [1916] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(994),
  [1918] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 2, .alias_sequence_id = 3),
  [1920] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(996),
  [1922] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 2),
  [1924] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(998),
  [1926] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(999),
  [1928] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(998),
  [1930] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1001),
  [1932] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1002),
  [1934] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1003),
  [1936] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1004),
  [1938] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1002),
  [1940] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 1),
  [1942] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 1),
  [1944] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1012),
  [1946] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1013),
  [1948] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1014),
  [1950] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1015),
  [1952] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_heredoc_redirect, 2),
  [1954] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_heredoc_redirect, 2),
  [1956] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_herestring_redirect, 2, .alias_sequence_id = 3),
  [1958] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_herestring_redirect, 2, .alias_sequence_id = 3),
  [1960] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_herestring_redirect, 2),
  [1962] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_herestring_redirect, 2),
  [1964] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [1966] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(183),
  [1969] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(15),
  [1972] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(184),
  [1975] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(17),
  [1978] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(18),
  [1981] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(19),
  [1984] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(20),
  [1987] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(21),
  [1990] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 3),
  [1992] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(179),
  [1995] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 2),
  [1997] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(180),
  [2000] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(181),
  [2003] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(182),
  [2006] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1017),
  [2008] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1018),
  [2010] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1018),
  [2012] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1020),
  [2014] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1021),
  [2016] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1021),
  [2018] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1021),
  [2020] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1022),
  [2022] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subscript, 4, .alias_sequence_id = 6),
  [2024] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1023),
  [2026] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1025),
  [2028] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1026),
  [2030] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1027),
  [2032] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subscript, 4),
  [2034] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1028),
  [2036] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1029),
  [2038] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1031),
  [2040] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1032),
  [2042] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1033),
  [2044] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1032),
  [2046] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1035),
  [2048] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1037),
  [2050] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1039),
  [2052] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1040),
  [2054] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1026),
  [2056] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_array, 2),
  [2058] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_array, 2),
  [2060] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1041),
  [2062] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1043),
  [2064] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1045),
  [2066] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1046),
  [2068] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1045),
  [2070] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1048),
  [2072] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1049),
  [2074] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1050),
  [2076] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1051),
  [2078] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1049),
  [2080] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1059),
  [2082] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1061),
  [2084] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1061),
  [2086] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1063),
  [2088] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1064),
  [2090] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1065),
  [2092] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1067),
  [2094] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1068),
  [2096] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1069),
  [2098] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1068),
  [2100] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1071),
  [2102] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1073),
  [2104] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1075),
  [2106] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1076),
  [2108] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1077),
  [2110] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1079),
  [2112] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1081),
  [2114] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1082),
  [2116] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1081),
  [2118] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1084),
  [2120] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1085),
  [2122] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1086),
  [2124] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1087),
  [2126] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1085),
  [2128] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1095),
  [2130] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(592),
  [2132] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(593),
  [2134] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(594),
  [2136] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(595),
  [2138] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(596),
  [2140] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(597),
  [2142] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(598),
  [2144] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(599),
  [2146] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_do_group, 2),
  [2148] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_do_group, 2),
  [2150] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1097),
  [2152] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1098),
  [2154] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_while_statement, 4),
  [2156] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 4),
  [2158] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_else_clause, 1),
  [2160] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1105),
  [2162] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_if_statement_repeat1, 1),
  [2164] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1106),
  [2166] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1106),
  [2168] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(609),
  [2170] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(610),
  [2172] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1111),
  [2174] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1112),
  [2176] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1113),
  [2178] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1114),
  [2180] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1115),
  [2182] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1116),
  [2184] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1117),
  [2186] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1118),
  [2188] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1119),
  [2190] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1114),
  [2192] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1124),
  [2194] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(221),
  [2197] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1125),
  [2199] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1128),
  [2201] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1129),
  [2203] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1130),
  [2205] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1131),
  [2207] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1131),
  [2209] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1133),
  [2211] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1134),
  [2213] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1135),
  [2215] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1137),
  [2217] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1140),
  [2219] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_compound_statement, 2),
  [2221] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_compound_statement, 2),
  [2223] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1142),
  [2225] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1143),
  [2227] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1145),
  [2229] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1145),
  [2231] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1146),
  [2233] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1147),
  [2235] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1148),
  [2237] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1149),
  [2239] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1150),
  [2241] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1151),
  [2243] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1152),
  [2245] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1153),
  [2247] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1148),
  [2249] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 4),
  [2251] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1155),
  [2253] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1157),
  [2255] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1159),
  [2257] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1160),
  [2259] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1159),
  [2261] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1162),
  [2263] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1163),
  [2265] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1164),
  [2267] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1165),
  [2269] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1163),
  [2271] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1174),
  [2273] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1175),
  [2275] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1176),
  [2277] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1177),
  [2279] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1178),
  [2281] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(253),
  [2283] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(254),
  [2285] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(255),
  [2287] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(256),
  [2289] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(257),
  [2291] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1178),
  [2293] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1179),
  [2295] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1179),
  [2297] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1181),
  [2299] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1182),
  [2301] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1183),
  [2303] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1185),
  [2305] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1186),
  [2307] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1187),
  [2309] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1186),
  [2311] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1189),
  [2313] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1191),
  [2315] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1193),
  [2317] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1194),
  [2319] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(249),
  [2322] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(250),
  [2325] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(251),
  [2328] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(252),
  [2331] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(253),
  [2334] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(254),
  [2337] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(255),
  [2340] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(256),
  [2343] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(257),
  [2346] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(260),
  [2349] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1195),
  [2351] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1196),
  [2353] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1197),
  [2355] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1197),
  [2357] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1199),
  [2359] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1200),
  [2361] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1201),
  [2363] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1203),
  [2365] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1206),
  [2367] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subshell, 4),
  [2369] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1208),
  [2371] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1209),
  [2373] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1209),
  [2375] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1210),
  [2377] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1212),
  [2379] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1214),
  [2381] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1215),
  [2383] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1214),
  [2385] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1217),
  [2387] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1218),
  [2389] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1219),
  [2391] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1220),
  [2393] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1218),
  [2395] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(286),
  [2398] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(57),
  [2401] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(287),
  [2404] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(59),
  [2407] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(60),
  [2410] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(61),
  [2413] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(62),
  [2416] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(63),
  [2419] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(283),
  [2422] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(284),
  [2425] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(285),
  [2428] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1228),
  [2430] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [2432] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(294),
  [2435] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_string, 3),
  [2437] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1230),
  [2439] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1231),
  [2441] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1232),
  [2443] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1232),
  [2445] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 3, .alias_sequence_id = 4),
  [2447] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1234),
  [2449] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1235),
  [2451] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1236),
  [2453] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1238),
  [2455] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 3, .alias_sequence_id = 5),
  [2457] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1241),
  [2459] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 3),
  [2461] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command_substitution, 3),
  [2463] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_process_substitution, 3),
  [2465] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(314),
  [2468] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1242),
  [2470] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1243),
  [2472] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1244),
  [2474] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1244),
  [2476] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1246),
  [2478] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1247),
  [2480] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1248),
  [2482] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1250),
  [2484] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1253),
  [2486] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1254),
  [2488] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(335),
  [2491] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1256),
  [2493] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1257),
  [2495] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1258),
  [2497] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1258),
  [2499] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1260),
  [2501] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1261),
  [2503] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1262),
  [2505] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1264),
  [2507] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1267),
  [2509] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(354),
  [2512] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1268),
  [2514] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1269),
  [2516] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1270),
  [2518] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1270),
  [2520] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1272),
  [2522] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1273),
  [2524] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1274),
  [2526] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1276),
  [2528] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1279),
  [2530] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1280),
  [2532] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1281),
  [2534] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1282),
  [2536] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1283),
  [2538] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1283),
  [2540] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1285),
  [2542] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1286),
  [2544] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1287),
  [2546] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1289),
  [2548] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1292),
  [2550] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1293),
  [2552] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1294),
  [2554] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1295),
  [2556] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1296),
  [2558] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1297),
  [2560] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4),
  [2562] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4),
  [2564] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1298),
  [2566] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1299),
  [2568] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1301),
  [2570] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1303),
  [2572] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1304),
  [2574] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1305),
  [2576] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1304),
  [2578] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1307),
  [2580] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1308),
  [2582] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1309),
  [2584] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1310),
  [2586] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1308),
  [2588] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1318),
  [2590] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1318),
  [2592] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1320),
  [2594] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1321),
  [2596] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1322),
  [2598] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1324),
  [2600] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1325),
  [2602] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1326),
  [2604] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1325),
  [2606] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1328),
  [2608] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1330),
  [2610] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1332),
  [2612] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1333),
  [2614] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 4),
  [2616] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 4),
  [2618] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_expansion_repeat1, 2),
  [2620] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(393),
  [2623] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(394),
  [2626] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(395),
  [2629] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(396),
  [2632] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(397),
  [2635] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(393),
  [2638] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(398),
  [2641] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(399),
  [2644] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(400),
  [2647] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(401),
  [2650] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(396),
  [2653] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1334),
  [2655] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1335),
  [2657] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1335),
  [2659] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 7),
  [2661] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 7),
  [2663] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1337),
  [2665] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 8),
  [2667] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 8),
  [2669] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1338),
  [2671] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 5),
  [2673] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 5),
  [2675] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym__assignment, 2),
  [2677] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1339),
  [2679] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1341),
  [2681] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym__assignment, 2, .alias_sequence_id = 3),
  [2683] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1343),
  [2685] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1345),
  [2687] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1346),
  [2689] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1345),
  [2691] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1348),
  [2693] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1349),
  [2695] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1350),
  [2697] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1351),
  [2699] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1349),
  [2701] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1360),
  [2703] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_while_statement, 3),
  [2705] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_while_statement, 3),
  [2707] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1363),
  [2709] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1367),
  [2711] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1368),
  [2713] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1369),
  [2715] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1370),
  [2717] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1371),
  [2719] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1372),
  [2721] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1374),
  [2723] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_function_definition, 3),
  [2725] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 3),
  [2727] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1375),
  [2729] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1375),
  [2731] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_subshell, 3),
  [2733] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subshell, 3),
  [2735] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1377),
  [2737] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1377),
  [2739] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1378),
  [2741] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_bracket_command, 3),
  [2743] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_bracket_command, 3),
  [2745] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1379),
  [2747] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1380),
  [2749] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1381),
  [2751] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1382),
  [2753] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1382),
  [2755] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1383),
  [2757] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1383),
  [2759] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1385),
  [2761] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1386),
  [2763] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1387),
  [2765] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1389),
  [2767] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1390),
  [2769] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1391),
  [2771] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1390),
  [2773] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1393),
  [2775] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1395),
  [2777] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1397),
  [2779] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1398),
  [2781] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(425),
  [2784] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [2786] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [2788] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(426),
  [2791] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(427),
  [2794] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(428),
  [2797] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(429),
  [2800] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(430),
  [2803] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(431),
  [2806] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(432),
  [2809] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(433),
  [2812] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(434),
  [2815] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(428),
  [2818] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(438),
  [2821] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1399),
  [2823] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1400),
  [2825] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1401),
  [2827] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1401),
  [2829] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1403),
  [2831] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1404),
  [2833] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1405),
  [2835] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1407),
  [2837] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1410),
  [2839] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_pipeline, 3),
  [2841] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_pipeline, 3),
  [2843] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_list, 3, .fragile = true),
  [2845] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1412),
  [2847] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1413),
  [2849] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1413),
  [2851] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1415),
  [2853] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1417),
  [2855] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1419),
  [2857] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1420),
  [2859] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1419),
  [2861] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1422),
  [2863] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1423),
  [2865] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1424),
  [2867] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1425),
  [2869] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1423),
  [2871] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_heredoc, 1),
  [2873] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1433),
  [2875] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_heredoc_redirect, 2),
  [2877] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_herestring_redirect, 2, .alias_sequence_id = 3),
  [2879] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_herestring_redirect, 2),
  [2881] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(464),
  [2884] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(141),
  [2887] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(465),
  [2890] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(143),
  [2893] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(144),
  [2896] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(145),
  [2899] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(146),
  [2902] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(147),
  [2905] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(465),
  [2908] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 3),
  [2910] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 3),
  [2912] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(460),
  [2915] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_while_statement_repeat1, 2),
  [2917] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 2),
  [2919] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(461),
  [2922] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(461),
  [2925] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(462),
  [2928] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(462),
  [2931] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(463),
  [2934] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1436),
  [2936] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1438),
  [2938] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1440),
  [2940] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1441),
  [2942] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1440),
  [2944] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1443),
  [2946] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1444),
  [2948] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1445),
  [2950] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1446),
  [2952] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1444),
  [2954] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1455),
  [2956] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1456),
  [2958] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1457),
  [2960] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1457),
  [2962] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1458),
  [2964] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1459),
  [2966] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(481),
  [2968] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1459),
  [2970] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1460),
  [2972] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1460),
  [2974] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1462),
  [2976] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1463),
  [2978] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1464),
  [2980] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1466),
  [2982] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1467),
  [2984] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1468),
  [2986] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1467),
  [2988] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1470),
  [2990] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1472),
  [2992] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1474),
  [2994] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1475),
  [2996] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(474),
  [2999] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(475),
  [3002] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(476),
  [3005] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(477),
  [3008] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(478),
  [3011] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(479),
  [3014] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(480),
  [3017] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(481),
  [3020] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(482),
  [3023] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(477),
  [3026] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(485),
  [3029] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1476),
  [3031] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1477),
  [3033] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1478),
  [3035] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1478),
  [3037] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1480),
  [3039] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1481),
  [3041] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1482),
  [3043] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1484),
  [3045] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1487),
  [3047] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1489),
  [3049] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1490),
  [3051] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1490),
  [3053] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1491),
  [3055] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1493),
  [3057] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1495),
  [3059] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1496),
  [3061] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1495),
  [3063] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1498),
  [3065] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1499),
  [3067] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1500),
  [3069] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1501),
  [3071] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1499),
  [3073] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(509),
  [3076] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(160),
  [3079] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(510),
  [3082] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(162),
  [3085] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(163),
  [3088] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(164),
  [3091] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(165),
  [3094] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(166),
  [3097] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(510),
  [3100] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(506),
  [3103] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(507),
  [3106] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(507),
  [3109] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(508),
  [3112] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 3, .alias_sequence_id = 6),
  [3114] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 3),
  [3116] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1511),
  [3118] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1511),
  [3120] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1513),
  [3122] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1514),
  [3124] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1515),
  [3126] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1517),
  [3128] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1518),
  [3130] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1519),
  [3132] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1518),
  [3134] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1521),
  [3136] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1523),
  [3138] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1525),
  [3140] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1526),
  [3142] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_heredoc_repeat1, 1),
  [3144] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_heredoc_repeat1, 1),
  [3146] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 2),
  [3148] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 2),
  [3150] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1527),
  [3152] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1528),
  [3154] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1529),
  [3156] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1528),
  [3158] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1531),
  [3160] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1532),
  [3162] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1533),
  [3164] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1534),
  [3166] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1532),
  [3168] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1536),
  [3170] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 4),
  [3172] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1538),
  [3174] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subscript, 5, .alias_sequence_id = 6),
  [3176] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1023),
  [3179] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1539),
  [3181] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subscript, 5),
  [3183] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1540),
  [3185] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1541),
  [3187] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1542),
  [3189] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1542),
  [3191] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1544),
  [3193] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1545),
  [3195] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1546),
  [3197] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1548),
  [3199] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1551),
  [3201] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1552),
  [3203] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1552),
  [3205] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1554),
  [3207] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1555),
  [3209] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1556),
  [3211] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1558),
  [3213] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1559),
  [3215] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1560),
  [3217] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1559),
  [3219] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1562),
  [3221] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1564),
  [3223] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1566),
  [3225] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1567),
  [3227] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_array, 3),
  [3229] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_array, 3),
  [3231] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(564),
  [3234] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(565),
  [3237] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(566),
  [3240] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(567),
  [3243] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(568),
  [3246] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(569),
  [3249] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(570),
  [3252] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(571),
  [3255] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(566),
  [3258] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(574),
  [3261] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1568),
  [3263] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1569),
  [3265] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1570),
  [3267] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1570),
  [3269] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1572),
  [3271] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1573),
  [3273] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1574),
  [3275] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1576),
  [3277] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1579),
  [3279] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1580),
  [3281] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1580),
  [3283] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1582),
  [3285] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1583),
  [3287] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1584),
  [3289] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1586),
  [3291] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1587),
  [3293] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1588),
  [3295] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1587),
  [3297] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1590),
  [3299] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1592),
  [3301] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1594),
  [3303] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1595),
  [3305] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1596),
  [3307] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(592),
  [3310] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(593),
  [3313] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(594),
  [3316] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(595),
  [3319] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(596),
  [3322] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(597),
  [3325] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(598),
  [3328] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(599),
  [3331] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_do_group, 3),
  [3333] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_do_group, 3),
  [3335] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2),
  [3337] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1598),
  [3339] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1599),
  [3341] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_else_clause, 2),
  [3343] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 5),
  [3345] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1601),
  [3347] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_if_statement_repeat1, 2),
  [3349] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_if_statement_repeat1, 2), SHIFT_REPEAT(609),
  [3352] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 5, .alias_sequence_id = 3),
  [3354] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1603),
  [3356] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1604),
  [3358] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1605),
  [3360] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1608),
  [3362] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1610),
  [3364] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1612),
  [3366] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1613),
  [3368] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1612),
  [3370] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1615),
  [3372] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1616),
  [3374] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1617),
  [3376] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1618),
  [3378] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1616),
  [3380] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_case_statement_repeat1, 1),
  [3382] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 1),
  [3384] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1626),
  [3386] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1114),
  [3388] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1629),
  [3390] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 5),
  [3392] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1631),
  [3394] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1633),
  [3396] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1635),
  [3398] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1636),
  [3400] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1637),
  [3402] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1638),
  [3404] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1638),
  [3406] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1640),
  [3408] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1641),
  [3410] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 5),
  [3412] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_compound_statement, 3),
  [3414] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_compound_statement, 3),
  [3416] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1643),
  [3418] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1644),
  [3420] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1644),
  [3422] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1646),
  [3424] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1648),
  [3426] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1650),
  [3428] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1651),
  [3430] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1650),
  [3432] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1653),
  [3434] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1654),
  [3436] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1655),
  [3438] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1656),
  [3440] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1654),
  [3442] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1664),
  [3444] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1664),
  [3446] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1666),
  [3448] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1667),
  [3450] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1668),
  [3452] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1670),
  [3454] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1671),
  [3456] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1672),
  [3458] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1671),
  [3460] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1674),
  [3462] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1676),
  [3464] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1678),
  [3466] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1679),
  [3468] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1681),
  [3470] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1681),
  [3472] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1682),
  [3474] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1683),
  [3476] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1684),
  [3478] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1685),
  [3480] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1686),
  [3482] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1687),
  [3484] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1688),
  [3486] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1689),
  [3488] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1684),
  [3490] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(659),
  [3493] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1690),
  [3495] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1691),
  [3497] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1692),
  [3499] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1692),
  [3501] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1694),
  [3503] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1695),
  [3505] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1696),
  [3507] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1698),
  [3509] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1701),
  [3511] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1702),
  [3513] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1703),
  [3515] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1704),
  [3517] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1705),
  [3519] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1705),
  [3521] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1707),
  [3523] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1708),
  [3525] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1709),
  [3527] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1709),
  [3529] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1711),
  [3531] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1712),
  [3533] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1713),
  [3535] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1715),
  [3537] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1716),
  [3539] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1717),
  [3541] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1716),
  [3543] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1719),
  [3545] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1721),
  [3547] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1723),
  [3549] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1724),
  [3551] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subshell, 5),
  [3553] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 4),
  [3555] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1725),
  [3557] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1726),
  [3559] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 4),
  [3561] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1727),
  [3563] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1728),
  [3565] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1728),
  [3567] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 7),
  [3569] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1730),
  [3571] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 8),
  [3573] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1731),
  [3575] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 5),
  [3577] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1732),
  [3579] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1733),
  [3581] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1734),
  [3583] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1735),
  [3585] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1735),
  [3587] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1737),
  [3589] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1738),
  [3591] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1739),
  [3593] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1740),
  [3595] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1741),
  [3597] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1742),
  [3599] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1743),
  [3601] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1743),
  [3603] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1745),
  [3605] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1746),
  [3607] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1747),
  [3609] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1748),
  [3611] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1749),
  [3613] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1750),
  [3615] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1750),
  [3617] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1752),
  [3619] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1753),
  [3621] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1754),
  [3623] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1755),
  [3625] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1756),
  [3627] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1757),
  [3629] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1757),
  [3631] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1759),
  [3633] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1760),
  [3635] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1761),
  [3637] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1762),
  [3639] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_subscript, 4, .alias_sequence_id = 6),
  [3641] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subscript, 4, .alias_sequence_id = 6),
  [3643] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1763),
  [3645] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1764),
  [3647] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_subscript, 4),
  [3649] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subscript, 4),
  [3651] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1763),
  [3653] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1765),
  [3655] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1765),
  [3657] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 9),
  [3659] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 9),
  [3661] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1767),
  [3663] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5),
  [3665] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5),
  [3667] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1768),
  [3669] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1769),
  [3671] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1771),
  [3673] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1772),
  [3675] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1773),
  [3677] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1772),
  [3679] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1775),
  [3681] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1777),
  [3683] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1779),
  [3685] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1780),
  [3687] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(809),
  [3690] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1781),
  [3692] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1782),
  [3694] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1783),
  [3696] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1783),
  [3698] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1785),
  [3700] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1786),
  [3702] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1787),
  [3704] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1789),
  [3706] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1792),
  [3708] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1793),
  [3710] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1794),
  [3712] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 7),
  [3714] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 7),
  [3716] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 8),
  [3718] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 8),
  [3720] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_array, 2),
  [3722] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1795),
  [3724] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1796),
  [3726] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1796),
  [3728] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1798),
  [3730] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1799),
  [3732] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1800),
  [3734] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1802),
  [3736] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1803),
  [3738] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1804),
  [3740] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1803),
  [3742] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1806),
  [3744] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1808),
  [3746] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1810),
  [3748] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1811),
  [3750] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1812),
  [3752] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_do_group, 2),
  [3754] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1813),
  [3756] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_while_statement, 4),
  [3758] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_while_statement, 4),
  [3760] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_if_statement, 4),
  [3762] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 4),
  [3764] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1814),
  [3766] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1814),
  [3768] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1817),
  [3770] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1820),
  [3772] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1821),
  [3774] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1824),
  [3776] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_compound_statement, 2),
  [3778] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1826),
  [3780] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1827),
  [3782] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1827),
  [3784] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1828),
  [3786] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1829),
  [3788] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1830),
  [3790] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1831),
  [3792] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1832),
  [3794] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1833),
  [3796] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1834),
  [3798] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1835),
  [3800] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1830),
  [3802] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_function_definition, 4),
  [3804] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 4),
  [3806] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_subshell, 4),
  [3808] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subshell, 4),
  [3810] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1837),
  [3812] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1838),
  [3814] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(864),
  [3817] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1840),
  [3819] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1841),
  [3821] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1842),
  [3823] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1842),
  [3825] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1844),
  [3827] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1845),
  [3829] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1846),
  [3831] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1848),
  [3833] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1851),
  [3835] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1852),
  [3837] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1853),
  [3839] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1854),
  [3841] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1855),
  [3843] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1855),
  [3845] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1857),
  [3847] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1858),
  [3849] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1860),
  [3851] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1860),
  [3853] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1862),
  [3855] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1863),
  [3857] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1864),
  [3859] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1866),
  [3861] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1867),
  [3863] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1868),
  [3865] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1867),
  [3867] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1870),
  [3869] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1872),
  [3871] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1874),
  [3873] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1875),
  [3875] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_heredoc, 2),
  [3877] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1876),
  [3879] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 4),
  [3881] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 4),
  [3883] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1877),
  [3885] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1877),
  [3887] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1879),
  [3889] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1880),
  [3891] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1881),
  [3893] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1883),
  [3895] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1884),
  [3897] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1885),
  [3899] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1884),
  [3901] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1887),
  [3903] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1889),
  [3905] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1891),
  [3907] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1892),
  [3909] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1894),
  [3911] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1894),
  [3913] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1895),
  [3915] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1896),
  [3917] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1897),
  [3919] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1898),
  [3921] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1899),
  [3923] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1900),
  [3925] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1901),
  [3927] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1902),
  [3929] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1897),
  [3931] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(936),
  [3934] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1903),
  [3936] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1904),
  [3938] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1905),
  [3940] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1905),
  [3942] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1907),
  [3944] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1908),
  [3946] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1909),
  [3948] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1911),
  [3950] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1914),
  [3952] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1915),
  [3954] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1916),
  [3956] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1917),
  [3958] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1918),
  [3960] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1918),
  [3962] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1920),
  [3964] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1921),
  [3966] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1922),
  [3968] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1922),
  [3970] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1924),
  [3972] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1925),
  [3974] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1926),
  [3976] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1928),
  [3978] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1929),
  [3980] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1930),
  [3982] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1929),
  [3984] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1932),
  [3986] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1934),
  [3988] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1936),
  [3990] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1937),
  [3992] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(994),
  [3995] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1938),
  [3997] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1939),
  [3999] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1940),
  [4001] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1940),
  [4003] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1942),
  [4005] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1943),
  [4007] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1944),
  [4009] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1946),
  [4011] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1949),
  [4013] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1950),
  [4015] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1952),
  [4017] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1953),
  [4019] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1955),
  [4021] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1956),
  [4023] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1957),
  [4025] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1956),
  [4027] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1959),
  [4029] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1961),
  [4031] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 3),
  [4033] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 3),
  [4035] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_heredoc_repeat1, 2), SHIFT_REPEAT(1012),
  [4038] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_heredoc_repeat1, 2),
  [4040] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_heredoc_repeat1, 2), SHIFT_REPEAT(1014),
  [4043] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_heredoc_repeat1, 2), SHIFT_REPEAT(1015),
  [4046] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subscript, 6, .alias_sequence_id = 6),
  [4048] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subscript, 6),
  [4050] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1963),
  [4052] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1964),
  [4054] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1965),
  [4056] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1966),
  [4058] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1966),
  [4060] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1968),
  [4062] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1969),
  [4064] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1041),
  [4067] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1970),
  [4069] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1971),
  [4071] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1972),
  [4073] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1972),
  [4075] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1974),
  [4077] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1975),
  [4079] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1976),
  [4081] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1978),
  [4083] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1981),
  [4085] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1982),
  [4087] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1983),
  [4089] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1984),
  [4091] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1985),
  [4093] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1985),
  [4095] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1987),
  [4097] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1988),
  [4099] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1077),
  [4102] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1989),
  [4104] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1990),
  [4106] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1991),
  [4108] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1991),
  [4110] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1993),
  [4112] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1994),
  [4114] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1995),
  [4116] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1997),
  [4118] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2000),
  [4120] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2001),
  [4122] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_for_statement, 6, .alias_sequence_id = 5),
  [4124] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_elif_clause, 3),
  [4126] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 6),
  [4128] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2004),
  [4130] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2005),
  [4132] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2005),
  [4134] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2006),
  [4136] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2007),
  [4138] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2007),
  [4140] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_last_case_item, 2, .alias_sequence_id = 1),
  [4142] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2009),
  [4144] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2014),
  [4146] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2017),
  [4148] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_last_case_item, 2),
  [4150] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2018),
  [4152] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2020),
  [4154] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2021),
  [4156] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2022),
  [4158] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2024),
  [4160] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2025),
  [4162] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2026),
  [4164] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2025),
  [4166] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2028),
  [4168] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2030),
  [4170] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2032),
  [4172] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2033),
  [4174] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 10),
  [4176] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2034),
  [4178] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2035),
  [4181] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1113),
  [4184] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2036),
  [4187] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1115),
  [4190] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1116),
  [4193] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1117),
  [4196] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1118),
  [4199] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1119),
  [4202] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2036),
  [4205] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 3),
  [4207] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 11),
  [4209] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2039),
  [4211] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 6),
  [4213] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2041),
  [4215] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2042),
  [4217] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 6),
  [4219] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2043),
  [4221] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2043),
  [4223] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2045),
  [4225] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2046),
  [4227] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2047),
  [4229] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2049),
  [4231] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2050),
  [4233] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2051),
  [4235] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2050),
  [4237] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2053),
  [4239] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2055),
  [4241] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2057),
  [4243] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2058),
  [4245] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1155),
  [4248] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2059),
  [4250] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2060),
  [4252] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2061),
  [4254] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2061),
  [4256] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2063),
  [4258] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2064),
  [4260] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2065),
  [4262] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2067),
  [4264] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2070),
  [4266] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2071),
  [4268] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2072),
  [4270] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2072),
  [4272] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2073),
  [4274] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2075),
  [4276] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2077),
  [4278] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2078),
  [4280] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2077),
  [4282] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2080),
  [4284] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2081),
  [4286] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2082),
  [4288] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2083),
  [4290] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2081),
  [4292] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2091),
  [4294] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2092),
  [4296] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2093),
  [4298] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2094),
  [4300] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2094),
  [4302] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2096),
  [4304] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2097),
  [4306] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2098),
  [4308] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2099),
  [4310] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1210),
  [4313] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2100),
  [4315] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2101),
  [4317] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2102),
  [4319] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2102),
  [4321] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2104),
  [4323] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2105),
  [4325] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2106),
  [4327] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2108),
  [4329] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2111),
  [4331] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 9),
  [4333] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 5),
  [4335] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2112),
  [4337] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2113),
  [4339] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 7),
  [4341] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 8),
  [4343] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2114),
  [4345] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2115),
  [4347] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2116),
  [4349] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2117),
  [4351] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2118),
  [4353] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2119),
  [4355] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2120),
  [4357] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2121),
  [4359] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2122),
  [4361] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_subscript, 5, .alias_sequence_id = 6),
  [4363] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subscript, 5, .alias_sequence_id = 6),
  [4365] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2123),
  [4367] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_subscript, 5),
  [4369] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subscript, 5),
  [4371] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1298),
  [4374] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2124),
  [4376] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2125),
  [4378] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2126),
  [4380] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2126),
  [4382] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2128),
  [4384] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2129),
  [4386] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2130),
  [4388] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2132),
  [4390] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2135),
  [4392] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2136),
  [4394] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2137),
  [4396] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2138),
  [4398] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2139),
  [4400] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2139),
  [4402] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2141),
  [4404] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2142),
  [4406] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 12),
  [4408] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 12),
  [4410] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 6),
  [4412] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 6),
  [4414] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_array, 3),
  [4416] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1341),
  [4419] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2143),
  [4421] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2144),
  [4423] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2145),
  [4425] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2145),
  [4427] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2147),
  [4429] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2148),
  [4431] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2149),
  [4433] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2151),
  [4435] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2154),
  [4437] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2155),
  [4439] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_do_group, 3),
  [4441] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_if_statement, 5),
  [4443] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 5),
  [4445] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2157),
  [4447] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 5, .alias_sequence_id = 3),
  [4449] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 5, .alias_sequence_id = 3),
  [4451] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2159),
  [4453] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2161),
  [4455] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 5),
  [4457] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 5),
  [4459] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2163),
  [4461] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2165),
  [4463] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_function_definition, 5),
  [4465] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 5),
  [4467] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_compound_statement, 3),
  [4469] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2168),
  [4471] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2169),
  [4473] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2169),
  [4475] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2171),
  [4477] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2173),
  [4479] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2175),
  [4481] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2176),
  [4483] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2175),
  [4485] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2178),
  [4487] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2179),
  [4489] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2180),
  [4491] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2181),
  [4493] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2179),
  [4495] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_subshell, 5),
  [4497] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subshell, 5),
  [4499] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2189),
  [4501] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2190),
  [4503] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2191),
  [4505] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2192),
  [4507] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2193),
  [4509] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2193),
  [4511] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2195),
  [4513] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2196),
  [4515] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2197),
  [4517] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2198),
  [4519] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1415),
  [4522] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2199),
  [4524] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2200),
  [4526] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2201),
  [4528] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2201),
  [4530] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2203),
  [4532] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2204),
  [4534] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2205),
  [4536] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2207),
  [4538] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2210),
  [4540] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_heredoc, 3),
  [4542] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1436),
  [4545] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2211),
  [4547] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2212),
  [4549] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2213),
  [4551] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2213),
  [4553] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2215),
  [4555] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2216),
  [4557] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2217),
  [4559] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2219),
  [4561] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2222),
  [4563] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2223),
  [4565] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2224),
  [4567] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2224),
  [4569] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2225),
  [4571] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2227),
  [4573] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2229),
  [4575] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2230),
  [4577] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2229),
  [4579] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2232),
  [4581] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2233),
  [4583] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2234),
  [4585] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2235),
  [4587] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2233),
  [4589] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2243),
  [4591] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2244),
  [4593] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2245),
  [4595] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2246),
  [4597] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2246),
  [4599] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2248),
  [4601] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2249),
  [4603] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2250),
  [4605] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2251),
  [4607] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1491),
  [4610] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2252),
  [4612] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2253),
  [4614] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2254),
  [4616] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2254),
  [4618] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2256),
  [4620] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2257),
  [4622] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2258),
  [4624] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2260),
  [4626] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2263),
  [4628] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2264),
  [4630] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2265),
  [4632] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2266),
  [4634] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2267),
  [4636] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2267),
  [4638] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2269),
  [4640] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2270),
  [4642] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2271),
  [4644] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2272),
  [4646] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2273),
  [4648] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2274),
  [4650] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2274),
  [4652] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2276),
  [4654] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2277),
  [4656] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2278),
  [4658] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2280),
  [4660] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2283),
  [4662] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2284),
  [4664] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2285),
  [4666] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2286),
  [4668] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2287),
  [4670] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2288),
  [4672] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2289),
  [4674] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2289),
  [4676] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2291),
  [4678] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2292),
  [4680] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2293),
  [4682] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2294),
  [4684] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2295),
  [4686] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2296),
  [4688] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2297),
  [4690] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2298),
  [4692] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2298),
  [4694] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2300),
  [4696] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2301),
  [4698] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2302),
  [4700] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_elif_clause, 4),
  [4702] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 7),
  [4704] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_item_repeat1, 2, .alias_sequence_id = 3),
  [4706] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_item_repeat1, 2),
  [4708] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_last_case_item, 3, .alias_sequence_id = 1),
  [4710] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_item, 3, .alias_sequence_id = 1),
  [4712] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_item, 3, .alias_sequence_id = 1),
  [4714] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_item, 3, .alias_sequence_id = 1),
  [4716] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2303),
  [4718] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2304),
  [4720] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_item_repeat1, 2), SHIFT_REPEAT(1604),
  [4723] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1603),
  [4726] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_last_case_item, 3),
  [4728] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_item, 3),
  [4730] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_item, 3),
  [4732] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_item, 3),
  [4734] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2307),
  [4736] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2309),
  [4738] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2310),
  [4740] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2311),
  [4742] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2311),
  [4744] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2313),
  [4746] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2314),
  [4748] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2315),
  [4750] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2317),
  [4752] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2320),
  [4754] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 13),
  [4756] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2321),
  [4758] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2323),
  [4760] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2325),
  [4762] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 14),
  [4764] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2326),
  [4766] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1646),
  [4769] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2327),
  [4771] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2328),
  [4773] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2329),
  [4775] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2329),
  [4777] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2331),
  [4779] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2332),
  [4781] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2333),
  [4783] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2335),
  [4785] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2338),
  [4787] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2339),
  [4789] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2340),
  [4791] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2341),
  [4793] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2342),
  [4795] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2342),
  [4797] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2344),
  [4799] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2345),
  [4801] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2346),
  [4803] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2346),
  [4805] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2348),
  [4807] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2349),
  [4809] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2350),
  [4811] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2352),
  [4813] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2353),
  [4815] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2354),
  [4817] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2353),
  [4819] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2356),
  [4821] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2358),
  [4823] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2360),
  [4825] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2361),
  [4827] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2362),
  [4829] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2363),
  [4831] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2364),
  [4833] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2365),
  [4835] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2366),
  [4837] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2367),
  [4839] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2367),
  [4841] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2369),
  [4843] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2370),
  [4845] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 12),
  [4847] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 6),
  [4849] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_subscript, 6, .alias_sequence_id = 6),
  [4851] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subscript, 6, .alias_sequence_id = 6),
  [4853] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_subscript, 6),
  [4855] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subscript, 6),
  [4857] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2371),
  [4859] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2372),
  [4861] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2373),
  [4863] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2374),
  [4865] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2374),
  [4867] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2376),
  [4869] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2377),
  [4871] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2378),
  [4873] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2379),
  [4875] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2380),
  [4877] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2381),
  [4879] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2382),
  [4881] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2383),
  [4883] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2383),
  [4885] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2385),
  [4887] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2386),
  [4889] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2387),
  [4891] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_for_statement, 6, .alias_sequence_id = 5),
  [4893] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_for_statement, 6, .alias_sequence_id = 5),
  [4895] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_if_statement, 6),
  [4897] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 6),
  [4899] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2389),
  [4901] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 10),
  [4903] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 10),
  [4905] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2390),
  [4907] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 3),
  [4909] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 3),
  [4911] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 11),
  [4913] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 11),
  [4915] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2392),
  [4917] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 6),
  [4919] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 6),
  [4921] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_function_definition, 6),
  [4923] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 6),
  [4925] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2394),
  [4927] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2394),
  [4929] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2396),
  [4931] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2397),
  [4933] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2398),
  [4935] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2400),
  [4937] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2401),
  [4939] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2402),
  [4941] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2401),
  [4943] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2404),
  [4945] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2406),
  [4947] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2408),
  [4949] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2409),
  [4951] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2410),
  [4953] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2411),
  [4955] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2412),
  [4957] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2413),
  [4959] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2414),
  [4961] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2415),
  [4963] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2415),
  [4965] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2417),
  [4967] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2418),
  [4969] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2419),
  [4971] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2420),
  [4973] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2421),
  [4975] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2422),
  [4977] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2422),
  [4979] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2424),
  [4981] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2425),
  [4983] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2426),
  [4985] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2426),
  [4987] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2428),
  [4989] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2429),
  [4991] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2430),
  [4993] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2432),
  [4995] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2433),
  [4997] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2434),
  [4999] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2433),
  [5001] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2436),
  [5003] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2438),
  [5005] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2440),
  [5007] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2441),
  [5009] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2442),
  [5011] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2443),
  [5013] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2444),
  [5015] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2445),
  [5017] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2446),
  [5019] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2447),
  [5021] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2447),
  [5023] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2449),
  [5025] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2450),
  [5027] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2451),
  [5029] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2452),
  [5031] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2453),
  [5033] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2454),
  [5035] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2455),
  [5037] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2456),
  [5039] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2456),
  [5041] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2458),
  [5043] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2459),
  [5045] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2460),
  [5047] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2461),
  [5049] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2462),
  [5051] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2463),
  [5053] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_last_case_item, 4, .alias_sequence_id = 1),
  [5055] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_item, 4, .alias_sequence_id = 1),
  [5057] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_item, 4, .alias_sequence_id = 1),
  [5059] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_item, 4, .alias_sequence_id = 1),
  [5061] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2464),
  [5063] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_last_case_item, 4),
  [5065] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_item, 4),
  [5067] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_item, 4),
  [5069] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_item, 4),
  [5071] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2465),
  [5073] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2466),
  [5075] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2467),
  [5077] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2468),
  [5079] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2469),
  [5081] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2469),
  [5083] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2471),
  [5085] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2472),
  [5087] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2473),
  [5089] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2475),
  [5091] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2476),
  [5093] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2478),
  [5095] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 15),
  [5097] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 16),
  [5099] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2479),
  [5101] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2480),
  [5103] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2481),
  [5105] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2482),
  [5107] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2482),
  [5109] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2484),
  [5111] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2485),
  [5113] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2486),
  [5115] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2487),
  [5117] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2073),
  [5120] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2488),
  [5122] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2489),
  [5124] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2490),
  [5126] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2490),
  [5128] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2492),
  [5130] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2493),
  [5132] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2494),
  [5134] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2496),
  [5136] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2499),
  [5138] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2500),
  [5140] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2501),
  [5142] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2502),
  [5144] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2503),
  [5146] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2504),
  [5148] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2505),
  [5150] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2506),
  [5152] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_if_statement, 7),
  [5154] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 7),
  [5156] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 13),
  [5158] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 13),
  [5160] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2507),
  [5162] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 14),
  [5164] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 14),
  [5166] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2508),
  [5168] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2171),
  [5171] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2509),
  [5173] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2510),
  [5175] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2511),
  [5177] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2511),
  [5179] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2513),
  [5181] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2514),
  [5183] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2515),
  [5185] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2517),
  [5187] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2520),
  [5189] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2521),
  [5191] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2522),
  [5193] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2523),
  [5195] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2524),
  [5197] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2225),
  [5200] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2525),
  [5202] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2526),
  [5204] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2527),
  [5206] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2527),
  [5208] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2529),
  [5210] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2530),
  [5212] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2531),
  [5214] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2533),
  [5216] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2536),
  [5218] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2537),
  [5220] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2538),
  [5222] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2539),
  [5224] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2540),
  [5226] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_last_case_item, 5, .alias_sequence_id = 1),
  [5228] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_item, 5, .alias_sequence_id = 1),
  [5230] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_item, 5, .alias_sequence_id = 1),
  [5232] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_item, 5, .alias_sequence_id = 1),
  [5234] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_last_case_item, 5),
  [5236] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_item, 5),
  [5238] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_item, 5),
  [5240] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_item, 5),
  [5242] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2541),
  [5244] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2542),
  [5246] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2543),
  [5248] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2546),
  [5250] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2548),
  [5252] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2549),
  [5254] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2550),
  [5256] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2551),
  [5258] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2552),
  [5260] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2553),
  [5262] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2553),
  [5264] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2555),
  [5266] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2556),
  [5268] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 15),
  [5270] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 15),
  [5272] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 16),
  [5274] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 16),
  [5276] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2557),
  [5278] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2558),
  [5280] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2559),
  [5282] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2560),
  [5284] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2560),
  [5286] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2562),
  [5288] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2563),
  [5290] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2564),
  [5292] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2565),
  [5294] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2566),
  [5296] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2567),
  [5298] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2567),
  [5300] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2569),
  [5302] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2570),
  [5304] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2571),
  [5306] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2572),
  [5308] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2573),
  [5310] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2574),
  [5312] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2575),
  [5314] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2576),
  [5316] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2577),
  [5318] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2578),
};

void *tree_sitter_bash_external_scanner_create();
void tree_sitter_bash_external_scanner_destroy(void *);
bool tree_sitter_bash_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_bash_external_scanner_serialize(void *, char *);
void tree_sitter_bash_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_bash() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_bash_external_scanner_create,
      tree_sitter_bash_external_scanner_destroy,
      tree_sitter_bash_external_scanner_scan,
      tree_sitter_bash_external_scanner_serialize,
      tree_sitter_bash_external_scanner_deserialize,
    },
  };
  return &language;
}
